// Generated automatically from org.openhealthtools.mdht.uml.cda.SubstanceAdministration for testing purposes

package org.openhealthtools.mdht.uml.cda;

import java.util.Map;
import org.eclipse.emf.common.util.DiagnosticChain;
import org.eclipse.emf.common.util.EList;
import org.openhealthtools.mdht.uml.cda.Author;
import org.openhealthtools.mdht.uml.cda.ClinicalStatement;
import org.openhealthtools.mdht.uml.cda.Consumable;
import org.openhealthtools.mdht.uml.cda.EntryRelationship;
import org.openhealthtools.mdht.uml.cda.Informant12;
import org.openhealthtools.mdht.uml.cda.InfrastructureRootTypeId;
import org.openhealthtools.mdht.uml.cda.Participant2;
import org.openhealthtools.mdht.uml.cda.Performer2;
import org.openhealthtools.mdht.uml.cda.Precondition;
import org.openhealthtools.mdht.uml.cda.Reference;
import org.openhealthtools.mdht.uml.cda.Specimen;
import org.openhealthtools.mdht.uml.cda.Subject;
import org.openhealthtools.mdht.uml.hl7.datatypes.CD;
import org.openhealthtools.mdht.uml.hl7.datatypes.CE;
import org.openhealthtools.mdht.uml.hl7.datatypes.CS;
import org.openhealthtools.mdht.uml.hl7.datatypes.ED;
import org.openhealthtools.mdht.uml.hl7.datatypes.II;
import org.openhealthtools.mdht.uml.hl7.datatypes.IVL_INT;
import org.openhealthtools.mdht.uml.hl7.datatypes.IVL_PQ;
import org.openhealthtools.mdht.uml.hl7.datatypes.RTO_PQ_PQ;
import org.openhealthtools.mdht.uml.hl7.datatypes.SXCM_TS;
import org.openhealthtools.mdht.uml.hl7.vocab.ActClass;
import org.openhealthtools.mdht.uml.hl7.vocab.NullFlavor;
import org.openhealthtools.mdht.uml.hl7.vocab.x_DocumentSubstanceMood;

public interface SubstanceAdministration extends ClinicalStatement
{
    ActClass getClassCode();
    Boolean getNegationInd();
    CD getCode();
    CE getAdministrationUnitCode();
    CE getPriorityCode();
    CE getRouteCode();
    CS getStatusCode();
    Consumable getConsumable();
    ED getText();
    EList<Author> getAuthors();
    EList<CD> getApproachSiteCodes();
    EList<CS> getRealmCodes();
    EList<EntryRelationship> getEntryRelationships();
    EList<II> getIds();
    EList<II> getTemplateIds();
    EList<Informant12> getInformants();
    EList<Participant2> getParticipants();
    EList<Performer2> getPerformers();
    EList<Precondition> getPreconditions();
    EList<Reference> getReferences();
    EList<SXCM_TS> getEffectiveTimes();
    EList<Specimen> getSpecimens();
    IVL_INT getRepeatNumber();
    IVL_PQ getDoseQuantity();
    IVL_PQ getRateQuantity();
    InfrastructureRootTypeId getTypeId();
    NullFlavor getNullFlavor();
    RTO_PQ_PQ getMaxDoseQuantity();
    Subject getSubject();
    boolean isSetClassCode();
    boolean isSetMoodCode();
    boolean isSetNegationInd();
    boolean isSetNullFlavor();
    boolean validateClassCode(DiagnosticChain p0, Map<Object, Object> p1);
    void setAdministrationUnitCode(CE p0);
    void setClassCode(ActClass p0);
    void setCode(CD p0);
    void setConsumable(Consumable p0);
    void setDoseQuantity(IVL_PQ p0);
    void setMaxDoseQuantity(RTO_PQ_PQ p0);
    void setMoodCode(x_DocumentSubstanceMood p0);
    void setNegationInd(Boolean p0);
    void setNullFlavor(NullFlavor p0);
    void setPriorityCode(CE p0);
    void setRateQuantity(IVL_PQ p0);
    void setRepeatNumber(IVL_INT p0);
    void setRouteCode(CE p0);
    void setStatusCode(CS p0);
    void setSubject(Subject p0);
    void setText(ED p0);
    void setTypeId(InfrastructureRootTypeId p0);
    void unsetClassCode();
    void unsetMoodCode();
    void unsetNegationInd();
    void unsetNullFlavor();
    x_DocumentSubstanceMood getMoodCode();
}
