// generated by codegen, do not edit
/**
 * This module provides the generated definition of `BinaryExpr`.
 * INTERNAL: Do not import directly.
 */

private import codeql.rust.elements.internal.generated.Synth
private import codeql.rust.elements.internal.generated.Raw
import codeql.rust.elements.Attr
import codeql.rust.elements.Expr
import codeql.rust.elements.internal.ExprImpl::Impl as ExprImpl

/**
 * INTERNAL: This module contains the fully generated definition of `BinaryExpr` and should not
 * be referenced directly.
 */
module Generated {
  /**
   * A binary operation expression. For example:
   * ```rust
   * x + y;
   * x && y;
   * x <= y;
   * x = y;
   * x += y;
   * ```
   * INTERNAL: Do not reference the `Generated::BinaryExpr` class directly.
   * Use the subclass `BinaryExpr`, where the following predicates are available.
   */
  class BinaryExpr extends Synth::TBinaryExpr, ExprImpl::Expr {
    override string getAPrimaryQlClass() { result = "BinaryExpr" }

    /**
     * Gets the `index`th attr of this binary expression (0-based).
     */
    Attr getAttr(int index) {
      result =
        Synth::convertAttrFromRaw(Synth::convertBinaryExprToRaw(this)
              .(Raw::BinaryExpr)
              .getAttr(index))
    }

    /**
     * Gets any of the attrs of this binary expression.
     */
    final Attr getAnAttr() { result = this.getAttr(_) }

    /**
     * Gets the number of attrs of this binary expression.
     */
    final int getNumberOfAttrs() { result = count(int i | exists(this.getAttr(i))) }

    /**
     * Gets the lhs of this binary expression, if it exists.
     */
    Expr getLhs() {
      result =
        Synth::convertExprFromRaw(Synth::convertBinaryExprToRaw(this).(Raw::BinaryExpr).getLhs())
    }

    /**
     * Holds if `getLhs()` exists.
     */
    final predicate hasLhs() { exists(this.getLhs()) }

    /**
     * Gets the operator name of this binary expression, if it exists.
     */
    string getOperatorName() {
      result = Synth::convertBinaryExprToRaw(this).(Raw::BinaryExpr).getOperatorName()
    }

    /**
     * Holds if `getOperatorName()` exists.
     */
    final predicate hasOperatorName() { exists(this.getOperatorName()) }

    /**
     * Gets the rhs of this binary expression, if it exists.
     */
    Expr getRhs() {
      result =
        Synth::convertExprFromRaw(Synth::convertBinaryExprToRaw(this).(Raw::BinaryExpr).getRhs())
    }

    /**
     * Holds if `getRhs()` exists.
     */
    final predicate hasRhs() { exists(this.getRhs()) }
  }
}
