// generated by codegen, do not edit
/**
 * This module provides the generated definition of `ContinueExpr`.
 * INTERNAL: Do not import directly.
 */

private import codeql.rust.elements.internal.generated.Synth
private import codeql.rust.elements.internal.generated.Raw
import codeql.rust.elements.Attr
import codeql.rust.elements.internal.ExprImpl::Impl as ExprImpl
import codeql.rust.elements.Lifetime

/**
 * INTERNAL: This module contains the fully generated definition of `ContinueExpr` and should not
 * be referenced directly.
 */
module Generated {
  /**
   * A continue expression. For example:
   * ```rust
   * loop {
   *     if not_ready() {
   *         continue;
   *     }
   * }
   * ```
   * ```rust
   * 'label: loop {
   *     if not_ready() {
   *         continue 'label;
   *     }
   * }
   * ```
   * INTERNAL: Do not reference the `Generated::ContinueExpr` class directly.
   * Use the subclass `ContinueExpr`, where the following predicates are available.
   */
  class ContinueExpr extends Synth::TContinueExpr, ExprImpl::Expr {
    override string getAPrimaryQlClass() { result = "ContinueExpr" }

    /**
     * Gets the `index`th attr of this continue expression (0-based).
     */
    Attr getAttr(int index) {
      result =
        Synth::convertAttrFromRaw(Synth::convertContinueExprToRaw(this)
              .(Raw::ContinueExpr)
              .getAttr(index))
    }

    /**
     * Gets any of the attrs of this continue expression.
     */
    final Attr getAnAttr() { result = this.getAttr(_) }

    /**
     * Gets the number of attrs of this continue expression.
     */
    final int getNumberOfAttrs() { result = count(int i | exists(this.getAttr(i))) }

    /**
     * Gets the lifetime of this continue expression, if it exists.
     */
    Lifetime getLifetime() {
      result =
        Synth::convertLifetimeFromRaw(Synth::convertContinueExprToRaw(this)
              .(Raw::ContinueExpr)
              .getLifetime())
    }

    /**
     * Holds if `getLifetime()` exists.
     */
    final predicate hasLifetime() { exists(this.getLifetime()) }
  }
}
