// generated by codegen/codegen.py
/**
 * This module provides the generated definition of `OpaqueTypeDecl`.
 * INTERNAL: Do not import directly.
 */

private import codeql.swift.generated.Synth
private import codeql.swift.generated.Raw
import codeql.swift.elements.decl.GenericTypeDecl
import codeql.swift.elements.type.GenericTypeParamType
import codeql.swift.elements.decl.ValueDecl

/**
 * INTERNAL: This module contains the fully generated definition of `OpaqueTypeDecl` and should not
 * be referenced directly.
 */
module Generated {
  /**
   * A declaration of an opaque type, that is formally equivalent to a given type but abstracts it
   * away.
   *
   * Such a declaration is implicitly given when a declaration is written with an opaque result type,
   * for example
   * ```
   * func opaque() -> some SignedInteger { return 1 }
   * ```
   * See https://docs.swift.org/swift-book/LanguageGuide/OpaqueTypes.html.
   * INTERNAL: Do not reference the `Generated::OpaqueTypeDecl` class directly.
   * Use the subclass `OpaqueTypeDecl`, where the following predicates are available.
   */
  class OpaqueTypeDecl extends Synth::TOpaqueTypeDecl, GenericTypeDecl {
    override string getAPrimaryQlClass() { result = "OpaqueTypeDecl" }

    /**
     * Gets the naming declaration of this opaque type declaration.
     */
    ValueDecl getNamingDeclaration() {
      result =
        Synth::convertValueDeclFromRaw(Synth::convertOpaqueTypeDeclToRaw(this)
              .(Raw::OpaqueTypeDecl)
              .getNamingDeclaration())
    }

    /**
     * Gets the `index`th opaque generic parameter of this opaque type declaration (0-based).
     *
     * This includes nodes from the "hidden" AST. It can be overridden in subclasses to change the
     * behavior of both the `Immediate` and non-`Immediate` versions.
     */
    GenericTypeParamType getImmediateOpaqueGenericParam(int index) {
      result =
        Synth::convertGenericTypeParamTypeFromRaw(Synth::convertOpaqueTypeDeclToRaw(this)
              .(Raw::OpaqueTypeDecl)
              .getOpaqueGenericParam(index))
    }

    /**
     * Gets the `index`th opaque generic parameter of this opaque type declaration (0-based).
     */
    final GenericTypeParamType getOpaqueGenericParam(int index) {
      exists(GenericTypeParamType immediate |
        immediate = this.getImmediateOpaqueGenericParam(index) and
        result = immediate.resolve()
      )
    }

    /**
     * Gets any of the opaque generic parameters of this opaque type declaration.
     */
    final GenericTypeParamType getAnOpaqueGenericParam() { result = this.getOpaqueGenericParam(_) }

    /**
     * Gets the number of opaque generic parameters of this opaque type declaration.
     */
    final int getNumberOfOpaqueGenericParams() {
      result = count(int i | exists(this.getOpaqueGenericParam(i)))
    }
  }
}
