#include <tree_sitter/parser.h>

#if defined(__GNUC__) || defined(__clang__)
#pragma GCC diagnostic push
#pragma GCC diagnostic ignored "-Wmissing-field-initializers"
#endif

#define LANGUAGE_VERSION 14
#define STATE_COUNT 1525
#define LARGE_STATE_COUNT 155
#define SYMBOL_COUNT 280
#define ALIAS_COUNT 3
#define TOKEN_COUNT 108
#define EXTERNAL_TOKEN_COUNT 6
#define FIELD_COUNT 53
#define MAX_ALIAS_SEQUENCE_LENGTH 10
#define PRODUCTION_ID_COUNT 161

enum {
  sym_identifier = 1,
  anon_sym_import = 2,
  anon_sym_DOT = 3,
  anon_sym_from = 4,
  anon_sym___future__ = 5,
  anon_sym_LPAREN = 6,
  anon_sym_RPAREN = 7,
  anon_sym_COMMA = 8,
  anon_sym_as = 9,
  anon_sym_STAR = 10,
  anon_sym_print = 11,
  anon_sym_GT_GT = 12,
  anon_sym_assert = 13,
  anon_sym_COLON_EQ = 14,
  anon_sym_return = 15,
  anon_sym_del = 16,
  anon_sym_raise = 17,
  anon_sym_pass = 18,
  anon_sym_break = 19,
  anon_sym_continue = 20,
  anon_sym_if = 21,
  anon_sym_COLON = 22,
  anon_sym_elif = 23,
  anon_sym_else = 24,
  anon_sym_async = 25,
  anon_sym_for = 26,
  anon_sym_in = 27,
  anon_sym_while = 28,
  anon_sym_try = 29,
  anon_sym_except = 30,
  anon_sym_except_STAR = 31,
  anon_sym_finally = 32,
  anon_sym_with = 33,
  anon_sym_match = 34,
  anon_sym_case = 35,
  anon_sym_PIPE = 36,
  anon_sym_DASH = 37,
  anon_sym_PLUS = 38,
  sym_match_wildcard_pattern = 39,
  anon_sym_LBRACK = 40,
  anon_sym_RBRACK = 41,
  anon_sym_LBRACE = 42,
  anon_sym_RBRACE = 43,
  anon_sym_STAR_STAR = 44,
  anon_sym_EQ = 45,
  anon_sym_def = 46,
  anon_sym_DASH_GT = 47,
  anon_sym_global = 48,
  anon_sym_nonlocal = 49,
  anon_sym_exec = 50,
  anon_sym_type = 51,
  anon_sym_class = 52,
  anon_sym_AT = 53,
  anon_sym_not = 54,
  anon_sym_and = 55,
  anon_sym_or = 56,
  anon_sym_SLASH = 57,
  anon_sym_PERCENT = 58,
  anon_sym_SLASH_SLASH = 59,
  anon_sym_AMP = 60,
  anon_sym_CARET = 61,
  anon_sym_LT_LT = 62,
  anon_sym_TILDE = 63,
  anon_sym_LT = 64,
  anon_sym_LT_EQ = 65,
  anon_sym_EQ_EQ = 66,
  anon_sym_BANG_EQ = 67,
  anon_sym_GT_EQ = 68,
  anon_sym_GT = 69,
  anon_sym_LT_GT = 70,
  anon_sym_is = 71,
  anon_sym_lambda = 72,
  anon_sym_PLUS_EQ = 73,
  anon_sym_DASH_EQ = 74,
  anon_sym_STAR_EQ = 75,
  anon_sym_SLASH_EQ = 76,
  anon_sym_AT_EQ = 77,
  anon_sym_SLASH_SLASH_EQ = 78,
  anon_sym_PERCENT_EQ = 79,
  anon_sym_STAR_STAR_EQ = 80,
  anon_sym_GT_GT_EQ = 81,
  anon_sym_LT_LT_EQ = 82,
  anon_sym_AMP_EQ = 83,
  anon_sym_CARET_EQ = 84,
  anon_sym_PIPE_EQ = 85,
  anon_sym_yield = 86,
  sym_ellipsis = 87,
  anon_sym_LBRACE2 = 88,
  sym__escape_interpolation = 89,
  sym_escape_sequence = 90,
  sym__not_escape_sequence = 91,
  aux_sym_format_specifier_token1 = 92,
  sym_type_conversion = 93,
  sym_integer = 94,
  sym_float = 95,
  anon_sym_await = 96,
  sym_true = 97,
  sym_false = 98,
  sym_none = 99,
  sym_comment = 100,
  sym__semicolon = 101,
  sym__newline = 102,
  sym__indent = 103,
  sym__dedent = 104,
  sym__string_start = 105,
  sym__string_content = 106,
  sym__string_end = 107,
  sym_module = 108,
  sym__statement = 109,
  sym__simple_statements = 110,
  sym_import_statement = 111,
  sym_import_prefix = 112,
  sym_relative_import = 113,
  sym_future_import_statement = 114,
  sym_import_from_statement = 115,
  sym__import_list = 116,
  sym_aliased_import = 117,
  sym_wildcard_import = 118,
  sym_print_statement = 119,
  sym_chevron = 120,
  sym_assert_statement = 121,
  sym_expression_statement = 122,
  sym_named_expression = 123,
  sym_return_statement = 124,
  sym_delete_statement = 125,
  sym_raise_statement = 126,
  sym_pass_statement = 127,
  sym_break_statement = 128,
  sym_continue_statement = 129,
  sym_if_statement = 130,
  sym_elif_clause = 131,
  sym_else_clause = 132,
  sym_for_statement = 133,
  sym_while_statement = 134,
  sym_try_statement = 135,
  sym_except_clause = 136,
  sym_except_group_clause = 137,
  sym_finally_clause = 138,
  sym_with_statement = 139,
  sym_with_clause = 140,
  sym_with_item = 141,
  sym_match_statement = 142,
  sym_cases = 143,
  sym_case_block = 144,
  sym__match_patterns = 145,
  sym_open_sequence_match_pattern = 146,
  sym__match_pattern = 147,
  sym_match_as_pattern = 148,
  sym__match_or_pattern = 149,
  sym_match_or_pattern = 150,
  sym__closed_pattern = 151,
  sym_match_literal_pattern = 152,
  sym_match_capture_pattern = 153,
  sym_match_value_pattern = 154,
  sym_match_group_pattern = 155,
  sym_match_sequence_pattern = 156,
  sym__match_maybe_star_pattern = 157,
  sym_match_star_pattern = 158,
  sym_match_mapping_pattern = 159,
  sym_match_double_star_pattern = 160,
  sym_match_key_value_pattern = 161,
  sym_match_class_pattern = 162,
  sym_pattern_class_name = 163,
  sym_match_positional_pattern = 164,
  sym_match_keyword_pattern = 165,
  sym_guard = 166,
  sym_function_definition = 167,
  sym_parameters = 168,
  sym_lambda_parameters = 169,
  sym_list_splat = 170,
  sym_dictionary_splat = 171,
  sym_global_statement = 172,
  sym_nonlocal_statement = 173,
  sym_exec_statement = 174,
  sym_type_alias_statement = 175,
  sym_class_definition = 176,
  sym_type_parameters = 177,
  sym__type_bound = 178,
  sym_typevar_parameter = 179,
  sym_typevartuple_parameter = 180,
  sym_paramspec_parameter = 181,
  sym__type_parameter = 182,
  sym_parenthesized_list_splat = 183,
  sym_argument_list = 184,
  sym_decorated_definition = 185,
  sym_decorator = 186,
  sym_block = 187,
  sym_expression_list = 188,
  sym_dotted_name = 189,
  sym__parameters = 190,
  sym__patterns = 191,
  sym_parameter = 192,
  sym_pattern = 193,
  sym_tuple_pattern = 194,
  sym_list_pattern = 195,
  sym_default_parameter = 196,
  sym_typed_default_parameter = 197,
  sym_list_splat_pattern = 198,
  sym_dictionary_splat_pattern = 199,
  sym__expression_within_for_in_clause = 200,
  sym_expression = 201,
  sym_primary_expression = 202,
  sym_not_operator = 203,
  sym_boolean_operator = 204,
  sym_binary_operator = 205,
  sym_unary_operator = 206,
  sym_comparison_operator = 207,
  sym_lambda = 208,
  sym_lambda_within_for_in_clause = 209,
  sym_assignment = 210,
  sym_augmented_assignment = 211,
  sym_pattern_list = 212,
  sym__right_hand_side = 213,
  sym_yield = 214,
  sym_attribute = 215,
  sym_subscript = 216,
  sym_slice = 217,
  sym_call = 218,
  sym_typed_parameter = 219,
  sym_type = 220,
  sym_keyword_argument = 221,
  sym_list = 222,
  sym_set = 223,
  sym_tuple = 224,
  sym_dictionary = 225,
  sym_pair = 226,
  sym_list_comprehension = 227,
  sym_dictionary_comprehension = 228,
  sym_set_comprehension = 229,
  sym_generator_expression = 230,
  sym__comprehension_clauses = 231,
  sym_parenthesized_expression = 232,
  sym__collection_elements = 233,
  sym_for_in_clause = 234,
  sym_if_clause = 235,
  sym_conditional_expression = 236,
  sym_concatenated_string = 237,
  sym_string = 238,
  sym_string_content = 239,
  sym_interpolation = 240,
  sym__f_expression = 241,
  sym_format_specifier = 242,
  sym_await = 243,
  sym_positional_separator = 244,
  sym_keyword_separator = 245,
  aux_sym_module_repeat1 = 246,
  aux_sym__simple_statements_repeat1 = 247,
  aux_sym_import_prefix_repeat1 = 248,
  aux_sym__import_list_repeat1 = 249,
  aux_sym_print_statement_repeat1 = 250,
  aux_sym_assert_statement_repeat1 = 251,
  aux_sym_if_statement_repeat1 = 252,
  aux_sym_try_statement_repeat1 = 253,
  aux_sym_try_statement_repeat2 = 254,
  aux_sym_with_clause_repeat1 = 255,
  aux_sym_cases_repeat1 = 256,
  aux_sym_open_sequence_match_pattern_repeat1 = 257,
  aux_sym_match_or_pattern_repeat1 = 258,
  aux_sym_match_value_pattern_repeat1 = 259,
  aux_sym_match_mapping_pattern_repeat1 = 260,
  aux_sym_match_class_pattern_repeat1 = 261,
  aux_sym_match_class_pattern_repeat2 = 262,
  aux_sym_global_statement_repeat1 = 263,
  aux_sym_type_parameters_repeat1 = 264,
  aux_sym_argument_list_repeat1 = 265,
  aux_sym_decorated_definition_repeat1 = 266,
  aux_sym_expression_list_repeat1 = 267,
  aux_sym__parameters_repeat1 = 268,
  aux_sym__patterns_repeat1 = 269,
  aux_sym_comparison_operator_repeat1 = 270,
  aux_sym_subscript_repeat1 = 271,
  aux_sym_dictionary_repeat1 = 272,
  aux_sym__comprehension_clauses_repeat1 = 273,
  aux_sym__collection_elements_repeat1 = 274,
  aux_sym_for_in_clause_repeat1 = 275,
  aux_sym_concatenated_string_repeat1 = 276,
  aux_sym_string_repeat1 = 277,
  aux_sym_string_content_repeat1 = 278,
  aux_sym_format_specifier_repeat1 = 279,
  alias_sym_format_expression = 280,
  anon_alias_sym_isnot = 281,
  anon_alias_sym_notin = 282,
};

static const char * const ts_symbol_names[] = {
  [ts_builtin_sym_end] = "end",
  [sym_identifier] = "identifier",
  [anon_sym_import] = "import",
  [anon_sym_DOT] = ".",
  [anon_sym_from] = "from",
  [anon_sym___future__] = "__future__",
  [anon_sym_LPAREN] = "(",
  [anon_sym_RPAREN] = ")",
  [anon_sym_COMMA] = ",",
  [anon_sym_as] = "as",
  [anon_sym_STAR] = "*",
  [anon_sym_print] = "print",
  [anon_sym_GT_GT] = ">>",
  [anon_sym_assert] = "assert",
  [anon_sym_COLON_EQ] = ":=",
  [anon_sym_return] = "return",
  [anon_sym_del] = "del",
  [anon_sym_raise] = "raise",
  [anon_sym_pass] = "pass",
  [anon_sym_break] = "break",
  [anon_sym_continue] = "continue",
  [anon_sym_if] = "if",
  [anon_sym_COLON] = ":",
  [anon_sym_elif] = "elif",
  [anon_sym_else] = "else",
  [anon_sym_async] = "async",
  [anon_sym_for] = "for",
  [anon_sym_in] = "in",
  [anon_sym_while] = "while",
  [anon_sym_try] = "try",
  [anon_sym_except] = "except",
  [anon_sym_except_STAR] = "except*",
  [anon_sym_finally] = "finally",
  [anon_sym_with] = "with",
  [anon_sym_match] = "match",
  [anon_sym_case] = "case",
  [anon_sym_PIPE] = "|",
  [anon_sym_DASH] = "-",
  [anon_sym_PLUS] = "+",
  [sym_match_wildcard_pattern] = "match_wildcard_pattern",
  [anon_sym_LBRACK] = "[",
  [anon_sym_RBRACK] = "]",
  [anon_sym_LBRACE] = "{",
  [anon_sym_RBRACE] = "}",
  [anon_sym_STAR_STAR] = "**",
  [anon_sym_EQ] = "=",
  [anon_sym_def] = "def",
  [anon_sym_DASH_GT] = "->",
  [anon_sym_global] = "global",
  [anon_sym_nonlocal] = "nonlocal",
  [anon_sym_exec] = "exec",
  [anon_sym_type] = "type",
  [anon_sym_class] = "class",
  [anon_sym_AT] = "@",
  [anon_sym_not] = "not",
  [anon_sym_and] = "and",
  [anon_sym_or] = "or",
  [anon_sym_SLASH] = "/",
  [anon_sym_PERCENT] = "%",
  [anon_sym_SLASH_SLASH] = "//",
  [anon_sym_AMP] = "&",
  [anon_sym_CARET] = "^",
  [anon_sym_LT_LT] = "<<",
  [anon_sym_TILDE] = "~",
  [anon_sym_LT] = "<",
  [anon_sym_LT_EQ] = "<=",
  [anon_sym_EQ_EQ] = "==",
  [anon_sym_BANG_EQ] = "!=",
  [anon_sym_GT_EQ] = ">=",
  [anon_sym_GT] = ">",
  [anon_sym_LT_GT] = "<>",
  [anon_sym_is] = "is",
  [anon_sym_lambda] = "lambda",
  [anon_sym_PLUS_EQ] = "+=",
  [anon_sym_DASH_EQ] = "-=",
  [anon_sym_STAR_EQ] = "*=",
  [anon_sym_SLASH_EQ] = "/=",
  [anon_sym_AT_EQ] = "@=",
  [anon_sym_SLASH_SLASH_EQ] = "//=",
  [anon_sym_PERCENT_EQ] = "%=",
  [anon_sym_STAR_STAR_EQ] = "**=",
  [anon_sym_GT_GT_EQ] = ">>=",
  [anon_sym_LT_LT_EQ] = "<<=",
  [anon_sym_AMP_EQ] = "&=",
  [anon_sym_CARET_EQ] = "^=",
  [anon_sym_PIPE_EQ] = "|=",
  [anon_sym_yield] = "yield",
  [sym_ellipsis] = "ellipsis",
  [anon_sym_LBRACE2] = "{",
  [sym__escape_interpolation] = "_escape_interpolation",
  [sym_escape_sequence] = "escape_sequence",
  [sym__not_escape_sequence] = "_not_escape_sequence",
  [aux_sym_format_specifier_token1] = "format_specifier_token1",
  [sym_type_conversion] = "type_conversion",
  [sym_integer] = "integer",
  [sym_float] = "float",
  [anon_sym_await] = "await",
  [sym_true] = "true",
  [sym_false] = "false",
  [sym_none] = "none",
  [sym_comment] = "comment",
  [sym__semicolon] = "_semicolon",
  [sym__newline] = "_newline",
  [sym__indent] = "_indent",
  [sym__dedent] = "_dedent",
  [sym__string_start] = "\"",
  [sym__string_content] = "_string_content",
  [sym__string_end] = "\"",
  [sym_module] = "module",
  [sym__statement] = "_statement",
  [sym__simple_statements] = "_simple_statements",
  [sym_import_statement] = "import_statement",
  [sym_import_prefix] = "import_prefix",
  [sym_relative_import] = "relative_import",
  [sym_future_import_statement] = "future_import_statement",
  [sym_import_from_statement] = "import_from_statement",
  [sym__import_list] = "_import_list",
  [sym_aliased_import] = "aliased_import",
  [sym_wildcard_import] = "wildcard_import",
  [sym_print_statement] = "print_statement",
  [sym_chevron] = "chevron",
  [sym_assert_statement] = "assert_statement",
  [sym_expression_statement] = "expression_statement",
  [sym_named_expression] = "named_expression",
  [sym_return_statement] = "return_statement",
  [sym_delete_statement] = "delete_statement",
  [sym_raise_statement] = "raise_statement",
  [sym_pass_statement] = "pass_statement",
  [sym_break_statement] = "break_statement",
  [sym_continue_statement] = "continue_statement",
  [sym_if_statement] = "if_statement",
  [sym_elif_clause] = "elif_clause",
  [sym_else_clause] = "else_clause",
  [sym_for_statement] = "for_statement",
  [sym_while_statement] = "while_statement",
  [sym_try_statement] = "try_statement",
  [sym_except_clause] = "except_clause",
  [sym_except_group_clause] = "except_group_clause",
  [sym_finally_clause] = "finally_clause",
  [sym_with_statement] = "with_statement",
  [sym_with_clause] = "with_clause",
  [sym_with_item] = "with_item",
  [sym_match_statement] = "match_statement",
  [sym_cases] = "cases",
  [sym_case_block] = "case_block",
  [sym__match_patterns] = "_match_patterns",
  [sym_open_sequence_match_pattern] = "match_sequence_pattern",
  [sym__match_pattern] = "_match_pattern",
  [sym_match_as_pattern] = "match_as_pattern",
  [sym__match_or_pattern] = "_match_or_pattern",
  [sym_match_or_pattern] = "match_or_pattern",
  [sym__closed_pattern] = "_closed_pattern",
  [sym_match_literal_pattern] = "match_literal_pattern",
  [sym_match_capture_pattern] = "match_capture_pattern",
  [sym_match_value_pattern] = "match_value_pattern",
  [sym_match_group_pattern] = "match_group_pattern",
  [sym_match_sequence_pattern] = "match_sequence_pattern",
  [sym__match_maybe_star_pattern] = "_match_maybe_star_pattern",
  [sym_match_star_pattern] = "match_star_pattern",
  [sym_match_mapping_pattern] = "match_mapping_pattern",
  [sym_match_double_star_pattern] = "match_double_star_pattern",
  [sym_match_key_value_pattern] = "match_key_value_pattern",
  [sym_match_class_pattern] = "match_class_pattern",
  [sym_pattern_class_name] = "pattern_class_name",
  [sym_match_positional_pattern] = "match_positional_pattern",
  [sym_match_keyword_pattern] = "match_keyword_pattern",
  [sym_guard] = "guard",
  [sym_function_definition] = "function_definition",
  [sym_parameters] = "parameters",
  [sym_lambda_parameters] = "lambda_parameters",
  [sym_list_splat] = "list_splat",
  [sym_dictionary_splat] = "dictionary_splat",
  [sym_global_statement] = "global_statement",
  [sym_nonlocal_statement] = "nonlocal_statement",
  [sym_exec_statement] = "exec_statement",
  [sym_type_alias_statement] = "type_alias_statement",
  [sym_class_definition] = "class_definition",
  [sym_type_parameters] = "type_parameters",
  [sym__type_bound] = "_type_bound",
  [sym_typevar_parameter] = "typevar_parameter",
  [sym_typevartuple_parameter] = "typevartuple_parameter",
  [sym_paramspec_parameter] = "paramspec_parameter",
  [sym__type_parameter] = "_type_parameter",
  [sym_parenthesized_list_splat] = "parenthesized_list_splat",
  [sym_argument_list] = "argument_list",
  [sym_decorated_definition] = "decorated_definition",
  [sym_decorator] = "decorator",
  [sym_block] = "block",
  [sym_expression_list] = "expression_list",
  [sym_dotted_name] = "dotted_name",
  [sym__parameters] = "_parameters",
  [sym__patterns] = "_patterns",
  [sym_parameter] = "parameter",
  [sym_pattern] = "pattern",
  [sym_tuple_pattern] = "tuple_pattern",
  [sym_list_pattern] = "list_pattern",
  [sym_default_parameter] = "default_parameter",
  [sym_typed_default_parameter] = "typed_default_parameter",
  [sym_list_splat_pattern] = "list_splat_pattern",
  [sym_dictionary_splat_pattern] = "dictionary_splat_pattern",
  [sym__expression_within_for_in_clause] = "_expression_within_for_in_clause",
  [sym_expression] = "expression",
  [sym_primary_expression] = "primary_expression",
  [sym_not_operator] = "not_operator",
  [sym_boolean_operator] = "boolean_operator",
  [sym_binary_operator] = "binary_operator",
  [sym_unary_operator] = "unary_operator",
  [sym_comparison_operator] = "comparison_operator",
  [sym_lambda] = "lambda",
  [sym_lambda_within_for_in_clause] = "lambda",
  [sym_assignment] = "assignment",
  [sym_augmented_assignment] = "augmented_assignment",
  [sym_pattern_list] = "pattern_list",
  [sym__right_hand_side] = "_right_hand_side",
  [sym_yield] = "yield",
  [sym_attribute] = "attribute",
  [sym_subscript] = "subscript",
  [sym_slice] = "slice",
  [sym_call] = "call",
  [sym_typed_parameter] = "typed_parameter",
  [sym_type] = "type",
  [sym_keyword_argument] = "keyword_argument",
  [sym_list] = "list",
  [sym_set] = "set",
  [sym_tuple] = "tuple",
  [sym_dictionary] = "dictionary",
  [sym_pair] = "pair",
  [sym_list_comprehension] = "list_comprehension",
  [sym_dictionary_comprehension] = "dictionary_comprehension",
  [sym_set_comprehension] = "set_comprehension",
  [sym_generator_expression] = "generator_expression",
  [sym__comprehension_clauses] = "_comprehension_clauses",
  [sym_parenthesized_expression] = "parenthesized_expression",
  [sym__collection_elements] = "_collection_elements",
  [sym_for_in_clause] = "for_in_clause",
  [sym_if_clause] = "if_clause",
  [sym_conditional_expression] = "conditional_expression",
  [sym_concatenated_string] = "concatenated_string",
  [sym_string] = "string",
  [sym_string_content] = "string_content",
  [sym_interpolation] = "interpolation",
  [sym__f_expression] = "_f_expression",
  [sym_format_specifier] = "format_specifier",
  [sym_await] = "await",
  [sym_positional_separator] = "positional_separator",
  [sym_keyword_separator] = "keyword_separator",
  [aux_sym_module_repeat1] = "module_repeat1",
  [aux_sym__simple_statements_repeat1] = "_simple_statements_repeat1",
  [aux_sym_import_prefix_repeat1] = "import_prefix_repeat1",
  [aux_sym__import_list_repeat1] = "_import_list_repeat1",
  [aux_sym_print_statement_repeat1] = "print_statement_repeat1",
  [aux_sym_assert_statement_repeat1] = "assert_statement_repeat1",
  [aux_sym_if_statement_repeat1] = "if_statement_repeat1",
  [aux_sym_try_statement_repeat1] = "try_statement_repeat1",
  [aux_sym_try_statement_repeat2] = "try_statement_repeat2",
  [aux_sym_with_clause_repeat1] = "with_clause_repeat1",
  [aux_sym_cases_repeat1] = "cases_repeat1",
  [aux_sym_open_sequence_match_pattern_repeat1] = "open_sequence_match_pattern_repeat1",
  [aux_sym_match_or_pattern_repeat1] = "match_or_pattern_repeat1",
  [aux_sym_match_value_pattern_repeat1] = "match_value_pattern_repeat1",
  [aux_sym_match_mapping_pattern_repeat1] = "match_mapping_pattern_repeat1",
  [aux_sym_match_class_pattern_repeat1] = "match_class_pattern_repeat1",
  [aux_sym_match_class_pattern_repeat2] = "match_class_pattern_repeat2",
  [aux_sym_global_statement_repeat1] = "global_statement_repeat1",
  [aux_sym_type_parameters_repeat1] = "type_parameters_repeat1",
  [aux_sym_argument_list_repeat1] = "argument_list_repeat1",
  [aux_sym_decorated_definition_repeat1] = "decorated_definition_repeat1",
  [aux_sym_expression_list_repeat1] = "expression_list_repeat1",
  [aux_sym__parameters_repeat1] = "_parameters_repeat1",
  [aux_sym__patterns_repeat1] = "_patterns_repeat1",
  [aux_sym_comparison_operator_repeat1] = "comparison_operator_repeat1",
  [aux_sym_subscript_repeat1] = "subscript_repeat1",
  [aux_sym_dictionary_repeat1] = "dictionary_repeat1",
  [aux_sym__comprehension_clauses_repeat1] = "_comprehension_clauses_repeat1",
  [aux_sym__collection_elements_repeat1] = "_collection_elements_repeat1",
  [aux_sym_for_in_clause_repeat1] = "for_in_clause_repeat1",
  [aux_sym_concatenated_string_repeat1] = "concatenated_string_repeat1",
  [aux_sym_string_repeat1] = "string_repeat1",
  [aux_sym_string_content_repeat1] = "string_content_repeat1",
  [aux_sym_format_specifier_repeat1] = "format_specifier_repeat1",
  [alias_sym_format_expression] = "format_expression",
  [anon_alias_sym_isnot] = "is not",
  [anon_alias_sym_notin] = "not in",
};

static const TSSymbol ts_symbol_map[] = {
  [ts_builtin_sym_end] = ts_builtin_sym_end,
  [sym_identifier] = sym_identifier,
  [anon_sym_import] = anon_sym_import,
  [anon_sym_DOT] = anon_sym_DOT,
  [anon_sym_from] = anon_sym_from,
  [anon_sym___future__] = anon_sym___future__,
  [anon_sym_LPAREN] = anon_sym_LPAREN,
  [anon_sym_RPAREN] = anon_sym_RPAREN,
  [anon_sym_COMMA] = anon_sym_COMMA,
  [anon_sym_as] = anon_sym_as,
  [anon_sym_STAR] = anon_sym_STAR,
  [anon_sym_print] = anon_sym_print,
  [anon_sym_GT_GT] = anon_sym_GT_GT,
  [anon_sym_assert] = anon_sym_assert,
  [anon_sym_COLON_EQ] = anon_sym_COLON_EQ,
  [anon_sym_return] = anon_sym_return,
  [anon_sym_del] = anon_sym_del,
  [anon_sym_raise] = anon_sym_raise,
  [anon_sym_pass] = anon_sym_pass,
  [anon_sym_break] = anon_sym_break,
  [anon_sym_continue] = anon_sym_continue,
  [anon_sym_if] = anon_sym_if,
  [anon_sym_COLON] = anon_sym_COLON,
  [anon_sym_elif] = anon_sym_elif,
  [anon_sym_else] = anon_sym_else,
  [anon_sym_async] = anon_sym_async,
  [anon_sym_for] = anon_sym_for,
  [anon_sym_in] = anon_sym_in,
  [anon_sym_while] = anon_sym_while,
  [anon_sym_try] = anon_sym_try,
  [anon_sym_except] = anon_sym_except,
  [anon_sym_except_STAR] = anon_sym_except_STAR,
  [anon_sym_finally] = anon_sym_finally,
  [anon_sym_with] = anon_sym_with,
  [anon_sym_match] = anon_sym_match,
  [anon_sym_case] = anon_sym_case,
  [anon_sym_PIPE] = anon_sym_PIPE,
  [anon_sym_DASH] = anon_sym_DASH,
  [anon_sym_PLUS] = anon_sym_PLUS,
  [sym_match_wildcard_pattern] = sym_match_wildcard_pattern,
  [anon_sym_LBRACK] = anon_sym_LBRACK,
  [anon_sym_RBRACK] = anon_sym_RBRACK,
  [anon_sym_LBRACE] = anon_sym_LBRACE,
  [anon_sym_RBRACE] = anon_sym_RBRACE,
  [anon_sym_STAR_STAR] = anon_sym_STAR_STAR,
  [anon_sym_EQ] = anon_sym_EQ,
  [anon_sym_def] = anon_sym_def,
  [anon_sym_DASH_GT] = anon_sym_DASH_GT,
  [anon_sym_global] = anon_sym_global,
  [anon_sym_nonlocal] = anon_sym_nonlocal,
  [anon_sym_exec] = anon_sym_exec,
  [anon_sym_type] = anon_sym_type,
  [anon_sym_class] = anon_sym_class,
  [anon_sym_AT] = anon_sym_AT,
  [anon_sym_not] = anon_sym_not,
  [anon_sym_and] = anon_sym_and,
  [anon_sym_or] = anon_sym_or,
  [anon_sym_SLASH] = anon_sym_SLASH,
  [anon_sym_PERCENT] = anon_sym_PERCENT,
  [anon_sym_SLASH_SLASH] = anon_sym_SLASH_SLASH,
  [anon_sym_AMP] = anon_sym_AMP,
  [anon_sym_CARET] = anon_sym_CARET,
  [anon_sym_LT_LT] = anon_sym_LT_LT,
  [anon_sym_TILDE] = anon_sym_TILDE,
  [anon_sym_LT] = anon_sym_LT,
  [anon_sym_LT_EQ] = anon_sym_LT_EQ,
  [anon_sym_EQ_EQ] = anon_sym_EQ_EQ,
  [anon_sym_BANG_EQ] = anon_sym_BANG_EQ,
  [anon_sym_GT_EQ] = anon_sym_GT_EQ,
  [anon_sym_GT] = anon_sym_GT,
  [anon_sym_LT_GT] = anon_sym_LT_GT,
  [anon_sym_is] = anon_sym_is,
  [anon_sym_lambda] = anon_sym_lambda,
  [anon_sym_PLUS_EQ] = anon_sym_PLUS_EQ,
  [anon_sym_DASH_EQ] = anon_sym_DASH_EQ,
  [anon_sym_STAR_EQ] = anon_sym_STAR_EQ,
  [anon_sym_SLASH_EQ] = anon_sym_SLASH_EQ,
  [anon_sym_AT_EQ] = anon_sym_AT_EQ,
  [anon_sym_SLASH_SLASH_EQ] = anon_sym_SLASH_SLASH_EQ,
  [anon_sym_PERCENT_EQ] = anon_sym_PERCENT_EQ,
  [anon_sym_STAR_STAR_EQ] = anon_sym_STAR_STAR_EQ,
  [anon_sym_GT_GT_EQ] = anon_sym_GT_GT_EQ,
  [anon_sym_LT_LT_EQ] = anon_sym_LT_LT_EQ,
  [anon_sym_AMP_EQ] = anon_sym_AMP_EQ,
  [anon_sym_CARET_EQ] = anon_sym_CARET_EQ,
  [anon_sym_PIPE_EQ] = anon_sym_PIPE_EQ,
  [anon_sym_yield] = anon_sym_yield,
  [sym_ellipsis] = sym_ellipsis,
  [anon_sym_LBRACE2] = anon_sym_LBRACE,
  [sym__escape_interpolation] = sym__escape_interpolation,
  [sym_escape_sequence] = sym_escape_sequence,
  [sym__not_escape_sequence] = sym__not_escape_sequence,
  [aux_sym_format_specifier_token1] = aux_sym_format_specifier_token1,
  [sym_type_conversion] = sym_type_conversion,
  [sym_integer] = sym_integer,
  [sym_float] = sym_float,
  [anon_sym_await] = anon_sym_await,
  [sym_true] = sym_true,
  [sym_false] = sym_false,
  [sym_none] = sym_none,
  [sym_comment] = sym_comment,
  [sym__semicolon] = sym__semicolon,
  [sym__newline] = sym__newline,
  [sym__indent] = sym__indent,
  [sym__dedent] = sym__dedent,
  [sym__string_start] = sym__string_start,
  [sym__string_content] = sym__string_content,
  [sym__string_end] = sym__string_start,
  [sym_module] = sym_module,
  [sym__statement] = sym__statement,
  [sym__simple_statements] = sym__simple_statements,
  [sym_import_statement] = sym_import_statement,
  [sym_import_prefix] = sym_import_prefix,
  [sym_relative_import] = sym_relative_import,
  [sym_future_import_statement] = sym_future_import_statement,
  [sym_import_from_statement] = sym_import_from_statement,
  [sym__import_list] = sym__import_list,
  [sym_aliased_import] = sym_aliased_import,
  [sym_wildcard_import] = sym_wildcard_import,
  [sym_print_statement] = sym_print_statement,
  [sym_chevron] = sym_chevron,
  [sym_assert_statement] = sym_assert_statement,
  [sym_expression_statement] = sym_expression_statement,
  [sym_named_expression] = sym_named_expression,
  [sym_return_statement] = sym_return_statement,
  [sym_delete_statement] = sym_delete_statement,
  [sym_raise_statement] = sym_raise_statement,
  [sym_pass_statement] = sym_pass_statement,
  [sym_break_statement] = sym_break_statement,
  [sym_continue_statement] = sym_continue_statement,
  [sym_if_statement] = sym_if_statement,
  [sym_elif_clause] = sym_elif_clause,
  [sym_else_clause] = sym_else_clause,
  [sym_for_statement] = sym_for_statement,
  [sym_while_statement] = sym_while_statement,
  [sym_try_statement] = sym_try_statement,
  [sym_except_clause] = sym_except_clause,
  [sym_except_group_clause] = sym_except_group_clause,
  [sym_finally_clause] = sym_finally_clause,
  [sym_with_statement] = sym_with_statement,
  [sym_with_clause] = sym_with_clause,
  [sym_with_item] = sym_with_item,
  [sym_match_statement] = sym_match_statement,
  [sym_cases] = sym_cases,
  [sym_case_block] = sym_case_block,
  [sym__match_patterns] = sym__match_patterns,
  [sym_open_sequence_match_pattern] = sym_match_sequence_pattern,
  [sym__match_pattern] = sym__match_pattern,
  [sym_match_as_pattern] = sym_match_as_pattern,
  [sym__match_or_pattern] = sym__match_or_pattern,
  [sym_match_or_pattern] = sym_match_or_pattern,
  [sym__closed_pattern] = sym__closed_pattern,
  [sym_match_literal_pattern] = sym_match_literal_pattern,
  [sym_match_capture_pattern] = sym_match_capture_pattern,
  [sym_match_value_pattern] = sym_match_value_pattern,
  [sym_match_group_pattern] = sym_match_group_pattern,
  [sym_match_sequence_pattern] = sym_match_sequence_pattern,
  [sym__match_maybe_star_pattern] = sym__match_maybe_star_pattern,
  [sym_match_star_pattern] = sym_match_star_pattern,
  [sym_match_mapping_pattern] = sym_match_mapping_pattern,
  [sym_match_double_star_pattern] = sym_match_double_star_pattern,
  [sym_match_key_value_pattern] = sym_match_key_value_pattern,
  [sym_match_class_pattern] = sym_match_class_pattern,
  [sym_pattern_class_name] = sym_pattern_class_name,
  [sym_match_positional_pattern] = sym_match_positional_pattern,
  [sym_match_keyword_pattern] = sym_match_keyword_pattern,
  [sym_guard] = sym_guard,
  [sym_function_definition] = sym_function_definition,
  [sym_parameters] = sym_parameters,
  [sym_lambda_parameters] = sym_lambda_parameters,
  [sym_list_splat] = sym_list_splat,
  [sym_dictionary_splat] = sym_dictionary_splat,
  [sym_global_statement] = sym_global_statement,
  [sym_nonlocal_statement] = sym_nonlocal_statement,
  [sym_exec_statement] = sym_exec_statement,
  [sym_type_alias_statement] = sym_type_alias_statement,
  [sym_class_definition] = sym_class_definition,
  [sym_type_parameters] = sym_type_parameters,
  [sym__type_bound] = sym__type_bound,
  [sym_typevar_parameter] = sym_typevar_parameter,
  [sym_typevartuple_parameter] = sym_typevartuple_parameter,
  [sym_paramspec_parameter] = sym_paramspec_parameter,
  [sym__type_parameter] = sym__type_parameter,
  [sym_parenthesized_list_splat] = sym_parenthesized_list_splat,
  [sym_argument_list] = sym_argument_list,
  [sym_decorated_definition] = sym_decorated_definition,
  [sym_decorator] = sym_decorator,
  [sym_block] = sym_block,
  [sym_expression_list] = sym_expression_list,
  [sym_dotted_name] = sym_dotted_name,
  [sym__parameters] = sym__parameters,
  [sym__patterns] = sym__patterns,
  [sym_parameter] = sym_parameter,
  [sym_pattern] = sym_pattern,
  [sym_tuple_pattern] = sym_tuple_pattern,
  [sym_list_pattern] = sym_list_pattern,
  [sym_default_parameter] = sym_default_parameter,
  [sym_typed_default_parameter] = sym_typed_default_parameter,
  [sym_list_splat_pattern] = sym_list_splat_pattern,
  [sym_dictionary_splat_pattern] = sym_dictionary_splat_pattern,
  [sym__expression_within_for_in_clause] = sym__expression_within_for_in_clause,
  [sym_expression] = sym_expression,
  [sym_primary_expression] = sym_primary_expression,
  [sym_not_operator] = sym_not_operator,
  [sym_boolean_operator] = sym_boolean_operator,
  [sym_binary_operator] = sym_binary_operator,
  [sym_unary_operator] = sym_unary_operator,
  [sym_comparison_operator] = sym_comparison_operator,
  [sym_lambda] = sym_lambda,
  [sym_lambda_within_for_in_clause] = sym_lambda,
  [sym_assignment] = sym_assignment,
  [sym_augmented_assignment] = sym_augmented_assignment,
  [sym_pattern_list] = sym_pattern_list,
  [sym__right_hand_side] = sym__right_hand_side,
  [sym_yield] = sym_yield,
  [sym_attribute] = sym_attribute,
  [sym_subscript] = sym_subscript,
  [sym_slice] = sym_slice,
  [sym_call] = sym_call,
  [sym_typed_parameter] = sym_typed_parameter,
  [sym_type] = sym_type,
  [sym_keyword_argument] = sym_keyword_argument,
  [sym_list] = sym_list,
  [sym_set] = sym_set,
  [sym_tuple] = sym_tuple,
  [sym_dictionary] = sym_dictionary,
  [sym_pair] = sym_pair,
  [sym_list_comprehension] = sym_list_comprehension,
  [sym_dictionary_comprehension] = sym_dictionary_comprehension,
  [sym_set_comprehension] = sym_set_comprehension,
  [sym_generator_expression] = sym_generator_expression,
  [sym__comprehension_clauses] = sym__comprehension_clauses,
  [sym_parenthesized_expression] = sym_parenthesized_expression,
  [sym__collection_elements] = sym__collection_elements,
  [sym_for_in_clause] = sym_for_in_clause,
  [sym_if_clause] = sym_if_clause,
  [sym_conditional_expression] = sym_conditional_expression,
  [sym_concatenated_string] = sym_concatenated_string,
  [sym_string] = sym_string,
  [sym_string_content] = sym_string_content,
  [sym_interpolation] = sym_interpolation,
  [sym__f_expression] = sym__f_expression,
  [sym_format_specifier] = sym_format_specifier,
  [sym_await] = sym_await,
  [sym_positional_separator] = sym_positional_separator,
  [sym_keyword_separator] = sym_keyword_separator,
  [aux_sym_module_repeat1] = aux_sym_module_repeat1,
  [aux_sym__simple_statements_repeat1] = aux_sym__simple_statements_repeat1,
  [aux_sym_import_prefix_repeat1] = aux_sym_import_prefix_repeat1,
  [aux_sym__import_list_repeat1] = aux_sym__import_list_repeat1,
  [aux_sym_print_statement_repeat1] = aux_sym_print_statement_repeat1,
  [aux_sym_assert_statement_repeat1] = aux_sym_assert_statement_repeat1,
  [aux_sym_if_statement_repeat1] = aux_sym_if_statement_repeat1,
  [aux_sym_try_statement_repeat1] = aux_sym_try_statement_repeat1,
  [aux_sym_try_statement_repeat2] = aux_sym_try_statement_repeat2,
  [aux_sym_with_clause_repeat1] = aux_sym_with_clause_repeat1,
  [aux_sym_cases_repeat1] = aux_sym_cases_repeat1,
  [aux_sym_open_sequence_match_pattern_repeat1] = aux_sym_open_sequence_match_pattern_repeat1,
  [aux_sym_match_or_pattern_repeat1] = aux_sym_match_or_pattern_repeat1,
  [aux_sym_match_value_pattern_repeat1] = aux_sym_match_value_pattern_repeat1,
  [aux_sym_match_mapping_pattern_repeat1] = aux_sym_match_mapping_pattern_repeat1,
  [aux_sym_match_class_pattern_repeat1] = aux_sym_match_class_pattern_repeat1,
  [aux_sym_match_class_pattern_repeat2] = aux_sym_match_class_pattern_repeat2,
  [aux_sym_global_statement_repeat1] = aux_sym_global_statement_repeat1,
  [aux_sym_type_parameters_repeat1] = aux_sym_type_parameters_repeat1,
  [aux_sym_argument_list_repeat1] = aux_sym_argument_list_repeat1,
  [aux_sym_decorated_definition_repeat1] = aux_sym_decorated_definition_repeat1,
  [aux_sym_expression_list_repeat1] = aux_sym_expression_list_repeat1,
  [aux_sym__parameters_repeat1] = aux_sym__parameters_repeat1,
  [aux_sym__patterns_repeat1] = aux_sym__patterns_repeat1,
  [aux_sym_comparison_operator_repeat1] = aux_sym_comparison_operator_repeat1,
  [aux_sym_subscript_repeat1] = aux_sym_subscript_repeat1,
  [aux_sym_dictionary_repeat1] = aux_sym_dictionary_repeat1,
  [aux_sym__comprehension_clauses_repeat1] = aux_sym__comprehension_clauses_repeat1,
  [aux_sym__collection_elements_repeat1] = aux_sym__collection_elements_repeat1,
  [aux_sym_for_in_clause_repeat1] = aux_sym_for_in_clause_repeat1,
  [aux_sym_concatenated_string_repeat1] = aux_sym_concatenated_string_repeat1,
  [aux_sym_string_repeat1] = aux_sym_string_repeat1,
  [aux_sym_string_content_repeat1] = aux_sym_string_content_repeat1,
  [aux_sym_format_specifier_repeat1] = aux_sym_format_specifier_repeat1,
  [alias_sym_format_expression] = alias_sym_format_expression,
  [anon_alias_sym_isnot] = anon_alias_sym_isnot,
  [anon_alias_sym_notin] = anon_alias_sym_notin,
};

static const TSSymbolMetadata ts_symbol_metadata[] = {
  [ts_builtin_sym_end] = {
    .visible = false,
    .named = true,
  },
  [sym_identifier] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_import] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_from] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___future__] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COMMA] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_as] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_print] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_assert] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_return] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_del] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_raise] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_pass] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_break] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_continue] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_if] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_elif] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_else] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_async] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_for] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_in] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_while] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_try] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_except] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_except_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_finally] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_with] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_match] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_case] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS] = {
    .visible = true,
    .named = false,
  },
  [sym_match_wildcard_pattern] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_def] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_global] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_nonlocal] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_exec] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_type] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_class] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_not] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_and] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_or] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH_SLASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_TILDE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_is] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_lambda] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH_SLASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_STAR_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_yield] = {
    .visible = true,
    .named = false,
  },
  [sym_ellipsis] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_LBRACE2] = {
    .visible = true,
    .named = false,
  },
  [sym__escape_interpolation] = {
    .visible = false,
    .named = true,
  },
  [sym_escape_sequence] = {
    .visible = true,
    .named = true,
  },
  [sym__not_escape_sequence] = {
    .visible = false,
    .named = true,
  },
  [aux_sym_format_specifier_token1] = {
    .visible = false,
    .named = false,
  },
  [sym_type_conversion] = {
    .visible = true,
    .named = true,
  },
  [sym_integer] = {
    .visible = true,
    .named = true,
  },
  [sym_float] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_await] = {
    .visible = true,
    .named = false,
  },
  [sym_true] = {
    .visible = true,
    .named = true,
  },
  [sym_false] = {
    .visible = true,
    .named = true,
  },
  [sym_none] = {
    .visible = true,
    .named = true,
  },
  [sym_comment] = {
    .visible = true,
    .named = true,
  },
  [sym__semicolon] = {
    .visible = false,
    .named = true,
  },
  [sym__newline] = {
    .visible = false,
    .named = true,
  },
  [sym__indent] = {
    .visible = false,
    .named = true,
  },
  [sym__dedent] = {
    .visible = false,
    .named = true,
  },
  [sym__string_start] = {
    .visible = true,
    .named = false,
  },
  [sym__string_content] = {
    .visible = false,
    .named = true,
  },
  [sym__string_end] = {
    .visible = true,
    .named = false,
  },
  [sym_module] = {
    .visible = true,
    .named = true,
  },
  [sym__statement] = {
    .visible = false,
    .named = true,
  },
  [sym__simple_statements] = {
    .visible = false,
    .named = true,
  },
  [sym_import_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_import_prefix] = {
    .visible = true,
    .named = true,
  },
  [sym_relative_import] = {
    .visible = true,
    .named = true,
  },
  [sym_future_import_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_import_from_statement] = {
    .visible = true,
    .named = true,
  },
  [sym__import_list] = {
    .visible = false,
    .named = true,
  },
  [sym_aliased_import] = {
    .visible = true,
    .named = true,
  },
  [sym_wildcard_import] = {
    .visible = true,
    .named = true,
  },
  [sym_print_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_chevron] = {
    .visible = true,
    .named = true,
  },
  [sym_assert_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_expression_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_named_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_return_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_delete_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_raise_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_pass_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_break_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_continue_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_if_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_elif_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_else_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_for_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_while_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_try_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_except_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_except_group_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_finally_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_with_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_with_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_with_item] = {
    .visible = true,
    .named = true,
  },
  [sym_match_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_cases] = {
    .visible = true,
    .named = true,
  },
  [sym_case_block] = {
    .visible = true,
    .named = true,
  },
  [sym__match_patterns] = {
    .visible = false,
    .named = true,
  },
  [sym_open_sequence_match_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym__match_pattern] = {
    .visible = false,
    .named = true,
  },
  [sym_match_as_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym__match_or_pattern] = {
    .visible = false,
    .named = true,
  },
  [sym_match_or_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym__closed_pattern] = {
    .visible = false,
    .named = true,
  },
  [sym_match_literal_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_match_capture_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_match_value_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_match_group_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_match_sequence_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym__match_maybe_star_pattern] = {
    .visible = false,
    .named = true,
  },
  [sym_match_star_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_match_mapping_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_match_double_star_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_match_key_value_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_match_class_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_pattern_class_name] = {
    .visible = true,
    .named = true,
  },
  [sym_match_positional_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_match_keyword_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_guard] = {
    .visible = true,
    .named = true,
  },
  [sym_function_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_parameters] = {
    .visible = true,
    .named = true,
  },
  [sym_lambda_parameters] = {
    .visible = true,
    .named = true,
  },
  [sym_list_splat] = {
    .visible = true,
    .named = true,
  },
  [sym_dictionary_splat] = {
    .visible = true,
    .named = true,
  },
  [sym_global_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_nonlocal_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_exec_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_type_alias_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_class_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_type_parameters] = {
    .visible = true,
    .named = true,
  },
  [sym__type_bound] = {
    .visible = false,
    .named = true,
  },
  [sym_typevar_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_typevartuple_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_paramspec_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym__type_parameter] = {
    .visible = false,
    .named = true,
  },
  [sym_parenthesized_list_splat] = {
    .visible = true,
    .named = true,
  },
  [sym_argument_list] = {
    .visible = true,
    .named = true,
  },
  [sym_decorated_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_decorator] = {
    .visible = true,
    .named = true,
  },
  [sym_block] = {
    .visible = true,
    .named = true,
  },
  [sym_expression_list] = {
    .visible = true,
    .named = true,
  },
  [sym_dotted_name] = {
    .visible = true,
    .named = true,
  },
  [sym__parameters] = {
    .visible = false,
    .named = true,
  },
  [sym__patterns] = {
    .visible = false,
    .named = true,
  },
  [sym_parameter] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_pattern] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_tuple_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_list_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_default_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_typed_default_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_list_splat_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_dictionary_splat_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym__expression_within_for_in_clause] = {
    .visible = false,
    .named = true,
  },
  [sym_expression] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_primary_expression] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_not_operator] = {
    .visible = true,
    .named = true,
  },
  [sym_boolean_operator] = {
    .visible = true,
    .named = true,
  },
  [sym_binary_operator] = {
    .visible = true,
    .named = true,
  },
  [sym_unary_operator] = {
    .visible = true,
    .named = true,
  },
  [sym_comparison_operator] = {
    .visible = true,
    .named = true,
  },
  [sym_lambda] = {
    .visible = true,
    .named = true,
  },
  [sym_lambda_within_for_in_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_assignment] = {
    .visible = true,
    .named = true,
  },
  [sym_augmented_assignment] = {
    .visible = true,
    .named = true,
  },
  [sym_pattern_list] = {
    .visible = true,
    .named = true,
  },
  [sym__right_hand_side] = {
    .visible = false,
    .named = true,
  },
  [sym_yield] = {
    .visible = true,
    .named = true,
  },
  [sym_attribute] = {
    .visible = true,
    .named = true,
  },
  [sym_subscript] = {
    .visible = true,
    .named = true,
  },
  [sym_slice] = {
    .visible = true,
    .named = true,
  },
  [sym_call] = {
    .visible = true,
    .named = true,
  },
  [sym_typed_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_type] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_argument] = {
    .visible = true,
    .named = true,
  },
  [sym_list] = {
    .visible = true,
    .named = true,
  },
  [sym_set] = {
    .visible = true,
    .named = true,
  },
  [sym_tuple] = {
    .visible = true,
    .named = true,
  },
  [sym_dictionary] = {
    .visible = true,
    .named = true,
  },
  [sym_pair] = {
    .visible = true,
    .named = true,
  },
  [sym_list_comprehension] = {
    .visible = true,
    .named = true,
  },
  [sym_dictionary_comprehension] = {
    .visible = true,
    .named = true,
  },
  [sym_set_comprehension] = {
    .visible = true,
    .named = true,
  },
  [sym_generator_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__comprehension_clauses] = {
    .visible = false,
    .named = true,
  },
  [sym_parenthesized_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__collection_elements] = {
    .visible = false,
    .named = true,
  },
  [sym_for_in_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_if_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_conditional_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_concatenated_string] = {
    .visible = true,
    .named = true,
  },
  [sym_string] = {
    .visible = true,
    .named = true,
  },
  [sym_string_content] = {
    .visible = true,
    .named = true,
  },
  [sym_interpolation] = {
    .visible = true,
    .named = true,
  },
  [sym__f_expression] = {
    .visible = false,
    .named = true,
  },
  [sym_format_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym_await] = {
    .visible = true,
    .named = true,
  },
  [sym_positional_separator] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_separator] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_module_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__simple_statements_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_import_prefix_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__import_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_print_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_assert_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_if_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_try_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_try_statement_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_with_clause_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_cases_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_open_sequence_match_pattern_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_match_or_pattern_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_match_value_pattern_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_match_mapping_pattern_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_match_class_pattern_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_match_class_pattern_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_global_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_type_parameters_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_argument_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_decorated_definition_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_expression_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__parameters_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__patterns_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_comparison_operator_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_subscript_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_dictionary_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__comprehension_clauses_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__collection_elements_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_for_in_clause_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_concatenated_string_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_string_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_string_content_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_format_specifier_repeat1] = {
    .visible = false,
    .named = false,
  },
  [alias_sym_format_expression] = {
    .visible = true,
    .named = true,
  },
  [anon_alias_sym_isnot] = {
    .visible = true,
    .named = false,
  },
  [anon_alias_sym_notin] = {
    .visible = true,
    .named = false,
  },
};

enum {
  field_alias = 1,
  field_alternative = 2,
  field_argument = 3,
  field_arguments = 4,
  field_attribute = 5,
  field_body = 6,
  field_bound = 7,
  field_cases = 8,
  field_cause = 9,
  field_class = 10,
  field_code = 11,
  field_condition = 12,
  field_consequence = 13,
  field_content = 14,
  field_definition = 15,
  field_element = 16,
  field_expression = 17,
  field_function = 18,
  field_guard = 19,
  field_imaginary = 20,
  field_inner = 21,
  field_interpolation = 22,
  field_key = 23,
  field_kwarg = 24,
  field_left = 25,
  field_module_name = 26,
  field_name = 27,
  field_object = 28,
  field_operator = 29,
  field_operators = 30,
  field_parameters = 31,
  field_pattern = 32,
  field_prefix = 33,
  field_prefix_operator = 34,
  field_real = 35,
  field_return_type = 36,
  field_right = 37,
  field_start = 38,
  field_step = 39,
  field_stop = 40,
  field_string_content = 41,
  field_subject = 42,
  field_subscript = 43,
  field_suffix = 44,
  field_superclasses = 45,
  field_target = 46,
  field_test = 47,
  field_trailing_comma = 48,
  field_type = 49,
  field_type_parameter = 50,
  field_type_parameters = 51,
  field_value = 52,
  field_vararg = 53,
};

static const char * const ts_field_names[] = {
  [0] = NULL,
  [field_alias] = "alias",
  [field_alternative] = "alternative",
  [field_argument] = "argument",
  [field_arguments] = "arguments",
  [field_attribute] = "attribute",
  [field_body] = "body",
  [field_bound] = "bound",
  [field_cases] = "cases",
  [field_cause] = "cause",
  [field_class] = "class",
  [field_code] = "code",
  [field_condition] = "condition",
  [field_consequence] = "consequence",
  [field_content] = "content",
  [field_definition] = "definition",
  [field_element] = "element",
  [field_expression] = "expression",
  [field_function] = "function",
  [field_guard] = "guard",
  [field_imaginary] = "imaginary",
  [field_inner] = "inner",
  [field_interpolation] = "interpolation",
  [field_key] = "key",
  [field_kwarg] = "kwarg",
  [field_left] = "left",
  [field_module_name] = "module_name",
  [field_name] = "name",
  [field_object] = "object",
  [field_operator] = "operator",
  [field_operators] = "operators",
  [field_parameters] = "parameters",
  [field_pattern] = "pattern",
  [field_prefix] = "prefix",
  [field_prefix_operator] = "prefix_operator",
  [field_real] = "real",
  [field_return_type] = "return_type",
  [field_right] = "right",
  [field_start] = "start",
  [field_step] = "step",
  [field_stop] = "stop",
  [field_string_content] = "string_content",
  [field_subject] = "subject",
  [field_subscript] = "subscript",
  [field_suffix] = "suffix",
  [field_superclasses] = "superclasses",
  [field_target] = "target",
  [field_test] = "test",
  [field_trailing_comma] = "trailing_comma",
  [field_type] = "type",
  [field_type_parameter] = "type_parameter",
  [field_type_parameters] = "type_parameters",
  [field_value] = "value",
  [field_vararg] = "vararg",
};

static const TSFieldMapSlice ts_field_map_slices[PRODUCTION_ID_COUNT] = {
  [2] = {.index = 0, .length = 2},
  [3] = {.index = 2, .length = 1},
  [4] = {.index = 3, .length = 1},
  [5] = {.index = 4, .length = 1},
  [6] = {.index = 5, .length = 1},
  [7] = {.index = 6, .length = 1},
  [8] = {.index = 7, .length = 1},
  [9] = {.index = 7, .length = 1},
  [10] = {.index = 8, .length = 1},
  [11] = {.index = 9, .length = 1},
  [12] = {.index = 10, .length = 1},
  [13] = {.index = 11, .length = 2},
  [14] = {.index = 13, .length = 1},
  [15] = {.index = 14, .length = 1},
  [16] = {.index = 15, .length = 2},
  [17] = {.index = 17, .length = 2},
  [18] = {.index = 19, .length = 1},
  [19] = {.index = 20, .length = 1},
  [20] = {.index = 21, .length = 4},
  [21] = {.index = 25, .length = 4},
  [22] = {.index = 29, .length = 2},
  [23] = {.index = 31, .length = 1},
  [24] = {.index = 32, .length = 2},
  [25] = {.index = 34, .length = 2},
  [26] = {.index = 36, .length = 1},
  [27] = {.index = 37, .length = 2},
  [28] = {.index = 39, .length = 1},
  [29] = {.index = 40, .length = 2},
  [30] = {.index = 42, .length = 1},
  [31] = {.index = 43, .length = 1},
  [32] = {.index = 44, .length = 1},
  [33] = {.index = 45, .length = 1},
  [34] = {.index = 45, .length = 1},
  [35] = {.index = 37, .length = 2},
  [36] = {.index = 46, .length = 2},
  [37] = {.index = 48, .length = 2},
  [38] = {.index = 50, .length = 2},
  [39] = {.index = 52, .length = 3},
  [40] = {.index = 55, .length = 2},
  [41] = {.index = 57, .length = 1},
  [42] = {.index = 58, .length = 2},
  [43] = {.index = 60, .length = 1},
  [44] = {.index = 61, .length = 2},
  [45] = {.index = 63, .length = 2},
  [46] = {.index = 65, .length = 1},
  [47] = {.index = 66, .length = 2},
  [48] = {.index = 68, .length = 1},
  [50] = {.index = 69, .length = 3},
  [51] = {.index = 72, .length = 1},
  [52] = {.index = 73, .length = 2},
  [53] = {.index = 75, .length = 1},
  [54] = {.index = 76, .length = 2},
  [55] = {.index = 78, .length = 2},
  [56] = {.index = 44, .length = 1},
  [57] = {.index = 80, .length = 1},
  [58] = {.index = 81, .length = 2},
  [59] = {.index = 83, .length = 2},
  [60] = {.index = 83, .length = 2},
  [61] = {.index = 85, .length = 2},
  [62] = {.index = 87, .length = 2},
  [63] = {.index = 89, .length = 2},
  [64] = {.index = 91, .length = 2},
  [65] = {.index = 93, .length = 1},
  [66] = {.index = 94, .length = 2},
  [67] = {.index = 43, .length = 1},
  [68] = {.index = 96, .length = 1},
  [69] = {.index = 97, .length = 1},
  [70] = {.index = 98, .length = 2},
  [71] = {.index = 100, .length = 2},
  [72] = {.index = 100, .length = 2},
  [74] = {.index = 102, .length = 1},
  [75] = {.index = 103, .length = 3},
  [76] = {.index = 106, .length = 3},
  [77] = {.index = 109, .length = 3},
  [78] = {.index = 112, .length = 1},
  [79] = {.index = 113, .length = 3},
  [80] = {.index = 116, .length = 3},
  [81] = {.index = 119, .length = 2},
  [82] = {.index = 121, .length = 2},
  [83] = {.index = 123, .length = 1},
  [84] = {.index = 124, .length = 2},
  [85] = {.index = 126, .length = 1},
  [86] = {.index = 127, .length = 3},
  [87] = {.index = 130, .length = 3},
  [88] = {.index = 133, .length = 3},
  [89] = {.index = 136, .length = 3},
  [90] = {.index = 139, .length = 3},
  [91] = {.index = 142, .length = 3},
  [92] = {.index = 85, .length = 2},
  [93] = {.index = 145, .length = 1},
  [94] = {.index = 146, .length = 1},
  [95] = {.index = 147, .length = 2},
  [96] = {.index = 149, .length = 3},
  [97] = {.index = 152, .length = 2},
  [98] = {.index = 154, .length = 1},
  [99] = {.index = 155, .length = 2},
  [100] = {.index = 157, .length = 2},
  [101] = {.index = 159, .length = 4},
  [102] = {.index = 163, .length = 2},
  [103] = {.index = 165, .length = 4},
  [104] = {.index = 169, .length = 4},
  [105] = {.index = 173, .length = 2},
  [106] = {.index = 175, .length = 3},
  [107] = {.index = 178, .length = 3},
  [108] = {.index = 181, .length = 4},
  [109] = {.index = 185, .length = 2},
  [110] = {.index = 187, .length = 1},
  [111] = {.index = 188, .length = 2},
  [112] = {.index = 190, .length = 2},
  [113] = {.index = 192, .length = 4},
  [114] = {.index = 196, .length = 4},
  [115] = {.index = 200, .length = 4},
  [116] = {.index = 204, .length = 4},
  [117] = {.index = 208, .length = 4},
  [118] = {.index = 212, .length = 3},
  [119] = {.index = 215, .length = 2},
  [120] = {.index = 217, .length = 2},
  [121] = {.index = 219, .length = 2},
  [122] = {.index = 221, .length = 3},
  [123] = {.index = 224, .length = 5},
  [124] = {.index = 229, .length = 3},
  [125] = {.index = 232, .length = 4},
  [126] = {.index = 236, .length = 4},
  [127] = {.index = 240, .length = 4},
  [128] = {.index = 244, .length = 4},
  [129] = {.index = 248, .length = 2},
  [130] = {.index = 250, .length = 1},
  [131] = {.index = 251, .length = 3},
  [132] = {.index = 254, .length = 1},
  [133] = {.index = 255, .length = 2},
  [134] = {.index = 257, .length = 2},
  [135] = {.index = 259, .length = 1},
  [136] = {.index = 260, .length = 4},
  [137] = {.index = 264, .length = 5},
  [138] = {.index = 269, .length = 5},
  [139] = {.index = 274, .length = 3},
  [140] = {.index = 277, .length = 3},
  [141] = {.index = 280, .length = 4},
  [142] = {.index = 284, .length = 4},
  [143] = {.index = 288, .length = 4},
  [144] = {.index = 292, .length = 5},
  [145] = {.index = 297, .length = 5},
  [146] = {.index = 302, .length = 3},
  [147] = {.index = 305, .length = 4},
  [148] = {.index = 309, .length = 3},
  [149] = {.index = 312, .length = 3},
  [150] = {.index = 315, .length = 5},
  [151] = {.index = 320, .length = 5},
  [152] = {.index = 325, .length = 5},
  [153] = {.index = 330, .length = 5},
  [154] = {.index = 335, .length = 5},
  [155] = {.index = 340, .length = 3},
  [156] = {.index = 343, .length = 4},
  [157] = {.index = 347, .length = 2},
  [158] = {.index = 349, .length = 6},
  [159] = {.index = 355, .length = 6},
  [160] = {.index = 361, .length = 4},
};

static const TSFieldMapEntry ts_field_map_entries[] = {
  [0] =
    {field_prefix, 0},
    {field_suffix, 1},
  [2] =
    {field_string_content, 0},
  [3] =
    {field_interpolation, 0},
  [4] =
    {field_name, 1, .inherited = true},
  [5] =
    {field_name, 0},
  [6] =
    {field_element, 0},
  [7] =
    {field_vararg, 1},
  [8] =
    {field_argument, 1},
  [9] =
    {field_target, 1},
  [10] =
    {field_value, 0},
  [11] =
    {field_argument, 1},
    {field_operator, 0},
  [13] =
    {field_value, 1},
  [14] =
    {field_code, 1},
  [15] =
    {field_element, 0},
    {field_element, 1, .inherited = true},
  [17] =
    {field_arguments, 1},
    {field_function, 0},
  [19] =
    {field_operators, 1, .inherited = true},
  [20] =
    {field_definition, 1},
  [21] =
    {field_interpolation, 1, .inherited = true},
    {field_prefix, 0},
    {field_string_content, 1, .inherited = true},
    {field_suffix, 2},
  [25] =
    {field_interpolation, 0, .inherited = true},
    {field_interpolation, 1, .inherited = true},
    {field_string_content, 0, .inherited = true},
    {field_string_content, 1, .inherited = true},
  [29] =
    {field_name, 0},
    {field_name, 1, .inherited = true},
  [31] =
    {field_name, 1},
  [32] =
    {field_element, 0},
    {field_trailing_comma, 1},
  [34] =
    {field_element, 1, .inherited = true},
    {field_trailing_comma, 1, .inherited = true},
  [36] =
    {field_inner, 1},
  [37] =
    {field_name, 0},
    {field_value, 2},
  [39] =
    {field_argument, 2, .inherited = true},
  [40] =
    {field_argument, 1},
    {field_argument, 2, .inherited = true},
  [42] =
    {field_cause, 2},
  [43] =
    {field_element, 1},
  [44] =
    {field_body, 2},
  [45] =
    {field_kwarg, 1},
  [46] =
    {field_element, 0, .inherited = true},
    {field_element, 1, .inherited = true},
  [48] =
    {field_left, 0},
    {field_type, 2},
  [50] =
    {field_left, 0},
    {field_right, 2},
  [52] =
    {field_left, 0},
    {field_operator, 1},
    {field_right, 2},
  [55] =
    {field_attribute, 2},
    {field_object, 0},
  [57] =
    {field_operators, 0},
  [58] =
    {field_operators, 0, .inherited = true},
    {field_operators, 1, .inherited = true},
  [60] =
    {field_expression, 1},
  [61] =
    {field_name, 0, .inherited = true},
    {field_name, 1, .inherited = true},
  [63] =
    {field_alias, 2},
    {field_name, 0},
  [65] =
    {field_name, 3, .inherited = true},
  [66] =
    {field_module_name, 1},
    {field_name, 3, .inherited = true},
  [68] =
    {field_module_name, 1},
  [69] =
    {field_element, 0},
    {field_element, 1, .inherited = true},
    {field_trailing_comma, 2},
  [72] =
    {field_body, 1},
  [73] =
    {field_argument, 0, .inherited = true},
    {field_argument, 1, .inherited = true},
  [75] =
    {field_cause, 3},
  [76] =
    {field_condition, 1},
    {field_consequence, 3},
  [78] =
    {field_body, 3},
    {field_condition, 1},
  [80] =
    {field_body, 3},
  [81] =
    {field_alias, 2},
    {field_value, 0},
  [83] =
    {field_cases, 3},
    {field_subject, 1},
  [85] =
    {field_element, 1},
    {field_element, 2, .inherited = true},
  [87] =
    {field_key, 0},
    {field_value, 2},
  [89] =
    {field_name, 1},
    {field_value, 3},
  [91] =
    {field_body, 3},
    {field_name, 1},
  [93] =
    {field_type, 2},
  [94] =
    {field_body, 3},
    {field_parameters, 1},
  [96] =
    {field_stop, 1},
  [97] =
    {field_start, 0},
  [98] =
    {field_subscript, 2},
    {field_value, 0},
  [100] =
    {field_operators, 0},
    {field_operators, 1},
  [102] =
    {field_alternative, 0},
  [103] =
    {field_alternative, 4},
    {field_condition, 1},
    {field_consequence, 3},
  [106] =
    {field_alternative, 4, .inherited = true},
    {field_condition, 1},
    {field_consequence, 3},
  [109] =
    {field_condition, 1},
    {field_consequence, 3},
    {field_consequence, 4},
  [112] =
    {field_body, 4},
  [113] =
    {field_alternative, 4},
    {field_body, 3},
    {field_condition, 1},
  [116] =
    {field_body, 3},
    {field_body, 4},
    {field_condition, 1},
  [119] =
    {field_body, 2},
    {field_body, 3},
  [121] =
    {field_body, 3},
    {field_body, 4},
  [123] =
    {field_real, 0},
  [124] =
    {field_bound, 1, .inherited = true},
    {field_name, 0},
  [126] =
    {field_type_parameter, 1},
  [127] =
    {field_body, 4},
    {field_name, 1},
    {field_parameters, 2},
  [130] =
    {field_name, 1},
    {field_type_parameters, 2},
    {field_value, 4},
  [133] =
    {field_body, 3},
    {field_body, 4},
    {field_name, 1},
  [136] =
    {field_body, 4},
    {field_name, 1},
    {field_type_parameters, 2},
  [139] =
    {field_body, 4},
    {field_name, 1},
    {field_superclasses, 2},
  [142] =
    {field_left, 0},
    {field_right, 4},
    {field_type, 2},
  [145] =
    {field_step, 2},
  [146] =
    {field_subscript, 1},
  [147] =
    {field_start, 0},
    {field_stop, 2},
  [149] =
    {field_subscript, 2},
    {field_subscript, 3, .inherited = true},
    {field_value, 0},
  [152] =
    {field_subscript, 0, .inherited = true},
    {field_subscript, 1, .inherited = true},
  [154] =
    {field_name, 4, .inherited = true},
  [155] =
    {field_module_name, 1},
    {field_name, 4, .inherited = true},
  [157] =
    {field_left, 1},
    {field_right, 3},
  [159] =
    {field_alternative, 4, .inherited = true},
    {field_alternative, 5},
    {field_condition, 1},
    {field_consequence, 3},
  [163] =
    {field_alternative, 0, .inherited = true},
    {field_alternative, 1, .inherited = true},
  [165] =
    {field_alternative, 5},
    {field_condition, 1},
    {field_consequence, 3},
    {field_consequence, 4},
  [169] =
    {field_alternative, 5, .inherited = true},
    {field_condition, 1},
    {field_consequence, 3},
    {field_consequence, 4},
  [173] =
    {field_body, 4},
    {field_body, 5},
  [175] =
    {field_body, 5},
    {field_name, 2},
    {field_parameters, 3},
  [178] =
    {field_body, 5},
    {field_left, 1},
    {field_right, 3},
  [181] =
    {field_alternative, 5},
    {field_body, 3},
    {field_body, 4},
    {field_condition, 1},
  [185] =
    {field_prefix_operator, 0},
    {field_real, 1},
  [187] =
    {field_bound, 1},
  [188] =
    {field_type_parameter, 1},
    {field_type_parameter, 2, .inherited = true},
  [190] =
    {field_type_parameter, 0, .inherited = true},
    {field_type_parameter, 1, .inherited = true},
  [192] =
    {field_body, 4},
    {field_body, 5},
    {field_name, 1},
    {field_parameters, 2},
  [196] =
    {field_body, 5},
    {field_name, 1},
    {field_parameters, 3},
    {field_type_parameters, 2},
  [200] =
    {field_body, 4},
    {field_body, 5},
    {field_name, 1},
    {field_type_parameters, 2},
  [204] =
    {field_body, 5},
    {field_name, 1},
    {field_superclasses, 3},
    {field_type_parameters, 2},
  [208] =
    {field_body, 4},
    {field_body, 5},
    {field_name, 1},
    {field_superclasses, 2},
  [212] =
    {field_name, 0},
    {field_type, 2},
    {field_value, 4},
  [215] =
    {field_step, 3},
    {field_stop, 1},
  [217] =
    {field_start, 0},
    {field_step, 3},
  [219] =
    {field_left, 2},
    {field_right, 4},
  [221] =
    {field_left, 1},
    {field_right, 3},
    {field_right, 4},
  [224] =
    {field_alternative, 5, .inherited = true},
    {field_alternative, 6},
    {field_condition, 1},
    {field_consequence, 3},
    {field_consequence, 4},
  [229] =
    {field_body, 6},
    {field_left, 2},
    {field_right, 4},
  [232] =
    {field_body, 5},
    {field_body, 6},
    {field_name, 2},
    {field_parameters, 3},
  [236] =
    {field_body, 6},
    {field_name, 2},
    {field_parameters, 4},
    {field_type_parameters, 3},
  [240] =
    {field_alternative, 6},
    {field_body, 5},
    {field_left, 1},
    {field_right, 3},
  [244] =
    {field_body, 5},
    {field_body, 6},
    {field_left, 1},
    {field_right, 3},
  [248] =
    {field_body, 3},
    {field_type, 1},
  [250] =
    {field_content, 1},
  [251] =
    {field_imaginary, 2},
    {field_operator, 1},
    {field_real, 0},
  [254] =
    {field_test, 1},
  [255] =
    {field_body, 3},
    {field_pattern, 1},
  [257] =
    {field_alias, 2},
    {field_pattern, 0},
  [259] =
    {field_class, 0},
  [260] =
    {field_body, 6},
    {field_name, 1},
    {field_parameters, 2},
    {field_return_type, 4},
  [264] =
    {field_body, 5},
    {field_body, 6},
    {field_name, 1},
    {field_parameters, 3},
    {field_type_parameters, 2},
  [269] =
    {field_body, 5},
    {field_body, 6},
    {field_name, 1},
    {field_superclasses, 3},
    {field_type_parameters, 2},
  [274] =
    {field_start, 0},
    {field_step, 4},
    {field_stop, 2},
  [277] =
    {field_left, 2},
    {field_right, 4},
    {field_right, 5},
  [280] =
    {field_alternative, 7},
    {field_body, 6},
    {field_left, 2},
    {field_right, 4},
  [284] =
    {field_body, 6},
    {field_body, 7},
    {field_left, 2},
    {field_right, 4},
  [288] =
    {field_body, 7},
    {field_name, 2},
    {field_parameters, 3},
    {field_return_type, 5},
  [292] =
    {field_body, 6},
    {field_body, 7},
    {field_name, 2},
    {field_parameters, 4},
    {field_type_parameters, 3},
  [297] =
    {field_alternative, 7},
    {field_body, 5},
    {field_body, 6},
    {field_left, 1},
    {field_right, 3},
  [302] =
    {field_body, 3},
    {field_body, 4},
    {field_type, 1},
  [305] =
    {field_imaginary, 3},
    {field_operator, 2},
    {field_prefix_operator, 0},
    {field_real, 1},
  [309] =
    {field_body, 3},
    {field_body, 4},
    {field_pattern, 1},
  [312] =
    {field_body, 4},
    {field_guard, 2},
    {field_pattern, 1},
  [315] =
    {field_body, 6},
    {field_body, 7},
    {field_name, 1},
    {field_parameters, 2},
    {field_return_type, 4},
  [320] =
    {field_body, 7},
    {field_name, 1},
    {field_parameters, 3},
    {field_return_type, 5},
    {field_type_parameters, 2},
  [325] =
    {field_alternative, 8},
    {field_body, 6},
    {field_body, 7},
    {field_left, 2},
    {field_right, 4},
  [330] =
    {field_body, 7},
    {field_body, 8},
    {field_name, 2},
    {field_parameters, 3},
    {field_return_type, 5},
  [335] =
    {field_body, 8},
    {field_name, 2},
    {field_parameters, 4},
    {field_return_type, 6},
    {field_type_parameters, 3},
  [340] =
    {field_alias, 3},
    {field_body, 5},
    {field_type, 1},
  [343] =
    {field_body, 4},
    {field_body, 5},
    {field_guard, 2},
    {field_pattern, 1},
  [347] =
    {field_attribute, 0},
    {field_value, 2},
  [349] =
    {field_body, 7},
    {field_body, 8},
    {field_name, 1},
    {field_parameters, 3},
    {field_return_type, 5},
    {field_type_parameters, 2},
  [355] =
    {field_body, 8},
    {field_body, 9},
    {field_name, 2},
    {field_parameters, 4},
    {field_return_type, 6},
    {field_type_parameters, 3},
  [361] =
    {field_alias, 3},
    {field_body, 5},
    {field_body, 6},
    {field_type, 1},
};

static const TSSymbol ts_alias_sequences[PRODUCTION_ID_COUNT][MAX_ALIAS_SEQUENCE_LENGTH] = {
  [0] = {0},
  [1] = {
    [0] = sym_identifier,
  },
  [8] = {
    [1] = sym_identifier,
  },
  [27] = {
    [0] = sym_identifier,
  },
  [33] = {
    [1] = sym_identifier,
  },
  [49] = {
    [1] = sym_parenthesized_expression,
  },
  [54] = {
    [3] = sym_block,
  },
  [55] = {
    [3] = sym_block,
  },
  [56] = {
    [2] = sym_block,
  },
  [57] = {
    [3] = sym_block,
  },
  [59] = {
    [1] = sym_tuple,
  },
  [64] = {
    [3] = sym_block,
  },
  [67] = {
    [1] = sym_parenthesized_expression,
  },
  [71] = {
    [0] = anon_alias_sym_notin,
    [1] = anon_alias_sym_notin,
  },
  [72] = {
    [0] = anon_alias_sym_isnot,
    [1] = anon_alias_sym_isnot,
  },
  [73] = {
    [0] = alias_sym_format_expression,
  },
  [75] = {
    [3] = sym_block,
  },
  [76] = {
    [3] = sym_block,
  },
  [78] = {
    [4] = sym_block,
  },
  [79] = {
    [3] = sym_block,
  },
  [86] = {
    [4] = sym_block,
  },
  [89] = {
    [4] = sym_block,
  },
  [90] = {
    [4] = sym_block,
  },
  [92] = {
    [1] = sym_parenthesized_expression,
  },
  [101] = {
    [3] = sym_block,
  },
  [106] = {
    [5] = sym_block,
  },
  [107] = {
    [5] = sym_block,
  },
  [114] = {
    [5] = sym_block,
  },
  [116] = {
    [5] = sym_block,
  },
  [124] = {
    [6] = sym_block,
  },
  [126] = {
    [6] = sym_block,
  },
  [127] = {
    [5] = sym_block,
  },
  [129] = {
    [3] = sym_block,
  },
  [133] = {
    [3] = sym_block,
  },
  [136] = {
    [6] = sym_block,
  },
  [141] = {
    [6] = sym_block,
  },
  [143] = {
    [7] = sym_block,
  },
  [149] = {
    [4] = sym_block,
  },
  [151] = {
    [7] = sym_block,
  },
  [154] = {
    [8] = sym_block,
  },
  [155] = {
    [5] = sym_block,
  },
};

static const uint16_t ts_non_terminal_alias_map[] = {
  sym__simple_statements, 2,
    sym__simple_statements,
    sym_block,
  sym_parenthesized_list_splat, 2,
    sym_parenthesized_list_splat,
    sym_parenthesized_expression,
  sym_expression_list, 2,
    sym_expression_list,
    sym_tuple,
  sym_interpolation, 2,
    sym_interpolation,
    alias_sym_format_expression,
  0,
};

static const TSStateId ts_primary_state_ids[STATE_COUNT] = {
  [0] = 0,
  [1] = 1,
  [2] = 2,
  [3] = 3,
  [4] = 4,
  [5] = 5,
  [6] = 6,
  [7] = 7,
  [8] = 8,
  [9] = 9,
  [10] = 8,
  [11] = 11,
  [12] = 12,
  [13] = 13,
  [14] = 14,
  [15] = 15,
  [16] = 16,
  [17] = 5,
  [18] = 13,
  [19] = 14,
  [20] = 20,
  [21] = 16,
  [22] = 22,
  [23] = 23,
  [24] = 24,
  [25] = 6,
  [26] = 3,
  [27] = 12,
  [28] = 15,
  [29] = 29,
  [30] = 30,
  [31] = 22,
  [32] = 23,
  [33] = 33,
  [34] = 34,
  [35] = 35,
  [36] = 36,
  [37] = 20,
  [38] = 38,
  [39] = 39,
  [40] = 36,
  [41] = 41,
  [42] = 9,
  [43] = 24,
  [44] = 4,
  [45] = 41,
  [46] = 39,
  [47] = 34,
  [48] = 35,
  [49] = 49,
  [50] = 2,
  [51] = 7,
  [52] = 33,
  [53] = 30,
  [54] = 54,
  [55] = 54,
  [56] = 11,
  [57] = 38,
  [58] = 49,
  [59] = 29,
  [60] = 60,
  [61] = 60,
  [62] = 60,
  [63] = 63,
  [64] = 64,
  [65] = 60,
  [66] = 60,
  [67] = 63,
  [68] = 60,
  [69] = 60,
  [70] = 70,
  [71] = 70,
  [72] = 72,
  [73] = 73,
  [74] = 74,
  [75] = 75,
  [76] = 76,
  [77] = 77,
  [78] = 78,
  [79] = 79,
  [80] = 80,
  [81] = 81,
  [82] = 82,
  [83] = 80,
  [84] = 84,
  [85] = 74,
  [86] = 86,
  [87] = 82,
  [88] = 88,
  [89] = 89,
  [90] = 84,
  [91] = 72,
  [92] = 92,
  [93] = 93,
  [94] = 77,
  [95] = 95,
  [96] = 96,
  [97] = 97,
  [98] = 76,
  [99] = 89,
  [100] = 100,
  [101] = 78,
  [102] = 102,
  [103] = 103,
  [104] = 104,
  [105] = 105,
  [106] = 102,
  [107] = 81,
  [108] = 108,
  [109] = 96,
  [110] = 88,
  [111] = 93,
  [112] = 112,
  [113] = 105,
  [114] = 114,
  [115] = 115,
  [116] = 116,
  [117] = 79,
  [118] = 73,
  [119] = 108,
  [120] = 92,
  [121] = 116,
  [122] = 115,
  [123] = 104,
  [124] = 97,
  [125] = 103,
  [126] = 100,
  [127] = 95,
  [128] = 112,
  [129] = 86,
  [130] = 114,
  [131] = 131,
  [132] = 132,
  [133] = 133,
  [134] = 133,
  [135] = 135,
  [136] = 135,
  [137] = 133,
  [138] = 133,
  [139] = 133,
  [140] = 133,
  [141] = 135,
  [142] = 135,
  [143] = 135,
  [144] = 135,
  [145] = 133,
  [146] = 135,
  [147] = 147,
  [148] = 148,
  [149] = 148,
  [150] = 148,
  [151] = 151,
  [152] = 131,
  [153] = 148,
  [154] = 151,
  [155] = 155,
  [156] = 156,
  [157] = 157,
  [158] = 158,
  [159] = 159,
  [160] = 159,
  [161] = 159,
  [162] = 162,
  [163] = 163,
  [164] = 162,
  [165] = 165,
  [166] = 166,
  [167] = 167,
  [168] = 168,
  [169] = 166,
  [170] = 166,
  [171] = 171,
  [172] = 172,
  [173] = 173,
  [174] = 174,
  [175] = 175,
  [176] = 176,
  [177] = 177,
  [178] = 178,
  [179] = 177,
  [180] = 158,
  [181] = 181,
  [182] = 182,
  [183] = 178,
  [184] = 177,
  [185] = 185,
  [186] = 186,
  [187] = 187,
  [188] = 188,
  [189] = 189,
  [190] = 187,
  [191] = 187,
  [192] = 192,
  [193] = 188,
  [194] = 194,
  [195] = 168,
  [196] = 196,
  [197] = 194,
  [198] = 189,
  [199] = 199,
  [200] = 200,
  [201] = 201,
  [202] = 202,
  [203] = 196,
  [204] = 188,
  [205] = 171,
  [206] = 194,
  [207] = 189,
  [208] = 186,
  [209] = 199,
  [210] = 167,
  [211] = 200,
  [212] = 188,
  [213] = 213,
  [214] = 186,
  [215] = 199,
  [216] = 196,
  [217] = 187,
  [218] = 218,
  [219] = 219,
  [220] = 220,
  [221] = 221,
  [222] = 222,
  [223] = 223,
  [224] = 224,
  [225] = 225,
  [226] = 226,
  [227] = 227,
  [228] = 228,
  [229] = 229,
  [230] = 230,
  [231] = 231,
  [232] = 232,
  [233] = 233,
  [234] = 234,
  [235] = 233,
  [236] = 236,
  [237] = 234,
  [238] = 232,
  [239] = 236,
  [240] = 229,
  [241] = 228,
  [242] = 242,
  [243] = 243,
  [244] = 244,
  [245] = 244,
  [246] = 246,
  [247] = 247,
  [248] = 243,
  [249] = 243,
  [250] = 242,
  [251] = 246,
  [252] = 246,
  [253] = 242,
  [254] = 247,
  [255] = 255,
  [256] = 256,
  [257] = 255,
  [258] = 258,
  [259] = 259,
  [260] = 256,
  [261] = 261,
  [262] = 261,
  [263] = 263,
  [264] = 264,
  [265] = 265,
  [266] = 266,
  [267] = 267,
  [268] = 268,
  [269] = 261,
  [270] = 267,
  [271] = 266,
  [272] = 268,
  [273] = 256,
  [274] = 255,
  [275] = 275,
  [276] = 263,
  [277] = 258,
  [278] = 278,
  [279] = 265,
  [280] = 280,
  [281] = 281,
  [282] = 282,
  [283] = 283,
  [284] = 284,
  [285] = 285,
  [286] = 286,
  [287] = 287,
  [288] = 288,
  [289] = 289,
  [290] = 290,
  [291] = 281,
  [292] = 283,
  [293] = 293,
  [294] = 294,
  [295] = 295,
  [296] = 296,
  [297] = 297,
  [298] = 296,
  [299] = 299,
  [300] = 300,
  [301] = 299,
  [302] = 302,
  [303] = 303,
  [304] = 304,
  [305] = 288,
  [306] = 306,
  [307] = 285,
  [308] = 308,
  [309] = 309,
  [310] = 299,
  [311] = 287,
  [312] = 312,
  [313] = 308,
  [314] = 314,
  [315] = 282,
  [316] = 316,
  [317] = 317,
  [318] = 318,
  [319] = 288,
  [320] = 320,
  [321] = 321,
  [322] = 322,
  [323] = 323,
  [324] = 324,
  [325] = 325,
  [326] = 281,
  [327] = 316,
  [328] = 328,
  [329] = 329,
  [330] = 330,
  [331] = 331,
  [332] = 317,
  [333] = 333,
  [334] = 334,
  [335] = 335,
  [336] = 226,
  [337] = 218,
  [338] = 338,
  [339] = 339,
  [340] = 340,
  [341] = 321,
  [342] = 220,
  [343] = 221,
  [344] = 223,
  [345] = 345,
  [346] = 322,
  [347] = 347,
  [348] = 348,
  [349] = 347,
  [350] = 323,
  [351] = 351,
  [352] = 219,
  [353] = 340,
  [354] = 288,
  [355] = 282,
  [356] = 281,
  [357] = 333,
  [358] = 308,
  [359] = 288,
  [360] = 308,
  [361] = 361,
  [362] = 308,
  [363] = 329,
  [364] = 364,
  [365] = 227,
  [366] = 328,
  [367] = 287,
  [368] = 324,
  [369] = 308,
  [370] = 281,
  [371] = 282,
  [372] = 318,
  [373] = 320,
  [374] = 287,
  [375] = 287,
  [376] = 281,
  [377] = 325,
  [378] = 287,
  [379] = 282,
  [380] = 345,
  [381] = 288,
  [382] = 282,
  [383] = 335,
  [384] = 331,
  [385] = 385,
  [386] = 386,
  [387] = 387,
  [388] = 388,
  [389] = 389,
  [390] = 390,
  [391] = 391,
  [392] = 392,
  [393] = 393,
  [394] = 394,
  [395] = 395,
  [396] = 396,
  [397] = 397,
  [398] = 398,
  [399] = 399,
  [400] = 400,
  [401] = 401,
  [402] = 402,
  [403] = 403,
  [404] = 404,
  [405] = 389,
  [406] = 406,
  [407] = 403,
  [408] = 408,
  [409] = 396,
  [410] = 396,
  [411] = 395,
  [412] = 412,
  [413] = 413,
  [414] = 408,
  [415] = 386,
  [416] = 402,
  [417] = 417,
  [418] = 387,
  [419] = 391,
  [420] = 420,
  [421] = 388,
  [422] = 392,
  [423] = 404,
  [424] = 400,
  [425] = 425,
  [426] = 386,
  [427] = 427,
  [428] = 427,
  [429] = 386,
  [430] = 430,
  [431] = 431,
  [432] = 430,
  [433] = 420,
  [434] = 434,
  [435] = 435,
  [436] = 397,
  [437] = 397,
  [438] = 438,
  [439] = 385,
  [440] = 413,
  [441] = 441,
  [442] = 442,
  [443] = 385,
  [444] = 444,
  [445] = 391,
  [446] = 395,
  [447] = 425,
  [448] = 389,
  [449] = 449,
  [450] = 450,
  [451] = 451,
  [452] = 392,
  [453] = 453,
  [454] = 454,
  [455] = 395,
  [456] = 385,
  [457] = 396,
  [458] = 444,
  [459] = 459,
  [460] = 442,
  [461] = 461,
  [462] = 462,
  [463] = 444,
  [464] = 464,
  [465] = 397,
  [466] = 466,
  [467] = 454,
  [468] = 398,
  [469] = 406,
  [470] = 391,
  [471] = 399,
  [472] = 464,
  [473] = 473,
  [474] = 473,
  [475] = 475,
  [476] = 392,
  [477] = 477,
  [478] = 401,
  [479] = 479,
  [480] = 480,
  [481] = 444,
  [482] = 389,
  [483] = 483,
  [484] = 412,
  [485] = 485,
  [486] = 485,
  [487] = 487,
  [488] = 488,
  [489] = 489,
  [490] = 487,
  [491] = 491,
  [492] = 492,
  [493] = 492,
  [494] = 491,
  [495] = 488,
  [496] = 489,
  [497] = 497,
  [498] = 498,
  [499] = 499,
  [500] = 500,
  [501] = 501,
  [502] = 502,
  [503] = 503,
  [504] = 504,
  [505] = 505,
  [506] = 506,
  [507] = 507,
  [508] = 508,
  [509] = 509,
  [510] = 510,
  [511] = 511,
  [512] = 512,
  [513] = 512,
  [514] = 514,
  [515] = 498,
  [516] = 507,
  [517] = 517,
  [518] = 518,
  [519] = 519,
  [520] = 504,
  [521] = 521,
  [522] = 522,
  [523] = 523,
  [524] = 524,
  [525] = 500,
  [526] = 524,
  [527] = 527,
  [528] = 528,
  [529] = 529,
  [530] = 530,
  [531] = 531,
  [532] = 532,
  [533] = 533,
  [534] = 534,
  [535] = 535,
  [536] = 534,
  [537] = 529,
  [538] = 530,
  [539] = 511,
  [540] = 533,
  [541] = 541,
  [542] = 502,
  [543] = 543,
  [544] = 544,
  [545] = 510,
  [546] = 509,
  [547] = 508,
  [548] = 501,
  [549] = 549,
  [550] = 527,
  [551] = 503,
  [552] = 552,
  [553] = 531,
  [554] = 549,
  [555] = 528,
  [556] = 506,
  [557] = 505,
  [558] = 532,
  [559] = 559,
  [560] = 543,
  [561] = 561,
  [562] = 541,
  [563] = 535,
  [564] = 559,
  [565] = 561,
  [566] = 517,
  [567] = 567,
  [568] = 514,
  [569] = 567,
  [570] = 570,
  [571] = 571,
  [572] = 571,
  [573] = 573,
  [574] = 573,
  [575] = 575,
  [576] = 522,
  [577] = 575,
  [578] = 544,
  [579] = 579,
  [580] = 497,
  [581] = 581,
  [582] = 582,
  [583] = 579,
  [584] = 499,
  [585] = 570,
  [586] = 581,
  [587] = 587,
  [588] = 523,
  [589] = 582,
  [590] = 587,
  [591] = 518,
  [592] = 521,
  [593] = 519,
  [594] = 552,
  [595] = 595,
  [596] = 596,
  [597] = 597,
  [598] = 598,
  [599] = 599,
  [600] = 600,
  [601] = 601,
  [602] = 602,
  [603] = 603,
  [604] = 602,
  [605] = 603,
  [606] = 606,
  [607] = 607,
  [608] = 608,
  [609] = 609,
  [610] = 610,
  [611] = 611,
  [612] = 612,
  [613] = 613,
  [614] = 614,
  [615] = 615,
  [616] = 616,
  [617] = 617,
  [618] = 618,
  [619] = 619,
  [620] = 620,
  [621] = 621,
  [622] = 622,
  [623] = 623,
  [624] = 624,
  [625] = 625,
  [626] = 626,
  [627] = 627,
  [628] = 628,
  [629] = 629,
  [630] = 630,
  [631] = 631,
  [632] = 632,
  [633] = 633,
  [634] = 634,
  [635] = 635,
  [636] = 636,
  [637] = 637,
  [638] = 638,
  [639] = 639,
  [640] = 640,
  [641] = 641,
  [642] = 642,
  [643] = 630,
  [644] = 644,
  [645] = 645,
  [646] = 646,
  [647] = 647,
  [648] = 647,
  [649] = 649,
  [650] = 650,
  [651] = 651,
  [652] = 652,
  [653] = 653,
  [654] = 651,
  [655] = 645,
  [656] = 656,
  [657] = 656,
  [658] = 653,
  [659] = 659,
  [660] = 646,
  [661] = 650,
  [662] = 662,
  [663] = 662,
  [664] = 659,
  [665] = 652,
  [666] = 649,
  [667] = 667,
  [668] = 668,
  [669] = 669,
  [670] = 669,
  [671] = 671,
  [672] = 672,
  [673] = 669,
  [674] = 667,
  [675] = 668,
  [676] = 669,
  [677] = 599,
  [678] = 598,
  [679] = 679,
  [680] = 680,
  [681] = 681,
  [682] = 682,
  [683] = 683,
  [684] = 630,
  [685] = 685,
  [686] = 682,
  [687] = 687,
  [688] = 688,
  [689] = 599,
  [690] = 690,
  [691] = 679,
  [692] = 681,
  [693] = 693,
  [694] = 679,
  [695] = 695,
  [696] = 680,
  [697] = 695,
  [698] = 698,
  [699] = 690,
  [700] = 682,
  [701] = 688,
  [702] = 680,
  [703] = 695,
  [704] = 681,
  [705] = 690,
  [706] = 687,
  [707] = 698,
  [708] = 687,
  [709] = 683,
  [710] = 687,
  [711] = 682,
  [712] = 679,
  [713] = 600,
  [714] = 690,
  [715] = 715,
  [716] = 693,
  [717] = 681,
  [718] = 688,
  [719] = 683,
  [720] = 598,
  [721] = 695,
  [722] = 680,
  [723] = 698,
  [724] = 688,
  [725] = 672,
  [726] = 683,
  [727] = 671,
  [728] = 698,
  [729] = 693,
  [730] = 693,
  [731] = 662,
  [732] = 649,
  [733] = 652,
  [734] = 659,
  [735] = 647,
  [736] = 609,
  [737] = 653,
  [738] = 651,
  [739] = 645,
  [740] = 630,
  [741] = 646,
  [742] = 600,
  [743] = 656,
  [744] = 610,
  [745] = 650,
  [746] = 662,
  [747] = 651,
  [748] = 748,
  [749] = 330,
  [750] = 653,
  [751] = 652,
  [752] = 649,
  [753] = 647,
  [754] = 667,
  [755] = 668,
  [756] = 645,
  [757] = 659,
  [758] = 609,
  [759] = 759,
  [760] = 760,
  [761] = 646,
  [762] = 449,
  [763] = 656,
  [764] = 334,
  [765] = 475,
  [766] = 650,
  [767] = 767,
  [768] = 441,
  [769] = 610,
  [770] = 431,
  [771] = 626,
  [772] = 639,
  [773] = 625,
  [774] = 624,
  [775] = 637,
  [776] = 620,
  [777] = 623,
  [778] = 617,
  [779] = 475,
  [780] = 622,
  [781] = 629,
  [782] = 632,
  [783] = 615,
  [784] = 627,
  [785] = 628,
  [786] = 671,
  [787] = 672,
  [788] = 631,
  [789] = 441,
  [790] = 634,
  [791] = 635,
  [792] = 633,
  [793] = 613,
  [794] = 618,
  [795] = 612,
  [796] = 640,
  [797] = 642,
  [798] = 667,
  [799] = 621,
  [800] = 641,
  [801] = 668,
  [802] = 644,
  [803] = 619,
  [804] = 611,
  [805] = 638,
  [806] = 431,
  [807] = 616,
  [808] = 614,
  [809] = 634,
  [810] = 220,
  [811] = 642,
  [812] = 759,
  [813] = 626,
  [814] = 625,
  [815] = 624,
  [816] = 623,
  [817] = 611,
  [818] = 622,
  [819] = 637,
  [820] = 621,
  [821] = 620,
  [822] = 219,
  [823] = 616,
  [824] = 614,
  [825] = 629,
  [826] = 641,
  [827] = 632,
  [828] = 638,
  [829] = 227,
  [830] = 644,
  [831] = 613,
  [832] = 618,
  [833] = 631,
  [834] = 223,
  [835] = 640,
  [836] = 221,
  [837] = 760,
  [838] = 639,
  [839] = 612,
  [840] = 627,
  [841] = 617,
  [842] = 628,
  [843] = 615,
  [844] = 218,
  [845] = 226,
  [846] = 619,
  [847] = 633,
  [848] = 635,
  [849] = 849,
  [850] = 850,
  [851] = 851,
  [852] = 849,
  [853] = 853,
  [854] = 854,
  [855] = 855,
  [856] = 856,
  [857] = 857,
  [858] = 858,
  [859] = 859,
  [860] = 860,
  [861] = 861,
  [862] = 862,
  [863] = 863,
  [864] = 864,
  [865] = 865,
  [866] = 866,
  [867] = 867,
  [868] = 868,
  [869] = 868,
  [870] = 870,
  [871] = 870,
  [872] = 872,
  [873] = 873,
  [874] = 874,
  [875] = 875,
  [876] = 876,
  [877] = 868,
  [878] = 870,
  [879] = 879,
  [880] = 880,
  [881] = 870,
  [882] = 882,
  [883] = 868,
  [884] = 884,
  [885] = 885,
  [886] = 885,
  [887] = 887,
  [888] = 885,
  [889] = 889,
  [890] = 885,
  [891] = 891,
  [892] = 892,
  [893] = 893,
  [894] = 894,
  [895] = 895,
  [896] = 896,
  [897] = 897,
  [898] = 895,
  [899] = 896,
  [900] = 900,
  [901] = 901,
  [902] = 902,
  [903] = 902,
  [904] = 904,
  [905] = 905,
  [906] = 906,
  [907] = 907,
  [908] = 908,
  [909] = 909,
  [910] = 910,
  [911] = 907,
  [912] = 912,
  [913] = 913,
  [914] = 914,
  [915] = 915,
  [916] = 916,
  [917] = 917,
  [918] = 907,
  [919] = 909,
  [920] = 920,
  [921] = 914,
  [922] = 916,
  [923] = 908,
  [924] = 912,
  [925] = 925,
  [926] = 926,
  [927] = 920,
  [928] = 926,
  [929] = 929,
  [930] = 930,
  [931] = 930,
  [932] = 932,
  [933] = 933,
  [934] = 934,
  [935] = 932,
  [936] = 936,
  [937] = 937,
  [938] = 936,
  [939] = 939,
  [940] = 940,
  [941] = 932,
  [942] = 936,
  [943] = 943,
  [944] = 934,
  [945] = 930,
  [946] = 940,
  [947] = 947,
  [948] = 948,
  [949] = 936,
  [950] = 934,
  [951] = 951,
  [952] = 934,
  [953] = 940,
  [954] = 954,
  [955] = 955,
  [956] = 956,
  [957] = 957,
  [958] = 958,
  [959] = 959,
  [960] = 960,
  [961] = 961,
  [962] = 962,
  [963] = 963,
  [964] = 964,
  [965] = 965,
  [966] = 966,
  [967] = 904,
  [968] = 968,
  [969] = 969,
  [970] = 970,
  [971] = 971,
  [972] = 972,
  [973] = 973,
  [974] = 914,
  [975] = 975,
  [976] = 901,
  [977] = 977,
  [978] = 978,
  [979] = 979,
  [980] = 926,
  [981] = 981,
  [982] = 982,
  [983] = 983,
  [984] = 984,
  [985] = 985,
  [986] = 986,
  [987] = 987,
  [988] = 988,
  [989] = 989,
  [990] = 990,
  [991] = 965,
  [992] = 909,
  [993] = 993,
  [994] = 994,
  [995] = 995,
  [996] = 996,
  [997] = 912,
  [998] = 998,
  [999] = 999,
  [1000] = 916,
  [1001] = 920,
  [1002] = 996,
  [1003] = 983,
  [1004] = 1004,
  [1005] = 1005,
  [1006] = 1006,
  [1007] = 908,
  [1008] = 1008,
  [1009] = 900,
  [1010] = 1010,
  [1011] = 1011,
  [1012] = 1012,
  [1013] = 1013,
  [1014] = 929,
  [1015] = 900,
  [1016] = 1016,
  [1017] = 1017,
  [1018] = 1018,
  [1019] = 1019,
  [1020] = 1020,
  [1021] = 1021,
  [1022] = 1022,
  [1023] = 1023,
  [1024] = 1024,
  [1025] = 926,
  [1026] = 1026,
  [1027] = 912,
  [1028] = 914,
  [1029] = 920,
  [1030] = 916,
  [1031] = 1031,
  [1032] = 908,
  [1033] = 1033,
  [1034] = 1034,
  [1035] = 909,
  [1036] = 933,
  [1037] = 1037,
  [1038] = 1038,
  [1039] = 1039,
  [1040] = 1021,
  [1041] = 1041,
  [1042] = 901,
  [1043] = 1043,
  [1044] = 1044,
  [1045] = 1045,
  [1046] = 1046,
  [1047] = 1021,
  [1048] = 947,
  [1049] = 1038,
  [1050] = 1050,
  [1051] = 904,
  [1052] = 1038,
  [1053] = 1053,
  [1054] = 948,
  [1055] = 1055,
  [1056] = 1056,
  [1057] = 906,
  [1058] = 1058,
  [1059] = 1059,
  [1060] = 1060,
  [1061] = 1061,
  [1062] = 1062,
  [1063] = 1063,
  [1064] = 1064,
  [1065] = 1065,
  [1066] = 1066,
  [1067] = 1067,
  [1068] = 1058,
  [1069] = 1069,
  [1070] = 1070,
  [1071] = 1071,
  [1072] = 1072,
  [1073] = 1073,
  [1074] = 1074,
  [1075] = 1059,
  [1076] = 1076,
  [1077] = 1077,
  [1078] = 1078,
  [1079] = 1079,
  [1080] = 1079,
  [1081] = 1063,
  [1082] = 1022,
  [1083] = 1083,
  [1084] = 1084,
  [1085] = 1070,
  [1086] = 1086,
  [1087] = 1087,
  [1088] = 1061,
  [1089] = 1089,
  [1090] = 1090,
  [1091] = 1091,
  [1092] = 964,
  [1093] = 1093,
  [1094] = 939,
  [1095] = 1095,
  [1096] = 1005,
  [1097] = 1097,
  [1098] = 1098,
  [1099] = 1099,
  [1100] = 1100,
  [1101] = 917,
  [1102] = 1039,
  [1103] = 1103,
  [1104] = 1104,
  [1105] = 1105,
  [1106] = 1106,
  [1107] = 1107,
  [1108] = 1107,
  [1109] = 1109,
  [1110] = 1110,
  [1111] = 1111,
  [1112] = 985,
  [1113] = 1113,
  [1114] = 1114,
  [1115] = 1115,
  [1116] = 1116,
  [1117] = 1117,
  [1118] = 1118,
  [1119] = 1119,
  [1120] = 1097,
  [1121] = 1121,
  [1122] = 1122,
  [1123] = 1104,
  [1124] = 1124,
  [1125] = 1125,
  [1126] = 1126,
  [1127] = 1127,
  [1128] = 1128,
  [1129] = 1129,
  [1130] = 1130,
  [1131] = 1131,
  [1132] = 1128,
  [1133] = 1133,
  [1134] = 1134,
  [1135] = 1135,
  [1136] = 1136,
  [1137] = 1137,
  [1138] = 1138,
  [1139] = 1139,
  [1140] = 1140,
  [1141] = 1141,
  [1142] = 1095,
  [1143] = 1143,
  [1144] = 1144,
  [1145] = 1145,
  [1146] = 1146,
  [1147] = 1093,
  [1148] = 1148,
  [1149] = 1149,
  [1150] = 1150,
  [1151] = 1141,
  [1152] = 1149,
  [1153] = 1140,
  [1154] = 1154,
  [1155] = 1155,
  [1156] = 1156,
  [1157] = 1134,
  [1158] = 1135,
  [1159] = 1136,
  [1160] = 1160,
  [1161] = 1109,
  [1162] = 1162,
  [1163] = 1163,
  [1164] = 1164,
  [1165] = 1165,
  [1166] = 1166,
  [1167] = 1167,
  [1168] = 913,
  [1169] = 1149,
  [1170] = 1170,
  [1171] = 1171,
  [1172] = 1172,
  [1173] = 1173,
  [1174] = 1174,
  [1175] = 1175,
  [1176] = 1131,
  [1177] = 1177,
  [1178] = 1178,
  [1179] = 1129,
  [1180] = 1180,
  [1181] = 1173,
  [1182] = 1118,
  [1183] = 1183,
  [1184] = 1180,
  [1185] = 1185,
  [1186] = 1149,
  [1187] = 1023,
  [1188] = 1188,
  [1189] = 1189,
  [1190] = 1190,
  [1191] = 1191,
  [1192] = 1192,
  [1193] = 1193,
  [1194] = 1194,
  [1195] = 1195,
  [1196] = 1196,
  [1197] = 1197,
  [1198] = 1198,
  [1199] = 1199,
  [1200] = 1200,
  [1201] = 1201,
  [1202] = 1202,
  [1203] = 1203,
  [1204] = 1204,
  [1205] = 1164,
  [1206] = 1163,
  [1207] = 1207,
  [1208] = 1208,
  [1209] = 1209,
  [1210] = 1210,
  [1211] = 1211,
  [1212] = 1212,
  [1213] = 1213,
  [1214] = 1209,
  [1215] = 1215,
  [1216] = 1216,
  [1217] = 282,
  [1218] = 1218,
  [1219] = 1219,
  [1220] = 1220,
  [1221] = 1221,
  [1222] = 1074,
  [1223] = 1223,
  [1224] = 1210,
  [1225] = 1225,
  [1226] = 1226,
  [1227] = 1227,
  [1228] = 1228,
  [1229] = 1229,
  [1230] = 1230,
  [1231] = 1194,
  [1232] = 1232,
  [1233] = 308,
  [1234] = 1234,
  [1235] = 1235,
  [1236] = 1236,
  [1237] = 1194,
  [1238] = 1209,
  [1239] = 1239,
  [1240] = 1189,
  [1241] = 1194,
  [1242] = 1242,
  [1243] = 1242,
  [1244] = 1209,
  [1245] = 1183,
  [1246] = 1194,
  [1247] = 1234,
  [1248] = 1209,
  [1249] = 1204,
  [1250] = 1250,
  [1251] = 1219,
  [1252] = 1252,
  [1253] = 1060,
  [1254] = 1194,
  [1255] = 1239,
  [1256] = 1256,
  [1257] = 1257,
  [1258] = 1220,
  [1259] = 1259,
  [1260] = 1260,
  [1261] = 1209,
  [1262] = 1262,
  [1263] = 1263,
  [1264] = 1264,
  [1265] = 281,
  [1266] = 1266,
  [1267] = 1267,
  [1268] = 1268,
  [1269] = 1269,
  [1270] = 1270,
  [1271] = 1196,
  [1272] = 1203,
  [1273] = 1228,
  [1274] = 1230,
  [1275] = 1275,
  [1276] = 1197,
  [1277] = 1264,
  [1278] = 1260,
  [1279] = 1230,
  [1280] = 1228,
  [1281] = 1281,
  [1282] = 1203,
  [1283] = 1196,
  [1284] = 1284,
  [1285] = 1264,
  [1286] = 1221,
  [1287] = 1287,
  [1288] = 1288,
  [1289] = 1289,
  [1290] = 1290,
  [1291] = 609,
  [1292] = 1292,
  [1293] = 1293,
  [1294] = 1220,
  [1295] = 1275,
  [1296] = 1296,
  [1297] = 1256,
  [1298] = 1239,
  [1299] = 1299,
  [1300] = 1234,
  [1301] = 1301,
  [1302] = 1242,
  [1303] = 1303,
  [1304] = 287,
  [1305] = 1305,
  [1306] = 1199,
  [1307] = 1069,
  [1308] = 1308,
  [1309] = 1194,
  [1310] = 1310,
  [1311] = 1225,
  [1312] = 1312,
  [1313] = 1219,
  [1314] = 1314,
  [1315] = 1284,
  [1316] = 1316,
  [1317] = 1312,
  [1318] = 610,
  [1319] = 1209,
  [1320] = 1320,
  [1321] = 1143,
  [1322] = 1322,
  [1323] = 1323,
  [1324] = 288,
  [1325] = 1325,
  [1326] = 1326,
  [1327] = 1225,
  [1328] = 1256,
  [1329] = 1329,
  [1330] = 1330,
  [1331] = 1331,
  [1332] = 1067,
  [1333] = 1333,
  [1334] = 1229,
  [1335] = 1335,
  [1336] = 1336,
  [1337] = 1337,
  [1338] = 1338,
  [1339] = 1177,
  [1340] = 1340,
  [1341] = 1341,
  [1342] = 1342,
  [1343] = 1343,
  [1344] = 1344,
  [1345] = 1345,
  [1346] = 1346,
  [1347] = 1267,
  [1348] = 1041,
  [1349] = 1349,
  [1350] = 1350,
  [1351] = 1351,
  [1352] = 1352,
  [1353] = 1353,
  [1354] = 1354,
  [1355] = 1355,
  [1356] = 1356,
  [1357] = 1357,
  [1358] = 1354,
  [1359] = 1359,
  [1360] = 1360,
  [1361] = 1361,
  [1362] = 1362,
  [1363] = 1363,
  [1364] = 1364,
  [1365] = 1365,
  [1366] = 1360,
  [1367] = 1367,
  [1368] = 1368,
  [1369] = 1369,
  [1370] = 1356,
  [1371] = 1371,
  [1372] = 1344,
  [1373] = 1373,
  [1374] = 1374,
  [1375] = 1375,
  [1376] = 1375,
  [1377] = 1363,
  [1378] = 1371,
  [1379] = 1379,
  [1380] = 1380,
  [1381] = 1381,
  [1382] = 1226,
  [1383] = 1383,
  [1384] = 1384,
  [1385] = 1385,
  [1386] = 1386,
  [1387] = 1387,
  [1388] = 1388,
  [1389] = 1389,
  [1390] = 1390,
  [1391] = 1391,
  [1392] = 1392,
  [1393] = 1393,
  [1394] = 1394,
  [1395] = 1395,
  [1396] = 1396,
  [1397] = 1198,
  [1398] = 1398,
  [1399] = 1399,
  [1400] = 1400,
  [1401] = 1401,
  [1402] = 1402,
  [1403] = 1403,
  [1404] = 1404,
  [1405] = 1405,
  [1406] = 1406,
  [1407] = 1407,
  [1408] = 1408,
  [1409] = 1409,
  [1410] = 1405,
  [1411] = 1411,
  [1412] = 1412,
  [1413] = 1413,
  [1414] = 1414,
  [1415] = 1415,
  [1416] = 1416,
  [1417] = 1417,
  [1418] = 1418,
  [1419] = 1419,
  [1420] = 1420,
  [1421] = 1421,
  [1422] = 1422,
  [1423] = 1423,
  [1424] = 1424,
  [1425] = 1425,
  [1426] = 1426,
  [1427] = 1427,
  [1428] = 1428,
  [1429] = 1407,
  [1430] = 1430,
  [1431] = 1431,
  [1432] = 1414,
  [1433] = 1411,
  [1434] = 1434,
  [1435] = 1435,
  [1436] = 1430,
  [1437] = 1407,
  [1438] = 1405,
  [1439] = 1411,
  [1440] = 1440,
  [1441] = 1441,
  [1442] = 1417,
  [1443] = 1443,
  [1444] = 1444,
  [1445] = 1445,
  [1446] = 1430,
  [1447] = 1414,
  [1448] = 1448,
  [1449] = 1448,
  [1450] = 1443,
  [1451] = 1451,
  [1452] = 1452,
  [1453] = 1427,
  [1454] = 1454,
  [1455] = 1455,
  [1456] = 1456,
  [1457] = 1457,
  [1458] = 1427,
  [1459] = 1422,
  [1460] = 1460,
  [1461] = 1460,
  [1462] = 1462,
  [1463] = 1463,
  [1464] = 1417,
  [1465] = 1465,
  [1466] = 1466,
  [1467] = 1467,
  [1468] = 1435,
  [1469] = 1462,
  [1470] = 1470,
  [1471] = 1471,
  [1472] = 1472,
  [1473] = 1467,
  [1474] = 1451,
  [1475] = 1431,
  [1476] = 1470,
  [1477] = 1445,
  [1478] = 1478,
  [1479] = 1420,
  [1480] = 1480,
  [1481] = 1481,
  [1482] = 1428,
  [1483] = 1483,
  [1484] = 1431,
  [1485] = 1483,
  [1486] = 1486,
  [1487] = 1487,
  [1488] = 1488,
  [1489] = 1489,
  [1490] = 1490,
  [1491] = 1478,
  [1492] = 1492,
  [1493] = 1452,
  [1494] = 1430,
  [1495] = 1495,
  [1496] = 1496,
  [1497] = 1497,
  [1498] = 1498,
  [1499] = 1463,
  [1500] = 1448,
  [1501] = 1481,
  [1502] = 1502,
  [1503] = 1467,
  [1504] = 1462,
  [1505] = 1480,
  [1506] = 1471,
  [1507] = 1465,
  [1508] = 1498,
  [1509] = 1509,
  [1510] = 1510,
  [1511] = 1511,
  [1512] = 1495,
  [1513] = 1460,
  [1514] = 1514,
  [1515] = 1409,
  [1516] = 1511,
  [1517] = 1514,
  [1518] = 1472,
  [1519] = 1454,
  [1520] = 1488,
  [1521] = 1521,
  [1522] = 1421,
  [1523] = 1425,
  [1524] = 1427,
};

static inline bool sym_identifier_character_set_1(int32_t c) {
  return (c < 43514
    ? (c < 4193
      ? (c < 2707
        ? (c < 1994
          ? (c < 931
            ? (c < 748
              ? (c < 192
                ? (c < 170
                  ? (c < 'a'
                    ? (c >= 'A' && c <= '_')
                    : c <= 'z')
                  : (c <= 170 || (c < 186
                    ? c == 181
                    : c <= 186)))
                : (c <= 214 || (c < 710
                  ? (c < 248
                    ? (c >= 216 && c <= 246)
                    : c <= 705)
                  : (c <= 721 || (c >= 736 && c <= 740)))))
              : (c <= 748 || (c < 895
                ? (c < 886
                  ? (c < 880
                    ? c == 750
                    : c <= 884)
                  : (c <= 887 || (c >= 891 && c <= 893)))
                : (c <= 895 || (c < 908
                  ? (c < 904
                    ? c == 902
                    : c <= 906)
                  : (c <= 908 || (c >= 910 && c <= 929)))))))
            : (c <= 1013 || (c < 1649
              ? (c < 1376
                ? (c < 1329
                  ? (c < 1162
                    ? (c >= 1015 && c <= 1153)
                    : c <= 1327)
                  : (c <= 1366 || c == 1369))
                : (c <= 1416 || (c < 1568
                  ? (c < 1519
                    ? (c >= 1488 && c <= 1514)
                    : c <= 1522)
                  : (c <= 1610 || (c >= 1646 && c <= 1647)))))
              : (c <= 1747 || (c < 1791
                ? (c < 1774
                  ? (c < 1765
                    ? c == 1749
                    : c <= 1766)
                  : (c <= 1775 || (c >= 1786 && c <= 1788)))
                : (c <= 1791 || (c < 1869
                  ? (c < 1810
                    ? c == 1808
                    : c <= 1839)
                  : (c <= 1957 || c == 1969))))))))
          : (c <= 2026 || (c < 2482
            ? (c < 2208
              ? (c < 2088
                ? (c < 2048
                  ? (c < 2042
                    ? (c >= 2036 && c <= 2037)
                    : c <= 2042)
                  : (c <= 2069 || (c < 2084
                    ? c == 2074
                    : c <= 2084)))
                : (c <= 2088 || (c < 2160
                  ? (c < 2144
                    ? (c >= 2112 && c <= 2136)
                    : c <= 2154)
                  : (c <= 2183 || (c >= 2185 && c <= 2190)))))
              : (c <= 2249 || (c < 2417
                ? (c < 2384
                  ? (c < 2365
                    ? (c >= 2308 && c <= 2361)
                    : c <= 2365)
                  : (c <= 2384 || (c >= 2392 && c <= 2401)))
                : (c <= 2432 || (c < 2451
                  ? (c < 2447
                    ? (c >= 2437 && c <= 2444)
                    : c <= 2448)
                  : (c <= 2472 || (c >= 2474 && c <= 2480)))))))
            : (c <= 2482 || (c < 2579
              ? (c < 2527
                ? (c < 2510
                  ? (c < 2493
                    ? (c >= 2486 && c <= 2489)
                    : c <= 2493)
                  : (c <= 2510 || (c >= 2524 && c <= 2525)))
                : (c <= 2529 || (c < 2565
                  ? (c < 2556
                    ? (c >= 2544 && c <= 2545)
                    : c <= 2556)
                  : (c <= 2570 || (c >= 2575 && c <= 2576)))))
              : (c <= 2600 || (c < 2649
                ? (c < 2613
                  ? (c < 2610
                    ? (c >= 2602 && c <= 2608)
                    : c <= 2611)
                  : (c <= 2614 || (c >= 2616 && c <= 2617)))
                : (c <= 2652 || (c < 2693
                  ? (c < 2674
                    ? c == 2654
                    : c <= 2676)
                  : (c <= 2701 || (c >= 2703 && c <= 2705)))))))))))
        : (c <= 2728 || (c < 3242
          ? (c < 2962
            ? (c < 2858
              ? (c < 2784
                ? (c < 2741
                  ? (c < 2738
                    ? (c >= 2730 && c <= 2736)
                    : c <= 2739)
                  : (c <= 2745 || (c < 2768
                    ? c == 2749
                    : c <= 2768)))
                : (c <= 2785 || (c < 2831
                  ? (c < 2821
                    ? c == 2809
                    : c <= 2828)
                  : (c <= 2832 || (c >= 2835 && c <= 2856)))))
              : (c <= 2864 || (c < 2911
                ? (c < 2877
                  ? (c < 2869
                    ? (c >= 2866 && c <= 2867)
                    : c <= 2873)
                  : (c <= 2877 || (c >= 2908 && c <= 2909)))
                : (c <= 2913 || (c < 2949
                  ? (c < 2947
                    ? c == 2929
                    : c <= 2947)
                  : (c <= 2954 || (c >= 2958 && c <= 2960)))))))
            : (c <= 2965 || (c < 3090
              ? (c < 2984
                ? (c < 2974
                  ? (c < 2972
                    ? (c >= 2969 && c <= 2970)
                    : c <= 2972)
                  : (c <= 2975 || (c >= 2979 && c <= 2980)))
                : (c <= 2986 || (c < 3077
                  ? (c < 3024
                    ? (c >= 2990 && c <= 3001)
                    : c <= 3024)
                  : (c <= 3084 || (c >= 3086 && c <= 3088)))))
              : (c <= 3112 || (c < 3168
                ? (c < 3160
                  ? (c < 3133
                    ? (c >= 3114 && c <= 3129)
                    : c <= 3133)
                  : (c <= 3162 || c == 3165))
                : (c <= 3169 || (c < 3214
                  ? (c < 3205
                    ? c == 3200
                    : c <= 3212)
                  : (c <= 3216 || (c >= 3218 && c <= 3240)))))))))
          : (c <= 3251 || (c < 3648
            ? (c < 3412
              ? (c < 3332
                ? (c < 3293
                  ? (c < 3261
                    ? (c >= 3253 && c <= 3257)
                    : c <= 3261)
                  : (c <= 3294 || (c < 3313
                    ? (c >= 3296 && c <= 3297)
                    : c <= 3314)))
                : (c <= 3340 || (c < 3389
                  ? (c < 3346
                    ? (c >= 3342 && c <= 3344)
                    : c <= 3386)
                  : (c <= 3389 || c == 3406))))
              : (c <= 3414 || (c < 3507
                ? (c < 3461
                  ? (c < 3450
                    ? (c >= 3423 && c <= 3425)
                    : c <= 3455)
                  : (c <= 3478 || (c >= 3482 && c <= 3505)))
                : (c <= 3515 || (c < 3585
                  ? (c < 3520
                    ? c == 3517
                    : c <= 3526)
                  : (c <= 3632 || c == 3634))))))
            : (c <= 3654 || (c < 3782
              ? (c < 3749
                ? (c < 3718
                  ? (c < 3716
                    ? (c >= 3713 && c <= 3714)
                    : c <= 3716)
                  : (c <= 3722 || (c >= 3724 && c <= 3747)))
                : (c <= 3749 || (c < 3773
                  ? (c < 3762
                    ? (c >= 3751 && c <= 3760)
                    : c <= 3762)
                  : (c <= 3773 || (c >= 3776 && c <= 3780)))))
              : (c <= 3782 || (c < 3976
                ? (c < 3904
                  ? (c < 3840
                    ? (c >= 3804 && c <= 3807)
                    : c <= 3840)
                  : (c <= 3911 || (c >= 3913 && c <= 3948)))
                : (c <= 3980 || (c < 4176
                  ? (c < 4159
                    ? (c >= 4096 && c <= 4138)
                    : c <= 4159)
                  : (c <= 4181 || (c >= 4186 && c <= 4189)))))))))))))
      : (c <= 4193 || (c < 8134
        ? (c < 6176
          ? (c < 4808
            ? (c < 4688
              ? (c < 4295
                ? (c < 4213
                  ? (c < 4206
                    ? (c >= 4197 && c <= 4198)
                    : c <= 4208)
                  : (c <= 4225 || (c < 4256
                    ? c == 4238
                    : c <= 4293)))
                : (c <= 4295 || (c < 4348
                  ? (c < 4304
                    ? c == 4301
                    : c <= 4346)
                  : (c <= 4680 || (c >= 4682 && c <= 4685)))))
              : (c <= 4694 || (c < 4752
                ? (c < 4704
                  ? (c < 4698
                    ? c == 4696
                    : c <= 4701)
                  : (c <= 4744 || (c >= 4746 && c <= 4749)))
                : (c <= 4784 || (c < 4800
                  ? (c < 4792
                    ? (c >= 4786 && c <= 4789)
                    : c <= 4798)
                  : (c <= 4800 || (c >= 4802 && c <= 4805)))))))
            : (c <= 4822 || (c < 5792
              ? (c < 5024
                ? (c < 4888
                  ? (c < 4882
                    ? (c >= 4824 && c <= 4880)
                    : c <= 4885)
                  : (c <= 4954 || (c >= 4992 && c <= 5007)))
                : (c <= 5109 || (c < 5743
                  ? (c < 5121
                    ? (c >= 5112 && c <= 5117)
                    : c <= 5740)
                  : (c <= 5759 || (c >= 5761 && c <= 5786)))))
              : (c <= 5866 || (c < 5984
                ? (c < 5919
                  ? (c < 5888
                    ? (c >= 5870 && c <= 5880)
                    : c <= 5905)
                  : (c <= 5937 || (c >= 5952 && c <= 5969)))
                : (c <= 5996 || (c < 6103
                  ? (c < 6016
                    ? (c >= 5998 && c <= 6000)
                    : c <= 6067)
                  : (c <= 6103 || c == 6108))))))))
          : (c <= 6264 || (c < 7312
            ? (c < 6823
              ? (c < 6512
                ? (c < 6320
                  ? (c < 6314
                    ? (c >= 6272 && c <= 6312)
                    : c <= 6314)
                  : (c <= 6389 || (c < 6480
                    ? (c >= 6400 && c <= 6430)
                    : c <= 6509)))
                : (c <= 6516 || (c < 6656
                  ? (c < 6576
                    ? (c >= 6528 && c <= 6571)
                    : c <= 6601)
                  : (c <= 6678 || (c >= 6688 && c <= 6740)))))
              : (c <= 6823 || (c < 7098
                ? (c < 7043
                  ? (c < 6981
                    ? (c >= 6917 && c <= 6963)
                    : c <= 6988)
                  : (c <= 7072 || (c >= 7086 && c <= 7087)))
                : (c <= 7141 || (c < 7258
                  ? (c < 7245
                    ? (c >= 7168 && c <= 7203)
                    : c <= 7247)
                  : (c <= 7293 || (c >= 7296 && c <= 7304)))))))
            : (c <= 7354 || (c < 8008
              ? (c < 7418
                ? (c < 7406
                  ? (c < 7401
                    ? (c >= 7357 && c <= 7359)
                    : c <= 7404)
                  : (c <= 7411 || (c >= 7413 && c <= 7414)))
                : (c <= 7418 || (c < 7960
                  ? (c < 7680
                    ? (c >= 7424 && c <= 7615)
                    : c <= 7957)
                  : (c <= 7965 || (c >= 7968 && c <= 8005)))))
              : (c <= 8013 || (c < 8031
                ? (c < 8027
                  ? (c < 8025
                    ? (c >= 8016 && c <= 8023)
                    : c <= 8025)
                  : (c <= 8027 || c == 8029))
                : (c <= 8061 || (c < 8126
                  ? (c < 8118
                    ? (c >= 8064 && c <= 8116)
                    : c <= 8124)
                  : (c <= 8126 || (c >= 8130 && c <= 8132)))))))))))
        : (c <= 8140 || (c < 12337
          ? (c < 8544
            ? (c < 8458
              ? (c < 8305
                ? (c < 8160
                  ? (c < 8150
                    ? (c >= 8144 && c <= 8147)
                    : c <= 8155)
                  : (c <= 8172 || (c < 8182
                    ? (c >= 8178 && c <= 8180)
                    : c <= 8188)))
                : (c <= 8305 || (c < 8450
                  ? (c < 8336
                    ? c == 8319
                    : c <= 8348)
                  : (c <= 8450 || c == 8455))))
              : (c <= 8467 || (c < 8488
                ? (c < 8484
                  ? (c < 8472
                    ? c == 8469
                    : c <= 8477)
                  : (c <= 8484 || c == 8486))
                : (c <= 8488 || (c < 8517
                  ? (c < 8508
                    ? (c >= 8490 && c <= 8505)
                    : c <= 8511)
                  : (c <= 8521 || c == 8526))))))
            : (c <= 8584 || (c < 11680
              ? (c < 11559
                ? (c < 11506
                  ? (c < 11499
                    ? (c >= 11264 && c <= 11492)
                    : c <= 11502)
                  : (c <= 11507 || (c >= 11520 && c <= 11557)))
                : (c <= 11559 || (c < 11631
                  ? (c < 11568
                    ? c == 11565
                    : c <= 11623)
                  : (c <= 11631 || (c >= 11648 && c <= 11670)))))
              : (c <= 11686 || (c < 11720
                ? (c < 11704
                  ? (c < 11696
                    ? (c >= 11688 && c <= 11694)
                    : c <= 11702)
                  : (c <= 11710 || (c >= 11712 && c <= 11718)))
                : (c <= 11726 || (c < 12293
                  ? (c < 11736
                    ? (c >= 11728 && c <= 11734)
                    : c <= 11742)
                  : (c <= 12295 || (c >= 12321 && c <= 12329)))))))))
          : (c <= 12341 || (c < 42891
            ? (c < 19968
              ? (c < 12549
                ? (c < 12445
                  ? (c < 12353
                    ? (c >= 12344 && c <= 12348)
                    : c <= 12438)
                  : (c <= 12447 || (c < 12540
                    ? (c >= 12449 && c <= 12538)
                    : c <= 12543)))
                : (c <= 12591 || (c < 12784
                  ? (c < 12704
                    ? (c >= 12593 && c <= 12686)
                    : c <= 12735)
                  : (c <= 12799 || (c >= 13312 && c <= 19903)))))
              : (c <= 42124 || (c < 42560
                ? (c < 42512
                  ? (c < 42240
                    ? (c >= 42192 && c <= 42237)
                    : c <= 42508)
                  : (c <= 42527 || (c >= 42538 && c <= 42539)))
                : (c <= 42606 || (c < 42775
                  ? (c < 42656
                    ? (c >= 42623 && c <= 42653)
                    : c <= 42735)
                  : (c <= 42783 || (c >= 42786 && c <= 42888)))))))
            : (c <= 42954 || (c < 43250
              ? (c < 43011
                ? (c < 42965
                  ? (c < 42963
                    ? (c >= 42960 && c <= 42961)
                    : c <= 42963)
                  : (c <= 42969 || (c >= 42994 && c <= 43009)))
                : (c <= 43013 || (c < 43072
                  ? (c < 43020
                    ? (c >= 43015 && c <= 43018)
                    : c <= 43042)
                  : (c <= 43123 || (c >= 43138 && c <= 43187)))))
              : (c <= 43255 || (c < 43360
                ? (c < 43274
                  ? (c < 43261
                    ? c == 43259
                    : c <= 43262)
                  : (c <= 43301 || (c >= 43312 && c <= 43334)))
                : (c <= 43388 || (c < 43488
                  ? (c < 43471
                    ? (c >= 43396 && c <= 43442)
                    : c <= 43471)
                  : (c <= 43492 || (c >= 43494 && c <= 43503)))))))))))))))
    : (c <= 43518 || (c < 70727
      ? (c < 66956
        ? (c < 64914
          ? (c < 43868
            ? (c < 43714
              ? (c < 43646
                ? (c < 43588
                  ? (c < 43584
                    ? (c >= 43520 && c <= 43560)
                    : c <= 43586)
                  : (c <= 43595 || (c < 43642
                    ? (c >= 43616 && c <= 43638)
                    : c <= 43642)))
                : (c <= 43695 || (c < 43705
                  ? (c < 43701
                    ? c == 43697
                    : c <= 43702)
                  : (c <= 43709 || c == 43712))))
              : (c <= 43714 || (c < 43785
                ? (c < 43762
                  ? (c < 43744
                    ? (c >= 43739 && c <= 43741)
                    : c <= 43754)
                  : (c <= 43764 || (c >= 43777 && c <= 43782)))
                : (c <= 43790 || (c < 43816
                  ? (c < 43808
                    ? (c >= 43793 && c <= 43798)
                    : c <= 43814)
                  : (c <= 43822 || (c >= 43824 && c <= 43866)))))))
            : (c <= 43881 || (c < 64287
              ? (c < 63744
                ? (c < 55216
                  ? (c < 44032
                    ? (c >= 43888 && c <= 44002)
                    : c <= 55203)
                  : (c <= 55238 || (c >= 55243 && c <= 55291)))
                : (c <= 64109 || (c < 64275
                  ? (c < 64256
                    ? (c >= 64112 && c <= 64217)
                    : c <= 64262)
                  : (c <= 64279 || c == 64285))))
              : (c <= 64296 || (c < 64323
                ? (c < 64318
                  ? (c < 64312
                    ? (c >= 64298 && c <= 64310)
                    : c <= 64316)
                  : (c <= 64318 || (c >= 64320 && c <= 64321)))
                : (c <= 64324 || (c < 64612
                  ? (c < 64467
                    ? (c >= 64326 && c <= 64433)
                    : c <= 64605)
                  : (c <= 64829 || (c >= 64848 && c <= 64911)))))))))
          : (c <= 64967 || (c < 65599
            ? (c < 65382
              ? (c < 65147
                ? (c < 65139
                  ? (c < 65137
                    ? (c >= 65008 && c <= 65017)
                    : c <= 65137)
                  : (c <= 65139 || (c < 65145
                    ? c == 65143
                    : c <= 65145)))
                : (c <= 65147 || (c < 65313
                  ? (c < 65151
                    ? c == 65149
                    : c <= 65276)
                  : (c <= 65338 || (c >= 65345 && c <= 65370)))))
              : (c <= 65437 || (c < 65498
                ? (c < 65482
                  ? (c < 65474
                    ? (c >= 65440 && c <= 65470)
                    : c <= 65479)
                  : (c <= 65487 || (c >= 65490 && c <= 65495)))
                : (c <= 65500 || (c < 65576
                  ? (c < 65549
                    ? (c >= 65536 && c <= 65547)
                    : c <= 65574)
                  : (c <= 65594 || (c >= 65596 && c <= 65597)))))))
            : (c <= 65613 || (c < 66464
              ? (c < 66208
                ? (c < 65856
                  ? (c < 65664
                    ? (c >= 65616 && c <= 65629)
                    : c <= 65786)
                  : (c <= 65908 || (c >= 66176 && c <= 66204)))
                : (c <= 66256 || (c < 66384
                  ? (c < 66349
                    ? (c >= 66304 && c <= 66335)
                    : c <= 66378)
                  : (c <= 66421 || (c >= 66432 && c <= 66461)))))
              : (c <= 66499 || (c < 66776
                ? (c < 66560
                  ? (c < 66513
                    ? (c >= 66504 && c <= 66511)
                    : c <= 66517)
                  : (c <= 66717 || (c >= 66736 && c <= 66771)))
                : (c <= 66811 || (c < 66928
                  ? (c < 66864
                    ? (c >= 66816 && c <= 66855)
                    : c <= 66915)
                  : (c <= 66938 || (c >= 66940 && c <= 66954)))))))))))
        : (c <= 66962 || (c < 68864
          ? (c < 67828
            ? (c < 67506
              ? (c < 67072
                ? (c < 66979
                  ? (c < 66967
                    ? (c >= 66964 && c <= 66965)
                    : c <= 66977)
                  : (c <= 66993 || (c < 67003
                    ? (c >= 66995 && c <= 67001)
                    : c <= 67004)))
                : (c <= 67382 || (c < 67456
                  ? (c < 67424
                    ? (c >= 67392 && c <= 67413)
                    : c <= 67431)
                  : (c <= 67461 || (c >= 67463 && c <= 67504)))))
              : (c <= 67514 || (c < 67644
                ? (c < 67594
                  ? (c < 67592
                    ? (c >= 67584 && c <= 67589)
                    : c <= 67592)
                  : (c <= 67637 || (c >= 67639 && c <= 67640)))
                : (c <= 67644 || (c < 67712
                  ? (c < 67680
                    ? (c >= 67647 && c <= 67669)
                    : c <= 67702)
                  : (c <= 67742 || (c >= 67808 && c <= 67826)))))))
            : (c <= 67829 || (c < 68224
              ? (c < 68096
                ? (c < 67968
                  ? (c < 67872
                    ? (c >= 67840 && c <= 67861)
                    : c <= 67897)
                  : (c <= 68023 || (c >= 68030 && c <= 68031)))
                : (c <= 68096 || (c < 68121
                  ? (c < 68117
                    ? (c >= 68112 && c <= 68115)
                    : c <= 68119)
                  : (c <= 68149 || (c >= 68192 && c <= 68220)))))
              : (c <= 68252 || (c < 68448
                ? (c < 68352
                  ? (c < 68297
                    ? (c >= 68288 && c <= 68295)
                    : c <= 68324)
                  : (c <= 68405 || (c >= 68416 && c <= 68437)))
                : (c <= 68466 || (c < 68736
                  ? (c < 68608
                    ? (c >= 68480 && c <= 68497)
                    : c <= 68680)
                  : (c <= 68786 || (c >= 68800 && c <= 68850)))))))))
          : (c <= 68899 || (c < 70106
            ? (c < 69749
              ? (c < 69488
                ? (c < 69376
                  ? (c < 69296
                    ? (c >= 69248 && c <= 69289)
                    : c <= 69297)
                  : (c <= 69404 || (c < 69424
                    ? c == 69415
                    : c <= 69445)))
                : (c <= 69505 || (c < 69635
                  ? (c < 69600
                    ? (c >= 69552 && c <= 69572)
                    : c <= 69622)
                  : (c <= 69687 || (c >= 69745 && c <= 69746)))))
              : (c <= 69749 || (c < 69959
                ? (c < 69891
                  ? (c < 69840
                    ? (c >= 69763 && c <= 69807)
                    : c <= 69864)
                  : (c <= 69926 || c == 69956))
                : (c <= 69959 || (c < 70019
                  ? (c < 70006
                    ? (c >= 69968 && c <= 70002)
                    : c <= 70006)
                  : (c <= 70066 || (c >= 70081 && c <= 70084)))))))
            : (c <= 70106 || (c < 70405
              ? (c < 70280
                ? (c < 70163
                  ? (c < 70144
                    ? c == 70108
                    : c <= 70161)
                  : (c <= 70187 || (c >= 70272 && c <= 70278)))
                : (c <= 70280 || (c < 70303
                  ? (c < 70287
                    ? (c >= 70282 && c <= 70285)
                    : c <= 70301)
                  : (c <= 70312 || (c >= 70320 && c <= 70366)))))
              : (c <= 70412 || (c < 70453
                ? (c < 70442
                  ? (c < 70419
                    ? (c >= 70415 && c <= 70416)
                    : c <= 70440)
                  : (c <= 70448 || (c >= 70450 && c <= 70451)))
                : (c <= 70457 || (c < 70493
                  ? (c < 70480
                    ? c == 70461
                    : c <= 70480)
                  : (c <= 70497 || (c >= 70656 && c <= 70708)))))))))))))
      : (c <= 70730 || (c < 119894
        ? (c < 73056
          ? (c < 72001
            ? (c < 71424
              ? (c < 71128
                ? (c < 70852
                  ? (c < 70784
                    ? (c >= 70751 && c <= 70753)
                    : c <= 70831)
                  : (c <= 70853 || (c < 71040
                    ? c == 70855
                    : c <= 71086)))
                : (c <= 71131 || (c < 71296
                  ? (c < 71236
                    ? (c >= 71168 && c <= 71215)
                    : c <= 71236)
                  : (c <= 71338 || c == 71352))))
              : (c <= 71450 || (c < 71945
                ? (c < 71840
                  ? (c < 71680
                    ? (c >= 71488 && c <= 71494)
                    : c <= 71723)
                  : (c <= 71903 || (c >= 71935 && c <= 71942)))
                : (c <= 71945 || (c < 71960
                  ? (c < 71957
                    ? (c >= 71948 && c <= 71955)
                    : c <= 71958)
                  : (c <= 71983 || c == 71999))))))
            : (c <= 72001 || (c < 72349
              ? (c < 72192
                ? (c < 72161
                  ? (c < 72106
                    ? (c >= 72096 && c <= 72103)
                    : c <= 72144)
                  : (c <= 72161 || c == 72163))
                : (c <= 72192 || (c < 72272
                  ? (c < 72250
                    ? (c >= 72203 && c <= 72242)
                    : c <= 72250)
                  : (c <= 72272 || (c >= 72284 && c <= 72329)))))
              : (c <= 72349 || (c < 72818
                ? (c < 72714
                  ? (c < 72704
                    ? (c >= 72368 && c <= 72440)
                    : c <= 72712)
                  : (c <= 72750 || c == 72768))
                : (c <= 72847 || (c < 72971
                  ? (c < 72968
                    ? (c >= 72960 && c <= 72966)
                    : c <= 72969)
                  : (c <= 73008 || c == 73030))))))))
          : (c <= 73061 || (c < 93952
            ? (c < 82944
              ? (c < 73728
                ? (c < 73112
                  ? (c < 73066
                    ? (c >= 73063 && c <= 73064)
                    : c <= 73097)
                  : (c <= 73112 || (c < 73648
                    ? (c >= 73440 && c <= 73458)
                    : c <= 73648)))
                : (c <= 74649 || (c < 77712
                  ? (c < 74880
                    ? (c >= 74752 && c <= 74862)
                    : c <= 75075)
                  : (c <= 77808 || (c >= 77824 && c <= 78894)))))
              : (c <= 83526 || (c < 92928
                ? (c < 92784
                  ? (c < 92736
                    ? (c >= 92160 && c <= 92728)
                    : c <= 92766)
                  : (c <= 92862 || (c >= 92880 && c <= 92909)))
                : (c <= 92975 || (c < 93053
                  ? (c < 93027
                    ? (c >= 92992 && c <= 92995)
                    : c <= 93047)
                  : (c <= 93071 || (c >= 93760 && c <= 93823)))))))
            : (c <= 94026 || (c < 110589
              ? (c < 94208
                ? (c < 94176
                  ? (c < 94099
                    ? c == 94032
                    : c <= 94111)
                  : (c <= 94177 || c == 94179))
                : (c <= 100343 || (c < 110576
                  ? (c < 101632
                    ? (c >= 100352 && c <= 101589)
                    : c <= 101640)
                  : (c <= 110579 || (c >= 110581 && c <= 110587)))))
              : (c <= 110590 || (c < 113664
                ? (c < 110948
                  ? (c < 110928
                    ? (c >= 110592 && c <= 110882)
                    : c <= 110930)
                  : (c <= 110951 || (c >= 110960 && c <= 111355)))
                : (c <= 113770 || (c < 113808
                  ? (c < 113792
                    ? (c >= 113776 && c <= 113788)
                    : c <= 113800)
                  : (c <= 113817 || (c >= 119808 && c <= 119892)))))))))))
        : (c <= 119964 || (c < 125259
          ? (c < 120572
            ? (c < 120086
              ? (c < 119995
                ? (c < 119973
                  ? (c < 119970
                    ? (c >= 119966 && c <= 119967)
                    : c <= 119970)
                  : (c <= 119974 || (c < 119982
                    ? (c >= 119977 && c <= 119980)
                    : c <= 119993)))
                : (c <= 119995 || (c < 120071
                  ? (c < 120005
                    ? (c >= 119997 && c <= 120003)
                    : c <= 120069)
                  : (c <= 120074 || (c >= 120077 && c <= 120084)))))
              : (c <= 120092 || (c < 120138
                ? (c < 120128
                  ? (c < 120123
                    ? (c >= 120094 && c <= 120121)
                    : c <= 120126)
                  : (c <= 120132 || c == 120134))
                : (c <= 120144 || (c < 120514
                  ? (c < 120488
                    ? (c >= 120146 && c <= 120485)
                    : c <= 120512)
                  : (c <= 120538 || (c >= 120540 && c <= 120570)))))))
            : (c <= 120596 || (c < 123191
              ? (c < 120714
                ? (c < 120656
                  ? (c < 120630
                    ? (c >= 120598 && c <= 120628)
                    : c <= 120654)
                  : (c <= 120686 || (c >= 120688 && c <= 120712)))
                : (c <= 120744 || (c < 122624
                  ? (c < 120772
                    ? (c >= 120746 && c <= 120770)
                    : c <= 120779)
                  : (c <= 122654 || (c >= 123136 && c <= 123180)))))
              : (c <= 123197 || (c < 124904
                ? (c < 123584
                  ? (c < 123536
                    ? c == 123214
                    : c <= 123565)
                  : (c <= 123627 || (c >= 124896 && c <= 124902)))
                : (c <= 124907 || (c < 124928
                  ? (c < 124912
                    ? (c >= 124909 && c <= 124910)
                    : c <= 124926)
                  : (c <= 125124 || (c >= 125184 && c <= 125251)))))))))
          : (c <= 125259 || (c < 126559
            ? (c < 126535
              ? (c < 126505
                ? (c < 126497
                  ? (c < 126469
                    ? (c >= 126464 && c <= 126467)
                    : c <= 126495)
                  : (c <= 126498 || (c < 126503
                    ? c == 126500
                    : c <= 126503)))
                : (c <= 126514 || (c < 126523
                  ? (c < 126521
                    ? (c >= 126516 && c <= 126519)
                    : c <= 126521)
                  : (c <= 126523 || c == 126530))))
              : (c <= 126535 || (c < 126548
                ? (c < 126541
                  ? (c < 126539
                    ? c == 126537
                    : c <= 126539)
                  : (c <= 126543 || (c >= 126545 && c <= 126546)))
                : (c <= 126548 || (c < 126555
                  ? (c < 126553
                    ? c == 126551
                    : c <= 126553)
                  : (c <= 126555 || c == 126557))))))
            : (c <= 126559 || (c < 126625
              ? (c < 126580
                ? (c < 126567
                  ? (c < 126564
                    ? (c >= 126561 && c <= 126562)
                    : c <= 126564)
                  : (c <= 126570 || (c >= 126572 && c <= 126578)))
                : (c <= 126583 || (c < 126592
                  ? (c < 126590
                    ? (c >= 126585 && c <= 126588)
                    : c <= 126590)
                  : (c <= 126601 || (c >= 126603 && c <= 126619)))))
              : (c <= 126627 || (c < 177984
                ? (c < 131072
                  ? (c < 126635
                    ? (c >= 126629 && c <= 126633)
                    : c <= 126651)
                  : (c <= 173791 || (c >= 173824 && c <= 177976)))
                : (c <= 178205 || (c < 194560
                  ? (c < 183984
                    ? (c >= 178208 && c <= 183969)
                    : c <= 191456)
                  : (c <= 195101 || (c >= 196608 && c <= 201546)))))))))))))))));
}

static inline bool sym_identifier_character_set_2(int32_t c) {
  return (c < 43514
    ? (c < 4193
      ? (c < 2707
        ? (c < 1994
          ? (c < 910
            ? (c < 736
              ? (c < 186
                ? (c < 'a'
                  ? (c < '_'
                    ? (c >= 'A' && c <= 'Z')
                    : c <= '_')
                  : (c <= 'z' || (c < 181
                    ? c == 170
                    : c <= 181)))
                : (c <= 186 || (c < 248
                  ? (c < 216
                    ? (c >= 192 && c <= 214)
                    : c <= 246)
                  : (c <= 705 || (c >= 710 && c <= 721)))))
              : (c <= 740 || (c < 891
                ? (c < 880
                  ? (c < 750
                    ? c == 748
                    : c <= 750)
                  : (c <= 884 || (c >= 886 && c <= 887)))
                : (c <= 893 || (c < 904
                  ? (c < 902
                    ? c == 895
                    : c <= 902)
                  : (c <= 906 || c == 908))))))
            : (c <= 929 || (c < 1649
              ? (c < 1376
                ? (c < 1162
                  ? (c < 1015
                    ? (c >= 931 && c <= 1013)
                    : c <= 1153)
                  : (c <= 1327 || (c < 1369
                    ? (c >= 1329 && c <= 1366)
                    : c <= 1369)))
                : (c <= 1416 || (c < 1568
                  ? (c < 1519
                    ? (c >= 1488 && c <= 1514)
                    : c <= 1522)
                  : (c <= 1610 || (c >= 1646 && c <= 1647)))))
              : (c <= 1747 || (c < 1791
                ? (c < 1774
                  ? (c < 1765
                    ? c == 1749
                    : c <= 1766)
                  : (c <= 1775 || (c >= 1786 && c <= 1788)))
                : (c <= 1791 || (c < 1869
                  ? (c < 1810
                    ? c == 1808
                    : c <= 1839)
                  : (c <= 1957 || c == 1969))))))))
          : (c <= 2026 || (c < 2482
            ? (c < 2208
              ? (c < 2088
                ? (c < 2048
                  ? (c < 2042
                    ? (c >= 2036 && c <= 2037)
                    : c <= 2042)
                  : (c <= 2069 || (c < 2084
                    ? c == 2074
                    : c <= 2084)))
                : (c <= 2088 || (c < 2160
                  ? (c < 2144
                    ? (c >= 2112 && c <= 2136)
                    : c <= 2154)
                  : (c <= 2183 || (c >= 2185 && c <= 2190)))))
              : (c <= 2249 || (c < 2417
                ? (c < 2384
                  ? (c < 2365
                    ? (c >= 2308 && c <= 2361)
                    : c <= 2365)
                  : (c <= 2384 || (c >= 2392 && c <= 2401)))
                : (c <= 2432 || (c < 2451
                  ? (c < 2447
                    ? (c >= 2437 && c <= 2444)
                    : c <= 2448)
                  : (c <= 2472 || (c >= 2474 && c <= 2480)))))))
            : (c <= 2482 || (c < 2579
              ? (c < 2527
                ? (c < 2510
                  ? (c < 2493
                    ? (c >= 2486 && c <= 2489)
                    : c <= 2493)
                  : (c <= 2510 || (c >= 2524 && c <= 2525)))
                : (c <= 2529 || (c < 2565
                  ? (c < 2556
                    ? (c >= 2544 && c <= 2545)
                    : c <= 2556)
                  : (c <= 2570 || (c >= 2575 && c <= 2576)))))
              : (c <= 2600 || (c < 2649
                ? (c < 2613
                  ? (c < 2610
                    ? (c >= 2602 && c <= 2608)
                    : c <= 2611)
                  : (c <= 2614 || (c >= 2616 && c <= 2617)))
                : (c <= 2652 || (c < 2693
                  ? (c < 2674
                    ? c == 2654
                    : c <= 2676)
                  : (c <= 2701 || (c >= 2703 && c <= 2705)))))))))))
        : (c <= 2728 || (c < 3242
          ? (c < 2962
            ? (c < 2858
              ? (c < 2784
                ? (c < 2741
                  ? (c < 2738
                    ? (c >= 2730 && c <= 2736)
                    : c <= 2739)
                  : (c <= 2745 || (c < 2768
                    ? c == 2749
                    : c <= 2768)))
                : (c <= 2785 || (c < 2831
                  ? (c < 2821
                    ? c == 2809
                    : c <= 2828)
                  : (c <= 2832 || (c >= 2835 && c <= 2856)))))
              : (c <= 2864 || (c < 2911
                ? (c < 2877
                  ? (c < 2869
                    ? (c >= 2866 && c <= 2867)
                    : c <= 2873)
                  : (c <= 2877 || (c >= 2908 && c <= 2909)))
                : (c <= 2913 || (c < 2949
                  ? (c < 2947
                    ? c == 2929
                    : c <= 2947)
                  : (c <= 2954 || (c >= 2958 && c <= 2960)))))))
            : (c <= 2965 || (c < 3090
              ? (c < 2984
                ? (c < 2974
                  ? (c < 2972
                    ? (c >= 2969 && c <= 2970)
                    : c <= 2972)
                  : (c <= 2975 || (c >= 2979 && c <= 2980)))
                : (c <= 2986 || (c < 3077
                  ? (c < 3024
                    ? (c >= 2990 && c <= 3001)
                    : c <= 3024)
                  : (c <= 3084 || (c >= 3086 && c <= 3088)))))
              : (c <= 3112 || (c < 3168
                ? (c < 3160
                  ? (c < 3133
                    ? (c >= 3114 && c <= 3129)
                    : c <= 3133)
                  : (c <= 3162 || c == 3165))
                : (c <= 3169 || (c < 3214
                  ? (c < 3205
                    ? c == 3200
                    : c <= 3212)
                  : (c <= 3216 || (c >= 3218 && c <= 3240)))))))))
          : (c <= 3251 || (c < 3648
            ? (c < 3412
              ? (c < 3332
                ? (c < 3293
                  ? (c < 3261
                    ? (c >= 3253 && c <= 3257)
                    : c <= 3261)
                  : (c <= 3294 || (c < 3313
                    ? (c >= 3296 && c <= 3297)
                    : c <= 3314)))
                : (c <= 3340 || (c < 3389
                  ? (c < 3346
                    ? (c >= 3342 && c <= 3344)
                    : c <= 3386)
                  : (c <= 3389 || c == 3406))))
              : (c <= 3414 || (c < 3507
                ? (c < 3461
                  ? (c < 3450
                    ? (c >= 3423 && c <= 3425)
                    : c <= 3455)
                  : (c <= 3478 || (c >= 3482 && c <= 3505)))
                : (c <= 3515 || (c < 3585
                  ? (c < 3520
                    ? c == 3517
                    : c <= 3526)
                  : (c <= 3632 || c == 3634))))))
            : (c <= 3654 || (c < 3782
              ? (c < 3749
                ? (c < 3718
                  ? (c < 3716
                    ? (c >= 3713 && c <= 3714)
                    : c <= 3716)
                  : (c <= 3722 || (c >= 3724 && c <= 3747)))
                : (c <= 3749 || (c < 3773
                  ? (c < 3762
                    ? (c >= 3751 && c <= 3760)
                    : c <= 3762)
                  : (c <= 3773 || (c >= 3776 && c <= 3780)))))
              : (c <= 3782 || (c < 3976
                ? (c < 3904
                  ? (c < 3840
                    ? (c >= 3804 && c <= 3807)
                    : c <= 3840)
                  : (c <= 3911 || (c >= 3913 && c <= 3948)))
                : (c <= 3980 || (c < 4176
                  ? (c < 4159
                    ? (c >= 4096 && c <= 4138)
                    : c <= 4159)
                  : (c <= 4181 || (c >= 4186 && c <= 4189)))))))))))))
      : (c <= 4193 || (c < 8134
        ? (c < 6176
          ? (c < 4808
            ? (c < 4688
              ? (c < 4295
                ? (c < 4213
                  ? (c < 4206
                    ? (c >= 4197 && c <= 4198)
                    : c <= 4208)
                  : (c <= 4225 || (c < 4256
                    ? c == 4238
                    : c <= 4293)))
                : (c <= 4295 || (c < 4348
                  ? (c < 4304
                    ? c == 4301
                    : c <= 4346)
                  : (c <= 4680 || (c >= 4682 && c <= 4685)))))
              : (c <= 4694 || (c < 4752
                ? (c < 4704
                  ? (c < 4698
                    ? c == 4696
                    : c <= 4701)
                  : (c <= 4744 || (c >= 4746 && c <= 4749)))
                : (c <= 4784 || (c < 4800
                  ? (c < 4792
                    ? (c >= 4786 && c <= 4789)
                    : c <= 4798)
                  : (c <= 4800 || (c >= 4802 && c <= 4805)))))))
            : (c <= 4822 || (c < 5792
              ? (c < 5024
                ? (c < 4888
                  ? (c < 4882
                    ? (c >= 4824 && c <= 4880)
                    : c <= 4885)
                  : (c <= 4954 || (c >= 4992 && c <= 5007)))
                : (c <= 5109 || (c < 5743
                  ? (c < 5121
                    ? (c >= 5112 && c <= 5117)
                    : c <= 5740)
                  : (c <= 5759 || (c >= 5761 && c <= 5786)))))
              : (c <= 5866 || (c < 5984
                ? (c < 5919
                  ? (c < 5888
                    ? (c >= 5870 && c <= 5880)
                    : c <= 5905)
                  : (c <= 5937 || (c >= 5952 && c <= 5969)))
                : (c <= 5996 || (c < 6103
                  ? (c < 6016
                    ? (c >= 5998 && c <= 6000)
                    : c <= 6067)
                  : (c <= 6103 || c == 6108))))))))
          : (c <= 6264 || (c < 7312
            ? (c < 6823
              ? (c < 6512
                ? (c < 6320
                  ? (c < 6314
                    ? (c >= 6272 && c <= 6312)
                    : c <= 6314)
                  : (c <= 6389 || (c < 6480
                    ? (c >= 6400 && c <= 6430)
                    : c <= 6509)))
                : (c <= 6516 || (c < 6656
                  ? (c < 6576
                    ? (c >= 6528 && c <= 6571)
                    : c <= 6601)
                  : (c <= 6678 || (c >= 6688 && c <= 6740)))))
              : (c <= 6823 || (c < 7098
                ? (c < 7043
                  ? (c < 6981
                    ? (c >= 6917 && c <= 6963)
                    : c <= 6988)
                  : (c <= 7072 || (c >= 7086 && c <= 7087)))
                : (c <= 7141 || (c < 7258
                  ? (c < 7245
                    ? (c >= 7168 && c <= 7203)
                    : c <= 7247)
                  : (c <= 7293 || (c >= 7296 && c <= 7304)))))))
            : (c <= 7354 || (c < 8008
              ? (c < 7418
                ? (c < 7406
                  ? (c < 7401
                    ? (c >= 7357 && c <= 7359)
                    : c <= 7404)
                  : (c <= 7411 || (c >= 7413 && c <= 7414)))
                : (c <= 7418 || (c < 7960
                  ? (c < 7680
                    ? (c >= 7424 && c <= 7615)
                    : c <= 7957)
                  : (c <= 7965 || (c >= 7968 && c <= 8005)))))
              : (c <= 8013 || (c < 8031
                ? (c < 8027
                  ? (c < 8025
                    ? (c >= 8016 && c <= 8023)
                    : c <= 8025)
                  : (c <= 8027 || c == 8029))
                : (c <= 8061 || (c < 8126
                  ? (c < 8118
                    ? (c >= 8064 && c <= 8116)
                    : c <= 8124)
                  : (c <= 8126 || (c >= 8130 && c <= 8132)))))))))))
        : (c <= 8140 || (c < 12337
          ? (c < 8544
            ? (c < 8458
              ? (c < 8305
                ? (c < 8160
                  ? (c < 8150
                    ? (c >= 8144 && c <= 8147)
                    : c <= 8155)
                  : (c <= 8172 || (c < 8182
                    ? (c >= 8178 && c <= 8180)
                    : c <= 8188)))
                : (c <= 8305 || (c < 8450
                  ? (c < 8336
                    ? c == 8319
                    : c <= 8348)
                  : (c <= 8450 || c == 8455))))
              : (c <= 8467 || (c < 8488
                ? (c < 8484
                  ? (c < 8472
                    ? c == 8469
                    : c <= 8477)
                  : (c <= 8484 || c == 8486))
                : (c <= 8488 || (c < 8517
                  ? (c < 8508
                    ? (c >= 8490 && c <= 8505)
                    : c <= 8511)
                  : (c <= 8521 || c == 8526))))))
            : (c <= 8584 || (c < 11680
              ? (c < 11559
                ? (c < 11506
                  ? (c < 11499
                    ? (c >= 11264 && c <= 11492)
                    : c <= 11502)
                  : (c <= 11507 || (c >= 11520 && c <= 11557)))
                : (c <= 11559 || (c < 11631
                  ? (c < 11568
                    ? c == 11565
                    : c <= 11623)
                  : (c <= 11631 || (c >= 11648 && c <= 11670)))))
              : (c <= 11686 || (c < 11720
                ? (c < 11704
                  ? (c < 11696
                    ? (c >= 11688 && c <= 11694)
                    : c <= 11702)
                  : (c <= 11710 || (c >= 11712 && c <= 11718)))
                : (c <= 11726 || (c < 12293
                  ? (c < 11736
                    ? (c >= 11728 && c <= 11734)
                    : c <= 11742)
                  : (c <= 12295 || (c >= 12321 && c <= 12329)))))))))
          : (c <= 12341 || (c < 42891
            ? (c < 19968
              ? (c < 12549
                ? (c < 12445
                  ? (c < 12353
                    ? (c >= 12344 && c <= 12348)
                    : c <= 12438)
                  : (c <= 12447 || (c < 12540
                    ? (c >= 12449 && c <= 12538)
                    : c <= 12543)))
                : (c <= 12591 || (c < 12784
                  ? (c < 12704
                    ? (c >= 12593 && c <= 12686)
                    : c <= 12735)
                  : (c <= 12799 || (c >= 13312 && c <= 19903)))))
              : (c <= 42124 || (c < 42560
                ? (c < 42512
                  ? (c < 42240
                    ? (c >= 42192 && c <= 42237)
                    : c <= 42508)
                  : (c <= 42527 || (c >= 42538 && c <= 42539)))
                : (c <= 42606 || (c < 42775
                  ? (c < 42656
                    ? (c >= 42623 && c <= 42653)
                    : c <= 42735)
                  : (c <= 42783 || (c >= 42786 && c <= 42888)))))))
            : (c <= 42954 || (c < 43250
              ? (c < 43011
                ? (c < 42965
                  ? (c < 42963
                    ? (c >= 42960 && c <= 42961)
                    : c <= 42963)
                  : (c <= 42969 || (c >= 42994 && c <= 43009)))
                : (c <= 43013 || (c < 43072
                  ? (c < 43020
                    ? (c >= 43015 && c <= 43018)
                    : c <= 43042)
                  : (c <= 43123 || (c >= 43138 && c <= 43187)))))
              : (c <= 43255 || (c < 43360
                ? (c < 43274
                  ? (c < 43261
                    ? c == 43259
                    : c <= 43262)
                  : (c <= 43301 || (c >= 43312 && c <= 43334)))
                : (c <= 43388 || (c < 43488
                  ? (c < 43471
                    ? (c >= 43396 && c <= 43442)
                    : c <= 43471)
                  : (c <= 43492 || (c >= 43494 && c <= 43503)))))))))))))))
    : (c <= 43518 || (c < 70727
      ? (c < 66956
        ? (c < 64914
          ? (c < 43868
            ? (c < 43714
              ? (c < 43646
                ? (c < 43588
                  ? (c < 43584
                    ? (c >= 43520 && c <= 43560)
                    : c <= 43586)
                  : (c <= 43595 || (c < 43642
                    ? (c >= 43616 && c <= 43638)
                    : c <= 43642)))
                : (c <= 43695 || (c < 43705
                  ? (c < 43701
                    ? c == 43697
                    : c <= 43702)
                  : (c <= 43709 || c == 43712))))
              : (c <= 43714 || (c < 43785
                ? (c < 43762
                  ? (c < 43744
                    ? (c >= 43739 && c <= 43741)
                    : c <= 43754)
                  : (c <= 43764 || (c >= 43777 && c <= 43782)))
                : (c <= 43790 || (c < 43816
                  ? (c < 43808
                    ? (c >= 43793 && c <= 43798)
                    : c <= 43814)
                  : (c <= 43822 || (c >= 43824 && c <= 43866)))))))
            : (c <= 43881 || (c < 64287
              ? (c < 63744
                ? (c < 55216
                  ? (c < 44032
                    ? (c >= 43888 && c <= 44002)
                    : c <= 55203)
                  : (c <= 55238 || (c >= 55243 && c <= 55291)))
                : (c <= 64109 || (c < 64275
                  ? (c < 64256
                    ? (c >= 64112 && c <= 64217)
                    : c <= 64262)
                  : (c <= 64279 || c == 64285))))
              : (c <= 64296 || (c < 64323
                ? (c < 64318
                  ? (c < 64312
                    ? (c >= 64298 && c <= 64310)
                    : c <= 64316)
                  : (c <= 64318 || (c >= 64320 && c <= 64321)))
                : (c <= 64324 || (c < 64612
                  ? (c < 64467
                    ? (c >= 64326 && c <= 64433)
                    : c <= 64605)
                  : (c <= 64829 || (c >= 64848 && c <= 64911)))))))))
          : (c <= 64967 || (c < 65599
            ? (c < 65382
              ? (c < 65147
                ? (c < 65139
                  ? (c < 65137
                    ? (c >= 65008 && c <= 65017)
                    : c <= 65137)
                  : (c <= 65139 || (c < 65145
                    ? c == 65143
                    : c <= 65145)))
                : (c <= 65147 || (c < 65313
                  ? (c < 65151
                    ? c == 65149
                    : c <= 65276)
                  : (c <= 65338 || (c >= 65345 && c <= 65370)))))
              : (c <= 65437 || (c < 65498
                ? (c < 65482
                  ? (c < 65474
                    ? (c >= 65440 && c <= 65470)
                    : c <= 65479)
                  : (c <= 65487 || (c >= 65490 && c <= 65495)))
                : (c <= 65500 || (c < 65576
                  ? (c < 65549
                    ? (c >= 65536 && c <= 65547)
                    : c <= 65574)
                  : (c <= 65594 || (c >= 65596 && c <= 65597)))))))
            : (c <= 65613 || (c < 66464
              ? (c < 66208
                ? (c < 65856
                  ? (c < 65664
                    ? (c >= 65616 && c <= 65629)
                    : c <= 65786)
                  : (c <= 65908 || (c >= 66176 && c <= 66204)))
                : (c <= 66256 || (c < 66384
                  ? (c < 66349
                    ? (c >= 66304 && c <= 66335)
                    : c <= 66378)
                  : (c <= 66421 || (c >= 66432 && c <= 66461)))))
              : (c <= 66499 || (c < 66776
                ? (c < 66560
                  ? (c < 66513
                    ? (c >= 66504 && c <= 66511)
                    : c <= 66517)
                  : (c <= 66717 || (c >= 66736 && c <= 66771)))
                : (c <= 66811 || (c < 66928
                  ? (c < 66864
                    ? (c >= 66816 && c <= 66855)
                    : c <= 66915)
                  : (c <= 66938 || (c >= 66940 && c <= 66954)))))))))))
        : (c <= 66962 || (c < 68864
          ? (c < 67828
            ? (c < 67506
              ? (c < 67072
                ? (c < 66979
                  ? (c < 66967
                    ? (c >= 66964 && c <= 66965)
                    : c <= 66977)
                  : (c <= 66993 || (c < 67003
                    ? (c >= 66995 && c <= 67001)
                    : c <= 67004)))
                : (c <= 67382 || (c < 67456
                  ? (c < 67424
                    ? (c >= 67392 && c <= 67413)
                    : c <= 67431)
                  : (c <= 67461 || (c >= 67463 && c <= 67504)))))
              : (c <= 67514 || (c < 67644
                ? (c < 67594
                  ? (c < 67592
                    ? (c >= 67584 && c <= 67589)
                    : c <= 67592)
                  : (c <= 67637 || (c >= 67639 && c <= 67640)))
                : (c <= 67644 || (c < 67712
                  ? (c < 67680
                    ? (c >= 67647 && c <= 67669)
                    : c <= 67702)
                  : (c <= 67742 || (c >= 67808 && c <= 67826)))))))
            : (c <= 67829 || (c < 68224
              ? (c < 68096
                ? (c < 67968
                  ? (c < 67872
                    ? (c >= 67840 && c <= 67861)
                    : c <= 67897)
                  : (c <= 68023 || (c >= 68030 && c <= 68031)))
                : (c <= 68096 || (c < 68121
                  ? (c < 68117
                    ? (c >= 68112 && c <= 68115)
                    : c <= 68119)
                  : (c <= 68149 || (c >= 68192 && c <= 68220)))))
              : (c <= 68252 || (c < 68448
                ? (c < 68352
                  ? (c < 68297
                    ? (c >= 68288 && c <= 68295)
                    : c <= 68324)
                  : (c <= 68405 || (c >= 68416 && c <= 68437)))
                : (c <= 68466 || (c < 68736
                  ? (c < 68608
                    ? (c >= 68480 && c <= 68497)
                    : c <= 68680)
                  : (c <= 68786 || (c >= 68800 && c <= 68850)))))))))
          : (c <= 68899 || (c < 70106
            ? (c < 69749
              ? (c < 69488
                ? (c < 69376
                  ? (c < 69296
                    ? (c >= 69248 && c <= 69289)
                    : c <= 69297)
                  : (c <= 69404 || (c < 69424
                    ? c == 69415
                    : c <= 69445)))
                : (c <= 69505 || (c < 69635
                  ? (c < 69600
                    ? (c >= 69552 && c <= 69572)
                    : c <= 69622)
                  : (c <= 69687 || (c >= 69745 && c <= 69746)))))
              : (c <= 69749 || (c < 69959
                ? (c < 69891
                  ? (c < 69840
                    ? (c >= 69763 && c <= 69807)
                    : c <= 69864)
                  : (c <= 69926 || c == 69956))
                : (c <= 69959 || (c < 70019
                  ? (c < 70006
                    ? (c >= 69968 && c <= 70002)
                    : c <= 70006)
                  : (c <= 70066 || (c >= 70081 && c <= 70084)))))))
            : (c <= 70106 || (c < 70405
              ? (c < 70280
                ? (c < 70163
                  ? (c < 70144
                    ? c == 70108
                    : c <= 70161)
                  : (c <= 70187 || (c >= 70272 && c <= 70278)))
                : (c <= 70280 || (c < 70303
                  ? (c < 70287
                    ? (c >= 70282 && c <= 70285)
                    : c <= 70301)
                  : (c <= 70312 || (c >= 70320 && c <= 70366)))))
              : (c <= 70412 || (c < 70453
                ? (c < 70442
                  ? (c < 70419
                    ? (c >= 70415 && c <= 70416)
                    : c <= 70440)
                  : (c <= 70448 || (c >= 70450 && c <= 70451)))
                : (c <= 70457 || (c < 70493
                  ? (c < 70480
                    ? c == 70461
                    : c <= 70480)
                  : (c <= 70497 || (c >= 70656 && c <= 70708)))))))))))))
      : (c <= 70730 || (c < 119894
        ? (c < 73056
          ? (c < 72001
            ? (c < 71424
              ? (c < 71128
                ? (c < 70852
                  ? (c < 70784
                    ? (c >= 70751 && c <= 70753)
                    : c <= 70831)
                  : (c <= 70853 || (c < 71040
                    ? c == 70855
                    : c <= 71086)))
                : (c <= 71131 || (c < 71296
                  ? (c < 71236
                    ? (c >= 71168 && c <= 71215)
                    : c <= 71236)
                  : (c <= 71338 || c == 71352))))
              : (c <= 71450 || (c < 71945
                ? (c < 71840
                  ? (c < 71680
                    ? (c >= 71488 && c <= 71494)
                    : c <= 71723)
                  : (c <= 71903 || (c >= 71935 && c <= 71942)))
                : (c <= 71945 || (c < 71960
                  ? (c < 71957
                    ? (c >= 71948 && c <= 71955)
                    : c <= 71958)
                  : (c <= 71983 || c == 71999))))))
            : (c <= 72001 || (c < 72349
              ? (c < 72192
                ? (c < 72161
                  ? (c < 72106
                    ? (c >= 72096 && c <= 72103)
                    : c <= 72144)
                  : (c <= 72161 || c == 72163))
                : (c <= 72192 || (c < 72272
                  ? (c < 72250
                    ? (c >= 72203 && c <= 72242)
                    : c <= 72250)
                  : (c <= 72272 || (c >= 72284 && c <= 72329)))))
              : (c <= 72349 || (c < 72818
                ? (c < 72714
                  ? (c < 72704
                    ? (c >= 72368 && c <= 72440)
                    : c <= 72712)
                  : (c <= 72750 || c == 72768))
                : (c <= 72847 || (c < 72971
                  ? (c < 72968
                    ? (c >= 72960 && c <= 72966)
                    : c <= 72969)
                  : (c <= 73008 || c == 73030))))))))
          : (c <= 73061 || (c < 93952
            ? (c < 82944
              ? (c < 73728
                ? (c < 73112
                  ? (c < 73066
                    ? (c >= 73063 && c <= 73064)
                    : c <= 73097)
                  : (c <= 73112 || (c < 73648
                    ? (c >= 73440 && c <= 73458)
                    : c <= 73648)))
                : (c <= 74649 || (c < 77712
                  ? (c < 74880
                    ? (c >= 74752 && c <= 74862)
                    : c <= 75075)
                  : (c <= 77808 || (c >= 77824 && c <= 78894)))))
              : (c <= 83526 || (c < 92928
                ? (c < 92784
                  ? (c < 92736
                    ? (c >= 92160 && c <= 92728)
                    : c <= 92766)
                  : (c <= 92862 || (c >= 92880 && c <= 92909)))
                : (c <= 92975 || (c < 93053
                  ? (c < 93027
                    ? (c >= 92992 && c <= 92995)
                    : c <= 93047)
                  : (c <= 93071 || (c >= 93760 && c <= 93823)))))))
            : (c <= 94026 || (c < 110589
              ? (c < 94208
                ? (c < 94176
                  ? (c < 94099
                    ? c == 94032
                    : c <= 94111)
                  : (c <= 94177 || c == 94179))
                : (c <= 100343 || (c < 110576
                  ? (c < 101632
                    ? (c >= 100352 && c <= 101589)
                    : c <= 101640)
                  : (c <= 110579 || (c >= 110581 && c <= 110587)))))
              : (c <= 110590 || (c < 113664
                ? (c < 110948
                  ? (c < 110928
                    ? (c >= 110592 && c <= 110882)
                    : c <= 110930)
                  : (c <= 110951 || (c >= 110960 && c <= 111355)))
                : (c <= 113770 || (c < 113808
                  ? (c < 113792
                    ? (c >= 113776 && c <= 113788)
                    : c <= 113800)
                  : (c <= 113817 || (c >= 119808 && c <= 119892)))))))))))
        : (c <= 119964 || (c < 125259
          ? (c < 120572
            ? (c < 120086
              ? (c < 119995
                ? (c < 119973
                  ? (c < 119970
                    ? (c >= 119966 && c <= 119967)
                    : c <= 119970)
                  : (c <= 119974 || (c < 119982
                    ? (c >= 119977 && c <= 119980)
                    : c <= 119993)))
                : (c <= 119995 || (c < 120071
                  ? (c < 120005
                    ? (c >= 119997 && c <= 120003)
                    : c <= 120069)
                  : (c <= 120074 || (c >= 120077 && c <= 120084)))))
              : (c <= 120092 || (c < 120138
                ? (c < 120128
                  ? (c < 120123
                    ? (c >= 120094 && c <= 120121)
                    : c <= 120126)
                  : (c <= 120132 || c == 120134))
                : (c <= 120144 || (c < 120514
                  ? (c < 120488
                    ? (c >= 120146 && c <= 120485)
                    : c <= 120512)
                  : (c <= 120538 || (c >= 120540 && c <= 120570)))))))
            : (c <= 120596 || (c < 123191
              ? (c < 120714
                ? (c < 120656
                  ? (c < 120630
                    ? (c >= 120598 && c <= 120628)
                    : c <= 120654)
                  : (c <= 120686 || (c >= 120688 && c <= 120712)))
                : (c <= 120744 || (c < 122624
                  ? (c < 120772
                    ? (c >= 120746 && c <= 120770)
                    : c <= 120779)
                  : (c <= 122654 || (c >= 123136 && c <= 123180)))))
              : (c <= 123197 || (c < 124904
                ? (c < 123584
                  ? (c < 123536
                    ? c == 123214
                    : c <= 123565)
                  : (c <= 123627 || (c >= 124896 && c <= 124902)))
                : (c <= 124907 || (c < 124928
                  ? (c < 124912
                    ? (c >= 124909 && c <= 124910)
                    : c <= 124926)
                  : (c <= 125124 || (c >= 125184 && c <= 125251)))))))))
          : (c <= 125259 || (c < 126559
            ? (c < 126535
              ? (c < 126505
                ? (c < 126497
                  ? (c < 126469
                    ? (c >= 126464 && c <= 126467)
                    : c <= 126495)
                  : (c <= 126498 || (c < 126503
                    ? c == 126500
                    : c <= 126503)))
                : (c <= 126514 || (c < 126523
                  ? (c < 126521
                    ? (c >= 126516 && c <= 126519)
                    : c <= 126521)
                  : (c <= 126523 || c == 126530))))
              : (c <= 126535 || (c < 126548
                ? (c < 126541
                  ? (c < 126539
                    ? c == 126537
                    : c <= 126539)
                  : (c <= 126543 || (c >= 126545 && c <= 126546)))
                : (c <= 126548 || (c < 126555
                  ? (c < 126553
                    ? c == 126551
                    : c <= 126553)
                  : (c <= 126555 || c == 126557))))))
            : (c <= 126559 || (c < 126625
              ? (c < 126580
                ? (c < 126567
                  ? (c < 126564
                    ? (c >= 126561 && c <= 126562)
                    : c <= 126564)
                  : (c <= 126570 || (c >= 126572 && c <= 126578)))
                : (c <= 126583 || (c < 126592
                  ? (c < 126590
                    ? (c >= 126585 && c <= 126588)
                    : c <= 126590)
                  : (c <= 126601 || (c >= 126603 && c <= 126619)))))
              : (c <= 126627 || (c < 177984
                ? (c < 131072
                  ? (c < 126635
                    ? (c >= 126629 && c <= 126633)
                    : c <= 126651)
                  : (c <= 173791 || (c >= 173824 && c <= 177976)))
                : (c <= 178205 || (c < 194560
                  ? (c < 183984
                    ? (c >= 178208 && c <= 183969)
                    : c <= 191456)
                  : (c <= 195101 || (c >= 196608 && c <= 201546)))))))))))))))));
}

static inline bool sym_identifier_character_set_3(int32_t c) {
  return (c < 43616
    ? (c < 3782
      ? (c < 2748
        ? (c < 2045
          ? (c < 1015
            ? (c < 710
              ? (c < 181
                ? (c < '_'
                  ? (c < 'A'
                    ? (c >= '0' && c <= '9')
                    : c <= 'Z')
                  : (c <= '_' || (c < 170
                    ? (c >= 'a' && c <= 'z')
                    : c <= 170)))
                : (c <= 181 || (c < 192
                  ? (c < 186
                    ? c == 183
                    : c <= 186)
                  : (c <= 214 || (c < 248
                    ? (c >= 216 && c <= 246)
                    : c <= 705)))))
              : (c <= 721 || (c < 891
                ? (c < 750
                  ? (c < 748
                    ? (c >= 736 && c <= 740)
                    : c <= 748)
                  : (c <= 750 || (c < 886
                    ? (c >= 768 && c <= 884)
                    : c <= 887)))
                : (c <= 893 || (c < 908
                  ? (c < 902
                    ? c == 895
                    : c <= 906)
                  : (c <= 908 || (c < 931
                    ? (c >= 910 && c <= 929)
                    : c <= 1013)))))))
            : (c <= 1153 || (c < 1519
              ? (c < 1425
                ? (c < 1329
                  ? (c < 1162
                    ? (c >= 1155 && c <= 1159)
                    : c <= 1327)
                  : (c <= 1366 || (c < 1376
                    ? c == 1369
                    : c <= 1416)))
                : (c <= 1469 || (c < 1476
                  ? (c < 1473
                    ? c == 1471
                    : c <= 1474)
                  : (c <= 1477 || (c < 1488
                    ? c == 1479
                    : c <= 1514)))))
              : (c <= 1522 || (c < 1770
                ? (c < 1646
                  ? (c < 1568
                    ? (c >= 1552 && c <= 1562)
                    : c <= 1641)
                  : (c <= 1747 || (c < 1759
                    ? (c >= 1749 && c <= 1756)
                    : c <= 1768)))
                : (c <= 1788 || (c < 1869
                  ? (c < 1808
                    ? c == 1791
                    : c <= 1866)
                  : (c <= 1969 || (c < 2042
                    ? (c >= 1984 && c <= 2037)
                    : c <= 2042)))))))))
          : (c <= 2045 || (c < 2558
            ? (c < 2451
              ? (c < 2200
                ? (c < 2144
                  ? (c < 2112
                    ? (c >= 2048 && c <= 2093)
                    : c <= 2139)
                  : (c <= 2154 || (c < 2185
                    ? (c >= 2160 && c <= 2183)
                    : c <= 2190)))
                : (c <= 2273 || (c < 2417
                  ? (c < 2406
                    ? (c >= 2275 && c <= 2403)
                    : c <= 2415)
                  : (c <= 2435 || (c < 2447
                    ? (c >= 2437 && c <= 2444)
                    : c <= 2448)))))
              : (c <= 2472 || (c < 2507
                ? (c < 2486
                  ? (c < 2482
                    ? (c >= 2474 && c <= 2480)
                    : c <= 2482)
                  : (c <= 2489 || (c < 2503
                    ? (c >= 2492 && c <= 2500)
                    : c <= 2504)))
                : (c <= 2510 || (c < 2527
                  ? (c < 2524
                    ? c == 2519
                    : c <= 2525)
                  : (c <= 2531 || (c < 2556
                    ? (c >= 2534 && c <= 2545)
                    : c <= 2556)))))))
            : (c <= 2558 || (c < 2635
              ? (c < 2610
                ? (c < 2575
                  ? (c < 2565
                    ? (c >= 2561 && c <= 2563)
                    : c <= 2570)
                  : (c <= 2576 || (c < 2602
                    ? (c >= 2579 && c <= 2600)
                    : c <= 2608)))
                : (c <= 2611 || (c < 2620
                  ? (c < 2616
                    ? (c >= 2613 && c <= 2614)
                    : c <= 2617)
                  : (c <= 2620 || (c < 2631
                    ? (c >= 2622 && c <= 2626)
                    : c <= 2632)))))
              : (c <= 2637 || (c < 2693
                ? (c < 2654
                  ? (c < 2649
                    ? c == 2641
                    : c <= 2652)
                  : (c <= 2654 || (c < 2689
                    ? (c >= 2662 && c <= 2677)
                    : c <= 2691)))
                : (c <= 2701 || (c < 2730
                  ? (c < 2707
                    ? (c >= 2703 && c <= 2705)
                    : c <= 2728)
                  : (c <= 2736 || (c < 2741
                    ? (c >= 2738 && c <= 2739)
                    : c <= 2745)))))))))))
        : (c <= 2757 || (c < 3168
          ? (c < 2958
            ? (c < 2866
              ? (c < 2809
                ? (c < 2768
                  ? (c < 2763
                    ? (c >= 2759 && c <= 2761)
                    : c <= 2765)
                  : (c <= 2768 || (c < 2790
                    ? (c >= 2784 && c <= 2787)
                    : c <= 2799)))
                : (c <= 2815 || (c < 2831
                  ? (c < 2821
                    ? (c >= 2817 && c <= 2819)
                    : c <= 2828)
                  : (c <= 2832 || (c < 2858
                    ? (c >= 2835 && c <= 2856)
                    : c <= 2864)))))
              : (c <= 2867 || (c < 2908
                ? (c < 2887
                  ? (c < 2876
                    ? (c >= 2869 && c <= 2873)
                    : c <= 2884)
                  : (c <= 2888 || (c < 2901
                    ? (c >= 2891 && c <= 2893)
                    : c <= 2903)))
                : (c <= 2909 || (c < 2929
                  ? (c < 2918
                    ? (c >= 2911 && c <= 2915)
                    : c <= 2927)
                  : (c <= 2929 || (c < 2949
                    ? (c >= 2946 && c <= 2947)
                    : c <= 2954)))))))
            : (c <= 2960 || (c < 3031
              ? (c < 2984
                ? (c < 2972
                  ? (c < 2969
                    ? (c >= 2962 && c <= 2965)
                    : c <= 2970)
                  : (c <= 2972 || (c < 2979
                    ? (c >= 2974 && c <= 2975)
                    : c <= 2980)))
                : (c <= 2986 || (c < 3014
                  ? (c < 3006
                    ? (c >= 2990 && c <= 3001)
                    : c <= 3010)
                  : (c <= 3016 || (c < 3024
                    ? (c >= 3018 && c <= 3021)
                    : c <= 3024)))))
              : (c <= 3031 || (c < 3132
                ? (c < 3086
                  ? (c < 3072
                    ? (c >= 3046 && c <= 3055)
                    : c <= 3084)
                  : (c <= 3088 || (c < 3114
                    ? (c >= 3090 && c <= 3112)
                    : c <= 3129)))
                : (c <= 3140 || (c < 3157
                  ? (c < 3146
                    ? (c >= 3142 && c <= 3144)
                    : c <= 3149)
                  : (c <= 3158 || (c < 3165
                    ? (c >= 3160 && c <= 3162)
                    : c <= 3165)))))))))
          : (c <= 3171 || (c < 3450
            ? (c < 3293
              ? (c < 3242
                ? (c < 3205
                  ? (c < 3200
                    ? (c >= 3174 && c <= 3183)
                    : c <= 3203)
                  : (c <= 3212 || (c < 3218
                    ? (c >= 3214 && c <= 3216)
                    : c <= 3240)))
                : (c <= 3251 || (c < 3270
                  ? (c < 3260
                    ? (c >= 3253 && c <= 3257)
                    : c <= 3268)
                  : (c <= 3272 || (c < 3285
                    ? (c >= 3274 && c <= 3277)
                    : c <= 3286)))))
              : (c <= 3294 || (c < 3346
                ? (c < 3313
                  ? (c < 3302
                    ? (c >= 3296 && c <= 3299)
                    : c <= 3311)
                  : (c <= 3314 || (c < 3342
                    ? (c >= 3328 && c <= 3340)
                    : c <= 3344)))
                : (c <= 3396 || (c < 3412
                  ? (c < 3402
                    ? (c >= 3398 && c <= 3400)
                    : c <= 3406)
                  : (c <= 3415 || (c < 3430
                    ? (c >= 3423 && c <= 3427)
                    : c <= 3439)))))))
            : (c <= 3455 || (c < 3570
              ? (c < 3520
                ? (c < 3482
                  ? (c < 3461
                    ? (c >= 3457 && c <= 3459)
                    : c <= 3478)
                  : (c <= 3505 || (c < 3517
                    ? (c >= 3507 && c <= 3515)
                    : c <= 3517)))
                : (c <= 3526 || (c < 3542
                  ? (c < 3535
                    ? c == 3530
                    : c <= 3540)
                  : (c <= 3542 || (c < 3558
                    ? (c >= 3544 && c <= 3551)
                    : c <= 3567)))))
              : (c <= 3571 || (c < 3718
                ? (c < 3664
                  ? (c < 3648
                    ? (c >= 3585 && c <= 3642)
                    : c <= 3662)
                  : (c <= 3673 || (c < 3716
                    ? (c >= 3713 && c <= 3714)
                    : c <= 3716)))
                : (c <= 3722 || (c < 3751
                  ? (c < 3749
                    ? (c >= 3724 && c <= 3747)
                    : c <= 3749)
                  : (c <= 3773 || (c >= 3776 && c <= 3780)))))))))))))
      : (c <= 3782 || (c < 8025
        ? (c < 5888
          ? (c < 4688
            ? (c < 3953
              ? (c < 3872
                ? (c < 3804
                  ? (c < 3792
                    ? (c >= 3784 && c <= 3789)
                    : c <= 3801)
                  : (c <= 3807 || (c < 3864
                    ? c == 3840
                    : c <= 3865)))
                : (c <= 3881 || (c < 3897
                  ? (c < 3895
                    ? c == 3893
                    : c <= 3895)
                  : (c <= 3897 || (c < 3913
                    ? (c >= 3902 && c <= 3911)
                    : c <= 3948)))))
              : (c <= 3972 || (c < 4256
                ? (c < 4038
                  ? (c < 3993
                    ? (c >= 3974 && c <= 3991)
                    : c <= 4028)
                  : (c <= 4038 || (c < 4176
                    ? (c >= 4096 && c <= 4169)
                    : c <= 4253)))
                : (c <= 4293 || (c < 4304
                  ? (c < 4301
                    ? c == 4295
                    : c <= 4301)
                  : (c <= 4346 || (c < 4682
                    ? (c >= 4348 && c <= 4680)
                    : c <= 4685)))))))
            : (c <= 4694 || (c < 4882
              ? (c < 4786
                ? (c < 4704
                  ? (c < 4698
                    ? c == 4696
                    : c <= 4701)
                  : (c <= 4744 || (c < 4752
                    ? (c >= 4746 && c <= 4749)
                    : c <= 4784)))
                : (c <= 4789 || (c < 4802
                  ? (c < 4800
                    ? (c >= 4792 && c <= 4798)
                    : c <= 4800)
                  : (c <= 4805 || (c < 4824
                    ? (c >= 4808 && c <= 4822)
                    : c <= 4880)))))
              : (c <= 4885 || (c < 5112
                ? (c < 4969
                  ? (c < 4957
                    ? (c >= 4888 && c <= 4954)
                    : c <= 4959)
                  : (c <= 4977 || (c < 5024
                    ? (c >= 4992 && c <= 5007)
                    : c <= 5109)))
                : (c <= 5117 || (c < 5761
                  ? (c < 5743
                    ? (c >= 5121 && c <= 5740)
                    : c <= 5759)
                  : (c <= 5786 || (c < 5870
                    ? (c >= 5792 && c <= 5866)
                    : c <= 5880)))))))))
          : (c <= 5909 || (c < 6688
            ? (c < 6176
              ? (c < 6016
                ? (c < 5984
                  ? (c < 5952
                    ? (c >= 5919 && c <= 5940)
                    : c <= 5971)
                  : (c <= 5996 || (c < 6002
                    ? (c >= 5998 && c <= 6000)
                    : c <= 6003)))
                : (c <= 6099 || (c < 6112
                  ? (c < 6108
                    ? c == 6103
                    : c <= 6109)
                  : (c <= 6121 || (c < 6159
                    ? (c >= 6155 && c <= 6157)
                    : c <= 6169)))))
              : (c <= 6264 || (c < 6470
                ? (c < 6400
                  ? (c < 6320
                    ? (c >= 6272 && c <= 6314)
                    : c <= 6389)
                  : (c <= 6430 || (c < 6448
                    ? (c >= 6432 && c <= 6443)
                    : c <= 6459)))
                : (c <= 6509 || (c < 6576
                  ? (c < 6528
                    ? (c >= 6512 && c <= 6516)
                    : c <= 6571)
                  : (c <= 6601 || (c < 6656
                    ? (c >= 6608 && c <= 6618)
                    : c <= 6683)))))))
            : (c <= 6750 || (c < 7232
              ? (c < 6847
                ? (c < 6800
                  ? (c < 6783
                    ? (c >= 6752 && c <= 6780)
                    : c <= 6793)
                  : (c <= 6809 || (c < 6832
                    ? c == 6823
                    : c <= 6845)))
                : (c <= 6862 || (c < 7019
                  ? (c < 6992
                    ? (c >= 6912 && c <= 6988)
                    : c <= 7001)
                  : (c <= 7027 || (c < 7168
                    ? (c >= 7040 && c <= 7155)
                    : c <= 7223)))))
              : (c <= 7241 || (c < 7380
                ? (c < 7312
                  ? (c < 7296
                    ? (c >= 7245 && c <= 7293)
                    : c <= 7304)
                  : (c <= 7354 || (c < 7376
                    ? (c >= 7357 && c <= 7359)
                    : c <= 7378)))
                : (c <= 7418 || (c < 7968
                  ? (c < 7960
                    ? (c >= 7424 && c <= 7957)
                    : c <= 7965)
                  : (c <= 8005 || (c < 8016
                    ? (c >= 8008 && c <= 8013)
                    : c <= 8023)))))))))))
        : (c <= 8025 || (c < 11720
          ? (c < 8458
            ? (c < 8178
              ? (c < 8126
                ? (c < 8031
                  ? (c < 8029
                    ? c == 8027
                    : c <= 8029)
                  : (c <= 8061 || (c < 8118
                    ? (c >= 8064 && c <= 8116)
                    : c <= 8124)))
                : (c <= 8126 || (c < 8144
                  ? (c < 8134
                    ? (c >= 8130 && c <= 8132)
                    : c <= 8140)
                  : (c <= 8147 || (c < 8160
                    ? (c >= 8150 && c <= 8155)
                    : c <= 8172)))))
              : (c <= 8180 || (c < 8336
                ? (c < 8276
                  ? (c < 8255
                    ? (c >= 8182 && c <= 8188)
                    : c <= 8256)
                  : (c <= 8276 || (c < 8319
                    ? c == 8305
                    : c <= 8319)))
                : (c <= 8348 || (c < 8421
                  ? (c < 8417
                    ? (c >= 8400 && c <= 8412)
                    : c <= 8417)
                  : (c <= 8432 || (c < 8455
                    ? c == 8450
                    : c <= 8455)))))))
            : (c <= 8467 || (c < 11499
              ? (c < 8490
                ? (c < 8484
                  ? (c < 8472
                    ? c == 8469
                    : c <= 8477)
                  : (c <= 8484 || (c < 8488
                    ? c == 8486
                    : c <= 8488)))
                : (c <= 8505 || (c < 8526
                  ? (c < 8517
                    ? (c >= 8508 && c <= 8511)
                    : c <= 8521)
                  : (c <= 8526 || (c < 11264
                    ? (c >= 8544 && c <= 8584)
                    : c <= 11492)))))
              : (c <= 11507 || (c < 11647
                ? (c < 11565
                  ? (c < 11559
                    ? (c >= 11520 && c <= 11557)
                    : c <= 11559)
                  : (c <= 11565 || (c < 11631
                    ? (c >= 11568 && c <= 11623)
                    : c <= 11631)))
                : (c <= 11670 || (c < 11696
                  ? (c < 11688
                    ? (c >= 11680 && c <= 11686)
                    : c <= 11694)
                  : (c <= 11702 || (c < 11712
                    ? (c >= 11704 && c <= 11710)
                    : c <= 11718)))))))))
          : (c <= 11726 || (c < 42623
            ? (c < 12540
              ? (c < 12337
                ? (c < 11744
                  ? (c < 11736
                    ? (c >= 11728 && c <= 11734)
                    : c <= 11742)
                  : (c <= 11775 || (c < 12321
                    ? (c >= 12293 && c <= 12295)
                    : c <= 12335)))
                : (c <= 12341 || (c < 12441
                  ? (c < 12353
                    ? (c >= 12344 && c <= 12348)
                    : c <= 12438)
                  : (c <= 12442 || (c < 12449
                    ? (c >= 12445 && c <= 12447)
                    : c <= 12538)))))
              : (c <= 12543 || (c < 19968
                ? (c < 12704
                  ? (c < 12593
                    ? (c >= 12549 && c <= 12591)
                    : c <= 12686)
                  : (c <= 12735 || (c < 13312
                    ? (c >= 12784 && c <= 12799)
                    : c <= 19903)))
                : (c <= 42124 || (c < 42512
                  ? (c < 42240
                    ? (c >= 42192 && c <= 42237)
                    : c <= 42508)
                  : (c <= 42539 || (c < 42612
                    ? (c >= 42560 && c <= 42607)
                    : c <= 42621)))))))
            : (c <= 42737 || (c < 43232
              ? (c < 42965
                ? (c < 42891
                  ? (c < 42786
                    ? (c >= 42775 && c <= 42783)
                    : c <= 42888)
                  : (c <= 42954 || (c < 42963
                    ? (c >= 42960 && c <= 42961)
                    : c <= 42963)))
                : (c <= 42969 || (c < 43072
                  ? (c < 43052
                    ? (c >= 42994 && c <= 43047)
                    : c <= 43052)
                  : (c <= 43123 || (c < 43216
                    ? (c >= 43136 && c <= 43205)
                    : c <= 43225)))))
              : (c <= 43255 || (c < 43471
                ? (c < 43312
                  ? (c < 43261
                    ? c == 43259
                    : c <= 43309)
                  : (c <= 43347 || (c < 43392
                    ? (c >= 43360 && c <= 43388)
                    : c <= 43456)))
                : (c <= 43481 || (c < 43584
                  ? (c < 43520
                    ? (c >= 43488 && c <= 43518)
                    : c <= 43574)
                  : (c <= 43597 || (c >= 43600 && c <= 43609)))))))))))))))
    : (c <= 43638 || (c < 71453
      ? (c < 67639
        ? (c < 65345
          ? (c < 64312
            ? (c < 43888
              ? (c < 43785
                ? (c < 43744
                  ? (c < 43739
                    ? (c >= 43642 && c <= 43714)
                    : c <= 43741)
                  : (c <= 43759 || (c < 43777
                    ? (c >= 43762 && c <= 43766)
                    : c <= 43782)))
                : (c <= 43790 || (c < 43816
                  ? (c < 43808
                    ? (c >= 43793 && c <= 43798)
                    : c <= 43814)
                  : (c <= 43822 || (c < 43868
                    ? (c >= 43824 && c <= 43866)
                    : c <= 43881)))))
              : (c <= 44010 || (c < 63744
                ? (c < 44032
                  ? (c < 44016
                    ? (c >= 44012 && c <= 44013)
                    : c <= 44025)
                  : (c <= 55203 || (c < 55243
                    ? (c >= 55216 && c <= 55238)
                    : c <= 55291)))
                : (c <= 64109 || (c < 64275
                  ? (c < 64256
                    ? (c >= 64112 && c <= 64217)
                    : c <= 64262)
                  : (c <= 64279 || (c < 64298
                    ? (c >= 64285 && c <= 64296)
                    : c <= 64310)))))))
            : (c <= 64316 || (c < 65075
              ? (c < 64612
                ? (c < 64323
                  ? (c < 64320
                    ? c == 64318
                    : c <= 64321)
                  : (c <= 64324 || (c < 64467
                    ? (c >= 64326 && c <= 64433)
                    : c <= 64605)))
                : (c <= 64829 || (c < 65008
                  ? (c < 64914
                    ? (c >= 64848 && c <= 64911)
                    : c <= 64967)
                  : (c <= 65017 || (c < 65056
                    ? (c >= 65024 && c <= 65039)
                    : c <= 65071)))))
              : (c <= 65076 || (c < 65147
                ? (c < 65139
                  ? (c < 65137
                    ? (c >= 65101 && c <= 65103)
                    : c <= 65137)
                  : (c <= 65139 || (c < 65145
                    ? c == 65143
                    : c <= 65145)))
                : (c <= 65147 || (c < 65296
                  ? (c < 65151
                    ? c == 65149
                    : c <= 65276)
                  : (c <= 65305 || (c < 65343
                    ? (c >= 65313 && c <= 65338)
                    : c <= 65343)))))))))
          : (c <= 65370 || (c < 66513
            ? (c < 65664
              ? (c < 65536
                ? (c < 65482
                  ? (c < 65474
                    ? (c >= 65382 && c <= 65470)
                    : c <= 65479)
                  : (c <= 65487 || (c < 65498
                    ? (c >= 65490 && c <= 65495)
                    : c <= 65500)))
                : (c <= 65547 || (c < 65596
                  ? (c < 65576
                    ? (c >= 65549 && c <= 65574)
                    : c <= 65594)
                  : (c <= 65597 || (c < 65616
                    ? (c >= 65599 && c <= 65613)
                    : c <= 65629)))))
              : (c <= 65786 || (c < 66304
                ? (c < 66176
                  ? (c < 66045
                    ? (c >= 65856 && c <= 65908)
                    : c <= 66045)
                  : (c <= 66204 || (c < 66272
                    ? (c >= 66208 && c <= 66256)
                    : c <= 66272)))
                : (c <= 66335 || (c < 66432
                  ? (c < 66384
                    ? (c >= 66349 && c <= 66378)
                    : c <= 66426)
                  : (c <= 66461 || (c < 66504
                    ? (c >= 66464 && c <= 66499)
                    : c <= 66511)))))))
            : (c <= 66517 || (c < 66979
              ? (c < 66864
                ? (c < 66736
                  ? (c < 66720
                    ? (c >= 66560 && c <= 66717)
                    : c <= 66729)
                  : (c <= 66771 || (c < 66816
                    ? (c >= 66776 && c <= 66811)
                    : c <= 66855)))
                : (c <= 66915 || (c < 66956
                  ? (c < 66940
                    ? (c >= 66928 && c <= 66938)
                    : c <= 66954)
                  : (c <= 66962 || (c < 66967
                    ? (c >= 66964 && c <= 66965)
                    : c <= 66977)))))
              : (c <= 66993 || (c < 67456
                ? (c < 67072
                  ? (c < 67003
                    ? (c >= 66995 && c <= 67001)
                    : c <= 67004)
                  : (c <= 67382 || (c < 67424
                    ? (c >= 67392 && c <= 67413)
                    : c <= 67431)))
                : (c <= 67461 || (c < 67584
                  ? (c < 67506
                    ? (c >= 67463 && c <= 67504)
                    : c <= 67514)
                  : (c <= 67589 || (c < 67594
                    ? c == 67592
                    : c <= 67637)))))))))))
        : (c <= 67640 || (c < 69956
          ? (c < 68448
            ? (c < 68101
              ? (c < 67828
                ? (c < 67680
                  ? (c < 67647
                    ? c == 67644
                    : c <= 67669)
                  : (c <= 67702 || (c < 67808
                    ? (c >= 67712 && c <= 67742)
                    : c <= 67826)))
                : (c <= 67829 || (c < 67968
                  ? (c < 67872
                    ? (c >= 67840 && c <= 67861)
                    : c <= 67897)
                  : (c <= 68023 || (c < 68096
                    ? (c >= 68030 && c <= 68031)
                    : c <= 68099)))))
              : (c <= 68102 || (c < 68192
                ? (c < 68121
                  ? (c < 68117
                    ? (c >= 68108 && c <= 68115)
                    : c <= 68119)
                  : (c <= 68149 || (c < 68159
                    ? (c >= 68152 && c <= 68154)
                    : c <= 68159)))
                : (c <= 68220 || (c < 68297
                  ? (c < 68288
                    ? (c >= 68224 && c <= 68252)
                    : c <= 68295)
                  : (c <= 68326 || (c < 68416
                    ? (c >= 68352 && c <= 68405)
                    : c <= 68437)))))))
            : (c <= 68466 || (c < 69424
              ? (c < 68912
                ? (c < 68736
                  ? (c < 68608
                    ? (c >= 68480 && c <= 68497)
                    : c <= 68680)
                  : (c <= 68786 || (c < 68864
                    ? (c >= 68800 && c <= 68850)
                    : c <= 68903)))
                : (c <= 68921 || (c < 69296
                  ? (c < 69291
                    ? (c >= 69248 && c <= 69289)
                    : c <= 69292)
                  : (c <= 69297 || (c < 69415
                    ? (c >= 69376 && c <= 69404)
                    : c <= 69415)))))
              : (c <= 69456 || (c < 69759
                ? (c < 69600
                  ? (c < 69552
                    ? (c >= 69488 && c <= 69509)
                    : c <= 69572)
                  : (c <= 69622 || (c < 69734
                    ? (c >= 69632 && c <= 69702)
                    : c <= 69749)))
                : (c <= 69818 || (c < 69872
                  ? (c < 69840
                    ? c == 69826
                    : c <= 69864)
                  : (c <= 69881 || (c < 69942
                    ? (c >= 69888 && c <= 69940)
                    : c <= 69951)))))))))
          : (c <= 69959 || (c < 70459
            ? (c < 70282
              ? (c < 70108
                ? (c < 70016
                  ? (c < 70006
                    ? (c >= 69968 && c <= 70003)
                    : c <= 70006)
                  : (c <= 70084 || (c < 70094
                    ? (c >= 70089 && c <= 70092)
                    : c <= 70106)))
                : (c <= 70108 || (c < 70206
                  ? (c < 70163
                    ? (c >= 70144 && c <= 70161)
                    : c <= 70199)
                  : (c <= 70206 || (c < 70280
                    ? (c >= 70272 && c <= 70278)
                    : c <= 70280)))))
              : (c <= 70285 || (c < 70405
                ? (c < 70320
                  ? (c < 70303
                    ? (c >= 70287 && c <= 70301)
                    : c <= 70312)
                  : (c <= 70378 || (c < 70400
                    ? (c >= 70384 && c <= 70393)
                    : c <= 70403)))
                : (c <= 70412 || (c < 70442
                  ? (c < 70419
                    ? (c >= 70415 && c <= 70416)
                    : c <= 70440)
                  : (c <= 70448 || (c < 70453
                    ? (c >= 70450 && c <= 70451)
                    : c <= 70457)))))))
            : (c <= 70468 || (c < 70855
              ? (c < 70502
                ? (c < 70480
                  ? (c < 70475
                    ? (c >= 70471 && c <= 70472)
                    : c <= 70477)
                  : (c <= 70480 || (c < 70493
                    ? c == 70487
                    : c <= 70499)))
                : (c <= 70508 || (c < 70736
                  ? (c < 70656
                    ? (c >= 70512 && c <= 70516)
                    : c <= 70730)
                  : (c <= 70745 || (c < 70784
                    ? (c >= 70750 && c <= 70753)
                    : c <= 70853)))))
              : (c <= 70855 || (c < 71236
                ? (c < 71096
                  ? (c < 71040
                    ? (c >= 70864 && c <= 70873)
                    : c <= 71093)
                  : (c <= 71104 || (c < 71168
                    ? (c >= 71128 && c <= 71133)
                    : c <= 71232)))
                : (c <= 71236 || (c < 71360
                  ? (c < 71296
                    ? (c >= 71248 && c <= 71257)
                    : c <= 71352)
                  : (c <= 71369 || (c >= 71424 && c <= 71450)))))))))))))
      : (c <= 71467 || (c < 119973
        ? (c < 77824
          ? (c < 72760
            ? (c < 72016
              ? (c < 71945
                ? (c < 71680
                  ? (c < 71488
                    ? (c >= 71472 && c <= 71481)
                    : c <= 71494)
                  : (c <= 71738 || (c < 71935
                    ? (c >= 71840 && c <= 71913)
                    : c <= 71942)))
                : (c <= 71945 || (c < 71960
                  ? (c < 71957
                    ? (c >= 71948 && c <= 71955)
                    : c <= 71958)
                  : (c <= 71989 || (c < 71995
                    ? (c >= 71991 && c <= 71992)
                    : c <= 72003)))))
              : (c <= 72025 || (c < 72263
                ? (c < 72154
                  ? (c < 72106
                    ? (c >= 72096 && c <= 72103)
                    : c <= 72151)
                  : (c <= 72161 || (c < 72192
                    ? (c >= 72163 && c <= 72164)
                    : c <= 72254)))
                : (c <= 72263 || (c < 72368
                  ? (c < 72349
                    ? (c >= 72272 && c <= 72345)
                    : c <= 72349)
                  : (c <= 72440 || (c < 72714
                    ? (c >= 72704 && c <= 72712)
                    : c <= 72758)))))))
            : (c <= 72768 || (c < 73056
              ? (c < 72968
                ? (c < 72850
                  ? (c < 72818
                    ? (c >= 72784 && c <= 72793)
                    : c <= 72847)
                  : (c <= 72871 || (c < 72960
                    ? (c >= 72873 && c <= 72886)
                    : c <= 72966)))
                : (c <= 72969 || (c < 73020
                  ? (c < 73018
                    ? (c >= 72971 && c <= 73014)
                    : c <= 73018)
                  : (c <= 73021 || (c < 73040
                    ? (c >= 73023 && c <= 73031)
                    : c <= 73049)))))
              : (c <= 73061 || (c < 73440
                ? (c < 73104
                  ? (c < 73066
                    ? (c >= 73063 && c <= 73064)
                    : c <= 73102)
                  : (c <= 73105 || (c < 73120
                    ? (c >= 73107 && c <= 73112)
                    : c <= 73129)))
                : (c <= 73462 || (c < 74752
                  ? (c < 73728
                    ? c == 73648
                    : c <= 74649)
                  : (c <= 74862 || (c < 77712
                    ? (c >= 74880 && c <= 75075)
                    : c <= 77808)))))))))
          : (c <= 78894 || (c < 110576
            ? (c < 93027
              ? (c < 92864
                ? (c < 92736
                  ? (c < 92160
                    ? (c >= 82944 && c <= 83526)
                    : c <= 92728)
                  : (c <= 92766 || (c < 92784
                    ? (c >= 92768 && c <= 92777)
                    : c <= 92862)))
                : (c <= 92873 || (c < 92928
                  ? (c < 92912
                    ? (c >= 92880 && c <= 92909)
                    : c <= 92916)
                  : (c <= 92982 || (c < 93008
                    ? (c >= 92992 && c <= 92995)
                    : c <= 93017)))))
              : (c <= 93047 || (c < 94176
                ? (c < 93952
                  ? (c < 93760
                    ? (c >= 93053 && c <= 93071)
                    : c <= 93823)
                  : (c <= 94026 || (c < 94095
                    ? (c >= 94031 && c <= 94087)
                    : c <= 94111)))
                : (c <= 94177 || (c < 94208
                  ? (c < 94192
                    ? (c >= 94179 && c <= 94180)
                    : c <= 94193)
                  : (c <= 100343 || (c < 101632
                    ? (c >= 100352 && c <= 101589)
                    : c <= 101640)))))))
            : (c <= 110579 || (c < 118528
              ? (c < 110960
                ? (c < 110592
                  ? (c < 110589
                    ? (c >= 110581 && c <= 110587)
                    : c <= 110590)
                  : (c <= 110882 || (c < 110948
                    ? (c >= 110928 && c <= 110930)
                    : c <= 110951)))
                : (c <= 111355 || (c < 113792
                  ? (c < 113776
                    ? (c >= 113664 && c <= 113770)
                    : c <= 113788)
                  : (c <= 113800 || (c < 113821
                    ? (c >= 113808 && c <= 113817)
                    : c <= 113822)))))
              : (c <= 118573 || (c < 119210
                ? (c < 119149
                  ? (c < 119141
                    ? (c >= 118576 && c <= 118598)
                    : c <= 119145)
                  : (c <= 119154 || (c < 119173
                    ? (c >= 119163 && c <= 119170)
                    : c <= 119179)))
                : (c <= 119213 || (c < 119894
                  ? (c < 119808
                    ? (c >= 119362 && c <= 119364)
                    : c <= 119892)
                  : (c <= 119964 || (c < 119970
                    ? (c >= 119966 && c <= 119967)
                    : c <= 119970)))))))))))
        : (c <= 119974 || (c < 124912
          ? (c < 120746
            ? (c < 120134
              ? (c < 120071
                ? (c < 119995
                  ? (c < 119982
                    ? (c >= 119977 && c <= 119980)
                    : c <= 119993)
                  : (c <= 119995 || (c < 120005
                    ? (c >= 119997 && c <= 120003)
                    : c <= 120069)))
                : (c <= 120074 || (c < 120094
                  ? (c < 120086
                    ? (c >= 120077 && c <= 120084)
                    : c <= 120092)
                  : (c <= 120121 || (c < 120128
                    ? (c >= 120123 && c <= 120126)
                    : c <= 120132)))))
              : (c <= 120134 || (c < 120572
                ? (c < 120488
                  ? (c < 120146
                    ? (c >= 120138 && c <= 120144)
                    : c <= 120485)
                  : (c <= 120512 || (c < 120540
                    ? (c >= 120514 && c <= 120538)
                    : c <= 120570)))
                : (c <= 120596 || (c < 120656
                  ? (c < 120630
                    ? (c >= 120598 && c <= 120628)
                    : c <= 120654)
                  : (c <= 120686 || (c < 120714
                    ? (c >= 120688 && c <= 120712)
                    : c <= 120744)))))))
            : (c <= 120770 || (c < 122907
              ? (c < 121476
                ? (c < 121344
                  ? (c < 120782
                    ? (c >= 120772 && c <= 120779)
                    : c <= 120831)
                  : (c <= 121398 || (c < 121461
                    ? (c >= 121403 && c <= 121452)
                    : c <= 121461)))
                : (c <= 121476 || (c < 122624
                  ? (c < 121505
                    ? (c >= 121499 && c <= 121503)
                    : c <= 121519)
                  : (c <= 122654 || (c < 122888
                    ? (c >= 122880 && c <= 122886)
                    : c <= 122904)))))
              : (c <= 122913 || (c < 123214
                ? (c < 123136
                  ? (c < 122918
                    ? (c >= 122915 && c <= 122916)
                    : c <= 122922)
                  : (c <= 123180 || (c < 123200
                    ? (c >= 123184 && c <= 123197)
                    : c <= 123209)))
                : (c <= 123214 || (c < 124896
                  ? (c < 123584
                    ? (c >= 123536 && c <= 123566)
                    : c <= 123641)
                  : (c <= 124902 || (c < 124909
                    ? (c >= 124904 && c <= 124907)
                    : c <= 124910)))))))))
          : (c <= 124926 || (c < 126557
            ? (c < 126521
              ? (c < 126469
                ? (c < 125184
                  ? (c < 125136
                    ? (c >= 124928 && c <= 125124)
                    : c <= 125142)
                  : (c <= 125259 || (c < 126464
                    ? (c >= 125264 && c <= 125273)
                    : c <= 126467)))
                : (c <= 126495 || (c < 126503
                  ? (c < 126500
                    ? (c >= 126497 && c <= 126498)
                    : c <= 126500)
                  : (c <= 126503 || (c < 126516
                    ? (c >= 126505 && c <= 126514)
                    : c <= 126519)))))
              : (c <= 126521 || (c < 126541
                ? (c < 126535
                  ? (c < 126530
                    ? c == 126523
                    : c <= 126530)
                  : (c <= 126535 || (c < 126539
                    ? c == 126537
                    : c <= 126539)))
                : (c <= 126543 || (c < 126551
                  ? (c < 126548
                    ? (c >= 126545 && c <= 126546)
                    : c <= 126548)
                  : (c <= 126551 || (c < 126555
                    ? c == 126553
                    : c <= 126555)))))))
            : (c <= 126557 || (c < 126629
              ? (c < 126580
                ? (c < 126564
                  ? (c < 126561
                    ? c == 126559
                    : c <= 126562)
                  : (c <= 126564 || (c < 126572
                    ? (c >= 126567 && c <= 126570)
                    : c <= 126578)))
                : (c <= 126583 || (c < 126592
                  ? (c < 126590
                    ? (c >= 126585 && c <= 126588)
                    : c <= 126590)
                  : (c <= 126601 || (c < 126625
                    ? (c >= 126603 && c <= 126619)
                    : c <= 126627)))))
              : (c <= 126633 || (c < 178208
                ? (c < 131072
                  ? (c < 130032
                    ? (c >= 126635 && c <= 126651)
                    : c <= 130041)
                  : (c <= 173791 || (c < 177984
                    ? (c >= 173824 && c <= 177976)
                    : c <= 178205)))
                : (c <= 183969 || (c < 196608
                  ? (c < 194560
                    ? (c >= 183984 && c <= 191456)
                    : c <= 195101)
                  : (c <= 201546 || (c >= 917760 && c <= 917999)))))))))))))))));
}

static bool ts_lex(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (eof) ADVANCE(65);
      if (lookahead == '!') ADVANCE(22);
      if (lookahead == '#') ADVANCE(165);
      if (lookahead == '%') ADVANCE(98);
      if (lookahead == '&') ADVANCE(100);
      if (lookahead == '(') ADVANCE(68);
      if (lookahead == ')') ADVANCE(69);
      if (lookahead == '*') ADVANCE(71);
      if (lookahead == '+') ADVANCE(85);
      if (lookahead == ',') ADVANCE(70);
      if (lookahead == '-') ADVANCE(83);
      if (lookahead == '.') ADVANCE(67);
      if (lookahead == '/') ADVANCE(96);
      if (lookahead == '0') ADVANCE(138);
      if (lookahead == ':') ADVANCE(76);
      if (lookahead == ';') ADVANCE(166);
      if (lookahead == '<') ADVANCE(104);
      if (lookahead == '=') ADVANCE(92);
      if (lookahead == '>') ADVANCE(110);
      if (lookahead == '@') ADVANCE(95);
      if (lookahead == '[') ADVANCE(86);
      if (lookahead == '\\') SKIP(54)
      if (lookahead == ']') ADVANCE(87);
      if (lookahead == '^') ADVANCE(101);
      if (lookahead == 'e') ADVANCE(161);
      if (lookahead == '{') ADVANCE(127);
      if (lookahead == '|') ADVANCE(80);
      if (lookahead == '}') ADVANCE(89);
      if (lookahead == '~') ADVANCE(103);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\f' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(61)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(137);
      if (sym_identifier_character_set_1(lookahead)) ADVANCE(164);
      END_STATE();
    case 1:
      if (lookahead == '\n') SKIP(16)
      END_STATE();
    case 2:
      if (lookahead == '\n') SKIP(16)
      if (lookahead == '\r') SKIP(1)
      END_STATE();
    case 3:
      if (lookahead == '\n') SKIP(15)
      END_STATE();
    case 4:
      if (lookahead == '\n') SKIP(15)
      if (lookahead == '\r') SKIP(3)
      END_STATE();
    case 5:
      if (lookahead == '\n') SKIP(19)
      END_STATE();
    case 6:
      if (lookahead == '\n') SKIP(19)
      if (lookahead == '\r') SKIP(5)
      END_STATE();
    case 7:
      if (lookahead == '\n') ADVANCE(130);
      END_STATE();
    case 8:
      if (lookahead == '\n') SKIP(9)
      if (lookahead == '#') ADVANCE(134);
      if (lookahead == '\\') ADVANCE(132);
      if (lookahead == '{') ADVANCE(127);
      if (lookahead == '}') ADVANCE(89);
      if (lookahead == '\t' ||
          lookahead == '\f' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) ADVANCE(133);
      if (lookahead != 0) ADVANCE(134);
      END_STATE();
    case 9:
      if (lookahead == '\n') SKIP(9)
      if (lookahead == '#') ADVANCE(134);
      if (lookahead == '\\') ADVANCE(132);
      if (lookahead == '}') ADVANCE(89);
      if (lookahead == '\t' ||
          lookahead == '\f' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) ADVANCE(133);
      if (lookahead != 0 &&
          lookahead != '{') ADVANCE(134);
      END_STATE();
    case 10:
      if (lookahead == '\n') SKIP(17)
      END_STATE();
    case 11:
      if (lookahead == '\n') SKIP(17)
      if (lookahead == '\r') SKIP(10)
      END_STATE();
    case 12:
      if (lookahead == '\n') SKIP(14)
      END_STATE();
    case 13:
      if (lookahead == '\n') SKIP(14)
      if (lookahead == '\r') SKIP(12)
      END_STATE();
    case 14:
      if (lookahead == '!') ADVANCE(22);
      if (lookahead == '#') ADVANCE(165);
      if (lookahead == '%') ADVANCE(98);
      if (lookahead == '&') ADVANCE(100);
      if (lookahead == '(') ADVANCE(68);
      if (lookahead == ')') ADVANCE(69);
      if (lookahead == '*') ADVANCE(71);
      if (lookahead == '+') ADVANCE(85);
      if (lookahead == ',') ADVANCE(70);
      if (lookahead == '-') ADVANCE(82);
      if (lookahead == '.') ADVANCE(66);
      if (lookahead == '/') ADVANCE(96);
      if (lookahead == ':') ADVANCE(76);
      if (lookahead == ';') ADVANCE(166);
      if (lookahead == '<') ADVANCE(104);
      if (lookahead == '=') ADVANCE(92);
      if (lookahead == '>') ADVANCE(110);
      if (lookahead == '@') ADVANCE(95);
      if (lookahead == '[') ADVANCE(86);
      if (lookahead == '\\') SKIP(13)
      if (lookahead == ']') ADVANCE(87);
      if (lookahead == '^') ADVANCE(101);
      if (lookahead == '|') ADVANCE(80);
      if (lookahead == '}') ADVANCE(89);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\f' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(14)
      if (sym_identifier_character_set_1(lookahead)) ADVANCE(164);
      END_STATE();
    case 15:
      if (lookahead == '!') ADVANCE(22);
      if (lookahead == '#') ADVANCE(165);
      if (lookahead == '%') ADVANCE(98);
      if (lookahead == '&') ADVANCE(100);
      if (lookahead == '(') ADVANCE(68);
      if (lookahead == ')') ADVANCE(69);
      if (lookahead == '*') ADVANCE(71);
      if (lookahead == '+') ADVANCE(85);
      if (lookahead == ',') ADVANCE(70);
      if (lookahead == '-') ADVANCE(82);
      if (lookahead == '.') ADVANCE(66);
      if (lookahead == '/') ADVANCE(96);
      if (lookahead == ':') ADVANCE(75);
      if (lookahead == ';') ADVANCE(166);
      if (lookahead == '<') ADVANCE(104);
      if (lookahead == '=') ADVANCE(92);
      if (lookahead == '>') ADVANCE(110);
      if (lookahead == '@') ADVANCE(95);
      if (lookahead == '[') ADVANCE(86);
      if (lookahead == '\\') SKIP(4)
      if (lookahead == ']') ADVANCE(87);
      if (lookahead == '^') ADVANCE(101);
      if (lookahead == '|') ADVANCE(80);
      if (lookahead == '}') ADVANCE(89);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\f' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(15)
      if (sym_identifier_character_set_1(lookahead)) ADVANCE(164);
      END_STATE();
    case 16:
      if (lookahead == '!') ADVANCE(22);
      if (lookahead == '#') ADVANCE(165);
      if (lookahead == '%') ADVANCE(23);
      if (lookahead == '&') ADVANCE(24);
      if (lookahead == '(') ADVANCE(68);
      if (lookahead == ')') ADVANCE(69);
      if (lookahead == '*') ADVANCE(71);
      if (lookahead == '+') ADVANCE(85);
      if (lookahead == ',') ADVANCE(70);
      if (lookahead == '-') ADVANCE(82);
      if (lookahead == '.') ADVANCE(20);
      if (lookahead == '/') ADVANCE(97);
      if (lookahead == '0') ADVANCE(138);
      if (lookahead == ':') ADVANCE(75);
      if (lookahead == '<') ADVANCE(105);
      if (lookahead == '=') ADVANCE(92);
      if (lookahead == '>') ADVANCE(111);
      if (lookahead == '@') ADVANCE(25);
      if (lookahead == '[') ADVANCE(86);
      if (lookahead == '\\') SKIP(2)
      if (lookahead == ']') ADVANCE(87);
      if (lookahead == '^') ADVANCE(26);
      if (lookahead == '{') ADVANCE(88);
      if (lookahead == '|') ADVANCE(80);
      if (lookahead == '}') ADVANCE(89);
      if (lookahead == '~') ADVANCE(103);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\f' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(16)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(137);
      if (sym_identifier_character_set_1(lookahead)) ADVANCE(164);
      END_STATE();
    case 17:
      if (lookahead == '#') ADVANCE(165);
      if (lookahead == '-') ADVANCE(30);
      if (lookahead == ':') ADVANCE(75);
      if (lookahead == '\\') SKIP(11)
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\f' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(17)
      END_STATE();
    case 18:
      if (lookahead == '#') ADVANCE(165);
      if (lookahead == '\\') ADVANCE(131);
      if (lookahead == '{') ADVANCE(128);
      if (lookahead == '}') ADVANCE(36);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\f' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(19)
      END_STATE();
    case 19:
      if (lookahead == '#') ADVANCE(165);
      if (lookahead == '\\') SKIP(6)
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\f' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(19)
      END_STATE();
    case 20:
      if (lookahead == '.') ADVANCE(21);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(144);
      END_STATE();
    case 21:
      if (lookahead == '.') ADVANCE(126);
      END_STATE();
    case 22:
      if (lookahead == '=') ADVANCE(108);
      if (('a' <= lookahead && lookahead <= 'z')) ADVANCE(135);
      END_STATE();
    case 23:
      if (lookahead == '=') ADVANCE(119);
      END_STATE();
    case 24:
      if (lookahead == '=') ADVANCE(123);
      END_STATE();
    case 25:
      if (lookahead == '=') ADVANCE(117);
      END_STATE();
    case 26:
      if (lookahead == '=') ADVANCE(124);
      END_STATE();
    case 27:
      if (lookahead == '=') ADVANCE(118);
      END_STATE();
    case 28:
      if (lookahead == '=') ADVANCE(122);
      END_STATE();
    case 29:
      if (lookahead == '=') ADVANCE(121);
      END_STATE();
    case 30:
      if (lookahead == '>') ADVANCE(93);
      END_STATE();
    case 31:
      if (lookahead == '_') ADVANCE(38);
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(140);
      END_STATE();
    case 32:
      if (lookahead == '_') ADVANCE(39);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(141);
      END_STATE();
    case 33:
      if (lookahead == '_') ADVANCE(43);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(142);
      END_STATE();
    case 34:
      if (lookahead == '{') ADVANCE(52);
      END_STATE();
    case 35:
      if (lookahead == '}') ADVANCE(130);
      if (lookahead != 0) ADVANCE(35);
      END_STATE();
    case 36:
      if (lookahead == '}') ADVANCE(129);
      END_STATE();
    case 37:
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(40);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(145);
      END_STATE();
    case 38:
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(140);
      END_STATE();
    case 39:
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(141);
      END_STATE();
    case 40:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(145);
      END_STATE();
    case 41:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(130);
      END_STATE();
    case 42:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(41);
      END_STATE();
    case 43:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(142);
      END_STATE();
    case 44:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(130);
      END_STATE();
    case 45:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(44);
      END_STATE();
    case 46:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(45);
      END_STATE();
    case 47:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(46);
      END_STATE();
    case 48:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(47);
      END_STATE();
    case 49:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(48);
      END_STATE();
    case 50:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(49);
      END_STATE();
    case 51:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(50);
      END_STATE();
    case 52:
      if (lookahead != 0 &&
          lookahead != '}') ADVANCE(35);
      END_STATE();
    case 53:
      if (eof) ADVANCE(65);
      if (lookahead == '\n') SKIP(61)
      END_STATE();
    case 54:
      if (eof) ADVANCE(65);
      if (lookahead == '\n') SKIP(61)
      if (lookahead == '\r') SKIP(53)
      END_STATE();
    case 55:
      if (eof) ADVANCE(65);
      if (lookahead == '\n') SKIP(62)
      END_STATE();
    case 56:
      if (eof) ADVANCE(65);
      if (lookahead == '\n') SKIP(62)
      if (lookahead == '\r') SKIP(55)
      END_STATE();
    case 57:
      if (eof) ADVANCE(65);
      if (lookahead == '\n') SKIP(63)
      END_STATE();
    case 58:
      if (eof) ADVANCE(65);
      if (lookahead == '\n') SKIP(63)
      if (lookahead == '\r') SKIP(57)
      END_STATE();
    case 59:
      if (eof) ADVANCE(65);
      if (lookahead == '\n') SKIP(64)
      END_STATE();
    case 60:
      if (eof) ADVANCE(65);
      if (lookahead == '\n') SKIP(64)
      if (lookahead == '\r') SKIP(59)
      END_STATE();
    case 61:
      if (eof) ADVANCE(65);
      if (lookahead == '!') ADVANCE(22);
      if (lookahead == '#') ADVANCE(165);
      if (lookahead == '%') ADVANCE(98);
      if (lookahead == '&') ADVANCE(100);
      if (lookahead == '(') ADVANCE(68);
      if (lookahead == ')') ADVANCE(69);
      if (lookahead == '*') ADVANCE(71);
      if (lookahead == '+') ADVANCE(85);
      if (lookahead == ',') ADVANCE(70);
      if (lookahead == '-') ADVANCE(83);
      if (lookahead == '.') ADVANCE(67);
      if (lookahead == '/') ADVANCE(96);
      if (lookahead == '0') ADVANCE(138);
      if (lookahead == ':') ADVANCE(76);
      if (lookahead == ';') ADVANCE(166);
      if (lookahead == '<') ADVANCE(104);
      if (lookahead == '=') ADVANCE(92);
      if (lookahead == '>') ADVANCE(110);
      if (lookahead == '@') ADVANCE(95);
      if (lookahead == '[') ADVANCE(86);
      if (lookahead == '\\') SKIP(54)
      if (lookahead == ']') ADVANCE(87);
      if (lookahead == '^') ADVANCE(101);
      if (lookahead == 'e') ADVANCE(161);
      if (lookahead == '{') ADVANCE(88);
      if (lookahead == '|') ADVANCE(80);
      if (lookahead == '}') ADVANCE(89);
      if (lookahead == '~') ADVANCE(103);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\f' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(61)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(137);
      if (sym_identifier_character_set_1(lookahead)) ADVANCE(164);
      END_STATE();
    case 62:
      if (eof) ADVANCE(65);
      if (lookahead == '!') ADVANCE(22);
      if (lookahead == '#') ADVANCE(165);
      if (lookahead == '%') ADVANCE(98);
      if (lookahead == '&') ADVANCE(100);
      if (lookahead == '(') ADVANCE(68);
      if (lookahead == ')') ADVANCE(69);
      if (lookahead == '*') ADVANCE(71);
      if (lookahead == '+') ADVANCE(85);
      if (lookahead == ',') ADVANCE(70);
      if (lookahead == '-') ADVANCE(82);
      if (lookahead == '.') ADVANCE(67);
      if (lookahead == '/') ADVANCE(96);
      if (lookahead == '0') ADVANCE(138);
      if (lookahead == ':') ADVANCE(76);
      if (lookahead == ';') ADVANCE(166);
      if (lookahead == '<') ADVANCE(104);
      if (lookahead == '=') ADVANCE(92);
      if (lookahead == '>') ADVANCE(110);
      if (lookahead == '@') ADVANCE(95);
      if (lookahead == '[') ADVANCE(86);
      if (lookahead == '\\') SKIP(56)
      if (lookahead == ']') ADVANCE(87);
      if (lookahead == '^') ADVANCE(101);
      if (lookahead == '{') ADVANCE(88);
      if (lookahead == '|') ADVANCE(80);
      if (lookahead == '}') ADVANCE(89);
      if (lookahead == '~') ADVANCE(103);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\f' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(62)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(137);
      if (sym_identifier_character_set_1(lookahead)) ADVANCE(164);
      END_STATE();
    case 63:
      if (eof) ADVANCE(65);
      if (lookahead == '#') ADVANCE(165);
      if (lookahead == '(') ADVANCE(68);
      if (lookahead == '*') ADVANCE(72);
      if (lookahead == '+') ADVANCE(84);
      if (lookahead == '-') ADVANCE(81);
      if (lookahead == '.') ADVANCE(20);
      if (lookahead == '0') ADVANCE(138);
      if (lookahead == '@') ADVANCE(94);
      if (lookahead == '[') ADVANCE(86);
      if (lookahead == '\\') SKIP(58)
      if (lookahead == 'e') ADVANCE(162);
      if (lookahead == '{') ADVANCE(88);
      if (lookahead == '~') ADVANCE(103);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\f' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(63)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(137);
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(164);
      END_STATE();
    case 64:
      if (eof) ADVANCE(65);
      if (lookahead == '#') ADVANCE(165);
      if (lookahead == '(') ADVANCE(68);
      if (lookahead == '*') ADVANCE(72);
      if (lookahead == '+') ADVANCE(84);
      if (lookahead == '-') ADVANCE(81);
      if (lookahead == '.') ADVANCE(20);
      if (lookahead == '0') ADVANCE(138);
      if (lookahead == '@') ADVANCE(94);
      if (lookahead == '[') ADVANCE(86);
      if (lookahead == '\\') SKIP(60)
      if (lookahead == 'e') ADVANCE(163);
      if (lookahead == '{') ADVANCE(88);
      if (lookahead == '~') ADVANCE(103);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\f' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(64)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(137);
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(164);
      END_STATE();
    case 65:
      ACCEPT_TOKEN(ts_builtin_sym_end);
      END_STATE();
    case 66:
      ACCEPT_TOKEN(anon_sym_DOT);
      END_STATE();
    case 67:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == '.') ADVANCE(21);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(144);
      END_STATE();
    case 68:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      END_STATE();
    case 69:
      ACCEPT_TOKEN(anon_sym_RPAREN);
      END_STATE();
    case 70:
      ACCEPT_TOKEN(anon_sym_COMMA);
      END_STATE();
    case 71:
      ACCEPT_TOKEN(anon_sym_STAR);
      if (lookahead == '*') ADVANCE(91);
      if (lookahead == '=') ADVANCE(115);
      END_STATE();
    case 72:
      ACCEPT_TOKEN(anon_sym_STAR);
      if (lookahead == '*') ADVANCE(90);
      END_STATE();
    case 73:
      ACCEPT_TOKEN(anon_sym_GT_GT);
      if (lookahead == '=') ADVANCE(121);
      END_STATE();
    case 74:
      ACCEPT_TOKEN(anon_sym_COLON_EQ);
      END_STATE();
    case 75:
      ACCEPT_TOKEN(anon_sym_COLON);
      END_STATE();
    case 76:
      ACCEPT_TOKEN(anon_sym_COLON);
      if (lookahead == '=') ADVANCE(74);
      END_STATE();
    case 77:
      ACCEPT_TOKEN(anon_sym_except);
      if (lookahead == '*') ADVANCE(79);
      if (sym_identifier_character_set_3(lookahead)) ADVANCE(164);
      END_STATE();
    case 78:
      ACCEPT_TOKEN(anon_sym_except);
      if (sym_identifier_character_set_3(lookahead)) ADVANCE(164);
      END_STATE();
    case 79:
      ACCEPT_TOKEN(anon_sym_except_STAR);
      END_STATE();
    case 80:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '=') ADVANCE(125);
      END_STATE();
    case 81:
      ACCEPT_TOKEN(anon_sym_DASH);
      END_STATE();
    case 82:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '=') ADVANCE(114);
      END_STATE();
    case 83:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '=') ADVANCE(114);
      if (lookahead == '>') ADVANCE(93);
      END_STATE();
    case 84:
      ACCEPT_TOKEN(anon_sym_PLUS);
      END_STATE();
    case 85:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '=') ADVANCE(113);
      END_STATE();
    case 86:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      END_STATE();
    case 87:
      ACCEPT_TOKEN(anon_sym_RBRACK);
      END_STATE();
    case 88:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      END_STATE();
    case 89:
      ACCEPT_TOKEN(anon_sym_RBRACE);
      END_STATE();
    case 90:
      ACCEPT_TOKEN(anon_sym_STAR_STAR);
      END_STATE();
    case 91:
      ACCEPT_TOKEN(anon_sym_STAR_STAR);
      if (lookahead == '=') ADVANCE(120);
      END_STATE();
    case 92:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '=') ADVANCE(107);
      END_STATE();
    case 93:
      ACCEPT_TOKEN(anon_sym_DASH_GT);
      END_STATE();
    case 94:
      ACCEPT_TOKEN(anon_sym_AT);
      END_STATE();
    case 95:
      ACCEPT_TOKEN(anon_sym_AT);
      if (lookahead == '=') ADVANCE(117);
      END_STATE();
    case 96:
      ACCEPT_TOKEN(anon_sym_SLASH);
      if (lookahead == '/') ADVANCE(99);
      if (lookahead == '=') ADVANCE(116);
      END_STATE();
    case 97:
      ACCEPT_TOKEN(anon_sym_SLASH);
      if (lookahead == '/') ADVANCE(27);
      if (lookahead == '=') ADVANCE(116);
      END_STATE();
    case 98:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      if (lookahead == '=') ADVANCE(119);
      END_STATE();
    case 99:
      ACCEPT_TOKEN(anon_sym_SLASH_SLASH);
      if (lookahead == '=') ADVANCE(118);
      END_STATE();
    case 100:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '=') ADVANCE(123);
      END_STATE();
    case 101:
      ACCEPT_TOKEN(anon_sym_CARET);
      if (lookahead == '=') ADVANCE(124);
      END_STATE();
    case 102:
      ACCEPT_TOKEN(anon_sym_LT_LT);
      if (lookahead == '=') ADVANCE(122);
      END_STATE();
    case 103:
      ACCEPT_TOKEN(anon_sym_TILDE);
      END_STATE();
    case 104:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<') ADVANCE(102);
      if (lookahead == '=') ADVANCE(106);
      if (lookahead == '>') ADVANCE(112);
      END_STATE();
    case 105:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<') ADVANCE(28);
      if (lookahead == '=') ADVANCE(106);
      if (lookahead == '>') ADVANCE(112);
      END_STATE();
    case 106:
      ACCEPT_TOKEN(anon_sym_LT_EQ);
      END_STATE();
    case 107:
      ACCEPT_TOKEN(anon_sym_EQ_EQ);
      END_STATE();
    case 108:
      ACCEPT_TOKEN(anon_sym_BANG_EQ);
      END_STATE();
    case 109:
      ACCEPT_TOKEN(anon_sym_GT_EQ);
      END_STATE();
    case 110:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=') ADVANCE(109);
      if (lookahead == '>') ADVANCE(73);
      END_STATE();
    case 111:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=') ADVANCE(109);
      if (lookahead == '>') ADVANCE(29);
      END_STATE();
    case 112:
      ACCEPT_TOKEN(anon_sym_LT_GT);
      END_STATE();
    case 113:
      ACCEPT_TOKEN(anon_sym_PLUS_EQ);
      END_STATE();
    case 114:
      ACCEPT_TOKEN(anon_sym_DASH_EQ);
      END_STATE();
    case 115:
      ACCEPT_TOKEN(anon_sym_STAR_EQ);
      END_STATE();
    case 116:
      ACCEPT_TOKEN(anon_sym_SLASH_EQ);
      END_STATE();
    case 117:
      ACCEPT_TOKEN(anon_sym_AT_EQ);
      END_STATE();
    case 118:
      ACCEPT_TOKEN(anon_sym_SLASH_SLASH_EQ);
      END_STATE();
    case 119:
      ACCEPT_TOKEN(anon_sym_PERCENT_EQ);
      END_STATE();
    case 120:
      ACCEPT_TOKEN(anon_sym_STAR_STAR_EQ);
      END_STATE();
    case 121:
      ACCEPT_TOKEN(anon_sym_GT_GT_EQ);
      END_STATE();
    case 122:
      ACCEPT_TOKEN(anon_sym_LT_LT_EQ);
      END_STATE();
    case 123:
      ACCEPT_TOKEN(anon_sym_AMP_EQ);
      END_STATE();
    case 124:
      ACCEPT_TOKEN(anon_sym_CARET_EQ);
      END_STATE();
    case 125:
      ACCEPT_TOKEN(anon_sym_PIPE_EQ);
      END_STATE();
    case 126:
      ACCEPT_TOKEN(sym_ellipsis);
      END_STATE();
    case 127:
      ACCEPT_TOKEN(anon_sym_LBRACE2);
      END_STATE();
    case 128:
      ACCEPT_TOKEN(anon_sym_LBRACE2);
      if (lookahead == '{') ADVANCE(129);
      END_STATE();
    case 129:
      ACCEPT_TOKEN(sym__escape_interpolation);
      END_STATE();
    case 130:
      ACCEPT_TOKEN(sym_escape_sequence);
      END_STATE();
    case 131:
      ACCEPT_TOKEN(sym__not_escape_sequence);
      if (lookahead == '\n') ADVANCE(130);
      if (lookahead == '\r') ADVANCE(7);
      if (lookahead == 'N') ADVANCE(34);
      if (lookahead == 'U') ADVANCE(51);
      if (lookahead == 'u') ADVANCE(47);
      if (lookahead == 'x') ADVANCE(45);
      if (lookahead == '"' ||
          lookahead == '\'' ||
          lookahead == '\\' ||
          lookahead == 'a' ||
          lookahead == 'b' ||
          lookahead == 'f' ||
          lookahead == 'n' ||
          lookahead == 'r' ||
          ('t' <= lookahead && lookahead <= 'v')) ADVANCE(130);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(42);
      END_STATE();
    case 132:
      ACCEPT_TOKEN(aux_sym_format_specifier_token1);
      if (lookahead == '\r') ADVANCE(134);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(134);
      END_STATE();
    case 133:
      ACCEPT_TOKEN(aux_sym_format_specifier_token1);
      if (lookahead == '#') ADVANCE(134);
      if (lookahead == '\\') ADVANCE(132);
      if (lookahead == '\t' ||
          lookahead == '\f' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) ADVANCE(133);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(134);
      END_STATE();
    case 134:
      ACCEPT_TOKEN(aux_sym_format_specifier_token1);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(134);
      END_STATE();
    case 135:
      ACCEPT_TOKEN(sym_type_conversion);
      END_STATE();
    case 136:
      ACCEPT_TOKEN(sym_integer);
      END_STATE();
    case 137:
      ACCEPT_TOKEN(sym_integer);
      if (lookahead == '.') ADVANCE(146);
      if (lookahead == '_') ADVANCE(139);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(37);
      if (lookahead == 'J' ||
          lookahead == 'L' ||
          lookahead == 'j' ||
          lookahead == 'l') ADVANCE(136);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(137);
      END_STATE();
    case 138:
      ACCEPT_TOKEN(sym_integer);
      if (lookahead == '.') ADVANCE(146);
      if (lookahead == 'B' ||
          lookahead == 'b') ADVANCE(31);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(32);
      if (lookahead == 'X' ||
          lookahead == 'x') ADVANCE(33);
      if (lookahead == '_') ADVANCE(139);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(37);
      if (lookahead == 'J' ||
          lookahead == 'L' ||
          lookahead == 'j' ||
          lookahead == 'l') ADVANCE(136);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(137);
      END_STATE();
    case 139:
      ACCEPT_TOKEN(sym_integer);
      if (lookahead == '.') ADVANCE(146);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(37);
      if (lookahead == 'J' ||
          lookahead == 'L' ||
          lookahead == 'j' ||
          lookahead == 'l') ADVANCE(136);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(137);
      END_STATE();
    case 140:
      ACCEPT_TOKEN(sym_integer);
      if (lookahead == '_') ADVANCE(38);
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(136);
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(140);
      END_STATE();
    case 141:
      ACCEPT_TOKEN(sym_integer);
      if (lookahead == '_') ADVANCE(39);
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(136);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(141);
      END_STATE();
    case 142:
      ACCEPT_TOKEN(sym_integer);
      if (lookahead == '_') ADVANCE(43);
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(136);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(142);
      END_STATE();
    case 143:
      ACCEPT_TOKEN(sym_float);
      END_STATE();
    case 144:
      ACCEPT_TOKEN(sym_float);
      if (lookahead == '_') ADVANCE(146);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(37);
      if (lookahead == 'J' ||
          lookahead == 'L' ||
          lookahead == 'j' ||
          lookahead == 'l') ADVANCE(143);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(144);
      END_STATE();
    case 145:
      ACCEPT_TOKEN(sym_float);
      if (lookahead == '_') ADVANCE(147);
      if (lookahead == 'J' ||
          lookahead == 'L' ||
          lookahead == 'j' ||
          lookahead == 'l') ADVANCE(143);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(145);
      END_STATE();
    case 146:
      ACCEPT_TOKEN(sym_float);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(37);
      if (lookahead == 'J' ||
          lookahead == 'L' ||
          lookahead == 'j' ||
          lookahead == 'l') ADVANCE(143);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(144);
      END_STATE();
    case 147:
      ACCEPT_TOKEN(sym_float);
      if (lookahead == 'J' ||
          lookahead == 'L' ||
          lookahead == 'j' ||
          lookahead == 'l') ADVANCE(143);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(145);
      END_STATE();
    case 148:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '*') ADVANCE(79);
      if (sym_identifier_character_set_3(lookahead)) ADVANCE(164);
      END_STATE();
    case 149:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'c') ADVANCE(152);
      if (sym_identifier_character_set_3(lookahead)) ADVANCE(164);
      END_STATE();
    case 150:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'c') ADVANCE(153);
      if (sym_identifier_character_set_3(lookahead)) ADVANCE(164);
      END_STATE();
    case 151:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'c') ADVANCE(154);
      if (sym_identifier_character_set_3(lookahead)) ADVANCE(164);
      END_STATE();
    case 152:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'e') ADVANCE(155);
      if (sym_identifier_character_set_3(lookahead)) ADVANCE(164);
      END_STATE();
    case 153:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'e') ADVANCE(156);
      if (sym_identifier_character_set_3(lookahead)) ADVANCE(164);
      END_STATE();
    case 154:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'e') ADVANCE(157);
      if (sym_identifier_character_set_3(lookahead)) ADVANCE(164);
      END_STATE();
    case 155:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'p') ADVANCE(158);
      if (sym_identifier_character_set_3(lookahead)) ADVANCE(164);
      END_STATE();
    case 156:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'p') ADVANCE(159);
      if (sym_identifier_character_set_3(lookahead)) ADVANCE(164);
      END_STATE();
    case 157:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'p') ADVANCE(160);
      if (sym_identifier_character_set_3(lookahead)) ADVANCE(164);
      END_STATE();
    case 158:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 't') ADVANCE(77);
      if (sym_identifier_character_set_3(lookahead)) ADVANCE(164);
      END_STATE();
    case 159:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 't') ADVANCE(78);
      if (sym_identifier_character_set_3(lookahead)) ADVANCE(164);
      END_STATE();
    case 160:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 't') ADVANCE(148);
      if (sym_identifier_character_set_3(lookahead)) ADVANCE(164);
      END_STATE();
    case 161:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'x') ADVANCE(149);
      if (sym_identifier_character_set_3(lookahead)) ADVANCE(164);
      END_STATE();
    case 162:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'x') ADVANCE(150);
      if (sym_identifier_character_set_3(lookahead)) ADVANCE(164);
      END_STATE();
    case 163:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'x') ADVANCE(151);
      if (sym_identifier_character_set_3(lookahead)) ADVANCE(164);
      END_STATE();
    case 164:
      ACCEPT_TOKEN(sym_identifier);
      if (sym_identifier_character_set_3(lookahead)) ADVANCE(164);
      END_STATE();
    case 165:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(165);
      END_STATE();
    case 166:
      ACCEPT_TOKEN(sym__semicolon);
      END_STATE();
    default:
      return false;
  }
}

static bool ts_lex_keywords(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (lookahead == 'F') ADVANCE(1);
      if (lookahead == 'N') ADVANCE(2);
      if (lookahead == 'T') ADVANCE(3);
      if (lookahead == '\\') SKIP(4)
      if (lookahead == '_') ADVANCE(5);
      if (lookahead == 'a') ADVANCE(6);
      if (lookahead == 'b') ADVANCE(7);
      if (lookahead == 'c') ADVANCE(8);
      if (lookahead == 'd') ADVANCE(9);
      if (lookahead == 'e') ADVANCE(10);
      if (lookahead == 'f') ADVANCE(11);
      if (lookahead == 'g') ADVANCE(12);
      if (lookahead == 'i') ADVANCE(13);
      if (lookahead == 'l') ADVANCE(14);
      if (lookahead == 'm') ADVANCE(15);
      if (lookahead == 'n') ADVANCE(16);
      if (lookahead == 'o') ADVANCE(17);
      if (lookahead == 'p') ADVANCE(18);
      if (lookahead == 'r') ADVANCE(19);
      if (lookahead == 't') ADVANCE(20);
      if (lookahead == 'w') ADVANCE(21);
      if (lookahead == 'y') ADVANCE(22);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\f' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(0)
      END_STATE();
    case 1:
      if (lookahead == 'a') ADVANCE(23);
      END_STATE();
    case 2:
      if (lookahead == 'o') ADVANCE(24);
      END_STATE();
    case 3:
      if (lookahead == 'r') ADVANCE(25);
      END_STATE();
    case 4:
      if (lookahead == '\n') SKIP(0)
      if (lookahead == '\r') SKIP(26)
      END_STATE();
    case 5:
      ACCEPT_TOKEN(sym_match_wildcard_pattern);
      if (lookahead == '_') ADVANCE(27);
      END_STATE();
    case 6:
      if (lookahead == 'n') ADVANCE(28);
      if (lookahead == 's') ADVANCE(29);
      if (lookahead == 'w') ADVANCE(30);
      END_STATE();
    case 7:
      if (lookahead == 'r') ADVANCE(31);
      END_STATE();
    case 8:
      if (lookahead == 'a') ADVANCE(32);
      if (lookahead == 'l') ADVANCE(33);
      if (lookahead == 'o') ADVANCE(34);
      END_STATE();
    case 9:
      if (lookahead == 'e') ADVANCE(35);
      END_STATE();
    case 10:
      if (lookahead == 'l') ADVANCE(36);
      if (lookahead == 'x') ADVANCE(37);
      END_STATE();
    case 11:
      if (lookahead == 'i') ADVANCE(38);
      if (lookahead == 'o') ADVANCE(39);
      if (lookahead == 'r') ADVANCE(40);
      END_STATE();
    case 12:
      if (lookahead == 'l') ADVANCE(41);
      END_STATE();
    case 13:
      if (lookahead == 'f') ADVANCE(42);
      if (lookahead == 'm') ADVANCE(43);
      if (lookahead == 'n') ADVANCE(44);
      if (lookahead == 's') ADVANCE(45);
      END_STATE();
    case 14:
      if (lookahead == 'a') ADVANCE(46);
      END_STATE();
    case 15:
      if (lookahead == 'a') ADVANCE(47);
      END_STATE();
    case 16:
      if (lookahead == 'o') ADVANCE(48);
      END_STATE();
    case 17:
      if (lookahead == 'r') ADVANCE(49);
      END_STATE();
    case 18:
      if (lookahead == 'a') ADVANCE(50);
      if (lookahead == 'r') ADVANCE(51);
      END_STATE();
    case 19:
      if (lookahead == 'a') ADVANCE(52);
      if (lookahead == 'e') ADVANCE(53);
      END_STATE();
    case 20:
      if (lookahead == 'r') ADVANCE(54);
      if (lookahead == 'y') ADVANCE(55);
      END_STATE();
    case 21:
      if (lookahead == 'h') ADVANCE(56);
      if (lookahead == 'i') ADVANCE(57);
      END_STATE();
    case 22:
      if (lookahead == 'i') ADVANCE(58);
      END_STATE();
    case 23:
      if (lookahead == 'l') ADVANCE(59);
      END_STATE();
    case 24:
      if (lookahead == 'n') ADVANCE(60);
      END_STATE();
    case 25:
      if (lookahead == 'u') ADVANCE(61);
      END_STATE();
    case 26:
      if (lookahead == '\n') SKIP(0)
      END_STATE();
    case 27:
      if (lookahead == 'f') ADVANCE(62);
      END_STATE();
    case 28:
      if (lookahead == 'd') ADVANCE(63);
      END_STATE();
    case 29:
      ACCEPT_TOKEN(anon_sym_as);
      if (lookahead == 's') ADVANCE(64);
      if (lookahead == 'y') ADVANCE(65);
      END_STATE();
    case 30:
      if (lookahead == 'a') ADVANCE(66);
      END_STATE();
    case 31:
      if (lookahead == 'e') ADVANCE(67);
      END_STATE();
    case 32:
      if (lookahead == 's') ADVANCE(68);
      END_STATE();
    case 33:
      if (lookahead == 'a') ADVANCE(69);
      END_STATE();
    case 34:
      if (lookahead == 'n') ADVANCE(70);
      END_STATE();
    case 35:
      if (lookahead == 'f') ADVANCE(71);
      if (lookahead == 'l') ADVANCE(72);
      END_STATE();
    case 36:
      if (lookahead == 'i') ADVANCE(73);
      if (lookahead == 's') ADVANCE(74);
      END_STATE();
    case 37:
      if (lookahead == 'e') ADVANCE(75);
      END_STATE();
    case 38:
      if (lookahead == 'n') ADVANCE(76);
      END_STATE();
    case 39:
      if (lookahead == 'r') ADVANCE(77);
      END_STATE();
    case 40:
      if (lookahead == 'o') ADVANCE(78);
      END_STATE();
    case 41:
      if (lookahead == 'o') ADVANCE(79);
      END_STATE();
    case 42:
      ACCEPT_TOKEN(anon_sym_if);
      END_STATE();
    case 43:
      if (lookahead == 'p') ADVANCE(80);
      END_STATE();
    case 44:
      ACCEPT_TOKEN(anon_sym_in);
      END_STATE();
    case 45:
      ACCEPT_TOKEN(anon_sym_is);
      END_STATE();
    case 46:
      if (lookahead == 'm') ADVANCE(81);
      END_STATE();
    case 47:
      if (lookahead == 't') ADVANCE(82);
      END_STATE();
    case 48:
      if (lookahead == 'n') ADVANCE(83);
      if (lookahead == 't') ADVANCE(84);
      END_STATE();
    case 49:
      ACCEPT_TOKEN(anon_sym_or);
      END_STATE();
    case 50:
      if (lookahead == 's') ADVANCE(85);
      END_STATE();
    case 51:
      if (lookahead == 'i') ADVANCE(86);
      END_STATE();
    case 52:
      if (lookahead == 'i') ADVANCE(87);
      END_STATE();
    case 53:
      if (lookahead == 't') ADVANCE(88);
      END_STATE();
    case 54:
      if (lookahead == 'y') ADVANCE(89);
      END_STATE();
    case 55:
      if (lookahead == 'p') ADVANCE(90);
      END_STATE();
    case 56:
      if (lookahead == 'i') ADVANCE(91);
      END_STATE();
    case 57:
      if (lookahead == 't') ADVANCE(92);
      END_STATE();
    case 58:
      if (lookahead == 'e') ADVANCE(93);
      END_STATE();
    case 59:
      if (lookahead == 's') ADVANCE(94);
      END_STATE();
    case 60:
      if (lookahead == 'e') ADVANCE(95);
      END_STATE();
    case 61:
      if (lookahead == 'e') ADVANCE(96);
      END_STATE();
    case 62:
      if (lookahead == 'u') ADVANCE(97);
      END_STATE();
    case 63:
      ACCEPT_TOKEN(anon_sym_and);
      END_STATE();
    case 64:
      if (lookahead == 'e') ADVANCE(98);
      END_STATE();
    case 65:
      if (lookahead == 'n') ADVANCE(99);
      END_STATE();
    case 66:
      if (lookahead == 'i') ADVANCE(100);
      END_STATE();
    case 67:
      if (lookahead == 'a') ADVANCE(101);
      END_STATE();
    case 68:
      if (lookahead == 'e') ADVANCE(102);
      END_STATE();
    case 69:
      if (lookahead == 's') ADVANCE(103);
      END_STATE();
    case 70:
      if (lookahead == 't') ADVANCE(104);
      END_STATE();
    case 71:
      ACCEPT_TOKEN(anon_sym_def);
      END_STATE();
    case 72:
      ACCEPT_TOKEN(anon_sym_del);
      END_STATE();
    case 73:
      if (lookahead == 'f') ADVANCE(105);
      END_STATE();
    case 74:
      if (lookahead == 'e') ADVANCE(106);
      END_STATE();
    case 75:
      if (lookahead == 'c') ADVANCE(107);
      END_STATE();
    case 76:
      if (lookahead == 'a') ADVANCE(108);
      END_STATE();
    case 77:
      ACCEPT_TOKEN(anon_sym_for);
      END_STATE();
    case 78:
      if (lookahead == 'm') ADVANCE(109);
      END_STATE();
    case 79:
      if (lookahead == 'b') ADVANCE(110);
      END_STATE();
    case 80:
      if (lookahead == 'o') ADVANCE(111);
      END_STATE();
    case 81:
      if (lookahead == 'b') ADVANCE(112);
      END_STATE();
    case 82:
      if (lookahead == 'c') ADVANCE(113);
      END_STATE();
    case 83:
      if (lookahead == 'l') ADVANCE(114);
      END_STATE();
    case 84:
      ACCEPT_TOKEN(anon_sym_not);
      END_STATE();
    case 85:
      if (lookahead == 's') ADVANCE(115);
      END_STATE();
    case 86:
      if (lookahead == 'n') ADVANCE(116);
      END_STATE();
    case 87:
      if (lookahead == 's') ADVANCE(117);
      END_STATE();
    case 88:
      if (lookahead == 'u') ADVANCE(118);
      END_STATE();
    case 89:
      ACCEPT_TOKEN(anon_sym_try);
      END_STATE();
    case 90:
      if (lookahead == 'e') ADVANCE(119);
      END_STATE();
    case 91:
      if (lookahead == 'l') ADVANCE(120);
      END_STATE();
    case 92:
      if (lookahead == 'h') ADVANCE(121);
      END_STATE();
    case 93:
      if (lookahead == 'l') ADVANCE(122);
      END_STATE();
    case 94:
      if (lookahead == 'e') ADVANCE(123);
      END_STATE();
    case 95:
      ACCEPT_TOKEN(sym_none);
      END_STATE();
    case 96:
      ACCEPT_TOKEN(sym_true);
      END_STATE();
    case 97:
      if (lookahead == 't') ADVANCE(124);
      END_STATE();
    case 98:
      if (lookahead == 'r') ADVANCE(125);
      END_STATE();
    case 99:
      if (lookahead == 'c') ADVANCE(126);
      END_STATE();
    case 100:
      if (lookahead == 't') ADVANCE(127);
      END_STATE();
    case 101:
      if (lookahead == 'k') ADVANCE(128);
      END_STATE();
    case 102:
      ACCEPT_TOKEN(anon_sym_case);
      END_STATE();
    case 103:
      if (lookahead == 's') ADVANCE(129);
      END_STATE();
    case 104:
      if (lookahead == 'i') ADVANCE(130);
      END_STATE();
    case 105:
      ACCEPT_TOKEN(anon_sym_elif);
      END_STATE();
    case 106:
      ACCEPT_TOKEN(anon_sym_else);
      END_STATE();
    case 107:
      ACCEPT_TOKEN(anon_sym_exec);
      END_STATE();
    case 108:
      if (lookahead == 'l') ADVANCE(131);
      END_STATE();
    case 109:
      ACCEPT_TOKEN(anon_sym_from);
      END_STATE();
    case 110:
      if (lookahead == 'a') ADVANCE(132);
      END_STATE();
    case 111:
      if (lookahead == 'r') ADVANCE(133);
      END_STATE();
    case 112:
      if (lookahead == 'd') ADVANCE(134);
      END_STATE();
    case 113:
      if (lookahead == 'h') ADVANCE(135);
      END_STATE();
    case 114:
      if (lookahead == 'o') ADVANCE(136);
      END_STATE();
    case 115:
      ACCEPT_TOKEN(anon_sym_pass);
      END_STATE();
    case 116:
      if (lookahead == 't') ADVANCE(137);
      END_STATE();
    case 117:
      if (lookahead == 'e') ADVANCE(138);
      END_STATE();
    case 118:
      if (lookahead == 'r') ADVANCE(139);
      END_STATE();
    case 119:
      ACCEPT_TOKEN(anon_sym_type);
      END_STATE();
    case 120:
      if (lookahead == 'e') ADVANCE(140);
      END_STATE();
    case 121:
      ACCEPT_TOKEN(anon_sym_with);
      END_STATE();
    case 122:
      if (lookahead == 'd') ADVANCE(141);
      END_STATE();
    case 123:
      ACCEPT_TOKEN(sym_false);
      END_STATE();
    case 124:
      if (lookahead == 'u') ADVANCE(142);
      END_STATE();
    case 125:
      if (lookahead == 't') ADVANCE(143);
      END_STATE();
    case 126:
      ACCEPT_TOKEN(anon_sym_async);
      END_STATE();
    case 127:
      ACCEPT_TOKEN(anon_sym_await);
      END_STATE();
    case 128:
      ACCEPT_TOKEN(anon_sym_break);
      END_STATE();
    case 129:
      ACCEPT_TOKEN(anon_sym_class);
      END_STATE();
    case 130:
      if (lookahead == 'n') ADVANCE(144);
      END_STATE();
    case 131:
      if (lookahead == 'l') ADVANCE(145);
      END_STATE();
    case 132:
      if (lookahead == 'l') ADVANCE(146);
      END_STATE();
    case 133:
      if (lookahead == 't') ADVANCE(147);
      END_STATE();
    case 134:
      if (lookahead == 'a') ADVANCE(148);
      END_STATE();
    case 135:
      ACCEPT_TOKEN(anon_sym_match);
      END_STATE();
    case 136:
      if (lookahead == 'c') ADVANCE(149);
      END_STATE();
    case 137:
      ACCEPT_TOKEN(anon_sym_print);
      END_STATE();
    case 138:
      ACCEPT_TOKEN(anon_sym_raise);
      END_STATE();
    case 139:
      if (lookahead == 'n') ADVANCE(150);
      END_STATE();
    case 140:
      ACCEPT_TOKEN(anon_sym_while);
      END_STATE();
    case 141:
      ACCEPT_TOKEN(anon_sym_yield);
      END_STATE();
    case 142:
      if (lookahead == 'r') ADVANCE(151);
      END_STATE();
    case 143:
      ACCEPT_TOKEN(anon_sym_assert);
      END_STATE();
    case 144:
      if (lookahead == 'u') ADVANCE(152);
      END_STATE();
    case 145:
      if (lookahead == 'y') ADVANCE(153);
      END_STATE();
    case 146:
      ACCEPT_TOKEN(anon_sym_global);
      END_STATE();
    case 147:
      ACCEPT_TOKEN(anon_sym_import);
      END_STATE();
    case 148:
      ACCEPT_TOKEN(anon_sym_lambda);
      END_STATE();
    case 149:
      if (lookahead == 'a') ADVANCE(154);
      END_STATE();
    case 150:
      ACCEPT_TOKEN(anon_sym_return);
      END_STATE();
    case 151:
      if (lookahead == 'e') ADVANCE(155);
      END_STATE();
    case 152:
      if (lookahead == 'e') ADVANCE(156);
      END_STATE();
    case 153:
      ACCEPT_TOKEN(anon_sym_finally);
      END_STATE();
    case 154:
      if (lookahead == 'l') ADVANCE(157);
      END_STATE();
    case 155:
      if (lookahead == '_') ADVANCE(158);
      END_STATE();
    case 156:
      ACCEPT_TOKEN(anon_sym_continue);
      END_STATE();
    case 157:
      ACCEPT_TOKEN(anon_sym_nonlocal);
      END_STATE();
    case 158:
      if (lookahead == '_') ADVANCE(159);
      END_STATE();
    case 159:
      ACCEPT_TOKEN(anon_sym___future__);
      END_STATE();
    default:
      return false;
  }
}

static const TSLexMode ts_lex_modes[STATE_COUNT] = {
  [0] = {.lex_state = 0, .external_lex_state = 1},
  [1] = {.lex_state = 62, .external_lex_state = 2},
  [2] = {.lex_state = 62, .external_lex_state = 3},
  [3] = {.lex_state = 62, .external_lex_state = 3},
  [4] = {.lex_state = 62, .external_lex_state = 3},
  [5] = {.lex_state = 62, .external_lex_state = 3},
  [6] = {.lex_state = 62, .external_lex_state = 3},
  [7] = {.lex_state = 62, .external_lex_state = 3},
  [8] = {.lex_state = 62, .external_lex_state = 3},
  [9] = {.lex_state = 62, .external_lex_state = 3},
  [10] = {.lex_state = 62, .external_lex_state = 3},
  [11] = {.lex_state = 62, .external_lex_state = 3},
  [12] = {.lex_state = 62, .external_lex_state = 3},
  [13] = {.lex_state = 62, .external_lex_state = 3},
  [14] = {.lex_state = 62, .external_lex_state = 3},
  [15] = {.lex_state = 62, .external_lex_state = 3},
  [16] = {.lex_state = 62, .external_lex_state = 3},
  [17] = {.lex_state = 62, .external_lex_state = 3},
  [18] = {.lex_state = 62, .external_lex_state = 3},
  [19] = {.lex_state = 62, .external_lex_state = 3},
  [20] = {.lex_state = 62, .external_lex_state = 3},
  [21] = {.lex_state = 62, .external_lex_state = 3},
  [22] = {.lex_state = 62, .external_lex_state = 3},
  [23] = {.lex_state = 62, .external_lex_state = 3},
  [24] = {.lex_state = 62, .external_lex_state = 3},
  [25] = {.lex_state = 62, .external_lex_state = 3},
  [26] = {.lex_state = 62, .external_lex_state = 3},
  [27] = {.lex_state = 62, .external_lex_state = 3},
  [28] = {.lex_state = 62, .external_lex_state = 3},
  [29] = {.lex_state = 62, .external_lex_state = 3},
  [30] = {.lex_state = 62, .external_lex_state = 3},
  [31] = {.lex_state = 62, .external_lex_state = 3},
  [32] = {.lex_state = 62, .external_lex_state = 3},
  [33] = {.lex_state = 62, .external_lex_state = 3},
  [34] = {.lex_state = 62, .external_lex_state = 3},
  [35] = {.lex_state = 62, .external_lex_state = 3},
  [36] = {.lex_state = 62, .external_lex_state = 3},
  [37] = {.lex_state = 62, .external_lex_state = 3},
  [38] = {.lex_state = 62, .external_lex_state = 3},
  [39] = {.lex_state = 62, .external_lex_state = 3},
  [40] = {.lex_state = 62, .external_lex_state = 3},
  [41] = {.lex_state = 62, .external_lex_state = 3},
  [42] = {.lex_state = 62, .external_lex_state = 3},
  [43] = {.lex_state = 62, .external_lex_state = 3},
  [44] = {.lex_state = 62, .external_lex_state = 3},
  [45] = {.lex_state = 62, .external_lex_state = 3},
  [46] = {.lex_state = 62, .external_lex_state = 3},
  [47] = {.lex_state = 62, .external_lex_state = 3},
  [48] = {.lex_state = 62, .external_lex_state = 3},
  [49] = {.lex_state = 62, .external_lex_state = 3},
  [50] = {.lex_state = 62, .external_lex_state = 3},
  [51] = {.lex_state = 62, .external_lex_state = 3},
  [52] = {.lex_state = 62, .external_lex_state = 3},
  [53] = {.lex_state = 62, .external_lex_state = 3},
  [54] = {.lex_state = 62, .external_lex_state = 3},
  [55] = {.lex_state = 62, .external_lex_state = 3},
  [56] = {.lex_state = 62, .external_lex_state = 3},
  [57] = {.lex_state = 62, .external_lex_state = 3},
  [58] = {.lex_state = 62, .external_lex_state = 3},
  [59] = {.lex_state = 62, .external_lex_state = 3},
  [60] = {.lex_state = 62, .external_lex_state = 3},
  [61] = {.lex_state = 62, .external_lex_state = 3},
  [62] = {.lex_state = 62, .external_lex_state = 3},
  [63] = {.lex_state = 62, .external_lex_state = 3},
  [64] = {.lex_state = 62, .external_lex_state = 2},
  [65] = {.lex_state = 62, .external_lex_state = 3},
  [66] = {.lex_state = 62, .external_lex_state = 3},
  [67] = {.lex_state = 62, .external_lex_state = 2},
  [68] = {.lex_state = 62, .external_lex_state = 3},
  [69] = {.lex_state = 62, .external_lex_state = 3},
  [70] = {.lex_state = 62, .external_lex_state = 4},
  [71] = {.lex_state = 62, .external_lex_state = 4},
  [72] = {.lex_state = 62, .external_lex_state = 5},
  [73] = {.lex_state = 62, .external_lex_state = 5},
  [74] = {.lex_state = 62, .external_lex_state = 5},
  [75] = {.lex_state = 62, .external_lex_state = 4},
  [76] = {.lex_state = 62, .external_lex_state = 5},
  [77] = {.lex_state = 62, .external_lex_state = 5},
  [78] = {.lex_state = 62, .external_lex_state = 5},
  [79] = {.lex_state = 62, .external_lex_state = 5},
  [80] = {.lex_state = 62, .external_lex_state = 5},
  [81] = {.lex_state = 62, .external_lex_state = 5},
  [82] = {.lex_state = 62, .external_lex_state = 5},
  [83] = {.lex_state = 62, .external_lex_state = 5},
  [84] = {.lex_state = 62, .external_lex_state = 5},
  [85] = {.lex_state = 62, .external_lex_state = 5},
  [86] = {.lex_state = 62, .external_lex_state = 5},
  [87] = {.lex_state = 62, .external_lex_state = 5},
  [88] = {.lex_state = 62, .external_lex_state = 5},
  [89] = {.lex_state = 62, .external_lex_state = 5},
  [90] = {.lex_state = 62, .external_lex_state = 5},
  [91] = {.lex_state = 62, .external_lex_state = 5},
  [92] = {.lex_state = 62, .external_lex_state = 5},
  [93] = {.lex_state = 62, .external_lex_state = 5},
  [94] = {.lex_state = 62, .external_lex_state = 5},
  [95] = {.lex_state = 62, .external_lex_state = 5},
  [96] = {.lex_state = 62, .external_lex_state = 5},
  [97] = {.lex_state = 62, .external_lex_state = 5},
  [98] = {.lex_state = 62, .external_lex_state = 5},
  [99] = {.lex_state = 62, .external_lex_state = 5},
  [100] = {.lex_state = 62, .external_lex_state = 5},
  [101] = {.lex_state = 62, .external_lex_state = 5},
  [102] = {.lex_state = 62, .external_lex_state = 5},
  [103] = {.lex_state = 62, .external_lex_state = 5},
  [104] = {.lex_state = 62, .external_lex_state = 5},
  [105] = {.lex_state = 62, .external_lex_state = 5},
  [106] = {.lex_state = 62, .external_lex_state = 5},
  [107] = {.lex_state = 62, .external_lex_state = 5},
  [108] = {.lex_state = 62, .external_lex_state = 5},
  [109] = {.lex_state = 62, .external_lex_state = 5},
  [110] = {.lex_state = 62, .external_lex_state = 5},
  [111] = {.lex_state = 62, .external_lex_state = 5},
  [112] = {.lex_state = 62, .external_lex_state = 5},
  [113] = {.lex_state = 62, .external_lex_state = 5},
  [114] = {.lex_state = 62, .external_lex_state = 5},
  [115] = {.lex_state = 62, .external_lex_state = 5},
  [116] = {.lex_state = 62, .external_lex_state = 5},
  [117] = {.lex_state = 62, .external_lex_state = 5},
  [118] = {.lex_state = 62, .external_lex_state = 5},
  [119] = {.lex_state = 62, .external_lex_state = 5},
  [120] = {.lex_state = 62, .external_lex_state = 5},
  [121] = {.lex_state = 62, .external_lex_state = 5},
  [122] = {.lex_state = 62, .external_lex_state = 5},
  [123] = {.lex_state = 62, .external_lex_state = 5},
  [124] = {.lex_state = 62, .external_lex_state = 5},
  [125] = {.lex_state = 62, .external_lex_state = 5},
  [126] = {.lex_state = 62, .external_lex_state = 5},
  [127] = {.lex_state = 62, .external_lex_state = 5},
  [128] = {.lex_state = 62, .external_lex_state = 5},
  [129] = {.lex_state = 62, .external_lex_state = 5},
  [130] = {.lex_state = 62, .external_lex_state = 5},
  [131] = {.lex_state = 62, .external_lex_state = 4},
  [132] = {.lex_state = 62, .external_lex_state = 2},
  [133] = {.lex_state = 62, .external_lex_state = 4},
  [134] = {.lex_state = 62, .external_lex_state = 4},
  [135] = {.lex_state = 62, .external_lex_state = 4},
  [136] = {.lex_state = 62, .external_lex_state = 4},
  [137] = {.lex_state = 62, .external_lex_state = 4},
  [138] = {.lex_state = 62, .external_lex_state = 4},
  [139] = {.lex_state = 62, .external_lex_state = 4},
  [140] = {.lex_state = 62, .external_lex_state = 4},
  [141] = {.lex_state = 62, .external_lex_state = 4},
  [142] = {.lex_state = 62, .external_lex_state = 4},
  [143] = {.lex_state = 62, .external_lex_state = 4},
  [144] = {.lex_state = 62, .external_lex_state = 4},
  [145] = {.lex_state = 62, .external_lex_state = 4},
  [146] = {.lex_state = 62, .external_lex_state = 4},
  [147] = {.lex_state = 62, .external_lex_state = 2},
  [148] = {.lex_state = 62, .external_lex_state = 2},
  [149] = {.lex_state = 62, .external_lex_state = 2},
  [150] = {.lex_state = 62, .external_lex_state = 4},
  [151] = {.lex_state = 62, .external_lex_state = 2},
  [152] = {.lex_state = 62, .external_lex_state = 2},
  [153] = {.lex_state = 62, .external_lex_state = 2},
  [154] = {.lex_state = 62, .external_lex_state = 2},
  [155] = {.lex_state = 62, .external_lex_state = 2},
  [156] = {.lex_state = 62, .external_lex_state = 2},
  [157] = {.lex_state = 62, .external_lex_state = 2},
  [158] = {.lex_state = 16, .external_lex_state = 2},
  [159] = {.lex_state = 62, .external_lex_state = 2},
  [160] = {.lex_state = 62, .external_lex_state = 2},
  [161] = {.lex_state = 62, .external_lex_state = 2},
  [162] = {.lex_state = 62, .external_lex_state = 2},
  [163] = {.lex_state = 62, .external_lex_state = 2},
  [164] = {.lex_state = 62, .external_lex_state = 2},
  [165] = {.lex_state = 16, .external_lex_state = 2},
  [166] = {.lex_state = 62, .external_lex_state = 2},
  [167] = {.lex_state = 16, .external_lex_state = 2},
  [168] = {.lex_state = 16, .external_lex_state = 2},
  [169] = {.lex_state = 62, .external_lex_state = 2},
  [170] = {.lex_state = 62, .external_lex_state = 2},
  [171] = {.lex_state = 16, .external_lex_state = 2},
  [172] = {.lex_state = 16, .external_lex_state = 2},
  [173] = {.lex_state = 62, .external_lex_state = 2},
  [174] = {.lex_state = 62, .external_lex_state = 2},
  [175] = {.lex_state = 62, .external_lex_state = 2},
  [176] = {.lex_state = 62, .external_lex_state = 2},
  [177] = {.lex_state = 62, .external_lex_state = 2},
  [178] = {.lex_state = 62, .external_lex_state = 2},
  [179] = {.lex_state = 62, .external_lex_state = 2},
  [180] = {.lex_state = 62, .external_lex_state = 4},
  [181] = {.lex_state = 62, .external_lex_state = 4},
  [182] = {.lex_state = 62, .external_lex_state = 2},
  [183] = {.lex_state = 62, .external_lex_state = 2},
  [184] = {.lex_state = 62, .external_lex_state = 2},
  [185] = {.lex_state = 62, .external_lex_state = 2},
  [186] = {.lex_state = 62, .external_lex_state = 2},
  [187] = {.lex_state = 62, .external_lex_state = 2},
  [188] = {.lex_state = 62, .external_lex_state = 2},
  [189] = {.lex_state = 62, .external_lex_state = 2},
  [190] = {.lex_state = 62, .external_lex_state = 2},
  [191] = {.lex_state = 62, .external_lex_state = 2},
  [192] = {.lex_state = 62, .external_lex_state = 2},
  [193] = {.lex_state = 62, .external_lex_state = 2},
  [194] = {.lex_state = 62, .external_lex_state = 2},
  [195] = {.lex_state = 62, .external_lex_state = 4},
  [196] = {.lex_state = 62, .external_lex_state = 2},
  [197] = {.lex_state = 62, .external_lex_state = 2},
  [198] = {.lex_state = 62, .external_lex_state = 2},
  [199] = {.lex_state = 62, .external_lex_state = 2},
  [200] = {.lex_state = 62, .external_lex_state = 2},
  [201] = {.lex_state = 62, .external_lex_state = 4},
  [202] = {.lex_state = 62, .external_lex_state = 2},
  [203] = {.lex_state = 62, .external_lex_state = 2},
  [204] = {.lex_state = 62, .external_lex_state = 2},
  [205] = {.lex_state = 62, .external_lex_state = 4},
  [206] = {.lex_state = 62, .external_lex_state = 2},
  [207] = {.lex_state = 62, .external_lex_state = 2},
  [208] = {.lex_state = 62, .external_lex_state = 2},
  [209] = {.lex_state = 62, .external_lex_state = 2},
  [210] = {.lex_state = 62, .external_lex_state = 4},
  [211] = {.lex_state = 62, .external_lex_state = 2},
  [212] = {.lex_state = 62, .external_lex_state = 2},
  [213] = {.lex_state = 62, .external_lex_state = 2},
  [214] = {.lex_state = 62, .external_lex_state = 2},
  [215] = {.lex_state = 62, .external_lex_state = 2},
  [216] = {.lex_state = 62, .external_lex_state = 2},
  [217] = {.lex_state = 62, .external_lex_state = 2},
  [218] = {.lex_state = 15},
  [219] = {.lex_state = 15},
  [220] = {.lex_state = 15},
  [221] = {.lex_state = 15},
  [222] = {.lex_state = 62, .external_lex_state = 2},
  [223] = {.lex_state = 15},
  [224] = {.lex_state = 62, .external_lex_state = 2},
  [225] = {.lex_state = 62, .external_lex_state = 2},
  [226] = {.lex_state = 15},
  [227] = {.lex_state = 15},
  [228] = {.lex_state = 63, .external_lex_state = 2},
  [229] = {.lex_state = 64, .external_lex_state = 3},
  [230] = {.lex_state = 62, .external_lex_state = 2},
  [231] = {.lex_state = 62, .external_lex_state = 2},
  [232] = {.lex_state = 63, .external_lex_state = 3},
  [233] = {.lex_state = 62, .external_lex_state = 2},
  [234] = {.lex_state = 64, .external_lex_state = 3},
  [235] = {.lex_state = 62, .external_lex_state = 2},
  [236] = {.lex_state = 62, .external_lex_state = 2},
  [237] = {.lex_state = 64, .external_lex_state = 2},
  [238] = {.lex_state = 63, .external_lex_state = 2},
  [239] = {.lex_state = 62, .external_lex_state = 2},
  [240] = {.lex_state = 64, .external_lex_state = 2},
  [241] = {.lex_state = 63, .external_lex_state = 3},
  [242] = {.lex_state = 62, .external_lex_state = 2},
  [243] = {.lex_state = 62, .external_lex_state = 2},
  [244] = {.lex_state = 62, .external_lex_state = 2},
  [245] = {.lex_state = 62, .external_lex_state = 2},
  [246] = {.lex_state = 62, .external_lex_state = 2},
  [247] = {.lex_state = 14, .external_lex_state = 6},
  [248] = {.lex_state = 62, .external_lex_state = 2},
  [249] = {.lex_state = 62, .external_lex_state = 2},
  [250] = {.lex_state = 62, .external_lex_state = 2},
  [251] = {.lex_state = 62, .external_lex_state = 2},
  [252] = {.lex_state = 62, .external_lex_state = 2},
  [253] = {.lex_state = 62, .external_lex_state = 2},
  [254] = {.lex_state = 14, .external_lex_state = 6},
  [255] = {.lex_state = 16, .external_lex_state = 2},
  [256] = {.lex_state = 16, .external_lex_state = 2},
  [257] = {.lex_state = 16, .external_lex_state = 2},
  [258] = {.lex_state = 62, .external_lex_state = 3},
  [259] = {.lex_state = 16, .external_lex_state = 2},
  [260] = {.lex_state = 16, .external_lex_state = 2},
  [261] = {.lex_state = 16, .external_lex_state = 2},
  [262] = {.lex_state = 16, .external_lex_state = 2},
  [263] = {.lex_state = 62, .external_lex_state = 3},
  [264] = {.lex_state = 16, .external_lex_state = 2},
  [265] = {.lex_state = 62, .external_lex_state = 3},
  [266] = {.lex_state = 63, .external_lex_state = 3},
  [267] = {.lex_state = 64, .external_lex_state = 3},
  [268] = {.lex_state = 62, .external_lex_state = 2},
  [269] = {.lex_state = 16, .external_lex_state = 2},
  [270] = {.lex_state = 64, .external_lex_state = 2},
  [271] = {.lex_state = 63, .external_lex_state = 2},
  [272] = {.lex_state = 62, .external_lex_state = 3},
  [273] = {.lex_state = 16, .external_lex_state = 2},
  [274] = {.lex_state = 16, .external_lex_state = 2},
  [275] = {.lex_state = 62, .external_lex_state = 2},
  [276] = {.lex_state = 62, .external_lex_state = 2},
  [277] = {.lex_state = 62, .external_lex_state = 2},
  [278] = {.lex_state = 14, .external_lex_state = 4},
  [279] = {.lex_state = 62, .external_lex_state = 2},
  [280] = {.lex_state = 62, .external_lex_state = 2},
  [281] = {.lex_state = 62, .external_lex_state = 2},
  [282] = {.lex_state = 62, .external_lex_state = 2},
  [283] = {.lex_state = 62, .external_lex_state = 2},
  [284] = {.lex_state = 14, .external_lex_state = 6},
  [285] = {.lex_state = 62, .external_lex_state = 2},
  [286] = {.lex_state = 62, .external_lex_state = 2},
  [287] = {.lex_state = 62, .external_lex_state = 2},
  [288] = {.lex_state = 62, .external_lex_state = 3},
  [289] = {.lex_state = 62, .external_lex_state = 2},
  [290] = {.lex_state = 62, .external_lex_state = 2},
  [291] = {.lex_state = 62, .external_lex_state = 3},
  [292] = {.lex_state = 62, .external_lex_state = 2},
  [293] = {.lex_state = 62, .external_lex_state = 2},
  [294] = {.lex_state = 62, .external_lex_state = 2},
  [295] = {.lex_state = 62, .external_lex_state = 4},
  [296] = {.lex_state = 62, .external_lex_state = 2},
  [297] = {.lex_state = 62, .external_lex_state = 2},
  [298] = {.lex_state = 62, .external_lex_state = 2},
  [299] = {.lex_state = 16, .external_lex_state = 2},
  [300] = {.lex_state = 62, .external_lex_state = 4},
  [301] = {.lex_state = 16, .external_lex_state = 2},
  [302] = {.lex_state = 62, .external_lex_state = 2},
  [303] = {.lex_state = 62, .external_lex_state = 4},
  [304] = {.lex_state = 62, .external_lex_state = 4},
  [305] = {.lex_state = 62, .external_lex_state = 2},
  [306] = {.lex_state = 62, .external_lex_state = 2},
  [307] = {.lex_state = 62, .external_lex_state = 3},
  [308] = {.lex_state = 62, .external_lex_state = 3},
  [309] = {.lex_state = 62, .external_lex_state = 2},
  [310] = {.lex_state = 16, .external_lex_state = 2},
  [311] = {.lex_state = 62, .external_lex_state = 3},
  [312] = {.lex_state = 62, .external_lex_state = 2},
  [313] = {.lex_state = 62, .external_lex_state = 2},
  [314] = {.lex_state = 16, .external_lex_state = 2},
  [315] = {.lex_state = 62, .external_lex_state = 3},
  [316] = {.lex_state = 64, .external_lex_state = 3},
  [317] = {.lex_state = 63, .external_lex_state = 3},
  [318] = {.lex_state = 64, .external_lex_state = 2},
  [319] = {.lex_state = 63, .external_lex_state = 2},
  [320] = {.lex_state = 63, .external_lex_state = 2},
  [321] = {.lex_state = 62, .external_lex_state = 2},
  [322] = {.lex_state = 62, .external_lex_state = 2},
  [323] = {.lex_state = 62, .external_lex_state = 2},
  [324] = {.lex_state = 62, .external_lex_state = 2},
  [325] = {.lex_state = 63, .external_lex_state = 2},
  [326] = {.lex_state = 63, .external_lex_state = 2},
  [327] = {.lex_state = 64, .external_lex_state = 2},
  [328] = {.lex_state = 63, .external_lex_state = 2},
  [329] = {.lex_state = 64, .external_lex_state = 2},
  [330] = {.lex_state = 14, .external_lex_state = 6},
  [331] = {.lex_state = 64, .external_lex_state = 2},
  [332] = {.lex_state = 63, .external_lex_state = 2},
  [333] = {.lex_state = 63, .external_lex_state = 2},
  [334] = {.lex_state = 14, .external_lex_state = 6},
  [335] = {.lex_state = 16, .external_lex_state = 2},
  [336] = {.lex_state = 15, .external_lex_state = 6},
  [337] = {.lex_state = 15, .external_lex_state = 6},
  [338] = {.lex_state = 14},
  [339] = {.lex_state = 14},
  [340] = {.lex_state = 63, .external_lex_state = 2},
  [341] = {.lex_state = 62, .external_lex_state = 2},
  [342] = {.lex_state = 15, .external_lex_state = 6},
  [343] = {.lex_state = 15, .external_lex_state = 6},
  [344] = {.lex_state = 15, .external_lex_state = 6},
  [345] = {.lex_state = 62, .external_lex_state = 3},
  [346] = {.lex_state = 62, .external_lex_state = 2},
  [347] = {.lex_state = 62, .external_lex_state = 2},
  [348] = {.lex_state = 62, .external_lex_state = 2},
  [349] = {.lex_state = 62, .external_lex_state = 3},
  [350] = {.lex_state = 62, .external_lex_state = 2},
  [351] = {.lex_state = 62, .external_lex_state = 2},
  [352] = {.lex_state = 15, .external_lex_state = 6},
  [353] = {.lex_state = 63, .external_lex_state = 3},
  [354] = {.lex_state = 64, .external_lex_state = 3},
  [355] = {.lex_state = 64, .external_lex_state = 3},
  [356] = {.lex_state = 64, .external_lex_state = 3},
  [357] = {.lex_state = 63, .external_lex_state = 3},
  [358] = {.lex_state = 64, .external_lex_state = 3},
  [359] = {.lex_state = 64, .external_lex_state = 2},
  [360] = {.lex_state = 63, .external_lex_state = 3},
  [361] = {.lex_state = 62, .external_lex_state = 2},
  [362] = {.lex_state = 64, .external_lex_state = 2},
  [363] = {.lex_state = 64, .external_lex_state = 3},
  [364] = {.lex_state = 62, .external_lex_state = 2},
  [365] = {.lex_state = 15, .external_lex_state = 6},
  [366] = {.lex_state = 63, .external_lex_state = 3},
  [367] = {.lex_state = 64, .external_lex_state = 2},
  [368] = {.lex_state = 62, .external_lex_state = 2},
  [369] = {.lex_state = 63, .external_lex_state = 2},
  [370] = {.lex_state = 63, .external_lex_state = 3},
  [371] = {.lex_state = 64, .external_lex_state = 2},
  [372] = {.lex_state = 64, .external_lex_state = 3},
  [373] = {.lex_state = 63, .external_lex_state = 3},
  [374] = {.lex_state = 64, .external_lex_state = 3},
  [375] = {.lex_state = 63, .external_lex_state = 2},
  [376] = {.lex_state = 64, .external_lex_state = 2},
  [377] = {.lex_state = 63, .external_lex_state = 3},
  [378] = {.lex_state = 63, .external_lex_state = 3},
  [379] = {.lex_state = 63, .external_lex_state = 3},
  [380] = {.lex_state = 62, .external_lex_state = 2},
  [381] = {.lex_state = 63, .external_lex_state = 3},
  [382] = {.lex_state = 63, .external_lex_state = 2},
  [383] = {.lex_state = 16, .external_lex_state = 2},
  [384] = {.lex_state = 64, .external_lex_state = 3},
  [385] = {.lex_state = 62, .external_lex_state = 2},
  [386] = {.lex_state = 62, .external_lex_state = 2},
  [387] = {.lex_state = 62, .external_lex_state = 2},
  [388] = {.lex_state = 62, .external_lex_state = 2},
  [389] = {.lex_state = 62, .external_lex_state = 2},
  [390] = {.lex_state = 62, .external_lex_state = 2},
  [391] = {.lex_state = 62, .external_lex_state = 2},
  [392] = {.lex_state = 62, .external_lex_state = 2},
  [393] = {.lex_state = 62, .external_lex_state = 2},
  [394] = {.lex_state = 62, .external_lex_state = 2},
  [395] = {.lex_state = 62, .external_lex_state = 2},
  [396] = {.lex_state = 62, .external_lex_state = 2},
  [397] = {.lex_state = 62, .external_lex_state = 2},
  [398] = {.lex_state = 62, .external_lex_state = 2},
  [399] = {.lex_state = 62, .external_lex_state = 2},
  [400] = {.lex_state = 62, .external_lex_state = 2},
  [401] = {.lex_state = 62, .external_lex_state = 2},
  [402] = {.lex_state = 62, .external_lex_state = 2},
  [403] = {.lex_state = 62, .external_lex_state = 3},
  [404] = {.lex_state = 62, .external_lex_state = 2},
  [405] = {.lex_state = 62, .external_lex_state = 2},
  [406] = {.lex_state = 62, .external_lex_state = 2},
  [407] = {.lex_state = 62, .external_lex_state = 2},
  [408] = {.lex_state = 62, .external_lex_state = 2},
  [409] = {.lex_state = 62, .external_lex_state = 2},
  [410] = {.lex_state = 62, .external_lex_state = 2},
  [411] = {.lex_state = 62, .external_lex_state = 2},
  [412] = {.lex_state = 62, .external_lex_state = 2},
  [413] = {.lex_state = 62, .external_lex_state = 3},
  [414] = {.lex_state = 62, .external_lex_state = 3},
  [415] = {.lex_state = 62, .external_lex_state = 2},
  [416] = {.lex_state = 62, .external_lex_state = 2},
  [417] = {.lex_state = 62, .external_lex_state = 2},
  [418] = {.lex_state = 62, .external_lex_state = 3},
  [419] = {.lex_state = 62, .external_lex_state = 2},
  [420] = {.lex_state = 62, .external_lex_state = 3},
  [421] = {.lex_state = 62, .external_lex_state = 3},
  [422] = {.lex_state = 62, .external_lex_state = 2},
  [423] = {.lex_state = 62, .external_lex_state = 2},
  [424] = {.lex_state = 62, .external_lex_state = 2},
  [425] = {.lex_state = 62, .external_lex_state = 2},
  [426] = {.lex_state = 62, .external_lex_state = 2},
  [427] = {.lex_state = 62, .external_lex_state = 2},
  [428] = {.lex_state = 62, .external_lex_state = 3},
  [429] = {.lex_state = 62, .external_lex_state = 2},
  [430] = {.lex_state = 62, .external_lex_state = 2},
  [431] = {.lex_state = 15, .external_lex_state = 6},
  [432] = {.lex_state = 62, .external_lex_state = 3},
  [433] = {.lex_state = 62, .external_lex_state = 2},
  [434] = {.lex_state = 62, .external_lex_state = 2},
  [435] = {.lex_state = 62, .external_lex_state = 2},
  [436] = {.lex_state = 62, .external_lex_state = 2},
  [437] = {.lex_state = 62, .external_lex_state = 2},
  [438] = {.lex_state = 62, .external_lex_state = 2},
  [439] = {.lex_state = 62, .external_lex_state = 2},
  [440] = {.lex_state = 62, .external_lex_state = 2},
  [441] = {.lex_state = 15, .external_lex_state = 6},
  [442] = {.lex_state = 62, .external_lex_state = 2},
  [443] = {.lex_state = 62, .external_lex_state = 2},
  [444] = {.lex_state = 62, .external_lex_state = 2},
  [445] = {.lex_state = 62, .external_lex_state = 2},
  [446] = {.lex_state = 62, .external_lex_state = 2},
  [447] = {.lex_state = 62, .external_lex_state = 2},
  [448] = {.lex_state = 62, .external_lex_state = 2},
  [449] = {.lex_state = 15},
  [450] = {.lex_state = 62, .external_lex_state = 2},
  [451] = {.lex_state = 62, .external_lex_state = 2},
  [452] = {.lex_state = 62, .external_lex_state = 2},
  [453] = {.lex_state = 62, .external_lex_state = 2},
  [454] = {.lex_state = 62, .external_lex_state = 3},
  [455] = {.lex_state = 62, .external_lex_state = 2},
  [456] = {.lex_state = 62, .external_lex_state = 2},
  [457] = {.lex_state = 62, .external_lex_state = 2},
  [458] = {.lex_state = 62, .external_lex_state = 2},
  [459] = {.lex_state = 62, .external_lex_state = 2},
  [460] = {.lex_state = 62, .external_lex_state = 2},
  [461] = {.lex_state = 62, .external_lex_state = 2},
  [462] = {.lex_state = 62, .external_lex_state = 2},
  [463] = {.lex_state = 62, .external_lex_state = 2},
  [464] = {.lex_state = 62, .external_lex_state = 3},
  [465] = {.lex_state = 62, .external_lex_state = 2},
  [466] = {.lex_state = 62, .external_lex_state = 2},
  [467] = {.lex_state = 62, .external_lex_state = 2},
  [468] = {.lex_state = 62, .external_lex_state = 2},
  [469] = {.lex_state = 62, .external_lex_state = 2},
  [470] = {.lex_state = 62, .external_lex_state = 2},
  [471] = {.lex_state = 62, .external_lex_state = 2},
  [472] = {.lex_state = 62, .external_lex_state = 2},
  [473] = {.lex_state = 62, .external_lex_state = 2},
  [474] = {.lex_state = 62, .external_lex_state = 2},
  [475] = {.lex_state = 15, .external_lex_state = 6},
  [476] = {.lex_state = 62, .external_lex_state = 2},
  [477] = {.lex_state = 62, .external_lex_state = 2},
  [478] = {.lex_state = 62, .external_lex_state = 3},
  [479] = {.lex_state = 62, .external_lex_state = 2},
  [480] = {.lex_state = 62, .external_lex_state = 2},
  [481] = {.lex_state = 62, .external_lex_state = 2},
  [482] = {.lex_state = 62, .external_lex_state = 2},
  [483] = {.lex_state = 62, .external_lex_state = 2},
  [484] = {.lex_state = 62, .external_lex_state = 2},
  [485] = {.lex_state = 62, .external_lex_state = 3},
  [486] = {.lex_state = 62, .external_lex_state = 2},
  [487] = {.lex_state = 62, .external_lex_state = 3},
  [488] = {.lex_state = 62, .external_lex_state = 2},
  [489] = {.lex_state = 62, .external_lex_state = 3},
  [490] = {.lex_state = 62, .external_lex_state = 2},
  [491] = {.lex_state = 62, .external_lex_state = 3},
  [492] = {.lex_state = 62, .external_lex_state = 3},
  [493] = {.lex_state = 62, .external_lex_state = 2},
  [494] = {.lex_state = 62, .external_lex_state = 2},
  [495] = {.lex_state = 62, .external_lex_state = 3},
  [496] = {.lex_state = 62, .external_lex_state = 2},
  [497] = {.lex_state = 62, .external_lex_state = 2},
  [498] = {.lex_state = 62, .external_lex_state = 3},
  [499] = {.lex_state = 62, .external_lex_state = 2},
  [500] = {.lex_state = 62, .external_lex_state = 2},
  [501] = {.lex_state = 62, .external_lex_state = 2},
  [502] = {.lex_state = 62, .external_lex_state = 3},
  [503] = {.lex_state = 62, .external_lex_state = 2},
  [504] = {.lex_state = 62, .external_lex_state = 2},
  [505] = {.lex_state = 62, .external_lex_state = 3},
  [506] = {.lex_state = 62, .external_lex_state = 3},
  [507] = {.lex_state = 62, .external_lex_state = 2},
  [508] = {.lex_state = 62, .external_lex_state = 3},
  [509] = {.lex_state = 62, .external_lex_state = 3},
  [510] = {.lex_state = 62, .external_lex_state = 3},
  [511] = {.lex_state = 62, .external_lex_state = 2},
  [512] = {.lex_state = 62, .external_lex_state = 2},
  [513] = {.lex_state = 62, .external_lex_state = 3},
  [514] = {.lex_state = 62, .external_lex_state = 2},
  [515] = {.lex_state = 62, .external_lex_state = 2},
  [516] = {.lex_state = 62, .external_lex_state = 3},
  [517] = {.lex_state = 62, .external_lex_state = 3},
  [518] = {.lex_state = 62, .external_lex_state = 2},
  [519] = {.lex_state = 62, .external_lex_state = 2},
  [520] = {.lex_state = 62, .external_lex_state = 3},
  [521] = {.lex_state = 62, .external_lex_state = 2},
  [522] = {.lex_state = 62, .external_lex_state = 3},
  [523] = {.lex_state = 62, .external_lex_state = 2},
  [524] = {.lex_state = 62, .external_lex_state = 2},
  [525] = {.lex_state = 62, .external_lex_state = 3},
  [526] = {.lex_state = 62, .external_lex_state = 3},
  [527] = {.lex_state = 62, .external_lex_state = 3},
  [528] = {.lex_state = 62, .external_lex_state = 2},
  [529] = {.lex_state = 62, .external_lex_state = 3},
  [530] = {.lex_state = 62, .external_lex_state = 3},
  [531] = {.lex_state = 62, .external_lex_state = 3},
  [532] = {.lex_state = 62, .external_lex_state = 2},
  [533] = {.lex_state = 62, .external_lex_state = 2},
  [534] = {.lex_state = 62, .external_lex_state = 3},
  [535] = {.lex_state = 62, .external_lex_state = 2},
  [536] = {.lex_state = 62, .external_lex_state = 2},
  [537] = {.lex_state = 62, .external_lex_state = 2},
  [538] = {.lex_state = 62, .external_lex_state = 2},
  [539] = {.lex_state = 62, .external_lex_state = 3},
  [540] = {.lex_state = 62, .external_lex_state = 3},
  [541] = {.lex_state = 62, .external_lex_state = 2},
  [542] = {.lex_state = 62, .external_lex_state = 2},
  [543] = {.lex_state = 62, .external_lex_state = 2},
  [544] = {.lex_state = 62, .external_lex_state = 3},
  [545] = {.lex_state = 62, .external_lex_state = 2},
  [546] = {.lex_state = 62, .external_lex_state = 2},
  [547] = {.lex_state = 62, .external_lex_state = 2},
  [548] = {.lex_state = 62, .external_lex_state = 3},
  [549] = {.lex_state = 62, .external_lex_state = 2},
  [550] = {.lex_state = 62, .external_lex_state = 2},
  [551] = {.lex_state = 62, .external_lex_state = 3},
  [552] = {.lex_state = 62, .external_lex_state = 2},
  [553] = {.lex_state = 62, .external_lex_state = 2},
  [554] = {.lex_state = 62, .external_lex_state = 3},
  [555] = {.lex_state = 62, .external_lex_state = 3},
  [556] = {.lex_state = 62, .external_lex_state = 2},
  [557] = {.lex_state = 62, .external_lex_state = 2},
  [558] = {.lex_state = 62, .external_lex_state = 3},
  [559] = {.lex_state = 62, .external_lex_state = 2},
  [560] = {.lex_state = 62, .external_lex_state = 3},
  [561] = {.lex_state = 62, .external_lex_state = 2},
  [562] = {.lex_state = 62, .external_lex_state = 3},
  [563] = {.lex_state = 62, .external_lex_state = 3},
  [564] = {.lex_state = 62, .external_lex_state = 3},
  [565] = {.lex_state = 62, .external_lex_state = 3},
  [566] = {.lex_state = 62, .external_lex_state = 2},
  [567] = {.lex_state = 62, .external_lex_state = 3},
  [568] = {.lex_state = 62, .external_lex_state = 3},
  [569] = {.lex_state = 62, .external_lex_state = 2},
  [570] = {.lex_state = 62, .external_lex_state = 3},
  [571] = {.lex_state = 62, .external_lex_state = 3},
  [572] = {.lex_state = 62, .external_lex_state = 2},
  [573] = {.lex_state = 62, .external_lex_state = 2},
  [574] = {.lex_state = 62, .external_lex_state = 3},
  [575] = {.lex_state = 62, .external_lex_state = 2},
  [576] = {.lex_state = 62, .external_lex_state = 2},
  [577] = {.lex_state = 62, .external_lex_state = 3},
  [578] = {.lex_state = 62, .external_lex_state = 2},
  [579] = {.lex_state = 62, .external_lex_state = 3},
  [580] = {.lex_state = 62, .external_lex_state = 3},
  [581] = {.lex_state = 62, .external_lex_state = 3},
  [582] = {.lex_state = 62, .external_lex_state = 3},
  [583] = {.lex_state = 62, .external_lex_state = 2},
  [584] = {.lex_state = 62, .external_lex_state = 3},
  [585] = {.lex_state = 62, .external_lex_state = 2},
  [586] = {.lex_state = 62, .external_lex_state = 2},
  [587] = {.lex_state = 62, .external_lex_state = 3},
  [588] = {.lex_state = 62, .external_lex_state = 3},
  [589] = {.lex_state = 62, .external_lex_state = 2},
  [590] = {.lex_state = 62, .external_lex_state = 2},
  [591] = {.lex_state = 62, .external_lex_state = 3},
  [592] = {.lex_state = 62, .external_lex_state = 3},
  [593] = {.lex_state = 62, .external_lex_state = 3},
  [594] = {.lex_state = 62, .external_lex_state = 3},
  [595] = {.lex_state = 62, .external_lex_state = 2},
  [596] = {.lex_state = 62, .external_lex_state = 2},
  [597] = {.lex_state = 62, .external_lex_state = 2},
  [598] = {.lex_state = 15, .external_lex_state = 2},
  [599] = {.lex_state = 15, .external_lex_state = 2},
  [600] = {.lex_state = 15, .external_lex_state = 2},
  [601] = {.lex_state = 62, .external_lex_state = 2},
  [602] = {.lex_state = 62, .external_lex_state = 2},
  [603] = {.lex_state = 62, .external_lex_state = 2},
  [604] = {.lex_state = 62, .external_lex_state = 2},
  [605] = {.lex_state = 62, .external_lex_state = 2},
  [606] = {.lex_state = 62, .external_lex_state = 2},
  [607] = {.lex_state = 62, .external_lex_state = 2},
  [608] = {.lex_state = 62, .external_lex_state = 2},
  [609] = {.lex_state = 15, .external_lex_state = 2},
  [610] = {.lex_state = 15, .external_lex_state = 2},
  [611] = {.lex_state = 15},
  [612] = {.lex_state = 15},
  [613] = {.lex_state = 15},
  [614] = {.lex_state = 15},
  [615] = {.lex_state = 15},
  [616] = {.lex_state = 15},
  [617] = {.lex_state = 15},
  [618] = {.lex_state = 15},
  [619] = {.lex_state = 15},
  [620] = {.lex_state = 15},
  [621] = {.lex_state = 15},
  [622] = {.lex_state = 15},
  [623] = {.lex_state = 15},
  [624] = {.lex_state = 15},
  [625] = {.lex_state = 15},
  [626] = {.lex_state = 15},
  [627] = {.lex_state = 15},
  [628] = {.lex_state = 15},
  [629] = {.lex_state = 15},
  [630] = {.lex_state = 15},
  [631] = {.lex_state = 15},
  [632] = {.lex_state = 15},
  [633] = {.lex_state = 15},
  [634] = {.lex_state = 15},
  [635] = {.lex_state = 15},
  [636] = {.lex_state = 16, .external_lex_state = 2},
  [637] = {.lex_state = 15},
  [638] = {.lex_state = 15},
  [639] = {.lex_state = 15},
  [640] = {.lex_state = 15},
  [641] = {.lex_state = 15},
  [642] = {.lex_state = 15},
  [643] = {.lex_state = 15},
  [644] = {.lex_state = 15},
  [645] = {.lex_state = 15},
  [646] = {.lex_state = 15},
  [647] = {.lex_state = 15},
  [648] = {.lex_state = 15},
  [649] = {.lex_state = 15},
  [650] = {.lex_state = 15},
  [651] = {.lex_state = 15},
  [652] = {.lex_state = 15},
  [653] = {.lex_state = 15},
  [654] = {.lex_state = 15},
  [655] = {.lex_state = 15},
  [656] = {.lex_state = 15},
  [657] = {.lex_state = 15},
  [658] = {.lex_state = 15},
  [659] = {.lex_state = 15},
  [660] = {.lex_state = 15},
  [661] = {.lex_state = 15},
  [662] = {.lex_state = 15},
  [663] = {.lex_state = 15},
  [664] = {.lex_state = 15},
  [665] = {.lex_state = 15},
  [666] = {.lex_state = 15},
  [667] = {.lex_state = 14},
  [668] = {.lex_state = 14},
  [669] = {.lex_state = 62, .external_lex_state = 2},
  [670] = {.lex_state = 62, .external_lex_state = 2},
  [671] = {.lex_state = 15},
  [672] = {.lex_state = 15},
  [673] = {.lex_state = 62, .external_lex_state = 2},
  [674] = {.lex_state = 14},
  [675] = {.lex_state = 14},
  [676] = {.lex_state = 62, .external_lex_state = 2},
  [677] = {.lex_state = 15, .external_lex_state = 2},
  [678] = {.lex_state = 15, .external_lex_state = 2},
  [679] = {.lex_state = 62, .external_lex_state = 2},
  [680] = {.lex_state = 62, .external_lex_state = 2},
  [681] = {.lex_state = 62, .external_lex_state = 2},
  [682] = {.lex_state = 62, .external_lex_state = 2},
  [683] = {.lex_state = 62, .external_lex_state = 2},
  [684] = {.lex_state = 15, .external_lex_state = 6},
  [685] = {.lex_state = 62, .external_lex_state = 2},
  [686] = {.lex_state = 62, .external_lex_state = 2},
  [687] = {.lex_state = 62, .external_lex_state = 2},
  [688] = {.lex_state = 62, .external_lex_state = 2},
  [689] = {.lex_state = 15, .external_lex_state = 4},
  [690] = {.lex_state = 62, .external_lex_state = 2},
  [691] = {.lex_state = 62, .external_lex_state = 2},
  [692] = {.lex_state = 62, .external_lex_state = 2},
  [693] = {.lex_state = 62, .external_lex_state = 2},
  [694] = {.lex_state = 62, .external_lex_state = 2},
  [695] = {.lex_state = 62, .external_lex_state = 2},
  [696] = {.lex_state = 62, .external_lex_state = 2},
  [697] = {.lex_state = 62, .external_lex_state = 2},
  [698] = {.lex_state = 62, .external_lex_state = 2},
  [699] = {.lex_state = 62, .external_lex_state = 2},
  [700] = {.lex_state = 62, .external_lex_state = 2},
  [701] = {.lex_state = 62, .external_lex_state = 2},
  [702] = {.lex_state = 62, .external_lex_state = 2},
  [703] = {.lex_state = 62, .external_lex_state = 2},
  [704] = {.lex_state = 62, .external_lex_state = 2},
  [705] = {.lex_state = 62, .external_lex_state = 2},
  [706] = {.lex_state = 62, .external_lex_state = 2},
  [707] = {.lex_state = 62, .external_lex_state = 2},
  [708] = {.lex_state = 62, .external_lex_state = 2},
  [709] = {.lex_state = 62, .external_lex_state = 2},
  [710] = {.lex_state = 62, .external_lex_state = 2},
  [711] = {.lex_state = 62, .external_lex_state = 2},
  [712] = {.lex_state = 62, .external_lex_state = 2},
  [713] = {.lex_state = 15, .external_lex_state = 4},
  [714] = {.lex_state = 62, .external_lex_state = 2},
  [715] = {.lex_state = 62, .external_lex_state = 2},
  [716] = {.lex_state = 62, .external_lex_state = 2},
  [717] = {.lex_state = 62, .external_lex_state = 2},
  [718] = {.lex_state = 62, .external_lex_state = 2},
  [719] = {.lex_state = 62, .external_lex_state = 2},
  [720] = {.lex_state = 15, .external_lex_state = 4},
  [721] = {.lex_state = 62, .external_lex_state = 2},
  [722] = {.lex_state = 62, .external_lex_state = 2},
  [723] = {.lex_state = 62, .external_lex_state = 2},
  [724] = {.lex_state = 62, .external_lex_state = 2},
  [725] = {.lex_state = 15},
  [726] = {.lex_state = 62, .external_lex_state = 2},
  [727] = {.lex_state = 15},
  [728] = {.lex_state = 62, .external_lex_state = 2},
  [729] = {.lex_state = 62, .external_lex_state = 2},
  [730] = {.lex_state = 62, .external_lex_state = 2},
  [731] = {.lex_state = 15, .external_lex_state = 6},
  [732] = {.lex_state = 15, .external_lex_state = 6},
  [733] = {.lex_state = 15, .external_lex_state = 6},
  [734] = {.lex_state = 15, .external_lex_state = 6},
  [735] = {.lex_state = 15, .external_lex_state = 6},
  [736] = {.lex_state = 15, .external_lex_state = 2},
  [737] = {.lex_state = 15, .external_lex_state = 6},
  [738] = {.lex_state = 15, .external_lex_state = 6},
  [739] = {.lex_state = 15, .external_lex_state = 6},
  [740] = {.lex_state = 15},
  [741] = {.lex_state = 15, .external_lex_state = 6},
  [742] = {.lex_state = 15, .external_lex_state = 2},
  [743] = {.lex_state = 15, .external_lex_state = 6},
  [744] = {.lex_state = 15, .external_lex_state = 2},
  [745] = {.lex_state = 15, .external_lex_state = 6},
  [746] = {.lex_state = 15},
  [747] = {.lex_state = 15},
  [748] = {.lex_state = 15},
  [749] = {.lex_state = 14},
  [750] = {.lex_state = 15},
  [751] = {.lex_state = 15},
  [752] = {.lex_state = 15},
  [753] = {.lex_state = 15},
  [754] = {.lex_state = 14, .external_lex_state = 6},
  [755] = {.lex_state = 14, .external_lex_state = 6},
  [756] = {.lex_state = 15},
  [757] = {.lex_state = 15},
  [758] = {.lex_state = 15, .external_lex_state = 4},
  [759] = {.lex_state = 14},
  [760] = {.lex_state = 14},
  [761] = {.lex_state = 15},
  [762] = {.lex_state = 15},
  [763] = {.lex_state = 15},
  [764] = {.lex_state = 14},
  [765] = {.lex_state = 15},
  [766] = {.lex_state = 15},
  [767] = {.lex_state = 15},
  [768] = {.lex_state = 15},
  [769] = {.lex_state = 15, .external_lex_state = 4},
  [770] = {.lex_state = 15},
  [771] = {.lex_state = 15, .external_lex_state = 6},
  [772] = {.lex_state = 15, .external_lex_state = 6},
  [773] = {.lex_state = 15, .external_lex_state = 6},
  [774] = {.lex_state = 15, .external_lex_state = 6},
  [775] = {.lex_state = 15, .external_lex_state = 6},
  [776] = {.lex_state = 15, .external_lex_state = 6},
  [777] = {.lex_state = 15, .external_lex_state = 6},
  [778] = {.lex_state = 15, .external_lex_state = 6},
  [779] = {.lex_state = 15},
  [780] = {.lex_state = 15, .external_lex_state = 6},
  [781] = {.lex_state = 15, .external_lex_state = 6},
  [782] = {.lex_state = 15, .external_lex_state = 6},
  [783] = {.lex_state = 15, .external_lex_state = 6},
  [784] = {.lex_state = 15, .external_lex_state = 6},
  [785] = {.lex_state = 15, .external_lex_state = 6},
  [786] = {.lex_state = 15, .external_lex_state = 6},
  [787] = {.lex_state = 15, .external_lex_state = 6},
  [788] = {.lex_state = 15, .external_lex_state = 6},
  [789] = {.lex_state = 15},
  [790] = {.lex_state = 15, .external_lex_state = 6},
  [791] = {.lex_state = 15, .external_lex_state = 6},
  [792] = {.lex_state = 15, .external_lex_state = 6},
  [793] = {.lex_state = 15, .external_lex_state = 6},
  [794] = {.lex_state = 15, .external_lex_state = 6},
  [795] = {.lex_state = 15, .external_lex_state = 6},
  [796] = {.lex_state = 15, .external_lex_state = 6},
  [797] = {.lex_state = 15, .external_lex_state = 6},
  [798] = {.lex_state = 14},
  [799] = {.lex_state = 15, .external_lex_state = 6},
  [800] = {.lex_state = 15, .external_lex_state = 6},
  [801] = {.lex_state = 14},
  [802] = {.lex_state = 15, .external_lex_state = 6},
  [803] = {.lex_state = 15, .external_lex_state = 6},
  [804] = {.lex_state = 15, .external_lex_state = 6},
  [805] = {.lex_state = 15, .external_lex_state = 6},
  [806] = {.lex_state = 15},
  [807] = {.lex_state = 15, .external_lex_state = 6},
  [808] = {.lex_state = 15, .external_lex_state = 6},
  [809] = {.lex_state = 15},
  [810] = {.lex_state = 15},
  [811] = {.lex_state = 15},
  [812] = {.lex_state = 14},
  [813] = {.lex_state = 15},
  [814] = {.lex_state = 15},
  [815] = {.lex_state = 15},
  [816] = {.lex_state = 15},
  [817] = {.lex_state = 15},
  [818] = {.lex_state = 15},
  [819] = {.lex_state = 15},
  [820] = {.lex_state = 15},
  [821] = {.lex_state = 15},
  [822] = {.lex_state = 15},
  [823] = {.lex_state = 15},
  [824] = {.lex_state = 15},
  [825] = {.lex_state = 15},
  [826] = {.lex_state = 15},
  [827] = {.lex_state = 15},
  [828] = {.lex_state = 15},
  [829] = {.lex_state = 15},
  [830] = {.lex_state = 15},
  [831] = {.lex_state = 15},
  [832] = {.lex_state = 15},
  [833] = {.lex_state = 15},
  [834] = {.lex_state = 15},
  [835] = {.lex_state = 15},
  [836] = {.lex_state = 15},
  [837] = {.lex_state = 14},
  [838] = {.lex_state = 15},
  [839] = {.lex_state = 15},
  [840] = {.lex_state = 15},
  [841] = {.lex_state = 15},
  [842] = {.lex_state = 15},
  [843] = {.lex_state = 15},
  [844] = {.lex_state = 15},
  [845] = {.lex_state = 15},
  [846] = {.lex_state = 15},
  [847] = {.lex_state = 15},
  [848] = {.lex_state = 15},
  [849] = {.lex_state = 62, .external_lex_state = 2},
  [850] = {.lex_state = 16, .external_lex_state = 2},
  [851] = {.lex_state = 16, .external_lex_state = 2},
  [852] = {.lex_state = 62, .external_lex_state = 2},
  [853] = {.lex_state = 62, .external_lex_state = 2},
  [854] = {.lex_state = 62, .external_lex_state = 2},
  [855] = {.lex_state = 62, .external_lex_state = 2},
  [856] = {.lex_state = 62, .external_lex_state = 2},
  [857] = {.lex_state = 62, .external_lex_state = 2},
  [858] = {.lex_state = 62, .external_lex_state = 2},
  [859] = {.lex_state = 62, .external_lex_state = 2},
  [860] = {.lex_state = 62, .external_lex_state = 2},
  [861] = {.lex_state = 62, .external_lex_state = 2},
  [862] = {.lex_state = 62, .external_lex_state = 2},
  [863] = {.lex_state = 62, .external_lex_state = 2},
  [864] = {.lex_state = 62, .external_lex_state = 2},
  [865] = {.lex_state = 62, .external_lex_state = 2},
  [866] = {.lex_state = 62, .external_lex_state = 2},
  [867] = {.lex_state = 62, .external_lex_state = 2},
  [868] = {.lex_state = 16},
  [869] = {.lex_state = 16},
  [870] = {.lex_state = 16},
  [871] = {.lex_state = 16},
  [872] = {.lex_state = 16},
  [873] = {.lex_state = 16},
  [874] = {.lex_state = 16},
  [875] = {.lex_state = 16},
  [876] = {.lex_state = 16},
  [877] = {.lex_state = 62, .external_lex_state = 6},
  [878] = {.lex_state = 62, .external_lex_state = 6},
  [879] = {.lex_state = 15},
  [880] = {.lex_state = 15},
  [881] = {.lex_state = 16},
  [882] = {.lex_state = 15},
  [883] = {.lex_state = 16},
  [884] = {.lex_state = 16},
  [885] = {.lex_state = 16},
  [886] = {.lex_state = 16},
  [887] = {.lex_state = 16},
  [888] = {.lex_state = 16},
  [889] = {.lex_state = 16},
  [890] = {.lex_state = 16},
  [891] = {.lex_state = 62, .external_lex_state = 2},
  [892] = {.lex_state = 62, .external_lex_state = 2},
  [893] = {.lex_state = 62},
  [894] = {.lex_state = 62, .external_lex_state = 2},
  [895] = {.lex_state = 62},
  [896] = {.lex_state = 16},
  [897] = {.lex_state = 16},
  [898] = {.lex_state = 16},
  [899] = {.lex_state = 62},
  [900] = {.lex_state = 16},
  [901] = {.lex_state = 16},
  [902] = {.lex_state = 62},
  [903] = {.lex_state = 62},
  [904] = {.lex_state = 16},
  [905] = {.lex_state = 62, .external_lex_state = 2},
  [906] = {.lex_state = 15},
  [907] = {.lex_state = 16},
  [908] = {.lex_state = 16},
  [909] = {.lex_state = 16},
  [910] = {.lex_state = 15},
  [911] = {.lex_state = 16},
  [912] = {.lex_state = 16},
  [913] = {.lex_state = 16, .external_lex_state = 2},
  [914] = {.lex_state = 16},
  [915] = {.lex_state = 62},
  [916] = {.lex_state = 16},
  [917] = {.lex_state = 15},
  [918] = {.lex_state = 16},
  [919] = {.lex_state = 16},
  [920] = {.lex_state = 16},
  [921] = {.lex_state = 16},
  [922] = {.lex_state = 16},
  [923] = {.lex_state = 16},
  [924] = {.lex_state = 16},
  [925] = {.lex_state = 15},
  [926] = {.lex_state = 16},
  [927] = {.lex_state = 16},
  [928] = {.lex_state = 16},
  [929] = {.lex_state = 16},
  [930] = {.lex_state = 62},
  [931] = {.lex_state = 62},
  [932] = {.lex_state = 62},
  [933] = {.lex_state = 16},
  [934] = {.lex_state = 18, .external_lex_state = 7},
  [935] = {.lex_state = 62},
  [936] = {.lex_state = 18, .external_lex_state = 7},
  [937] = {.lex_state = 18, .external_lex_state = 7},
  [938] = {.lex_state = 18, .external_lex_state = 7},
  [939] = {.lex_state = 16},
  [940] = {.lex_state = 62},
  [941] = {.lex_state = 62},
  [942] = {.lex_state = 18, .external_lex_state = 7},
  [943] = {.lex_state = 16},
  [944] = {.lex_state = 18, .external_lex_state = 7},
  [945] = {.lex_state = 62},
  [946] = {.lex_state = 62},
  [947] = {.lex_state = 16},
  [948] = {.lex_state = 16},
  [949] = {.lex_state = 18, .external_lex_state = 7},
  [950] = {.lex_state = 18, .external_lex_state = 7},
  [951] = {.lex_state = 16},
  [952] = {.lex_state = 18, .external_lex_state = 7},
  [953] = {.lex_state = 62},
  [954] = {.lex_state = 16},
  [955] = {.lex_state = 62},
  [956] = {.lex_state = 62},
  [957] = {.lex_state = 16},
  [958] = {.lex_state = 62},
  [959] = {.lex_state = 62},
  [960] = {.lex_state = 16},
  [961] = {.lex_state = 16},
  [962] = {.lex_state = 62},
  [963] = {.lex_state = 62},
  [964] = {.lex_state = 16},
  [965] = {.lex_state = 0},
  [966] = {.lex_state = 16},
  [967] = {.lex_state = 62, .external_lex_state = 6},
  [968] = {.lex_state = 16},
  [969] = {.lex_state = 16},
  [970] = {.lex_state = 16},
  [971] = {.lex_state = 16},
  [972] = {.lex_state = 16},
  [973] = {.lex_state = 16},
  [974] = {.lex_state = 62, .external_lex_state = 6},
  [975] = {.lex_state = 16},
  [976] = {.lex_state = 62, .external_lex_state = 6},
  [977] = {.lex_state = 16},
  [978] = {.lex_state = 62},
  [979] = {.lex_state = 62},
  [980] = {.lex_state = 62, .external_lex_state = 6},
  [981] = {.lex_state = 16},
  [982] = {.lex_state = 62, .external_lex_state = 6},
  [983] = {.lex_state = 0},
  [984] = {.lex_state = 16},
  [985] = {.lex_state = 16},
  [986] = {.lex_state = 16},
  [987] = {.lex_state = 16},
  [988] = {.lex_state = 16},
  [989] = {.lex_state = 16},
  [990] = {.lex_state = 16},
  [991] = {.lex_state = 0},
  [992] = {.lex_state = 62, .external_lex_state = 6},
  [993] = {.lex_state = 16},
  [994] = {.lex_state = 62},
  [995] = {.lex_state = 62},
  [996] = {.lex_state = 62},
  [997] = {.lex_state = 62, .external_lex_state = 6},
  [998] = {.lex_state = 16},
  [999] = {.lex_state = 15},
  [1000] = {.lex_state = 62, .external_lex_state = 6},
  [1001] = {.lex_state = 62, .external_lex_state = 6},
  [1002] = {.lex_state = 62},
  [1003] = {.lex_state = 0},
  [1004] = {.lex_state = 16},
  [1005] = {.lex_state = 16},
  [1006] = {.lex_state = 16},
  [1007] = {.lex_state = 62, .external_lex_state = 6},
  [1008] = {.lex_state = 16},
  [1009] = {.lex_state = 62, .external_lex_state = 6},
  [1010] = {.lex_state = 16},
  [1011] = {.lex_state = 16},
  [1012] = {.lex_state = 62},
  [1013] = {.lex_state = 62},
  [1014] = {.lex_state = 62, .external_lex_state = 6},
  [1015] = {.lex_state = 16},
  [1016] = {.lex_state = 15},
  [1017] = {.lex_state = 62},
  [1018] = {.lex_state = 62},
  [1019] = {.lex_state = 62, .external_lex_state = 6},
  [1020] = {.lex_state = 62},
  [1021] = {.lex_state = 16},
  [1022] = {.lex_state = 16},
  [1023] = {.lex_state = 16},
  [1024] = {.lex_state = 16},
  [1025] = {.lex_state = 16},
  [1026] = {.lex_state = 62, .external_lex_state = 6},
  [1027] = {.lex_state = 16},
  [1028] = {.lex_state = 16},
  [1029] = {.lex_state = 16},
  [1030] = {.lex_state = 16},
  [1031] = {.lex_state = 18, .external_lex_state = 7},
  [1032] = {.lex_state = 16},
  [1033] = {.lex_state = 62},
  [1034] = {.lex_state = 62, .external_lex_state = 6},
  [1035] = {.lex_state = 16},
  [1036] = {.lex_state = 62, .external_lex_state = 6},
  [1037] = {.lex_state = 62},
  [1038] = {.lex_state = 62},
  [1039] = {.lex_state = 62},
  [1040] = {.lex_state = 16},
  [1041] = {.lex_state = 16},
  [1042] = {.lex_state = 16},
  [1043] = {.lex_state = 62, .external_lex_state = 6},
  [1044] = {.lex_state = 62, .external_lex_state = 6},
  [1045] = {.lex_state = 62, .external_lex_state = 6},
  [1046] = {.lex_state = 62, .external_lex_state = 6},
  [1047] = {.lex_state = 16},
  [1048] = {.lex_state = 62, .external_lex_state = 6},
  [1049] = {.lex_state = 62},
  [1050] = {.lex_state = 16},
  [1051] = {.lex_state = 16},
  [1052] = {.lex_state = 62},
  [1053] = {.lex_state = 62},
  [1054] = {.lex_state = 62, .external_lex_state = 6},
  [1055] = {.lex_state = 18, .external_lex_state = 7},
  [1056] = {.lex_state = 62},
  [1057] = {.lex_state = 15, .external_lex_state = 6},
  [1058] = {.lex_state = 15},
  [1059] = {.lex_state = 16},
  [1060] = {.lex_state = 18, .external_lex_state = 7},
  [1061] = {.lex_state = 15},
  [1062] = {.lex_state = 62},
  [1063] = {.lex_state = 16},
  [1064] = {.lex_state = 16},
  [1065] = {.lex_state = 62, .external_lex_state = 6},
  [1066] = {.lex_state = 62, .external_lex_state = 6},
  [1067] = {.lex_state = 18, .external_lex_state = 7},
  [1068] = {.lex_state = 15, .external_lex_state = 6},
  [1069] = {.lex_state = 18, .external_lex_state = 7},
  [1070] = {.lex_state = 16},
  [1071] = {.lex_state = 62},
  [1072] = {.lex_state = 18, .external_lex_state = 7},
  [1073] = {.lex_state = 16},
  [1074] = {.lex_state = 18, .external_lex_state = 7},
  [1075] = {.lex_state = 16},
  [1076] = {.lex_state = 18, .external_lex_state = 7},
  [1077] = {.lex_state = 16},
  [1078] = {.lex_state = 62, .external_lex_state = 6},
  [1079] = {.lex_state = 16},
  [1080] = {.lex_state = 16},
  [1081] = {.lex_state = 16},
  [1082] = {.lex_state = 62, .external_lex_state = 6},
  [1083] = {.lex_state = 16},
  [1084] = {.lex_state = 16},
  [1085] = {.lex_state = 16},
  [1086] = {.lex_state = 16},
  [1087] = {.lex_state = 16},
  [1088] = {.lex_state = 15, .external_lex_state = 6},
  [1089] = {.lex_state = 16},
  [1090] = {.lex_state = 62},
  [1091] = {.lex_state = 62},
  [1092] = {.lex_state = 62, .external_lex_state = 6},
  [1093] = {.lex_state = 62, .external_lex_state = 6},
  [1094] = {.lex_state = 62, .external_lex_state = 6},
  [1095] = {.lex_state = 62, .external_lex_state = 6},
  [1096] = {.lex_state = 62, .external_lex_state = 6},
  [1097] = {.lex_state = 16},
  [1098] = {.lex_state = 62},
  [1099] = {.lex_state = 8},
  [1100] = {.lex_state = 0},
  [1101] = {.lex_state = 15, .external_lex_state = 6},
  [1102] = {.lex_state = 62},
  [1103] = {.lex_state = 62},
  [1104] = {.lex_state = 16},
  [1105] = {.lex_state = 62, .external_lex_state = 6},
  [1106] = {.lex_state = 16},
  [1107] = {.lex_state = 16},
  [1108] = {.lex_state = 16},
  [1109] = {.lex_state = 62, .external_lex_state = 6},
  [1110] = {.lex_state = 16},
  [1111] = {.lex_state = 0},
  [1112] = {.lex_state = 62, .external_lex_state = 6},
  [1113] = {.lex_state = 62, .external_lex_state = 6},
  [1114] = {.lex_state = 0},
  [1115] = {.lex_state = 0},
  [1116] = {.lex_state = 62},
  [1117] = {.lex_state = 8},
  [1118] = {.lex_state = 62, .external_lex_state = 6},
  [1119] = {.lex_state = 62},
  [1120] = {.lex_state = 16},
  [1121] = {.lex_state = 62, .external_lex_state = 6},
  [1122] = {.lex_state = 62, .external_lex_state = 6},
  [1123] = {.lex_state = 16},
  [1124] = {.lex_state = 62},
  [1125] = {.lex_state = 8},
  [1126] = {.lex_state = 62},
  [1127] = {.lex_state = 62},
  [1128] = {.lex_state = 0},
  [1129] = {.lex_state = 62},
  [1130] = {.lex_state = 62},
  [1131] = {.lex_state = 0},
  [1132] = {.lex_state = 0},
  [1133] = {.lex_state = 16},
  [1134] = {.lex_state = 16},
  [1135] = {.lex_state = 16},
  [1136] = {.lex_state = 16},
  [1137] = {.lex_state = 0, .external_lex_state = 6},
  [1138] = {.lex_state = 0, .external_lex_state = 6},
  [1139] = {.lex_state = 16},
  [1140] = {.lex_state = 16},
  [1141] = {.lex_state = 16},
  [1142] = {.lex_state = 62},
  [1143] = {.lex_state = 0, .external_lex_state = 6},
  [1144] = {.lex_state = 15},
  [1145] = {.lex_state = 16},
  [1146] = {.lex_state = 0},
  [1147] = {.lex_state = 62},
  [1148] = {.lex_state = 16},
  [1149] = {.lex_state = 62},
  [1150] = {.lex_state = 0, .external_lex_state = 6},
  [1151] = {.lex_state = 16},
  [1152] = {.lex_state = 62},
  [1153] = {.lex_state = 16},
  [1154] = {.lex_state = 0, .external_lex_state = 6},
  [1155] = {.lex_state = 0, .external_lex_state = 6},
  [1156] = {.lex_state = 62, .external_lex_state = 6},
  [1157] = {.lex_state = 16},
  [1158] = {.lex_state = 16},
  [1159] = {.lex_state = 16},
  [1160] = {.lex_state = 0, .external_lex_state = 6},
  [1161] = {.lex_state = 62},
  [1162] = {.lex_state = 0, .external_lex_state = 6},
  [1163] = {.lex_state = 0, .external_lex_state = 6},
  [1164] = {.lex_state = 0, .external_lex_state = 6},
  [1165] = {.lex_state = 15},
  [1166] = {.lex_state = 0},
  [1167] = {.lex_state = 0},
  [1168] = {.lex_state = 16, .external_lex_state = 2},
  [1169] = {.lex_state = 62},
  [1170] = {.lex_state = 0},
  [1171] = {.lex_state = 0, .external_lex_state = 6},
  [1172] = {.lex_state = 0, .external_lex_state = 6},
  [1173] = {.lex_state = 16},
  [1174] = {.lex_state = 0, .external_lex_state = 6},
  [1175] = {.lex_state = 0},
  [1176] = {.lex_state = 0},
  [1177] = {.lex_state = 16},
  [1178] = {.lex_state = 16},
  [1179] = {.lex_state = 62},
  [1180] = {.lex_state = 62},
  [1181] = {.lex_state = 16},
  [1182] = {.lex_state = 62},
  [1183] = {.lex_state = 62, .external_lex_state = 6},
  [1184] = {.lex_state = 62},
  [1185] = {.lex_state = 62},
  [1186] = {.lex_state = 62},
  [1187] = {.lex_state = 62, .external_lex_state = 6},
  [1188] = {.lex_state = 62},
  [1189] = {.lex_state = 0, .external_lex_state = 6},
  [1190] = {.lex_state = 16},
  [1191] = {.lex_state = 0, .external_lex_state = 6},
  [1192] = {.lex_state = 0, .external_lex_state = 6},
  [1193] = {.lex_state = 62},
  [1194] = {.lex_state = 0, .external_lex_state = 6},
  [1195] = {.lex_state = 62},
  [1196] = {.lex_state = 0},
  [1197] = {.lex_state = 62},
  [1198] = {.lex_state = 0, .external_lex_state = 6},
  [1199] = {.lex_state = 62},
  [1200] = {.lex_state = 0, .external_lex_state = 6},
  [1201] = {.lex_state = 16},
  [1202] = {.lex_state = 0},
  [1203] = {.lex_state = 0},
  [1204] = {.lex_state = 16},
  [1205] = {.lex_state = 0},
  [1206] = {.lex_state = 0},
  [1207] = {.lex_state = 16},
  [1208] = {.lex_state = 0},
  [1209] = {.lex_state = 0, .external_lex_state = 6},
  [1210] = {.lex_state = 16},
  [1211] = {.lex_state = 0},
  [1212] = {.lex_state = 0},
  [1213] = {.lex_state = 0},
  [1214] = {.lex_state = 0, .external_lex_state = 6},
  [1215] = {.lex_state = 62},
  [1216] = {.lex_state = 0},
  [1217] = {.lex_state = 0},
  [1218] = {.lex_state = 0},
  [1219] = {.lex_state = 0},
  [1220] = {.lex_state = 0},
  [1221] = {.lex_state = 16},
  [1222] = {.lex_state = 8},
  [1223] = {.lex_state = 0, .external_lex_state = 6},
  [1224] = {.lex_state = 16},
  [1225] = {.lex_state = 0},
  [1226] = {.lex_state = 0, .external_lex_state = 6},
  [1227] = {.lex_state = 0},
  [1228] = {.lex_state = 0},
  [1229] = {.lex_state = 0},
  [1230] = {.lex_state = 0},
  [1231] = {.lex_state = 0, .external_lex_state = 6},
  [1232] = {.lex_state = 0},
  [1233] = {.lex_state = 0},
  [1234] = {.lex_state = 0},
  [1235] = {.lex_state = 0},
  [1236] = {.lex_state = 62},
  [1237] = {.lex_state = 0, .external_lex_state = 6},
  [1238] = {.lex_state = 0, .external_lex_state = 6},
  [1239] = {.lex_state = 0},
  [1240] = {.lex_state = 0},
  [1241] = {.lex_state = 0, .external_lex_state = 6},
  [1242] = {.lex_state = 0},
  [1243] = {.lex_state = 0},
  [1244] = {.lex_state = 0, .external_lex_state = 6},
  [1245] = {.lex_state = 62},
  [1246] = {.lex_state = 0, .external_lex_state = 6},
  [1247] = {.lex_state = 0},
  [1248] = {.lex_state = 0, .external_lex_state = 6},
  [1249] = {.lex_state = 0},
  [1250] = {.lex_state = 16},
  [1251] = {.lex_state = 0},
  [1252] = {.lex_state = 0},
  [1253] = {.lex_state = 8},
  [1254] = {.lex_state = 0, .external_lex_state = 6},
  [1255] = {.lex_state = 0},
  [1256] = {.lex_state = 0},
  [1257] = {.lex_state = 0},
  [1258] = {.lex_state = 0},
  [1259] = {.lex_state = 62},
  [1260] = {.lex_state = 16},
  [1261] = {.lex_state = 0, .external_lex_state = 6},
  [1262] = {.lex_state = 15},
  [1263] = {.lex_state = 0, .external_lex_state = 6},
  [1264] = {.lex_state = 0},
  [1265] = {.lex_state = 0},
  [1266] = {.lex_state = 16},
  [1267] = {.lex_state = 16},
  [1268] = {.lex_state = 0},
  [1269] = {.lex_state = 8},
  [1270] = {.lex_state = 16},
  [1271] = {.lex_state = 0},
  [1272] = {.lex_state = 0},
  [1273] = {.lex_state = 0},
  [1274] = {.lex_state = 0},
  [1275] = {.lex_state = 0},
  [1276] = {.lex_state = 62},
  [1277] = {.lex_state = 0},
  [1278] = {.lex_state = 16},
  [1279] = {.lex_state = 0},
  [1280] = {.lex_state = 0},
  [1281] = {.lex_state = 16},
  [1282] = {.lex_state = 0},
  [1283] = {.lex_state = 0},
  [1284] = {.lex_state = 16},
  [1285] = {.lex_state = 0},
  [1286] = {.lex_state = 16},
  [1287] = {.lex_state = 16},
  [1288] = {.lex_state = 62, .external_lex_state = 6},
  [1289] = {.lex_state = 0},
  [1290] = {.lex_state = 0},
  [1291] = {.lex_state = 62, .external_lex_state = 6},
  [1292] = {.lex_state = 0},
  [1293] = {.lex_state = 62},
  [1294] = {.lex_state = 0},
  [1295] = {.lex_state = 16},
  [1296] = {.lex_state = 0},
  [1297] = {.lex_state = 0},
  [1298] = {.lex_state = 0},
  [1299] = {.lex_state = 0},
  [1300] = {.lex_state = 0},
  [1301] = {.lex_state = 0},
  [1302] = {.lex_state = 0},
  [1303] = {.lex_state = 0},
  [1304] = {.lex_state = 0},
  [1305] = {.lex_state = 62},
  [1306] = {.lex_state = 62},
  [1307] = {.lex_state = 8},
  [1308] = {.lex_state = 16},
  [1309] = {.lex_state = 0, .external_lex_state = 6},
  [1310] = {.lex_state = 0},
  [1311] = {.lex_state = 0},
  [1312] = {.lex_state = 62},
  [1313] = {.lex_state = 0},
  [1314] = {.lex_state = 62},
  [1315] = {.lex_state = 16},
  [1316] = {.lex_state = 0},
  [1317] = {.lex_state = 62},
  [1318] = {.lex_state = 62, .external_lex_state = 6},
  [1319] = {.lex_state = 0, .external_lex_state = 6},
  [1320] = {.lex_state = 16},
  [1321] = {.lex_state = 0},
  [1322] = {.lex_state = 16},
  [1323] = {.lex_state = 0},
  [1324] = {.lex_state = 0},
  [1325] = {.lex_state = 0},
  [1326] = {.lex_state = 0},
  [1327] = {.lex_state = 0},
  [1328] = {.lex_state = 0},
  [1329] = {.lex_state = 62},
  [1330] = {.lex_state = 0},
  [1331] = {.lex_state = 0},
  [1332] = {.lex_state = 8},
  [1333] = {.lex_state = 16},
  [1334] = {.lex_state = 16},
  [1335] = {.lex_state = 62, .external_lex_state = 6},
  [1336] = {.lex_state = 0},
  [1337] = {.lex_state = 0},
  [1338] = {.lex_state = 62},
  [1339] = {.lex_state = 16},
  [1340] = {.lex_state = 16},
  [1341] = {.lex_state = 0},
  [1342] = {.lex_state = 0, .external_lex_state = 6},
  [1343] = {.lex_state = 0},
  [1344] = {.lex_state = 17},
  [1345] = {.lex_state = 0, .external_lex_state = 6},
  [1346] = {.lex_state = 0, .external_lex_state = 6},
  [1347] = {.lex_state = 16},
  [1348] = {.lex_state = 0, .external_lex_state = 6},
  [1349] = {.lex_state = 0, .external_lex_state = 6},
  [1350] = {.lex_state = 0, .external_lex_state = 6},
  [1351] = {.lex_state = 0, .external_lex_state = 6},
  [1352] = {.lex_state = 0},
  [1353] = {.lex_state = 62},
  [1354] = {.lex_state = 0},
  [1355] = {.lex_state = 0},
  [1356] = {.lex_state = 0},
  [1357] = {.lex_state = 62},
  [1358] = {.lex_state = 0},
  [1359] = {.lex_state = 0},
  [1360] = {.lex_state = 0},
  [1361] = {.lex_state = 0, .external_lex_state = 6},
  [1362] = {.lex_state = 0},
  [1363] = {.lex_state = 17},
  [1364] = {.lex_state = 0},
  [1365] = {.lex_state = 15},
  [1366] = {.lex_state = 0},
  [1367] = {.lex_state = 0},
  [1368] = {.lex_state = 0},
  [1369] = {.lex_state = 0, .external_lex_state = 6},
  [1370] = {.lex_state = 0},
  [1371] = {.lex_state = 17},
  [1372] = {.lex_state = 17},
  [1373] = {.lex_state = 0},
  [1374] = {.lex_state = 17},
  [1375] = {.lex_state = 17},
  [1376] = {.lex_state = 17},
  [1377] = {.lex_state = 17},
  [1378] = {.lex_state = 17},
  [1379] = {.lex_state = 0},
  [1380] = {.lex_state = 17},
  [1381] = {.lex_state = 0},
  [1382] = {.lex_state = 0},
  [1383] = {.lex_state = 0, .external_lex_state = 6},
  [1384] = {.lex_state = 0},
  [1385] = {.lex_state = 0, .external_lex_state = 6},
  [1386] = {.lex_state = 0, .external_lex_state = 6},
  [1387] = {.lex_state = 0},
  [1388] = {.lex_state = 0},
  [1389] = {.lex_state = 0, .external_lex_state = 6},
  [1390] = {.lex_state = 0},
  [1391] = {.lex_state = 0, .external_lex_state = 6},
  [1392] = {.lex_state = 0},
  [1393] = {.lex_state = 0, .external_lex_state = 6},
  [1394] = {.lex_state = 0, .external_lex_state = 6},
  [1395] = {.lex_state = 0, .external_lex_state = 6},
  [1396] = {.lex_state = 0},
  [1397] = {.lex_state = 0},
  [1398] = {.lex_state = 0},
  [1399] = {.lex_state = 0},
  [1400] = {.lex_state = 0, .external_lex_state = 6},
  [1401] = {.lex_state = 0},
  [1402] = {.lex_state = 0},
  [1403] = {.lex_state = 0},
  [1404] = {.lex_state = 0},
  [1405] = {.lex_state = 0},
  [1406] = {.lex_state = 0},
  [1407] = {.lex_state = 0},
  [1408] = {.lex_state = 62},
  [1409] = {.lex_state = 0},
  [1410] = {.lex_state = 0},
  [1411] = {.lex_state = 0},
  [1412] = {.lex_state = 0},
  [1413] = {.lex_state = 16},
  [1414] = {.lex_state = 0},
  [1415] = {.lex_state = 0},
  [1416] = {.lex_state = 62},
  [1417] = {.lex_state = 0},
  [1418] = {.lex_state = 0},
  [1419] = {.lex_state = 62},
  [1420] = {.lex_state = 0},
  [1421] = {.lex_state = 62},
  [1422] = {.lex_state = 16},
  [1423] = {.lex_state = 16},
  [1424] = {.lex_state = 0},
  [1425] = {.lex_state = 0},
  [1426] = {.lex_state = 0},
  [1427] = {.lex_state = 16},
  [1428] = {.lex_state = 16},
  [1429] = {.lex_state = 0},
  [1430] = {.lex_state = 62},
  [1431] = {.lex_state = 0},
  [1432] = {.lex_state = 0},
  [1433] = {.lex_state = 0},
  [1434] = {.lex_state = 0},
  [1435] = {.lex_state = 16},
  [1436] = {.lex_state = 62},
  [1437] = {.lex_state = 0},
  [1438] = {.lex_state = 0},
  [1439] = {.lex_state = 0},
  [1440] = {.lex_state = 62},
  [1441] = {.lex_state = 62},
  [1442] = {.lex_state = 0},
  [1443] = {.lex_state = 62},
  [1444] = {.lex_state = 62},
  [1445] = {.lex_state = 62},
  [1446] = {.lex_state = 62},
  [1447] = {.lex_state = 0},
  [1448] = {.lex_state = 62},
  [1449] = {.lex_state = 62},
  [1450] = {.lex_state = 62},
  [1451] = {.lex_state = 16},
  [1452] = {.lex_state = 16},
  [1453] = {.lex_state = 16},
  [1454] = {.lex_state = 62},
  [1455] = {.lex_state = 0},
  [1456] = {.lex_state = 62},
  [1457] = {.lex_state = 62},
  [1458] = {.lex_state = 16},
  [1459] = {.lex_state = 16},
  [1460] = {.lex_state = 0},
  [1461] = {.lex_state = 0},
  [1462] = {.lex_state = 0},
  [1463] = {.lex_state = 16},
  [1464] = {.lex_state = 0},
  [1465] = {.lex_state = 16},
  [1466] = {.lex_state = 62},
  [1467] = {.lex_state = 0},
  [1468] = {.lex_state = 16},
  [1469] = {.lex_state = 0},
  [1470] = {.lex_state = 16},
  [1471] = {.lex_state = 16},
  [1472] = {.lex_state = 16},
  [1473] = {.lex_state = 0},
  [1474] = {.lex_state = 16},
  [1475] = {.lex_state = 0},
  [1476] = {.lex_state = 16},
  [1477] = {.lex_state = 62},
  [1478] = {.lex_state = 16},
  [1479] = {.lex_state = 0},
  [1480] = {.lex_state = 16},
  [1481] = {.lex_state = 16},
  [1482] = {.lex_state = 16},
  [1483] = {.lex_state = 16},
  [1484] = {.lex_state = 0},
  [1485] = {.lex_state = 16},
  [1486] = {.lex_state = 16},
  [1487] = {.lex_state = 16},
  [1488] = {.lex_state = 62},
  [1489] = {.lex_state = 16},
  [1490] = {.lex_state = 62},
  [1491] = {.lex_state = 16},
  [1492] = {.lex_state = 0},
  [1493] = {.lex_state = 16},
  [1494] = {.lex_state = 62},
  [1495] = {.lex_state = 16},
  [1496] = {.lex_state = 0},
  [1497] = {.lex_state = 0},
  [1498] = {.lex_state = 62},
  [1499] = {.lex_state = 16},
  [1500] = {.lex_state = 62},
  [1501] = {.lex_state = 16},
  [1502] = {.lex_state = 0},
  [1503] = {.lex_state = 0},
  [1504] = {.lex_state = 0},
  [1505] = {.lex_state = 16},
  [1506] = {.lex_state = 16},
  [1507] = {.lex_state = 16},
  [1508] = {.lex_state = 62},
  [1509] = {.lex_state = 62},
  [1510] = {.lex_state = 62},
  [1511] = {.lex_state = 62},
  [1512] = {.lex_state = 16},
  [1513] = {.lex_state = 0},
  [1514] = {.lex_state = 62},
  [1515] = {.lex_state = 0},
  [1516] = {.lex_state = 62},
  [1517] = {.lex_state = 62},
  [1518] = {.lex_state = 16},
  [1519] = {.lex_state = 62},
  [1520] = {.lex_state = 62},
  [1521] = {.lex_state = 16},
  [1522] = {.lex_state = 62},
  [1523] = {.lex_state = 0},
  [1524] = {.lex_state = 16},
};

enum {
  ts_external_token__newline = 0,
  ts_external_token__indent = 1,
  ts_external_token__dedent = 2,
  ts_external_token__string_start = 3,
  ts_external_token__string_content = 4,
  ts_external_token__string_end = 5,
};

static const TSSymbol ts_external_scanner_symbol_map[EXTERNAL_TOKEN_COUNT] = {
  [ts_external_token__newline] = sym__newline,
  [ts_external_token__indent] = sym__indent,
  [ts_external_token__dedent] = sym__dedent,
  [ts_external_token__string_start] = sym__string_start,
  [ts_external_token__string_content] = sym__string_content,
  [ts_external_token__string_end] = sym__string_end,
};

static const bool ts_external_scanner_states[8][EXTERNAL_TOKEN_COUNT] = {
  [1] = {
    [ts_external_token__newline] = true,
    [ts_external_token__indent] = true,
    [ts_external_token__dedent] = true,
    [ts_external_token__string_start] = true,
    [ts_external_token__string_content] = true,
    [ts_external_token__string_end] = true,
  },
  [2] = {
    [ts_external_token__string_start] = true,
  },
  [3] = {
    [ts_external_token__dedent] = true,
    [ts_external_token__string_start] = true,
  },
  [4] = {
    [ts_external_token__newline] = true,
    [ts_external_token__string_start] = true,
  },
  [5] = {
    [ts_external_token__newline] = true,
    [ts_external_token__indent] = true,
    [ts_external_token__string_start] = true,
  },
  [6] = {
    [ts_external_token__newline] = true,
  },
  [7] = {
    [ts_external_token__string_content] = true,
    [ts_external_token__string_end] = true,
  },
};

static const uint16_t ts_parse_table[LARGE_STATE_COUNT][SYMBOL_COUNT] = {
  [0] = {
    [ts_builtin_sym_end] = ACTIONS(1),
    [sym_identifier] = ACTIONS(1),
    [anon_sym_import] = ACTIONS(1),
    [anon_sym_DOT] = ACTIONS(1),
    [anon_sym_from] = ACTIONS(1),
    [anon_sym___future__] = ACTIONS(1),
    [anon_sym_LPAREN] = ACTIONS(1),
    [anon_sym_RPAREN] = ACTIONS(1),
    [anon_sym_COMMA] = ACTIONS(1),
    [anon_sym_as] = ACTIONS(1),
    [anon_sym_STAR] = ACTIONS(1),
    [anon_sym_print] = ACTIONS(1),
    [anon_sym_GT_GT] = ACTIONS(1),
    [anon_sym_assert] = ACTIONS(1),
    [anon_sym_COLON_EQ] = ACTIONS(1),
    [anon_sym_return] = ACTIONS(1),
    [anon_sym_del] = ACTIONS(1),
    [anon_sym_raise] = ACTIONS(1),
    [anon_sym_pass] = ACTIONS(1),
    [anon_sym_break] = ACTIONS(1),
    [anon_sym_continue] = ACTIONS(1),
    [anon_sym_if] = ACTIONS(1),
    [anon_sym_COLON] = ACTIONS(1),
    [anon_sym_elif] = ACTIONS(1),
    [anon_sym_else] = ACTIONS(1),
    [anon_sym_async] = ACTIONS(1),
    [anon_sym_for] = ACTIONS(1),
    [anon_sym_in] = ACTIONS(1),
    [anon_sym_while] = ACTIONS(1),
    [anon_sym_try] = ACTIONS(1),
    [anon_sym_except] = ACTIONS(1),
    [anon_sym_except_STAR] = ACTIONS(1),
    [anon_sym_finally] = ACTIONS(1),
    [anon_sym_with] = ACTIONS(1),
    [anon_sym_match] = ACTIONS(1),
    [anon_sym_case] = ACTIONS(1),
    [anon_sym_PIPE] = ACTIONS(1),
    [anon_sym_DASH] = ACTIONS(1),
    [anon_sym_PLUS] = ACTIONS(1),
    [sym_match_wildcard_pattern] = ACTIONS(1),
    [anon_sym_LBRACK] = ACTIONS(1),
    [anon_sym_RBRACK] = ACTIONS(1),
    [anon_sym_LBRACE] = ACTIONS(1),
    [anon_sym_RBRACE] = ACTIONS(1),
    [anon_sym_STAR_STAR] = ACTIONS(1),
    [anon_sym_EQ] = ACTIONS(1),
    [anon_sym_def] = ACTIONS(1),
    [anon_sym_DASH_GT] = ACTIONS(1),
    [anon_sym_global] = ACTIONS(1),
    [anon_sym_nonlocal] = ACTIONS(1),
    [anon_sym_exec] = ACTIONS(1),
    [anon_sym_type] = ACTIONS(1),
    [anon_sym_class] = ACTIONS(1),
    [anon_sym_AT] = ACTIONS(1),
    [anon_sym_not] = ACTIONS(1),
    [anon_sym_and] = ACTIONS(1),
    [anon_sym_or] = ACTIONS(1),
    [anon_sym_SLASH] = ACTIONS(1),
    [anon_sym_PERCENT] = ACTIONS(1),
    [anon_sym_SLASH_SLASH] = ACTIONS(1),
    [anon_sym_AMP] = ACTIONS(1),
    [anon_sym_CARET] = ACTIONS(1),
    [anon_sym_LT_LT] = ACTIONS(1),
    [anon_sym_TILDE] = ACTIONS(1),
    [anon_sym_LT] = ACTIONS(1),
    [anon_sym_LT_EQ] = ACTIONS(1),
    [anon_sym_EQ_EQ] = ACTIONS(1),
    [anon_sym_BANG_EQ] = ACTIONS(1),
    [anon_sym_GT_EQ] = ACTIONS(1),
    [anon_sym_GT] = ACTIONS(1),
    [anon_sym_LT_GT] = ACTIONS(1),
    [anon_sym_is] = ACTIONS(1),
    [anon_sym_lambda] = ACTIONS(1),
    [anon_sym_PLUS_EQ] = ACTIONS(1),
    [anon_sym_DASH_EQ] = ACTIONS(1),
    [anon_sym_STAR_EQ] = ACTIONS(1),
    [anon_sym_SLASH_EQ] = ACTIONS(1),
    [anon_sym_AT_EQ] = ACTIONS(1),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(1),
    [anon_sym_PERCENT_EQ] = ACTIONS(1),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1),
    [anon_sym_GT_GT_EQ] = ACTIONS(1),
    [anon_sym_LT_LT_EQ] = ACTIONS(1),
    [anon_sym_AMP_EQ] = ACTIONS(1),
    [anon_sym_CARET_EQ] = ACTIONS(1),
    [anon_sym_PIPE_EQ] = ACTIONS(1),
    [anon_sym_yield] = ACTIONS(1),
    [sym_ellipsis] = ACTIONS(1),
    [anon_sym_LBRACE2] = ACTIONS(1),
    [sym_type_conversion] = ACTIONS(1),
    [sym_integer] = ACTIONS(1),
    [sym_float] = ACTIONS(1),
    [anon_sym_await] = ACTIONS(1),
    [sym_true] = ACTIONS(1),
    [sym_false] = ACTIONS(1),
    [sym_none] = ACTIONS(1),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(1),
    [sym__newline] = ACTIONS(1),
    [sym__indent] = ACTIONS(1),
    [sym__dedent] = ACTIONS(1),
    [sym__string_start] = ACTIONS(1),
    [sym__string_content] = ACTIONS(1),
    [sym__string_end] = ACTIONS(1),
  },
  [1] = {
    [sym_module] = STATE(1502),
    [sym__statement] = STATE(64),
    [sym__simple_statements] = STATE(64),
    [sym_import_statement] = STATE(1209),
    [sym_future_import_statement] = STATE(1209),
    [sym_import_from_statement] = STATE(1209),
    [sym_print_statement] = STATE(1209),
    [sym_assert_statement] = STATE(1209),
    [sym_expression_statement] = STATE(1209),
    [sym_named_expression] = STATE(1009),
    [sym_return_statement] = STATE(1209),
    [sym_delete_statement] = STATE(1209),
    [sym_raise_statement] = STATE(1209),
    [sym_pass_statement] = STATE(1209),
    [sym_break_statement] = STATE(1209),
    [sym_continue_statement] = STATE(1209),
    [sym_if_statement] = STATE(64),
    [sym_for_statement] = STATE(64),
    [sym_while_statement] = STATE(64),
    [sym_try_statement] = STATE(64),
    [sym_with_statement] = STATE(64),
    [sym_match_statement] = STATE(64),
    [sym_function_definition] = STATE(64),
    [sym_list_splat] = STATE(1360),
    [sym_dictionary_splat] = STATE(1360),
    [sym_global_statement] = STATE(1209),
    [sym_nonlocal_statement] = STATE(1209),
    [sym_exec_statement] = STATE(1209),
    [sym_type_alias_statement] = STATE(1209),
    [sym_class_definition] = STATE(64),
    [sym_decorated_definition] = STATE(64),
    [sym_decorator] = STATE(1002),
    [sym_expression_list] = STATE(1361),
    [sym_pattern] = STATE(889),
    [sym_tuple_pattern] = STATE(875),
    [sym_list_pattern] = STATE(875),
    [sym_list_splat_pattern] = STATE(875),
    [sym_expression] = STATE(1019),
    [sym_primary_expression] = STATE(684),
    [sym_not_operator] = STATE(1009),
    [sym_boolean_operator] = STATE(1009),
    [sym_binary_operator] = STATE(797),
    [sym_unary_operator] = STATE(797),
    [sym_comparison_operator] = STATE(1009),
    [sym_lambda] = STATE(1009),
    [sym_assignment] = STATE(1361),
    [sym_augmented_assignment] = STATE(1361),
    [sym_pattern_list] = STATE(897),
    [sym_yield] = STATE(1361),
    [sym_attribute] = STATE(431),
    [sym_subscript] = STATE(431),
    [sym_call] = STATE(797),
    [sym_list] = STATE(797),
    [sym_set] = STATE(797),
    [sym_tuple] = STATE(797),
    [sym_dictionary] = STATE(797),
    [sym_list_comprehension] = STATE(797),
    [sym_dictionary_comprehension] = STATE(797),
    [sym_set_comprehension] = STATE(797),
    [sym_generator_expression] = STATE(797),
    [sym_parenthesized_expression] = STATE(797),
    [sym_conditional_expression] = STATE(1009),
    [sym_concatenated_string] = STATE(797),
    [sym_string] = STATE(713),
    [sym_await] = STATE(1009),
    [aux_sym_module_repeat1] = STATE(64),
    [aux_sym_decorated_definition_repeat1] = STATE(1002),
    [ts_builtin_sym_end] = ACTIONS(5),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_STAR] = ACTIONS(15),
    [anon_sym_print] = ACTIONS(17),
    [anon_sym_assert] = ACTIONS(19),
    [anon_sym_return] = ACTIONS(21),
    [anon_sym_del] = ACTIONS(23),
    [anon_sym_raise] = ACTIONS(25),
    [anon_sym_pass] = ACTIONS(27),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(33),
    [anon_sym_async] = ACTIONS(35),
    [anon_sym_for] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_try] = ACTIONS(41),
    [anon_sym_with] = ACTIONS(43),
    [anon_sym_match] = ACTIONS(45),
    [anon_sym_DASH] = ACTIONS(47),
    [anon_sym_PLUS] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(51),
    [anon_sym_STAR_STAR] = ACTIONS(53),
    [anon_sym_def] = ACTIONS(55),
    [anon_sym_global] = ACTIONS(57),
    [anon_sym_nonlocal] = ACTIONS(59),
    [anon_sym_exec] = ACTIONS(61),
    [anon_sym_type] = ACTIONS(63),
    [anon_sym_class] = ACTIONS(65),
    [anon_sym_AT] = ACTIONS(67),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(81),
  },
  [2] = {
    [sym__statement] = STATE(65),
    [sym__simple_statements] = STATE(65),
    [sym_import_statement] = STATE(1319),
    [sym_future_import_statement] = STATE(1319),
    [sym_import_from_statement] = STATE(1319),
    [sym_print_statement] = STATE(1319),
    [sym_assert_statement] = STATE(1319),
    [sym_expression_statement] = STATE(1319),
    [sym_named_expression] = STATE(1009),
    [sym_return_statement] = STATE(1319),
    [sym_delete_statement] = STATE(1319),
    [sym_raise_statement] = STATE(1319),
    [sym_pass_statement] = STATE(1319),
    [sym_break_statement] = STATE(1319),
    [sym_continue_statement] = STATE(1319),
    [sym_if_statement] = STATE(65),
    [sym_for_statement] = STATE(65),
    [sym_while_statement] = STATE(65),
    [sym_try_statement] = STATE(65),
    [sym_with_statement] = STATE(65),
    [sym_match_statement] = STATE(65),
    [sym_function_definition] = STATE(65),
    [sym_list_splat] = STATE(1360),
    [sym_dictionary_splat] = STATE(1360),
    [sym_global_statement] = STATE(1319),
    [sym_nonlocal_statement] = STATE(1319),
    [sym_exec_statement] = STATE(1319),
    [sym_type_alias_statement] = STATE(1319),
    [sym_class_definition] = STATE(65),
    [sym_decorated_definition] = STATE(65),
    [sym_decorator] = STATE(996),
    [sym_block] = STATE(357),
    [sym_expression_list] = STATE(1361),
    [sym_pattern] = STATE(889),
    [sym_tuple_pattern] = STATE(875),
    [sym_list_pattern] = STATE(875),
    [sym_list_splat_pattern] = STATE(875),
    [sym_expression] = STATE(1019),
    [sym_primary_expression] = STATE(684),
    [sym_not_operator] = STATE(1009),
    [sym_boolean_operator] = STATE(1009),
    [sym_binary_operator] = STATE(797),
    [sym_unary_operator] = STATE(797),
    [sym_comparison_operator] = STATE(1009),
    [sym_lambda] = STATE(1009),
    [sym_assignment] = STATE(1361),
    [sym_augmented_assignment] = STATE(1361),
    [sym_pattern_list] = STATE(897),
    [sym_yield] = STATE(1361),
    [sym_attribute] = STATE(431),
    [sym_subscript] = STATE(431),
    [sym_call] = STATE(797),
    [sym_list] = STATE(797),
    [sym_set] = STATE(797),
    [sym_tuple] = STATE(797),
    [sym_dictionary] = STATE(797),
    [sym_list_comprehension] = STATE(797),
    [sym_dictionary_comprehension] = STATE(797),
    [sym_set_comprehension] = STATE(797),
    [sym_generator_expression] = STATE(797),
    [sym_parenthesized_expression] = STATE(797),
    [sym_conditional_expression] = STATE(1009),
    [sym_concatenated_string] = STATE(797),
    [sym_string] = STATE(713),
    [sym_await] = STATE(1009),
    [aux_sym_module_repeat1] = STATE(65),
    [aux_sym_decorated_definition_repeat1] = STATE(996),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_STAR] = ACTIONS(15),
    [anon_sym_print] = ACTIONS(17),
    [anon_sym_assert] = ACTIONS(19),
    [anon_sym_return] = ACTIONS(21),
    [anon_sym_del] = ACTIONS(23),
    [anon_sym_raise] = ACTIONS(25),
    [anon_sym_pass] = ACTIONS(27),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_async] = ACTIONS(85),
    [anon_sym_for] = ACTIONS(87),
    [anon_sym_while] = ACTIONS(89),
    [anon_sym_try] = ACTIONS(91),
    [anon_sym_with] = ACTIONS(93),
    [anon_sym_match] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(47),
    [anon_sym_PLUS] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(51),
    [anon_sym_STAR_STAR] = ACTIONS(53),
    [anon_sym_def] = ACTIONS(97),
    [anon_sym_global] = ACTIONS(57),
    [anon_sym_nonlocal] = ACTIONS(59),
    [anon_sym_exec] = ACTIONS(61),
    [anon_sym_type] = ACTIONS(63),
    [anon_sym_class] = ACTIONS(99),
    [anon_sym_AT] = ACTIONS(67),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(101),
    [sym__string_start] = ACTIONS(81),
  },
  [3] = {
    [sym__statement] = STATE(68),
    [sym__simple_statements] = STATE(68),
    [sym_import_statement] = STATE(1319),
    [sym_future_import_statement] = STATE(1319),
    [sym_import_from_statement] = STATE(1319),
    [sym_print_statement] = STATE(1319),
    [sym_assert_statement] = STATE(1319),
    [sym_expression_statement] = STATE(1319),
    [sym_named_expression] = STATE(1009),
    [sym_return_statement] = STATE(1319),
    [sym_delete_statement] = STATE(1319),
    [sym_raise_statement] = STATE(1319),
    [sym_pass_statement] = STATE(1319),
    [sym_break_statement] = STATE(1319),
    [sym_continue_statement] = STATE(1319),
    [sym_if_statement] = STATE(68),
    [sym_for_statement] = STATE(68),
    [sym_while_statement] = STATE(68),
    [sym_try_statement] = STATE(68),
    [sym_with_statement] = STATE(68),
    [sym_match_statement] = STATE(68),
    [sym_function_definition] = STATE(68),
    [sym_list_splat] = STATE(1360),
    [sym_dictionary_splat] = STATE(1360),
    [sym_global_statement] = STATE(1319),
    [sym_nonlocal_statement] = STATE(1319),
    [sym_exec_statement] = STATE(1319),
    [sym_type_alias_statement] = STATE(1319),
    [sym_class_definition] = STATE(68),
    [sym_decorated_definition] = STATE(68),
    [sym_decorator] = STATE(996),
    [sym_block] = STATE(587),
    [sym_expression_list] = STATE(1361),
    [sym_pattern] = STATE(889),
    [sym_tuple_pattern] = STATE(875),
    [sym_list_pattern] = STATE(875),
    [sym_list_splat_pattern] = STATE(875),
    [sym_expression] = STATE(1019),
    [sym_primary_expression] = STATE(684),
    [sym_not_operator] = STATE(1009),
    [sym_boolean_operator] = STATE(1009),
    [sym_binary_operator] = STATE(797),
    [sym_unary_operator] = STATE(797),
    [sym_comparison_operator] = STATE(1009),
    [sym_lambda] = STATE(1009),
    [sym_assignment] = STATE(1361),
    [sym_augmented_assignment] = STATE(1361),
    [sym_pattern_list] = STATE(897),
    [sym_yield] = STATE(1361),
    [sym_attribute] = STATE(431),
    [sym_subscript] = STATE(431),
    [sym_call] = STATE(797),
    [sym_list] = STATE(797),
    [sym_set] = STATE(797),
    [sym_tuple] = STATE(797),
    [sym_dictionary] = STATE(797),
    [sym_list_comprehension] = STATE(797),
    [sym_dictionary_comprehension] = STATE(797),
    [sym_set_comprehension] = STATE(797),
    [sym_generator_expression] = STATE(797),
    [sym_parenthesized_expression] = STATE(797),
    [sym_conditional_expression] = STATE(1009),
    [sym_concatenated_string] = STATE(797),
    [sym_string] = STATE(713),
    [sym_await] = STATE(1009),
    [aux_sym_module_repeat1] = STATE(68),
    [aux_sym_decorated_definition_repeat1] = STATE(996),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_STAR] = ACTIONS(15),
    [anon_sym_print] = ACTIONS(17),
    [anon_sym_assert] = ACTIONS(19),
    [anon_sym_return] = ACTIONS(21),
    [anon_sym_del] = ACTIONS(23),
    [anon_sym_raise] = ACTIONS(25),
    [anon_sym_pass] = ACTIONS(27),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_async] = ACTIONS(85),
    [anon_sym_for] = ACTIONS(87),
    [anon_sym_while] = ACTIONS(89),
    [anon_sym_try] = ACTIONS(91),
    [anon_sym_with] = ACTIONS(93),
    [anon_sym_match] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(47),
    [anon_sym_PLUS] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(51),
    [anon_sym_STAR_STAR] = ACTIONS(53),
    [anon_sym_def] = ACTIONS(97),
    [anon_sym_global] = ACTIONS(57),
    [anon_sym_nonlocal] = ACTIONS(59),
    [anon_sym_exec] = ACTIONS(61),
    [anon_sym_type] = ACTIONS(63),
    [anon_sym_class] = ACTIONS(99),
    [anon_sym_AT] = ACTIONS(67),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(103),
    [sym__string_start] = ACTIONS(81),
  },
  [4] = {
    [sym__statement] = STATE(68),
    [sym__simple_statements] = STATE(68),
    [sym_import_statement] = STATE(1319),
    [sym_future_import_statement] = STATE(1319),
    [sym_import_from_statement] = STATE(1319),
    [sym_print_statement] = STATE(1319),
    [sym_assert_statement] = STATE(1319),
    [sym_expression_statement] = STATE(1319),
    [sym_named_expression] = STATE(1009),
    [sym_return_statement] = STATE(1319),
    [sym_delete_statement] = STATE(1319),
    [sym_raise_statement] = STATE(1319),
    [sym_pass_statement] = STATE(1319),
    [sym_break_statement] = STATE(1319),
    [sym_continue_statement] = STATE(1319),
    [sym_if_statement] = STATE(68),
    [sym_for_statement] = STATE(68),
    [sym_while_statement] = STATE(68),
    [sym_try_statement] = STATE(68),
    [sym_with_statement] = STATE(68),
    [sym_match_statement] = STATE(68),
    [sym_function_definition] = STATE(68),
    [sym_list_splat] = STATE(1360),
    [sym_dictionary_splat] = STATE(1360),
    [sym_global_statement] = STATE(1319),
    [sym_nonlocal_statement] = STATE(1319),
    [sym_exec_statement] = STATE(1319),
    [sym_type_alias_statement] = STATE(1319),
    [sym_class_definition] = STATE(68),
    [sym_decorated_definition] = STATE(68),
    [sym_decorator] = STATE(996),
    [sym_block] = STATE(540),
    [sym_expression_list] = STATE(1361),
    [sym_pattern] = STATE(889),
    [sym_tuple_pattern] = STATE(875),
    [sym_list_pattern] = STATE(875),
    [sym_list_splat_pattern] = STATE(875),
    [sym_expression] = STATE(1019),
    [sym_primary_expression] = STATE(684),
    [sym_not_operator] = STATE(1009),
    [sym_boolean_operator] = STATE(1009),
    [sym_binary_operator] = STATE(797),
    [sym_unary_operator] = STATE(797),
    [sym_comparison_operator] = STATE(1009),
    [sym_lambda] = STATE(1009),
    [sym_assignment] = STATE(1361),
    [sym_augmented_assignment] = STATE(1361),
    [sym_pattern_list] = STATE(897),
    [sym_yield] = STATE(1361),
    [sym_attribute] = STATE(431),
    [sym_subscript] = STATE(431),
    [sym_call] = STATE(797),
    [sym_list] = STATE(797),
    [sym_set] = STATE(797),
    [sym_tuple] = STATE(797),
    [sym_dictionary] = STATE(797),
    [sym_list_comprehension] = STATE(797),
    [sym_dictionary_comprehension] = STATE(797),
    [sym_set_comprehension] = STATE(797),
    [sym_generator_expression] = STATE(797),
    [sym_parenthesized_expression] = STATE(797),
    [sym_conditional_expression] = STATE(1009),
    [sym_concatenated_string] = STATE(797),
    [sym_string] = STATE(713),
    [sym_await] = STATE(1009),
    [aux_sym_module_repeat1] = STATE(68),
    [aux_sym_decorated_definition_repeat1] = STATE(996),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_STAR] = ACTIONS(15),
    [anon_sym_print] = ACTIONS(17),
    [anon_sym_assert] = ACTIONS(19),
    [anon_sym_return] = ACTIONS(21),
    [anon_sym_del] = ACTIONS(23),
    [anon_sym_raise] = ACTIONS(25),
    [anon_sym_pass] = ACTIONS(27),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_async] = ACTIONS(85),
    [anon_sym_for] = ACTIONS(87),
    [anon_sym_while] = ACTIONS(89),
    [anon_sym_try] = ACTIONS(91),
    [anon_sym_with] = ACTIONS(93),
    [anon_sym_match] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(47),
    [anon_sym_PLUS] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(51),
    [anon_sym_STAR_STAR] = ACTIONS(53),
    [anon_sym_def] = ACTIONS(97),
    [anon_sym_global] = ACTIONS(57),
    [anon_sym_nonlocal] = ACTIONS(59),
    [anon_sym_exec] = ACTIONS(61),
    [anon_sym_type] = ACTIONS(63),
    [anon_sym_class] = ACTIONS(99),
    [anon_sym_AT] = ACTIONS(67),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(103),
    [sym__string_start] = ACTIONS(81),
  },
  [5] = {
    [sym__statement] = STATE(68),
    [sym__simple_statements] = STATE(68),
    [sym_import_statement] = STATE(1319),
    [sym_future_import_statement] = STATE(1319),
    [sym_import_from_statement] = STATE(1319),
    [sym_print_statement] = STATE(1319),
    [sym_assert_statement] = STATE(1319),
    [sym_expression_statement] = STATE(1319),
    [sym_named_expression] = STATE(1009),
    [sym_return_statement] = STATE(1319),
    [sym_delete_statement] = STATE(1319),
    [sym_raise_statement] = STATE(1319),
    [sym_pass_statement] = STATE(1319),
    [sym_break_statement] = STATE(1319),
    [sym_continue_statement] = STATE(1319),
    [sym_if_statement] = STATE(68),
    [sym_for_statement] = STATE(68),
    [sym_while_statement] = STATE(68),
    [sym_try_statement] = STATE(68),
    [sym_with_statement] = STATE(68),
    [sym_match_statement] = STATE(68),
    [sym_function_definition] = STATE(68),
    [sym_list_splat] = STATE(1360),
    [sym_dictionary_splat] = STATE(1360),
    [sym_global_statement] = STATE(1319),
    [sym_nonlocal_statement] = STATE(1319),
    [sym_exec_statement] = STATE(1319),
    [sym_type_alias_statement] = STATE(1319),
    [sym_class_definition] = STATE(68),
    [sym_decorated_definition] = STATE(68),
    [sym_decorator] = STATE(996),
    [sym_block] = STATE(534),
    [sym_expression_list] = STATE(1361),
    [sym_pattern] = STATE(889),
    [sym_tuple_pattern] = STATE(875),
    [sym_list_pattern] = STATE(875),
    [sym_list_splat_pattern] = STATE(875),
    [sym_expression] = STATE(1019),
    [sym_primary_expression] = STATE(684),
    [sym_not_operator] = STATE(1009),
    [sym_boolean_operator] = STATE(1009),
    [sym_binary_operator] = STATE(797),
    [sym_unary_operator] = STATE(797),
    [sym_comparison_operator] = STATE(1009),
    [sym_lambda] = STATE(1009),
    [sym_assignment] = STATE(1361),
    [sym_augmented_assignment] = STATE(1361),
    [sym_pattern_list] = STATE(897),
    [sym_yield] = STATE(1361),
    [sym_attribute] = STATE(431),
    [sym_subscript] = STATE(431),
    [sym_call] = STATE(797),
    [sym_list] = STATE(797),
    [sym_set] = STATE(797),
    [sym_tuple] = STATE(797),
    [sym_dictionary] = STATE(797),
    [sym_list_comprehension] = STATE(797),
    [sym_dictionary_comprehension] = STATE(797),
    [sym_set_comprehension] = STATE(797),
    [sym_generator_expression] = STATE(797),
    [sym_parenthesized_expression] = STATE(797),
    [sym_conditional_expression] = STATE(1009),
    [sym_concatenated_string] = STATE(797),
    [sym_string] = STATE(713),
    [sym_await] = STATE(1009),
    [aux_sym_module_repeat1] = STATE(68),
    [aux_sym_decorated_definition_repeat1] = STATE(996),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_STAR] = ACTIONS(15),
    [anon_sym_print] = ACTIONS(17),
    [anon_sym_assert] = ACTIONS(19),
    [anon_sym_return] = ACTIONS(21),
    [anon_sym_del] = ACTIONS(23),
    [anon_sym_raise] = ACTIONS(25),
    [anon_sym_pass] = ACTIONS(27),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_async] = ACTIONS(85),
    [anon_sym_for] = ACTIONS(87),
    [anon_sym_while] = ACTIONS(89),
    [anon_sym_try] = ACTIONS(91),
    [anon_sym_with] = ACTIONS(93),
    [anon_sym_match] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(47),
    [anon_sym_PLUS] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(51),
    [anon_sym_STAR_STAR] = ACTIONS(53),
    [anon_sym_def] = ACTIONS(97),
    [anon_sym_global] = ACTIONS(57),
    [anon_sym_nonlocal] = ACTIONS(59),
    [anon_sym_exec] = ACTIONS(61),
    [anon_sym_type] = ACTIONS(63),
    [anon_sym_class] = ACTIONS(99),
    [anon_sym_AT] = ACTIONS(67),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(103),
    [sym__string_start] = ACTIONS(81),
  },
  [6] = {
    [sym__statement] = STATE(65),
    [sym__simple_statements] = STATE(65),
    [sym_import_statement] = STATE(1319),
    [sym_future_import_statement] = STATE(1319),
    [sym_import_from_statement] = STATE(1319),
    [sym_print_statement] = STATE(1319),
    [sym_assert_statement] = STATE(1319),
    [sym_expression_statement] = STATE(1319),
    [sym_named_expression] = STATE(1009),
    [sym_return_statement] = STATE(1319),
    [sym_delete_statement] = STATE(1319),
    [sym_raise_statement] = STATE(1319),
    [sym_pass_statement] = STATE(1319),
    [sym_break_statement] = STATE(1319),
    [sym_continue_statement] = STATE(1319),
    [sym_if_statement] = STATE(65),
    [sym_for_statement] = STATE(65),
    [sym_while_statement] = STATE(65),
    [sym_try_statement] = STATE(65),
    [sym_with_statement] = STATE(65),
    [sym_match_statement] = STATE(65),
    [sym_function_definition] = STATE(65),
    [sym_list_splat] = STATE(1360),
    [sym_dictionary_splat] = STATE(1360),
    [sym_global_statement] = STATE(1319),
    [sym_nonlocal_statement] = STATE(1319),
    [sym_exec_statement] = STATE(1319),
    [sym_type_alias_statement] = STATE(1319),
    [sym_class_definition] = STATE(65),
    [sym_decorated_definition] = STATE(65),
    [sym_decorator] = STATE(996),
    [sym_block] = STATE(373),
    [sym_expression_list] = STATE(1361),
    [sym_pattern] = STATE(889),
    [sym_tuple_pattern] = STATE(875),
    [sym_list_pattern] = STATE(875),
    [sym_list_splat_pattern] = STATE(875),
    [sym_expression] = STATE(1019),
    [sym_primary_expression] = STATE(684),
    [sym_not_operator] = STATE(1009),
    [sym_boolean_operator] = STATE(1009),
    [sym_binary_operator] = STATE(797),
    [sym_unary_operator] = STATE(797),
    [sym_comparison_operator] = STATE(1009),
    [sym_lambda] = STATE(1009),
    [sym_assignment] = STATE(1361),
    [sym_augmented_assignment] = STATE(1361),
    [sym_pattern_list] = STATE(897),
    [sym_yield] = STATE(1361),
    [sym_attribute] = STATE(431),
    [sym_subscript] = STATE(431),
    [sym_call] = STATE(797),
    [sym_list] = STATE(797),
    [sym_set] = STATE(797),
    [sym_tuple] = STATE(797),
    [sym_dictionary] = STATE(797),
    [sym_list_comprehension] = STATE(797),
    [sym_dictionary_comprehension] = STATE(797),
    [sym_set_comprehension] = STATE(797),
    [sym_generator_expression] = STATE(797),
    [sym_parenthesized_expression] = STATE(797),
    [sym_conditional_expression] = STATE(1009),
    [sym_concatenated_string] = STATE(797),
    [sym_string] = STATE(713),
    [sym_await] = STATE(1009),
    [aux_sym_module_repeat1] = STATE(65),
    [aux_sym_decorated_definition_repeat1] = STATE(996),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_STAR] = ACTIONS(15),
    [anon_sym_print] = ACTIONS(17),
    [anon_sym_assert] = ACTIONS(19),
    [anon_sym_return] = ACTIONS(21),
    [anon_sym_del] = ACTIONS(23),
    [anon_sym_raise] = ACTIONS(25),
    [anon_sym_pass] = ACTIONS(27),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_async] = ACTIONS(85),
    [anon_sym_for] = ACTIONS(87),
    [anon_sym_while] = ACTIONS(89),
    [anon_sym_try] = ACTIONS(91),
    [anon_sym_with] = ACTIONS(93),
    [anon_sym_match] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(47),
    [anon_sym_PLUS] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(51),
    [anon_sym_STAR_STAR] = ACTIONS(53),
    [anon_sym_def] = ACTIONS(97),
    [anon_sym_global] = ACTIONS(57),
    [anon_sym_nonlocal] = ACTIONS(59),
    [anon_sym_exec] = ACTIONS(61),
    [anon_sym_type] = ACTIONS(63),
    [anon_sym_class] = ACTIONS(99),
    [anon_sym_AT] = ACTIONS(67),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(101),
    [sym__string_start] = ACTIONS(81),
  },
  [7] = {
    [sym__statement] = STATE(68),
    [sym__simple_statements] = STATE(68),
    [sym_import_statement] = STATE(1319),
    [sym_future_import_statement] = STATE(1319),
    [sym_import_from_statement] = STATE(1319),
    [sym_print_statement] = STATE(1319),
    [sym_assert_statement] = STATE(1319),
    [sym_expression_statement] = STATE(1319),
    [sym_named_expression] = STATE(1009),
    [sym_return_statement] = STATE(1319),
    [sym_delete_statement] = STATE(1319),
    [sym_raise_statement] = STATE(1319),
    [sym_pass_statement] = STATE(1319),
    [sym_break_statement] = STATE(1319),
    [sym_continue_statement] = STATE(1319),
    [sym_if_statement] = STATE(68),
    [sym_for_statement] = STATE(68),
    [sym_while_statement] = STATE(68),
    [sym_try_statement] = STATE(68),
    [sym_with_statement] = STATE(68),
    [sym_match_statement] = STATE(68),
    [sym_function_definition] = STATE(68),
    [sym_list_splat] = STATE(1360),
    [sym_dictionary_splat] = STATE(1360),
    [sym_global_statement] = STATE(1319),
    [sym_nonlocal_statement] = STATE(1319),
    [sym_exec_statement] = STATE(1319),
    [sym_type_alias_statement] = STATE(1319),
    [sym_class_definition] = STATE(68),
    [sym_decorated_definition] = STATE(68),
    [sym_decorator] = STATE(996),
    [sym_block] = STATE(403),
    [sym_expression_list] = STATE(1361),
    [sym_pattern] = STATE(889),
    [sym_tuple_pattern] = STATE(875),
    [sym_list_pattern] = STATE(875),
    [sym_list_splat_pattern] = STATE(875),
    [sym_expression] = STATE(1019),
    [sym_primary_expression] = STATE(684),
    [sym_not_operator] = STATE(1009),
    [sym_boolean_operator] = STATE(1009),
    [sym_binary_operator] = STATE(797),
    [sym_unary_operator] = STATE(797),
    [sym_comparison_operator] = STATE(1009),
    [sym_lambda] = STATE(1009),
    [sym_assignment] = STATE(1361),
    [sym_augmented_assignment] = STATE(1361),
    [sym_pattern_list] = STATE(897),
    [sym_yield] = STATE(1361),
    [sym_attribute] = STATE(431),
    [sym_subscript] = STATE(431),
    [sym_call] = STATE(797),
    [sym_list] = STATE(797),
    [sym_set] = STATE(797),
    [sym_tuple] = STATE(797),
    [sym_dictionary] = STATE(797),
    [sym_list_comprehension] = STATE(797),
    [sym_dictionary_comprehension] = STATE(797),
    [sym_set_comprehension] = STATE(797),
    [sym_generator_expression] = STATE(797),
    [sym_parenthesized_expression] = STATE(797),
    [sym_conditional_expression] = STATE(1009),
    [sym_concatenated_string] = STATE(797),
    [sym_string] = STATE(713),
    [sym_await] = STATE(1009),
    [aux_sym_module_repeat1] = STATE(68),
    [aux_sym_decorated_definition_repeat1] = STATE(996),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_STAR] = ACTIONS(15),
    [anon_sym_print] = ACTIONS(17),
    [anon_sym_assert] = ACTIONS(19),
    [anon_sym_return] = ACTIONS(21),
    [anon_sym_del] = ACTIONS(23),
    [anon_sym_raise] = ACTIONS(25),
    [anon_sym_pass] = ACTIONS(27),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_async] = ACTIONS(85),
    [anon_sym_for] = ACTIONS(87),
    [anon_sym_while] = ACTIONS(89),
    [anon_sym_try] = ACTIONS(91),
    [anon_sym_with] = ACTIONS(93),
    [anon_sym_match] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(47),
    [anon_sym_PLUS] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(51),
    [anon_sym_STAR_STAR] = ACTIONS(53),
    [anon_sym_def] = ACTIONS(97),
    [anon_sym_global] = ACTIONS(57),
    [anon_sym_nonlocal] = ACTIONS(59),
    [anon_sym_exec] = ACTIONS(61),
    [anon_sym_type] = ACTIONS(63),
    [anon_sym_class] = ACTIONS(99),
    [anon_sym_AT] = ACTIONS(67),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(103),
    [sym__string_start] = ACTIONS(81),
  },
  [8] = {
    [sym__statement] = STATE(68),
    [sym__simple_statements] = STATE(68),
    [sym_import_statement] = STATE(1319),
    [sym_future_import_statement] = STATE(1319),
    [sym_import_from_statement] = STATE(1319),
    [sym_print_statement] = STATE(1319),
    [sym_assert_statement] = STATE(1319),
    [sym_expression_statement] = STATE(1319),
    [sym_named_expression] = STATE(1009),
    [sym_return_statement] = STATE(1319),
    [sym_delete_statement] = STATE(1319),
    [sym_raise_statement] = STATE(1319),
    [sym_pass_statement] = STATE(1319),
    [sym_break_statement] = STATE(1319),
    [sym_continue_statement] = STATE(1319),
    [sym_if_statement] = STATE(68),
    [sym_for_statement] = STATE(68),
    [sym_while_statement] = STATE(68),
    [sym_try_statement] = STATE(68),
    [sym_with_statement] = STATE(68),
    [sym_match_statement] = STATE(68),
    [sym_function_definition] = STATE(68),
    [sym_list_splat] = STATE(1360),
    [sym_dictionary_splat] = STATE(1360),
    [sym_global_statement] = STATE(1319),
    [sym_nonlocal_statement] = STATE(1319),
    [sym_exec_statement] = STATE(1319),
    [sym_type_alias_statement] = STATE(1319),
    [sym_class_definition] = STATE(68),
    [sym_decorated_definition] = STATE(68),
    [sym_decorator] = STATE(996),
    [sym_block] = STATE(509),
    [sym_expression_list] = STATE(1361),
    [sym_pattern] = STATE(889),
    [sym_tuple_pattern] = STATE(875),
    [sym_list_pattern] = STATE(875),
    [sym_list_splat_pattern] = STATE(875),
    [sym_expression] = STATE(1019),
    [sym_primary_expression] = STATE(684),
    [sym_not_operator] = STATE(1009),
    [sym_boolean_operator] = STATE(1009),
    [sym_binary_operator] = STATE(797),
    [sym_unary_operator] = STATE(797),
    [sym_comparison_operator] = STATE(1009),
    [sym_lambda] = STATE(1009),
    [sym_assignment] = STATE(1361),
    [sym_augmented_assignment] = STATE(1361),
    [sym_pattern_list] = STATE(897),
    [sym_yield] = STATE(1361),
    [sym_attribute] = STATE(431),
    [sym_subscript] = STATE(431),
    [sym_call] = STATE(797),
    [sym_list] = STATE(797),
    [sym_set] = STATE(797),
    [sym_tuple] = STATE(797),
    [sym_dictionary] = STATE(797),
    [sym_list_comprehension] = STATE(797),
    [sym_dictionary_comprehension] = STATE(797),
    [sym_set_comprehension] = STATE(797),
    [sym_generator_expression] = STATE(797),
    [sym_parenthesized_expression] = STATE(797),
    [sym_conditional_expression] = STATE(1009),
    [sym_concatenated_string] = STATE(797),
    [sym_string] = STATE(713),
    [sym_await] = STATE(1009),
    [aux_sym_module_repeat1] = STATE(68),
    [aux_sym_decorated_definition_repeat1] = STATE(996),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_STAR] = ACTIONS(15),
    [anon_sym_print] = ACTIONS(17),
    [anon_sym_assert] = ACTIONS(19),
    [anon_sym_return] = ACTIONS(21),
    [anon_sym_del] = ACTIONS(23),
    [anon_sym_raise] = ACTIONS(25),
    [anon_sym_pass] = ACTIONS(27),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_async] = ACTIONS(85),
    [anon_sym_for] = ACTIONS(87),
    [anon_sym_while] = ACTIONS(89),
    [anon_sym_try] = ACTIONS(91),
    [anon_sym_with] = ACTIONS(93),
    [anon_sym_match] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(47),
    [anon_sym_PLUS] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(51),
    [anon_sym_STAR_STAR] = ACTIONS(53),
    [anon_sym_def] = ACTIONS(97),
    [anon_sym_global] = ACTIONS(57),
    [anon_sym_nonlocal] = ACTIONS(59),
    [anon_sym_exec] = ACTIONS(61),
    [anon_sym_type] = ACTIONS(63),
    [anon_sym_class] = ACTIONS(99),
    [anon_sym_AT] = ACTIONS(67),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(103),
    [sym__string_start] = ACTIONS(81),
  },
  [9] = {
    [sym__statement] = STATE(62),
    [sym__simple_statements] = STATE(62),
    [sym_import_statement] = STATE(1319),
    [sym_future_import_statement] = STATE(1319),
    [sym_import_from_statement] = STATE(1319),
    [sym_print_statement] = STATE(1319),
    [sym_assert_statement] = STATE(1319),
    [sym_expression_statement] = STATE(1319),
    [sym_named_expression] = STATE(1009),
    [sym_return_statement] = STATE(1319),
    [sym_delete_statement] = STATE(1319),
    [sym_raise_statement] = STATE(1319),
    [sym_pass_statement] = STATE(1319),
    [sym_break_statement] = STATE(1319),
    [sym_continue_statement] = STATE(1319),
    [sym_if_statement] = STATE(62),
    [sym_for_statement] = STATE(62),
    [sym_while_statement] = STATE(62),
    [sym_try_statement] = STATE(62),
    [sym_with_statement] = STATE(62),
    [sym_match_statement] = STATE(62),
    [sym_function_definition] = STATE(62),
    [sym_list_splat] = STATE(1360),
    [sym_dictionary_splat] = STATE(1360),
    [sym_global_statement] = STATE(1319),
    [sym_nonlocal_statement] = STATE(1319),
    [sym_exec_statement] = STATE(1319),
    [sym_type_alias_statement] = STATE(1319),
    [sym_class_definition] = STATE(62),
    [sym_decorated_definition] = STATE(62),
    [sym_decorator] = STATE(996),
    [sym_block] = STATE(372),
    [sym_expression_list] = STATE(1361),
    [sym_pattern] = STATE(889),
    [sym_tuple_pattern] = STATE(875),
    [sym_list_pattern] = STATE(875),
    [sym_list_splat_pattern] = STATE(875),
    [sym_expression] = STATE(1019),
    [sym_primary_expression] = STATE(684),
    [sym_not_operator] = STATE(1009),
    [sym_boolean_operator] = STATE(1009),
    [sym_binary_operator] = STATE(797),
    [sym_unary_operator] = STATE(797),
    [sym_comparison_operator] = STATE(1009),
    [sym_lambda] = STATE(1009),
    [sym_assignment] = STATE(1361),
    [sym_augmented_assignment] = STATE(1361),
    [sym_pattern_list] = STATE(897),
    [sym_yield] = STATE(1361),
    [sym_attribute] = STATE(431),
    [sym_subscript] = STATE(431),
    [sym_call] = STATE(797),
    [sym_list] = STATE(797),
    [sym_set] = STATE(797),
    [sym_tuple] = STATE(797),
    [sym_dictionary] = STATE(797),
    [sym_list_comprehension] = STATE(797),
    [sym_dictionary_comprehension] = STATE(797),
    [sym_set_comprehension] = STATE(797),
    [sym_generator_expression] = STATE(797),
    [sym_parenthesized_expression] = STATE(797),
    [sym_conditional_expression] = STATE(1009),
    [sym_concatenated_string] = STATE(797),
    [sym_string] = STATE(713),
    [sym_await] = STATE(1009),
    [aux_sym_module_repeat1] = STATE(62),
    [aux_sym_decorated_definition_repeat1] = STATE(996),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_STAR] = ACTIONS(15),
    [anon_sym_print] = ACTIONS(17),
    [anon_sym_assert] = ACTIONS(19),
    [anon_sym_return] = ACTIONS(21),
    [anon_sym_del] = ACTIONS(23),
    [anon_sym_raise] = ACTIONS(25),
    [anon_sym_pass] = ACTIONS(27),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_async] = ACTIONS(85),
    [anon_sym_for] = ACTIONS(87),
    [anon_sym_while] = ACTIONS(89),
    [anon_sym_try] = ACTIONS(91),
    [anon_sym_with] = ACTIONS(93),
    [anon_sym_match] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(47),
    [anon_sym_PLUS] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(51),
    [anon_sym_STAR_STAR] = ACTIONS(53),
    [anon_sym_def] = ACTIONS(97),
    [anon_sym_global] = ACTIONS(57),
    [anon_sym_nonlocal] = ACTIONS(59),
    [anon_sym_exec] = ACTIONS(61),
    [anon_sym_type] = ACTIONS(63),
    [anon_sym_class] = ACTIONS(99),
    [anon_sym_AT] = ACTIONS(67),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(105),
    [sym__string_start] = ACTIONS(81),
  },
  [10] = {
    [sym__statement] = STATE(61),
    [sym__simple_statements] = STATE(61),
    [sym_import_statement] = STATE(1319),
    [sym_future_import_statement] = STATE(1319),
    [sym_import_from_statement] = STATE(1319),
    [sym_print_statement] = STATE(1319),
    [sym_assert_statement] = STATE(1319),
    [sym_expression_statement] = STATE(1319),
    [sym_named_expression] = STATE(1009),
    [sym_return_statement] = STATE(1319),
    [sym_delete_statement] = STATE(1319),
    [sym_raise_statement] = STATE(1319),
    [sym_pass_statement] = STATE(1319),
    [sym_break_statement] = STATE(1319),
    [sym_continue_statement] = STATE(1319),
    [sym_if_statement] = STATE(61),
    [sym_for_statement] = STATE(61),
    [sym_while_statement] = STATE(61),
    [sym_try_statement] = STATE(61),
    [sym_with_statement] = STATE(61),
    [sym_match_statement] = STATE(61),
    [sym_function_definition] = STATE(61),
    [sym_list_splat] = STATE(1360),
    [sym_dictionary_splat] = STATE(1360),
    [sym_global_statement] = STATE(1319),
    [sym_nonlocal_statement] = STATE(1319),
    [sym_exec_statement] = STATE(1319),
    [sym_type_alias_statement] = STATE(1319),
    [sym_class_definition] = STATE(61),
    [sym_decorated_definition] = STATE(61),
    [sym_decorator] = STATE(996),
    [sym_block] = STATE(546),
    [sym_expression_list] = STATE(1361),
    [sym_pattern] = STATE(889),
    [sym_tuple_pattern] = STATE(875),
    [sym_list_pattern] = STATE(875),
    [sym_list_splat_pattern] = STATE(875),
    [sym_expression] = STATE(1019),
    [sym_primary_expression] = STATE(684),
    [sym_not_operator] = STATE(1009),
    [sym_boolean_operator] = STATE(1009),
    [sym_binary_operator] = STATE(797),
    [sym_unary_operator] = STATE(797),
    [sym_comparison_operator] = STATE(1009),
    [sym_lambda] = STATE(1009),
    [sym_assignment] = STATE(1361),
    [sym_augmented_assignment] = STATE(1361),
    [sym_pattern_list] = STATE(897),
    [sym_yield] = STATE(1361),
    [sym_attribute] = STATE(431),
    [sym_subscript] = STATE(431),
    [sym_call] = STATE(797),
    [sym_list] = STATE(797),
    [sym_set] = STATE(797),
    [sym_tuple] = STATE(797),
    [sym_dictionary] = STATE(797),
    [sym_list_comprehension] = STATE(797),
    [sym_dictionary_comprehension] = STATE(797),
    [sym_set_comprehension] = STATE(797),
    [sym_generator_expression] = STATE(797),
    [sym_parenthesized_expression] = STATE(797),
    [sym_conditional_expression] = STATE(1009),
    [sym_concatenated_string] = STATE(797),
    [sym_string] = STATE(713),
    [sym_await] = STATE(1009),
    [aux_sym_module_repeat1] = STATE(61),
    [aux_sym_decorated_definition_repeat1] = STATE(996),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_STAR] = ACTIONS(15),
    [anon_sym_print] = ACTIONS(17),
    [anon_sym_assert] = ACTIONS(19),
    [anon_sym_return] = ACTIONS(21),
    [anon_sym_del] = ACTIONS(23),
    [anon_sym_raise] = ACTIONS(25),
    [anon_sym_pass] = ACTIONS(27),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_async] = ACTIONS(85),
    [anon_sym_for] = ACTIONS(87),
    [anon_sym_while] = ACTIONS(89),
    [anon_sym_try] = ACTIONS(91),
    [anon_sym_with] = ACTIONS(93),
    [anon_sym_match] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(47),
    [anon_sym_PLUS] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(51),
    [anon_sym_STAR_STAR] = ACTIONS(53),
    [anon_sym_def] = ACTIONS(97),
    [anon_sym_global] = ACTIONS(57),
    [anon_sym_nonlocal] = ACTIONS(59),
    [anon_sym_exec] = ACTIONS(61),
    [anon_sym_type] = ACTIONS(63),
    [anon_sym_class] = ACTIONS(99),
    [anon_sym_AT] = ACTIONS(67),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(107),
    [sym__string_start] = ACTIONS(81),
  },
  [11] = {
    [sym__statement] = STATE(61),
    [sym__simple_statements] = STATE(61),
    [sym_import_statement] = STATE(1319),
    [sym_future_import_statement] = STATE(1319),
    [sym_import_from_statement] = STATE(1319),
    [sym_print_statement] = STATE(1319),
    [sym_assert_statement] = STATE(1319),
    [sym_expression_statement] = STATE(1319),
    [sym_named_expression] = STATE(1009),
    [sym_return_statement] = STATE(1319),
    [sym_delete_statement] = STATE(1319),
    [sym_raise_statement] = STATE(1319),
    [sym_pass_statement] = STATE(1319),
    [sym_break_statement] = STATE(1319),
    [sym_continue_statement] = STATE(1319),
    [sym_if_statement] = STATE(61),
    [sym_for_statement] = STATE(61),
    [sym_while_statement] = STATE(61),
    [sym_try_statement] = STATE(61),
    [sym_with_statement] = STATE(61),
    [sym_match_statement] = STATE(61),
    [sym_function_definition] = STATE(61),
    [sym_list_splat] = STATE(1360),
    [sym_dictionary_splat] = STATE(1360),
    [sym_global_statement] = STATE(1319),
    [sym_nonlocal_statement] = STATE(1319),
    [sym_exec_statement] = STATE(1319),
    [sym_type_alias_statement] = STATE(1319),
    [sym_class_definition] = STATE(61),
    [sym_decorated_definition] = STATE(61),
    [sym_decorator] = STATE(996),
    [sym_block] = STATE(279),
    [sym_expression_list] = STATE(1361),
    [sym_pattern] = STATE(889),
    [sym_tuple_pattern] = STATE(875),
    [sym_list_pattern] = STATE(875),
    [sym_list_splat_pattern] = STATE(875),
    [sym_expression] = STATE(1019),
    [sym_primary_expression] = STATE(684),
    [sym_not_operator] = STATE(1009),
    [sym_boolean_operator] = STATE(1009),
    [sym_binary_operator] = STATE(797),
    [sym_unary_operator] = STATE(797),
    [sym_comparison_operator] = STATE(1009),
    [sym_lambda] = STATE(1009),
    [sym_assignment] = STATE(1361),
    [sym_augmented_assignment] = STATE(1361),
    [sym_pattern_list] = STATE(897),
    [sym_yield] = STATE(1361),
    [sym_attribute] = STATE(431),
    [sym_subscript] = STATE(431),
    [sym_call] = STATE(797),
    [sym_list] = STATE(797),
    [sym_set] = STATE(797),
    [sym_tuple] = STATE(797),
    [sym_dictionary] = STATE(797),
    [sym_list_comprehension] = STATE(797),
    [sym_dictionary_comprehension] = STATE(797),
    [sym_set_comprehension] = STATE(797),
    [sym_generator_expression] = STATE(797),
    [sym_parenthesized_expression] = STATE(797),
    [sym_conditional_expression] = STATE(1009),
    [sym_concatenated_string] = STATE(797),
    [sym_string] = STATE(713),
    [sym_await] = STATE(1009),
    [aux_sym_module_repeat1] = STATE(61),
    [aux_sym_decorated_definition_repeat1] = STATE(996),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_STAR] = ACTIONS(15),
    [anon_sym_print] = ACTIONS(17),
    [anon_sym_assert] = ACTIONS(19),
    [anon_sym_return] = ACTIONS(21),
    [anon_sym_del] = ACTIONS(23),
    [anon_sym_raise] = ACTIONS(25),
    [anon_sym_pass] = ACTIONS(27),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_async] = ACTIONS(85),
    [anon_sym_for] = ACTIONS(87),
    [anon_sym_while] = ACTIONS(89),
    [anon_sym_try] = ACTIONS(91),
    [anon_sym_with] = ACTIONS(93),
    [anon_sym_match] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(47),
    [anon_sym_PLUS] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(51),
    [anon_sym_STAR_STAR] = ACTIONS(53),
    [anon_sym_def] = ACTIONS(97),
    [anon_sym_global] = ACTIONS(57),
    [anon_sym_nonlocal] = ACTIONS(59),
    [anon_sym_exec] = ACTIONS(61),
    [anon_sym_type] = ACTIONS(63),
    [anon_sym_class] = ACTIONS(99),
    [anon_sym_AT] = ACTIONS(67),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(107),
    [sym__string_start] = ACTIONS(81),
  },
  [12] = {
    [sym__statement] = STATE(68),
    [sym__simple_statements] = STATE(68),
    [sym_import_statement] = STATE(1319),
    [sym_future_import_statement] = STATE(1319),
    [sym_import_from_statement] = STATE(1319),
    [sym_print_statement] = STATE(1319),
    [sym_assert_statement] = STATE(1319),
    [sym_expression_statement] = STATE(1319),
    [sym_named_expression] = STATE(1009),
    [sym_return_statement] = STATE(1319),
    [sym_delete_statement] = STATE(1319),
    [sym_raise_statement] = STATE(1319),
    [sym_pass_statement] = STATE(1319),
    [sym_break_statement] = STATE(1319),
    [sym_continue_statement] = STATE(1319),
    [sym_if_statement] = STATE(68),
    [sym_for_statement] = STATE(68),
    [sym_while_statement] = STATE(68),
    [sym_try_statement] = STATE(68),
    [sym_with_statement] = STATE(68),
    [sym_match_statement] = STATE(68),
    [sym_function_definition] = STATE(68),
    [sym_list_splat] = STATE(1360),
    [sym_dictionary_splat] = STATE(1360),
    [sym_global_statement] = STATE(1319),
    [sym_nonlocal_statement] = STATE(1319),
    [sym_exec_statement] = STATE(1319),
    [sym_type_alias_statement] = STATE(1319),
    [sym_class_definition] = STATE(68),
    [sym_decorated_definition] = STATE(68),
    [sym_decorator] = STATE(996),
    [sym_block] = STATE(491),
    [sym_expression_list] = STATE(1361),
    [sym_pattern] = STATE(889),
    [sym_tuple_pattern] = STATE(875),
    [sym_list_pattern] = STATE(875),
    [sym_list_splat_pattern] = STATE(875),
    [sym_expression] = STATE(1019),
    [sym_primary_expression] = STATE(684),
    [sym_not_operator] = STATE(1009),
    [sym_boolean_operator] = STATE(1009),
    [sym_binary_operator] = STATE(797),
    [sym_unary_operator] = STATE(797),
    [sym_comparison_operator] = STATE(1009),
    [sym_lambda] = STATE(1009),
    [sym_assignment] = STATE(1361),
    [sym_augmented_assignment] = STATE(1361),
    [sym_pattern_list] = STATE(897),
    [sym_yield] = STATE(1361),
    [sym_attribute] = STATE(431),
    [sym_subscript] = STATE(431),
    [sym_call] = STATE(797),
    [sym_list] = STATE(797),
    [sym_set] = STATE(797),
    [sym_tuple] = STATE(797),
    [sym_dictionary] = STATE(797),
    [sym_list_comprehension] = STATE(797),
    [sym_dictionary_comprehension] = STATE(797),
    [sym_set_comprehension] = STATE(797),
    [sym_generator_expression] = STATE(797),
    [sym_parenthesized_expression] = STATE(797),
    [sym_conditional_expression] = STATE(1009),
    [sym_concatenated_string] = STATE(797),
    [sym_string] = STATE(713),
    [sym_await] = STATE(1009),
    [aux_sym_module_repeat1] = STATE(68),
    [aux_sym_decorated_definition_repeat1] = STATE(996),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_STAR] = ACTIONS(15),
    [anon_sym_print] = ACTIONS(17),
    [anon_sym_assert] = ACTIONS(19),
    [anon_sym_return] = ACTIONS(21),
    [anon_sym_del] = ACTIONS(23),
    [anon_sym_raise] = ACTIONS(25),
    [anon_sym_pass] = ACTIONS(27),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_async] = ACTIONS(85),
    [anon_sym_for] = ACTIONS(87),
    [anon_sym_while] = ACTIONS(89),
    [anon_sym_try] = ACTIONS(91),
    [anon_sym_with] = ACTIONS(93),
    [anon_sym_match] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(47),
    [anon_sym_PLUS] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(51),
    [anon_sym_STAR_STAR] = ACTIONS(53),
    [anon_sym_def] = ACTIONS(97),
    [anon_sym_global] = ACTIONS(57),
    [anon_sym_nonlocal] = ACTIONS(59),
    [anon_sym_exec] = ACTIONS(61),
    [anon_sym_type] = ACTIONS(63),
    [anon_sym_class] = ACTIONS(99),
    [anon_sym_AT] = ACTIONS(67),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(103),
    [sym__string_start] = ACTIONS(81),
  },
  [13] = {
    [sym__statement] = STATE(68),
    [sym__simple_statements] = STATE(68),
    [sym_import_statement] = STATE(1319),
    [sym_future_import_statement] = STATE(1319),
    [sym_import_from_statement] = STATE(1319),
    [sym_print_statement] = STATE(1319),
    [sym_assert_statement] = STATE(1319),
    [sym_expression_statement] = STATE(1319),
    [sym_named_expression] = STATE(1009),
    [sym_return_statement] = STATE(1319),
    [sym_delete_statement] = STATE(1319),
    [sym_raise_statement] = STATE(1319),
    [sym_pass_statement] = STATE(1319),
    [sym_break_statement] = STATE(1319),
    [sym_continue_statement] = STATE(1319),
    [sym_if_statement] = STATE(68),
    [sym_for_statement] = STATE(68),
    [sym_while_statement] = STATE(68),
    [sym_try_statement] = STATE(68),
    [sym_with_statement] = STATE(68),
    [sym_match_statement] = STATE(68),
    [sym_function_definition] = STATE(68),
    [sym_list_splat] = STATE(1360),
    [sym_dictionary_splat] = STATE(1360),
    [sym_global_statement] = STATE(1319),
    [sym_nonlocal_statement] = STATE(1319),
    [sym_exec_statement] = STATE(1319),
    [sym_type_alias_statement] = STATE(1319),
    [sym_class_definition] = STATE(68),
    [sym_decorated_definition] = STATE(68),
    [sym_decorator] = STATE(996),
    [sym_block] = STATE(495),
    [sym_expression_list] = STATE(1361),
    [sym_pattern] = STATE(889),
    [sym_tuple_pattern] = STATE(875),
    [sym_list_pattern] = STATE(875),
    [sym_list_splat_pattern] = STATE(875),
    [sym_expression] = STATE(1019),
    [sym_primary_expression] = STATE(684),
    [sym_not_operator] = STATE(1009),
    [sym_boolean_operator] = STATE(1009),
    [sym_binary_operator] = STATE(797),
    [sym_unary_operator] = STATE(797),
    [sym_comparison_operator] = STATE(1009),
    [sym_lambda] = STATE(1009),
    [sym_assignment] = STATE(1361),
    [sym_augmented_assignment] = STATE(1361),
    [sym_pattern_list] = STATE(897),
    [sym_yield] = STATE(1361),
    [sym_attribute] = STATE(431),
    [sym_subscript] = STATE(431),
    [sym_call] = STATE(797),
    [sym_list] = STATE(797),
    [sym_set] = STATE(797),
    [sym_tuple] = STATE(797),
    [sym_dictionary] = STATE(797),
    [sym_list_comprehension] = STATE(797),
    [sym_dictionary_comprehension] = STATE(797),
    [sym_set_comprehension] = STATE(797),
    [sym_generator_expression] = STATE(797),
    [sym_parenthesized_expression] = STATE(797),
    [sym_conditional_expression] = STATE(1009),
    [sym_concatenated_string] = STATE(797),
    [sym_string] = STATE(713),
    [sym_await] = STATE(1009),
    [aux_sym_module_repeat1] = STATE(68),
    [aux_sym_decorated_definition_repeat1] = STATE(996),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_STAR] = ACTIONS(15),
    [anon_sym_print] = ACTIONS(17),
    [anon_sym_assert] = ACTIONS(19),
    [anon_sym_return] = ACTIONS(21),
    [anon_sym_del] = ACTIONS(23),
    [anon_sym_raise] = ACTIONS(25),
    [anon_sym_pass] = ACTIONS(27),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_async] = ACTIONS(85),
    [anon_sym_for] = ACTIONS(87),
    [anon_sym_while] = ACTIONS(89),
    [anon_sym_try] = ACTIONS(91),
    [anon_sym_with] = ACTIONS(93),
    [anon_sym_match] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(47),
    [anon_sym_PLUS] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(51),
    [anon_sym_STAR_STAR] = ACTIONS(53),
    [anon_sym_def] = ACTIONS(97),
    [anon_sym_global] = ACTIONS(57),
    [anon_sym_nonlocal] = ACTIONS(59),
    [anon_sym_exec] = ACTIONS(61),
    [anon_sym_type] = ACTIONS(63),
    [anon_sym_class] = ACTIONS(99),
    [anon_sym_AT] = ACTIONS(67),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(103),
    [sym__string_start] = ACTIONS(81),
  },
  [14] = {
    [sym__statement] = STATE(68),
    [sym__simple_statements] = STATE(68),
    [sym_import_statement] = STATE(1319),
    [sym_future_import_statement] = STATE(1319),
    [sym_import_from_statement] = STATE(1319),
    [sym_print_statement] = STATE(1319),
    [sym_assert_statement] = STATE(1319),
    [sym_expression_statement] = STATE(1319),
    [sym_named_expression] = STATE(1009),
    [sym_return_statement] = STATE(1319),
    [sym_delete_statement] = STATE(1319),
    [sym_raise_statement] = STATE(1319),
    [sym_pass_statement] = STATE(1319),
    [sym_break_statement] = STATE(1319),
    [sym_continue_statement] = STATE(1319),
    [sym_if_statement] = STATE(68),
    [sym_for_statement] = STATE(68),
    [sym_while_statement] = STATE(68),
    [sym_try_statement] = STATE(68),
    [sym_with_statement] = STATE(68),
    [sym_match_statement] = STATE(68),
    [sym_function_definition] = STATE(68),
    [sym_list_splat] = STATE(1360),
    [sym_dictionary_splat] = STATE(1360),
    [sym_global_statement] = STATE(1319),
    [sym_nonlocal_statement] = STATE(1319),
    [sym_exec_statement] = STATE(1319),
    [sym_type_alias_statement] = STATE(1319),
    [sym_class_definition] = STATE(68),
    [sym_decorated_definition] = STATE(68),
    [sym_decorator] = STATE(996),
    [sym_block] = STATE(506),
    [sym_expression_list] = STATE(1361),
    [sym_pattern] = STATE(889),
    [sym_tuple_pattern] = STATE(875),
    [sym_list_pattern] = STATE(875),
    [sym_list_splat_pattern] = STATE(875),
    [sym_expression] = STATE(1019),
    [sym_primary_expression] = STATE(684),
    [sym_not_operator] = STATE(1009),
    [sym_boolean_operator] = STATE(1009),
    [sym_binary_operator] = STATE(797),
    [sym_unary_operator] = STATE(797),
    [sym_comparison_operator] = STATE(1009),
    [sym_lambda] = STATE(1009),
    [sym_assignment] = STATE(1361),
    [sym_augmented_assignment] = STATE(1361),
    [sym_pattern_list] = STATE(897),
    [sym_yield] = STATE(1361),
    [sym_attribute] = STATE(431),
    [sym_subscript] = STATE(431),
    [sym_call] = STATE(797),
    [sym_list] = STATE(797),
    [sym_set] = STATE(797),
    [sym_tuple] = STATE(797),
    [sym_dictionary] = STATE(797),
    [sym_list_comprehension] = STATE(797),
    [sym_dictionary_comprehension] = STATE(797),
    [sym_set_comprehension] = STATE(797),
    [sym_generator_expression] = STATE(797),
    [sym_parenthesized_expression] = STATE(797),
    [sym_conditional_expression] = STATE(1009),
    [sym_concatenated_string] = STATE(797),
    [sym_string] = STATE(713),
    [sym_await] = STATE(1009),
    [aux_sym_module_repeat1] = STATE(68),
    [aux_sym_decorated_definition_repeat1] = STATE(996),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_STAR] = ACTIONS(15),
    [anon_sym_print] = ACTIONS(17),
    [anon_sym_assert] = ACTIONS(19),
    [anon_sym_return] = ACTIONS(21),
    [anon_sym_del] = ACTIONS(23),
    [anon_sym_raise] = ACTIONS(25),
    [anon_sym_pass] = ACTIONS(27),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_async] = ACTIONS(85),
    [anon_sym_for] = ACTIONS(87),
    [anon_sym_while] = ACTIONS(89),
    [anon_sym_try] = ACTIONS(91),
    [anon_sym_with] = ACTIONS(93),
    [anon_sym_match] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(47),
    [anon_sym_PLUS] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(51),
    [anon_sym_STAR_STAR] = ACTIONS(53),
    [anon_sym_def] = ACTIONS(97),
    [anon_sym_global] = ACTIONS(57),
    [anon_sym_nonlocal] = ACTIONS(59),
    [anon_sym_exec] = ACTIONS(61),
    [anon_sym_type] = ACTIONS(63),
    [anon_sym_class] = ACTIONS(99),
    [anon_sym_AT] = ACTIONS(67),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(103),
    [sym__string_start] = ACTIONS(81),
  },
  [15] = {
    [sym__statement] = STATE(68),
    [sym__simple_statements] = STATE(68),
    [sym_import_statement] = STATE(1319),
    [sym_future_import_statement] = STATE(1319),
    [sym_import_from_statement] = STATE(1319),
    [sym_print_statement] = STATE(1319),
    [sym_assert_statement] = STATE(1319),
    [sym_expression_statement] = STATE(1319),
    [sym_named_expression] = STATE(1009),
    [sym_return_statement] = STATE(1319),
    [sym_delete_statement] = STATE(1319),
    [sym_raise_statement] = STATE(1319),
    [sym_pass_statement] = STATE(1319),
    [sym_break_statement] = STATE(1319),
    [sym_continue_statement] = STATE(1319),
    [sym_if_statement] = STATE(68),
    [sym_for_statement] = STATE(68),
    [sym_while_statement] = STATE(68),
    [sym_try_statement] = STATE(68),
    [sym_with_statement] = STATE(68),
    [sym_match_statement] = STATE(68),
    [sym_function_definition] = STATE(68),
    [sym_list_splat] = STATE(1360),
    [sym_dictionary_splat] = STATE(1360),
    [sym_global_statement] = STATE(1319),
    [sym_nonlocal_statement] = STATE(1319),
    [sym_exec_statement] = STATE(1319),
    [sym_type_alias_statement] = STATE(1319),
    [sym_class_definition] = STATE(68),
    [sym_decorated_definition] = STATE(68),
    [sym_decorator] = STATE(996),
    [sym_block] = STATE(505),
    [sym_expression_list] = STATE(1361),
    [sym_pattern] = STATE(889),
    [sym_tuple_pattern] = STATE(875),
    [sym_list_pattern] = STATE(875),
    [sym_list_splat_pattern] = STATE(875),
    [sym_expression] = STATE(1019),
    [sym_primary_expression] = STATE(684),
    [sym_not_operator] = STATE(1009),
    [sym_boolean_operator] = STATE(1009),
    [sym_binary_operator] = STATE(797),
    [sym_unary_operator] = STATE(797),
    [sym_comparison_operator] = STATE(1009),
    [sym_lambda] = STATE(1009),
    [sym_assignment] = STATE(1361),
    [sym_augmented_assignment] = STATE(1361),
    [sym_pattern_list] = STATE(897),
    [sym_yield] = STATE(1361),
    [sym_attribute] = STATE(431),
    [sym_subscript] = STATE(431),
    [sym_call] = STATE(797),
    [sym_list] = STATE(797),
    [sym_set] = STATE(797),
    [sym_tuple] = STATE(797),
    [sym_dictionary] = STATE(797),
    [sym_list_comprehension] = STATE(797),
    [sym_dictionary_comprehension] = STATE(797),
    [sym_set_comprehension] = STATE(797),
    [sym_generator_expression] = STATE(797),
    [sym_parenthesized_expression] = STATE(797),
    [sym_conditional_expression] = STATE(1009),
    [sym_concatenated_string] = STATE(797),
    [sym_string] = STATE(713),
    [sym_await] = STATE(1009),
    [aux_sym_module_repeat1] = STATE(68),
    [aux_sym_decorated_definition_repeat1] = STATE(996),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_STAR] = ACTIONS(15),
    [anon_sym_print] = ACTIONS(17),
    [anon_sym_assert] = ACTIONS(19),
    [anon_sym_return] = ACTIONS(21),
    [anon_sym_del] = ACTIONS(23),
    [anon_sym_raise] = ACTIONS(25),
    [anon_sym_pass] = ACTIONS(27),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_async] = ACTIONS(85),
    [anon_sym_for] = ACTIONS(87),
    [anon_sym_while] = ACTIONS(89),
    [anon_sym_try] = ACTIONS(91),
    [anon_sym_with] = ACTIONS(93),
    [anon_sym_match] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(47),
    [anon_sym_PLUS] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(51),
    [anon_sym_STAR_STAR] = ACTIONS(53),
    [anon_sym_def] = ACTIONS(97),
    [anon_sym_global] = ACTIONS(57),
    [anon_sym_nonlocal] = ACTIONS(59),
    [anon_sym_exec] = ACTIONS(61),
    [anon_sym_type] = ACTIONS(63),
    [anon_sym_class] = ACTIONS(99),
    [anon_sym_AT] = ACTIONS(67),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(103),
    [sym__string_start] = ACTIONS(81),
  },
  [16] = {
    [sym__statement] = STATE(61),
    [sym__simple_statements] = STATE(61),
    [sym_import_statement] = STATE(1319),
    [sym_future_import_statement] = STATE(1319),
    [sym_import_from_statement] = STATE(1319),
    [sym_print_statement] = STATE(1319),
    [sym_assert_statement] = STATE(1319),
    [sym_expression_statement] = STATE(1319),
    [sym_named_expression] = STATE(1009),
    [sym_return_statement] = STATE(1319),
    [sym_delete_statement] = STATE(1319),
    [sym_raise_statement] = STATE(1319),
    [sym_pass_statement] = STATE(1319),
    [sym_break_statement] = STATE(1319),
    [sym_continue_statement] = STATE(1319),
    [sym_if_statement] = STATE(61),
    [sym_for_statement] = STATE(61),
    [sym_while_statement] = STATE(61),
    [sym_try_statement] = STATE(61),
    [sym_with_statement] = STATE(61),
    [sym_match_statement] = STATE(61),
    [sym_function_definition] = STATE(61),
    [sym_list_splat] = STATE(1360),
    [sym_dictionary_splat] = STATE(1360),
    [sym_global_statement] = STATE(1319),
    [sym_nonlocal_statement] = STATE(1319),
    [sym_exec_statement] = STATE(1319),
    [sym_type_alias_statement] = STATE(1319),
    [sym_class_definition] = STATE(61),
    [sym_decorated_definition] = STATE(61),
    [sym_decorator] = STATE(996),
    [sym_block] = STATE(408),
    [sym_expression_list] = STATE(1361),
    [sym_pattern] = STATE(889),
    [sym_tuple_pattern] = STATE(875),
    [sym_list_pattern] = STATE(875),
    [sym_list_splat_pattern] = STATE(875),
    [sym_expression] = STATE(1019),
    [sym_primary_expression] = STATE(684),
    [sym_not_operator] = STATE(1009),
    [sym_boolean_operator] = STATE(1009),
    [sym_binary_operator] = STATE(797),
    [sym_unary_operator] = STATE(797),
    [sym_comparison_operator] = STATE(1009),
    [sym_lambda] = STATE(1009),
    [sym_assignment] = STATE(1361),
    [sym_augmented_assignment] = STATE(1361),
    [sym_pattern_list] = STATE(897),
    [sym_yield] = STATE(1361),
    [sym_attribute] = STATE(431),
    [sym_subscript] = STATE(431),
    [sym_call] = STATE(797),
    [sym_list] = STATE(797),
    [sym_set] = STATE(797),
    [sym_tuple] = STATE(797),
    [sym_dictionary] = STATE(797),
    [sym_list_comprehension] = STATE(797),
    [sym_dictionary_comprehension] = STATE(797),
    [sym_set_comprehension] = STATE(797),
    [sym_generator_expression] = STATE(797),
    [sym_parenthesized_expression] = STATE(797),
    [sym_conditional_expression] = STATE(1009),
    [sym_concatenated_string] = STATE(797),
    [sym_string] = STATE(713),
    [sym_await] = STATE(1009),
    [aux_sym_module_repeat1] = STATE(61),
    [aux_sym_decorated_definition_repeat1] = STATE(996),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_STAR] = ACTIONS(15),
    [anon_sym_print] = ACTIONS(17),
    [anon_sym_assert] = ACTIONS(19),
    [anon_sym_return] = ACTIONS(21),
    [anon_sym_del] = ACTIONS(23),
    [anon_sym_raise] = ACTIONS(25),
    [anon_sym_pass] = ACTIONS(27),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_async] = ACTIONS(85),
    [anon_sym_for] = ACTIONS(87),
    [anon_sym_while] = ACTIONS(89),
    [anon_sym_try] = ACTIONS(91),
    [anon_sym_with] = ACTIONS(93),
    [anon_sym_match] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(47),
    [anon_sym_PLUS] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(51),
    [anon_sym_STAR_STAR] = ACTIONS(53),
    [anon_sym_def] = ACTIONS(97),
    [anon_sym_global] = ACTIONS(57),
    [anon_sym_nonlocal] = ACTIONS(59),
    [anon_sym_exec] = ACTIONS(61),
    [anon_sym_type] = ACTIONS(63),
    [anon_sym_class] = ACTIONS(99),
    [anon_sym_AT] = ACTIONS(67),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(107),
    [sym__string_start] = ACTIONS(81),
  },
  [17] = {
    [sym__statement] = STATE(61),
    [sym__simple_statements] = STATE(61),
    [sym_import_statement] = STATE(1319),
    [sym_future_import_statement] = STATE(1319),
    [sym_import_from_statement] = STATE(1319),
    [sym_print_statement] = STATE(1319),
    [sym_assert_statement] = STATE(1319),
    [sym_expression_statement] = STATE(1319),
    [sym_named_expression] = STATE(1009),
    [sym_return_statement] = STATE(1319),
    [sym_delete_statement] = STATE(1319),
    [sym_raise_statement] = STATE(1319),
    [sym_pass_statement] = STATE(1319),
    [sym_break_statement] = STATE(1319),
    [sym_continue_statement] = STATE(1319),
    [sym_if_statement] = STATE(61),
    [sym_for_statement] = STATE(61),
    [sym_while_statement] = STATE(61),
    [sym_try_statement] = STATE(61),
    [sym_with_statement] = STATE(61),
    [sym_match_statement] = STATE(61),
    [sym_function_definition] = STATE(61),
    [sym_list_splat] = STATE(1360),
    [sym_dictionary_splat] = STATE(1360),
    [sym_global_statement] = STATE(1319),
    [sym_nonlocal_statement] = STATE(1319),
    [sym_exec_statement] = STATE(1319),
    [sym_type_alias_statement] = STATE(1319),
    [sym_class_definition] = STATE(61),
    [sym_decorated_definition] = STATE(61),
    [sym_decorator] = STATE(996),
    [sym_block] = STATE(536),
    [sym_expression_list] = STATE(1361),
    [sym_pattern] = STATE(889),
    [sym_tuple_pattern] = STATE(875),
    [sym_list_pattern] = STATE(875),
    [sym_list_splat_pattern] = STATE(875),
    [sym_expression] = STATE(1019),
    [sym_primary_expression] = STATE(684),
    [sym_not_operator] = STATE(1009),
    [sym_boolean_operator] = STATE(1009),
    [sym_binary_operator] = STATE(797),
    [sym_unary_operator] = STATE(797),
    [sym_comparison_operator] = STATE(1009),
    [sym_lambda] = STATE(1009),
    [sym_assignment] = STATE(1361),
    [sym_augmented_assignment] = STATE(1361),
    [sym_pattern_list] = STATE(897),
    [sym_yield] = STATE(1361),
    [sym_attribute] = STATE(431),
    [sym_subscript] = STATE(431),
    [sym_call] = STATE(797),
    [sym_list] = STATE(797),
    [sym_set] = STATE(797),
    [sym_tuple] = STATE(797),
    [sym_dictionary] = STATE(797),
    [sym_list_comprehension] = STATE(797),
    [sym_dictionary_comprehension] = STATE(797),
    [sym_set_comprehension] = STATE(797),
    [sym_generator_expression] = STATE(797),
    [sym_parenthesized_expression] = STATE(797),
    [sym_conditional_expression] = STATE(1009),
    [sym_concatenated_string] = STATE(797),
    [sym_string] = STATE(713),
    [sym_await] = STATE(1009),
    [aux_sym_module_repeat1] = STATE(61),
    [aux_sym_decorated_definition_repeat1] = STATE(996),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_STAR] = ACTIONS(15),
    [anon_sym_print] = ACTIONS(17),
    [anon_sym_assert] = ACTIONS(19),
    [anon_sym_return] = ACTIONS(21),
    [anon_sym_del] = ACTIONS(23),
    [anon_sym_raise] = ACTIONS(25),
    [anon_sym_pass] = ACTIONS(27),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_async] = ACTIONS(85),
    [anon_sym_for] = ACTIONS(87),
    [anon_sym_while] = ACTIONS(89),
    [anon_sym_try] = ACTIONS(91),
    [anon_sym_with] = ACTIONS(93),
    [anon_sym_match] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(47),
    [anon_sym_PLUS] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(51),
    [anon_sym_STAR_STAR] = ACTIONS(53),
    [anon_sym_def] = ACTIONS(97),
    [anon_sym_global] = ACTIONS(57),
    [anon_sym_nonlocal] = ACTIONS(59),
    [anon_sym_exec] = ACTIONS(61),
    [anon_sym_type] = ACTIONS(63),
    [anon_sym_class] = ACTIONS(99),
    [anon_sym_AT] = ACTIONS(67),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(107),
    [sym__string_start] = ACTIONS(81),
  },
  [18] = {
    [sym__statement] = STATE(61),
    [sym__simple_statements] = STATE(61),
    [sym_import_statement] = STATE(1319),
    [sym_future_import_statement] = STATE(1319),
    [sym_import_from_statement] = STATE(1319),
    [sym_print_statement] = STATE(1319),
    [sym_assert_statement] = STATE(1319),
    [sym_expression_statement] = STATE(1319),
    [sym_named_expression] = STATE(1009),
    [sym_return_statement] = STATE(1319),
    [sym_delete_statement] = STATE(1319),
    [sym_raise_statement] = STATE(1319),
    [sym_pass_statement] = STATE(1319),
    [sym_break_statement] = STATE(1319),
    [sym_continue_statement] = STATE(1319),
    [sym_if_statement] = STATE(61),
    [sym_for_statement] = STATE(61),
    [sym_while_statement] = STATE(61),
    [sym_try_statement] = STATE(61),
    [sym_with_statement] = STATE(61),
    [sym_match_statement] = STATE(61),
    [sym_function_definition] = STATE(61),
    [sym_list_splat] = STATE(1360),
    [sym_dictionary_splat] = STATE(1360),
    [sym_global_statement] = STATE(1319),
    [sym_nonlocal_statement] = STATE(1319),
    [sym_exec_statement] = STATE(1319),
    [sym_type_alias_statement] = STATE(1319),
    [sym_class_definition] = STATE(61),
    [sym_decorated_definition] = STATE(61),
    [sym_decorator] = STATE(996),
    [sym_block] = STATE(488),
    [sym_expression_list] = STATE(1361),
    [sym_pattern] = STATE(889),
    [sym_tuple_pattern] = STATE(875),
    [sym_list_pattern] = STATE(875),
    [sym_list_splat_pattern] = STATE(875),
    [sym_expression] = STATE(1019),
    [sym_primary_expression] = STATE(684),
    [sym_not_operator] = STATE(1009),
    [sym_boolean_operator] = STATE(1009),
    [sym_binary_operator] = STATE(797),
    [sym_unary_operator] = STATE(797),
    [sym_comparison_operator] = STATE(1009),
    [sym_lambda] = STATE(1009),
    [sym_assignment] = STATE(1361),
    [sym_augmented_assignment] = STATE(1361),
    [sym_pattern_list] = STATE(897),
    [sym_yield] = STATE(1361),
    [sym_attribute] = STATE(431),
    [sym_subscript] = STATE(431),
    [sym_call] = STATE(797),
    [sym_list] = STATE(797),
    [sym_set] = STATE(797),
    [sym_tuple] = STATE(797),
    [sym_dictionary] = STATE(797),
    [sym_list_comprehension] = STATE(797),
    [sym_dictionary_comprehension] = STATE(797),
    [sym_set_comprehension] = STATE(797),
    [sym_generator_expression] = STATE(797),
    [sym_parenthesized_expression] = STATE(797),
    [sym_conditional_expression] = STATE(1009),
    [sym_concatenated_string] = STATE(797),
    [sym_string] = STATE(713),
    [sym_await] = STATE(1009),
    [aux_sym_module_repeat1] = STATE(61),
    [aux_sym_decorated_definition_repeat1] = STATE(996),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_STAR] = ACTIONS(15),
    [anon_sym_print] = ACTIONS(17),
    [anon_sym_assert] = ACTIONS(19),
    [anon_sym_return] = ACTIONS(21),
    [anon_sym_del] = ACTIONS(23),
    [anon_sym_raise] = ACTIONS(25),
    [anon_sym_pass] = ACTIONS(27),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_async] = ACTIONS(85),
    [anon_sym_for] = ACTIONS(87),
    [anon_sym_while] = ACTIONS(89),
    [anon_sym_try] = ACTIONS(91),
    [anon_sym_with] = ACTIONS(93),
    [anon_sym_match] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(47),
    [anon_sym_PLUS] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(51),
    [anon_sym_STAR_STAR] = ACTIONS(53),
    [anon_sym_def] = ACTIONS(97),
    [anon_sym_global] = ACTIONS(57),
    [anon_sym_nonlocal] = ACTIONS(59),
    [anon_sym_exec] = ACTIONS(61),
    [anon_sym_type] = ACTIONS(63),
    [anon_sym_class] = ACTIONS(99),
    [anon_sym_AT] = ACTIONS(67),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(107),
    [sym__string_start] = ACTIONS(81),
  },
  [19] = {
    [sym__statement] = STATE(61),
    [sym__simple_statements] = STATE(61),
    [sym_import_statement] = STATE(1319),
    [sym_future_import_statement] = STATE(1319),
    [sym_import_from_statement] = STATE(1319),
    [sym_print_statement] = STATE(1319),
    [sym_assert_statement] = STATE(1319),
    [sym_expression_statement] = STATE(1319),
    [sym_named_expression] = STATE(1009),
    [sym_return_statement] = STATE(1319),
    [sym_delete_statement] = STATE(1319),
    [sym_raise_statement] = STATE(1319),
    [sym_pass_statement] = STATE(1319),
    [sym_break_statement] = STATE(1319),
    [sym_continue_statement] = STATE(1319),
    [sym_if_statement] = STATE(61),
    [sym_for_statement] = STATE(61),
    [sym_while_statement] = STATE(61),
    [sym_try_statement] = STATE(61),
    [sym_with_statement] = STATE(61),
    [sym_match_statement] = STATE(61),
    [sym_function_definition] = STATE(61),
    [sym_list_splat] = STATE(1360),
    [sym_dictionary_splat] = STATE(1360),
    [sym_global_statement] = STATE(1319),
    [sym_nonlocal_statement] = STATE(1319),
    [sym_exec_statement] = STATE(1319),
    [sym_type_alias_statement] = STATE(1319),
    [sym_class_definition] = STATE(61),
    [sym_decorated_definition] = STATE(61),
    [sym_decorator] = STATE(996),
    [sym_block] = STATE(556),
    [sym_expression_list] = STATE(1361),
    [sym_pattern] = STATE(889),
    [sym_tuple_pattern] = STATE(875),
    [sym_list_pattern] = STATE(875),
    [sym_list_splat_pattern] = STATE(875),
    [sym_expression] = STATE(1019),
    [sym_primary_expression] = STATE(684),
    [sym_not_operator] = STATE(1009),
    [sym_boolean_operator] = STATE(1009),
    [sym_binary_operator] = STATE(797),
    [sym_unary_operator] = STATE(797),
    [sym_comparison_operator] = STATE(1009),
    [sym_lambda] = STATE(1009),
    [sym_assignment] = STATE(1361),
    [sym_augmented_assignment] = STATE(1361),
    [sym_pattern_list] = STATE(897),
    [sym_yield] = STATE(1361),
    [sym_attribute] = STATE(431),
    [sym_subscript] = STATE(431),
    [sym_call] = STATE(797),
    [sym_list] = STATE(797),
    [sym_set] = STATE(797),
    [sym_tuple] = STATE(797),
    [sym_dictionary] = STATE(797),
    [sym_list_comprehension] = STATE(797),
    [sym_dictionary_comprehension] = STATE(797),
    [sym_set_comprehension] = STATE(797),
    [sym_generator_expression] = STATE(797),
    [sym_parenthesized_expression] = STATE(797),
    [sym_conditional_expression] = STATE(1009),
    [sym_concatenated_string] = STATE(797),
    [sym_string] = STATE(713),
    [sym_await] = STATE(1009),
    [aux_sym_module_repeat1] = STATE(61),
    [aux_sym_decorated_definition_repeat1] = STATE(996),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_STAR] = ACTIONS(15),
    [anon_sym_print] = ACTIONS(17),
    [anon_sym_assert] = ACTIONS(19),
    [anon_sym_return] = ACTIONS(21),
    [anon_sym_del] = ACTIONS(23),
    [anon_sym_raise] = ACTIONS(25),
    [anon_sym_pass] = ACTIONS(27),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_async] = ACTIONS(85),
    [anon_sym_for] = ACTIONS(87),
    [anon_sym_while] = ACTIONS(89),
    [anon_sym_try] = ACTIONS(91),
    [anon_sym_with] = ACTIONS(93),
    [anon_sym_match] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(47),
    [anon_sym_PLUS] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(51),
    [anon_sym_STAR_STAR] = ACTIONS(53),
    [anon_sym_def] = ACTIONS(97),
    [anon_sym_global] = ACTIONS(57),
    [anon_sym_nonlocal] = ACTIONS(59),
    [anon_sym_exec] = ACTIONS(61),
    [anon_sym_type] = ACTIONS(63),
    [anon_sym_class] = ACTIONS(99),
    [anon_sym_AT] = ACTIONS(67),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(107),
    [sym__string_start] = ACTIONS(81),
  },
  [20] = {
    [sym__statement] = STATE(61),
    [sym__simple_statements] = STATE(61),
    [sym_import_statement] = STATE(1319),
    [sym_future_import_statement] = STATE(1319),
    [sym_import_from_statement] = STATE(1319),
    [sym_print_statement] = STATE(1319),
    [sym_assert_statement] = STATE(1319),
    [sym_expression_statement] = STATE(1319),
    [sym_named_expression] = STATE(1009),
    [sym_return_statement] = STATE(1319),
    [sym_delete_statement] = STATE(1319),
    [sym_raise_statement] = STATE(1319),
    [sym_pass_statement] = STATE(1319),
    [sym_break_statement] = STATE(1319),
    [sym_continue_statement] = STATE(1319),
    [sym_if_statement] = STATE(61),
    [sym_for_statement] = STATE(61),
    [sym_while_statement] = STATE(61),
    [sym_try_statement] = STATE(61),
    [sym_with_statement] = STATE(61),
    [sym_match_statement] = STATE(61),
    [sym_function_definition] = STATE(61),
    [sym_list_splat] = STATE(1360),
    [sym_dictionary_splat] = STATE(1360),
    [sym_global_statement] = STATE(1319),
    [sym_nonlocal_statement] = STATE(1319),
    [sym_exec_statement] = STATE(1319),
    [sym_type_alias_statement] = STATE(1319),
    [sym_class_definition] = STATE(61),
    [sym_decorated_definition] = STATE(61),
    [sym_decorator] = STATE(996),
    [sym_block] = STATE(528),
    [sym_expression_list] = STATE(1361),
    [sym_pattern] = STATE(889),
    [sym_tuple_pattern] = STATE(875),
    [sym_list_pattern] = STATE(875),
    [sym_list_splat_pattern] = STATE(875),
    [sym_expression] = STATE(1019),
    [sym_primary_expression] = STATE(684),
    [sym_not_operator] = STATE(1009),
    [sym_boolean_operator] = STATE(1009),
    [sym_binary_operator] = STATE(797),
    [sym_unary_operator] = STATE(797),
    [sym_comparison_operator] = STATE(1009),
    [sym_lambda] = STATE(1009),
    [sym_assignment] = STATE(1361),
    [sym_augmented_assignment] = STATE(1361),
    [sym_pattern_list] = STATE(897),
    [sym_yield] = STATE(1361),
    [sym_attribute] = STATE(431),
    [sym_subscript] = STATE(431),
    [sym_call] = STATE(797),
    [sym_list] = STATE(797),
    [sym_set] = STATE(797),
    [sym_tuple] = STATE(797),
    [sym_dictionary] = STATE(797),
    [sym_list_comprehension] = STATE(797),
    [sym_dictionary_comprehension] = STATE(797),
    [sym_set_comprehension] = STATE(797),
    [sym_generator_expression] = STATE(797),
    [sym_parenthesized_expression] = STATE(797),
    [sym_conditional_expression] = STATE(1009),
    [sym_concatenated_string] = STATE(797),
    [sym_string] = STATE(713),
    [sym_await] = STATE(1009),
    [aux_sym_module_repeat1] = STATE(61),
    [aux_sym_decorated_definition_repeat1] = STATE(996),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_STAR] = ACTIONS(15),
    [anon_sym_print] = ACTIONS(17),
    [anon_sym_assert] = ACTIONS(19),
    [anon_sym_return] = ACTIONS(21),
    [anon_sym_del] = ACTIONS(23),
    [anon_sym_raise] = ACTIONS(25),
    [anon_sym_pass] = ACTIONS(27),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_async] = ACTIONS(85),
    [anon_sym_for] = ACTIONS(87),
    [anon_sym_while] = ACTIONS(89),
    [anon_sym_try] = ACTIONS(91),
    [anon_sym_with] = ACTIONS(93),
    [anon_sym_match] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(47),
    [anon_sym_PLUS] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(51),
    [anon_sym_STAR_STAR] = ACTIONS(53),
    [anon_sym_def] = ACTIONS(97),
    [anon_sym_global] = ACTIONS(57),
    [anon_sym_nonlocal] = ACTIONS(59),
    [anon_sym_exec] = ACTIONS(61),
    [anon_sym_type] = ACTIONS(63),
    [anon_sym_class] = ACTIONS(99),
    [anon_sym_AT] = ACTIONS(67),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(107),
    [sym__string_start] = ACTIONS(81),
  },
  [21] = {
    [sym__statement] = STATE(68),
    [sym__simple_statements] = STATE(68),
    [sym_import_statement] = STATE(1319),
    [sym_future_import_statement] = STATE(1319),
    [sym_import_from_statement] = STATE(1319),
    [sym_print_statement] = STATE(1319),
    [sym_assert_statement] = STATE(1319),
    [sym_expression_statement] = STATE(1319),
    [sym_named_expression] = STATE(1009),
    [sym_return_statement] = STATE(1319),
    [sym_delete_statement] = STATE(1319),
    [sym_raise_statement] = STATE(1319),
    [sym_pass_statement] = STATE(1319),
    [sym_break_statement] = STATE(1319),
    [sym_continue_statement] = STATE(1319),
    [sym_if_statement] = STATE(68),
    [sym_for_statement] = STATE(68),
    [sym_while_statement] = STATE(68),
    [sym_try_statement] = STATE(68),
    [sym_with_statement] = STATE(68),
    [sym_match_statement] = STATE(68),
    [sym_function_definition] = STATE(68),
    [sym_list_splat] = STATE(1360),
    [sym_dictionary_splat] = STATE(1360),
    [sym_global_statement] = STATE(1319),
    [sym_nonlocal_statement] = STATE(1319),
    [sym_exec_statement] = STATE(1319),
    [sym_type_alias_statement] = STATE(1319),
    [sym_class_definition] = STATE(68),
    [sym_decorated_definition] = STATE(68),
    [sym_decorator] = STATE(996),
    [sym_block] = STATE(414),
    [sym_expression_list] = STATE(1361),
    [sym_pattern] = STATE(889),
    [sym_tuple_pattern] = STATE(875),
    [sym_list_pattern] = STATE(875),
    [sym_list_splat_pattern] = STATE(875),
    [sym_expression] = STATE(1019),
    [sym_primary_expression] = STATE(684),
    [sym_not_operator] = STATE(1009),
    [sym_boolean_operator] = STATE(1009),
    [sym_binary_operator] = STATE(797),
    [sym_unary_operator] = STATE(797),
    [sym_comparison_operator] = STATE(1009),
    [sym_lambda] = STATE(1009),
    [sym_assignment] = STATE(1361),
    [sym_augmented_assignment] = STATE(1361),
    [sym_pattern_list] = STATE(897),
    [sym_yield] = STATE(1361),
    [sym_attribute] = STATE(431),
    [sym_subscript] = STATE(431),
    [sym_call] = STATE(797),
    [sym_list] = STATE(797),
    [sym_set] = STATE(797),
    [sym_tuple] = STATE(797),
    [sym_dictionary] = STATE(797),
    [sym_list_comprehension] = STATE(797),
    [sym_dictionary_comprehension] = STATE(797),
    [sym_set_comprehension] = STATE(797),
    [sym_generator_expression] = STATE(797),
    [sym_parenthesized_expression] = STATE(797),
    [sym_conditional_expression] = STATE(1009),
    [sym_concatenated_string] = STATE(797),
    [sym_string] = STATE(713),
    [sym_await] = STATE(1009),
    [aux_sym_module_repeat1] = STATE(68),
    [aux_sym_decorated_definition_repeat1] = STATE(996),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_STAR] = ACTIONS(15),
    [anon_sym_print] = ACTIONS(17),
    [anon_sym_assert] = ACTIONS(19),
    [anon_sym_return] = ACTIONS(21),
    [anon_sym_del] = ACTIONS(23),
    [anon_sym_raise] = ACTIONS(25),
    [anon_sym_pass] = ACTIONS(27),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_async] = ACTIONS(85),
    [anon_sym_for] = ACTIONS(87),
    [anon_sym_while] = ACTIONS(89),
    [anon_sym_try] = ACTIONS(91),
    [anon_sym_with] = ACTIONS(93),
    [anon_sym_match] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(47),
    [anon_sym_PLUS] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(51),
    [anon_sym_STAR_STAR] = ACTIONS(53),
    [anon_sym_def] = ACTIONS(97),
    [anon_sym_global] = ACTIONS(57),
    [anon_sym_nonlocal] = ACTIONS(59),
    [anon_sym_exec] = ACTIONS(61),
    [anon_sym_type] = ACTIONS(63),
    [anon_sym_class] = ACTIONS(99),
    [anon_sym_AT] = ACTIONS(67),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(103),
    [sym__string_start] = ACTIONS(81),
  },
  [22] = {
    [sym__statement] = STATE(65),
    [sym__simple_statements] = STATE(65),
    [sym_import_statement] = STATE(1319),
    [sym_future_import_statement] = STATE(1319),
    [sym_import_from_statement] = STATE(1319),
    [sym_print_statement] = STATE(1319),
    [sym_assert_statement] = STATE(1319),
    [sym_expression_statement] = STATE(1319),
    [sym_named_expression] = STATE(1009),
    [sym_return_statement] = STATE(1319),
    [sym_delete_statement] = STATE(1319),
    [sym_raise_statement] = STATE(1319),
    [sym_pass_statement] = STATE(1319),
    [sym_break_statement] = STATE(1319),
    [sym_continue_statement] = STATE(1319),
    [sym_if_statement] = STATE(65),
    [sym_for_statement] = STATE(65),
    [sym_while_statement] = STATE(65),
    [sym_try_statement] = STATE(65),
    [sym_with_statement] = STATE(65),
    [sym_match_statement] = STATE(65),
    [sym_function_definition] = STATE(65),
    [sym_list_splat] = STATE(1360),
    [sym_dictionary_splat] = STATE(1360),
    [sym_global_statement] = STATE(1319),
    [sym_nonlocal_statement] = STATE(1319),
    [sym_exec_statement] = STATE(1319),
    [sym_type_alias_statement] = STATE(1319),
    [sym_class_definition] = STATE(65),
    [sym_decorated_definition] = STATE(65),
    [sym_decorator] = STATE(996),
    [sym_block] = STATE(366),
    [sym_expression_list] = STATE(1361),
    [sym_pattern] = STATE(889),
    [sym_tuple_pattern] = STATE(875),
    [sym_list_pattern] = STATE(875),
    [sym_list_splat_pattern] = STATE(875),
    [sym_expression] = STATE(1019),
    [sym_primary_expression] = STATE(684),
    [sym_not_operator] = STATE(1009),
    [sym_boolean_operator] = STATE(1009),
    [sym_binary_operator] = STATE(797),
    [sym_unary_operator] = STATE(797),
    [sym_comparison_operator] = STATE(1009),
    [sym_lambda] = STATE(1009),
    [sym_assignment] = STATE(1361),
    [sym_augmented_assignment] = STATE(1361),
    [sym_pattern_list] = STATE(897),
    [sym_yield] = STATE(1361),
    [sym_attribute] = STATE(431),
    [sym_subscript] = STATE(431),
    [sym_call] = STATE(797),
    [sym_list] = STATE(797),
    [sym_set] = STATE(797),
    [sym_tuple] = STATE(797),
    [sym_dictionary] = STATE(797),
    [sym_list_comprehension] = STATE(797),
    [sym_dictionary_comprehension] = STATE(797),
    [sym_set_comprehension] = STATE(797),
    [sym_generator_expression] = STATE(797),
    [sym_parenthesized_expression] = STATE(797),
    [sym_conditional_expression] = STATE(1009),
    [sym_concatenated_string] = STATE(797),
    [sym_string] = STATE(713),
    [sym_await] = STATE(1009),
    [aux_sym_module_repeat1] = STATE(65),
    [aux_sym_decorated_definition_repeat1] = STATE(996),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_STAR] = ACTIONS(15),
    [anon_sym_print] = ACTIONS(17),
    [anon_sym_assert] = ACTIONS(19),
    [anon_sym_return] = ACTIONS(21),
    [anon_sym_del] = ACTIONS(23),
    [anon_sym_raise] = ACTIONS(25),
    [anon_sym_pass] = ACTIONS(27),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_async] = ACTIONS(85),
    [anon_sym_for] = ACTIONS(87),
    [anon_sym_while] = ACTIONS(89),
    [anon_sym_try] = ACTIONS(91),
    [anon_sym_with] = ACTIONS(93),
    [anon_sym_match] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(47),
    [anon_sym_PLUS] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(51),
    [anon_sym_STAR_STAR] = ACTIONS(53),
    [anon_sym_def] = ACTIONS(97),
    [anon_sym_global] = ACTIONS(57),
    [anon_sym_nonlocal] = ACTIONS(59),
    [anon_sym_exec] = ACTIONS(61),
    [anon_sym_type] = ACTIONS(63),
    [anon_sym_class] = ACTIONS(99),
    [anon_sym_AT] = ACTIONS(67),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(101),
    [sym__string_start] = ACTIONS(81),
  },
  [23] = {
    [sym__statement] = STATE(62),
    [sym__simple_statements] = STATE(62),
    [sym_import_statement] = STATE(1319),
    [sym_future_import_statement] = STATE(1319),
    [sym_import_from_statement] = STATE(1319),
    [sym_print_statement] = STATE(1319),
    [sym_assert_statement] = STATE(1319),
    [sym_expression_statement] = STATE(1319),
    [sym_named_expression] = STATE(1009),
    [sym_return_statement] = STATE(1319),
    [sym_delete_statement] = STATE(1319),
    [sym_raise_statement] = STATE(1319),
    [sym_pass_statement] = STATE(1319),
    [sym_break_statement] = STATE(1319),
    [sym_continue_statement] = STATE(1319),
    [sym_if_statement] = STATE(62),
    [sym_for_statement] = STATE(62),
    [sym_while_statement] = STATE(62),
    [sym_try_statement] = STATE(62),
    [sym_with_statement] = STATE(62),
    [sym_match_statement] = STATE(62),
    [sym_function_definition] = STATE(62),
    [sym_list_splat] = STATE(1360),
    [sym_dictionary_splat] = STATE(1360),
    [sym_global_statement] = STATE(1319),
    [sym_nonlocal_statement] = STATE(1319),
    [sym_exec_statement] = STATE(1319),
    [sym_type_alias_statement] = STATE(1319),
    [sym_class_definition] = STATE(62),
    [sym_decorated_definition] = STATE(62),
    [sym_decorator] = STATE(996),
    [sym_block] = STATE(363),
    [sym_expression_list] = STATE(1361),
    [sym_pattern] = STATE(889),
    [sym_tuple_pattern] = STATE(875),
    [sym_list_pattern] = STATE(875),
    [sym_list_splat_pattern] = STATE(875),
    [sym_expression] = STATE(1019),
    [sym_primary_expression] = STATE(684),
    [sym_not_operator] = STATE(1009),
    [sym_boolean_operator] = STATE(1009),
    [sym_binary_operator] = STATE(797),
    [sym_unary_operator] = STATE(797),
    [sym_comparison_operator] = STATE(1009),
    [sym_lambda] = STATE(1009),
    [sym_assignment] = STATE(1361),
    [sym_augmented_assignment] = STATE(1361),
    [sym_pattern_list] = STATE(897),
    [sym_yield] = STATE(1361),
    [sym_attribute] = STATE(431),
    [sym_subscript] = STATE(431),
    [sym_call] = STATE(797),
    [sym_list] = STATE(797),
    [sym_set] = STATE(797),
    [sym_tuple] = STATE(797),
    [sym_dictionary] = STATE(797),
    [sym_list_comprehension] = STATE(797),
    [sym_dictionary_comprehension] = STATE(797),
    [sym_set_comprehension] = STATE(797),
    [sym_generator_expression] = STATE(797),
    [sym_parenthesized_expression] = STATE(797),
    [sym_conditional_expression] = STATE(1009),
    [sym_concatenated_string] = STATE(797),
    [sym_string] = STATE(713),
    [sym_await] = STATE(1009),
    [aux_sym_module_repeat1] = STATE(62),
    [aux_sym_decorated_definition_repeat1] = STATE(996),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_STAR] = ACTIONS(15),
    [anon_sym_print] = ACTIONS(17),
    [anon_sym_assert] = ACTIONS(19),
    [anon_sym_return] = ACTIONS(21),
    [anon_sym_del] = ACTIONS(23),
    [anon_sym_raise] = ACTIONS(25),
    [anon_sym_pass] = ACTIONS(27),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_async] = ACTIONS(85),
    [anon_sym_for] = ACTIONS(87),
    [anon_sym_while] = ACTIONS(89),
    [anon_sym_try] = ACTIONS(91),
    [anon_sym_with] = ACTIONS(93),
    [anon_sym_match] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(47),
    [anon_sym_PLUS] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(51),
    [anon_sym_STAR_STAR] = ACTIONS(53),
    [anon_sym_def] = ACTIONS(97),
    [anon_sym_global] = ACTIONS(57),
    [anon_sym_nonlocal] = ACTIONS(59),
    [anon_sym_exec] = ACTIONS(61),
    [anon_sym_type] = ACTIONS(63),
    [anon_sym_class] = ACTIONS(99),
    [anon_sym_AT] = ACTIONS(67),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(105),
    [sym__string_start] = ACTIONS(81),
  },
  [24] = {
    [sym__statement] = STATE(61),
    [sym__simple_statements] = STATE(61),
    [sym_import_statement] = STATE(1319),
    [sym_future_import_statement] = STATE(1319),
    [sym_import_from_statement] = STATE(1319),
    [sym_print_statement] = STATE(1319),
    [sym_assert_statement] = STATE(1319),
    [sym_expression_statement] = STATE(1319),
    [sym_named_expression] = STATE(1009),
    [sym_return_statement] = STATE(1319),
    [sym_delete_statement] = STATE(1319),
    [sym_raise_statement] = STATE(1319),
    [sym_pass_statement] = STATE(1319),
    [sym_break_statement] = STATE(1319),
    [sym_continue_statement] = STATE(1319),
    [sym_if_statement] = STATE(61),
    [sym_for_statement] = STATE(61),
    [sym_while_statement] = STATE(61),
    [sym_try_statement] = STATE(61),
    [sym_with_statement] = STATE(61),
    [sym_match_statement] = STATE(61),
    [sym_function_definition] = STATE(61),
    [sym_list_splat] = STATE(1360),
    [sym_dictionary_splat] = STATE(1360),
    [sym_global_statement] = STATE(1319),
    [sym_nonlocal_statement] = STATE(1319),
    [sym_exec_statement] = STATE(1319),
    [sym_type_alias_statement] = STATE(1319),
    [sym_class_definition] = STATE(61),
    [sym_decorated_definition] = STATE(61),
    [sym_decorator] = STATE(996),
    [sym_block] = STATE(512),
    [sym_expression_list] = STATE(1361),
    [sym_pattern] = STATE(889),
    [sym_tuple_pattern] = STATE(875),
    [sym_list_pattern] = STATE(875),
    [sym_list_splat_pattern] = STATE(875),
    [sym_expression] = STATE(1019),
    [sym_primary_expression] = STATE(684),
    [sym_not_operator] = STATE(1009),
    [sym_boolean_operator] = STATE(1009),
    [sym_binary_operator] = STATE(797),
    [sym_unary_operator] = STATE(797),
    [sym_comparison_operator] = STATE(1009),
    [sym_lambda] = STATE(1009),
    [sym_assignment] = STATE(1361),
    [sym_augmented_assignment] = STATE(1361),
    [sym_pattern_list] = STATE(897),
    [sym_yield] = STATE(1361),
    [sym_attribute] = STATE(431),
    [sym_subscript] = STATE(431),
    [sym_call] = STATE(797),
    [sym_list] = STATE(797),
    [sym_set] = STATE(797),
    [sym_tuple] = STATE(797),
    [sym_dictionary] = STATE(797),
    [sym_list_comprehension] = STATE(797),
    [sym_dictionary_comprehension] = STATE(797),
    [sym_set_comprehension] = STATE(797),
    [sym_generator_expression] = STATE(797),
    [sym_parenthesized_expression] = STATE(797),
    [sym_conditional_expression] = STATE(1009),
    [sym_concatenated_string] = STATE(797),
    [sym_string] = STATE(713),
    [sym_await] = STATE(1009),
    [aux_sym_module_repeat1] = STATE(61),
    [aux_sym_decorated_definition_repeat1] = STATE(996),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_STAR] = ACTIONS(15),
    [anon_sym_print] = ACTIONS(17),
    [anon_sym_assert] = ACTIONS(19),
    [anon_sym_return] = ACTIONS(21),
    [anon_sym_del] = ACTIONS(23),
    [anon_sym_raise] = ACTIONS(25),
    [anon_sym_pass] = ACTIONS(27),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_async] = ACTIONS(85),
    [anon_sym_for] = ACTIONS(87),
    [anon_sym_while] = ACTIONS(89),
    [anon_sym_try] = ACTIONS(91),
    [anon_sym_with] = ACTIONS(93),
    [anon_sym_match] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(47),
    [anon_sym_PLUS] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(51),
    [anon_sym_STAR_STAR] = ACTIONS(53),
    [anon_sym_def] = ACTIONS(97),
    [anon_sym_global] = ACTIONS(57),
    [anon_sym_nonlocal] = ACTIONS(59),
    [anon_sym_exec] = ACTIONS(61),
    [anon_sym_type] = ACTIONS(63),
    [anon_sym_class] = ACTIONS(99),
    [anon_sym_AT] = ACTIONS(67),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(107),
    [sym__string_start] = ACTIONS(81),
  },
  [25] = {
    [sym__statement] = STATE(60),
    [sym__simple_statements] = STATE(60),
    [sym_import_statement] = STATE(1319),
    [sym_future_import_statement] = STATE(1319),
    [sym_import_from_statement] = STATE(1319),
    [sym_print_statement] = STATE(1319),
    [sym_assert_statement] = STATE(1319),
    [sym_expression_statement] = STATE(1319),
    [sym_named_expression] = STATE(1009),
    [sym_return_statement] = STATE(1319),
    [sym_delete_statement] = STATE(1319),
    [sym_raise_statement] = STATE(1319),
    [sym_pass_statement] = STATE(1319),
    [sym_break_statement] = STATE(1319),
    [sym_continue_statement] = STATE(1319),
    [sym_if_statement] = STATE(60),
    [sym_for_statement] = STATE(60),
    [sym_while_statement] = STATE(60),
    [sym_try_statement] = STATE(60),
    [sym_with_statement] = STATE(60),
    [sym_match_statement] = STATE(60),
    [sym_function_definition] = STATE(60),
    [sym_list_splat] = STATE(1360),
    [sym_dictionary_splat] = STATE(1360),
    [sym_global_statement] = STATE(1319),
    [sym_nonlocal_statement] = STATE(1319),
    [sym_exec_statement] = STATE(1319),
    [sym_type_alias_statement] = STATE(1319),
    [sym_class_definition] = STATE(60),
    [sym_decorated_definition] = STATE(60),
    [sym_decorator] = STATE(996),
    [sym_block] = STATE(320),
    [sym_expression_list] = STATE(1361),
    [sym_pattern] = STATE(889),
    [sym_tuple_pattern] = STATE(875),
    [sym_list_pattern] = STATE(875),
    [sym_list_splat_pattern] = STATE(875),
    [sym_expression] = STATE(1019),
    [sym_primary_expression] = STATE(684),
    [sym_not_operator] = STATE(1009),
    [sym_boolean_operator] = STATE(1009),
    [sym_binary_operator] = STATE(797),
    [sym_unary_operator] = STATE(797),
    [sym_comparison_operator] = STATE(1009),
    [sym_lambda] = STATE(1009),
    [sym_assignment] = STATE(1361),
    [sym_augmented_assignment] = STATE(1361),
    [sym_pattern_list] = STATE(897),
    [sym_yield] = STATE(1361),
    [sym_attribute] = STATE(431),
    [sym_subscript] = STATE(431),
    [sym_call] = STATE(797),
    [sym_list] = STATE(797),
    [sym_set] = STATE(797),
    [sym_tuple] = STATE(797),
    [sym_dictionary] = STATE(797),
    [sym_list_comprehension] = STATE(797),
    [sym_dictionary_comprehension] = STATE(797),
    [sym_set_comprehension] = STATE(797),
    [sym_generator_expression] = STATE(797),
    [sym_parenthesized_expression] = STATE(797),
    [sym_conditional_expression] = STATE(1009),
    [sym_concatenated_string] = STATE(797),
    [sym_string] = STATE(713),
    [sym_await] = STATE(1009),
    [aux_sym_module_repeat1] = STATE(60),
    [aux_sym_decorated_definition_repeat1] = STATE(996),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_STAR] = ACTIONS(15),
    [anon_sym_print] = ACTIONS(17),
    [anon_sym_assert] = ACTIONS(19),
    [anon_sym_return] = ACTIONS(21),
    [anon_sym_del] = ACTIONS(23),
    [anon_sym_raise] = ACTIONS(25),
    [anon_sym_pass] = ACTIONS(27),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_async] = ACTIONS(85),
    [anon_sym_for] = ACTIONS(87),
    [anon_sym_while] = ACTIONS(89),
    [anon_sym_try] = ACTIONS(91),
    [anon_sym_with] = ACTIONS(93),
    [anon_sym_match] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(47),
    [anon_sym_PLUS] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(51),
    [anon_sym_STAR_STAR] = ACTIONS(53),
    [anon_sym_def] = ACTIONS(97),
    [anon_sym_global] = ACTIONS(57),
    [anon_sym_nonlocal] = ACTIONS(59),
    [anon_sym_exec] = ACTIONS(61),
    [anon_sym_type] = ACTIONS(63),
    [anon_sym_class] = ACTIONS(99),
    [anon_sym_AT] = ACTIONS(67),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(109),
    [sym__string_start] = ACTIONS(81),
  },
  [26] = {
    [sym__statement] = STATE(61),
    [sym__simple_statements] = STATE(61),
    [sym_import_statement] = STATE(1319),
    [sym_future_import_statement] = STATE(1319),
    [sym_import_from_statement] = STATE(1319),
    [sym_print_statement] = STATE(1319),
    [sym_assert_statement] = STATE(1319),
    [sym_expression_statement] = STATE(1319),
    [sym_named_expression] = STATE(1009),
    [sym_return_statement] = STATE(1319),
    [sym_delete_statement] = STATE(1319),
    [sym_raise_statement] = STATE(1319),
    [sym_pass_statement] = STATE(1319),
    [sym_break_statement] = STATE(1319),
    [sym_continue_statement] = STATE(1319),
    [sym_if_statement] = STATE(61),
    [sym_for_statement] = STATE(61),
    [sym_while_statement] = STATE(61),
    [sym_try_statement] = STATE(61),
    [sym_with_statement] = STATE(61),
    [sym_match_statement] = STATE(61),
    [sym_function_definition] = STATE(61),
    [sym_list_splat] = STATE(1360),
    [sym_dictionary_splat] = STATE(1360),
    [sym_global_statement] = STATE(1319),
    [sym_nonlocal_statement] = STATE(1319),
    [sym_exec_statement] = STATE(1319),
    [sym_type_alias_statement] = STATE(1319),
    [sym_class_definition] = STATE(61),
    [sym_decorated_definition] = STATE(61),
    [sym_decorator] = STATE(996),
    [sym_block] = STATE(590),
    [sym_expression_list] = STATE(1361),
    [sym_pattern] = STATE(889),
    [sym_tuple_pattern] = STATE(875),
    [sym_list_pattern] = STATE(875),
    [sym_list_splat_pattern] = STATE(875),
    [sym_expression] = STATE(1019),
    [sym_primary_expression] = STATE(684),
    [sym_not_operator] = STATE(1009),
    [sym_boolean_operator] = STATE(1009),
    [sym_binary_operator] = STATE(797),
    [sym_unary_operator] = STATE(797),
    [sym_comparison_operator] = STATE(1009),
    [sym_lambda] = STATE(1009),
    [sym_assignment] = STATE(1361),
    [sym_augmented_assignment] = STATE(1361),
    [sym_pattern_list] = STATE(897),
    [sym_yield] = STATE(1361),
    [sym_attribute] = STATE(431),
    [sym_subscript] = STATE(431),
    [sym_call] = STATE(797),
    [sym_list] = STATE(797),
    [sym_set] = STATE(797),
    [sym_tuple] = STATE(797),
    [sym_dictionary] = STATE(797),
    [sym_list_comprehension] = STATE(797),
    [sym_dictionary_comprehension] = STATE(797),
    [sym_set_comprehension] = STATE(797),
    [sym_generator_expression] = STATE(797),
    [sym_parenthesized_expression] = STATE(797),
    [sym_conditional_expression] = STATE(1009),
    [sym_concatenated_string] = STATE(797),
    [sym_string] = STATE(713),
    [sym_await] = STATE(1009),
    [aux_sym_module_repeat1] = STATE(61),
    [aux_sym_decorated_definition_repeat1] = STATE(996),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_STAR] = ACTIONS(15),
    [anon_sym_print] = ACTIONS(17),
    [anon_sym_assert] = ACTIONS(19),
    [anon_sym_return] = ACTIONS(21),
    [anon_sym_del] = ACTIONS(23),
    [anon_sym_raise] = ACTIONS(25),
    [anon_sym_pass] = ACTIONS(27),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_async] = ACTIONS(85),
    [anon_sym_for] = ACTIONS(87),
    [anon_sym_while] = ACTIONS(89),
    [anon_sym_try] = ACTIONS(91),
    [anon_sym_with] = ACTIONS(93),
    [anon_sym_match] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(47),
    [anon_sym_PLUS] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(51),
    [anon_sym_STAR_STAR] = ACTIONS(53),
    [anon_sym_def] = ACTIONS(97),
    [anon_sym_global] = ACTIONS(57),
    [anon_sym_nonlocal] = ACTIONS(59),
    [anon_sym_exec] = ACTIONS(61),
    [anon_sym_type] = ACTIONS(63),
    [anon_sym_class] = ACTIONS(99),
    [anon_sym_AT] = ACTIONS(67),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(107),
    [sym__string_start] = ACTIONS(81),
  },
  [27] = {
    [sym__statement] = STATE(61),
    [sym__simple_statements] = STATE(61),
    [sym_import_statement] = STATE(1319),
    [sym_future_import_statement] = STATE(1319),
    [sym_import_from_statement] = STATE(1319),
    [sym_print_statement] = STATE(1319),
    [sym_assert_statement] = STATE(1319),
    [sym_expression_statement] = STATE(1319),
    [sym_named_expression] = STATE(1009),
    [sym_return_statement] = STATE(1319),
    [sym_delete_statement] = STATE(1319),
    [sym_raise_statement] = STATE(1319),
    [sym_pass_statement] = STATE(1319),
    [sym_break_statement] = STATE(1319),
    [sym_continue_statement] = STATE(1319),
    [sym_if_statement] = STATE(61),
    [sym_for_statement] = STATE(61),
    [sym_while_statement] = STATE(61),
    [sym_try_statement] = STATE(61),
    [sym_with_statement] = STATE(61),
    [sym_match_statement] = STATE(61),
    [sym_function_definition] = STATE(61),
    [sym_list_splat] = STATE(1360),
    [sym_dictionary_splat] = STATE(1360),
    [sym_global_statement] = STATE(1319),
    [sym_nonlocal_statement] = STATE(1319),
    [sym_exec_statement] = STATE(1319),
    [sym_type_alias_statement] = STATE(1319),
    [sym_class_definition] = STATE(61),
    [sym_decorated_definition] = STATE(61),
    [sym_decorator] = STATE(996),
    [sym_block] = STATE(494),
    [sym_expression_list] = STATE(1361),
    [sym_pattern] = STATE(889),
    [sym_tuple_pattern] = STATE(875),
    [sym_list_pattern] = STATE(875),
    [sym_list_splat_pattern] = STATE(875),
    [sym_expression] = STATE(1019),
    [sym_primary_expression] = STATE(684),
    [sym_not_operator] = STATE(1009),
    [sym_boolean_operator] = STATE(1009),
    [sym_binary_operator] = STATE(797),
    [sym_unary_operator] = STATE(797),
    [sym_comparison_operator] = STATE(1009),
    [sym_lambda] = STATE(1009),
    [sym_assignment] = STATE(1361),
    [sym_augmented_assignment] = STATE(1361),
    [sym_pattern_list] = STATE(897),
    [sym_yield] = STATE(1361),
    [sym_attribute] = STATE(431),
    [sym_subscript] = STATE(431),
    [sym_call] = STATE(797),
    [sym_list] = STATE(797),
    [sym_set] = STATE(797),
    [sym_tuple] = STATE(797),
    [sym_dictionary] = STATE(797),
    [sym_list_comprehension] = STATE(797),
    [sym_dictionary_comprehension] = STATE(797),
    [sym_set_comprehension] = STATE(797),
    [sym_generator_expression] = STATE(797),
    [sym_parenthesized_expression] = STATE(797),
    [sym_conditional_expression] = STATE(1009),
    [sym_concatenated_string] = STATE(797),
    [sym_string] = STATE(713),
    [sym_await] = STATE(1009),
    [aux_sym_module_repeat1] = STATE(61),
    [aux_sym_decorated_definition_repeat1] = STATE(996),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_STAR] = ACTIONS(15),
    [anon_sym_print] = ACTIONS(17),
    [anon_sym_assert] = ACTIONS(19),
    [anon_sym_return] = ACTIONS(21),
    [anon_sym_del] = ACTIONS(23),
    [anon_sym_raise] = ACTIONS(25),
    [anon_sym_pass] = ACTIONS(27),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_async] = ACTIONS(85),
    [anon_sym_for] = ACTIONS(87),
    [anon_sym_while] = ACTIONS(89),
    [anon_sym_try] = ACTIONS(91),
    [anon_sym_with] = ACTIONS(93),
    [anon_sym_match] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(47),
    [anon_sym_PLUS] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(51),
    [anon_sym_STAR_STAR] = ACTIONS(53),
    [anon_sym_def] = ACTIONS(97),
    [anon_sym_global] = ACTIONS(57),
    [anon_sym_nonlocal] = ACTIONS(59),
    [anon_sym_exec] = ACTIONS(61),
    [anon_sym_type] = ACTIONS(63),
    [anon_sym_class] = ACTIONS(99),
    [anon_sym_AT] = ACTIONS(67),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(107),
    [sym__string_start] = ACTIONS(81),
  },
  [28] = {
    [sym__statement] = STATE(61),
    [sym__simple_statements] = STATE(61),
    [sym_import_statement] = STATE(1319),
    [sym_future_import_statement] = STATE(1319),
    [sym_import_from_statement] = STATE(1319),
    [sym_print_statement] = STATE(1319),
    [sym_assert_statement] = STATE(1319),
    [sym_expression_statement] = STATE(1319),
    [sym_named_expression] = STATE(1009),
    [sym_return_statement] = STATE(1319),
    [sym_delete_statement] = STATE(1319),
    [sym_raise_statement] = STATE(1319),
    [sym_pass_statement] = STATE(1319),
    [sym_break_statement] = STATE(1319),
    [sym_continue_statement] = STATE(1319),
    [sym_if_statement] = STATE(61),
    [sym_for_statement] = STATE(61),
    [sym_while_statement] = STATE(61),
    [sym_try_statement] = STATE(61),
    [sym_with_statement] = STATE(61),
    [sym_match_statement] = STATE(61),
    [sym_function_definition] = STATE(61),
    [sym_list_splat] = STATE(1360),
    [sym_dictionary_splat] = STATE(1360),
    [sym_global_statement] = STATE(1319),
    [sym_nonlocal_statement] = STATE(1319),
    [sym_exec_statement] = STATE(1319),
    [sym_type_alias_statement] = STATE(1319),
    [sym_class_definition] = STATE(61),
    [sym_decorated_definition] = STATE(61),
    [sym_decorator] = STATE(996),
    [sym_block] = STATE(557),
    [sym_expression_list] = STATE(1361),
    [sym_pattern] = STATE(889),
    [sym_tuple_pattern] = STATE(875),
    [sym_list_pattern] = STATE(875),
    [sym_list_splat_pattern] = STATE(875),
    [sym_expression] = STATE(1019),
    [sym_primary_expression] = STATE(684),
    [sym_not_operator] = STATE(1009),
    [sym_boolean_operator] = STATE(1009),
    [sym_binary_operator] = STATE(797),
    [sym_unary_operator] = STATE(797),
    [sym_comparison_operator] = STATE(1009),
    [sym_lambda] = STATE(1009),
    [sym_assignment] = STATE(1361),
    [sym_augmented_assignment] = STATE(1361),
    [sym_pattern_list] = STATE(897),
    [sym_yield] = STATE(1361),
    [sym_attribute] = STATE(431),
    [sym_subscript] = STATE(431),
    [sym_call] = STATE(797),
    [sym_list] = STATE(797),
    [sym_set] = STATE(797),
    [sym_tuple] = STATE(797),
    [sym_dictionary] = STATE(797),
    [sym_list_comprehension] = STATE(797),
    [sym_dictionary_comprehension] = STATE(797),
    [sym_set_comprehension] = STATE(797),
    [sym_generator_expression] = STATE(797),
    [sym_parenthesized_expression] = STATE(797),
    [sym_conditional_expression] = STATE(1009),
    [sym_concatenated_string] = STATE(797),
    [sym_string] = STATE(713),
    [sym_await] = STATE(1009),
    [aux_sym_module_repeat1] = STATE(61),
    [aux_sym_decorated_definition_repeat1] = STATE(996),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_STAR] = ACTIONS(15),
    [anon_sym_print] = ACTIONS(17),
    [anon_sym_assert] = ACTIONS(19),
    [anon_sym_return] = ACTIONS(21),
    [anon_sym_del] = ACTIONS(23),
    [anon_sym_raise] = ACTIONS(25),
    [anon_sym_pass] = ACTIONS(27),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_async] = ACTIONS(85),
    [anon_sym_for] = ACTIONS(87),
    [anon_sym_while] = ACTIONS(89),
    [anon_sym_try] = ACTIONS(91),
    [anon_sym_with] = ACTIONS(93),
    [anon_sym_match] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(47),
    [anon_sym_PLUS] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(51),
    [anon_sym_STAR_STAR] = ACTIONS(53),
    [anon_sym_def] = ACTIONS(97),
    [anon_sym_global] = ACTIONS(57),
    [anon_sym_nonlocal] = ACTIONS(59),
    [anon_sym_exec] = ACTIONS(61),
    [anon_sym_type] = ACTIONS(63),
    [anon_sym_class] = ACTIONS(99),
    [anon_sym_AT] = ACTIONS(67),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(107),
    [sym__string_start] = ACTIONS(81),
  },
  [29] = {
    [sym__statement] = STATE(61),
    [sym__simple_statements] = STATE(61),
    [sym_import_statement] = STATE(1319),
    [sym_future_import_statement] = STATE(1319),
    [sym_import_from_statement] = STATE(1319),
    [sym_print_statement] = STATE(1319),
    [sym_assert_statement] = STATE(1319),
    [sym_expression_statement] = STATE(1319),
    [sym_named_expression] = STATE(1009),
    [sym_return_statement] = STATE(1319),
    [sym_delete_statement] = STATE(1319),
    [sym_raise_statement] = STATE(1319),
    [sym_pass_statement] = STATE(1319),
    [sym_break_statement] = STATE(1319),
    [sym_continue_statement] = STATE(1319),
    [sym_if_statement] = STATE(61),
    [sym_for_statement] = STATE(61),
    [sym_while_statement] = STATE(61),
    [sym_try_statement] = STATE(61),
    [sym_with_statement] = STATE(61),
    [sym_match_statement] = STATE(61),
    [sym_function_definition] = STATE(61),
    [sym_list_splat] = STATE(1360),
    [sym_dictionary_splat] = STATE(1360),
    [sym_global_statement] = STATE(1319),
    [sym_nonlocal_statement] = STATE(1319),
    [sym_exec_statement] = STATE(1319),
    [sym_type_alias_statement] = STATE(1319),
    [sym_class_definition] = STATE(61),
    [sym_decorated_definition] = STATE(61),
    [sym_decorator] = STATE(996),
    [sym_block] = STATE(549),
    [sym_expression_list] = STATE(1361),
    [sym_pattern] = STATE(889),
    [sym_tuple_pattern] = STATE(875),
    [sym_list_pattern] = STATE(875),
    [sym_list_splat_pattern] = STATE(875),
    [sym_expression] = STATE(1019),
    [sym_primary_expression] = STATE(684),
    [sym_not_operator] = STATE(1009),
    [sym_boolean_operator] = STATE(1009),
    [sym_binary_operator] = STATE(797),
    [sym_unary_operator] = STATE(797),
    [sym_comparison_operator] = STATE(1009),
    [sym_lambda] = STATE(1009),
    [sym_assignment] = STATE(1361),
    [sym_augmented_assignment] = STATE(1361),
    [sym_pattern_list] = STATE(897),
    [sym_yield] = STATE(1361),
    [sym_attribute] = STATE(431),
    [sym_subscript] = STATE(431),
    [sym_call] = STATE(797),
    [sym_list] = STATE(797),
    [sym_set] = STATE(797),
    [sym_tuple] = STATE(797),
    [sym_dictionary] = STATE(797),
    [sym_list_comprehension] = STATE(797),
    [sym_dictionary_comprehension] = STATE(797),
    [sym_set_comprehension] = STATE(797),
    [sym_generator_expression] = STATE(797),
    [sym_parenthesized_expression] = STATE(797),
    [sym_conditional_expression] = STATE(1009),
    [sym_concatenated_string] = STATE(797),
    [sym_string] = STATE(713),
    [sym_await] = STATE(1009),
    [aux_sym_module_repeat1] = STATE(61),
    [aux_sym_decorated_definition_repeat1] = STATE(996),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_STAR] = ACTIONS(15),
    [anon_sym_print] = ACTIONS(17),
    [anon_sym_assert] = ACTIONS(19),
    [anon_sym_return] = ACTIONS(21),
    [anon_sym_del] = ACTIONS(23),
    [anon_sym_raise] = ACTIONS(25),
    [anon_sym_pass] = ACTIONS(27),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_async] = ACTIONS(85),
    [anon_sym_for] = ACTIONS(87),
    [anon_sym_while] = ACTIONS(89),
    [anon_sym_try] = ACTIONS(91),
    [anon_sym_with] = ACTIONS(93),
    [anon_sym_match] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(47),
    [anon_sym_PLUS] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(51),
    [anon_sym_STAR_STAR] = ACTIONS(53),
    [anon_sym_def] = ACTIONS(97),
    [anon_sym_global] = ACTIONS(57),
    [anon_sym_nonlocal] = ACTIONS(59),
    [anon_sym_exec] = ACTIONS(61),
    [anon_sym_type] = ACTIONS(63),
    [anon_sym_class] = ACTIONS(99),
    [anon_sym_AT] = ACTIONS(67),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(107),
    [sym__string_start] = ACTIONS(81),
  },
  [30] = {
    [sym__statement] = STATE(61),
    [sym__simple_statements] = STATE(61),
    [sym_import_statement] = STATE(1319),
    [sym_future_import_statement] = STATE(1319),
    [sym_import_from_statement] = STATE(1319),
    [sym_print_statement] = STATE(1319),
    [sym_assert_statement] = STATE(1319),
    [sym_expression_statement] = STATE(1319),
    [sym_named_expression] = STATE(1009),
    [sym_return_statement] = STATE(1319),
    [sym_delete_statement] = STATE(1319),
    [sym_raise_statement] = STATE(1319),
    [sym_pass_statement] = STATE(1319),
    [sym_break_statement] = STATE(1319),
    [sym_continue_statement] = STATE(1319),
    [sym_if_statement] = STATE(61),
    [sym_for_statement] = STATE(61),
    [sym_while_statement] = STATE(61),
    [sym_try_statement] = STATE(61),
    [sym_with_statement] = STATE(61),
    [sym_match_statement] = STATE(61),
    [sym_function_definition] = STATE(61),
    [sym_list_splat] = STATE(1360),
    [sym_dictionary_splat] = STATE(1360),
    [sym_global_statement] = STATE(1319),
    [sym_nonlocal_statement] = STATE(1319),
    [sym_exec_statement] = STATE(1319),
    [sym_type_alias_statement] = STATE(1319),
    [sym_class_definition] = STATE(61),
    [sym_decorated_definition] = STATE(61),
    [sym_decorator] = STATE(996),
    [sym_block] = STATE(586),
    [sym_expression_list] = STATE(1361),
    [sym_pattern] = STATE(889),
    [sym_tuple_pattern] = STATE(875),
    [sym_list_pattern] = STATE(875),
    [sym_list_splat_pattern] = STATE(875),
    [sym_expression] = STATE(1019),
    [sym_primary_expression] = STATE(684),
    [sym_not_operator] = STATE(1009),
    [sym_boolean_operator] = STATE(1009),
    [sym_binary_operator] = STATE(797),
    [sym_unary_operator] = STATE(797),
    [sym_comparison_operator] = STATE(1009),
    [sym_lambda] = STATE(1009),
    [sym_assignment] = STATE(1361),
    [sym_augmented_assignment] = STATE(1361),
    [sym_pattern_list] = STATE(897),
    [sym_yield] = STATE(1361),
    [sym_attribute] = STATE(431),
    [sym_subscript] = STATE(431),
    [sym_call] = STATE(797),
    [sym_list] = STATE(797),
    [sym_set] = STATE(797),
    [sym_tuple] = STATE(797),
    [sym_dictionary] = STATE(797),
    [sym_list_comprehension] = STATE(797),
    [sym_dictionary_comprehension] = STATE(797),
    [sym_set_comprehension] = STATE(797),
    [sym_generator_expression] = STATE(797),
    [sym_parenthesized_expression] = STATE(797),
    [sym_conditional_expression] = STATE(1009),
    [sym_concatenated_string] = STATE(797),
    [sym_string] = STATE(713),
    [sym_await] = STATE(1009),
    [aux_sym_module_repeat1] = STATE(61),
    [aux_sym_decorated_definition_repeat1] = STATE(996),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_STAR] = ACTIONS(15),
    [anon_sym_print] = ACTIONS(17),
    [anon_sym_assert] = ACTIONS(19),
    [anon_sym_return] = ACTIONS(21),
    [anon_sym_del] = ACTIONS(23),
    [anon_sym_raise] = ACTIONS(25),
    [anon_sym_pass] = ACTIONS(27),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_async] = ACTIONS(85),
    [anon_sym_for] = ACTIONS(87),
    [anon_sym_while] = ACTIONS(89),
    [anon_sym_try] = ACTIONS(91),
    [anon_sym_with] = ACTIONS(93),
    [anon_sym_match] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(47),
    [anon_sym_PLUS] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(51),
    [anon_sym_STAR_STAR] = ACTIONS(53),
    [anon_sym_def] = ACTIONS(97),
    [anon_sym_global] = ACTIONS(57),
    [anon_sym_nonlocal] = ACTIONS(59),
    [anon_sym_exec] = ACTIONS(61),
    [anon_sym_type] = ACTIONS(63),
    [anon_sym_class] = ACTIONS(99),
    [anon_sym_AT] = ACTIONS(67),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(107),
    [sym__string_start] = ACTIONS(81),
  },
  [31] = {
    [sym__statement] = STATE(60),
    [sym__simple_statements] = STATE(60),
    [sym_import_statement] = STATE(1319),
    [sym_future_import_statement] = STATE(1319),
    [sym_import_from_statement] = STATE(1319),
    [sym_print_statement] = STATE(1319),
    [sym_assert_statement] = STATE(1319),
    [sym_expression_statement] = STATE(1319),
    [sym_named_expression] = STATE(1009),
    [sym_return_statement] = STATE(1319),
    [sym_delete_statement] = STATE(1319),
    [sym_raise_statement] = STATE(1319),
    [sym_pass_statement] = STATE(1319),
    [sym_break_statement] = STATE(1319),
    [sym_continue_statement] = STATE(1319),
    [sym_if_statement] = STATE(60),
    [sym_for_statement] = STATE(60),
    [sym_while_statement] = STATE(60),
    [sym_try_statement] = STATE(60),
    [sym_with_statement] = STATE(60),
    [sym_match_statement] = STATE(60),
    [sym_function_definition] = STATE(60),
    [sym_list_splat] = STATE(1360),
    [sym_dictionary_splat] = STATE(1360),
    [sym_global_statement] = STATE(1319),
    [sym_nonlocal_statement] = STATE(1319),
    [sym_exec_statement] = STATE(1319),
    [sym_type_alias_statement] = STATE(1319),
    [sym_class_definition] = STATE(60),
    [sym_decorated_definition] = STATE(60),
    [sym_decorator] = STATE(996),
    [sym_block] = STATE(328),
    [sym_expression_list] = STATE(1361),
    [sym_pattern] = STATE(889),
    [sym_tuple_pattern] = STATE(875),
    [sym_list_pattern] = STATE(875),
    [sym_list_splat_pattern] = STATE(875),
    [sym_expression] = STATE(1019),
    [sym_primary_expression] = STATE(684),
    [sym_not_operator] = STATE(1009),
    [sym_boolean_operator] = STATE(1009),
    [sym_binary_operator] = STATE(797),
    [sym_unary_operator] = STATE(797),
    [sym_comparison_operator] = STATE(1009),
    [sym_lambda] = STATE(1009),
    [sym_assignment] = STATE(1361),
    [sym_augmented_assignment] = STATE(1361),
    [sym_pattern_list] = STATE(897),
    [sym_yield] = STATE(1361),
    [sym_attribute] = STATE(431),
    [sym_subscript] = STATE(431),
    [sym_call] = STATE(797),
    [sym_list] = STATE(797),
    [sym_set] = STATE(797),
    [sym_tuple] = STATE(797),
    [sym_dictionary] = STATE(797),
    [sym_list_comprehension] = STATE(797),
    [sym_dictionary_comprehension] = STATE(797),
    [sym_set_comprehension] = STATE(797),
    [sym_generator_expression] = STATE(797),
    [sym_parenthesized_expression] = STATE(797),
    [sym_conditional_expression] = STATE(1009),
    [sym_concatenated_string] = STATE(797),
    [sym_string] = STATE(713),
    [sym_await] = STATE(1009),
    [aux_sym_module_repeat1] = STATE(60),
    [aux_sym_decorated_definition_repeat1] = STATE(996),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_STAR] = ACTIONS(15),
    [anon_sym_print] = ACTIONS(17),
    [anon_sym_assert] = ACTIONS(19),
    [anon_sym_return] = ACTIONS(21),
    [anon_sym_del] = ACTIONS(23),
    [anon_sym_raise] = ACTIONS(25),
    [anon_sym_pass] = ACTIONS(27),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_async] = ACTIONS(85),
    [anon_sym_for] = ACTIONS(87),
    [anon_sym_while] = ACTIONS(89),
    [anon_sym_try] = ACTIONS(91),
    [anon_sym_with] = ACTIONS(93),
    [anon_sym_match] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(47),
    [anon_sym_PLUS] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(51),
    [anon_sym_STAR_STAR] = ACTIONS(53),
    [anon_sym_def] = ACTIONS(97),
    [anon_sym_global] = ACTIONS(57),
    [anon_sym_nonlocal] = ACTIONS(59),
    [anon_sym_exec] = ACTIONS(61),
    [anon_sym_type] = ACTIONS(63),
    [anon_sym_class] = ACTIONS(99),
    [anon_sym_AT] = ACTIONS(67),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(109),
    [sym__string_start] = ACTIONS(81),
  },
  [32] = {
    [sym__statement] = STATE(66),
    [sym__simple_statements] = STATE(66),
    [sym_import_statement] = STATE(1319),
    [sym_future_import_statement] = STATE(1319),
    [sym_import_from_statement] = STATE(1319),
    [sym_print_statement] = STATE(1319),
    [sym_assert_statement] = STATE(1319),
    [sym_expression_statement] = STATE(1319),
    [sym_named_expression] = STATE(1009),
    [sym_return_statement] = STATE(1319),
    [sym_delete_statement] = STATE(1319),
    [sym_raise_statement] = STATE(1319),
    [sym_pass_statement] = STATE(1319),
    [sym_break_statement] = STATE(1319),
    [sym_continue_statement] = STATE(1319),
    [sym_if_statement] = STATE(66),
    [sym_for_statement] = STATE(66),
    [sym_while_statement] = STATE(66),
    [sym_try_statement] = STATE(66),
    [sym_with_statement] = STATE(66),
    [sym_match_statement] = STATE(66),
    [sym_function_definition] = STATE(66),
    [sym_list_splat] = STATE(1360),
    [sym_dictionary_splat] = STATE(1360),
    [sym_global_statement] = STATE(1319),
    [sym_nonlocal_statement] = STATE(1319),
    [sym_exec_statement] = STATE(1319),
    [sym_type_alias_statement] = STATE(1319),
    [sym_class_definition] = STATE(66),
    [sym_decorated_definition] = STATE(66),
    [sym_decorator] = STATE(996),
    [sym_block] = STATE(329),
    [sym_expression_list] = STATE(1361),
    [sym_pattern] = STATE(889),
    [sym_tuple_pattern] = STATE(875),
    [sym_list_pattern] = STATE(875),
    [sym_list_splat_pattern] = STATE(875),
    [sym_expression] = STATE(1019),
    [sym_primary_expression] = STATE(684),
    [sym_not_operator] = STATE(1009),
    [sym_boolean_operator] = STATE(1009),
    [sym_binary_operator] = STATE(797),
    [sym_unary_operator] = STATE(797),
    [sym_comparison_operator] = STATE(1009),
    [sym_lambda] = STATE(1009),
    [sym_assignment] = STATE(1361),
    [sym_augmented_assignment] = STATE(1361),
    [sym_pattern_list] = STATE(897),
    [sym_yield] = STATE(1361),
    [sym_attribute] = STATE(431),
    [sym_subscript] = STATE(431),
    [sym_call] = STATE(797),
    [sym_list] = STATE(797),
    [sym_set] = STATE(797),
    [sym_tuple] = STATE(797),
    [sym_dictionary] = STATE(797),
    [sym_list_comprehension] = STATE(797),
    [sym_dictionary_comprehension] = STATE(797),
    [sym_set_comprehension] = STATE(797),
    [sym_generator_expression] = STATE(797),
    [sym_parenthesized_expression] = STATE(797),
    [sym_conditional_expression] = STATE(1009),
    [sym_concatenated_string] = STATE(797),
    [sym_string] = STATE(713),
    [sym_await] = STATE(1009),
    [aux_sym_module_repeat1] = STATE(66),
    [aux_sym_decorated_definition_repeat1] = STATE(996),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_STAR] = ACTIONS(15),
    [anon_sym_print] = ACTIONS(17),
    [anon_sym_assert] = ACTIONS(19),
    [anon_sym_return] = ACTIONS(21),
    [anon_sym_del] = ACTIONS(23),
    [anon_sym_raise] = ACTIONS(25),
    [anon_sym_pass] = ACTIONS(27),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_async] = ACTIONS(85),
    [anon_sym_for] = ACTIONS(87),
    [anon_sym_while] = ACTIONS(89),
    [anon_sym_try] = ACTIONS(91),
    [anon_sym_with] = ACTIONS(93),
    [anon_sym_match] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(47),
    [anon_sym_PLUS] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(51),
    [anon_sym_STAR_STAR] = ACTIONS(53),
    [anon_sym_def] = ACTIONS(97),
    [anon_sym_global] = ACTIONS(57),
    [anon_sym_nonlocal] = ACTIONS(59),
    [anon_sym_exec] = ACTIONS(61),
    [anon_sym_type] = ACTIONS(63),
    [anon_sym_class] = ACTIONS(99),
    [anon_sym_AT] = ACTIONS(67),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(111),
    [sym__string_start] = ACTIONS(81),
  },
  [33] = {
    [sym__statement] = STATE(61),
    [sym__simple_statements] = STATE(61),
    [sym_import_statement] = STATE(1319),
    [sym_future_import_statement] = STATE(1319),
    [sym_import_from_statement] = STATE(1319),
    [sym_print_statement] = STATE(1319),
    [sym_assert_statement] = STATE(1319),
    [sym_expression_statement] = STATE(1319),
    [sym_named_expression] = STATE(1009),
    [sym_return_statement] = STATE(1319),
    [sym_delete_statement] = STATE(1319),
    [sym_raise_statement] = STATE(1319),
    [sym_pass_statement] = STATE(1319),
    [sym_break_statement] = STATE(1319),
    [sym_continue_statement] = STATE(1319),
    [sym_if_statement] = STATE(61),
    [sym_for_statement] = STATE(61),
    [sym_while_statement] = STATE(61),
    [sym_try_statement] = STATE(61),
    [sym_with_statement] = STATE(61),
    [sym_match_statement] = STATE(61),
    [sym_function_definition] = STATE(61),
    [sym_list_splat] = STATE(1360),
    [sym_dictionary_splat] = STATE(1360),
    [sym_global_statement] = STATE(1319),
    [sym_nonlocal_statement] = STATE(1319),
    [sym_exec_statement] = STATE(1319),
    [sym_type_alias_statement] = STATE(1319),
    [sym_class_definition] = STATE(61),
    [sym_decorated_definition] = STATE(61),
    [sym_decorator] = STATE(996),
    [sym_block] = STATE(583),
    [sym_expression_list] = STATE(1361),
    [sym_pattern] = STATE(889),
    [sym_tuple_pattern] = STATE(875),
    [sym_list_pattern] = STATE(875),
    [sym_list_splat_pattern] = STATE(875),
    [sym_expression] = STATE(1019),
    [sym_primary_expression] = STATE(684),
    [sym_not_operator] = STATE(1009),
    [sym_boolean_operator] = STATE(1009),
    [sym_binary_operator] = STATE(797),
    [sym_unary_operator] = STATE(797),
    [sym_comparison_operator] = STATE(1009),
    [sym_lambda] = STATE(1009),
    [sym_assignment] = STATE(1361),
    [sym_augmented_assignment] = STATE(1361),
    [sym_pattern_list] = STATE(897),
    [sym_yield] = STATE(1361),
    [sym_attribute] = STATE(431),
    [sym_subscript] = STATE(431),
    [sym_call] = STATE(797),
    [sym_list] = STATE(797),
    [sym_set] = STATE(797),
    [sym_tuple] = STATE(797),
    [sym_dictionary] = STATE(797),
    [sym_list_comprehension] = STATE(797),
    [sym_dictionary_comprehension] = STATE(797),
    [sym_set_comprehension] = STATE(797),
    [sym_generator_expression] = STATE(797),
    [sym_parenthesized_expression] = STATE(797),
    [sym_conditional_expression] = STATE(1009),
    [sym_concatenated_string] = STATE(797),
    [sym_string] = STATE(713),
    [sym_await] = STATE(1009),
    [aux_sym_module_repeat1] = STATE(61),
    [aux_sym_decorated_definition_repeat1] = STATE(996),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_STAR] = ACTIONS(15),
    [anon_sym_print] = ACTIONS(17),
    [anon_sym_assert] = ACTIONS(19),
    [anon_sym_return] = ACTIONS(21),
    [anon_sym_del] = ACTIONS(23),
    [anon_sym_raise] = ACTIONS(25),
    [anon_sym_pass] = ACTIONS(27),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_async] = ACTIONS(85),
    [anon_sym_for] = ACTIONS(87),
    [anon_sym_while] = ACTIONS(89),
    [anon_sym_try] = ACTIONS(91),
    [anon_sym_with] = ACTIONS(93),
    [anon_sym_match] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(47),
    [anon_sym_PLUS] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(51),
    [anon_sym_STAR_STAR] = ACTIONS(53),
    [anon_sym_def] = ACTIONS(97),
    [anon_sym_global] = ACTIONS(57),
    [anon_sym_nonlocal] = ACTIONS(59),
    [anon_sym_exec] = ACTIONS(61),
    [anon_sym_type] = ACTIONS(63),
    [anon_sym_class] = ACTIONS(99),
    [anon_sym_AT] = ACTIONS(67),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(107),
    [sym__string_start] = ACTIONS(81),
  },
  [34] = {
    [sym__statement] = STATE(68),
    [sym__simple_statements] = STATE(68),
    [sym_import_statement] = STATE(1319),
    [sym_future_import_statement] = STATE(1319),
    [sym_import_from_statement] = STATE(1319),
    [sym_print_statement] = STATE(1319),
    [sym_assert_statement] = STATE(1319),
    [sym_expression_statement] = STATE(1319),
    [sym_named_expression] = STATE(1009),
    [sym_return_statement] = STATE(1319),
    [sym_delete_statement] = STATE(1319),
    [sym_raise_statement] = STATE(1319),
    [sym_pass_statement] = STATE(1319),
    [sym_break_statement] = STATE(1319),
    [sym_continue_statement] = STATE(1319),
    [sym_if_statement] = STATE(68),
    [sym_for_statement] = STATE(68),
    [sym_while_statement] = STATE(68),
    [sym_try_statement] = STATE(68),
    [sym_with_statement] = STATE(68),
    [sym_match_statement] = STATE(68),
    [sym_function_definition] = STATE(68),
    [sym_list_splat] = STATE(1360),
    [sym_dictionary_splat] = STATE(1360),
    [sym_global_statement] = STATE(1319),
    [sym_nonlocal_statement] = STATE(1319),
    [sym_exec_statement] = STATE(1319),
    [sym_type_alias_statement] = STATE(1319),
    [sym_class_definition] = STATE(68),
    [sym_decorated_definition] = STATE(68),
    [sym_decorator] = STATE(996),
    [sym_block] = STATE(418),
    [sym_expression_list] = STATE(1361),
    [sym_pattern] = STATE(889),
    [sym_tuple_pattern] = STATE(875),
    [sym_list_pattern] = STATE(875),
    [sym_list_splat_pattern] = STATE(875),
    [sym_expression] = STATE(1019),
    [sym_primary_expression] = STATE(684),
    [sym_not_operator] = STATE(1009),
    [sym_boolean_operator] = STATE(1009),
    [sym_binary_operator] = STATE(797),
    [sym_unary_operator] = STATE(797),
    [sym_comparison_operator] = STATE(1009),
    [sym_lambda] = STATE(1009),
    [sym_assignment] = STATE(1361),
    [sym_augmented_assignment] = STATE(1361),
    [sym_pattern_list] = STATE(897),
    [sym_yield] = STATE(1361),
    [sym_attribute] = STATE(431),
    [sym_subscript] = STATE(431),
    [sym_call] = STATE(797),
    [sym_list] = STATE(797),
    [sym_set] = STATE(797),
    [sym_tuple] = STATE(797),
    [sym_dictionary] = STATE(797),
    [sym_list_comprehension] = STATE(797),
    [sym_dictionary_comprehension] = STATE(797),
    [sym_set_comprehension] = STATE(797),
    [sym_generator_expression] = STATE(797),
    [sym_parenthesized_expression] = STATE(797),
    [sym_conditional_expression] = STATE(1009),
    [sym_concatenated_string] = STATE(797),
    [sym_string] = STATE(713),
    [sym_await] = STATE(1009),
    [aux_sym_module_repeat1] = STATE(68),
    [aux_sym_decorated_definition_repeat1] = STATE(996),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_STAR] = ACTIONS(15),
    [anon_sym_print] = ACTIONS(17),
    [anon_sym_assert] = ACTIONS(19),
    [anon_sym_return] = ACTIONS(21),
    [anon_sym_del] = ACTIONS(23),
    [anon_sym_raise] = ACTIONS(25),
    [anon_sym_pass] = ACTIONS(27),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_async] = ACTIONS(85),
    [anon_sym_for] = ACTIONS(87),
    [anon_sym_while] = ACTIONS(89),
    [anon_sym_try] = ACTIONS(91),
    [anon_sym_with] = ACTIONS(93),
    [anon_sym_match] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(47),
    [anon_sym_PLUS] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(51),
    [anon_sym_STAR_STAR] = ACTIONS(53),
    [anon_sym_def] = ACTIONS(97),
    [anon_sym_global] = ACTIONS(57),
    [anon_sym_nonlocal] = ACTIONS(59),
    [anon_sym_exec] = ACTIONS(61),
    [anon_sym_type] = ACTIONS(63),
    [anon_sym_class] = ACTIONS(99),
    [anon_sym_AT] = ACTIONS(67),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(103),
    [sym__string_start] = ACTIONS(81),
  },
  [35] = {
    [sym__statement] = STATE(68),
    [sym__simple_statements] = STATE(68),
    [sym_import_statement] = STATE(1319),
    [sym_future_import_statement] = STATE(1319),
    [sym_import_from_statement] = STATE(1319),
    [sym_print_statement] = STATE(1319),
    [sym_assert_statement] = STATE(1319),
    [sym_expression_statement] = STATE(1319),
    [sym_named_expression] = STATE(1009),
    [sym_return_statement] = STATE(1319),
    [sym_delete_statement] = STATE(1319),
    [sym_raise_statement] = STATE(1319),
    [sym_pass_statement] = STATE(1319),
    [sym_break_statement] = STATE(1319),
    [sym_continue_statement] = STATE(1319),
    [sym_if_statement] = STATE(68),
    [sym_for_statement] = STATE(68),
    [sym_while_statement] = STATE(68),
    [sym_try_statement] = STATE(68),
    [sym_with_statement] = STATE(68),
    [sym_match_statement] = STATE(68),
    [sym_function_definition] = STATE(68),
    [sym_list_splat] = STATE(1360),
    [sym_dictionary_splat] = STATE(1360),
    [sym_global_statement] = STATE(1319),
    [sym_nonlocal_statement] = STATE(1319),
    [sym_exec_statement] = STATE(1319),
    [sym_type_alias_statement] = STATE(1319),
    [sym_class_definition] = STATE(68),
    [sym_decorated_definition] = STATE(68),
    [sym_decorator] = STATE(996),
    [sym_block] = STATE(489),
    [sym_expression_list] = STATE(1361),
    [sym_pattern] = STATE(889),
    [sym_tuple_pattern] = STATE(875),
    [sym_list_pattern] = STATE(875),
    [sym_list_splat_pattern] = STATE(875),
    [sym_expression] = STATE(1019),
    [sym_primary_expression] = STATE(684),
    [sym_not_operator] = STATE(1009),
    [sym_boolean_operator] = STATE(1009),
    [sym_binary_operator] = STATE(797),
    [sym_unary_operator] = STATE(797),
    [sym_comparison_operator] = STATE(1009),
    [sym_lambda] = STATE(1009),
    [sym_assignment] = STATE(1361),
    [sym_augmented_assignment] = STATE(1361),
    [sym_pattern_list] = STATE(897),
    [sym_yield] = STATE(1361),
    [sym_attribute] = STATE(431),
    [sym_subscript] = STATE(431),
    [sym_call] = STATE(797),
    [sym_list] = STATE(797),
    [sym_set] = STATE(797),
    [sym_tuple] = STATE(797),
    [sym_dictionary] = STATE(797),
    [sym_list_comprehension] = STATE(797),
    [sym_dictionary_comprehension] = STATE(797),
    [sym_set_comprehension] = STATE(797),
    [sym_generator_expression] = STATE(797),
    [sym_parenthesized_expression] = STATE(797),
    [sym_conditional_expression] = STATE(1009),
    [sym_concatenated_string] = STATE(797),
    [sym_string] = STATE(713),
    [sym_await] = STATE(1009),
    [aux_sym_module_repeat1] = STATE(68),
    [aux_sym_decorated_definition_repeat1] = STATE(996),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_STAR] = ACTIONS(15),
    [anon_sym_print] = ACTIONS(17),
    [anon_sym_assert] = ACTIONS(19),
    [anon_sym_return] = ACTIONS(21),
    [anon_sym_del] = ACTIONS(23),
    [anon_sym_raise] = ACTIONS(25),
    [anon_sym_pass] = ACTIONS(27),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_async] = ACTIONS(85),
    [anon_sym_for] = ACTIONS(87),
    [anon_sym_while] = ACTIONS(89),
    [anon_sym_try] = ACTIONS(91),
    [anon_sym_with] = ACTIONS(93),
    [anon_sym_match] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(47),
    [anon_sym_PLUS] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(51),
    [anon_sym_STAR_STAR] = ACTIONS(53),
    [anon_sym_def] = ACTIONS(97),
    [anon_sym_global] = ACTIONS(57),
    [anon_sym_nonlocal] = ACTIONS(59),
    [anon_sym_exec] = ACTIONS(61),
    [anon_sym_type] = ACTIONS(63),
    [anon_sym_class] = ACTIONS(99),
    [anon_sym_AT] = ACTIONS(67),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(103),
    [sym__string_start] = ACTIONS(81),
  },
  [36] = {
    [sym__statement] = STATE(68),
    [sym__simple_statements] = STATE(68),
    [sym_import_statement] = STATE(1319),
    [sym_future_import_statement] = STATE(1319),
    [sym_import_from_statement] = STATE(1319),
    [sym_print_statement] = STATE(1319),
    [sym_assert_statement] = STATE(1319),
    [sym_expression_statement] = STATE(1319),
    [sym_named_expression] = STATE(1009),
    [sym_return_statement] = STATE(1319),
    [sym_delete_statement] = STATE(1319),
    [sym_raise_statement] = STATE(1319),
    [sym_pass_statement] = STATE(1319),
    [sym_break_statement] = STATE(1319),
    [sym_continue_statement] = STATE(1319),
    [sym_if_statement] = STATE(68),
    [sym_for_statement] = STATE(68),
    [sym_while_statement] = STATE(68),
    [sym_try_statement] = STATE(68),
    [sym_with_statement] = STATE(68),
    [sym_match_statement] = STATE(68),
    [sym_function_definition] = STATE(68),
    [sym_list_splat] = STATE(1360),
    [sym_dictionary_splat] = STATE(1360),
    [sym_global_statement] = STATE(1319),
    [sym_nonlocal_statement] = STATE(1319),
    [sym_exec_statement] = STATE(1319),
    [sym_type_alias_statement] = STATE(1319),
    [sym_class_definition] = STATE(68),
    [sym_decorated_definition] = STATE(68),
    [sym_decorator] = STATE(996),
    [sym_block] = STATE(498),
    [sym_expression_list] = STATE(1361),
    [sym_pattern] = STATE(889),
    [sym_tuple_pattern] = STATE(875),
    [sym_list_pattern] = STATE(875),
    [sym_list_splat_pattern] = STATE(875),
    [sym_expression] = STATE(1019),
    [sym_primary_expression] = STATE(684),
    [sym_not_operator] = STATE(1009),
    [sym_boolean_operator] = STATE(1009),
    [sym_binary_operator] = STATE(797),
    [sym_unary_operator] = STATE(797),
    [sym_comparison_operator] = STATE(1009),
    [sym_lambda] = STATE(1009),
    [sym_assignment] = STATE(1361),
    [sym_augmented_assignment] = STATE(1361),
    [sym_pattern_list] = STATE(897),
    [sym_yield] = STATE(1361),
    [sym_attribute] = STATE(431),
    [sym_subscript] = STATE(431),
    [sym_call] = STATE(797),
    [sym_list] = STATE(797),
    [sym_set] = STATE(797),
    [sym_tuple] = STATE(797),
    [sym_dictionary] = STATE(797),
    [sym_list_comprehension] = STATE(797),
    [sym_dictionary_comprehension] = STATE(797),
    [sym_set_comprehension] = STATE(797),
    [sym_generator_expression] = STATE(797),
    [sym_parenthesized_expression] = STATE(797),
    [sym_conditional_expression] = STATE(1009),
    [sym_concatenated_string] = STATE(797),
    [sym_string] = STATE(713),
    [sym_await] = STATE(1009),
    [aux_sym_module_repeat1] = STATE(68),
    [aux_sym_decorated_definition_repeat1] = STATE(996),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_STAR] = ACTIONS(15),
    [anon_sym_print] = ACTIONS(17),
    [anon_sym_assert] = ACTIONS(19),
    [anon_sym_return] = ACTIONS(21),
    [anon_sym_del] = ACTIONS(23),
    [anon_sym_raise] = ACTIONS(25),
    [anon_sym_pass] = ACTIONS(27),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_async] = ACTIONS(85),
    [anon_sym_for] = ACTIONS(87),
    [anon_sym_while] = ACTIONS(89),
    [anon_sym_try] = ACTIONS(91),
    [anon_sym_with] = ACTIONS(93),
    [anon_sym_match] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(47),
    [anon_sym_PLUS] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(51),
    [anon_sym_STAR_STAR] = ACTIONS(53),
    [anon_sym_def] = ACTIONS(97),
    [anon_sym_global] = ACTIONS(57),
    [anon_sym_nonlocal] = ACTIONS(59),
    [anon_sym_exec] = ACTIONS(61),
    [anon_sym_type] = ACTIONS(63),
    [anon_sym_class] = ACTIONS(99),
    [anon_sym_AT] = ACTIONS(67),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(103),
    [sym__string_start] = ACTIONS(81),
  },
  [37] = {
    [sym__statement] = STATE(68),
    [sym__simple_statements] = STATE(68),
    [sym_import_statement] = STATE(1319),
    [sym_future_import_statement] = STATE(1319),
    [sym_import_from_statement] = STATE(1319),
    [sym_print_statement] = STATE(1319),
    [sym_assert_statement] = STATE(1319),
    [sym_expression_statement] = STATE(1319),
    [sym_named_expression] = STATE(1009),
    [sym_return_statement] = STATE(1319),
    [sym_delete_statement] = STATE(1319),
    [sym_raise_statement] = STATE(1319),
    [sym_pass_statement] = STATE(1319),
    [sym_break_statement] = STATE(1319),
    [sym_continue_statement] = STATE(1319),
    [sym_if_statement] = STATE(68),
    [sym_for_statement] = STATE(68),
    [sym_while_statement] = STATE(68),
    [sym_try_statement] = STATE(68),
    [sym_with_statement] = STATE(68),
    [sym_match_statement] = STATE(68),
    [sym_function_definition] = STATE(68),
    [sym_list_splat] = STATE(1360),
    [sym_dictionary_splat] = STATE(1360),
    [sym_global_statement] = STATE(1319),
    [sym_nonlocal_statement] = STATE(1319),
    [sym_exec_statement] = STATE(1319),
    [sym_type_alias_statement] = STATE(1319),
    [sym_class_definition] = STATE(68),
    [sym_decorated_definition] = STATE(68),
    [sym_decorator] = STATE(996),
    [sym_block] = STATE(555),
    [sym_expression_list] = STATE(1361),
    [sym_pattern] = STATE(889),
    [sym_tuple_pattern] = STATE(875),
    [sym_list_pattern] = STATE(875),
    [sym_list_splat_pattern] = STATE(875),
    [sym_expression] = STATE(1019),
    [sym_primary_expression] = STATE(684),
    [sym_not_operator] = STATE(1009),
    [sym_boolean_operator] = STATE(1009),
    [sym_binary_operator] = STATE(797),
    [sym_unary_operator] = STATE(797),
    [sym_comparison_operator] = STATE(1009),
    [sym_lambda] = STATE(1009),
    [sym_assignment] = STATE(1361),
    [sym_augmented_assignment] = STATE(1361),
    [sym_pattern_list] = STATE(897),
    [sym_yield] = STATE(1361),
    [sym_attribute] = STATE(431),
    [sym_subscript] = STATE(431),
    [sym_call] = STATE(797),
    [sym_list] = STATE(797),
    [sym_set] = STATE(797),
    [sym_tuple] = STATE(797),
    [sym_dictionary] = STATE(797),
    [sym_list_comprehension] = STATE(797),
    [sym_dictionary_comprehension] = STATE(797),
    [sym_set_comprehension] = STATE(797),
    [sym_generator_expression] = STATE(797),
    [sym_parenthesized_expression] = STATE(797),
    [sym_conditional_expression] = STATE(1009),
    [sym_concatenated_string] = STATE(797),
    [sym_string] = STATE(713),
    [sym_await] = STATE(1009),
    [aux_sym_module_repeat1] = STATE(68),
    [aux_sym_decorated_definition_repeat1] = STATE(996),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_STAR] = ACTIONS(15),
    [anon_sym_print] = ACTIONS(17),
    [anon_sym_assert] = ACTIONS(19),
    [anon_sym_return] = ACTIONS(21),
    [anon_sym_del] = ACTIONS(23),
    [anon_sym_raise] = ACTIONS(25),
    [anon_sym_pass] = ACTIONS(27),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_async] = ACTIONS(85),
    [anon_sym_for] = ACTIONS(87),
    [anon_sym_while] = ACTIONS(89),
    [anon_sym_try] = ACTIONS(91),
    [anon_sym_with] = ACTIONS(93),
    [anon_sym_match] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(47),
    [anon_sym_PLUS] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(51),
    [anon_sym_STAR_STAR] = ACTIONS(53),
    [anon_sym_def] = ACTIONS(97),
    [anon_sym_global] = ACTIONS(57),
    [anon_sym_nonlocal] = ACTIONS(59),
    [anon_sym_exec] = ACTIONS(61),
    [anon_sym_type] = ACTIONS(63),
    [anon_sym_class] = ACTIONS(99),
    [anon_sym_AT] = ACTIONS(67),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(103),
    [sym__string_start] = ACTIONS(81),
  },
  [38] = {
    [sym__statement] = STATE(68),
    [sym__simple_statements] = STATE(68),
    [sym_import_statement] = STATE(1319),
    [sym_future_import_statement] = STATE(1319),
    [sym_import_from_statement] = STATE(1319),
    [sym_print_statement] = STATE(1319),
    [sym_assert_statement] = STATE(1319),
    [sym_expression_statement] = STATE(1319),
    [sym_named_expression] = STATE(1009),
    [sym_return_statement] = STATE(1319),
    [sym_delete_statement] = STATE(1319),
    [sym_raise_statement] = STATE(1319),
    [sym_pass_statement] = STATE(1319),
    [sym_break_statement] = STATE(1319),
    [sym_continue_statement] = STATE(1319),
    [sym_if_statement] = STATE(68),
    [sym_for_statement] = STATE(68),
    [sym_while_statement] = STATE(68),
    [sym_try_statement] = STATE(68),
    [sym_with_statement] = STATE(68),
    [sym_match_statement] = STATE(68),
    [sym_function_definition] = STATE(68),
    [sym_list_splat] = STATE(1360),
    [sym_dictionary_splat] = STATE(1360),
    [sym_global_statement] = STATE(1319),
    [sym_nonlocal_statement] = STATE(1319),
    [sym_exec_statement] = STATE(1319),
    [sym_type_alias_statement] = STATE(1319),
    [sym_class_definition] = STATE(68),
    [sym_decorated_definition] = STATE(68),
    [sym_decorator] = STATE(996),
    [sym_block] = STATE(565),
    [sym_expression_list] = STATE(1361),
    [sym_pattern] = STATE(889),
    [sym_tuple_pattern] = STATE(875),
    [sym_list_pattern] = STATE(875),
    [sym_list_splat_pattern] = STATE(875),
    [sym_expression] = STATE(1019),
    [sym_primary_expression] = STATE(684),
    [sym_not_operator] = STATE(1009),
    [sym_boolean_operator] = STATE(1009),
    [sym_binary_operator] = STATE(797),
    [sym_unary_operator] = STATE(797),
    [sym_comparison_operator] = STATE(1009),
    [sym_lambda] = STATE(1009),
    [sym_assignment] = STATE(1361),
    [sym_augmented_assignment] = STATE(1361),
    [sym_pattern_list] = STATE(897),
    [sym_yield] = STATE(1361),
    [sym_attribute] = STATE(431),
    [sym_subscript] = STATE(431),
    [sym_call] = STATE(797),
    [sym_list] = STATE(797),
    [sym_set] = STATE(797),
    [sym_tuple] = STATE(797),
    [sym_dictionary] = STATE(797),
    [sym_list_comprehension] = STATE(797),
    [sym_dictionary_comprehension] = STATE(797),
    [sym_set_comprehension] = STATE(797),
    [sym_generator_expression] = STATE(797),
    [sym_parenthesized_expression] = STATE(797),
    [sym_conditional_expression] = STATE(1009),
    [sym_concatenated_string] = STATE(797),
    [sym_string] = STATE(713),
    [sym_await] = STATE(1009),
    [aux_sym_module_repeat1] = STATE(68),
    [aux_sym_decorated_definition_repeat1] = STATE(996),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_STAR] = ACTIONS(15),
    [anon_sym_print] = ACTIONS(17),
    [anon_sym_assert] = ACTIONS(19),
    [anon_sym_return] = ACTIONS(21),
    [anon_sym_del] = ACTIONS(23),
    [anon_sym_raise] = ACTIONS(25),
    [anon_sym_pass] = ACTIONS(27),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_async] = ACTIONS(85),
    [anon_sym_for] = ACTIONS(87),
    [anon_sym_while] = ACTIONS(89),
    [anon_sym_try] = ACTIONS(91),
    [anon_sym_with] = ACTIONS(93),
    [anon_sym_match] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(47),
    [anon_sym_PLUS] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(51),
    [anon_sym_STAR_STAR] = ACTIONS(53),
    [anon_sym_def] = ACTIONS(97),
    [anon_sym_global] = ACTIONS(57),
    [anon_sym_nonlocal] = ACTIONS(59),
    [anon_sym_exec] = ACTIONS(61),
    [anon_sym_type] = ACTIONS(63),
    [anon_sym_class] = ACTIONS(99),
    [anon_sym_AT] = ACTIONS(67),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(103),
    [sym__string_start] = ACTIONS(81),
  },
  [39] = {
    [sym__statement] = STATE(68),
    [sym__simple_statements] = STATE(68),
    [sym_import_statement] = STATE(1319),
    [sym_future_import_statement] = STATE(1319),
    [sym_import_from_statement] = STATE(1319),
    [sym_print_statement] = STATE(1319),
    [sym_assert_statement] = STATE(1319),
    [sym_expression_statement] = STATE(1319),
    [sym_named_expression] = STATE(1009),
    [sym_return_statement] = STATE(1319),
    [sym_delete_statement] = STATE(1319),
    [sym_raise_statement] = STATE(1319),
    [sym_pass_statement] = STATE(1319),
    [sym_break_statement] = STATE(1319),
    [sym_continue_statement] = STATE(1319),
    [sym_if_statement] = STATE(68),
    [sym_for_statement] = STATE(68),
    [sym_while_statement] = STATE(68),
    [sym_try_statement] = STATE(68),
    [sym_with_statement] = STATE(68),
    [sym_match_statement] = STATE(68),
    [sym_function_definition] = STATE(68),
    [sym_list_splat] = STATE(1360),
    [sym_dictionary_splat] = STATE(1360),
    [sym_global_statement] = STATE(1319),
    [sym_nonlocal_statement] = STATE(1319),
    [sym_exec_statement] = STATE(1319),
    [sym_type_alias_statement] = STATE(1319),
    [sym_class_definition] = STATE(68),
    [sym_decorated_definition] = STATE(68),
    [sym_decorator] = STATE(996),
    [sym_block] = STATE(428),
    [sym_expression_list] = STATE(1361),
    [sym_pattern] = STATE(889),
    [sym_tuple_pattern] = STATE(875),
    [sym_list_pattern] = STATE(875),
    [sym_list_splat_pattern] = STATE(875),
    [sym_expression] = STATE(1019),
    [sym_primary_expression] = STATE(684),
    [sym_not_operator] = STATE(1009),
    [sym_boolean_operator] = STATE(1009),
    [sym_binary_operator] = STATE(797),
    [sym_unary_operator] = STATE(797),
    [sym_comparison_operator] = STATE(1009),
    [sym_lambda] = STATE(1009),
    [sym_assignment] = STATE(1361),
    [sym_augmented_assignment] = STATE(1361),
    [sym_pattern_list] = STATE(897),
    [sym_yield] = STATE(1361),
    [sym_attribute] = STATE(431),
    [sym_subscript] = STATE(431),
    [sym_call] = STATE(797),
    [sym_list] = STATE(797),
    [sym_set] = STATE(797),
    [sym_tuple] = STATE(797),
    [sym_dictionary] = STATE(797),
    [sym_list_comprehension] = STATE(797),
    [sym_dictionary_comprehension] = STATE(797),
    [sym_set_comprehension] = STATE(797),
    [sym_generator_expression] = STATE(797),
    [sym_parenthesized_expression] = STATE(797),
    [sym_conditional_expression] = STATE(1009),
    [sym_concatenated_string] = STATE(797),
    [sym_string] = STATE(713),
    [sym_await] = STATE(1009),
    [aux_sym_module_repeat1] = STATE(68),
    [aux_sym_decorated_definition_repeat1] = STATE(996),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_STAR] = ACTIONS(15),
    [anon_sym_print] = ACTIONS(17),
    [anon_sym_assert] = ACTIONS(19),
    [anon_sym_return] = ACTIONS(21),
    [anon_sym_del] = ACTIONS(23),
    [anon_sym_raise] = ACTIONS(25),
    [anon_sym_pass] = ACTIONS(27),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_async] = ACTIONS(85),
    [anon_sym_for] = ACTIONS(87),
    [anon_sym_while] = ACTIONS(89),
    [anon_sym_try] = ACTIONS(91),
    [anon_sym_with] = ACTIONS(93),
    [anon_sym_match] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(47),
    [anon_sym_PLUS] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(51),
    [anon_sym_STAR_STAR] = ACTIONS(53),
    [anon_sym_def] = ACTIONS(97),
    [anon_sym_global] = ACTIONS(57),
    [anon_sym_nonlocal] = ACTIONS(59),
    [anon_sym_exec] = ACTIONS(61),
    [anon_sym_type] = ACTIONS(63),
    [anon_sym_class] = ACTIONS(99),
    [anon_sym_AT] = ACTIONS(67),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(103),
    [sym__string_start] = ACTIONS(81),
  },
  [40] = {
    [sym__statement] = STATE(61),
    [sym__simple_statements] = STATE(61),
    [sym_import_statement] = STATE(1319),
    [sym_future_import_statement] = STATE(1319),
    [sym_import_from_statement] = STATE(1319),
    [sym_print_statement] = STATE(1319),
    [sym_assert_statement] = STATE(1319),
    [sym_expression_statement] = STATE(1319),
    [sym_named_expression] = STATE(1009),
    [sym_return_statement] = STATE(1319),
    [sym_delete_statement] = STATE(1319),
    [sym_raise_statement] = STATE(1319),
    [sym_pass_statement] = STATE(1319),
    [sym_break_statement] = STATE(1319),
    [sym_continue_statement] = STATE(1319),
    [sym_if_statement] = STATE(61),
    [sym_for_statement] = STATE(61),
    [sym_while_statement] = STATE(61),
    [sym_try_statement] = STATE(61),
    [sym_with_statement] = STATE(61),
    [sym_match_statement] = STATE(61),
    [sym_function_definition] = STATE(61),
    [sym_list_splat] = STATE(1360),
    [sym_dictionary_splat] = STATE(1360),
    [sym_global_statement] = STATE(1319),
    [sym_nonlocal_statement] = STATE(1319),
    [sym_exec_statement] = STATE(1319),
    [sym_type_alias_statement] = STATE(1319),
    [sym_class_definition] = STATE(61),
    [sym_decorated_definition] = STATE(61),
    [sym_decorator] = STATE(996),
    [sym_block] = STATE(515),
    [sym_expression_list] = STATE(1361),
    [sym_pattern] = STATE(889),
    [sym_tuple_pattern] = STATE(875),
    [sym_list_pattern] = STATE(875),
    [sym_list_splat_pattern] = STATE(875),
    [sym_expression] = STATE(1019),
    [sym_primary_expression] = STATE(684),
    [sym_not_operator] = STATE(1009),
    [sym_boolean_operator] = STATE(1009),
    [sym_binary_operator] = STATE(797),
    [sym_unary_operator] = STATE(797),
    [sym_comparison_operator] = STATE(1009),
    [sym_lambda] = STATE(1009),
    [sym_assignment] = STATE(1361),
    [sym_augmented_assignment] = STATE(1361),
    [sym_pattern_list] = STATE(897),
    [sym_yield] = STATE(1361),
    [sym_attribute] = STATE(431),
    [sym_subscript] = STATE(431),
    [sym_call] = STATE(797),
    [sym_list] = STATE(797),
    [sym_set] = STATE(797),
    [sym_tuple] = STATE(797),
    [sym_dictionary] = STATE(797),
    [sym_list_comprehension] = STATE(797),
    [sym_dictionary_comprehension] = STATE(797),
    [sym_set_comprehension] = STATE(797),
    [sym_generator_expression] = STATE(797),
    [sym_parenthesized_expression] = STATE(797),
    [sym_conditional_expression] = STATE(1009),
    [sym_concatenated_string] = STATE(797),
    [sym_string] = STATE(713),
    [sym_await] = STATE(1009),
    [aux_sym_module_repeat1] = STATE(61),
    [aux_sym_decorated_definition_repeat1] = STATE(996),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_STAR] = ACTIONS(15),
    [anon_sym_print] = ACTIONS(17),
    [anon_sym_assert] = ACTIONS(19),
    [anon_sym_return] = ACTIONS(21),
    [anon_sym_del] = ACTIONS(23),
    [anon_sym_raise] = ACTIONS(25),
    [anon_sym_pass] = ACTIONS(27),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_async] = ACTIONS(85),
    [anon_sym_for] = ACTIONS(87),
    [anon_sym_while] = ACTIONS(89),
    [anon_sym_try] = ACTIONS(91),
    [anon_sym_with] = ACTIONS(93),
    [anon_sym_match] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(47),
    [anon_sym_PLUS] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(51),
    [anon_sym_STAR_STAR] = ACTIONS(53),
    [anon_sym_def] = ACTIONS(97),
    [anon_sym_global] = ACTIONS(57),
    [anon_sym_nonlocal] = ACTIONS(59),
    [anon_sym_exec] = ACTIONS(61),
    [anon_sym_type] = ACTIONS(63),
    [anon_sym_class] = ACTIONS(99),
    [anon_sym_AT] = ACTIONS(67),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(107),
    [sym__string_start] = ACTIONS(81),
  },
  [41] = {
    [sym__statement] = STATE(68),
    [sym__simple_statements] = STATE(68),
    [sym_import_statement] = STATE(1319),
    [sym_future_import_statement] = STATE(1319),
    [sym_import_from_statement] = STATE(1319),
    [sym_print_statement] = STATE(1319),
    [sym_assert_statement] = STATE(1319),
    [sym_expression_statement] = STATE(1319),
    [sym_named_expression] = STATE(1009),
    [sym_return_statement] = STATE(1319),
    [sym_delete_statement] = STATE(1319),
    [sym_raise_statement] = STATE(1319),
    [sym_pass_statement] = STATE(1319),
    [sym_break_statement] = STATE(1319),
    [sym_continue_statement] = STATE(1319),
    [sym_if_statement] = STATE(68),
    [sym_for_statement] = STATE(68),
    [sym_while_statement] = STATE(68),
    [sym_try_statement] = STATE(68),
    [sym_with_statement] = STATE(68),
    [sym_match_statement] = STATE(68),
    [sym_function_definition] = STATE(68),
    [sym_list_splat] = STATE(1360),
    [sym_dictionary_splat] = STATE(1360),
    [sym_global_statement] = STATE(1319),
    [sym_nonlocal_statement] = STATE(1319),
    [sym_exec_statement] = STATE(1319),
    [sym_type_alias_statement] = STATE(1319),
    [sym_class_definition] = STATE(68),
    [sym_decorated_definition] = STATE(68),
    [sym_decorator] = STATE(996),
    [sym_block] = STATE(574),
    [sym_expression_list] = STATE(1361),
    [sym_pattern] = STATE(889),
    [sym_tuple_pattern] = STATE(875),
    [sym_list_pattern] = STATE(875),
    [sym_list_splat_pattern] = STATE(875),
    [sym_expression] = STATE(1019),
    [sym_primary_expression] = STATE(684),
    [sym_not_operator] = STATE(1009),
    [sym_boolean_operator] = STATE(1009),
    [sym_binary_operator] = STATE(797),
    [sym_unary_operator] = STATE(797),
    [sym_comparison_operator] = STATE(1009),
    [sym_lambda] = STATE(1009),
    [sym_assignment] = STATE(1361),
    [sym_augmented_assignment] = STATE(1361),
    [sym_pattern_list] = STATE(897),
    [sym_yield] = STATE(1361),
    [sym_attribute] = STATE(431),
    [sym_subscript] = STATE(431),
    [sym_call] = STATE(797),
    [sym_list] = STATE(797),
    [sym_set] = STATE(797),
    [sym_tuple] = STATE(797),
    [sym_dictionary] = STATE(797),
    [sym_list_comprehension] = STATE(797),
    [sym_dictionary_comprehension] = STATE(797),
    [sym_set_comprehension] = STATE(797),
    [sym_generator_expression] = STATE(797),
    [sym_parenthesized_expression] = STATE(797),
    [sym_conditional_expression] = STATE(1009),
    [sym_concatenated_string] = STATE(797),
    [sym_string] = STATE(713),
    [sym_await] = STATE(1009),
    [aux_sym_module_repeat1] = STATE(68),
    [aux_sym_decorated_definition_repeat1] = STATE(996),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_STAR] = ACTIONS(15),
    [anon_sym_print] = ACTIONS(17),
    [anon_sym_assert] = ACTIONS(19),
    [anon_sym_return] = ACTIONS(21),
    [anon_sym_del] = ACTIONS(23),
    [anon_sym_raise] = ACTIONS(25),
    [anon_sym_pass] = ACTIONS(27),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_async] = ACTIONS(85),
    [anon_sym_for] = ACTIONS(87),
    [anon_sym_while] = ACTIONS(89),
    [anon_sym_try] = ACTIONS(91),
    [anon_sym_with] = ACTIONS(93),
    [anon_sym_match] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(47),
    [anon_sym_PLUS] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(51),
    [anon_sym_STAR_STAR] = ACTIONS(53),
    [anon_sym_def] = ACTIONS(97),
    [anon_sym_global] = ACTIONS(57),
    [anon_sym_nonlocal] = ACTIONS(59),
    [anon_sym_exec] = ACTIONS(61),
    [anon_sym_type] = ACTIONS(63),
    [anon_sym_class] = ACTIONS(99),
    [anon_sym_AT] = ACTIONS(67),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(103),
    [sym__string_start] = ACTIONS(81),
  },
  [42] = {
    [sym__statement] = STATE(66),
    [sym__simple_statements] = STATE(66),
    [sym_import_statement] = STATE(1319),
    [sym_future_import_statement] = STATE(1319),
    [sym_import_from_statement] = STATE(1319),
    [sym_print_statement] = STATE(1319),
    [sym_assert_statement] = STATE(1319),
    [sym_expression_statement] = STATE(1319),
    [sym_named_expression] = STATE(1009),
    [sym_return_statement] = STATE(1319),
    [sym_delete_statement] = STATE(1319),
    [sym_raise_statement] = STATE(1319),
    [sym_pass_statement] = STATE(1319),
    [sym_break_statement] = STATE(1319),
    [sym_continue_statement] = STATE(1319),
    [sym_if_statement] = STATE(66),
    [sym_for_statement] = STATE(66),
    [sym_while_statement] = STATE(66),
    [sym_try_statement] = STATE(66),
    [sym_with_statement] = STATE(66),
    [sym_match_statement] = STATE(66),
    [sym_function_definition] = STATE(66),
    [sym_list_splat] = STATE(1360),
    [sym_dictionary_splat] = STATE(1360),
    [sym_global_statement] = STATE(1319),
    [sym_nonlocal_statement] = STATE(1319),
    [sym_exec_statement] = STATE(1319),
    [sym_type_alias_statement] = STATE(1319),
    [sym_class_definition] = STATE(66),
    [sym_decorated_definition] = STATE(66),
    [sym_decorator] = STATE(996),
    [sym_block] = STATE(318),
    [sym_expression_list] = STATE(1361),
    [sym_pattern] = STATE(889),
    [sym_tuple_pattern] = STATE(875),
    [sym_list_pattern] = STATE(875),
    [sym_list_splat_pattern] = STATE(875),
    [sym_expression] = STATE(1019),
    [sym_primary_expression] = STATE(684),
    [sym_not_operator] = STATE(1009),
    [sym_boolean_operator] = STATE(1009),
    [sym_binary_operator] = STATE(797),
    [sym_unary_operator] = STATE(797),
    [sym_comparison_operator] = STATE(1009),
    [sym_lambda] = STATE(1009),
    [sym_assignment] = STATE(1361),
    [sym_augmented_assignment] = STATE(1361),
    [sym_pattern_list] = STATE(897),
    [sym_yield] = STATE(1361),
    [sym_attribute] = STATE(431),
    [sym_subscript] = STATE(431),
    [sym_call] = STATE(797),
    [sym_list] = STATE(797),
    [sym_set] = STATE(797),
    [sym_tuple] = STATE(797),
    [sym_dictionary] = STATE(797),
    [sym_list_comprehension] = STATE(797),
    [sym_dictionary_comprehension] = STATE(797),
    [sym_set_comprehension] = STATE(797),
    [sym_generator_expression] = STATE(797),
    [sym_parenthesized_expression] = STATE(797),
    [sym_conditional_expression] = STATE(1009),
    [sym_concatenated_string] = STATE(797),
    [sym_string] = STATE(713),
    [sym_await] = STATE(1009),
    [aux_sym_module_repeat1] = STATE(66),
    [aux_sym_decorated_definition_repeat1] = STATE(996),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_STAR] = ACTIONS(15),
    [anon_sym_print] = ACTIONS(17),
    [anon_sym_assert] = ACTIONS(19),
    [anon_sym_return] = ACTIONS(21),
    [anon_sym_del] = ACTIONS(23),
    [anon_sym_raise] = ACTIONS(25),
    [anon_sym_pass] = ACTIONS(27),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_async] = ACTIONS(85),
    [anon_sym_for] = ACTIONS(87),
    [anon_sym_while] = ACTIONS(89),
    [anon_sym_try] = ACTIONS(91),
    [anon_sym_with] = ACTIONS(93),
    [anon_sym_match] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(47),
    [anon_sym_PLUS] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(51),
    [anon_sym_STAR_STAR] = ACTIONS(53),
    [anon_sym_def] = ACTIONS(97),
    [anon_sym_global] = ACTIONS(57),
    [anon_sym_nonlocal] = ACTIONS(59),
    [anon_sym_exec] = ACTIONS(61),
    [anon_sym_type] = ACTIONS(63),
    [anon_sym_class] = ACTIONS(99),
    [anon_sym_AT] = ACTIONS(67),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(111),
    [sym__string_start] = ACTIONS(81),
  },
  [43] = {
    [sym__statement] = STATE(68),
    [sym__simple_statements] = STATE(68),
    [sym_import_statement] = STATE(1319),
    [sym_future_import_statement] = STATE(1319),
    [sym_import_from_statement] = STATE(1319),
    [sym_print_statement] = STATE(1319),
    [sym_assert_statement] = STATE(1319),
    [sym_expression_statement] = STATE(1319),
    [sym_named_expression] = STATE(1009),
    [sym_return_statement] = STATE(1319),
    [sym_delete_statement] = STATE(1319),
    [sym_raise_statement] = STATE(1319),
    [sym_pass_statement] = STATE(1319),
    [sym_break_statement] = STATE(1319),
    [sym_continue_statement] = STATE(1319),
    [sym_if_statement] = STATE(68),
    [sym_for_statement] = STATE(68),
    [sym_while_statement] = STATE(68),
    [sym_try_statement] = STATE(68),
    [sym_with_statement] = STATE(68),
    [sym_match_statement] = STATE(68),
    [sym_function_definition] = STATE(68),
    [sym_list_splat] = STATE(1360),
    [sym_dictionary_splat] = STATE(1360),
    [sym_global_statement] = STATE(1319),
    [sym_nonlocal_statement] = STATE(1319),
    [sym_exec_statement] = STATE(1319),
    [sym_type_alias_statement] = STATE(1319),
    [sym_class_definition] = STATE(68),
    [sym_decorated_definition] = STATE(68),
    [sym_decorator] = STATE(996),
    [sym_block] = STATE(513),
    [sym_expression_list] = STATE(1361),
    [sym_pattern] = STATE(889),
    [sym_tuple_pattern] = STATE(875),
    [sym_list_pattern] = STATE(875),
    [sym_list_splat_pattern] = STATE(875),
    [sym_expression] = STATE(1019),
    [sym_primary_expression] = STATE(684),
    [sym_not_operator] = STATE(1009),
    [sym_boolean_operator] = STATE(1009),
    [sym_binary_operator] = STATE(797),
    [sym_unary_operator] = STATE(797),
    [sym_comparison_operator] = STATE(1009),
    [sym_lambda] = STATE(1009),
    [sym_assignment] = STATE(1361),
    [sym_augmented_assignment] = STATE(1361),
    [sym_pattern_list] = STATE(897),
    [sym_yield] = STATE(1361),
    [sym_attribute] = STATE(431),
    [sym_subscript] = STATE(431),
    [sym_call] = STATE(797),
    [sym_list] = STATE(797),
    [sym_set] = STATE(797),
    [sym_tuple] = STATE(797),
    [sym_dictionary] = STATE(797),
    [sym_list_comprehension] = STATE(797),
    [sym_dictionary_comprehension] = STATE(797),
    [sym_set_comprehension] = STATE(797),
    [sym_generator_expression] = STATE(797),
    [sym_parenthesized_expression] = STATE(797),
    [sym_conditional_expression] = STATE(1009),
    [sym_concatenated_string] = STATE(797),
    [sym_string] = STATE(713),
    [sym_await] = STATE(1009),
    [aux_sym_module_repeat1] = STATE(68),
    [aux_sym_decorated_definition_repeat1] = STATE(996),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_STAR] = ACTIONS(15),
    [anon_sym_print] = ACTIONS(17),
    [anon_sym_assert] = ACTIONS(19),
    [anon_sym_return] = ACTIONS(21),
    [anon_sym_del] = ACTIONS(23),
    [anon_sym_raise] = ACTIONS(25),
    [anon_sym_pass] = ACTIONS(27),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_async] = ACTIONS(85),
    [anon_sym_for] = ACTIONS(87),
    [anon_sym_while] = ACTIONS(89),
    [anon_sym_try] = ACTIONS(91),
    [anon_sym_with] = ACTIONS(93),
    [anon_sym_match] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(47),
    [anon_sym_PLUS] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(51),
    [anon_sym_STAR_STAR] = ACTIONS(53),
    [anon_sym_def] = ACTIONS(97),
    [anon_sym_global] = ACTIONS(57),
    [anon_sym_nonlocal] = ACTIONS(59),
    [anon_sym_exec] = ACTIONS(61),
    [anon_sym_type] = ACTIONS(63),
    [anon_sym_class] = ACTIONS(99),
    [anon_sym_AT] = ACTIONS(67),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(103),
    [sym__string_start] = ACTIONS(81),
  },
  [44] = {
    [sym__statement] = STATE(61),
    [sym__simple_statements] = STATE(61),
    [sym_import_statement] = STATE(1319),
    [sym_future_import_statement] = STATE(1319),
    [sym_import_from_statement] = STATE(1319),
    [sym_print_statement] = STATE(1319),
    [sym_assert_statement] = STATE(1319),
    [sym_expression_statement] = STATE(1319),
    [sym_named_expression] = STATE(1009),
    [sym_return_statement] = STATE(1319),
    [sym_delete_statement] = STATE(1319),
    [sym_raise_statement] = STATE(1319),
    [sym_pass_statement] = STATE(1319),
    [sym_break_statement] = STATE(1319),
    [sym_continue_statement] = STATE(1319),
    [sym_if_statement] = STATE(61),
    [sym_for_statement] = STATE(61),
    [sym_while_statement] = STATE(61),
    [sym_try_statement] = STATE(61),
    [sym_with_statement] = STATE(61),
    [sym_match_statement] = STATE(61),
    [sym_function_definition] = STATE(61),
    [sym_list_splat] = STATE(1360),
    [sym_dictionary_splat] = STATE(1360),
    [sym_global_statement] = STATE(1319),
    [sym_nonlocal_statement] = STATE(1319),
    [sym_exec_statement] = STATE(1319),
    [sym_type_alias_statement] = STATE(1319),
    [sym_class_definition] = STATE(61),
    [sym_decorated_definition] = STATE(61),
    [sym_decorator] = STATE(996),
    [sym_block] = STATE(533),
    [sym_expression_list] = STATE(1361),
    [sym_pattern] = STATE(889),
    [sym_tuple_pattern] = STATE(875),
    [sym_list_pattern] = STATE(875),
    [sym_list_splat_pattern] = STATE(875),
    [sym_expression] = STATE(1019),
    [sym_primary_expression] = STATE(684),
    [sym_not_operator] = STATE(1009),
    [sym_boolean_operator] = STATE(1009),
    [sym_binary_operator] = STATE(797),
    [sym_unary_operator] = STATE(797),
    [sym_comparison_operator] = STATE(1009),
    [sym_lambda] = STATE(1009),
    [sym_assignment] = STATE(1361),
    [sym_augmented_assignment] = STATE(1361),
    [sym_pattern_list] = STATE(897),
    [sym_yield] = STATE(1361),
    [sym_attribute] = STATE(431),
    [sym_subscript] = STATE(431),
    [sym_call] = STATE(797),
    [sym_list] = STATE(797),
    [sym_set] = STATE(797),
    [sym_tuple] = STATE(797),
    [sym_dictionary] = STATE(797),
    [sym_list_comprehension] = STATE(797),
    [sym_dictionary_comprehension] = STATE(797),
    [sym_set_comprehension] = STATE(797),
    [sym_generator_expression] = STATE(797),
    [sym_parenthesized_expression] = STATE(797),
    [sym_conditional_expression] = STATE(1009),
    [sym_concatenated_string] = STATE(797),
    [sym_string] = STATE(713),
    [sym_await] = STATE(1009),
    [aux_sym_module_repeat1] = STATE(61),
    [aux_sym_decorated_definition_repeat1] = STATE(996),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_STAR] = ACTIONS(15),
    [anon_sym_print] = ACTIONS(17),
    [anon_sym_assert] = ACTIONS(19),
    [anon_sym_return] = ACTIONS(21),
    [anon_sym_del] = ACTIONS(23),
    [anon_sym_raise] = ACTIONS(25),
    [anon_sym_pass] = ACTIONS(27),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_async] = ACTIONS(85),
    [anon_sym_for] = ACTIONS(87),
    [anon_sym_while] = ACTIONS(89),
    [anon_sym_try] = ACTIONS(91),
    [anon_sym_with] = ACTIONS(93),
    [anon_sym_match] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(47),
    [anon_sym_PLUS] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(51),
    [anon_sym_STAR_STAR] = ACTIONS(53),
    [anon_sym_def] = ACTIONS(97),
    [anon_sym_global] = ACTIONS(57),
    [anon_sym_nonlocal] = ACTIONS(59),
    [anon_sym_exec] = ACTIONS(61),
    [anon_sym_type] = ACTIONS(63),
    [anon_sym_class] = ACTIONS(99),
    [anon_sym_AT] = ACTIONS(67),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(107),
    [sym__string_start] = ACTIONS(81),
  },
  [45] = {
    [sym__statement] = STATE(61),
    [sym__simple_statements] = STATE(61),
    [sym_import_statement] = STATE(1319),
    [sym_future_import_statement] = STATE(1319),
    [sym_import_from_statement] = STATE(1319),
    [sym_print_statement] = STATE(1319),
    [sym_assert_statement] = STATE(1319),
    [sym_expression_statement] = STATE(1319),
    [sym_named_expression] = STATE(1009),
    [sym_return_statement] = STATE(1319),
    [sym_delete_statement] = STATE(1319),
    [sym_raise_statement] = STATE(1319),
    [sym_pass_statement] = STATE(1319),
    [sym_break_statement] = STATE(1319),
    [sym_continue_statement] = STATE(1319),
    [sym_if_statement] = STATE(61),
    [sym_for_statement] = STATE(61),
    [sym_while_statement] = STATE(61),
    [sym_try_statement] = STATE(61),
    [sym_with_statement] = STATE(61),
    [sym_match_statement] = STATE(61),
    [sym_function_definition] = STATE(61),
    [sym_list_splat] = STATE(1360),
    [sym_dictionary_splat] = STATE(1360),
    [sym_global_statement] = STATE(1319),
    [sym_nonlocal_statement] = STATE(1319),
    [sym_exec_statement] = STATE(1319),
    [sym_type_alias_statement] = STATE(1319),
    [sym_class_definition] = STATE(61),
    [sym_decorated_definition] = STATE(61),
    [sym_decorator] = STATE(996),
    [sym_block] = STATE(573),
    [sym_expression_list] = STATE(1361),
    [sym_pattern] = STATE(889),
    [sym_tuple_pattern] = STATE(875),
    [sym_list_pattern] = STATE(875),
    [sym_list_splat_pattern] = STATE(875),
    [sym_expression] = STATE(1019),
    [sym_primary_expression] = STATE(684),
    [sym_not_operator] = STATE(1009),
    [sym_boolean_operator] = STATE(1009),
    [sym_binary_operator] = STATE(797),
    [sym_unary_operator] = STATE(797),
    [sym_comparison_operator] = STATE(1009),
    [sym_lambda] = STATE(1009),
    [sym_assignment] = STATE(1361),
    [sym_augmented_assignment] = STATE(1361),
    [sym_pattern_list] = STATE(897),
    [sym_yield] = STATE(1361),
    [sym_attribute] = STATE(431),
    [sym_subscript] = STATE(431),
    [sym_call] = STATE(797),
    [sym_list] = STATE(797),
    [sym_set] = STATE(797),
    [sym_tuple] = STATE(797),
    [sym_dictionary] = STATE(797),
    [sym_list_comprehension] = STATE(797),
    [sym_dictionary_comprehension] = STATE(797),
    [sym_set_comprehension] = STATE(797),
    [sym_generator_expression] = STATE(797),
    [sym_parenthesized_expression] = STATE(797),
    [sym_conditional_expression] = STATE(1009),
    [sym_concatenated_string] = STATE(797),
    [sym_string] = STATE(713),
    [sym_await] = STATE(1009),
    [aux_sym_module_repeat1] = STATE(61),
    [aux_sym_decorated_definition_repeat1] = STATE(996),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_STAR] = ACTIONS(15),
    [anon_sym_print] = ACTIONS(17),
    [anon_sym_assert] = ACTIONS(19),
    [anon_sym_return] = ACTIONS(21),
    [anon_sym_del] = ACTIONS(23),
    [anon_sym_raise] = ACTIONS(25),
    [anon_sym_pass] = ACTIONS(27),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_async] = ACTIONS(85),
    [anon_sym_for] = ACTIONS(87),
    [anon_sym_while] = ACTIONS(89),
    [anon_sym_try] = ACTIONS(91),
    [anon_sym_with] = ACTIONS(93),
    [anon_sym_match] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(47),
    [anon_sym_PLUS] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(51),
    [anon_sym_STAR_STAR] = ACTIONS(53),
    [anon_sym_def] = ACTIONS(97),
    [anon_sym_global] = ACTIONS(57),
    [anon_sym_nonlocal] = ACTIONS(59),
    [anon_sym_exec] = ACTIONS(61),
    [anon_sym_type] = ACTIONS(63),
    [anon_sym_class] = ACTIONS(99),
    [anon_sym_AT] = ACTIONS(67),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(107),
    [sym__string_start] = ACTIONS(81),
  },
  [46] = {
    [sym__statement] = STATE(61),
    [sym__simple_statements] = STATE(61),
    [sym_import_statement] = STATE(1319),
    [sym_future_import_statement] = STATE(1319),
    [sym_import_from_statement] = STATE(1319),
    [sym_print_statement] = STATE(1319),
    [sym_assert_statement] = STATE(1319),
    [sym_expression_statement] = STATE(1319),
    [sym_named_expression] = STATE(1009),
    [sym_return_statement] = STATE(1319),
    [sym_delete_statement] = STATE(1319),
    [sym_raise_statement] = STATE(1319),
    [sym_pass_statement] = STATE(1319),
    [sym_break_statement] = STATE(1319),
    [sym_continue_statement] = STATE(1319),
    [sym_if_statement] = STATE(61),
    [sym_for_statement] = STATE(61),
    [sym_while_statement] = STATE(61),
    [sym_try_statement] = STATE(61),
    [sym_with_statement] = STATE(61),
    [sym_match_statement] = STATE(61),
    [sym_function_definition] = STATE(61),
    [sym_list_splat] = STATE(1360),
    [sym_dictionary_splat] = STATE(1360),
    [sym_global_statement] = STATE(1319),
    [sym_nonlocal_statement] = STATE(1319),
    [sym_exec_statement] = STATE(1319),
    [sym_type_alias_statement] = STATE(1319),
    [sym_class_definition] = STATE(61),
    [sym_decorated_definition] = STATE(61),
    [sym_decorator] = STATE(996),
    [sym_block] = STATE(427),
    [sym_expression_list] = STATE(1361),
    [sym_pattern] = STATE(889),
    [sym_tuple_pattern] = STATE(875),
    [sym_list_pattern] = STATE(875),
    [sym_list_splat_pattern] = STATE(875),
    [sym_expression] = STATE(1019),
    [sym_primary_expression] = STATE(684),
    [sym_not_operator] = STATE(1009),
    [sym_boolean_operator] = STATE(1009),
    [sym_binary_operator] = STATE(797),
    [sym_unary_operator] = STATE(797),
    [sym_comparison_operator] = STATE(1009),
    [sym_lambda] = STATE(1009),
    [sym_assignment] = STATE(1361),
    [sym_augmented_assignment] = STATE(1361),
    [sym_pattern_list] = STATE(897),
    [sym_yield] = STATE(1361),
    [sym_attribute] = STATE(431),
    [sym_subscript] = STATE(431),
    [sym_call] = STATE(797),
    [sym_list] = STATE(797),
    [sym_set] = STATE(797),
    [sym_tuple] = STATE(797),
    [sym_dictionary] = STATE(797),
    [sym_list_comprehension] = STATE(797),
    [sym_dictionary_comprehension] = STATE(797),
    [sym_set_comprehension] = STATE(797),
    [sym_generator_expression] = STATE(797),
    [sym_parenthesized_expression] = STATE(797),
    [sym_conditional_expression] = STATE(1009),
    [sym_concatenated_string] = STATE(797),
    [sym_string] = STATE(713),
    [sym_await] = STATE(1009),
    [aux_sym_module_repeat1] = STATE(61),
    [aux_sym_decorated_definition_repeat1] = STATE(996),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_STAR] = ACTIONS(15),
    [anon_sym_print] = ACTIONS(17),
    [anon_sym_assert] = ACTIONS(19),
    [anon_sym_return] = ACTIONS(21),
    [anon_sym_del] = ACTIONS(23),
    [anon_sym_raise] = ACTIONS(25),
    [anon_sym_pass] = ACTIONS(27),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_async] = ACTIONS(85),
    [anon_sym_for] = ACTIONS(87),
    [anon_sym_while] = ACTIONS(89),
    [anon_sym_try] = ACTIONS(91),
    [anon_sym_with] = ACTIONS(93),
    [anon_sym_match] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(47),
    [anon_sym_PLUS] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(51),
    [anon_sym_STAR_STAR] = ACTIONS(53),
    [anon_sym_def] = ACTIONS(97),
    [anon_sym_global] = ACTIONS(57),
    [anon_sym_nonlocal] = ACTIONS(59),
    [anon_sym_exec] = ACTIONS(61),
    [anon_sym_type] = ACTIONS(63),
    [anon_sym_class] = ACTIONS(99),
    [anon_sym_AT] = ACTIONS(67),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(107),
    [sym__string_start] = ACTIONS(81),
  },
  [47] = {
    [sym__statement] = STATE(61),
    [sym__simple_statements] = STATE(61),
    [sym_import_statement] = STATE(1319),
    [sym_future_import_statement] = STATE(1319),
    [sym_import_from_statement] = STATE(1319),
    [sym_print_statement] = STATE(1319),
    [sym_assert_statement] = STATE(1319),
    [sym_expression_statement] = STATE(1319),
    [sym_named_expression] = STATE(1009),
    [sym_return_statement] = STATE(1319),
    [sym_delete_statement] = STATE(1319),
    [sym_raise_statement] = STATE(1319),
    [sym_pass_statement] = STATE(1319),
    [sym_break_statement] = STATE(1319),
    [sym_continue_statement] = STATE(1319),
    [sym_if_statement] = STATE(61),
    [sym_for_statement] = STATE(61),
    [sym_while_statement] = STATE(61),
    [sym_try_statement] = STATE(61),
    [sym_with_statement] = STATE(61),
    [sym_match_statement] = STATE(61),
    [sym_function_definition] = STATE(61),
    [sym_list_splat] = STATE(1360),
    [sym_dictionary_splat] = STATE(1360),
    [sym_global_statement] = STATE(1319),
    [sym_nonlocal_statement] = STATE(1319),
    [sym_exec_statement] = STATE(1319),
    [sym_type_alias_statement] = STATE(1319),
    [sym_class_definition] = STATE(61),
    [sym_decorated_definition] = STATE(61),
    [sym_decorator] = STATE(996),
    [sym_block] = STATE(387),
    [sym_expression_list] = STATE(1361),
    [sym_pattern] = STATE(889),
    [sym_tuple_pattern] = STATE(875),
    [sym_list_pattern] = STATE(875),
    [sym_list_splat_pattern] = STATE(875),
    [sym_expression] = STATE(1019),
    [sym_primary_expression] = STATE(684),
    [sym_not_operator] = STATE(1009),
    [sym_boolean_operator] = STATE(1009),
    [sym_binary_operator] = STATE(797),
    [sym_unary_operator] = STATE(797),
    [sym_comparison_operator] = STATE(1009),
    [sym_lambda] = STATE(1009),
    [sym_assignment] = STATE(1361),
    [sym_augmented_assignment] = STATE(1361),
    [sym_pattern_list] = STATE(897),
    [sym_yield] = STATE(1361),
    [sym_attribute] = STATE(431),
    [sym_subscript] = STATE(431),
    [sym_call] = STATE(797),
    [sym_list] = STATE(797),
    [sym_set] = STATE(797),
    [sym_tuple] = STATE(797),
    [sym_dictionary] = STATE(797),
    [sym_list_comprehension] = STATE(797),
    [sym_dictionary_comprehension] = STATE(797),
    [sym_set_comprehension] = STATE(797),
    [sym_generator_expression] = STATE(797),
    [sym_parenthesized_expression] = STATE(797),
    [sym_conditional_expression] = STATE(1009),
    [sym_concatenated_string] = STATE(797),
    [sym_string] = STATE(713),
    [sym_await] = STATE(1009),
    [aux_sym_module_repeat1] = STATE(61),
    [aux_sym_decorated_definition_repeat1] = STATE(996),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_STAR] = ACTIONS(15),
    [anon_sym_print] = ACTIONS(17),
    [anon_sym_assert] = ACTIONS(19),
    [anon_sym_return] = ACTIONS(21),
    [anon_sym_del] = ACTIONS(23),
    [anon_sym_raise] = ACTIONS(25),
    [anon_sym_pass] = ACTIONS(27),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_async] = ACTIONS(85),
    [anon_sym_for] = ACTIONS(87),
    [anon_sym_while] = ACTIONS(89),
    [anon_sym_try] = ACTIONS(91),
    [anon_sym_with] = ACTIONS(93),
    [anon_sym_match] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(47),
    [anon_sym_PLUS] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(51),
    [anon_sym_STAR_STAR] = ACTIONS(53),
    [anon_sym_def] = ACTIONS(97),
    [anon_sym_global] = ACTIONS(57),
    [anon_sym_nonlocal] = ACTIONS(59),
    [anon_sym_exec] = ACTIONS(61),
    [anon_sym_type] = ACTIONS(63),
    [anon_sym_class] = ACTIONS(99),
    [anon_sym_AT] = ACTIONS(67),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(107),
    [sym__string_start] = ACTIONS(81),
  },
  [48] = {
    [sym__statement] = STATE(61),
    [sym__simple_statements] = STATE(61),
    [sym_import_statement] = STATE(1319),
    [sym_future_import_statement] = STATE(1319),
    [sym_import_from_statement] = STATE(1319),
    [sym_print_statement] = STATE(1319),
    [sym_assert_statement] = STATE(1319),
    [sym_expression_statement] = STATE(1319),
    [sym_named_expression] = STATE(1009),
    [sym_return_statement] = STATE(1319),
    [sym_delete_statement] = STATE(1319),
    [sym_raise_statement] = STATE(1319),
    [sym_pass_statement] = STATE(1319),
    [sym_break_statement] = STATE(1319),
    [sym_continue_statement] = STATE(1319),
    [sym_if_statement] = STATE(61),
    [sym_for_statement] = STATE(61),
    [sym_while_statement] = STATE(61),
    [sym_try_statement] = STATE(61),
    [sym_with_statement] = STATE(61),
    [sym_match_statement] = STATE(61),
    [sym_function_definition] = STATE(61),
    [sym_list_splat] = STATE(1360),
    [sym_dictionary_splat] = STATE(1360),
    [sym_global_statement] = STATE(1319),
    [sym_nonlocal_statement] = STATE(1319),
    [sym_exec_statement] = STATE(1319),
    [sym_type_alias_statement] = STATE(1319),
    [sym_class_definition] = STATE(61),
    [sym_decorated_definition] = STATE(61),
    [sym_decorator] = STATE(996),
    [sym_block] = STATE(496),
    [sym_expression_list] = STATE(1361),
    [sym_pattern] = STATE(889),
    [sym_tuple_pattern] = STATE(875),
    [sym_list_pattern] = STATE(875),
    [sym_list_splat_pattern] = STATE(875),
    [sym_expression] = STATE(1019),
    [sym_primary_expression] = STATE(684),
    [sym_not_operator] = STATE(1009),
    [sym_boolean_operator] = STATE(1009),
    [sym_binary_operator] = STATE(797),
    [sym_unary_operator] = STATE(797),
    [sym_comparison_operator] = STATE(1009),
    [sym_lambda] = STATE(1009),
    [sym_assignment] = STATE(1361),
    [sym_augmented_assignment] = STATE(1361),
    [sym_pattern_list] = STATE(897),
    [sym_yield] = STATE(1361),
    [sym_attribute] = STATE(431),
    [sym_subscript] = STATE(431),
    [sym_call] = STATE(797),
    [sym_list] = STATE(797),
    [sym_set] = STATE(797),
    [sym_tuple] = STATE(797),
    [sym_dictionary] = STATE(797),
    [sym_list_comprehension] = STATE(797),
    [sym_dictionary_comprehension] = STATE(797),
    [sym_set_comprehension] = STATE(797),
    [sym_generator_expression] = STATE(797),
    [sym_parenthesized_expression] = STATE(797),
    [sym_conditional_expression] = STATE(1009),
    [sym_concatenated_string] = STATE(797),
    [sym_string] = STATE(713),
    [sym_await] = STATE(1009),
    [aux_sym_module_repeat1] = STATE(61),
    [aux_sym_decorated_definition_repeat1] = STATE(996),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_STAR] = ACTIONS(15),
    [anon_sym_print] = ACTIONS(17),
    [anon_sym_assert] = ACTIONS(19),
    [anon_sym_return] = ACTIONS(21),
    [anon_sym_del] = ACTIONS(23),
    [anon_sym_raise] = ACTIONS(25),
    [anon_sym_pass] = ACTIONS(27),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_async] = ACTIONS(85),
    [anon_sym_for] = ACTIONS(87),
    [anon_sym_while] = ACTIONS(89),
    [anon_sym_try] = ACTIONS(91),
    [anon_sym_with] = ACTIONS(93),
    [anon_sym_match] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(47),
    [anon_sym_PLUS] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(51),
    [anon_sym_STAR_STAR] = ACTIONS(53),
    [anon_sym_def] = ACTIONS(97),
    [anon_sym_global] = ACTIONS(57),
    [anon_sym_nonlocal] = ACTIONS(59),
    [anon_sym_exec] = ACTIONS(61),
    [anon_sym_type] = ACTIONS(63),
    [anon_sym_class] = ACTIONS(99),
    [anon_sym_AT] = ACTIONS(67),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(107),
    [sym__string_start] = ACTIONS(81),
  },
  [49] = {
    [sym__statement] = STATE(61),
    [sym__simple_statements] = STATE(61),
    [sym_import_statement] = STATE(1319),
    [sym_future_import_statement] = STATE(1319),
    [sym_import_from_statement] = STATE(1319),
    [sym_print_statement] = STATE(1319),
    [sym_assert_statement] = STATE(1319),
    [sym_expression_statement] = STATE(1319),
    [sym_named_expression] = STATE(1009),
    [sym_return_statement] = STATE(1319),
    [sym_delete_statement] = STATE(1319),
    [sym_raise_statement] = STATE(1319),
    [sym_pass_statement] = STATE(1319),
    [sym_break_statement] = STATE(1319),
    [sym_continue_statement] = STATE(1319),
    [sym_if_statement] = STATE(61),
    [sym_for_statement] = STATE(61),
    [sym_while_statement] = STATE(61),
    [sym_try_statement] = STATE(61),
    [sym_with_statement] = STATE(61),
    [sym_match_statement] = STATE(61),
    [sym_function_definition] = STATE(61),
    [sym_list_splat] = STATE(1360),
    [sym_dictionary_splat] = STATE(1360),
    [sym_global_statement] = STATE(1319),
    [sym_nonlocal_statement] = STATE(1319),
    [sym_exec_statement] = STATE(1319),
    [sym_type_alias_statement] = STATE(1319),
    [sym_class_definition] = STATE(61),
    [sym_decorated_definition] = STATE(61),
    [sym_decorator] = STATE(996),
    [sym_block] = STATE(566),
    [sym_expression_list] = STATE(1361),
    [sym_pattern] = STATE(889),
    [sym_tuple_pattern] = STATE(875),
    [sym_list_pattern] = STATE(875),
    [sym_list_splat_pattern] = STATE(875),
    [sym_expression] = STATE(1019),
    [sym_primary_expression] = STATE(684),
    [sym_not_operator] = STATE(1009),
    [sym_boolean_operator] = STATE(1009),
    [sym_binary_operator] = STATE(797),
    [sym_unary_operator] = STATE(797),
    [sym_comparison_operator] = STATE(1009),
    [sym_lambda] = STATE(1009),
    [sym_assignment] = STATE(1361),
    [sym_augmented_assignment] = STATE(1361),
    [sym_pattern_list] = STATE(897),
    [sym_yield] = STATE(1361),
    [sym_attribute] = STATE(431),
    [sym_subscript] = STATE(431),
    [sym_call] = STATE(797),
    [sym_list] = STATE(797),
    [sym_set] = STATE(797),
    [sym_tuple] = STATE(797),
    [sym_dictionary] = STATE(797),
    [sym_list_comprehension] = STATE(797),
    [sym_dictionary_comprehension] = STATE(797),
    [sym_set_comprehension] = STATE(797),
    [sym_generator_expression] = STATE(797),
    [sym_parenthesized_expression] = STATE(797),
    [sym_conditional_expression] = STATE(1009),
    [sym_concatenated_string] = STATE(797),
    [sym_string] = STATE(713),
    [sym_await] = STATE(1009),
    [aux_sym_module_repeat1] = STATE(61),
    [aux_sym_decorated_definition_repeat1] = STATE(996),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_STAR] = ACTIONS(15),
    [anon_sym_print] = ACTIONS(17),
    [anon_sym_assert] = ACTIONS(19),
    [anon_sym_return] = ACTIONS(21),
    [anon_sym_del] = ACTIONS(23),
    [anon_sym_raise] = ACTIONS(25),
    [anon_sym_pass] = ACTIONS(27),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_async] = ACTIONS(85),
    [anon_sym_for] = ACTIONS(87),
    [anon_sym_while] = ACTIONS(89),
    [anon_sym_try] = ACTIONS(91),
    [anon_sym_with] = ACTIONS(93),
    [anon_sym_match] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(47),
    [anon_sym_PLUS] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(51),
    [anon_sym_STAR_STAR] = ACTIONS(53),
    [anon_sym_def] = ACTIONS(97),
    [anon_sym_global] = ACTIONS(57),
    [anon_sym_nonlocal] = ACTIONS(59),
    [anon_sym_exec] = ACTIONS(61),
    [anon_sym_type] = ACTIONS(63),
    [anon_sym_class] = ACTIONS(99),
    [anon_sym_AT] = ACTIONS(67),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(107),
    [sym__string_start] = ACTIONS(81),
  },
  [50] = {
    [sym__statement] = STATE(60),
    [sym__simple_statements] = STATE(60),
    [sym_import_statement] = STATE(1319),
    [sym_future_import_statement] = STATE(1319),
    [sym_import_from_statement] = STATE(1319),
    [sym_print_statement] = STATE(1319),
    [sym_assert_statement] = STATE(1319),
    [sym_expression_statement] = STATE(1319),
    [sym_named_expression] = STATE(1009),
    [sym_return_statement] = STATE(1319),
    [sym_delete_statement] = STATE(1319),
    [sym_raise_statement] = STATE(1319),
    [sym_pass_statement] = STATE(1319),
    [sym_break_statement] = STATE(1319),
    [sym_continue_statement] = STATE(1319),
    [sym_if_statement] = STATE(60),
    [sym_for_statement] = STATE(60),
    [sym_while_statement] = STATE(60),
    [sym_try_statement] = STATE(60),
    [sym_with_statement] = STATE(60),
    [sym_match_statement] = STATE(60),
    [sym_function_definition] = STATE(60),
    [sym_list_splat] = STATE(1360),
    [sym_dictionary_splat] = STATE(1360),
    [sym_global_statement] = STATE(1319),
    [sym_nonlocal_statement] = STATE(1319),
    [sym_exec_statement] = STATE(1319),
    [sym_type_alias_statement] = STATE(1319),
    [sym_class_definition] = STATE(60),
    [sym_decorated_definition] = STATE(60),
    [sym_decorator] = STATE(996),
    [sym_block] = STATE(333),
    [sym_expression_list] = STATE(1361),
    [sym_pattern] = STATE(889),
    [sym_tuple_pattern] = STATE(875),
    [sym_list_pattern] = STATE(875),
    [sym_list_splat_pattern] = STATE(875),
    [sym_expression] = STATE(1019),
    [sym_primary_expression] = STATE(684),
    [sym_not_operator] = STATE(1009),
    [sym_boolean_operator] = STATE(1009),
    [sym_binary_operator] = STATE(797),
    [sym_unary_operator] = STATE(797),
    [sym_comparison_operator] = STATE(1009),
    [sym_lambda] = STATE(1009),
    [sym_assignment] = STATE(1361),
    [sym_augmented_assignment] = STATE(1361),
    [sym_pattern_list] = STATE(897),
    [sym_yield] = STATE(1361),
    [sym_attribute] = STATE(431),
    [sym_subscript] = STATE(431),
    [sym_call] = STATE(797),
    [sym_list] = STATE(797),
    [sym_set] = STATE(797),
    [sym_tuple] = STATE(797),
    [sym_dictionary] = STATE(797),
    [sym_list_comprehension] = STATE(797),
    [sym_dictionary_comprehension] = STATE(797),
    [sym_set_comprehension] = STATE(797),
    [sym_generator_expression] = STATE(797),
    [sym_parenthesized_expression] = STATE(797),
    [sym_conditional_expression] = STATE(1009),
    [sym_concatenated_string] = STATE(797),
    [sym_string] = STATE(713),
    [sym_await] = STATE(1009),
    [aux_sym_module_repeat1] = STATE(60),
    [aux_sym_decorated_definition_repeat1] = STATE(996),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_STAR] = ACTIONS(15),
    [anon_sym_print] = ACTIONS(17),
    [anon_sym_assert] = ACTIONS(19),
    [anon_sym_return] = ACTIONS(21),
    [anon_sym_del] = ACTIONS(23),
    [anon_sym_raise] = ACTIONS(25),
    [anon_sym_pass] = ACTIONS(27),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_async] = ACTIONS(85),
    [anon_sym_for] = ACTIONS(87),
    [anon_sym_while] = ACTIONS(89),
    [anon_sym_try] = ACTIONS(91),
    [anon_sym_with] = ACTIONS(93),
    [anon_sym_match] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(47),
    [anon_sym_PLUS] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(51),
    [anon_sym_STAR_STAR] = ACTIONS(53),
    [anon_sym_def] = ACTIONS(97),
    [anon_sym_global] = ACTIONS(57),
    [anon_sym_nonlocal] = ACTIONS(59),
    [anon_sym_exec] = ACTIONS(61),
    [anon_sym_type] = ACTIONS(63),
    [anon_sym_class] = ACTIONS(99),
    [anon_sym_AT] = ACTIONS(67),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(109),
    [sym__string_start] = ACTIONS(81),
  },
  [51] = {
    [sym__statement] = STATE(61),
    [sym__simple_statements] = STATE(61),
    [sym_import_statement] = STATE(1319),
    [sym_future_import_statement] = STATE(1319),
    [sym_import_from_statement] = STATE(1319),
    [sym_print_statement] = STATE(1319),
    [sym_assert_statement] = STATE(1319),
    [sym_expression_statement] = STATE(1319),
    [sym_named_expression] = STATE(1009),
    [sym_return_statement] = STATE(1319),
    [sym_delete_statement] = STATE(1319),
    [sym_raise_statement] = STATE(1319),
    [sym_pass_statement] = STATE(1319),
    [sym_break_statement] = STATE(1319),
    [sym_continue_statement] = STATE(1319),
    [sym_if_statement] = STATE(61),
    [sym_for_statement] = STATE(61),
    [sym_while_statement] = STATE(61),
    [sym_try_statement] = STATE(61),
    [sym_with_statement] = STATE(61),
    [sym_match_statement] = STATE(61),
    [sym_function_definition] = STATE(61),
    [sym_list_splat] = STATE(1360),
    [sym_dictionary_splat] = STATE(1360),
    [sym_global_statement] = STATE(1319),
    [sym_nonlocal_statement] = STATE(1319),
    [sym_exec_statement] = STATE(1319),
    [sym_type_alias_statement] = STATE(1319),
    [sym_class_definition] = STATE(61),
    [sym_decorated_definition] = STATE(61),
    [sym_decorator] = STATE(996),
    [sym_block] = STATE(407),
    [sym_expression_list] = STATE(1361),
    [sym_pattern] = STATE(889),
    [sym_tuple_pattern] = STATE(875),
    [sym_list_pattern] = STATE(875),
    [sym_list_splat_pattern] = STATE(875),
    [sym_expression] = STATE(1019),
    [sym_primary_expression] = STATE(684),
    [sym_not_operator] = STATE(1009),
    [sym_boolean_operator] = STATE(1009),
    [sym_binary_operator] = STATE(797),
    [sym_unary_operator] = STATE(797),
    [sym_comparison_operator] = STATE(1009),
    [sym_lambda] = STATE(1009),
    [sym_assignment] = STATE(1361),
    [sym_augmented_assignment] = STATE(1361),
    [sym_pattern_list] = STATE(897),
    [sym_yield] = STATE(1361),
    [sym_attribute] = STATE(431),
    [sym_subscript] = STATE(431),
    [sym_call] = STATE(797),
    [sym_list] = STATE(797),
    [sym_set] = STATE(797),
    [sym_tuple] = STATE(797),
    [sym_dictionary] = STATE(797),
    [sym_list_comprehension] = STATE(797),
    [sym_dictionary_comprehension] = STATE(797),
    [sym_set_comprehension] = STATE(797),
    [sym_generator_expression] = STATE(797),
    [sym_parenthesized_expression] = STATE(797),
    [sym_conditional_expression] = STATE(1009),
    [sym_concatenated_string] = STATE(797),
    [sym_string] = STATE(713),
    [sym_await] = STATE(1009),
    [aux_sym_module_repeat1] = STATE(61),
    [aux_sym_decorated_definition_repeat1] = STATE(996),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_STAR] = ACTIONS(15),
    [anon_sym_print] = ACTIONS(17),
    [anon_sym_assert] = ACTIONS(19),
    [anon_sym_return] = ACTIONS(21),
    [anon_sym_del] = ACTIONS(23),
    [anon_sym_raise] = ACTIONS(25),
    [anon_sym_pass] = ACTIONS(27),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_async] = ACTIONS(85),
    [anon_sym_for] = ACTIONS(87),
    [anon_sym_while] = ACTIONS(89),
    [anon_sym_try] = ACTIONS(91),
    [anon_sym_with] = ACTIONS(93),
    [anon_sym_match] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(47),
    [anon_sym_PLUS] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(51),
    [anon_sym_STAR_STAR] = ACTIONS(53),
    [anon_sym_def] = ACTIONS(97),
    [anon_sym_global] = ACTIONS(57),
    [anon_sym_nonlocal] = ACTIONS(59),
    [anon_sym_exec] = ACTIONS(61),
    [anon_sym_type] = ACTIONS(63),
    [anon_sym_class] = ACTIONS(99),
    [anon_sym_AT] = ACTIONS(67),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(107),
    [sym__string_start] = ACTIONS(81),
  },
  [52] = {
    [sym__statement] = STATE(68),
    [sym__simple_statements] = STATE(68),
    [sym_import_statement] = STATE(1319),
    [sym_future_import_statement] = STATE(1319),
    [sym_import_from_statement] = STATE(1319),
    [sym_print_statement] = STATE(1319),
    [sym_assert_statement] = STATE(1319),
    [sym_expression_statement] = STATE(1319),
    [sym_named_expression] = STATE(1009),
    [sym_return_statement] = STATE(1319),
    [sym_delete_statement] = STATE(1319),
    [sym_raise_statement] = STATE(1319),
    [sym_pass_statement] = STATE(1319),
    [sym_break_statement] = STATE(1319),
    [sym_continue_statement] = STATE(1319),
    [sym_if_statement] = STATE(68),
    [sym_for_statement] = STATE(68),
    [sym_while_statement] = STATE(68),
    [sym_try_statement] = STATE(68),
    [sym_with_statement] = STATE(68),
    [sym_match_statement] = STATE(68),
    [sym_function_definition] = STATE(68),
    [sym_list_splat] = STATE(1360),
    [sym_dictionary_splat] = STATE(1360),
    [sym_global_statement] = STATE(1319),
    [sym_nonlocal_statement] = STATE(1319),
    [sym_exec_statement] = STATE(1319),
    [sym_type_alias_statement] = STATE(1319),
    [sym_class_definition] = STATE(68),
    [sym_decorated_definition] = STATE(68),
    [sym_decorator] = STATE(996),
    [sym_block] = STATE(579),
    [sym_expression_list] = STATE(1361),
    [sym_pattern] = STATE(889),
    [sym_tuple_pattern] = STATE(875),
    [sym_list_pattern] = STATE(875),
    [sym_list_splat_pattern] = STATE(875),
    [sym_expression] = STATE(1019),
    [sym_primary_expression] = STATE(684),
    [sym_not_operator] = STATE(1009),
    [sym_boolean_operator] = STATE(1009),
    [sym_binary_operator] = STATE(797),
    [sym_unary_operator] = STATE(797),
    [sym_comparison_operator] = STATE(1009),
    [sym_lambda] = STATE(1009),
    [sym_assignment] = STATE(1361),
    [sym_augmented_assignment] = STATE(1361),
    [sym_pattern_list] = STATE(897),
    [sym_yield] = STATE(1361),
    [sym_attribute] = STATE(431),
    [sym_subscript] = STATE(431),
    [sym_call] = STATE(797),
    [sym_list] = STATE(797),
    [sym_set] = STATE(797),
    [sym_tuple] = STATE(797),
    [sym_dictionary] = STATE(797),
    [sym_list_comprehension] = STATE(797),
    [sym_dictionary_comprehension] = STATE(797),
    [sym_set_comprehension] = STATE(797),
    [sym_generator_expression] = STATE(797),
    [sym_parenthesized_expression] = STATE(797),
    [sym_conditional_expression] = STATE(1009),
    [sym_concatenated_string] = STATE(797),
    [sym_string] = STATE(713),
    [sym_await] = STATE(1009),
    [aux_sym_module_repeat1] = STATE(68),
    [aux_sym_decorated_definition_repeat1] = STATE(996),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_STAR] = ACTIONS(15),
    [anon_sym_print] = ACTIONS(17),
    [anon_sym_assert] = ACTIONS(19),
    [anon_sym_return] = ACTIONS(21),
    [anon_sym_del] = ACTIONS(23),
    [anon_sym_raise] = ACTIONS(25),
    [anon_sym_pass] = ACTIONS(27),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_async] = ACTIONS(85),
    [anon_sym_for] = ACTIONS(87),
    [anon_sym_while] = ACTIONS(89),
    [anon_sym_try] = ACTIONS(91),
    [anon_sym_with] = ACTIONS(93),
    [anon_sym_match] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(47),
    [anon_sym_PLUS] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(51),
    [anon_sym_STAR_STAR] = ACTIONS(53),
    [anon_sym_def] = ACTIONS(97),
    [anon_sym_global] = ACTIONS(57),
    [anon_sym_nonlocal] = ACTIONS(59),
    [anon_sym_exec] = ACTIONS(61),
    [anon_sym_type] = ACTIONS(63),
    [anon_sym_class] = ACTIONS(99),
    [anon_sym_AT] = ACTIONS(67),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(103),
    [sym__string_start] = ACTIONS(81),
  },
  [53] = {
    [sym__statement] = STATE(68),
    [sym__simple_statements] = STATE(68),
    [sym_import_statement] = STATE(1319),
    [sym_future_import_statement] = STATE(1319),
    [sym_import_from_statement] = STATE(1319),
    [sym_print_statement] = STATE(1319),
    [sym_assert_statement] = STATE(1319),
    [sym_expression_statement] = STATE(1319),
    [sym_named_expression] = STATE(1009),
    [sym_return_statement] = STATE(1319),
    [sym_delete_statement] = STATE(1319),
    [sym_raise_statement] = STATE(1319),
    [sym_pass_statement] = STATE(1319),
    [sym_break_statement] = STATE(1319),
    [sym_continue_statement] = STATE(1319),
    [sym_if_statement] = STATE(68),
    [sym_for_statement] = STATE(68),
    [sym_while_statement] = STATE(68),
    [sym_try_statement] = STATE(68),
    [sym_with_statement] = STATE(68),
    [sym_match_statement] = STATE(68),
    [sym_function_definition] = STATE(68),
    [sym_list_splat] = STATE(1360),
    [sym_dictionary_splat] = STATE(1360),
    [sym_global_statement] = STATE(1319),
    [sym_nonlocal_statement] = STATE(1319),
    [sym_exec_statement] = STATE(1319),
    [sym_type_alias_statement] = STATE(1319),
    [sym_class_definition] = STATE(68),
    [sym_decorated_definition] = STATE(68),
    [sym_decorator] = STATE(996),
    [sym_block] = STATE(581),
    [sym_expression_list] = STATE(1361),
    [sym_pattern] = STATE(889),
    [sym_tuple_pattern] = STATE(875),
    [sym_list_pattern] = STATE(875),
    [sym_list_splat_pattern] = STATE(875),
    [sym_expression] = STATE(1019),
    [sym_primary_expression] = STATE(684),
    [sym_not_operator] = STATE(1009),
    [sym_boolean_operator] = STATE(1009),
    [sym_binary_operator] = STATE(797),
    [sym_unary_operator] = STATE(797),
    [sym_comparison_operator] = STATE(1009),
    [sym_lambda] = STATE(1009),
    [sym_assignment] = STATE(1361),
    [sym_augmented_assignment] = STATE(1361),
    [sym_pattern_list] = STATE(897),
    [sym_yield] = STATE(1361),
    [sym_attribute] = STATE(431),
    [sym_subscript] = STATE(431),
    [sym_call] = STATE(797),
    [sym_list] = STATE(797),
    [sym_set] = STATE(797),
    [sym_tuple] = STATE(797),
    [sym_dictionary] = STATE(797),
    [sym_list_comprehension] = STATE(797),
    [sym_dictionary_comprehension] = STATE(797),
    [sym_set_comprehension] = STATE(797),
    [sym_generator_expression] = STATE(797),
    [sym_parenthesized_expression] = STATE(797),
    [sym_conditional_expression] = STATE(1009),
    [sym_concatenated_string] = STATE(797),
    [sym_string] = STATE(713),
    [sym_await] = STATE(1009),
    [aux_sym_module_repeat1] = STATE(68),
    [aux_sym_decorated_definition_repeat1] = STATE(996),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_STAR] = ACTIONS(15),
    [anon_sym_print] = ACTIONS(17),
    [anon_sym_assert] = ACTIONS(19),
    [anon_sym_return] = ACTIONS(21),
    [anon_sym_del] = ACTIONS(23),
    [anon_sym_raise] = ACTIONS(25),
    [anon_sym_pass] = ACTIONS(27),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_async] = ACTIONS(85),
    [anon_sym_for] = ACTIONS(87),
    [anon_sym_while] = ACTIONS(89),
    [anon_sym_try] = ACTIONS(91),
    [anon_sym_with] = ACTIONS(93),
    [anon_sym_match] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(47),
    [anon_sym_PLUS] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(51),
    [anon_sym_STAR_STAR] = ACTIONS(53),
    [anon_sym_def] = ACTIONS(97),
    [anon_sym_global] = ACTIONS(57),
    [anon_sym_nonlocal] = ACTIONS(59),
    [anon_sym_exec] = ACTIONS(61),
    [anon_sym_type] = ACTIONS(63),
    [anon_sym_class] = ACTIONS(99),
    [anon_sym_AT] = ACTIONS(67),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(103),
    [sym__string_start] = ACTIONS(81),
  },
  [54] = {
    [sym__statement] = STATE(69),
    [sym__simple_statements] = STATE(69),
    [sym_import_statement] = STATE(1319),
    [sym_future_import_statement] = STATE(1319),
    [sym_import_from_statement] = STATE(1319),
    [sym_print_statement] = STATE(1319),
    [sym_assert_statement] = STATE(1319),
    [sym_expression_statement] = STATE(1319),
    [sym_named_expression] = STATE(1009),
    [sym_return_statement] = STATE(1319),
    [sym_delete_statement] = STATE(1319),
    [sym_raise_statement] = STATE(1319),
    [sym_pass_statement] = STATE(1319),
    [sym_break_statement] = STATE(1319),
    [sym_continue_statement] = STATE(1319),
    [sym_if_statement] = STATE(69),
    [sym_for_statement] = STATE(69),
    [sym_while_statement] = STATE(69),
    [sym_try_statement] = STATE(69),
    [sym_with_statement] = STATE(69),
    [sym_match_statement] = STATE(69),
    [sym_function_definition] = STATE(69),
    [sym_list_splat] = STATE(1360),
    [sym_dictionary_splat] = STATE(1360),
    [sym_global_statement] = STATE(1319),
    [sym_nonlocal_statement] = STATE(1319),
    [sym_exec_statement] = STATE(1319),
    [sym_type_alias_statement] = STATE(1319),
    [sym_class_definition] = STATE(69),
    [sym_decorated_definition] = STATE(69),
    [sym_decorator] = STATE(996),
    [sym_block] = STATE(1003),
    [sym_expression_list] = STATE(1361),
    [sym_pattern] = STATE(889),
    [sym_tuple_pattern] = STATE(875),
    [sym_list_pattern] = STATE(875),
    [sym_list_splat_pattern] = STATE(875),
    [sym_expression] = STATE(1019),
    [sym_primary_expression] = STATE(684),
    [sym_not_operator] = STATE(1009),
    [sym_boolean_operator] = STATE(1009),
    [sym_binary_operator] = STATE(797),
    [sym_unary_operator] = STATE(797),
    [sym_comparison_operator] = STATE(1009),
    [sym_lambda] = STATE(1009),
    [sym_assignment] = STATE(1361),
    [sym_augmented_assignment] = STATE(1361),
    [sym_pattern_list] = STATE(897),
    [sym_yield] = STATE(1361),
    [sym_attribute] = STATE(431),
    [sym_subscript] = STATE(431),
    [sym_call] = STATE(797),
    [sym_list] = STATE(797),
    [sym_set] = STATE(797),
    [sym_tuple] = STATE(797),
    [sym_dictionary] = STATE(797),
    [sym_list_comprehension] = STATE(797),
    [sym_dictionary_comprehension] = STATE(797),
    [sym_set_comprehension] = STATE(797),
    [sym_generator_expression] = STATE(797),
    [sym_parenthesized_expression] = STATE(797),
    [sym_conditional_expression] = STATE(1009),
    [sym_concatenated_string] = STATE(797),
    [sym_string] = STATE(713),
    [sym_await] = STATE(1009),
    [aux_sym_module_repeat1] = STATE(69),
    [aux_sym_decorated_definition_repeat1] = STATE(996),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_STAR] = ACTIONS(15),
    [anon_sym_print] = ACTIONS(17),
    [anon_sym_assert] = ACTIONS(19),
    [anon_sym_return] = ACTIONS(21),
    [anon_sym_del] = ACTIONS(23),
    [anon_sym_raise] = ACTIONS(25),
    [anon_sym_pass] = ACTIONS(27),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_async] = ACTIONS(85),
    [anon_sym_for] = ACTIONS(87),
    [anon_sym_while] = ACTIONS(89),
    [anon_sym_try] = ACTIONS(91),
    [anon_sym_with] = ACTIONS(93),
    [anon_sym_match] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(47),
    [anon_sym_PLUS] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(51),
    [anon_sym_STAR_STAR] = ACTIONS(53),
    [anon_sym_def] = ACTIONS(97),
    [anon_sym_global] = ACTIONS(57),
    [anon_sym_nonlocal] = ACTIONS(59),
    [anon_sym_exec] = ACTIONS(61),
    [anon_sym_type] = ACTIONS(63),
    [anon_sym_class] = ACTIONS(99),
    [anon_sym_AT] = ACTIONS(67),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(113),
    [sym__string_start] = ACTIONS(81),
  },
  [55] = {
    [sym__statement] = STATE(69),
    [sym__simple_statements] = STATE(69),
    [sym_import_statement] = STATE(1319),
    [sym_future_import_statement] = STATE(1319),
    [sym_import_from_statement] = STATE(1319),
    [sym_print_statement] = STATE(1319),
    [sym_assert_statement] = STATE(1319),
    [sym_expression_statement] = STATE(1319),
    [sym_named_expression] = STATE(1009),
    [sym_return_statement] = STATE(1319),
    [sym_delete_statement] = STATE(1319),
    [sym_raise_statement] = STATE(1319),
    [sym_pass_statement] = STATE(1319),
    [sym_break_statement] = STATE(1319),
    [sym_continue_statement] = STATE(1319),
    [sym_if_statement] = STATE(69),
    [sym_for_statement] = STATE(69),
    [sym_while_statement] = STATE(69),
    [sym_try_statement] = STATE(69),
    [sym_with_statement] = STATE(69),
    [sym_match_statement] = STATE(69),
    [sym_function_definition] = STATE(69),
    [sym_list_splat] = STATE(1360),
    [sym_dictionary_splat] = STATE(1360),
    [sym_global_statement] = STATE(1319),
    [sym_nonlocal_statement] = STATE(1319),
    [sym_exec_statement] = STATE(1319),
    [sym_type_alias_statement] = STATE(1319),
    [sym_class_definition] = STATE(69),
    [sym_decorated_definition] = STATE(69),
    [sym_decorator] = STATE(996),
    [sym_block] = STATE(983),
    [sym_expression_list] = STATE(1361),
    [sym_pattern] = STATE(889),
    [sym_tuple_pattern] = STATE(875),
    [sym_list_pattern] = STATE(875),
    [sym_list_splat_pattern] = STATE(875),
    [sym_expression] = STATE(1019),
    [sym_primary_expression] = STATE(684),
    [sym_not_operator] = STATE(1009),
    [sym_boolean_operator] = STATE(1009),
    [sym_binary_operator] = STATE(797),
    [sym_unary_operator] = STATE(797),
    [sym_comparison_operator] = STATE(1009),
    [sym_lambda] = STATE(1009),
    [sym_assignment] = STATE(1361),
    [sym_augmented_assignment] = STATE(1361),
    [sym_pattern_list] = STATE(897),
    [sym_yield] = STATE(1361),
    [sym_attribute] = STATE(431),
    [sym_subscript] = STATE(431),
    [sym_call] = STATE(797),
    [sym_list] = STATE(797),
    [sym_set] = STATE(797),
    [sym_tuple] = STATE(797),
    [sym_dictionary] = STATE(797),
    [sym_list_comprehension] = STATE(797),
    [sym_dictionary_comprehension] = STATE(797),
    [sym_set_comprehension] = STATE(797),
    [sym_generator_expression] = STATE(797),
    [sym_parenthesized_expression] = STATE(797),
    [sym_conditional_expression] = STATE(1009),
    [sym_concatenated_string] = STATE(797),
    [sym_string] = STATE(713),
    [sym_await] = STATE(1009),
    [aux_sym_module_repeat1] = STATE(69),
    [aux_sym_decorated_definition_repeat1] = STATE(996),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_STAR] = ACTIONS(15),
    [anon_sym_print] = ACTIONS(17),
    [anon_sym_assert] = ACTIONS(19),
    [anon_sym_return] = ACTIONS(21),
    [anon_sym_del] = ACTIONS(23),
    [anon_sym_raise] = ACTIONS(25),
    [anon_sym_pass] = ACTIONS(27),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_async] = ACTIONS(85),
    [anon_sym_for] = ACTIONS(87),
    [anon_sym_while] = ACTIONS(89),
    [anon_sym_try] = ACTIONS(91),
    [anon_sym_with] = ACTIONS(93),
    [anon_sym_match] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(47),
    [anon_sym_PLUS] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(51),
    [anon_sym_STAR_STAR] = ACTIONS(53),
    [anon_sym_def] = ACTIONS(97),
    [anon_sym_global] = ACTIONS(57),
    [anon_sym_nonlocal] = ACTIONS(59),
    [anon_sym_exec] = ACTIONS(61),
    [anon_sym_type] = ACTIONS(63),
    [anon_sym_class] = ACTIONS(99),
    [anon_sym_AT] = ACTIONS(67),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(113),
    [sym__string_start] = ACTIONS(81),
  },
  [56] = {
    [sym__statement] = STATE(68),
    [sym__simple_statements] = STATE(68),
    [sym_import_statement] = STATE(1319),
    [sym_future_import_statement] = STATE(1319),
    [sym_import_from_statement] = STATE(1319),
    [sym_print_statement] = STATE(1319),
    [sym_assert_statement] = STATE(1319),
    [sym_expression_statement] = STATE(1319),
    [sym_named_expression] = STATE(1009),
    [sym_return_statement] = STATE(1319),
    [sym_delete_statement] = STATE(1319),
    [sym_raise_statement] = STATE(1319),
    [sym_pass_statement] = STATE(1319),
    [sym_break_statement] = STATE(1319),
    [sym_continue_statement] = STATE(1319),
    [sym_if_statement] = STATE(68),
    [sym_for_statement] = STATE(68),
    [sym_while_statement] = STATE(68),
    [sym_try_statement] = STATE(68),
    [sym_with_statement] = STATE(68),
    [sym_match_statement] = STATE(68),
    [sym_function_definition] = STATE(68),
    [sym_list_splat] = STATE(1360),
    [sym_dictionary_splat] = STATE(1360),
    [sym_global_statement] = STATE(1319),
    [sym_nonlocal_statement] = STATE(1319),
    [sym_exec_statement] = STATE(1319),
    [sym_type_alias_statement] = STATE(1319),
    [sym_class_definition] = STATE(68),
    [sym_decorated_definition] = STATE(68),
    [sym_decorator] = STATE(996),
    [sym_block] = STATE(265),
    [sym_expression_list] = STATE(1361),
    [sym_pattern] = STATE(889),
    [sym_tuple_pattern] = STATE(875),
    [sym_list_pattern] = STATE(875),
    [sym_list_splat_pattern] = STATE(875),
    [sym_expression] = STATE(1019),
    [sym_primary_expression] = STATE(684),
    [sym_not_operator] = STATE(1009),
    [sym_boolean_operator] = STATE(1009),
    [sym_binary_operator] = STATE(797),
    [sym_unary_operator] = STATE(797),
    [sym_comparison_operator] = STATE(1009),
    [sym_lambda] = STATE(1009),
    [sym_assignment] = STATE(1361),
    [sym_augmented_assignment] = STATE(1361),
    [sym_pattern_list] = STATE(897),
    [sym_yield] = STATE(1361),
    [sym_attribute] = STATE(431),
    [sym_subscript] = STATE(431),
    [sym_call] = STATE(797),
    [sym_list] = STATE(797),
    [sym_set] = STATE(797),
    [sym_tuple] = STATE(797),
    [sym_dictionary] = STATE(797),
    [sym_list_comprehension] = STATE(797),
    [sym_dictionary_comprehension] = STATE(797),
    [sym_set_comprehension] = STATE(797),
    [sym_generator_expression] = STATE(797),
    [sym_parenthesized_expression] = STATE(797),
    [sym_conditional_expression] = STATE(1009),
    [sym_concatenated_string] = STATE(797),
    [sym_string] = STATE(713),
    [sym_await] = STATE(1009),
    [aux_sym_module_repeat1] = STATE(68),
    [aux_sym_decorated_definition_repeat1] = STATE(996),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_STAR] = ACTIONS(15),
    [anon_sym_print] = ACTIONS(17),
    [anon_sym_assert] = ACTIONS(19),
    [anon_sym_return] = ACTIONS(21),
    [anon_sym_del] = ACTIONS(23),
    [anon_sym_raise] = ACTIONS(25),
    [anon_sym_pass] = ACTIONS(27),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_async] = ACTIONS(85),
    [anon_sym_for] = ACTIONS(87),
    [anon_sym_while] = ACTIONS(89),
    [anon_sym_try] = ACTIONS(91),
    [anon_sym_with] = ACTIONS(93),
    [anon_sym_match] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(47),
    [anon_sym_PLUS] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(51),
    [anon_sym_STAR_STAR] = ACTIONS(53),
    [anon_sym_def] = ACTIONS(97),
    [anon_sym_global] = ACTIONS(57),
    [anon_sym_nonlocal] = ACTIONS(59),
    [anon_sym_exec] = ACTIONS(61),
    [anon_sym_type] = ACTIONS(63),
    [anon_sym_class] = ACTIONS(99),
    [anon_sym_AT] = ACTIONS(67),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(103),
    [sym__string_start] = ACTIONS(81),
  },
  [57] = {
    [sym__statement] = STATE(61),
    [sym__simple_statements] = STATE(61),
    [sym_import_statement] = STATE(1319),
    [sym_future_import_statement] = STATE(1319),
    [sym_import_from_statement] = STATE(1319),
    [sym_print_statement] = STATE(1319),
    [sym_assert_statement] = STATE(1319),
    [sym_expression_statement] = STATE(1319),
    [sym_named_expression] = STATE(1009),
    [sym_return_statement] = STATE(1319),
    [sym_delete_statement] = STATE(1319),
    [sym_raise_statement] = STATE(1319),
    [sym_pass_statement] = STATE(1319),
    [sym_break_statement] = STATE(1319),
    [sym_continue_statement] = STATE(1319),
    [sym_if_statement] = STATE(61),
    [sym_for_statement] = STATE(61),
    [sym_while_statement] = STATE(61),
    [sym_try_statement] = STATE(61),
    [sym_with_statement] = STATE(61),
    [sym_match_statement] = STATE(61),
    [sym_function_definition] = STATE(61),
    [sym_list_splat] = STATE(1360),
    [sym_dictionary_splat] = STATE(1360),
    [sym_global_statement] = STATE(1319),
    [sym_nonlocal_statement] = STATE(1319),
    [sym_exec_statement] = STATE(1319),
    [sym_type_alias_statement] = STATE(1319),
    [sym_class_definition] = STATE(61),
    [sym_decorated_definition] = STATE(61),
    [sym_decorator] = STATE(996),
    [sym_block] = STATE(561),
    [sym_expression_list] = STATE(1361),
    [sym_pattern] = STATE(889),
    [sym_tuple_pattern] = STATE(875),
    [sym_list_pattern] = STATE(875),
    [sym_list_splat_pattern] = STATE(875),
    [sym_expression] = STATE(1019),
    [sym_primary_expression] = STATE(684),
    [sym_not_operator] = STATE(1009),
    [sym_boolean_operator] = STATE(1009),
    [sym_binary_operator] = STATE(797),
    [sym_unary_operator] = STATE(797),
    [sym_comparison_operator] = STATE(1009),
    [sym_lambda] = STATE(1009),
    [sym_assignment] = STATE(1361),
    [sym_augmented_assignment] = STATE(1361),
    [sym_pattern_list] = STATE(897),
    [sym_yield] = STATE(1361),
    [sym_attribute] = STATE(431),
    [sym_subscript] = STATE(431),
    [sym_call] = STATE(797),
    [sym_list] = STATE(797),
    [sym_set] = STATE(797),
    [sym_tuple] = STATE(797),
    [sym_dictionary] = STATE(797),
    [sym_list_comprehension] = STATE(797),
    [sym_dictionary_comprehension] = STATE(797),
    [sym_set_comprehension] = STATE(797),
    [sym_generator_expression] = STATE(797),
    [sym_parenthesized_expression] = STATE(797),
    [sym_conditional_expression] = STATE(1009),
    [sym_concatenated_string] = STATE(797),
    [sym_string] = STATE(713),
    [sym_await] = STATE(1009),
    [aux_sym_module_repeat1] = STATE(61),
    [aux_sym_decorated_definition_repeat1] = STATE(996),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_STAR] = ACTIONS(15),
    [anon_sym_print] = ACTIONS(17),
    [anon_sym_assert] = ACTIONS(19),
    [anon_sym_return] = ACTIONS(21),
    [anon_sym_del] = ACTIONS(23),
    [anon_sym_raise] = ACTIONS(25),
    [anon_sym_pass] = ACTIONS(27),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_async] = ACTIONS(85),
    [anon_sym_for] = ACTIONS(87),
    [anon_sym_while] = ACTIONS(89),
    [anon_sym_try] = ACTIONS(91),
    [anon_sym_with] = ACTIONS(93),
    [anon_sym_match] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(47),
    [anon_sym_PLUS] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(51),
    [anon_sym_STAR_STAR] = ACTIONS(53),
    [anon_sym_def] = ACTIONS(97),
    [anon_sym_global] = ACTIONS(57),
    [anon_sym_nonlocal] = ACTIONS(59),
    [anon_sym_exec] = ACTIONS(61),
    [anon_sym_type] = ACTIONS(63),
    [anon_sym_class] = ACTIONS(99),
    [anon_sym_AT] = ACTIONS(67),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(107),
    [sym__string_start] = ACTIONS(81),
  },
  [58] = {
    [sym__statement] = STATE(68),
    [sym__simple_statements] = STATE(68),
    [sym_import_statement] = STATE(1319),
    [sym_future_import_statement] = STATE(1319),
    [sym_import_from_statement] = STATE(1319),
    [sym_print_statement] = STATE(1319),
    [sym_assert_statement] = STATE(1319),
    [sym_expression_statement] = STATE(1319),
    [sym_named_expression] = STATE(1009),
    [sym_return_statement] = STATE(1319),
    [sym_delete_statement] = STATE(1319),
    [sym_raise_statement] = STATE(1319),
    [sym_pass_statement] = STATE(1319),
    [sym_break_statement] = STATE(1319),
    [sym_continue_statement] = STATE(1319),
    [sym_if_statement] = STATE(68),
    [sym_for_statement] = STATE(68),
    [sym_while_statement] = STATE(68),
    [sym_try_statement] = STATE(68),
    [sym_with_statement] = STATE(68),
    [sym_match_statement] = STATE(68),
    [sym_function_definition] = STATE(68),
    [sym_list_splat] = STATE(1360),
    [sym_dictionary_splat] = STATE(1360),
    [sym_global_statement] = STATE(1319),
    [sym_nonlocal_statement] = STATE(1319),
    [sym_exec_statement] = STATE(1319),
    [sym_type_alias_statement] = STATE(1319),
    [sym_class_definition] = STATE(68),
    [sym_decorated_definition] = STATE(68),
    [sym_decorator] = STATE(996),
    [sym_block] = STATE(517),
    [sym_expression_list] = STATE(1361),
    [sym_pattern] = STATE(889),
    [sym_tuple_pattern] = STATE(875),
    [sym_list_pattern] = STATE(875),
    [sym_list_splat_pattern] = STATE(875),
    [sym_expression] = STATE(1019),
    [sym_primary_expression] = STATE(684),
    [sym_not_operator] = STATE(1009),
    [sym_boolean_operator] = STATE(1009),
    [sym_binary_operator] = STATE(797),
    [sym_unary_operator] = STATE(797),
    [sym_comparison_operator] = STATE(1009),
    [sym_lambda] = STATE(1009),
    [sym_assignment] = STATE(1361),
    [sym_augmented_assignment] = STATE(1361),
    [sym_pattern_list] = STATE(897),
    [sym_yield] = STATE(1361),
    [sym_attribute] = STATE(431),
    [sym_subscript] = STATE(431),
    [sym_call] = STATE(797),
    [sym_list] = STATE(797),
    [sym_set] = STATE(797),
    [sym_tuple] = STATE(797),
    [sym_dictionary] = STATE(797),
    [sym_list_comprehension] = STATE(797),
    [sym_dictionary_comprehension] = STATE(797),
    [sym_set_comprehension] = STATE(797),
    [sym_generator_expression] = STATE(797),
    [sym_parenthesized_expression] = STATE(797),
    [sym_conditional_expression] = STATE(1009),
    [sym_concatenated_string] = STATE(797),
    [sym_string] = STATE(713),
    [sym_await] = STATE(1009),
    [aux_sym_module_repeat1] = STATE(68),
    [aux_sym_decorated_definition_repeat1] = STATE(996),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_STAR] = ACTIONS(15),
    [anon_sym_print] = ACTIONS(17),
    [anon_sym_assert] = ACTIONS(19),
    [anon_sym_return] = ACTIONS(21),
    [anon_sym_del] = ACTIONS(23),
    [anon_sym_raise] = ACTIONS(25),
    [anon_sym_pass] = ACTIONS(27),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_async] = ACTIONS(85),
    [anon_sym_for] = ACTIONS(87),
    [anon_sym_while] = ACTIONS(89),
    [anon_sym_try] = ACTIONS(91),
    [anon_sym_with] = ACTIONS(93),
    [anon_sym_match] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(47),
    [anon_sym_PLUS] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(51),
    [anon_sym_STAR_STAR] = ACTIONS(53),
    [anon_sym_def] = ACTIONS(97),
    [anon_sym_global] = ACTIONS(57),
    [anon_sym_nonlocal] = ACTIONS(59),
    [anon_sym_exec] = ACTIONS(61),
    [anon_sym_type] = ACTIONS(63),
    [anon_sym_class] = ACTIONS(99),
    [anon_sym_AT] = ACTIONS(67),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(103),
    [sym__string_start] = ACTIONS(81),
  },
  [59] = {
    [sym__statement] = STATE(68),
    [sym__simple_statements] = STATE(68),
    [sym_import_statement] = STATE(1319),
    [sym_future_import_statement] = STATE(1319),
    [sym_import_from_statement] = STATE(1319),
    [sym_print_statement] = STATE(1319),
    [sym_assert_statement] = STATE(1319),
    [sym_expression_statement] = STATE(1319),
    [sym_named_expression] = STATE(1009),
    [sym_return_statement] = STATE(1319),
    [sym_delete_statement] = STATE(1319),
    [sym_raise_statement] = STATE(1319),
    [sym_pass_statement] = STATE(1319),
    [sym_break_statement] = STATE(1319),
    [sym_continue_statement] = STATE(1319),
    [sym_if_statement] = STATE(68),
    [sym_for_statement] = STATE(68),
    [sym_while_statement] = STATE(68),
    [sym_try_statement] = STATE(68),
    [sym_with_statement] = STATE(68),
    [sym_match_statement] = STATE(68),
    [sym_function_definition] = STATE(68),
    [sym_list_splat] = STATE(1360),
    [sym_dictionary_splat] = STATE(1360),
    [sym_global_statement] = STATE(1319),
    [sym_nonlocal_statement] = STATE(1319),
    [sym_exec_statement] = STATE(1319),
    [sym_type_alias_statement] = STATE(1319),
    [sym_class_definition] = STATE(68),
    [sym_decorated_definition] = STATE(68),
    [sym_decorator] = STATE(996),
    [sym_block] = STATE(554),
    [sym_expression_list] = STATE(1361),
    [sym_pattern] = STATE(889),
    [sym_tuple_pattern] = STATE(875),
    [sym_list_pattern] = STATE(875),
    [sym_list_splat_pattern] = STATE(875),
    [sym_expression] = STATE(1019),
    [sym_primary_expression] = STATE(684),
    [sym_not_operator] = STATE(1009),
    [sym_boolean_operator] = STATE(1009),
    [sym_binary_operator] = STATE(797),
    [sym_unary_operator] = STATE(797),
    [sym_comparison_operator] = STATE(1009),
    [sym_lambda] = STATE(1009),
    [sym_assignment] = STATE(1361),
    [sym_augmented_assignment] = STATE(1361),
    [sym_pattern_list] = STATE(897),
    [sym_yield] = STATE(1361),
    [sym_attribute] = STATE(431),
    [sym_subscript] = STATE(431),
    [sym_call] = STATE(797),
    [sym_list] = STATE(797),
    [sym_set] = STATE(797),
    [sym_tuple] = STATE(797),
    [sym_dictionary] = STATE(797),
    [sym_list_comprehension] = STATE(797),
    [sym_dictionary_comprehension] = STATE(797),
    [sym_set_comprehension] = STATE(797),
    [sym_generator_expression] = STATE(797),
    [sym_parenthesized_expression] = STATE(797),
    [sym_conditional_expression] = STATE(1009),
    [sym_concatenated_string] = STATE(797),
    [sym_string] = STATE(713),
    [sym_await] = STATE(1009),
    [aux_sym_module_repeat1] = STATE(68),
    [aux_sym_decorated_definition_repeat1] = STATE(996),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_STAR] = ACTIONS(15),
    [anon_sym_print] = ACTIONS(17),
    [anon_sym_assert] = ACTIONS(19),
    [anon_sym_return] = ACTIONS(21),
    [anon_sym_del] = ACTIONS(23),
    [anon_sym_raise] = ACTIONS(25),
    [anon_sym_pass] = ACTIONS(27),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_async] = ACTIONS(85),
    [anon_sym_for] = ACTIONS(87),
    [anon_sym_while] = ACTIONS(89),
    [anon_sym_try] = ACTIONS(91),
    [anon_sym_with] = ACTIONS(93),
    [anon_sym_match] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(47),
    [anon_sym_PLUS] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(51),
    [anon_sym_STAR_STAR] = ACTIONS(53),
    [anon_sym_def] = ACTIONS(97),
    [anon_sym_global] = ACTIONS(57),
    [anon_sym_nonlocal] = ACTIONS(59),
    [anon_sym_exec] = ACTIONS(61),
    [anon_sym_type] = ACTIONS(63),
    [anon_sym_class] = ACTIONS(99),
    [anon_sym_AT] = ACTIONS(67),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(103),
    [sym__string_start] = ACTIONS(81),
  },
  [60] = {
    [sym__statement] = STATE(63),
    [sym__simple_statements] = STATE(63),
    [sym_import_statement] = STATE(1319),
    [sym_future_import_statement] = STATE(1319),
    [sym_import_from_statement] = STATE(1319),
    [sym_print_statement] = STATE(1319),
    [sym_assert_statement] = STATE(1319),
    [sym_expression_statement] = STATE(1319),
    [sym_named_expression] = STATE(1009),
    [sym_return_statement] = STATE(1319),
    [sym_delete_statement] = STATE(1319),
    [sym_raise_statement] = STATE(1319),
    [sym_pass_statement] = STATE(1319),
    [sym_break_statement] = STATE(1319),
    [sym_continue_statement] = STATE(1319),
    [sym_if_statement] = STATE(63),
    [sym_for_statement] = STATE(63),
    [sym_while_statement] = STATE(63),
    [sym_try_statement] = STATE(63),
    [sym_with_statement] = STATE(63),
    [sym_match_statement] = STATE(63),
    [sym_function_definition] = STATE(63),
    [sym_list_splat] = STATE(1360),
    [sym_dictionary_splat] = STATE(1360),
    [sym_global_statement] = STATE(1319),
    [sym_nonlocal_statement] = STATE(1319),
    [sym_exec_statement] = STATE(1319),
    [sym_type_alias_statement] = STATE(1319),
    [sym_class_definition] = STATE(63),
    [sym_decorated_definition] = STATE(63),
    [sym_decorator] = STATE(996),
    [sym_expression_list] = STATE(1361),
    [sym_pattern] = STATE(889),
    [sym_tuple_pattern] = STATE(875),
    [sym_list_pattern] = STATE(875),
    [sym_list_splat_pattern] = STATE(875),
    [sym_expression] = STATE(1019),
    [sym_primary_expression] = STATE(684),
    [sym_not_operator] = STATE(1009),
    [sym_boolean_operator] = STATE(1009),
    [sym_binary_operator] = STATE(797),
    [sym_unary_operator] = STATE(797),
    [sym_comparison_operator] = STATE(1009),
    [sym_lambda] = STATE(1009),
    [sym_assignment] = STATE(1361),
    [sym_augmented_assignment] = STATE(1361),
    [sym_pattern_list] = STATE(897),
    [sym_yield] = STATE(1361),
    [sym_attribute] = STATE(431),
    [sym_subscript] = STATE(431),
    [sym_call] = STATE(797),
    [sym_list] = STATE(797),
    [sym_set] = STATE(797),
    [sym_tuple] = STATE(797),
    [sym_dictionary] = STATE(797),
    [sym_list_comprehension] = STATE(797),
    [sym_dictionary_comprehension] = STATE(797),
    [sym_set_comprehension] = STATE(797),
    [sym_generator_expression] = STATE(797),
    [sym_parenthesized_expression] = STATE(797),
    [sym_conditional_expression] = STATE(1009),
    [sym_concatenated_string] = STATE(797),
    [sym_string] = STATE(713),
    [sym_await] = STATE(1009),
    [aux_sym_module_repeat1] = STATE(63),
    [aux_sym_decorated_definition_repeat1] = STATE(996),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_STAR] = ACTIONS(15),
    [anon_sym_print] = ACTIONS(17),
    [anon_sym_assert] = ACTIONS(19),
    [anon_sym_return] = ACTIONS(21),
    [anon_sym_del] = ACTIONS(23),
    [anon_sym_raise] = ACTIONS(25),
    [anon_sym_pass] = ACTIONS(27),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_async] = ACTIONS(85),
    [anon_sym_for] = ACTIONS(87),
    [anon_sym_while] = ACTIONS(89),
    [anon_sym_try] = ACTIONS(91),
    [anon_sym_with] = ACTIONS(93),
    [anon_sym_match] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(47),
    [anon_sym_PLUS] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(51),
    [anon_sym_STAR_STAR] = ACTIONS(53),
    [anon_sym_def] = ACTIONS(97),
    [anon_sym_global] = ACTIONS(57),
    [anon_sym_nonlocal] = ACTIONS(59),
    [anon_sym_exec] = ACTIONS(61),
    [anon_sym_type] = ACTIONS(63),
    [anon_sym_class] = ACTIONS(99),
    [anon_sym_AT] = ACTIONS(67),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(115),
    [sym__string_start] = ACTIONS(81),
  },
  [61] = {
    [sym__statement] = STATE(63),
    [sym__simple_statements] = STATE(63),
    [sym_import_statement] = STATE(1319),
    [sym_future_import_statement] = STATE(1319),
    [sym_import_from_statement] = STATE(1319),
    [sym_print_statement] = STATE(1319),
    [sym_assert_statement] = STATE(1319),
    [sym_expression_statement] = STATE(1319),
    [sym_named_expression] = STATE(1009),
    [sym_return_statement] = STATE(1319),
    [sym_delete_statement] = STATE(1319),
    [sym_raise_statement] = STATE(1319),
    [sym_pass_statement] = STATE(1319),
    [sym_break_statement] = STATE(1319),
    [sym_continue_statement] = STATE(1319),
    [sym_if_statement] = STATE(63),
    [sym_for_statement] = STATE(63),
    [sym_while_statement] = STATE(63),
    [sym_try_statement] = STATE(63),
    [sym_with_statement] = STATE(63),
    [sym_match_statement] = STATE(63),
    [sym_function_definition] = STATE(63),
    [sym_list_splat] = STATE(1360),
    [sym_dictionary_splat] = STATE(1360),
    [sym_global_statement] = STATE(1319),
    [sym_nonlocal_statement] = STATE(1319),
    [sym_exec_statement] = STATE(1319),
    [sym_type_alias_statement] = STATE(1319),
    [sym_class_definition] = STATE(63),
    [sym_decorated_definition] = STATE(63),
    [sym_decorator] = STATE(996),
    [sym_expression_list] = STATE(1361),
    [sym_pattern] = STATE(889),
    [sym_tuple_pattern] = STATE(875),
    [sym_list_pattern] = STATE(875),
    [sym_list_splat_pattern] = STATE(875),
    [sym_expression] = STATE(1019),
    [sym_primary_expression] = STATE(684),
    [sym_not_operator] = STATE(1009),
    [sym_boolean_operator] = STATE(1009),
    [sym_binary_operator] = STATE(797),
    [sym_unary_operator] = STATE(797),
    [sym_comparison_operator] = STATE(1009),
    [sym_lambda] = STATE(1009),
    [sym_assignment] = STATE(1361),
    [sym_augmented_assignment] = STATE(1361),
    [sym_pattern_list] = STATE(897),
    [sym_yield] = STATE(1361),
    [sym_attribute] = STATE(431),
    [sym_subscript] = STATE(431),
    [sym_call] = STATE(797),
    [sym_list] = STATE(797),
    [sym_set] = STATE(797),
    [sym_tuple] = STATE(797),
    [sym_dictionary] = STATE(797),
    [sym_list_comprehension] = STATE(797),
    [sym_dictionary_comprehension] = STATE(797),
    [sym_set_comprehension] = STATE(797),
    [sym_generator_expression] = STATE(797),
    [sym_parenthesized_expression] = STATE(797),
    [sym_conditional_expression] = STATE(1009),
    [sym_concatenated_string] = STATE(797),
    [sym_string] = STATE(713),
    [sym_await] = STATE(1009),
    [aux_sym_module_repeat1] = STATE(63),
    [aux_sym_decorated_definition_repeat1] = STATE(996),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_STAR] = ACTIONS(15),
    [anon_sym_print] = ACTIONS(17),
    [anon_sym_assert] = ACTIONS(19),
    [anon_sym_return] = ACTIONS(21),
    [anon_sym_del] = ACTIONS(23),
    [anon_sym_raise] = ACTIONS(25),
    [anon_sym_pass] = ACTIONS(27),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_async] = ACTIONS(85),
    [anon_sym_for] = ACTIONS(87),
    [anon_sym_while] = ACTIONS(89),
    [anon_sym_try] = ACTIONS(91),
    [anon_sym_with] = ACTIONS(93),
    [anon_sym_match] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(47),
    [anon_sym_PLUS] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(51),
    [anon_sym_STAR_STAR] = ACTIONS(53),
    [anon_sym_def] = ACTIONS(97),
    [anon_sym_global] = ACTIONS(57),
    [anon_sym_nonlocal] = ACTIONS(59),
    [anon_sym_exec] = ACTIONS(61),
    [anon_sym_type] = ACTIONS(63),
    [anon_sym_class] = ACTIONS(99),
    [anon_sym_AT] = ACTIONS(67),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(117),
    [sym__string_start] = ACTIONS(81),
  },
  [62] = {
    [sym__statement] = STATE(63),
    [sym__simple_statements] = STATE(63),
    [sym_import_statement] = STATE(1319),
    [sym_future_import_statement] = STATE(1319),
    [sym_import_from_statement] = STATE(1319),
    [sym_print_statement] = STATE(1319),
    [sym_assert_statement] = STATE(1319),
    [sym_expression_statement] = STATE(1319),
    [sym_named_expression] = STATE(1009),
    [sym_return_statement] = STATE(1319),
    [sym_delete_statement] = STATE(1319),
    [sym_raise_statement] = STATE(1319),
    [sym_pass_statement] = STATE(1319),
    [sym_break_statement] = STATE(1319),
    [sym_continue_statement] = STATE(1319),
    [sym_if_statement] = STATE(63),
    [sym_for_statement] = STATE(63),
    [sym_while_statement] = STATE(63),
    [sym_try_statement] = STATE(63),
    [sym_with_statement] = STATE(63),
    [sym_match_statement] = STATE(63),
    [sym_function_definition] = STATE(63),
    [sym_list_splat] = STATE(1360),
    [sym_dictionary_splat] = STATE(1360),
    [sym_global_statement] = STATE(1319),
    [sym_nonlocal_statement] = STATE(1319),
    [sym_exec_statement] = STATE(1319),
    [sym_type_alias_statement] = STATE(1319),
    [sym_class_definition] = STATE(63),
    [sym_decorated_definition] = STATE(63),
    [sym_decorator] = STATE(996),
    [sym_expression_list] = STATE(1361),
    [sym_pattern] = STATE(889),
    [sym_tuple_pattern] = STATE(875),
    [sym_list_pattern] = STATE(875),
    [sym_list_splat_pattern] = STATE(875),
    [sym_expression] = STATE(1019),
    [sym_primary_expression] = STATE(684),
    [sym_not_operator] = STATE(1009),
    [sym_boolean_operator] = STATE(1009),
    [sym_binary_operator] = STATE(797),
    [sym_unary_operator] = STATE(797),
    [sym_comparison_operator] = STATE(1009),
    [sym_lambda] = STATE(1009),
    [sym_assignment] = STATE(1361),
    [sym_augmented_assignment] = STATE(1361),
    [sym_pattern_list] = STATE(897),
    [sym_yield] = STATE(1361),
    [sym_attribute] = STATE(431),
    [sym_subscript] = STATE(431),
    [sym_call] = STATE(797),
    [sym_list] = STATE(797),
    [sym_set] = STATE(797),
    [sym_tuple] = STATE(797),
    [sym_dictionary] = STATE(797),
    [sym_list_comprehension] = STATE(797),
    [sym_dictionary_comprehension] = STATE(797),
    [sym_set_comprehension] = STATE(797),
    [sym_generator_expression] = STATE(797),
    [sym_parenthesized_expression] = STATE(797),
    [sym_conditional_expression] = STATE(1009),
    [sym_concatenated_string] = STATE(797),
    [sym_string] = STATE(713),
    [sym_await] = STATE(1009),
    [aux_sym_module_repeat1] = STATE(63),
    [aux_sym_decorated_definition_repeat1] = STATE(996),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_STAR] = ACTIONS(15),
    [anon_sym_print] = ACTIONS(17),
    [anon_sym_assert] = ACTIONS(19),
    [anon_sym_return] = ACTIONS(21),
    [anon_sym_del] = ACTIONS(23),
    [anon_sym_raise] = ACTIONS(25),
    [anon_sym_pass] = ACTIONS(27),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_async] = ACTIONS(85),
    [anon_sym_for] = ACTIONS(87),
    [anon_sym_while] = ACTIONS(89),
    [anon_sym_try] = ACTIONS(91),
    [anon_sym_with] = ACTIONS(93),
    [anon_sym_match] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(47),
    [anon_sym_PLUS] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(51),
    [anon_sym_STAR_STAR] = ACTIONS(53),
    [anon_sym_def] = ACTIONS(97),
    [anon_sym_global] = ACTIONS(57),
    [anon_sym_nonlocal] = ACTIONS(59),
    [anon_sym_exec] = ACTIONS(61),
    [anon_sym_type] = ACTIONS(63),
    [anon_sym_class] = ACTIONS(99),
    [anon_sym_AT] = ACTIONS(67),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(119),
    [sym__string_start] = ACTIONS(81),
  },
  [63] = {
    [sym__statement] = STATE(63),
    [sym__simple_statements] = STATE(63),
    [sym_import_statement] = STATE(1319),
    [sym_future_import_statement] = STATE(1319),
    [sym_import_from_statement] = STATE(1319),
    [sym_print_statement] = STATE(1319),
    [sym_assert_statement] = STATE(1319),
    [sym_expression_statement] = STATE(1319),
    [sym_named_expression] = STATE(1009),
    [sym_return_statement] = STATE(1319),
    [sym_delete_statement] = STATE(1319),
    [sym_raise_statement] = STATE(1319),
    [sym_pass_statement] = STATE(1319),
    [sym_break_statement] = STATE(1319),
    [sym_continue_statement] = STATE(1319),
    [sym_if_statement] = STATE(63),
    [sym_for_statement] = STATE(63),
    [sym_while_statement] = STATE(63),
    [sym_try_statement] = STATE(63),
    [sym_with_statement] = STATE(63),
    [sym_match_statement] = STATE(63),
    [sym_function_definition] = STATE(63),
    [sym_list_splat] = STATE(1360),
    [sym_dictionary_splat] = STATE(1360),
    [sym_global_statement] = STATE(1319),
    [sym_nonlocal_statement] = STATE(1319),
    [sym_exec_statement] = STATE(1319),
    [sym_type_alias_statement] = STATE(1319),
    [sym_class_definition] = STATE(63),
    [sym_decorated_definition] = STATE(63),
    [sym_decorator] = STATE(996),
    [sym_expression_list] = STATE(1361),
    [sym_pattern] = STATE(889),
    [sym_tuple_pattern] = STATE(875),
    [sym_list_pattern] = STATE(875),
    [sym_list_splat_pattern] = STATE(875),
    [sym_expression] = STATE(1019),
    [sym_primary_expression] = STATE(684),
    [sym_not_operator] = STATE(1009),
    [sym_boolean_operator] = STATE(1009),
    [sym_binary_operator] = STATE(797),
    [sym_unary_operator] = STATE(797),
    [sym_comparison_operator] = STATE(1009),
    [sym_lambda] = STATE(1009),
    [sym_assignment] = STATE(1361),
    [sym_augmented_assignment] = STATE(1361),
    [sym_pattern_list] = STATE(897),
    [sym_yield] = STATE(1361),
    [sym_attribute] = STATE(431),
    [sym_subscript] = STATE(431),
    [sym_call] = STATE(797),
    [sym_list] = STATE(797),
    [sym_set] = STATE(797),
    [sym_tuple] = STATE(797),
    [sym_dictionary] = STATE(797),
    [sym_list_comprehension] = STATE(797),
    [sym_dictionary_comprehension] = STATE(797),
    [sym_set_comprehension] = STATE(797),
    [sym_generator_expression] = STATE(797),
    [sym_parenthesized_expression] = STATE(797),
    [sym_conditional_expression] = STATE(1009),
    [sym_concatenated_string] = STATE(797),
    [sym_string] = STATE(713),
    [sym_await] = STATE(1009),
    [aux_sym_module_repeat1] = STATE(63),
    [aux_sym_decorated_definition_repeat1] = STATE(996),
    [sym_identifier] = ACTIONS(121),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_from] = ACTIONS(127),
    [anon_sym_LPAREN] = ACTIONS(130),
    [anon_sym_STAR] = ACTIONS(133),
    [anon_sym_print] = ACTIONS(136),
    [anon_sym_assert] = ACTIONS(139),
    [anon_sym_return] = ACTIONS(142),
    [anon_sym_del] = ACTIONS(145),
    [anon_sym_raise] = ACTIONS(148),
    [anon_sym_pass] = ACTIONS(151),
    [anon_sym_break] = ACTIONS(154),
    [anon_sym_continue] = ACTIONS(157),
    [anon_sym_if] = ACTIONS(160),
    [anon_sym_async] = ACTIONS(163),
    [anon_sym_for] = ACTIONS(166),
    [anon_sym_while] = ACTIONS(169),
    [anon_sym_try] = ACTIONS(172),
    [anon_sym_with] = ACTIONS(175),
    [anon_sym_match] = ACTIONS(178),
    [anon_sym_DASH] = ACTIONS(181),
    [anon_sym_PLUS] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(184),
    [anon_sym_LBRACE] = ACTIONS(187),
    [anon_sym_STAR_STAR] = ACTIONS(190),
    [anon_sym_def] = ACTIONS(193),
    [anon_sym_global] = ACTIONS(196),
    [anon_sym_nonlocal] = ACTIONS(199),
    [anon_sym_exec] = ACTIONS(202),
    [anon_sym_type] = ACTIONS(205),
    [anon_sym_class] = ACTIONS(208),
    [anon_sym_AT] = ACTIONS(211),
    [anon_sym_not] = ACTIONS(214),
    [anon_sym_TILDE] = ACTIONS(181),
    [anon_sym_lambda] = ACTIONS(217),
    [anon_sym_yield] = ACTIONS(220),
    [sym_ellipsis] = ACTIONS(223),
    [sym_integer] = ACTIONS(226),
    [sym_float] = ACTIONS(223),
    [anon_sym_await] = ACTIONS(229),
    [sym_true] = ACTIONS(226),
    [sym_false] = ACTIONS(226),
    [sym_none] = ACTIONS(226),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(232),
    [sym__string_start] = ACTIONS(234),
  },
  [64] = {
    [sym__statement] = STATE(67),
    [sym__simple_statements] = STATE(67),
    [sym_import_statement] = STATE(1209),
    [sym_future_import_statement] = STATE(1209),
    [sym_import_from_statement] = STATE(1209),
    [sym_print_statement] = STATE(1209),
    [sym_assert_statement] = STATE(1209),
    [sym_expression_statement] = STATE(1209),
    [sym_named_expression] = STATE(1009),
    [sym_return_statement] = STATE(1209),
    [sym_delete_statement] = STATE(1209),
    [sym_raise_statement] = STATE(1209),
    [sym_pass_statement] = STATE(1209),
    [sym_break_statement] = STATE(1209),
    [sym_continue_statement] = STATE(1209),
    [sym_if_statement] = STATE(67),
    [sym_for_statement] = STATE(67),
    [sym_while_statement] = STATE(67),
    [sym_try_statement] = STATE(67),
    [sym_with_statement] = STATE(67),
    [sym_match_statement] = STATE(67),
    [sym_function_definition] = STATE(67),
    [sym_list_splat] = STATE(1360),
    [sym_dictionary_splat] = STATE(1360),
    [sym_global_statement] = STATE(1209),
    [sym_nonlocal_statement] = STATE(1209),
    [sym_exec_statement] = STATE(1209),
    [sym_type_alias_statement] = STATE(1209),
    [sym_class_definition] = STATE(67),
    [sym_decorated_definition] = STATE(67),
    [sym_decorator] = STATE(1002),
    [sym_expression_list] = STATE(1361),
    [sym_pattern] = STATE(889),
    [sym_tuple_pattern] = STATE(875),
    [sym_list_pattern] = STATE(875),
    [sym_list_splat_pattern] = STATE(875),
    [sym_expression] = STATE(1019),
    [sym_primary_expression] = STATE(684),
    [sym_not_operator] = STATE(1009),
    [sym_boolean_operator] = STATE(1009),
    [sym_binary_operator] = STATE(797),
    [sym_unary_operator] = STATE(797),
    [sym_comparison_operator] = STATE(1009),
    [sym_lambda] = STATE(1009),
    [sym_assignment] = STATE(1361),
    [sym_augmented_assignment] = STATE(1361),
    [sym_pattern_list] = STATE(897),
    [sym_yield] = STATE(1361),
    [sym_attribute] = STATE(431),
    [sym_subscript] = STATE(431),
    [sym_call] = STATE(797),
    [sym_list] = STATE(797),
    [sym_set] = STATE(797),
    [sym_tuple] = STATE(797),
    [sym_dictionary] = STATE(797),
    [sym_list_comprehension] = STATE(797),
    [sym_dictionary_comprehension] = STATE(797),
    [sym_set_comprehension] = STATE(797),
    [sym_generator_expression] = STATE(797),
    [sym_parenthesized_expression] = STATE(797),
    [sym_conditional_expression] = STATE(1009),
    [sym_concatenated_string] = STATE(797),
    [sym_string] = STATE(713),
    [sym_await] = STATE(1009),
    [aux_sym_module_repeat1] = STATE(67),
    [aux_sym_decorated_definition_repeat1] = STATE(1002),
    [ts_builtin_sym_end] = ACTIONS(237),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_STAR] = ACTIONS(15),
    [anon_sym_print] = ACTIONS(17),
    [anon_sym_assert] = ACTIONS(19),
    [anon_sym_return] = ACTIONS(21),
    [anon_sym_del] = ACTIONS(23),
    [anon_sym_raise] = ACTIONS(25),
    [anon_sym_pass] = ACTIONS(27),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(33),
    [anon_sym_async] = ACTIONS(35),
    [anon_sym_for] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_try] = ACTIONS(41),
    [anon_sym_with] = ACTIONS(43),
    [anon_sym_match] = ACTIONS(45),
    [anon_sym_DASH] = ACTIONS(47),
    [anon_sym_PLUS] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(51),
    [anon_sym_STAR_STAR] = ACTIONS(53),
    [anon_sym_def] = ACTIONS(55),
    [anon_sym_global] = ACTIONS(57),
    [anon_sym_nonlocal] = ACTIONS(59),
    [anon_sym_exec] = ACTIONS(61),
    [anon_sym_type] = ACTIONS(63),
    [anon_sym_class] = ACTIONS(65),
    [anon_sym_AT] = ACTIONS(67),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(81),
  },
  [65] = {
    [sym__statement] = STATE(63),
    [sym__simple_statements] = STATE(63),
    [sym_import_statement] = STATE(1319),
    [sym_future_import_statement] = STATE(1319),
    [sym_import_from_statement] = STATE(1319),
    [sym_print_statement] = STATE(1319),
    [sym_assert_statement] = STATE(1319),
    [sym_expression_statement] = STATE(1319),
    [sym_named_expression] = STATE(1009),
    [sym_return_statement] = STATE(1319),
    [sym_delete_statement] = STATE(1319),
    [sym_raise_statement] = STATE(1319),
    [sym_pass_statement] = STATE(1319),
    [sym_break_statement] = STATE(1319),
    [sym_continue_statement] = STATE(1319),
    [sym_if_statement] = STATE(63),
    [sym_for_statement] = STATE(63),
    [sym_while_statement] = STATE(63),
    [sym_try_statement] = STATE(63),
    [sym_with_statement] = STATE(63),
    [sym_match_statement] = STATE(63),
    [sym_function_definition] = STATE(63),
    [sym_list_splat] = STATE(1360),
    [sym_dictionary_splat] = STATE(1360),
    [sym_global_statement] = STATE(1319),
    [sym_nonlocal_statement] = STATE(1319),
    [sym_exec_statement] = STATE(1319),
    [sym_type_alias_statement] = STATE(1319),
    [sym_class_definition] = STATE(63),
    [sym_decorated_definition] = STATE(63),
    [sym_decorator] = STATE(996),
    [sym_expression_list] = STATE(1361),
    [sym_pattern] = STATE(889),
    [sym_tuple_pattern] = STATE(875),
    [sym_list_pattern] = STATE(875),
    [sym_list_splat_pattern] = STATE(875),
    [sym_expression] = STATE(1019),
    [sym_primary_expression] = STATE(684),
    [sym_not_operator] = STATE(1009),
    [sym_boolean_operator] = STATE(1009),
    [sym_binary_operator] = STATE(797),
    [sym_unary_operator] = STATE(797),
    [sym_comparison_operator] = STATE(1009),
    [sym_lambda] = STATE(1009),
    [sym_assignment] = STATE(1361),
    [sym_augmented_assignment] = STATE(1361),
    [sym_pattern_list] = STATE(897),
    [sym_yield] = STATE(1361),
    [sym_attribute] = STATE(431),
    [sym_subscript] = STATE(431),
    [sym_call] = STATE(797),
    [sym_list] = STATE(797),
    [sym_set] = STATE(797),
    [sym_tuple] = STATE(797),
    [sym_dictionary] = STATE(797),
    [sym_list_comprehension] = STATE(797),
    [sym_dictionary_comprehension] = STATE(797),
    [sym_set_comprehension] = STATE(797),
    [sym_generator_expression] = STATE(797),
    [sym_parenthesized_expression] = STATE(797),
    [sym_conditional_expression] = STATE(1009),
    [sym_concatenated_string] = STATE(797),
    [sym_string] = STATE(713),
    [sym_await] = STATE(1009),
    [aux_sym_module_repeat1] = STATE(63),
    [aux_sym_decorated_definition_repeat1] = STATE(996),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_STAR] = ACTIONS(15),
    [anon_sym_print] = ACTIONS(17),
    [anon_sym_assert] = ACTIONS(19),
    [anon_sym_return] = ACTIONS(21),
    [anon_sym_del] = ACTIONS(23),
    [anon_sym_raise] = ACTIONS(25),
    [anon_sym_pass] = ACTIONS(27),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_async] = ACTIONS(85),
    [anon_sym_for] = ACTIONS(87),
    [anon_sym_while] = ACTIONS(89),
    [anon_sym_try] = ACTIONS(91),
    [anon_sym_with] = ACTIONS(93),
    [anon_sym_match] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(47),
    [anon_sym_PLUS] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(51),
    [anon_sym_STAR_STAR] = ACTIONS(53),
    [anon_sym_def] = ACTIONS(97),
    [anon_sym_global] = ACTIONS(57),
    [anon_sym_nonlocal] = ACTIONS(59),
    [anon_sym_exec] = ACTIONS(61),
    [anon_sym_type] = ACTIONS(63),
    [anon_sym_class] = ACTIONS(99),
    [anon_sym_AT] = ACTIONS(67),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(239),
    [sym__string_start] = ACTIONS(81),
  },
  [66] = {
    [sym__statement] = STATE(63),
    [sym__simple_statements] = STATE(63),
    [sym_import_statement] = STATE(1319),
    [sym_future_import_statement] = STATE(1319),
    [sym_import_from_statement] = STATE(1319),
    [sym_print_statement] = STATE(1319),
    [sym_assert_statement] = STATE(1319),
    [sym_expression_statement] = STATE(1319),
    [sym_named_expression] = STATE(1009),
    [sym_return_statement] = STATE(1319),
    [sym_delete_statement] = STATE(1319),
    [sym_raise_statement] = STATE(1319),
    [sym_pass_statement] = STATE(1319),
    [sym_break_statement] = STATE(1319),
    [sym_continue_statement] = STATE(1319),
    [sym_if_statement] = STATE(63),
    [sym_for_statement] = STATE(63),
    [sym_while_statement] = STATE(63),
    [sym_try_statement] = STATE(63),
    [sym_with_statement] = STATE(63),
    [sym_match_statement] = STATE(63),
    [sym_function_definition] = STATE(63),
    [sym_list_splat] = STATE(1360),
    [sym_dictionary_splat] = STATE(1360),
    [sym_global_statement] = STATE(1319),
    [sym_nonlocal_statement] = STATE(1319),
    [sym_exec_statement] = STATE(1319),
    [sym_type_alias_statement] = STATE(1319),
    [sym_class_definition] = STATE(63),
    [sym_decorated_definition] = STATE(63),
    [sym_decorator] = STATE(996),
    [sym_expression_list] = STATE(1361),
    [sym_pattern] = STATE(889),
    [sym_tuple_pattern] = STATE(875),
    [sym_list_pattern] = STATE(875),
    [sym_list_splat_pattern] = STATE(875),
    [sym_expression] = STATE(1019),
    [sym_primary_expression] = STATE(684),
    [sym_not_operator] = STATE(1009),
    [sym_boolean_operator] = STATE(1009),
    [sym_binary_operator] = STATE(797),
    [sym_unary_operator] = STATE(797),
    [sym_comparison_operator] = STATE(1009),
    [sym_lambda] = STATE(1009),
    [sym_assignment] = STATE(1361),
    [sym_augmented_assignment] = STATE(1361),
    [sym_pattern_list] = STATE(897),
    [sym_yield] = STATE(1361),
    [sym_attribute] = STATE(431),
    [sym_subscript] = STATE(431),
    [sym_call] = STATE(797),
    [sym_list] = STATE(797),
    [sym_set] = STATE(797),
    [sym_tuple] = STATE(797),
    [sym_dictionary] = STATE(797),
    [sym_list_comprehension] = STATE(797),
    [sym_dictionary_comprehension] = STATE(797),
    [sym_set_comprehension] = STATE(797),
    [sym_generator_expression] = STATE(797),
    [sym_parenthesized_expression] = STATE(797),
    [sym_conditional_expression] = STATE(1009),
    [sym_concatenated_string] = STATE(797),
    [sym_string] = STATE(713),
    [sym_await] = STATE(1009),
    [aux_sym_module_repeat1] = STATE(63),
    [aux_sym_decorated_definition_repeat1] = STATE(996),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_STAR] = ACTIONS(15),
    [anon_sym_print] = ACTIONS(17),
    [anon_sym_assert] = ACTIONS(19),
    [anon_sym_return] = ACTIONS(21),
    [anon_sym_del] = ACTIONS(23),
    [anon_sym_raise] = ACTIONS(25),
    [anon_sym_pass] = ACTIONS(27),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_async] = ACTIONS(85),
    [anon_sym_for] = ACTIONS(87),
    [anon_sym_while] = ACTIONS(89),
    [anon_sym_try] = ACTIONS(91),
    [anon_sym_with] = ACTIONS(93),
    [anon_sym_match] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(47),
    [anon_sym_PLUS] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(51),
    [anon_sym_STAR_STAR] = ACTIONS(53),
    [anon_sym_def] = ACTIONS(97),
    [anon_sym_global] = ACTIONS(57),
    [anon_sym_nonlocal] = ACTIONS(59),
    [anon_sym_exec] = ACTIONS(61),
    [anon_sym_type] = ACTIONS(63),
    [anon_sym_class] = ACTIONS(99),
    [anon_sym_AT] = ACTIONS(67),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(241),
    [sym__string_start] = ACTIONS(81),
  },
  [67] = {
    [sym__statement] = STATE(67),
    [sym__simple_statements] = STATE(67),
    [sym_import_statement] = STATE(1209),
    [sym_future_import_statement] = STATE(1209),
    [sym_import_from_statement] = STATE(1209),
    [sym_print_statement] = STATE(1209),
    [sym_assert_statement] = STATE(1209),
    [sym_expression_statement] = STATE(1209),
    [sym_named_expression] = STATE(1009),
    [sym_return_statement] = STATE(1209),
    [sym_delete_statement] = STATE(1209),
    [sym_raise_statement] = STATE(1209),
    [sym_pass_statement] = STATE(1209),
    [sym_break_statement] = STATE(1209),
    [sym_continue_statement] = STATE(1209),
    [sym_if_statement] = STATE(67),
    [sym_for_statement] = STATE(67),
    [sym_while_statement] = STATE(67),
    [sym_try_statement] = STATE(67),
    [sym_with_statement] = STATE(67),
    [sym_match_statement] = STATE(67),
    [sym_function_definition] = STATE(67),
    [sym_list_splat] = STATE(1360),
    [sym_dictionary_splat] = STATE(1360),
    [sym_global_statement] = STATE(1209),
    [sym_nonlocal_statement] = STATE(1209),
    [sym_exec_statement] = STATE(1209),
    [sym_type_alias_statement] = STATE(1209),
    [sym_class_definition] = STATE(67),
    [sym_decorated_definition] = STATE(67),
    [sym_decorator] = STATE(1002),
    [sym_expression_list] = STATE(1361),
    [sym_pattern] = STATE(889),
    [sym_tuple_pattern] = STATE(875),
    [sym_list_pattern] = STATE(875),
    [sym_list_splat_pattern] = STATE(875),
    [sym_expression] = STATE(1019),
    [sym_primary_expression] = STATE(684),
    [sym_not_operator] = STATE(1009),
    [sym_boolean_operator] = STATE(1009),
    [sym_binary_operator] = STATE(797),
    [sym_unary_operator] = STATE(797),
    [sym_comparison_operator] = STATE(1009),
    [sym_lambda] = STATE(1009),
    [sym_assignment] = STATE(1361),
    [sym_augmented_assignment] = STATE(1361),
    [sym_pattern_list] = STATE(897),
    [sym_yield] = STATE(1361),
    [sym_attribute] = STATE(431),
    [sym_subscript] = STATE(431),
    [sym_call] = STATE(797),
    [sym_list] = STATE(797),
    [sym_set] = STATE(797),
    [sym_tuple] = STATE(797),
    [sym_dictionary] = STATE(797),
    [sym_list_comprehension] = STATE(797),
    [sym_dictionary_comprehension] = STATE(797),
    [sym_set_comprehension] = STATE(797),
    [sym_generator_expression] = STATE(797),
    [sym_parenthesized_expression] = STATE(797),
    [sym_conditional_expression] = STATE(1009),
    [sym_concatenated_string] = STATE(797),
    [sym_string] = STATE(713),
    [sym_await] = STATE(1009),
    [aux_sym_module_repeat1] = STATE(67),
    [aux_sym_decorated_definition_repeat1] = STATE(1002),
    [ts_builtin_sym_end] = ACTIONS(232),
    [sym_identifier] = ACTIONS(121),
    [anon_sym_import] = ACTIONS(124),
    [anon_sym_from] = ACTIONS(127),
    [anon_sym_LPAREN] = ACTIONS(130),
    [anon_sym_STAR] = ACTIONS(133),
    [anon_sym_print] = ACTIONS(136),
    [anon_sym_assert] = ACTIONS(139),
    [anon_sym_return] = ACTIONS(142),
    [anon_sym_del] = ACTIONS(145),
    [anon_sym_raise] = ACTIONS(148),
    [anon_sym_pass] = ACTIONS(151),
    [anon_sym_break] = ACTIONS(154),
    [anon_sym_continue] = ACTIONS(157),
    [anon_sym_if] = ACTIONS(243),
    [anon_sym_async] = ACTIONS(246),
    [anon_sym_for] = ACTIONS(249),
    [anon_sym_while] = ACTIONS(252),
    [anon_sym_try] = ACTIONS(255),
    [anon_sym_with] = ACTIONS(258),
    [anon_sym_match] = ACTIONS(261),
    [anon_sym_DASH] = ACTIONS(181),
    [anon_sym_PLUS] = ACTIONS(181),
    [anon_sym_LBRACK] = ACTIONS(184),
    [anon_sym_LBRACE] = ACTIONS(187),
    [anon_sym_STAR_STAR] = ACTIONS(190),
    [anon_sym_def] = ACTIONS(264),
    [anon_sym_global] = ACTIONS(196),
    [anon_sym_nonlocal] = ACTIONS(199),
    [anon_sym_exec] = ACTIONS(202),
    [anon_sym_type] = ACTIONS(205),
    [anon_sym_class] = ACTIONS(267),
    [anon_sym_AT] = ACTIONS(211),
    [anon_sym_not] = ACTIONS(214),
    [anon_sym_TILDE] = ACTIONS(181),
    [anon_sym_lambda] = ACTIONS(217),
    [anon_sym_yield] = ACTIONS(220),
    [sym_ellipsis] = ACTIONS(223),
    [sym_integer] = ACTIONS(226),
    [sym_float] = ACTIONS(223),
    [anon_sym_await] = ACTIONS(229),
    [sym_true] = ACTIONS(226),
    [sym_false] = ACTIONS(226),
    [sym_none] = ACTIONS(226),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(234),
  },
  [68] = {
    [sym__statement] = STATE(63),
    [sym__simple_statements] = STATE(63),
    [sym_import_statement] = STATE(1319),
    [sym_future_import_statement] = STATE(1319),
    [sym_import_from_statement] = STATE(1319),
    [sym_print_statement] = STATE(1319),
    [sym_assert_statement] = STATE(1319),
    [sym_expression_statement] = STATE(1319),
    [sym_named_expression] = STATE(1009),
    [sym_return_statement] = STATE(1319),
    [sym_delete_statement] = STATE(1319),
    [sym_raise_statement] = STATE(1319),
    [sym_pass_statement] = STATE(1319),
    [sym_break_statement] = STATE(1319),
    [sym_continue_statement] = STATE(1319),
    [sym_if_statement] = STATE(63),
    [sym_for_statement] = STATE(63),
    [sym_while_statement] = STATE(63),
    [sym_try_statement] = STATE(63),
    [sym_with_statement] = STATE(63),
    [sym_match_statement] = STATE(63),
    [sym_function_definition] = STATE(63),
    [sym_list_splat] = STATE(1360),
    [sym_dictionary_splat] = STATE(1360),
    [sym_global_statement] = STATE(1319),
    [sym_nonlocal_statement] = STATE(1319),
    [sym_exec_statement] = STATE(1319),
    [sym_type_alias_statement] = STATE(1319),
    [sym_class_definition] = STATE(63),
    [sym_decorated_definition] = STATE(63),
    [sym_decorator] = STATE(996),
    [sym_expression_list] = STATE(1361),
    [sym_pattern] = STATE(889),
    [sym_tuple_pattern] = STATE(875),
    [sym_list_pattern] = STATE(875),
    [sym_list_splat_pattern] = STATE(875),
    [sym_expression] = STATE(1019),
    [sym_primary_expression] = STATE(684),
    [sym_not_operator] = STATE(1009),
    [sym_boolean_operator] = STATE(1009),
    [sym_binary_operator] = STATE(797),
    [sym_unary_operator] = STATE(797),
    [sym_comparison_operator] = STATE(1009),
    [sym_lambda] = STATE(1009),
    [sym_assignment] = STATE(1361),
    [sym_augmented_assignment] = STATE(1361),
    [sym_pattern_list] = STATE(897),
    [sym_yield] = STATE(1361),
    [sym_attribute] = STATE(431),
    [sym_subscript] = STATE(431),
    [sym_call] = STATE(797),
    [sym_list] = STATE(797),
    [sym_set] = STATE(797),
    [sym_tuple] = STATE(797),
    [sym_dictionary] = STATE(797),
    [sym_list_comprehension] = STATE(797),
    [sym_dictionary_comprehension] = STATE(797),
    [sym_set_comprehension] = STATE(797),
    [sym_generator_expression] = STATE(797),
    [sym_parenthesized_expression] = STATE(797),
    [sym_conditional_expression] = STATE(1009),
    [sym_concatenated_string] = STATE(797),
    [sym_string] = STATE(713),
    [sym_await] = STATE(1009),
    [aux_sym_module_repeat1] = STATE(63),
    [aux_sym_decorated_definition_repeat1] = STATE(996),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_STAR] = ACTIONS(15),
    [anon_sym_print] = ACTIONS(17),
    [anon_sym_assert] = ACTIONS(19),
    [anon_sym_return] = ACTIONS(21),
    [anon_sym_del] = ACTIONS(23),
    [anon_sym_raise] = ACTIONS(25),
    [anon_sym_pass] = ACTIONS(27),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_async] = ACTIONS(85),
    [anon_sym_for] = ACTIONS(87),
    [anon_sym_while] = ACTIONS(89),
    [anon_sym_try] = ACTIONS(91),
    [anon_sym_with] = ACTIONS(93),
    [anon_sym_match] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(47),
    [anon_sym_PLUS] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(51),
    [anon_sym_STAR_STAR] = ACTIONS(53),
    [anon_sym_def] = ACTIONS(97),
    [anon_sym_global] = ACTIONS(57),
    [anon_sym_nonlocal] = ACTIONS(59),
    [anon_sym_exec] = ACTIONS(61),
    [anon_sym_type] = ACTIONS(63),
    [anon_sym_class] = ACTIONS(99),
    [anon_sym_AT] = ACTIONS(67),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(270),
    [sym__string_start] = ACTIONS(81),
  },
  [69] = {
    [sym__statement] = STATE(63),
    [sym__simple_statements] = STATE(63),
    [sym_import_statement] = STATE(1319),
    [sym_future_import_statement] = STATE(1319),
    [sym_import_from_statement] = STATE(1319),
    [sym_print_statement] = STATE(1319),
    [sym_assert_statement] = STATE(1319),
    [sym_expression_statement] = STATE(1319),
    [sym_named_expression] = STATE(1009),
    [sym_return_statement] = STATE(1319),
    [sym_delete_statement] = STATE(1319),
    [sym_raise_statement] = STATE(1319),
    [sym_pass_statement] = STATE(1319),
    [sym_break_statement] = STATE(1319),
    [sym_continue_statement] = STATE(1319),
    [sym_if_statement] = STATE(63),
    [sym_for_statement] = STATE(63),
    [sym_while_statement] = STATE(63),
    [sym_try_statement] = STATE(63),
    [sym_with_statement] = STATE(63),
    [sym_match_statement] = STATE(63),
    [sym_function_definition] = STATE(63),
    [sym_list_splat] = STATE(1360),
    [sym_dictionary_splat] = STATE(1360),
    [sym_global_statement] = STATE(1319),
    [sym_nonlocal_statement] = STATE(1319),
    [sym_exec_statement] = STATE(1319),
    [sym_type_alias_statement] = STATE(1319),
    [sym_class_definition] = STATE(63),
    [sym_decorated_definition] = STATE(63),
    [sym_decorator] = STATE(996),
    [sym_expression_list] = STATE(1361),
    [sym_pattern] = STATE(889),
    [sym_tuple_pattern] = STATE(875),
    [sym_list_pattern] = STATE(875),
    [sym_list_splat_pattern] = STATE(875),
    [sym_expression] = STATE(1019),
    [sym_primary_expression] = STATE(684),
    [sym_not_operator] = STATE(1009),
    [sym_boolean_operator] = STATE(1009),
    [sym_binary_operator] = STATE(797),
    [sym_unary_operator] = STATE(797),
    [sym_comparison_operator] = STATE(1009),
    [sym_lambda] = STATE(1009),
    [sym_assignment] = STATE(1361),
    [sym_augmented_assignment] = STATE(1361),
    [sym_pattern_list] = STATE(897),
    [sym_yield] = STATE(1361),
    [sym_attribute] = STATE(431),
    [sym_subscript] = STATE(431),
    [sym_call] = STATE(797),
    [sym_list] = STATE(797),
    [sym_set] = STATE(797),
    [sym_tuple] = STATE(797),
    [sym_dictionary] = STATE(797),
    [sym_list_comprehension] = STATE(797),
    [sym_dictionary_comprehension] = STATE(797),
    [sym_set_comprehension] = STATE(797),
    [sym_generator_expression] = STATE(797),
    [sym_parenthesized_expression] = STATE(797),
    [sym_conditional_expression] = STATE(1009),
    [sym_concatenated_string] = STATE(797),
    [sym_string] = STATE(713),
    [sym_await] = STATE(1009),
    [aux_sym_module_repeat1] = STATE(63),
    [aux_sym_decorated_definition_repeat1] = STATE(996),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_STAR] = ACTIONS(15),
    [anon_sym_print] = ACTIONS(17),
    [anon_sym_assert] = ACTIONS(19),
    [anon_sym_return] = ACTIONS(21),
    [anon_sym_del] = ACTIONS(23),
    [anon_sym_raise] = ACTIONS(25),
    [anon_sym_pass] = ACTIONS(27),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_async] = ACTIONS(85),
    [anon_sym_for] = ACTIONS(87),
    [anon_sym_while] = ACTIONS(89),
    [anon_sym_try] = ACTIONS(91),
    [anon_sym_with] = ACTIONS(93),
    [anon_sym_match] = ACTIONS(95),
    [anon_sym_DASH] = ACTIONS(47),
    [anon_sym_PLUS] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(51),
    [anon_sym_STAR_STAR] = ACTIONS(53),
    [anon_sym_def] = ACTIONS(97),
    [anon_sym_global] = ACTIONS(57),
    [anon_sym_nonlocal] = ACTIONS(59),
    [anon_sym_exec] = ACTIONS(61),
    [anon_sym_type] = ACTIONS(63),
    [anon_sym_class] = ACTIONS(99),
    [anon_sym_AT] = ACTIONS(67),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(272),
    [sym__string_start] = ACTIONS(81),
  },
  [70] = {
    [sym_named_expression] = STATE(900),
    [sym_list_splat] = STATE(1366),
    [sym_dictionary_splat] = STATE(1366),
    [sym_expression_list] = STATE(1452),
    [sym_expression] = STATE(1079),
    [sym_primary_expression] = STATE(630),
    [sym_not_operator] = STATE(900),
    [sym_boolean_operator] = STATE(900),
    [sym_binary_operator] = STATE(642),
    [sym_unary_operator] = STATE(642),
    [sym_comparison_operator] = STATE(900),
    [sym_lambda] = STATE(900),
    [sym_attribute] = STATE(642),
    [sym_subscript] = STATE(642),
    [sym_call] = STATE(642),
    [sym_list] = STATE(642),
    [sym_set] = STATE(642),
    [sym_tuple] = STATE(642),
    [sym_dictionary] = STATE(642),
    [sym_list_comprehension] = STATE(642),
    [sym_dictionary_comprehension] = STATE(642),
    [sym_set_comprehension] = STATE(642),
    [sym_generator_expression] = STATE(642),
    [sym_parenthesized_expression] = STATE(642),
    [sym_conditional_expression] = STATE(900),
    [sym_concatenated_string] = STATE(642),
    [sym_string] = STATE(600),
    [sym_await] = STATE(900),
    [sym_identifier] = ACTIONS(274),
    [anon_sym_DOT] = ACTIONS(276),
    [anon_sym_LPAREN] = ACTIONS(278),
    [anon_sym_COMMA] = ACTIONS(280),
    [anon_sym_STAR] = ACTIONS(283),
    [anon_sym_print] = ACTIONS(285),
    [anon_sym_GT_GT] = ACTIONS(276),
    [anon_sym_COLON_EQ] = ACTIONS(287),
    [anon_sym_if] = ACTIONS(276),
    [anon_sym_COLON] = ACTIONS(289),
    [anon_sym_async] = ACTIONS(285),
    [anon_sym_in] = ACTIONS(276),
    [anon_sym_match] = ACTIONS(285),
    [anon_sym_PIPE] = ACTIONS(276),
    [anon_sym_DASH] = ACTIONS(291),
    [anon_sym_PLUS] = ACTIONS(291),
    [anon_sym_LBRACK] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(295),
    [anon_sym_STAR_STAR] = ACTIONS(297),
    [anon_sym_EQ] = ACTIONS(289),
    [anon_sym_exec] = ACTIONS(285),
    [anon_sym_type] = ACTIONS(285),
    [anon_sym_AT] = ACTIONS(276),
    [anon_sym_not] = ACTIONS(299),
    [anon_sym_and] = ACTIONS(276),
    [anon_sym_or] = ACTIONS(276),
    [anon_sym_SLASH] = ACTIONS(276),
    [anon_sym_PERCENT] = ACTIONS(276),
    [anon_sym_SLASH_SLASH] = ACTIONS(276),
    [anon_sym_AMP] = ACTIONS(276),
    [anon_sym_CARET] = ACTIONS(276),
    [anon_sym_LT_LT] = ACTIONS(276),
    [anon_sym_TILDE] = ACTIONS(301),
    [anon_sym_LT] = ACTIONS(276),
    [anon_sym_LT_EQ] = ACTIONS(303),
    [anon_sym_EQ_EQ] = ACTIONS(303),
    [anon_sym_BANG_EQ] = ACTIONS(303),
    [anon_sym_GT_EQ] = ACTIONS(303),
    [anon_sym_GT] = ACTIONS(276),
    [anon_sym_LT_GT] = ACTIONS(303),
    [anon_sym_is] = ACTIONS(276),
    [anon_sym_lambda] = ACTIONS(305),
    [anon_sym_PLUS_EQ] = ACTIONS(307),
    [anon_sym_DASH_EQ] = ACTIONS(307),
    [anon_sym_STAR_EQ] = ACTIONS(307),
    [anon_sym_SLASH_EQ] = ACTIONS(307),
    [anon_sym_AT_EQ] = ACTIONS(307),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(307),
    [anon_sym_PERCENT_EQ] = ACTIONS(307),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(307),
    [anon_sym_GT_GT_EQ] = ACTIONS(307),
    [anon_sym_LT_LT_EQ] = ACTIONS(307),
    [anon_sym_AMP_EQ] = ACTIONS(307),
    [anon_sym_CARET_EQ] = ACTIONS(307),
    [anon_sym_PIPE_EQ] = ACTIONS(307),
    [sym_ellipsis] = ACTIONS(309),
    [sym_integer] = ACTIONS(311),
    [sym_float] = ACTIONS(309),
    [anon_sym_await] = ACTIONS(313),
    [sym_true] = ACTIONS(311),
    [sym_false] = ACTIONS(311),
    [sym_none] = ACTIONS(311),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(303),
    [sym__newline] = ACTIONS(303),
    [sym__string_start] = ACTIONS(315),
  },
  [71] = {
    [sym_named_expression] = STATE(900),
    [sym_list_splat] = STATE(1366),
    [sym_dictionary_splat] = STATE(1366),
    [sym_expression_list] = STATE(1493),
    [sym_expression] = STATE(1080),
    [sym_primary_expression] = STATE(630),
    [sym_not_operator] = STATE(900),
    [sym_boolean_operator] = STATE(900),
    [sym_binary_operator] = STATE(642),
    [sym_unary_operator] = STATE(642),
    [sym_comparison_operator] = STATE(900),
    [sym_lambda] = STATE(900),
    [sym_attribute] = STATE(642),
    [sym_subscript] = STATE(642),
    [sym_call] = STATE(642),
    [sym_list] = STATE(642),
    [sym_set] = STATE(642),
    [sym_tuple] = STATE(642),
    [sym_dictionary] = STATE(642),
    [sym_list_comprehension] = STATE(642),
    [sym_dictionary_comprehension] = STATE(642),
    [sym_set_comprehension] = STATE(642),
    [sym_generator_expression] = STATE(642),
    [sym_parenthesized_expression] = STATE(642),
    [sym_conditional_expression] = STATE(900),
    [sym_concatenated_string] = STATE(642),
    [sym_string] = STATE(600),
    [sym_await] = STATE(900),
    [sym_identifier] = ACTIONS(274),
    [anon_sym_DOT] = ACTIONS(276),
    [anon_sym_LPAREN] = ACTIONS(278),
    [anon_sym_COMMA] = ACTIONS(280),
    [anon_sym_STAR] = ACTIONS(283),
    [anon_sym_print] = ACTIONS(285),
    [anon_sym_GT_GT] = ACTIONS(276),
    [anon_sym_COLON_EQ] = ACTIONS(287),
    [anon_sym_if] = ACTIONS(276),
    [anon_sym_COLON] = ACTIONS(289),
    [anon_sym_async] = ACTIONS(285),
    [anon_sym_in] = ACTIONS(276),
    [anon_sym_match] = ACTIONS(285),
    [anon_sym_PIPE] = ACTIONS(276),
    [anon_sym_DASH] = ACTIONS(291),
    [anon_sym_PLUS] = ACTIONS(291),
    [anon_sym_LBRACK] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(295),
    [anon_sym_STAR_STAR] = ACTIONS(297),
    [anon_sym_EQ] = ACTIONS(289),
    [anon_sym_exec] = ACTIONS(285),
    [anon_sym_type] = ACTIONS(285),
    [anon_sym_AT] = ACTIONS(276),
    [anon_sym_not] = ACTIONS(299),
    [anon_sym_and] = ACTIONS(276),
    [anon_sym_or] = ACTIONS(276),
    [anon_sym_SLASH] = ACTIONS(276),
    [anon_sym_PERCENT] = ACTIONS(276),
    [anon_sym_SLASH_SLASH] = ACTIONS(276),
    [anon_sym_AMP] = ACTIONS(276),
    [anon_sym_CARET] = ACTIONS(276),
    [anon_sym_LT_LT] = ACTIONS(276),
    [anon_sym_TILDE] = ACTIONS(301),
    [anon_sym_LT] = ACTIONS(276),
    [anon_sym_LT_EQ] = ACTIONS(303),
    [anon_sym_EQ_EQ] = ACTIONS(303),
    [anon_sym_BANG_EQ] = ACTIONS(303),
    [anon_sym_GT_EQ] = ACTIONS(303),
    [anon_sym_GT] = ACTIONS(276),
    [anon_sym_LT_GT] = ACTIONS(303),
    [anon_sym_is] = ACTIONS(276),
    [anon_sym_lambda] = ACTIONS(305),
    [anon_sym_PLUS_EQ] = ACTIONS(307),
    [anon_sym_DASH_EQ] = ACTIONS(307),
    [anon_sym_STAR_EQ] = ACTIONS(307),
    [anon_sym_SLASH_EQ] = ACTIONS(307),
    [anon_sym_AT_EQ] = ACTIONS(307),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(307),
    [anon_sym_PERCENT_EQ] = ACTIONS(307),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(307),
    [anon_sym_GT_GT_EQ] = ACTIONS(307),
    [anon_sym_LT_LT_EQ] = ACTIONS(307),
    [anon_sym_AMP_EQ] = ACTIONS(307),
    [anon_sym_CARET_EQ] = ACTIONS(307),
    [anon_sym_PIPE_EQ] = ACTIONS(307),
    [sym_ellipsis] = ACTIONS(309),
    [sym_integer] = ACTIONS(311),
    [sym_float] = ACTIONS(309),
    [anon_sym_await] = ACTIONS(313),
    [sym_true] = ACTIONS(311),
    [sym_false] = ACTIONS(311),
    [sym_none] = ACTIONS(311),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(303),
    [sym__newline] = ACTIONS(303),
    [sym__string_start] = ACTIONS(315),
  },
  [72] = {
    [sym__simple_statements] = STATE(550),
    [sym_import_statement] = STATE(1209),
    [sym_future_import_statement] = STATE(1209),
    [sym_import_from_statement] = STATE(1209),
    [sym_print_statement] = STATE(1209),
    [sym_assert_statement] = STATE(1209),
    [sym_expression_statement] = STATE(1209),
    [sym_named_expression] = STATE(1009),
    [sym_return_statement] = STATE(1209),
    [sym_delete_statement] = STATE(1209),
    [sym_raise_statement] = STATE(1209),
    [sym_pass_statement] = STATE(1209),
    [sym_break_statement] = STATE(1209),
    [sym_continue_statement] = STATE(1209),
    [sym_list_splat] = STATE(1360),
    [sym_dictionary_splat] = STATE(1360),
    [sym_global_statement] = STATE(1209),
    [sym_nonlocal_statement] = STATE(1209),
    [sym_exec_statement] = STATE(1209),
    [sym_type_alias_statement] = STATE(1209),
    [sym_expression_list] = STATE(1361),
    [sym_pattern] = STATE(889),
    [sym_tuple_pattern] = STATE(875),
    [sym_list_pattern] = STATE(875),
    [sym_list_splat_pattern] = STATE(875),
    [sym_expression] = STATE(1019),
    [sym_primary_expression] = STATE(684),
    [sym_not_operator] = STATE(1009),
    [sym_boolean_operator] = STATE(1009),
    [sym_binary_operator] = STATE(797),
    [sym_unary_operator] = STATE(797),
    [sym_comparison_operator] = STATE(1009),
    [sym_lambda] = STATE(1009),
    [sym_assignment] = STATE(1361),
    [sym_augmented_assignment] = STATE(1361),
    [sym_pattern_list] = STATE(897),
    [sym_yield] = STATE(1361),
    [sym_attribute] = STATE(431),
    [sym_subscript] = STATE(431),
    [sym_call] = STATE(797),
    [sym_list] = STATE(797),
    [sym_set] = STATE(797),
    [sym_tuple] = STATE(797),
    [sym_dictionary] = STATE(797),
    [sym_list_comprehension] = STATE(797),
    [sym_dictionary_comprehension] = STATE(797),
    [sym_set_comprehension] = STATE(797),
    [sym_generator_expression] = STATE(797),
    [sym_parenthesized_expression] = STATE(797),
    [sym_conditional_expression] = STATE(1009),
    [sym_concatenated_string] = STATE(797),
    [sym_string] = STATE(713),
    [sym_await] = STATE(1009),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_STAR] = ACTIONS(15),
    [anon_sym_print] = ACTIONS(17),
    [anon_sym_assert] = ACTIONS(19),
    [anon_sym_return] = ACTIONS(21),
    [anon_sym_del] = ACTIONS(23),
    [anon_sym_raise] = ACTIONS(25),
    [anon_sym_pass] = ACTIONS(27),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_async] = ACTIONS(317),
    [anon_sym_match] = ACTIONS(317),
    [anon_sym_DASH] = ACTIONS(47),
    [anon_sym_PLUS] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(51),
    [anon_sym_STAR_STAR] = ACTIONS(53),
    [anon_sym_global] = ACTIONS(57),
    [anon_sym_nonlocal] = ACTIONS(59),
    [anon_sym_exec] = ACTIONS(61),
    [anon_sym_type] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(319),
    [sym__indent] = ACTIONS(321),
    [sym__string_start] = ACTIONS(81),
  },
  [73] = {
    [sym__simple_statements] = STATE(432),
    [sym_import_statement] = STATE(1319),
    [sym_future_import_statement] = STATE(1319),
    [sym_import_from_statement] = STATE(1319),
    [sym_print_statement] = STATE(1319),
    [sym_assert_statement] = STATE(1319),
    [sym_expression_statement] = STATE(1319),
    [sym_named_expression] = STATE(1009),
    [sym_return_statement] = STATE(1319),
    [sym_delete_statement] = STATE(1319),
    [sym_raise_statement] = STATE(1319),
    [sym_pass_statement] = STATE(1319),
    [sym_break_statement] = STATE(1319),
    [sym_continue_statement] = STATE(1319),
    [sym_list_splat] = STATE(1360),
    [sym_dictionary_splat] = STATE(1360),
    [sym_global_statement] = STATE(1319),
    [sym_nonlocal_statement] = STATE(1319),
    [sym_exec_statement] = STATE(1319),
    [sym_type_alias_statement] = STATE(1319),
    [sym_expression_list] = STATE(1361),
    [sym_pattern] = STATE(889),
    [sym_tuple_pattern] = STATE(875),
    [sym_list_pattern] = STATE(875),
    [sym_list_splat_pattern] = STATE(875),
    [sym_expression] = STATE(1019),
    [sym_primary_expression] = STATE(684),
    [sym_not_operator] = STATE(1009),
    [sym_boolean_operator] = STATE(1009),
    [sym_binary_operator] = STATE(797),
    [sym_unary_operator] = STATE(797),
    [sym_comparison_operator] = STATE(1009),
    [sym_lambda] = STATE(1009),
    [sym_assignment] = STATE(1361),
    [sym_augmented_assignment] = STATE(1361),
    [sym_pattern_list] = STATE(897),
    [sym_yield] = STATE(1361),
    [sym_attribute] = STATE(431),
    [sym_subscript] = STATE(431),
    [sym_call] = STATE(797),
    [sym_list] = STATE(797),
    [sym_set] = STATE(797),
    [sym_tuple] = STATE(797),
    [sym_dictionary] = STATE(797),
    [sym_list_comprehension] = STATE(797),
    [sym_dictionary_comprehension] = STATE(797),
    [sym_set_comprehension] = STATE(797),
    [sym_generator_expression] = STATE(797),
    [sym_parenthesized_expression] = STATE(797),
    [sym_conditional_expression] = STATE(1009),
    [sym_concatenated_string] = STATE(797),
    [sym_string] = STATE(713),
    [sym_await] = STATE(1009),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_STAR] = ACTIONS(15),
    [anon_sym_print] = ACTIONS(17),
    [anon_sym_assert] = ACTIONS(19),
    [anon_sym_return] = ACTIONS(21),
    [anon_sym_del] = ACTIONS(23),
    [anon_sym_raise] = ACTIONS(25),
    [anon_sym_pass] = ACTIONS(27),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_async] = ACTIONS(317),
    [anon_sym_match] = ACTIONS(317),
    [anon_sym_DASH] = ACTIONS(47),
    [anon_sym_PLUS] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(51),
    [anon_sym_STAR_STAR] = ACTIONS(53),
    [anon_sym_global] = ACTIONS(57),
    [anon_sym_nonlocal] = ACTIONS(59),
    [anon_sym_exec] = ACTIONS(61),
    [anon_sym_type] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(323),
    [sym__indent] = ACTIONS(325),
    [sym__string_start] = ACTIONS(81),
  },
  [74] = {
    [sym__simple_statements] = STATE(327),
    [sym_import_statement] = STATE(1248),
    [sym_future_import_statement] = STATE(1248),
    [sym_import_from_statement] = STATE(1248),
    [sym_print_statement] = STATE(1248),
    [sym_assert_statement] = STATE(1248),
    [sym_expression_statement] = STATE(1248),
    [sym_named_expression] = STATE(1009),
    [sym_return_statement] = STATE(1248),
    [sym_delete_statement] = STATE(1248),
    [sym_raise_statement] = STATE(1248),
    [sym_pass_statement] = STATE(1248),
    [sym_break_statement] = STATE(1248),
    [sym_continue_statement] = STATE(1248),
    [sym_list_splat] = STATE(1360),
    [sym_dictionary_splat] = STATE(1360),
    [sym_global_statement] = STATE(1248),
    [sym_nonlocal_statement] = STATE(1248),
    [sym_exec_statement] = STATE(1248),
    [sym_type_alias_statement] = STATE(1248),
    [sym_expression_list] = STATE(1361),
    [sym_pattern] = STATE(889),
    [sym_tuple_pattern] = STATE(875),
    [sym_list_pattern] = STATE(875),
    [sym_list_splat_pattern] = STATE(875),
    [sym_expression] = STATE(1019),
    [sym_primary_expression] = STATE(684),
    [sym_not_operator] = STATE(1009),
    [sym_boolean_operator] = STATE(1009),
    [sym_binary_operator] = STATE(797),
    [sym_unary_operator] = STATE(797),
    [sym_comparison_operator] = STATE(1009),
    [sym_lambda] = STATE(1009),
    [sym_assignment] = STATE(1361),
    [sym_augmented_assignment] = STATE(1361),
    [sym_pattern_list] = STATE(897),
    [sym_yield] = STATE(1361),
    [sym_attribute] = STATE(431),
    [sym_subscript] = STATE(431),
    [sym_call] = STATE(797),
    [sym_list] = STATE(797),
    [sym_set] = STATE(797),
    [sym_tuple] = STATE(797),
    [sym_dictionary] = STATE(797),
    [sym_list_comprehension] = STATE(797),
    [sym_dictionary_comprehension] = STATE(797),
    [sym_set_comprehension] = STATE(797),
    [sym_generator_expression] = STATE(797),
    [sym_parenthesized_expression] = STATE(797),
    [sym_conditional_expression] = STATE(1009),
    [sym_concatenated_string] = STATE(797),
    [sym_string] = STATE(713),
    [sym_await] = STATE(1009),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_STAR] = ACTIONS(15),
    [anon_sym_print] = ACTIONS(17),
    [anon_sym_assert] = ACTIONS(19),
    [anon_sym_return] = ACTIONS(21),
    [anon_sym_del] = ACTIONS(23),
    [anon_sym_raise] = ACTIONS(25),
    [anon_sym_pass] = ACTIONS(27),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_async] = ACTIONS(317),
    [anon_sym_match] = ACTIONS(317),
    [anon_sym_DASH] = ACTIONS(47),
    [anon_sym_PLUS] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(51),
    [anon_sym_STAR_STAR] = ACTIONS(53),
    [anon_sym_global] = ACTIONS(57),
    [anon_sym_nonlocal] = ACTIONS(59),
    [anon_sym_exec] = ACTIONS(61),
    [anon_sym_type] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(327),
    [sym__indent] = ACTIONS(329),
    [sym__string_start] = ACTIONS(81),
  },
  [75] = {
    [sym_chevron] = STATE(1150),
    [sym_named_expression] = STATE(1009),
    [sym_expression] = STATE(1043),
    [sym_primary_expression] = STATE(684),
    [sym_not_operator] = STATE(1009),
    [sym_boolean_operator] = STATE(1009),
    [sym_binary_operator] = STATE(797),
    [sym_unary_operator] = STATE(797),
    [sym_comparison_operator] = STATE(1009),
    [sym_lambda] = STATE(1009),
    [sym_attribute] = STATE(797),
    [sym_subscript] = STATE(797),
    [sym_call] = STATE(797),
    [sym_list] = STATE(797),
    [sym_set] = STATE(797),
    [sym_tuple] = STATE(797),
    [sym_dictionary] = STATE(797),
    [sym_list_comprehension] = STATE(797),
    [sym_dictionary_comprehension] = STATE(797),
    [sym_set_comprehension] = STATE(797),
    [sym_generator_expression] = STATE(797),
    [sym_parenthesized_expression] = STATE(797),
    [sym_conditional_expression] = STATE(1009),
    [sym_concatenated_string] = STATE(797),
    [sym_string] = STATE(713),
    [sym_await] = STATE(1009),
    [sym_identifier] = ACTIONS(331),
    [anon_sym_DOT] = ACTIONS(276),
    [anon_sym_LPAREN] = ACTIONS(303),
    [anon_sym_COMMA] = ACTIONS(280),
    [anon_sym_STAR] = ACTIONS(276),
    [anon_sym_print] = ACTIONS(333),
    [anon_sym_GT_GT] = ACTIONS(335),
    [anon_sym_COLON_EQ] = ACTIONS(287),
    [anon_sym_if] = ACTIONS(276),
    [anon_sym_COLON] = ACTIONS(289),
    [anon_sym_async] = ACTIONS(333),
    [anon_sym_in] = ACTIONS(276),
    [anon_sym_match] = ACTIONS(333),
    [anon_sym_PIPE] = ACTIONS(276),
    [anon_sym_DASH] = ACTIONS(276),
    [anon_sym_PLUS] = ACTIONS(276),
    [anon_sym_LBRACK] = ACTIONS(303),
    [anon_sym_LBRACE] = ACTIONS(51),
    [anon_sym_STAR_STAR] = ACTIONS(276),
    [anon_sym_EQ] = ACTIONS(289),
    [anon_sym_exec] = ACTIONS(333),
    [anon_sym_type] = ACTIONS(333),
    [anon_sym_AT] = ACTIONS(276),
    [anon_sym_not] = ACTIONS(276),
    [anon_sym_and] = ACTIONS(276),
    [anon_sym_or] = ACTIONS(276),
    [anon_sym_SLASH] = ACTIONS(276),
    [anon_sym_PERCENT] = ACTIONS(276),
    [anon_sym_SLASH_SLASH] = ACTIONS(276),
    [anon_sym_AMP] = ACTIONS(276),
    [anon_sym_CARET] = ACTIONS(276),
    [anon_sym_LT_LT] = ACTIONS(276),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(276),
    [anon_sym_LT_EQ] = ACTIONS(303),
    [anon_sym_EQ_EQ] = ACTIONS(303),
    [anon_sym_BANG_EQ] = ACTIONS(303),
    [anon_sym_GT_EQ] = ACTIONS(303),
    [anon_sym_GT] = ACTIONS(276),
    [anon_sym_LT_GT] = ACTIONS(303),
    [anon_sym_is] = ACTIONS(276),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_PLUS_EQ] = ACTIONS(307),
    [anon_sym_DASH_EQ] = ACTIONS(307),
    [anon_sym_STAR_EQ] = ACTIONS(307),
    [anon_sym_SLASH_EQ] = ACTIONS(307),
    [anon_sym_AT_EQ] = ACTIONS(307),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(307),
    [anon_sym_PERCENT_EQ] = ACTIONS(307),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(307),
    [anon_sym_GT_GT_EQ] = ACTIONS(307),
    [anon_sym_LT_LT_EQ] = ACTIONS(307),
    [anon_sym_AMP_EQ] = ACTIONS(307),
    [anon_sym_CARET_EQ] = ACTIONS(307),
    [anon_sym_PIPE_EQ] = ACTIONS(307),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(337),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(303),
    [sym__newline] = ACTIONS(303),
    [sym__string_start] = ACTIONS(81),
  },
  [76] = {
    [sym__simple_statements] = STATE(340),
    [sym_import_statement] = STATE(1261),
    [sym_future_import_statement] = STATE(1261),
    [sym_import_from_statement] = STATE(1261),
    [sym_print_statement] = STATE(1261),
    [sym_assert_statement] = STATE(1261),
    [sym_expression_statement] = STATE(1261),
    [sym_named_expression] = STATE(1009),
    [sym_return_statement] = STATE(1261),
    [sym_delete_statement] = STATE(1261),
    [sym_raise_statement] = STATE(1261),
    [sym_pass_statement] = STATE(1261),
    [sym_break_statement] = STATE(1261),
    [sym_continue_statement] = STATE(1261),
    [sym_list_splat] = STATE(1360),
    [sym_dictionary_splat] = STATE(1360),
    [sym_global_statement] = STATE(1261),
    [sym_nonlocal_statement] = STATE(1261),
    [sym_exec_statement] = STATE(1261),
    [sym_type_alias_statement] = STATE(1261),
    [sym_expression_list] = STATE(1361),
    [sym_pattern] = STATE(889),
    [sym_tuple_pattern] = STATE(875),
    [sym_list_pattern] = STATE(875),
    [sym_list_splat_pattern] = STATE(875),
    [sym_expression] = STATE(1019),
    [sym_primary_expression] = STATE(684),
    [sym_not_operator] = STATE(1009),
    [sym_boolean_operator] = STATE(1009),
    [sym_binary_operator] = STATE(797),
    [sym_unary_operator] = STATE(797),
    [sym_comparison_operator] = STATE(1009),
    [sym_lambda] = STATE(1009),
    [sym_assignment] = STATE(1361),
    [sym_augmented_assignment] = STATE(1361),
    [sym_pattern_list] = STATE(897),
    [sym_yield] = STATE(1361),
    [sym_attribute] = STATE(431),
    [sym_subscript] = STATE(431),
    [sym_call] = STATE(797),
    [sym_list] = STATE(797),
    [sym_set] = STATE(797),
    [sym_tuple] = STATE(797),
    [sym_dictionary] = STATE(797),
    [sym_list_comprehension] = STATE(797),
    [sym_dictionary_comprehension] = STATE(797),
    [sym_set_comprehension] = STATE(797),
    [sym_generator_expression] = STATE(797),
    [sym_parenthesized_expression] = STATE(797),
    [sym_conditional_expression] = STATE(1009),
    [sym_concatenated_string] = STATE(797),
    [sym_string] = STATE(713),
    [sym_await] = STATE(1009),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_STAR] = ACTIONS(15),
    [anon_sym_print] = ACTIONS(17),
    [anon_sym_assert] = ACTIONS(19),
    [anon_sym_return] = ACTIONS(21),
    [anon_sym_del] = ACTIONS(23),
    [anon_sym_raise] = ACTIONS(25),
    [anon_sym_pass] = ACTIONS(27),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_async] = ACTIONS(317),
    [anon_sym_match] = ACTIONS(317),
    [anon_sym_DASH] = ACTIONS(47),
    [anon_sym_PLUS] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(51),
    [anon_sym_STAR_STAR] = ACTIONS(53),
    [anon_sym_global] = ACTIONS(57),
    [anon_sym_nonlocal] = ACTIONS(59),
    [anon_sym_exec] = ACTIONS(61),
    [anon_sym_type] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(339),
    [sym__indent] = ACTIONS(341),
    [sym__string_start] = ACTIONS(81),
  },
  [77] = {
    [sym__simple_statements] = STATE(530),
    [sym_import_statement] = STATE(1319),
    [sym_future_import_statement] = STATE(1319),
    [sym_import_from_statement] = STATE(1319),
    [sym_print_statement] = STATE(1319),
    [sym_assert_statement] = STATE(1319),
    [sym_expression_statement] = STATE(1319),
    [sym_named_expression] = STATE(1009),
    [sym_return_statement] = STATE(1319),
    [sym_delete_statement] = STATE(1319),
    [sym_raise_statement] = STATE(1319),
    [sym_pass_statement] = STATE(1319),
    [sym_break_statement] = STATE(1319),
    [sym_continue_statement] = STATE(1319),
    [sym_list_splat] = STATE(1360),
    [sym_dictionary_splat] = STATE(1360),
    [sym_global_statement] = STATE(1319),
    [sym_nonlocal_statement] = STATE(1319),
    [sym_exec_statement] = STATE(1319),
    [sym_type_alias_statement] = STATE(1319),
    [sym_expression_list] = STATE(1361),
    [sym_pattern] = STATE(889),
    [sym_tuple_pattern] = STATE(875),
    [sym_list_pattern] = STATE(875),
    [sym_list_splat_pattern] = STATE(875),
    [sym_expression] = STATE(1019),
    [sym_primary_expression] = STATE(684),
    [sym_not_operator] = STATE(1009),
    [sym_boolean_operator] = STATE(1009),
    [sym_binary_operator] = STATE(797),
    [sym_unary_operator] = STATE(797),
    [sym_comparison_operator] = STATE(1009),
    [sym_lambda] = STATE(1009),
    [sym_assignment] = STATE(1361),
    [sym_augmented_assignment] = STATE(1361),
    [sym_pattern_list] = STATE(897),
    [sym_yield] = STATE(1361),
    [sym_attribute] = STATE(431),
    [sym_subscript] = STATE(431),
    [sym_call] = STATE(797),
    [sym_list] = STATE(797),
    [sym_set] = STATE(797),
    [sym_tuple] = STATE(797),
    [sym_dictionary] = STATE(797),
    [sym_list_comprehension] = STATE(797),
    [sym_dictionary_comprehension] = STATE(797),
    [sym_set_comprehension] = STATE(797),
    [sym_generator_expression] = STATE(797),
    [sym_parenthesized_expression] = STATE(797),
    [sym_conditional_expression] = STATE(1009),
    [sym_concatenated_string] = STATE(797),
    [sym_string] = STATE(713),
    [sym_await] = STATE(1009),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_STAR] = ACTIONS(15),
    [anon_sym_print] = ACTIONS(17),
    [anon_sym_assert] = ACTIONS(19),
    [anon_sym_return] = ACTIONS(21),
    [anon_sym_del] = ACTIONS(23),
    [anon_sym_raise] = ACTIONS(25),
    [anon_sym_pass] = ACTIONS(27),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_async] = ACTIONS(317),
    [anon_sym_match] = ACTIONS(317),
    [anon_sym_DASH] = ACTIONS(47),
    [anon_sym_PLUS] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(51),
    [anon_sym_STAR_STAR] = ACTIONS(53),
    [anon_sym_global] = ACTIONS(57),
    [anon_sym_nonlocal] = ACTIONS(59),
    [anon_sym_exec] = ACTIONS(61),
    [anon_sym_type] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(343),
    [sym__indent] = ACTIONS(345),
    [sym__string_start] = ACTIONS(81),
  },
  [78] = {
    [sym__simple_statements] = STATE(521),
    [sym_import_statement] = STATE(1209),
    [sym_future_import_statement] = STATE(1209),
    [sym_import_from_statement] = STATE(1209),
    [sym_print_statement] = STATE(1209),
    [sym_assert_statement] = STATE(1209),
    [sym_expression_statement] = STATE(1209),
    [sym_named_expression] = STATE(1009),
    [sym_return_statement] = STATE(1209),
    [sym_delete_statement] = STATE(1209),
    [sym_raise_statement] = STATE(1209),
    [sym_pass_statement] = STATE(1209),
    [sym_break_statement] = STATE(1209),
    [sym_continue_statement] = STATE(1209),
    [sym_list_splat] = STATE(1360),
    [sym_dictionary_splat] = STATE(1360),
    [sym_global_statement] = STATE(1209),
    [sym_nonlocal_statement] = STATE(1209),
    [sym_exec_statement] = STATE(1209),
    [sym_type_alias_statement] = STATE(1209),
    [sym_expression_list] = STATE(1361),
    [sym_pattern] = STATE(889),
    [sym_tuple_pattern] = STATE(875),
    [sym_list_pattern] = STATE(875),
    [sym_list_splat_pattern] = STATE(875),
    [sym_expression] = STATE(1019),
    [sym_primary_expression] = STATE(684),
    [sym_not_operator] = STATE(1009),
    [sym_boolean_operator] = STATE(1009),
    [sym_binary_operator] = STATE(797),
    [sym_unary_operator] = STATE(797),
    [sym_comparison_operator] = STATE(1009),
    [sym_lambda] = STATE(1009),
    [sym_assignment] = STATE(1361),
    [sym_augmented_assignment] = STATE(1361),
    [sym_pattern_list] = STATE(897),
    [sym_yield] = STATE(1361),
    [sym_attribute] = STATE(431),
    [sym_subscript] = STATE(431),
    [sym_call] = STATE(797),
    [sym_list] = STATE(797),
    [sym_set] = STATE(797),
    [sym_tuple] = STATE(797),
    [sym_dictionary] = STATE(797),
    [sym_list_comprehension] = STATE(797),
    [sym_dictionary_comprehension] = STATE(797),
    [sym_set_comprehension] = STATE(797),
    [sym_generator_expression] = STATE(797),
    [sym_parenthesized_expression] = STATE(797),
    [sym_conditional_expression] = STATE(1009),
    [sym_concatenated_string] = STATE(797),
    [sym_string] = STATE(713),
    [sym_await] = STATE(1009),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_STAR] = ACTIONS(15),
    [anon_sym_print] = ACTIONS(17),
    [anon_sym_assert] = ACTIONS(19),
    [anon_sym_return] = ACTIONS(21),
    [anon_sym_del] = ACTIONS(23),
    [anon_sym_raise] = ACTIONS(25),
    [anon_sym_pass] = ACTIONS(27),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_async] = ACTIONS(317),
    [anon_sym_match] = ACTIONS(317),
    [anon_sym_DASH] = ACTIONS(47),
    [anon_sym_PLUS] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(51),
    [anon_sym_STAR_STAR] = ACTIONS(53),
    [anon_sym_global] = ACTIONS(57),
    [anon_sym_nonlocal] = ACTIONS(59),
    [anon_sym_exec] = ACTIONS(61),
    [anon_sym_type] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(347),
    [sym__indent] = ACTIONS(349),
    [sym__string_start] = ACTIONS(81),
  },
  [79] = {
    [sym__simple_statements] = STATE(548),
    [sym_import_statement] = STATE(1319),
    [sym_future_import_statement] = STATE(1319),
    [sym_import_from_statement] = STATE(1319),
    [sym_print_statement] = STATE(1319),
    [sym_assert_statement] = STATE(1319),
    [sym_expression_statement] = STATE(1319),
    [sym_named_expression] = STATE(1009),
    [sym_return_statement] = STATE(1319),
    [sym_delete_statement] = STATE(1319),
    [sym_raise_statement] = STATE(1319),
    [sym_pass_statement] = STATE(1319),
    [sym_break_statement] = STATE(1319),
    [sym_continue_statement] = STATE(1319),
    [sym_list_splat] = STATE(1360),
    [sym_dictionary_splat] = STATE(1360),
    [sym_global_statement] = STATE(1319),
    [sym_nonlocal_statement] = STATE(1319),
    [sym_exec_statement] = STATE(1319),
    [sym_type_alias_statement] = STATE(1319),
    [sym_expression_list] = STATE(1361),
    [sym_pattern] = STATE(889),
    [sym_tuple_pattern] = STATE(875),
    [sym_list_pattern] = STATE(875),
    [sym_list_splat_pattern] = STATE(875),
    [sym_expression] = STATE(1019),
    [sym_primary_expression] = STATE(684),
    [sym_not_operator] = STATE(1009),
    [sym_boolean_operator] = STATE(1009),
    [sym_binary_operator] = STATE(797),
    [sym_unary_operator] = STATE(797),
    [sym_comparison_operator] = STATE(1009),
    [sym_lambda] = STATE(1009),
    [sym_assignment] = STATE(1361),
    [sym_augmented_assignment] = STATE(1361),
    [sym_pattern_list] = STATE(897),
    [sym_yield] = STATE(1361),
    [sym_attribute] = STATE(431),
    [sym_subscript] = STATE(431),
    [sym_call] = STATE(797),
    [sym_list] = STATE(797),
    [sym_set] = STATE(797),
    [sym_tuple] = STATE(797),
    [sym_dictionary] = STATE(797),
    [sym_list_comprehension] = STATE(797),
    [sym_dictionary_comprehension] = STATE(797),
    [sym_set_comprehension] = STATE(797),
    [sym_generator_expression] = STATE(797),
    [sym_parenthesized_expression] = STATE(797),
    [sym_conditional_expression] = STATE(1009),
    [sym_concatenated_string] = STATE(797),
    [sym_string] = STATE(713),
    [sym_await] = STATE(1009),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_STAR] = ACTIONS(15),
    [anon_sym_print] = ACTIONS(17),
    [anon_sym_assert] = ACTIONS(19),
    [anon_sym_return] = ACTIONS(21),
    [anon_sym_del] = ACTIONS(23),
    [anon_sym_raise] = ACTIONS(25),
    [anon_sym_pass] = ACTIONS(27),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_async] = ACTIONS(317),
    [anon_sym_match] = ACTIONS(317),
    [anon_sym_DASH] = ACTIONS(47),
    [anon_sym_PLUS] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(51),
    [anon_sym_STAR_STAR] = ACTIONS(53),
    [anon_sym_global] = ACTIONS(57),
    [anon_sym_nonlocal] = ACTIONS(59),
    [anon_sym_exec] = ACTIONS(61),
    [anon_sym_type] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(351),
    [sym__indent] = ACTIONS(353),
    [sym__string_start] = ACTIONS(81),
  },
  [80] = {
    [sym__simple_statements] = STATE(325),
    [sym_import_statement] = STATE(1261),
    [sym_future_import_statement] = STATE(1261),
    [sym_import_from_statement] = STATE(1261),
    [sym_print_statement] = STATE(1261),
    [sym_assert_statement] = STATE(1261),
    [sym_expression_statement] = STATE(1261),
    [sym_named_expression] = STATE(1009),
    [sym_return_statement] = STATE(1261),
    [sym_delete_statement] = STATE(1261),
    [sym_raise_statement] = STATE(1261),
    [sym_pass_statement] = STATE(1261),
    [sym_break_statement] = STATE(1261),
    [sym_continue_statement] = STATE(1261),
    [sym_list_splat] = STATE(1360),
    [sym_dictionary_splat] = STATE(1360),
    [sym_global_statement] = STATE(1261),
    [sym_nonlocal_statement] = STATE(1261),
    [sym_exec_statement] = STATE(1261),
    [sym_type_alias_statement] = STATE(1261),
    [sym_expression_list] = STATE(1361),
    [sym_pattern] = STATE(889),
    [sym_tuple_pattern] = STATE(875),
    [sym_list_pattern] = STATE(875),
    [sym_list_splat_pattern] = STATE(875),
    [sym_expression] = STATE(1019),
    [sym_primary_expression] = STATE(684),
    [sym_not_operator] = STATE(1009),
    [sym_boolean_operator] = STATE(1009),
    [sym_binary_operator] = STATE(797),
    [sym_unary_operator] = STATE(797),
    [sym_comparison_operator] = STATE(1009),
    [sym_lambda] = STATE(1009),
    [sym_assignment] = STATE(1361),
    [sym_augmented_assignment] = STATE(1361),
    [sym_pattern_list] = STATE(897),
    [sym_yield] = STATE(1361),
    [sym_attribute] = STATE(431),
    [sym_subscript] = STATE(431),
    [sym_call] = STATE(797),
    [sym_list] = STATE(797),
    [sym_set] = STATE(797),
    [sym_tuple] = STATE(797),
    [sym_dictionary] = STATE(797),
    [sym_list_comprehension] = STATE(797),
    [sym_dictionary_comprehension] = STATE(797),
    [sym_set_comprehension] = STATE(797),
    [sym_generator_expression] = STATE(797),
    [sym_parenthesized_expression] = STATE(797),
    [sym_conditional_expression] = STATE(1009),
    [sym_concatenated_string] = STATE(797),
    [sym_string] = STATE(713),
    [sym_await] = STATE(1009),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_STAR] = ACTIONS(15),
    [anon_sym_print] = ACTIONS(17),
    [anon_sym_assert] = ACTIONS(19),
    [anon_sym_return] = ACTIONS(21),
    [anon_sym_del] = ACTIONS(23),
    [anon_sym_raise] = ACTIONS(25),
    [anon_sym_pass] = ACTIONS(27),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_async] = ACTIONS(317),
    [anon_sym_match] = ACTIONS(317),
    [anon_sym_DASH] = ACTIONS(47),
    [anon_sym_PLUS] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(51),
    [anon_sym_STAR_STAR] = ACTIONS(53),
    [anon_sym_global] = ACTIONS(57),
    [anon_sym_nonlocal] = ACTIONS(59),
    [anon_sym_exec] = ACTIONS(61),
    [anon_sym_type] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(355),
    [sym__indent] = ACTIONS(357),
    [sym__string_start] = ACTIONS(81),
  },
  [81] = {
    [sym__simple_statements] = STATE(535),
    [sym_import_statement] = STATE(1209),
    [sym_future_import_statement] = STATE(1209),
    [sym_import_from_statement] = STATE(1209),
    [sym_print_statement] = STATE(1209),
    [sym_assert_statement] = STATE(1209),
    [sym_expression_statement] = STATE(1209),
    [sym_named_expression] = STATE(1009),
    [sym_return_statement] = STATE(1209),
    [sym_delete_statement] = STATE(1209),
    [sym_raise_statement] = STATE(1209),
    [sym_pass_statement] = STATE(1209),
    [sym_break_statement] = STATE(1209),
    [sym_continue_statement] = STATE(1209),
    [sym_list_splat] = STATE(1360),
    [sym_dictionary_splat] = STATE(1360),
    [sym_global_statement] = STATE(1209),
    [sym_nonlocal_statement] = STATE(1209),
    [sym_exec_statement] = STATE(1209),
    [sym_type_alias_statement] = STATE(1209),
    [sym_expression_list] = STATE(1361),
    [sym_pattern] = STATE(889),
    [sym_tuple_pattern] = STATE(875),
    [sym_list_pattern] = STATE(875),
    [sym_list_splat_pattern] = STATE(875),
    [sym_expression] = STATE(1019),
    [sym_primary_expression] = STATE(684),
    [sym_not_operator] = STATE(1009),
    [sym_boolean_operator] = STATE(1009),
    [sym_binary_operator] = STATE(797),
    [sym_unary_operator] = STATE(797),
    [sym_comparison_operator] = STATE(1009),
    [sym_lambda] = STATE(1009),
    [sym_assignment] = STATE(1361),
    [sym_augmented_assignment] = STATE(1361),
    [sym_pattern_list] = STATE(897),
    [sym_yield] = STATE(1361),
    [sym_attribute] = STATE(431),
    [sym_subscript] = STATE(431),
    [sym_call] = STATE(797),
    [sym_list] = STATE(797),
    [sym_set] = STATE(797),
    [sym_tuple] = STATE(797),
    [sym_dictionary] = STATE(797),
    [sym_list_comprehension] = STATE(797),
    [sym_dictionary_comprehension] = STATE(797),
    [sym_set_comprehension] = STATE(797),
    [sym_generator_expression] = STATE(797),
    [sym_parenthesized_expression] = STATE(797),
    [sym_conditional_expression] = STATE(1009),
    [sym_concatenated_string] = STATE(797),
    [sym_string] = STATE(713),
    [sym_await] = STATE(1009),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_STAR] = ACTIONS(15),
    [anon_sym_print] = ACTIONS(17),
    [anon_sym_assert] = ACTIONS(19),
    [anon_sym_return] = ACTIONS(21),
    [anon_sym_del] = ACTIONS(23),
    [anon_sym_raise] = ACTIONS(25),
    [anon_sym_pass] = ACTIONS(27),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_async] = ACTIONS(317),
    [anon_sym_match] = ACTIONS(317),
    [anon_sym_DASH] = ACTIONS(47),
    [anon_sym_PLUS] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(51),
    [anon_sym_STAR_STAR] = ACTIONS(53),
    [anon_sym_global] = ACTIONS(57),
    [anon_sym_nonlocal] = ACTIONS(59),
    [anon_sym_exec] = ACTIONS(61),
    [anon_sym_type] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(359),
    [sym__indent] = ACTIONS(361),
    [sym__string_start] = ACTIONS(81),
  },
  [82] = {
    [sym__simple_statements] = STATE(508),
    [sym_import_statement] = STATE(1319),
    [sym_future_import_statement] = STATE(1319),
    [sym_import_from_statement] = STATE(1319),
    [sym_print_statement] = STATE(1319),
    [sym_assert_statement] = STATE(1319),
    [sym_expression_statement] = STATE(1319),
    [sym_named_expression] = STATE(1009),
    [sym_return_statement] = STATE(1319),
    [sym_delete_statement] = STATE(1319),
    [sym_raise_statement] = STATE(1319),
    [sym_pass_statement] = STATE(1319),
    [sym_break_statement] = STATE(1319),
    [sym_continue_statement] = STATE(1319),
    [sym_list_splat] = STATE(1360),
    [sym_dictionary_splat] = STATE(1360),
    [sym_global_statement] = STATE(1319),
    [sym_nonlocal_statement] = STATE(1319),
    [sym_exec_statement] = STATE(1319),
    [sym_type_alias_statement] = STATE(1319),
    [sym_expression_list] = STATE(1361),
    [sym_pattern] = STATE(889),
    [sym_tuple_pattern] = STATE(875),
    [sym_list_pattern] = STATE(875),
    [sym_list_splat_pattern] = STATE(875),
    [sym_expression] = STATE(1019),
    [sym_primary_expression] = STATE(684),
    [sym_not_operator] = STATE(1009),
    [sym_boolean_operator] = STATE(1009),
    [sym_binary_operator] = STATE(797),
    [sym_unary_operator] = STATE(797),
    [sym_comparison_operator] = STATE(1009),
    [sym_lambda] = STATE(1009),
    [sym_assignment] = STATE(1361),
    [sym_augmented_assignment] = STATE(1361),
    [sym_pattern_list] = STATE(897),
    [sym_yield] = STATE(1361),
    [sym_attribute] = STATE(431),
    [sym_subscript] = STATE(431),
    [sym_call] = STATE(797),
    [sym_list] = STATE(797),
    [sym_set] = STATE(797),
    [sym_tuple] = STATE(797),
    [sym_dictionary] = STATE(797),
    [sym_list_comprehension] = STATE(797),
    [sym_dictionary_comprehension] = STATE(797),
    [sym_set_comprehension] = STATE(797),
    [sym_generator_expression] = STATE(797),
    [sym_parenthesized_expression] = STATE(797),
    [sym_conditional_expression] = STATE(1009),
    [sym_concatenated_string] = STATE(797),
    [sym_string] = STATE(713),
    [sym_await] = STATE(1009),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_STAR] = ACTIONS(15),
    [anon_sym_print] = ACTIONS(17),
    [anon_sym_assert] = ACTIONS(19),
    [anon_sym_return] = ACTIONS(21),
    [anon_sym_del] = ACTIONS(23),
    [anon_sym_raise] = ACTIONS(25),
    [anon_sym_pass] = ACTIONS(27),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_async] = ACTIONS(317),
    [anon_sym_match] = ACTIONS(317),
    [anon_sym_DASH] = ACTIONS(47),
    [anon_sym_PLUS] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(51),
    [anon_sym_STAR_STAR] = ACTIONS(53),
    [anon_sym_global] = ACTIONS(57),
    [anon_sym_nonlocal] = ACTIONS(59),
    [anon_sym_exec] = ACTIONS(61),
    [anon_sym_type] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(363),
    [sym__indent] = ACTIONS(365),
    [sym__string_start] = ACTIONS(81),
  },
  [83] = {
    [sym__simple_statements] = STATE(377),
    [sym_import_statement] = STATE(1244),
    [sym_future_import_statement] = STATE(1244),
    [sym_import_from_statement] = STATE(1244),
    [sym_print_statement] = STATE(1244),
    [sym_assert_statement] = STATE(1244),
    [sym_expression_statement] = STATE(1244),
    [sym_named_expression] = STATE(1009),
    [sym_return_statement] = STATE(1244),
    [sym_delete_statement] = STATE(1244),
    [sym_raise_statement] = STATE(1244),
    [sym_pass_statement] = STATE(1244),
    [sym_break_statement] = STATE(1244),
    [sym_continue_statement] = STATE(1244),
    [sym_list_splat] = STATE(1360),
    [sym_dictionary_splat] = STATE(1360),
    [sym_global_statement] = STATE(1244),
    [sym_nonlocal_statement] = STATE(1244),
    [sym_exec_statement] = STATE(1244),
    [sym_type_alias_statement] = STATE(1244),
    [sym_expression_list] = STATE(1361),
    [sym_pattern] = STATE(889),
    [sym_tuple_pattern] = STATE(875),
    [sym_list_pattern] = STATE(875),
    [sym_list_splat_pattern] = STATE(875),
    [sym_expression] = STATE(1019),
    [sym_primary_expression] = STATE(684),
    [sym_not_operator] = STATE(1009),
    [sym_boolean_operator] = STATE(1009),
    [sym_binary_operator] = STATE(797),
    [sym_unary_operator] = STATE(797),
    [sym_comparison_operator] = STATE(1009),
    [sym_lambda] = STATE(1009),
    [sym_assignment] = STATE(1361),
    [sym_augmented_assignment] = STATE(1361),
    [sym_pattern_list] = STATE(897),
    [sym_yield] = STATE(1361),
    [sym_attribute] = STATE(431),
    [sym_subscript] = STATE(431),
    [sym_call] = STATE(797),
    [sym_list] = STATE(797),
    [sym_set] = STATE(797),
    [sym_tuple] = STATE(797),
    [sym_dictionary] = STATE(797),
    [sym_list_comprehension] = STATE(797),
    [sym_dictionary_comprehension] = STATE(797),
    [sym_set_comprehension] = STATE(797),
    [sym_generator_expression] = STATE(797),
    [sym_parenthesized_expression] = STATE(797),
    [sym_conditional_expression] = STATE(1009),
    [sym_concatenated_string] = STATE(797),
    [sym_string] = STATE(713),
    [sym_await] = STATE(1009),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_STAR] = ACTIONS(15),
    [anon_sym_print] = ACTIONS(17),
    [anon_sym_assert] = ACTIONS(19),
    [anon_sym_return] = ACTIONS(21),
    [anon_sym_del] = ACTIONS(23),
    [anon_sym_raise] = ACTIONS(25),
    [anon_sym_pass] = ACTIONS(27),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_async] = ACTIONS(317),
    [anon_sym_match] = ACTIONS(317),
    [anon_sym_DASH] = ACTIONS(47),
    [anon_sym_PLUS] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(51),
    [anon_sym_STAR_STAR] = ACTIONS(53),
    [anon_sym_global] = ACTIONS(57),
    [anon_sym_nonlocal] = ACTIONS(59),
    [anon_sym_exec] = ACTIONS(61),
    [anon_sym_type] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(367),
    [sym__indent] = ACTIONS(369),
    [sym__string_start] = ACTIONS(81),
  },
  [84] = {
    [sym__simple_statements] = STATE(524),
    [sym_import_statement] = STATE(1209),
    [sym_future_import_statement] = STATE(1209),
    [sym_import_from_statement] = STATE(1209),
    [sym_print_statement] = STATE(1209),
    [sym_assert_statement] = STATE(1209),
    [sym_expression_statement] = STATE(1209),
    [sym_named_expression] = STATE(1009),
    [sym_return_statement] = STATE(1209),
    [sym_delete_statement] = STATE(1209),
    [sym_raise_statement] = STATE(1209),
    [sym_pass_statement] = STATE(1209),
    [sym_break_statement] = STATE(1209),
    [sym_continue_statement] = STATE(1209),
    [sym_list_splat] = STATE(1360),
    [sym_dictionary_splat] = STATE(1360),
    [sym_global_statement] = STATE(1209),
    [sym_nonlocal_statement] = STATE(1209),
    [sym_exec_statement] = STATE(1209),
    [sym_type_alias_statement] = STATE(1209),
    [sym_expression_list] = STATE(1361),
    [sym_pattern] = STATE(889),
    [sym_tuple_pattern] = STATE(875),
    [sym_list_pattern] = STATE(875),
    [sym_list_splat_pattern] = STATE(875),
    [sym_expression] = STATE(1019),
    [sym_primary_expression] = STATE(684),
    [sym_not_operator] = STATE(1009),
    [sym_boolean_operator] = STATE(1009),
    [sym_binary_operator] = STATE(797),
    [sym_unary_operator] = STATE(797),
    [sym_comparison_operator] = STATE(1009),
    [sym_lambda] = STATE(1009),
    [sym_assignment] = STATE(1361),
    [sym_augmented_assignment] = STATE(1361),
    [sym_pattern_list] = STATE(897),
    [sym_yield] = STATE(1361),
    [sym_attribute] = STATE(431),
    [sym_subscript] = STATE(431),
    [sym_call] = STATE(797),
    [sym_list] = STATE(797),
    [sym_set] = STATE(797),
    [sym_tuple] = STATE(797),
    [sym_dictionary] = STATE(797),
    [sym_list_comprehension] = STATE(797),
    [sym_dictionary_comprehension] = STATE(797),
    [sym_set_comprehension] = STATE(797),
    [sym_generator_expression] = STATE(797),
    [sym_parenthesized_expression] = STATE(797),
    [sym_conditional_expression] = STATE(1009),
    [sym_concatenated_string] = STATE(797),
    [sym_string] = STATE(713),
    [sym_await] = STATE(1009),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_STAR] = ACTIONS(15),
    [anon_sym_print] = ACTIONS(17),
    [anon_sym_assert] = ACTIONS(19),
    [anon_sym_return] = ACTIONS(21),
    [anon_sym_del] = ACTIONS(23),
    [anon_sym_raise] = ACTIONS(25),
    [anon_sym_pass] = ACTIONS(27),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_async] = ACTIONS(317),
    [anon_sym_match] = ACTIONS(317),
    [anon_sym_DASH] = ACTIONS(47),
    [anon_sym_PLUS] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(51),
    [anon_sym_STAR_STAR] = ACTIONS(53),
    [anon_sym_global] = ACTIONS(57),
    [anon_sym_nonlocal] = ACTIONS(59),
    [anon_sym_exec] = ACTIONS(61),
    [anon_sym_type] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(371),
    [sym__indent] = ACTIONS(373),
    [sym__string_start] = ACTIONS(81),
  },
  [85] = {
    [sym__simple_statements] = STATE(316),
    [sym_import_statement] = STATE(1238),
    [sym_future_import_statement] = STATE(1238),
    [sym_import_from_statement] = STATE(1238),
    [sym_print_statement] = STATE(1238),
    [sym_assert_statement] = STATE(1238),
    [sym_expression_statement] = STATE(1238),
    [sym_named_expression] = STATE(1009),
    [sym_return_statement] = STATE(1238),
    [sym_delete_statement] = STATE(1238),
    [sym_raise_statement] = STATE(1238),
    [sym_pass_statement] = STATE(1238),
    [sym_break_statement] = STATE(1238),
    [sym_continue_statement] = STATE(1238),
    [sym_list_splat] = STATE(1360),
    [sym_dictionary_splat] = STATE(1360),
    [sym_global_statement] = STATE(1238),
    [sym_nonlocal_statement] = STATE(1238),
    [sym_exec_statement] = STATE(1238),
    [sym_type_alias_statement] = STATE(1238),
    [sym_expression_list] = STATE(1361),
    [sym_pattern] = STATE(889),
    [sym_tuple_pattern] = STATE(875),
    [sym_list_pattern] = STATE(875),
    [sym_list_splat_pattern] = STATE(875),
    [sym_expression] = STATE(1019),
    [sym_primary_expression] = STATE(684),
    [sym_not_operator] = STATE(1009),
    [sym_boolean_operator] = STATE(1009),
    [sym_binary_operator] = STATE(797),
    [sym_unary_operator] = STATE(797),
    [sym_comparison_operator] = STATE(1009),
    [sym_lambda] = STATE(1009),
    [sym_assignment] = STATE(1361),
    [sym_augmented_assignment] = STATE(1361),
    [sym_pattern_list] = STATE(897),
    [sym_yield] = STATE(1361),
    [sym_attribute] = STATE(431),
    [sym_subscript] = STATE(431),
    [sym_call] = STATE(797),
    [sym_list] = STATE(797),
    [sym_set] = STATE(797),
    [sym_tuple] = STATE(797),
    [sym_dictionary] = STATE(797),
    [sym_list_comprehension] = STATE(797),
    [sym_dictionary_comprehension] = STATE(797),
    [sym_set_comprehension] = STATE(797),
    [sym_generator_expression] = STATE(797),
    [sym_parenthesized_expression] = STATE(797),
    [sym_conditional_expression] = STATE(1009),
    [sym_concatenated_string] = STATE(797),
    [sym_string] = STATE(713),
    [sym_await] = STATE(1009),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_STAR] = ACTIONS(15),
    [anon_sym_print] = ACTIONS(17),
    [anon_sym_assert] = ACTIONS(19),
    [anon_sym_return] = ACTIONS(21),
    [anon_sym_del] = ACTIONS(23),
    [anon_sym_raise] = ACTIONS(25),
    [anon_sym_pass] = ACTIONS(27),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_async] = ACTIONS(317),
    [anon_sym_match] = ACTIONS(317),
    [anon_sym_DASH] = ACTIONS(47),
    [anon_sym_PLUS] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(51),
    [anon_sym_STAR_STAR] = ACTIONS(53),
    [anon_sym_global] = ACTIONS(57),
    [anon_sym_nonlocal] = ACTIONS(59),
    [anon_sym_exec] = ACTIONS(61),
    [anon_sym_type] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(375),
    [sym__indent] = ACTIONS(377),
    [sym__string_start] = ACTIONS(81),
  },
  [86] = {
    [sym__simple_statements] = STATE(532),
    [sym_import_statement] = STATE(1209),
    [sym_future_import_statement] = STATE(1209),
    [sym_import_from_statement] = STATE(1209),
    [sym_print_statement] = STATE(1209),
    [sym_assert_statement] = STATE(1209),
    [sym_expression_statement] = STATE(1209),
    [sym_named_expression] = STATE(1009),
    [sym_return_statement] = STATE(1209),
    [sym_delete_statement] = STATE(1209),
    [sym_raise_statement] = STATE(1209),
    [sym_pass_statement] = STATE(1209),
    [sym_break_statement] = STATE(1209),
    [sym_continue_statement] = STATE(1209),
    [sym_list_splat] = STATE(1360),
    [sym_dictionary_splat] = STATE(1360),
    [sym_global_statement] = STATE(1209),
    [sym_nonlocal_statement] = STATE(1209),
    [sym_exec_statement] = STATE(1209),
    [sym_type_alias_statement] = STATE(1209),
    [sym_expression_list] = STATE(1361),
    [sym_pattern] = STATE(889),
    [sym_tuple_pattern] = STATE(875),
    [sym_list_pattern] = STATE(875),
    [sym_list_splat_pattern] = STATE(875),
    [sym_expression] = STATE(1019),
    [sym_primary_expression] = STATE(684),
    [sym_not_operator] = STATE(1009),
    [sym_boolean_operator] = STATE(1009),
    [sym_binary_operator] = STATE(797),
    [sym_unary_operator] = STATE(797),
    [sym_comparison_operator] = STATE(1009),
    [sym_lambda] = STATE(1009),
    [sym_assignment] = STATE(1361),
    [sym_augmented_assignment] = STATE(1361),
    [sym_pattern_list] = STATE(897),
    [sym_yield] = STATE(1361),
    [sym_attribute] = STATE(431),
    [sym_subscript] = STATE(431),
    [sym_call] = STATE(797),
    [sym_list] = STATE(797),
    [sym_set] = STATE(797),
    [sym_tuple] = STATE(797),
    [sym_dictionary] = STATE(797),
    [sym_list_comprehension] = STATE(797),
    [sym_dictionary_comprehension] = STATE(797),
    [sym_set_comprehension] = STATE(797),
    [sym_generator_expression] = STATE(797),
    [sym_parenthesized_expression] = STATE(797),
    [sym_conditional_expression] = STATE(1009),
    [sym_concatenated_string] = STATE(797),
    [sym_string] = STATE(713),
    [sym_await] = STATE(1009),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_STAR] = ACTIONS(15),
    [anon_sym_print] = ACTIONS(17),
    [anon_sym_assert] = ACTIONS(19),
    [anon_sym_return] = ACTIONS(21),
    [anon_sym_del] = ACTIONS(23),
    [anon_sym_raise] = ACTIONS(25),
    [anon_sym_pass] = ACTIONS(27),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_async] = ACTIONS(317),
    [anon_sym_match] = ACTIONS(317),
    [anon_sym_DASH] = ACTIONS(47),
    [anon_sym_PLUS] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(51),
    [anon_sym_STAR_STAR] = ACTIONS(53),
    [anon_sym_global] = ACTIONS(57),
    [anon_sym_nonlocal] = ACTIONS(59),
    [anon_sym_exec] = ACTIONS(61),
    [anon_sym_type] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(379),
    [sym__indent] = ACTIONS(381),
    [sym__string_start] = ACTIONS(81),
  },
  [87] = {
    [sym__simple_statements] = STATE(547),
    [sym_import_statement] = STATE(1209),
    [sym_future_import_statement] = STATE(1209),
    [sym_import_from_statement] = STATE(1209),
    [sym_print_statement] = STATE(1209),
    [sym_assert_statement] = STATE(1209),
    [sym_expression_statement] = STATE(1209),
    [sym_named_expression] = STATE(1009),
    [sym_return_statement] = STATE(1209),
    [sym_delete_statement] = STATE(1209),
    [sym_raise_statement] = STATE(1209),
    [sym_pass_statement] = STATE(1209),
    [sym_break_statement] = STATE(1209),
    [sym_continue_statement] = STATE(1209),
    [sym_list_splat] = STATE(1360),
    [sym_dictionary_splat] = STATE(1360),
    [sym_global_statement] = STATE(1209),
    [sym_nonlocal_statement] = STATE(1209),
    [sym_exec_statement] = STATE(1209),
    [sym_type_alias_statement] = STATE(1209),
    [sym_expression_list] = STATE(1361),
    [sym_pattern] = STATE(889),
    [sym_tuple_pattern] = STATE(875),
    [sym_list_pattern] = STATE(875),
    [sym_list_splat_pattern] = STATE(875),
    [sym_expression] = STATE(1019),
    [sym_primary_expression] = STATE(684),
    [sym_not_operator] = STATE(1009),
    [sym_boolean_operator] = STATE(1009),
    [sym_binary_operator] = STATE(797),
    [sym_unary_operator] = STATE(797),
    [sym_comparison_operator] = STATE(1009),
    [sym_lambda] = STATE(1009),
    [sym_assignment] = STATE(1361),
    [sym_augmented_assignment] = STATE(1361),
    [sym_pattern_list] = STATE(897),
    [sym_yield] = STATE(1361),
    [sym_attribute] = STATE(431),
    [sym_subscript] = STATE(431),
    [sym_call] = STATE(797),
    [sym_list] = STATE(797),
    [sym_set] = STATE(797),
    [sym_tuple] = STATE(797),
    [sym_dictionary] = STATE(797),
    [sym_list_comprehension] = STATE(797),
    [sym_dictionary_comprehension] = STATE(797),
    [sym_set_comprehension] = STATE(797),
    [sym_generator_expression] = STATE(797),
    [sym_parenthesized_expression] = STATE(797),
    [sym_conditional_expression] = STATE(1009),
    [sym_concatenated_string] = STATE(797),
    [sym_string] = STATE(713),
    [sym_await] = STATE(1009),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_STAR] = ACTIONS(15),
    [anon_sym_print] = ACTIONS(17),
    [anon_sym_assert] = ACTIONS(19),
    [anon_sym_return] = ACTIONS(21),
    [anon_sym_del] = ACTIONS(23),
    [anon_sym_raise] = ACTIONS(25),
    [anon_sym_pass] = ACTIONS(27),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_async] = ACTIONS(317),
    [anon_sym_match] = ACTIONS(317),
    [anon_sym_DASH] = ACTIONS(47),
    [anon_sym_PLUS] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(51),
    [anon_sym_STAR_STAR] = ACTIONS(53),
    [anon_sym_global] = ACTIONS(57),
    [anon_sym_nonlocal] = ACTIONS(59),
    [anon_sym_exec] = ACTIONS(61),
    [anon_sym_type] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(383),
    [sym__indent] = ACTIONS(385),
    [sym__string_start] = ACTIONS(81),
  },
  [88] = {
    [sym__simple_statements] = STATE(401),
    [sym_import_statement] = STATE(1209),
    [sym_future_import_statement] = STATE(1209),
    [sym_import_from_statement] = STATE(1209),
    [sym_print_statement] = STATE(1209),
    [sym_assert_statement] = STATE(1209),
    [sym_expression_statement] = STATE(1209),
    [sym_named_expression] = STATE(1009),
    [sym_return_statement] = STATE(1209),
    [sym_delete_statement] = STATE(1209),
    [sym_raise_statement] = STATE(1209),
    [sym_pass_statement] = STATE(1209),
    [sym_break_statement] = STATE(1209),
    [sym_continue_statement] = STATE(1209),
    [sym_list_splat] = STATE(1360),
    [sym_dictionary_splat] = STATE(1360),
    [sym_global_statement] = STATE(1209),
    [sym_nonlocal_statement] = STATE(1209),
    [sym_exec_statement] = STATE(1209),
    [sym_type_alias_statement] = STATE(1209),
    [sym_expression_list] = STATE(1361),
    [sym_pattern] = STATE(889),
    [sym_tuple_pattern] = STATE(875),
    [sym_list_pattern] = STATE(875),
    [sym_list_splat_pattern] = STATE(875),
    [sym_expression] = STATE(1019),
    [sym_primary_expression] = STATE(684),
    [sym_not_operator] = STATE(1009),
    [sym_boolean_operator] = STATE(1009),
    [sym_binary_operator] = STATE(797),
    [sym_unary_operator] = STATE(797),
    [sym_comparison_operator] = STATE(1009),
    [sym_lambda] = STATE(1009),
    [sym_assignment] = STATE(1361),
    [sym_augmented_assignment] = STATE(1361),
    [sym_pattern_list] = STATE(897),
    [sym_yield] = STATE(1361),
    [sym_attribute] = STATE(431),
    [sym_subscript] = STATE(431),
    [sym_call] = STATE(797),
    [sym_list] = STATE(797),
    [sym_set] = STATE(797),
    [sym_tuple] = STATE(797),
    [sym_dictionary] = STATE(797),
    [sym_list_comprehension] = STATE(797),
    [sym_dictionary_comprehension] = STATE(797),
    [sym_set_comprehension] = STATE(797),
    [sym_generator_expression] = STATE(797),
    [sym_parenthesized_expression] = STATE(797),
    [sym_conditional_expression] = STATE(1009),
    [sym_concatenated_string] = STATE(797),
    [sym_string] = STATE(713),
    [sym_await] = STATE(1009),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_STAR] = ACTIONS(15),
    [anon_sym_print] = ACTIONS(17),
    [anon_sym_assert] = ACTIONS(19),
    [anon_sym_return] = ACTIONS(21),
    [anon_sym_del] = ACTIONS(23),
    [anon_sym_raise] = ACTIONS(25),
    [anon_sym_pass] = ACTIONS(27),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_async] = ACTIONS(317),
    [anon_sym_match] = ACTIONS(317),
    [anon_sym_DASH] = ACTIONS(47),
    [anon_sym_PLUS] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(51),
    [anon_sym_STAR_STAR] = ACTIONS(53),
    [anon_sym_global] = ACTIONS(57),
    [anon_sym_nonlocal] = ACTIONS(59),
    [anon_sym_exec] = ACTIONS(61),
    [anon_sym_type] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(387),
    [sym__indent] = ACTIONS(389),
    [sym__string_start] = ACTIONS(81),
  },
  [89] = {
    [sym__simple_statements] = STATE(502),
    [sym_import_statement] = STATE(1319),
    [sym_future_import_statement] = STATE(1319),
    [sym_import_from_statement] = STATE(1319),
    [sym_print_statement] = STATE(1319),
    [sym_assert_statement] = STATE(1319),
    [sym_expression_statement] = STATE(1319),
    [sym_named_expression] = STATE(1009),
    [sym_return_statement] = STATE(1319),
    [sym_delete_statement] = STATE(1319),
    [sym_raise_statement] = STATE(1319),
    [sym_pass_statement] = STATE(1319),
    [sym_break_statement] = STATE(1319),
    [sym_continue_statement] = STATE(1319),
    [sym_list_splat] = STATE(1360),
    [sym_dictionary_splat] = STATE(1360),
    [sym_global_statement] = STATE(1319),
    [sym_nonlocal_statement] = STATE(1319),
    [sym_exec_statement] = STATE(1319),
    [sym_type_alias_statement] = STATE(1319),
    [sym_expression_list] = STATE(1361),
    [sym_pattern] = STATE(889),
    [sym_tuple_pattern] = STATE(875),
    [sym_list_pattern] = STATE(875),
    [sym_list_splat_pattern] = STATE(875),
    [sym_expression] = STATE(1019),
    [sym_primary_expression] = STATE(684),
    [sym_not_operator] = STATE(1009),
    [sym_boolean_operator] = STATE(1009),
    [sym_binary_operator] = STATE(797),
    [sym_unary_operator] = STATE(797),
    [sym_comparison_operator] = STATE(1009),
    [sym_lambda] = STATE(1009),
    [sym_assignment] = STATE(1361),
    [sym_augmented_assignment] = STATE(1361),
    [sym_pattern_list] = STATE(897),
    [sym_yield] = STATE(1361),
    [sym_attribute] = STATE(431),
    [sym_subscript] = STATE(431),
    [sym_call] = STATE(797),
    [sym_list] = STATE(797),
    [sym_set] = STATE(797),
    [sym_tuple] = STATE(797),
    [sym_dictionary] = STATE(797),
    [sym_list_comprehension] = STATE(797),
    [sym_dictionary_comprehension] = STATE(797),
    [sym_set_comprehension] = STATE(797),
    [sym_generator_expression] = STATE(797),
    [sym_parenthesized_expression] = STATE(797),
    [sym_conditional_expression] = STATE(1009),
    [sym_concatenated_string] = STATE(797),
    [sym_string] = STATE(713),
    [sym_await] = STATE(1009),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_STAR] = ACTIONS(15),
    [anon_sym_print] = ACTIONS(17),
    [anon_sym_assert] = ACTIONS(19),
    [anon_sym_return] = ACTIONS(21),
    [anon_sym_del] = ACTIONS(23),
    [anon_sym_raise] = ACTIONS(25),
    [anon_sym_pass] = ACTIONS(27),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_async] = ACTIONS(317),
    [anon_sym_match] = ACTIONS(317),
    [anon_sym_DASH] = ACTIONS(47),
    [anon_sym_PLUS] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(51),
    [anon_sym_STAR_STAR] = ACTIONS(53),
    [anon_sym_global] = ACTIONS(57),
    [anon_sym_nonlocal] = ACTIONS(59),
    [anon_sym_exec] = ACTIONS(61),
    [anon_sym_type] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(391),
    [sym__indent] = ACTIONS(393),
    [sym__string_start] = ACTIONS(81),
  },
  [90] = {
    [sym__simple_statements] = STATE(526),
    [sym_import_statement] = STATE(1319),
    [sym_future_import_statement] = STATE(1319),
    [sym_import_from_statement] = STATE(1319),
    [sym_print_statement] = STATE(1319),
    [sym_assert_statement] = STATE(1319),
    [sym_expression_statement] = STATE(1319),
    [sym_named_expression] = STATE(1009),
    [sym_return_statement] = STATE(1319),
    [sym_delete_statement] = STATE(1319),
    [sym_raise_statement] = STATE(1319),
    [sym_pass_statement] = STATE(1319),
    [sym_break_statement] = STATE(1319),
    [sym_continue_statement] = STATE(1319),
    [sym_list_splat] = STATE(1360),
    [sym_dictionary_splat] = STATE(1360),
    [sym_global_statement] = STATE(1319),
    [sym_nonlocal_statement] = STATE(1319),
    [sym_exec_statement] = STATE(1319),
    [sym_type_alias_statement] = STATE(1319),
    [sym_expression_list] = STATE(1361),
    [sym_pattern] = STATE(889),
    [sym_tuple_pattern] = STATE(875),
    [sym_list_pattern] = STATE(875),
    [sym_list_splat_pattern] = STATE(875),
    [sym_expression] = STATE(1019),
    [sym_primary_expression] = STATE(684),
    [sym_not_operator] = STATE(1009),
    [sym_boolean_operator] = STATE(1009),
    [sym_binary_operator] = STATE(797),
    [sym_unary_operator] = STATE(797),
    [sym_comparison_operator] = STATE(1009),
    [sym_lambda] = STATE(1009),
    [sym_assignment] = STATE(1361),
    [sym_augmented_assignment] = STATE(1361),
    [sym_pattern_list] = STATE(897),
    [sym_yield] = STATE(1361),
    [sym_attribute] = STATE(431),
    [sym_subscript] = STATE(431),
    [sym_call] = STATE(797),
    [sym_list] = STATE(797),
    [sym_set] = STATE(797),
    [sym_tuple] = STATE(797),
    [sym_dictionary] = STATE(797),
    [sym_list_comprehension] = STATE(797),
    [sym_dictionary_comprehension] = STATE(797),
    [sym_set_comprehension] = STATE(797),
    [sym_generator_expression] = STATE(797),
    [sym_parenthesized_expression] = STATE(797),
    [sym_conditional_expression] = STATE(1009),
    [sym_concatenated_string] = STATE(797),
    [sym_string] = STATE(713),
    [sym_await] = STATE(1009),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_STAR] = ACTIONS(15),
    [anon_sym_print] = ACTIONS(17),
    [anon_sym_assert] = ACTIONS(19),
    [anon_sym_return] = ACTIONS(21),
    [anon_sym_del] = ACTIONS(23),
    [anon_sym_raise] = ACTIONS(25),
    [anon_sym_pass] = ACTIONS(27),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_async] = ACTIONS(317),
    [anon_sym_match] = ACTIONS(317),
    [anon_sym_DASH] = ACTIONS(47),
    [anon_sym_PLUS] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(51),
    [anon_sym_STAR_STAR] = ACTIONS(53),
    [anon_sym_global] = ACTIONS(57),
    [anon_sym_nonlocal] = ACTIONS(59),
    [anon_sym_exec] = ACTIONS(61),
    [anon_sym_type] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(395),
    [sym__indent] = ACTIONS(397),
    [sym__string_start] = ACTIONS(81),
  },
  [91] = {
    [sym__simple_statements] = STATE(527),
    [sym_import_statement] = STATE(1319),
    [sym_future_import_statement] = STATE(1319),
    [sym_import_from_statement] = STATE(1319),
    [sym_print_statement] = STATE(1319),
    [sym_assert_statement] = STATE(1319),
    [sym_expression_statement] = STATE(1319),
    [sym_named_expression] = STATE(1009),
    [sym_return_statement] = STATE(1319),
    [sym_delete_statement] = STATE(1319),
    [sym_raise_statement] = STATE(1319),
    [sym_pass_statement] = STATE(1319),
    [sym_break_statement] = STATE(1319),
    [sym_continue_statement] = STATE(1319),
    [sym_list_splat] = STATE(1360),
    [sym_dictionary_splat] = STATE(1360),
    [sym_global_statement] = STATE(1319),
    [sym_nonlocal_statement] = STATE(1319),
    [sym_exec_statement] = STATE(1319),
    [sym_type_alias_statement] = STATE(1319),
    [sym_expression_list] = STATE(1361),
    [sym_pattern] = STATE(889),
    [sym_tuple_pattern] = STATE(875),
    [sym_list_pattern] = STATE(875),
    [sym_list_splat_pattern] = STATE(875),
    [sym_expression] = STATE(1019),
    [sym_primary_expression] = STATE(684),
    [sym_not_operator] = STATE(1009),
    [sym_boolean_operator] = STATE(1009),
    [sym_binary_operator] = STATE(797),
    [sym_unary_operator] = STATE(797),
    [sym_comparison_operator] = STATE(1009),
    [sym_lambda] = STATE(1009),
    [sym_assignment] = STATE(1361),
    [sym_augmented_assignment] = STATE(1361),
    [sym_pattern_list] = STATE(897),
    [sym_yield] = STATE(1361),
    [sym_attribute] = STATE(431),
    [sym_subscript] = STATE(431),
    [sym_call] = STATE(797),
    [sym_list] = STATE(797),
    [sym_set] = STATE(797),
    [sym_tuple] = STATE(797),
    [sym_dictionary] = STATE(797),
    [sym_list_comprehension] = STATE(797),
    [sym_dictionary_comprehension] = STATE(797),
    [sym_set_comprehension] = STATE(797),
    [sym_generator_expression] = STATE(797),
    [sym_parenthesized_expression] = STATE(797),
    [sym_conditional_expression] = STATE(1009),
    [sym_concatenated_string] = STATE(797),
    [sym_string] = STATE(713),
    [sym_await] = STATE(1009),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_STAR] = ACTIONS(15),
    [anon_sym_print] = ACTIONS(17),
    [anon_sym_assert] = ACTIONS(19),
    [anon_sym_return] = ACTIONS(21),
    [anon_sym_del] = ACTIONS(23),
    [anon_sym_raise] = ACTIONS(25),
    [anon_sym_pass] = ACTIONS(27),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_async] = ACTIONS(317),
    [anon_sym_match] = ACTIONS(317),
    [anon_sym_DASH] = ACTIONS(47),
    [anon_sym_PLUS] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(51),
    [anon_sym_STAR_STAR] = ACTIONS(53),
    [anon_sym_global] = ACTIONS(57),
    [anon_sym_nonlocal] = ACTIONS(59),
    [anon_sym_exec] = ACTIONS(61),
    [anon_sym_type] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(399),
    [sym__indent] = ACTIONS(401),
    [sym__string_start] = ACTIONS(81),
  },
  [92] = {
    [sym__simple_statements] = STATE(531),
    [sym_import_statement] = STATE(1319),
    [sym_future_import_statement] = STATE(1319),
    [sym_import_from_statement] = STATE(1319),
    [sym_print_statement] = STATE(1319),
    [sym_assert_statement] = STATE(1319),
    [sym_expression_statement] = STATE(1319),
    [sym_named_expression] = STATE(1009),
    [sym_return_statement] = STATE(1319),
    [sym_delete_statement] = STATE(1319),
    [sym_raise_statement] = STATE(1319),
    [sym_pass_statement] = STATE(1319),
    [sym_break_statement] = STATE(1319),
    [sym_continue_statement] = STATE(1319),
    [sym_list_splat] = STATE(1360),
    [sym_dictionary_splat] = STATE(1360),
    [sym_global_statement] = STATE(1319),
    [sym_nonlocal_statement] = STATE(1319),
    [sym_exec_statement] = STATE(1319),
    [sym_type_alias_statement] = STATE(1319),
    [sym_expression_list] = STATE(1361),
    [sym_pattern] = STATE(889),
    [sym_tuple_pattern] = STATE(875),
    [sym_list_pattern] = STATE(875),
    [sym_list_splat_pattern] = STATE(875),
    [sym_expression] = STATE(1019),
    [sym_primary_expression] = STATE(684),
    [sym_not_operator] = STATE(1009),
    [sym_boolean_operator] = STATE(1009),
    [sym_binary_operator] = STATE(797),
    [sym_unary_operator] = STATE(797),
    [sym_comparison_operator] = STATE(1009),
    [sym_lambda] = STATE(1009),
    [sym_assignment] = STATE(1361),
    [sym_augmented_assignment] = STATE(1361),
    [sym_pattern_list] = STATE(897),
    [sym_yield] = STATE(1361),
    [sym_attribute] = STATE(431),
    [sym_subscript] = STATE(431),
    [sym_call] = STATE(797),
    [sym_list] = STATE(797),
    [sym_set] = STATE(797),
    [sym_tuple] = STATE(797),
    [sym_dictionary] = STATE(797),
    [sym_list_comprehension] = STATE(797),
    [sym_dictionary_comprehension] = STATE(797),
    [sym_set_comprehension] = STATE(797),
    [sym_generator_expression] = STATE(797),
    [sym_parenthesized_expression] = STATE(797),
    [sym_conditional_expression] = STATE(1009),
    [sym_concatenated_string] = STATE(797),
    [sym_string] = STATE(713),
    [sym_await] = STATE(1009),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_STAR] = ACTIONS(15),
    [anon_sym_print] = ACTIONS(17),
    [anon_sym_assert] = ACTIONS(19),
    [anon_sym_return] = ACTIONS(21),
    [anon_sym_del] = ACTIONS(23),
    [anon_sym_raise] = ACTIONS(25),
    [anon_sym_pass] = ACTIONS(27),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_async] = ACTIONS(317),
    [anon_sym_match] = ACTIONS(317),
    [anon_sym_DASH] = ACTIONS(47),
    [anon_sym_PLUS] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(51),
    [anon_sym_STAR_STAR] = ACTIONS(53),
    [anon_sym_global] = ACTIONS(57),
    [anon_sym_nonlocal] = ACTIONS(59),
    [anon_sym_exec] = ACTIONS(61),
    [anon_sym_type] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(403),
    [sym__indent] = ACTIONS(405),
    [sym__string_start] = ACTIONS(81),
  },
  [93] = {
    [sym__simple_statements] = STATE(268),
    [sym_import_statement] = STATE(1209),
    [sym_future_import_statement] = STATE(1209),
    [sym_import_from_statement] = STATE(1209),
    [sym_print_statement] = STATE(1209),
    [sym_assert_statement] = STATE(1209),
    [sym_expression_statement] = STATE(1209),
    [sym_named_expression] = STATE(1009),
    [sym_return_statement] = STATE(1209),
    [sym_delete_statement] = STATE(1209),
    [sym_raise_statement] = STATE(1209),
    [sym_pass_statement] = STATE(1209),
    [sym_break_statement] = STATE(1209),
    [sym_continue_statement] = STATE(1209),
    [sym_list_splat] = STATE(1360),
    [sym_dictionary_splat] = STATE(1360),
    [sym_global_statement] = STATE(1209),
    [sym_nonlocal_statement] = STATE(1209),
    [sym_exec_statement] = STATE(1209),
    [sym_type_alias_statement] = STATE(1209),
    [sym_expression_list] = STATE(1361),
    [sym_pattern] = STATE(889),
    [sym_tuple_pattern] = STATE(875),
    [sym_list_pattern] = STATE(875),
    [sym_list_splat_pattern] = STATE(875),
    [sym_expression] = STATE(1019),
    [sym_primary_expression] = STATE(684),
    [sym_not_operator] = STATE(1009),
    [sym_boolean_operator] = STATE(1009),
    [sym_binary_operator] = STATE(797),
    [sym_unary_operator] = STATE(797),
    [sym_comparison_operator] = STATE(1009),
    [sym_lambda] = STATE(1009),
    [sym_assignment] = STATE(1361),
    [sym_augmented_assignment] = STATE(1361),
    [sym_pattern_list] = STATE(897),
    [sym_yield] = STATE(1361),
    [sym_attribute] = STATE(431),
    [sym_subscript] = STATE(431),
    [sym_call] = STATE(797),
    [sym_list] = STATE(797),
    [sym_set] = STATE(797),
    [sym_tuple] = STATE(797),
    [sym_dictionary] = STATE(797),
    [sym_list_comprehension] = STATE(797),
    [sym_dictionary_comprehension] = STATE(797),
    [sym_set_comprehension] = STATE(797),
    [sym_generator_expression] = STATE(797),
    [sym_parenthesized_expression] = STATE(797),
    [sym_conditional_expression] = STATE(1009),
    [sym_concatenated_string] = STATE(797),
    [sym_string] = STATE(713),
    [sym_await] = STATE(1009),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_STAR] = ACTIONS(15),
    [anon_sym_print] = ACTIONS(17),
    [anon_sym_assert] = ACTIONS(19),
    [anon_sym_return] = ACTIONS(21),
    [anon_sym_del] = ACTIONS(23),
    [anon_sym_raise] = ACTIONS(25),
    [anon_sym_pass] = ACTIONS(27),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_async] = ACTIONS(317),
    [anon_sym_match] = ACTIONS(317),
    [anon_sym_DASH] = ACTIONS(47),
    [anon_sym_PLUS] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(51),
    [anon_sym_STAR_STAR] = ACTIONS(53),
    [anon_sym_global] = ACTIONS(57),
    [anon_sym_nonlocal] = ACTIONS(59),
    [anon_sym_exec] = ACTIONS(61),
    [anon_sym_type] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(407),
    [sym__indent] = ACTIONS(409),
    [sym__string_start] = ACTIONS(81),
  },
  [94] = {
    [sym__simple_statements] = STATE(538),
    [sym_import_statement] = STATE(1209),
    [sym_future_import_statement] = STATE(1209),
    [sym_import_from_statement] = STATE(1209),
    [sym_print_statement] = STATE(1209),
    [sym_assert_statement] = STATE(1209),
    [sym_expression_statement] = STATE(1209),
    [sym_named_expression] = STATE(1009),
    [sym_return_statement] = STATE(1209),
    [sym_delete_statement] = STATE(1209),
    [sym_raise_statement] = STATE(1209),
    [sym_pass_statement] = STATE(1209),
    [sym_break_statement] = STATE(1209),
    [sym_continue_statement] = STATE(1209),
    [sym_list_splat] = STATE(1360),
    [sym_dictionary_splat] = STATE(1360),
    [sym_global_statement] = STATE(1209),
    [sym_nonlocal_statement] = STATE(1209),
    [sym_exec_statement] = STATE(1209),
    [sym_type_alias_statement] = STATE(1209),
    [sym_expression_list] = STATE(1361),
    [sym_pattern] = STATE(889),
    [sym_tuple_pattern] = STATE(875),
    [sym_list_pattern] = STATE(875),
    [sym_list_splat_pattern] = STATE(875),
    [sym_expression] = STATE(1019),
    [sym_primary_expression] = STATE(684),
    [sym_not_operator] = STATE(1009),
    [sym_boolean_operator] = STATE(1009),
    [sym_binary_operator] = STATE(797),
    [sym_unary_operator] = STATE(797),
    [sym_comparison_operator] = STATE(1009),
    [sym_lambda] = STATE(1009),
    [sym_assignment] = STATE(1361),
    [sym_augmented_assignment] = STATE(1361),
    [sym_pattern_list] = STATE(897),
    [sym_yield] = STATE(1361),
    [sym_attribute] = STATE(431),
    [sym_subscript] = STATE(431),
    [sym_call] = STATE(797),
    [sym_list] = STATE(797),
    [sym_set] = STATE(797),
    [sym_tuple] = STATE(797),
    [sym_dictionary] = STATE(797),
    [sym_list_comprehension] = STATE(797),
    [sym_dictionary_comprehension] = STATE(797),
    [sym_set_comprehension] = STATE(797),
    [sym_generator_expression] = STATE(797),
    [sym_parenthesized_expression] = STATE(797),
    [sym_conditional_expression] = STATE(1009),
    [sym_concatenated_string] = STATE(797),
    [sym_string] = STATE(713),
    [sym_await] = STATE(1009),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_STAR] = ACTIONS(15),
    [anon_sym_print] = ACTIONS(17),
    [anon_sym_assert] = ACTIONS(19),
    [anon_sym_return] = ACTIONS(21),
    [anon_sym_del] = ACTIONS(23),
    [anon_sym_raise] = ACTIONS(25),
    [anon_sym_pass] = ACTIONS(27),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_async] = ACTIONS(317),
    [anon_sym_match] = ACTIONS(317),
    [anon_sym_DASH] = ACTIONS(47),
    [anon_sym_PLUS] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(51),
    [anon_sym_STAR_STAR] = ACTIONS(53),
    [anon_sym_global] = ACTIONS(57),
    [anon_sym_nonlocal] = ACTIONS(59),
    [anon_sym_exec] = ACTIONS(61),
    [anon_sym_type] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(411),
    [sym__indent] = ACTIONS(413),
    [sym__string_start] = ACTIONS(81),
  },
  [95] = {
    [sym__simple_statements] = STATE(594),
    [sym_import_statement] = STATE(1319),
    [sym_future_import_statement] = STATE(1319),
    [sym_import_from_statement] = STATE(1319),
    [sym_print_statement] = STATE(1319),
    [sym_assert_statement] = STATE(1319),
    [sym_expression_statement] = STATE(1319),
    [sym_named_expression] = STATE(1009),
    [sym_return_statement] = STATE(1319),
    [sym_delete_statement] = STATE(1319),
    [sym_raise_statement] = STATE(1319),
    [sym_pass_statement] = STATE(1319),
    [sym_break_statement] = STATE(1319),
    [sym_continue_statement] = STATE(1319),
    [sym_list_splat] = STATE(1360),
    [sym_dictionary_splat] = STATE(1360),
    [sym_global_statement] = STATE(1319),
    [sym_nonlocal_statement] = STATE(1319),
    [sym_exec_statement] = STATE(1319),
    [sym_type_alias_statement] = STATE(1319),
    [sym_expression_list] = STATE(1361),
    [sym_pattern] = STATE(889),
    [sym_tuple_pattern] = STATE(875),
    [sym_list_pattern] = STATE(875),
    [sym_list_splat_pattern] = STATE(875),
    [sym_expression] = STATE(1019),
    [sym_primary_expression] = STATE(684),
    [sym_not_operator] = STATE(1009),
    [sym_boolean_operator] = STATE(1009),
    [sym_binary_operator] = STATE(797),
    [sym_unary_operator] = STATE(797),
    [sym_comparison_operator] = STATE(1009),
    [sym_lambda] = STATE(1009),
    [sym_assignment] = STATE(1361),
    [sym_augmented_assignment] = STATE(1361),
    [sym_pattern_list] = STATE(897),
    [sym_yield] = STATE(1361),
    [sym_attribute] = STATE(431),
    [sym_subscript] = STATE(431),
    [sym_call] = STATE(797),
    [sym_list] = STATE(797),
    [sym_set] = STATE(797),
    [sym_tuple] = STATE(797),
    [sym_dictionary] = STATE(797),
    [sym_list_comprehension] = STATE(797),
    [sym_dictionary_comprehension] = STATE(797),
    [sym_set_comprehension] = STATE(797),
    [sym_generator_expression] = STATE(797),
    [sym_parenthesized_expression] = STATE(797),
    [sym_conditional_expression] = STATE(1009),
    [sym_concatenated_string] = STATE(797),
    [sym_string] = STATE(713),
    [sym_await] = STATE(1009),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_STAR] = ACTIONS(15),
    [anon_sym_print] = ACTIONS(17),
    [anon_sym_assert] = ACTIONS(19),
    [anon_sym_return] = ACTIONS(21),
    [anon_sym_del] = ACTIONS(23),
    [anon_sym_raise] = ACTIONS(25),
    [anon_sym_pass] = ACTIONS(27),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_async] = ACTIONS(317),
    [anon_sym_match] = ACTIONS(317),
    [anon_sym_DASH] = ACTIONS(47),
    [anon_sym_PLUS] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(51),
    [anon_sym_STAR_STAR] = ACTIONS(53),
    [anon_sym_global] = ACTIONS(57),
    [anon_sym_nonlocal] = ACTIONS(59),
    [anon_sym_exec] = ACTIONS(61),
    [anon_sym_type] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(415),
    [sym__indent] = ACTIONS(417),
    [sym__string_start] = ACTIONS(81),
  },
  [96] = {
    [sym__simple_statements] = STATE(965),
    [sym_import_statement] = STATE(1214),
    [sym_future_import_statement] = STATE(1214),
    [sym_import_from_statement] = STATE(1214),
    [sym_print_statement] = STATE(1214),
    [sym_assert_statement] = STATE(1214),
    [sym_expression_statement] = STATE(1214),
    [sym_named_expression] = STATE(1009),
    [sym_return_statement] = STATE(1214),
    [sym_delete_statement] = STATE(1214),
    [sym_raise_statement] = STATE(1214),
    [sym_pass_statement] = STATE(1214),
    [sym_break_statement] = STATE(1214),
    [sym_continue_statement] = STATE(1214),
    [sym_list_splat] = STATE(1360),
    [sym_dictionary_splat] = STATE(1360),
    [sym_global_statement] = STATE(1214),
    [sym_nonlocal_statement] = STATE(1214),
    [sym_exec_statement] = STATE(1214),
    [sym_type_alias_statement] = STATE(1214),
    [sym_expression_list] = STATE(1361),
    [sym_pattern] = STATE(889),
    [sym_tuple_pattern] = STATE(875),
    [sym_list_pattern] = STATE(875),
    [sym_list_splat_pattern] = STATE(875),
    [sym_expression] = STATE(1019),
    [sym_primary_expression] = STATE(684),
    [sym_not_operator] = STATE(1009),
    [sym_boolean_operator] = STATE(1009),
    [sym_binary_operator] = STATE(797),
    [sym_unary_operator] = STATE(797),
    [sym_comparison_operator] = STATE(1009),
    [sym_lambda] = STATE(1009),
    [sym_assignment] = STATE(1361),
    [sym_augmented_assignment] = STATE(1361),
    [sym_pattern_list] = STATE(897),
    [sym_yield] = STATE(1361),
    [sym_attribute] = STATE(431),
    [sym_subscript] = STATE(431),
    [sym_call] = STATE(797),
    [sym_list] = STATE(797),
    [sym_set] = STATE(797),
    [sym_tuple] = STATE(797),
    [sym_dictionary] = STATE(797),
    [sym_list_comprehension] = STATE(797),
    [sym_dictionary_comprehension] = STATE(797),
    [sym_set_comprehension] = STATE(797),
    [sym_generator_expression] = STATE(797),
    [sym_parenthesized_expression] = STATE(797),
    [sym_conditional_expression] = STATE(1009),
    [sym_concatenated_string] = STATE(797),
    [sym_string] = STATE(713),
    [sym_await] = STATE(1009),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_STAR] = ACTIONS(15),
    [anon_sym_print] = ACTIONS(17),
    [anon_sym_assert] = ACTIONS(19),
    [anon_sym_return] = ACTIONS(21),
    [anon_sym_del] = ACTIONS(23),
    [anon_sym_raise] = ACTIONS(25),
    [anon_sym_pass] = ACTIONS(27),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_async] = ACTIONS(317),
    [anon_sym_match] = ACTIONS(317),
    [anon_sym_DASH] = ACTIONS(47),
    [anon_sym_PLUS] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(51),
    [anon_sym_STAR_STAR] = ACTIONS(53),
    [anon_sym_global] = ACTIONS(57),
    [anon_sym_nonlocal] = ACTIONS(59),
    [anon_sym_exec] = ACTIONS(61),
    [anon_sym_type] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(419),
    [sym__indent] = ACTIONS(421),
    [sym__string_start] = ACTIONS(81),
  },
  [97] = {
    [sym__simple_statements] = STATE(464),
    [sym_import_statement] = STATE(1319),
    [sym_future_import_statement] = STATE(1319),
    [sym_import_from_statement] = STATE(1319),
    [sym_print_statement] = STATE(1319),
    [sym_assert_statement] = STATE(1319),
    [sym_expression_statement] = STATE(1319),
    [sym_named_expression] = STATE(1009),
    [sym_return_statement] = STATE(1319),
    [sym_delete_statement] = STATE(1319),
    [sym_raise_statement] = STATE(1319),
    [sym_pass_statement] = STATE(1319),
    [sym_break_statement] = STATE(1319),
    [sym_continue_statement] = STATE(1319),
    [sym_list_splat] = STATE(1360),
    [sym_dictionary_splat] = STATE(1360),
    [sym_global_statement] = STATE(1319),
    [sym_nonlocal_statement] = STATE(1319),
    [sym_exec_statement] = STATE(1319),
    [sym_type_alias_statement] = STATE(1319),
    [sym_expression_list] = STATE(1361),
    [sym_pattern] = STATE(889),
    [sym_tuple_pattern] = STATE(875),
    [sym_list_pattern] = STATE(875),
    [sym_list_splat_pattern] = STATE(875),
    [sym_expression] = STATE(1019),
    [sym_primary_expression] = STATE(684),
    [sym_not_operator] = STATE(1009),
    [sym_boolean_operator] = STATE(1009),
    [sym_binary_operator] = STATE(797),
    [sym_unary_operator] = STATE(797),
    [sym_comparison_operator] = STATE(1009),
    [sym_lambda] = STATE(1009),
    [sym_assignment] = STATE(1361),
    [sym_augmented_assignment] = STATE(1361),
    [sym_pattern_list] = STATE(897),
    [sym_yield] = STATE(1361),
    [sym_attribute] = STATE(431),
    [sym_subscript] = STATE(431),
    [sym_call] = STATE(797),
    [sym_list] = STATE(797),
    [sym_set] = STATE(797),
    [sym_tuple] = STATE(797),
    [sym_dictionary] = STATE(797),
    [sym_list_comprehension] = STATE(797),
    [sym_dictionary_comprehension] = STATE(797),
    [sym_set_comprehension] = STATE(797),
    [sym_generator_expression] = STATE(797),
    [sym_parenthesized_expression] = STATE(797),
    [sym_conditional_expression] = STATE(1009),
    [sym_concatenated_string] = STATE(797),
    [sym_string] = STATE(713),
    [sym_await] = STATE(1009),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_STAR] = ACTIONS(15),
    [anon_sym_print] = ACTIONS(17),
    [anon_sym_assert] = ACTIONS(19),
    [anon_sym_return] = ACTIONS(21),
    [anon_sym_del] = ACTIONS(23),
    [anon_sym_raise] = ACTIONS(25),
    [anon_sym_pass] = ACTIONS(27),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_async] = ACTIONS(317),
    [anon_sym_match] = ACTIONS(317),
    [anon_sym_DASH] = ACTIONS(47),
    [anon_sym_PLUS] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(51),
    [anon_sym_STAR_STAR] = ACTIONS(53),
    [anon_sym_global] = ACTIONS(57),
    [anon_sym_nonlocal] = ACTIONS(59),
    [anon_sym_exec] = ACTIONS(61),
    [anon_sym_type] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(423),
    [sym__indent] = ACTIONS(425),
    [sym__string_start] = ACTIONS(81),
  },
  [98] = {
    [sym__simple_statements] = STATE(353),
    [sym_import_statement] = STATE(1244),
    [sym_future_import_statement] = STATE(1244),
    [sym_import_from_statement] = STATE(1244),
    [sym_print_statement] = STATE(1244),
    [sym_assert_statement] = STATE(1244),
    [sym_expression_statement] = STATE(1244),
    [sym_named_expression] = STATE(1009),
    [sym_return_statement] = STATE(1244),
    [sym_delete_statement] = STATE(1244),
    [sym_raise_statement] = STATE(1244),
    [sym_pass_statement] = STATE(1244),
    [sym_break_statement] = STATE(1244),
    [sym_continue_statement] = STATE(1244),
    [sym_list_splat] = STATE(1360),
    [sym_dictionary_splat] = STATE(1360),
    [sym_global_statement] = STATE(1244),
    [sym_nonlocal_statement] = STATE(1244),
    [sym_exec_statement] = STATE(1244),
    [sym_type_alias_statement] = STATE(1244),
    [sym_expression_list] = STATE(1361),
    [sym_pattern] = STATE(889),
    [sym_tuple_pattern] = STATE(875),
    [sym_list_pattern] = STATE(875),
    [sym_list_splat_pattern] = STATE(875),
    [sym_expression] = STATE(1019),
    [sym_primary_expression] = STATE(684),
    [sym_not_operator] = STATE(1009),
    [sym_boolean_operator] = STATE(1009),
    [sym_binary_operator] = STATE(797),
    [sym_unary_operator] = STATE(797),
    [sym_comparison_operator] = STATE(1009),
    [sym_lambda] = STATE(1009),
    [sym_assignment] = STATE(1361),
    [sym_augmented_assignment] = STATE(1361),
    [sym_pattern_list] = STATE(897),
    [sym_yield] = STATE(1361),
    [sym_attribute] = STATE(431),
    [sym_subscript] = STATE(431),
    [sym_call] = STATE(797),
    [sym_list] = STATE(797),
    [sym_set] = STATE(797),
    [sym_tuple] = STATE(797),
    [sym_dictionary] = STATE(797),
    [sym_list_comprehension] = STATE(797),
    [sym_dictionary_comprehension] = STATE(797),
    [sym_set_comprehension] = STATE(797),
    [sym_generator_expression] = STATE(797),
    [sym_parenthesized_expression] = STATE(797),
    [sym_conditional_expression] = STATE(1009),
    [sym_concatenated_string] = STATE(797),
    [sym_string] = STATE(713),
    [sym_await] = STATE(1009),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_STAR] = ACTIONS(15),
    [anon_sym_print] = ACTIONS(17),
    [anon_sym_assert] = ACTIONS(19),
    [anon_sym_return] = ACTIONS(21),
    [anon_sym_del] = ACTIONS(23),
    [anon_sym_raise] = ACTIONS(25),
    [anon_sym_pass] = ACTIONS(27),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_async] = ACTIONS(317),
    [anon_sym_match] = ACTIONS(317),
    [anon_sym_DASH] = ACTIONS(47),
    [anon_sym_PLUS] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(51),
    [anon_sym_STAR_STAR] = ACTIONS(53),
    [anon_sym_global] = ACTIONS(57),
    [anon_sym_nonlocal] = ACTIONS(59),
    [anon_sym_exec] = ACTIONS(61),
    [anon_sym_type] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(427),
    [sym__indent] = ACTIONS(429),
    [sym__string_start] = ACTIONS(81),
  },
  [99] = {
    [sym__simple_statements] = STATE(542),
    [sym_import_statement] = STATE(1209),
    [sym_future_import_statement] = STATE(1209),
    [sym_import_from_statement] = STATE(1209),
    [sym_print_statement] = STATE(1209),
    [sym_assert_statement] = STATE(1209),
    [sym_expression_statement] = STATE(1209),
    [sym_named_expression] = STATE(1009),
    [sym_return_statement] = STATE(1209),
    [sym_delete_statement] = STATE(1209),
    [sym_raise_statement] = STATE(1209),
    [sym_pass_statement] = STATE(1209),
    [sym_break_statement] = STATE(1209),
    [sym_continue_statement] = STATE(1209),
    [sym_list_splat] = STATE(1360),
    [sym_dictionary_splat] = STATE(1360),
    [sym_global_statement] = STATE(1209),
    [sym_nonlocal_statement] = STATE(1209),
    [sym_exec_statement] = STATE(1209),
    [sym_type_alias_statement] = STATE(1209),
    [sym_expression_list] = STATE(1361),
    [sym_pattern] = STATE(889),
    [sym_tuple_pattern] = STATE(875),
    [sym_list_pattern] = STATE(875),
    [sym_list_splat_pattern] = STATE(875),
    [sym_expression] = STATE(1019),
    [sym_primary_expression] = STATE(684),
    [sym_not_operator] = STATE(1009),
    [sym_boolean_operator] = STATE(1009),
    [sym_binary_operator] = STATE(797),
    [sym_unary_operator] = STATE(797),
    [sym_comparison_operator] = STATE(1009),
    [sym_lambda] = STATE(1009),
    [sym_assignment] = STATE(1361),
    [sym_augmented_assignment] = STATE(1361),
    [sym_pattern_list] = STATE(897),
    [sym_yield] = STATE(1361),
    [sym_attribute] = STATE(431),
    [sym_subscript] = STATE(431),
    [sym_call] = STATE(797),
    [sym_list] = STATE(797),
    [sym_set] = STATE(797),
    [sym_tuple] = STATE(797),
    [sym_dictionary] = STATE(797),
    [sym_list_comprehension] = STATE(797),
    [sym_dictionary_comprehension] = STATE(797),
    [sym_set_comprehension] = STATE(797),
    [sym_generator_expression] = STATE(797),
    [sym_parenthesized_expression] = STATE(797),
    [sym_conditional_expression] = STATE(1009),
    [sym_concatenated_string] = STATE(797),
    [sym_string] = STATE(713),
    [sym_await] = STATE(1009),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_STAR] = ACTIONS(15),
    [anon_sym_print] = ACTIONS(17),
    [anon_sym_assert] = ACTIONS(19),
    [anon_sym_return] = ACTIONS(21),
    [anon_sym_del] = ACTIONS(23),
    [anon_sym_raise] = ACTIONS(25),
    [anon_sym_pass] = ACTIONS(27),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_async] = ACTIONS(317),
    [anon_sym_match] = ACTIONS(317),
    [anon_sym_DASH] = ACTIONS(47),
    [anon_sym_PLUS] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(51),
    [anon_sym_STAR_STAR] = ACTIONS(53),
    [anon_sym_global] = ACTIONS(57),
    [anon_sym_nonlocal] = ACTIONS(59),
    [anon_sym_exec] = ACTIONS(61),
    [anon_sym_type] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(431),
    [sym__indent] = ACTIONS(433),
    [sym__string_start] = ACTIONS(81),
  },
  [100] = {
    [sym__simple_statements] = STATE(331),
    [sym_import_statement] = STATE(1248),
    [sym_future_import_statement] = STATE(1248),
    [sym_import_from_statement] = STATE(1248),
    [sym_print_statement] = STATE(1248),
    [sym_assert_statement] = STATE(1248),
    [sym_expression_statement] = STATE(1248),
    [sym_named_expression] = STATE(1009),
    [sym_return_statement] = STATE(1248),
    [sym_delete_statement] = STATE(1248),
    [sym_raise_statement] = STATE(1248),
    [sym_pass_statement] = STATE(1248),
    [sym_break_statement] = STATE(1248),
    [sym_continue_statement] = STATE(1248),
    [sym_list_splat] = STATE(1360),
    [sym_dictionary_splat] = STATE(1360),
    [sym_global_statement] = STATE(1248),
    [sym_nonlocal_statement] = STATE(1248),
    [sym_exec_statement] = STATE(1248),
    [sym_type_alias_statement] = STATE(1248),
    [sym_expression_list] = STATE(1361),
    [sym_pattern] = STATE(889),
    [sym_tuple_pattern] = STATE(875),
    [sym_list_pattern] = STATE(875),
    [sym_list_splat_pattern] = STATE(875),
    [sym_expression] = STATE(1019),
    [sym_primary_expression] = STATE(684),
    [sym_not_operator] = STATE(1009),
    [sym_boolean_operator] = STATE(1009),
    [sym_binary_operator] = STATE(797),
    [sym_unary_operator] = STATE(797),
    [sym_comparison_operator] = STATE(1009),
    [sym_lambda] = STATE(1009),
    [sym_assignment] = STATE(1361),
    [sym_augmented_assignment] = STATE(1361),
    [sym_pattern_list] = STATE(897),
    [sym_yield] = STATE(1361),
    [sym_attribute] = STATE(431),
    [sym_subscript] = STATE(431),
    [sym_call] = STATE(797),
    [sym_list] = STATE(797),
    [sym_set] = STATE(797),
    [sym_tuple] = STATE(797),
    [sym_dictionary] = STATE(797),
    [sym_list_comprehension] = STATE(797),
    [sym_dictionary_comprehension] = STATE(797),
    [sym_set_comprehension] = STATE(797),
    [sym_generator_expression] = STATE(797),
    [sym_parenthesized_expression] = STATE(797),
    [sym_conditional_expression] = STATE(1009),
    [sym_concatenated_string] = STATE(797),
    [sym_string] = STATE(713),
    [sym_await] = STATE(1009),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_STAR] = ACTIONS(15),
    [anon_sym_print] = ACTIONS(17),
    [anon_sym_assert] = ACTIONS(19),
    [anon_sym_return] = ACTIONS(21),
    [anon_sym_del] = ACTIONS(23),
    [anon_sym_raise] = ACTIONS(25),
    [anon_sym_pass] = ACTIONS(27),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_async] = ACTIONS(317),
    [anon_sym_match] = ACTIONS(317),
    [anon_sym_DASH] = ACTIONS(47),
    [anon_sym_PLUS] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(51),
    [anon_sym_STAR_STAR] = ACTIONS(53),
    [anon_sym_global] = ACTIONS(57),
    [anon_sym_nonlocal] = ACTIONS(59),
    [anon_sym_exec] = ACTIONS(61),
    [anon_sym_type] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(435),
    [sym__indent] = ACTIONS(437),
    [sym__string_start] = ACTIONS(81),
  },
  [101] = {
    [sym__simple_statements] = STATE(592),
    [sym_import_statement] = STATE(1319),
    [sym_future_import_statement] = STATE(1319),
    [sym_import_from_statement] = STATE(1319),
    [sym_print_statement] = STATE(1319),
    [sym_assert_statement] = STATE(1319),
    [sym_expression_statement] = STATE(1319),
    [sym_named_expression] = STATE(1009),
    [sym_return_statement] = STATE(1319),
    [sym_delete_statement] = STATE(1319),
    [sym_raise_statement] = STATE(1319),
    [sym_pass_statement] = STATE(1319),
    [sym_break_statement] = STATE(1319),
    [sym_continue_statement] = STATE(1319),
    [sym_list_splat] = STATE(1360),
    [sym_dictionary_splat] = STATE(1360),
    [sym_global_statement] = STATE(1319),
    [sym_nonlocal_statement] = STATE(1319),
    [sym_exec_statement] = STATE(1319),
    [sym_type_alias_statement] = STATE(1319),
    [sym_expression_list] = STATE(1361),
    [sym_pattern] = STATE(889),
    [sym_tuple_pattern] = STATE(875),
    [sym_list_pattern] = STATE(875),
    [sym_list_splat_pattern] = STATE(875),
    [sym_expression] = STATE(1019),
    [sym_primary_expression] = STATE(684),
    [sym_not_operator] = STATE(1009),
    [sym_boolean_operator] = STATE(1009),
    [sym_binary_operator] = STATE(797),
    [sym_unary_operator] = STATE(797),
    [sym_comparison_operator] = STATE(1009),
    [sym_lambda] = STATE(1009),
    [sym_assignment] = STATE(1361),
    [sym_augmented_assignment] = STATE(1361),
    [sym_pattern_list] = STATE(897),
    [sym_yield] = STATE(1361),
    [sym_attribute] = STATE(431),
    [sym_subscript] = STATE(431),
    [sym_call] = STATE(797),
    [sym_list] = STATE(797),
    [sym_set] = STATE(797),
    [sym_tuple] = STATE(797),
    [sym_dictionary] = STATE(797),
    [sym_list_comprehension] = STATE(797),
    [sym_dictionary_comprehension] = STATE(797),
    [sym_set_comprehension] = STATE(797),
    [sym_generator_expression] = STATE(797),
    [sym_parenthesized_expression] = STATE(797),
    [sym_conditional_expression] = STATE(1009),
    [sym_concatenated_string] = STATE(797),
    [sym_string] = STATE(713),
    [sym_await] = STATE(1009),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_STAR] = ACTIONS(15),
    [anon_sym_print] = ACTIONS(17),
    [anon_sym_assert] = ACTIONS(19),
    [anon_sym_return] = ACTIONS(21),
    [anon_sym_del] = ACTIONS(23),
    [anon_sym_raise] = ACTIONS(25),
    [anon_sym_pass] = ACTIONS(27),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_async] = ACTIONS(317),
    [anon_sym_match] = ACTIONS(317),
    [anon_sym_DASH] = ACTIONS(47),
    [anon_sym_PLUS] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(51),
    [anon_sym_STAR_STAR] = ACTIONS(53),
    [anon_sym_global] = ACTIONS(57),
    [anon_sym_nonlocal] = ACTIONS(59),
    [anon_sym_exec] = ACTIONS(61),
    [anon_sym_type] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(439),
    [sym__indent] = ACTIONS(441),
    [sym__string_start] = ACTIONS(81),
  },
  [102] = {
    [sym__simple_statements] = STATE(492),
    [sym_import_statement] = STATE(1319),
    [sym_future_import_statement] = STATE(1319),
    [sym_import_from_statement] = STATE(1319),
    [sym_print_statement] = STATE(1319),
    [sym_assert_statement] = STATE(1319),
    [sym_expression_statement] = STATE(1319),
    [sym_named_expression] = STATE(1009),
    [sym_return_statement] = STATE(1319),
    [sym_delete_statement] = STATE(1319),
    [sym_raise_statement] = STATE(1319),
    [sym_pass_statement] = STATE(1319),
    [sym_break_statement] = STATE(1319),
    [sym_continue_statement] = STATE(1319),
    [sym_list_splat] = STATE(1360),
    [sym_dictionary_splat] = STATE(1360),
    [sym_global_statement] = STATE(1319),
    [sym_nonlocal_statement] = STATE(1319),
    [sym_exec_statement] = STATE(1319),
    [sym_type_alias_statement] = STATE(1319),
    [sym_expression_list] = STATE(1361),
    [sym_pattern] = STATE(889),
    [sym_tuple_pattern] = STATE(875),
    [sym_list_pattern] = STATE(875),
    [sym_list_splat_pattern] = STATE(875),
    [sym_expression] = STATE(1019),
    [sym_primary_expression] = STATE(684),
    [sym_not_operator] = STATE(1009),
    [sym_boolean_operator] = STATE(1009),
    [sym_binary_operator] = STATE(797),
    [sym_unary_operator] = STATE(797),
    [sym_comparison_operator] = STATE(1009),
    [sym_lambda] = STATE(1009),
    [sym_assignment] = STATE(1361),
    [sym_augmented_assignment] = STATE(1361),
    [sym_pattern_list] = STATE(897),
    [sym_yield] = STATE(1361),
    [sym_attribute] = STATE(431),
    [sym_subscript] = STATE(431),
    [sym_call] = STATE(797),
    [sym_list] = STATE(797),
    [sym_set] = STATE(797),
    [sym_tuple] = STATE(797),
    [sym_dictionary] = STATE(797),
    [sym_list_comprehension] = STATE(797),
    [sym_dictionary_comprehension] = STATE(797),
    [sym_set_comprehension] = STATE(797),
    [sym_generator_expression] = STATE(797),
    [sym_parenthesized_expression] = STATE(797),
    [sym_conditional_expression] = STATE(1009),
    [sym_concatenated_string] = STATE(797),
    [sym_string] = STATE(713),
    [sym_await] = STATE(1009),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_STAR] = ACTIONS(15),
    [anon_sym_print] = ACTIONS(17),
    [anon_sym_assert] = ACTIONS(19),
    [anon_sym_return] = ACTIONS(21),
    [anon_sym_del] = ACTIONS(23),
    [anon_sym_raise] = ACTIONS(25),
    [anon_sym_pass] = ACTIONS(27),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_async] = ACTIONS(317),
    [anon_sym_match] = ACTIONS(317),
    [anon_sym_DASH] = ACTIONS(47),
    [anon_sym_PLUS] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(51),
    [anon_sym_STAR_STAR] = ACTIONS(53),
    [anon_sym_global] = ACTIONS(57),
    [anon_sym_nonlocal] = ACTIONS(59),
    [anon_sym_exec] = ACTIONS(61),
    [anon_sym_type] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(443),
    [sym__indent] = ACTIONS(445),
    [sym__string_start] = ACTIONS(81),
  },
  [103] = {
    [sym__simple_statements] = STATE(332),
    [sym_import_statement] = STATE(1261),
    [sym_future_import_statement] = STATE(1261),
    [sym_import_from_statement] = STATE(1261),
    [sym_print_statement] = STATE(1261),
    [sym_assert_statement] = STATE(1261),
    [sym_expression_statement] = STATE(1261),
    [sym_named_expression] = STATE(1009),
    [sym_return_statement] = STATE(1261),
    [sym_delete_statement] = STATE(1261),
    [sym_raise_statement] = STATE(1261),
    [sym_pass_statement] = STATE(1261),
    [sym_break_statement] = STATE(1261),
    [sym_continue_statement] = STATE(1261),
    [sym_list_splat] = STATE(1360),
    [sym_dictionary_splat] = STATE(1360),
    [sym_global_statement] = STATE(1261),
    [sym_nonlocal_statement] = STATE(1261),
    [sym_exec_statement] = STATE(1261),
    [sym_type_alias_statement] = STATE(1261),
    [sym_expression_list] = STATE(1361),
    [sym_pattern] = STATE(889),
    [sym_tuple_pattern] = STATE(875),
    [sym_list_pattern] = STATE(875),
    [sym_list_splat_pattern] = STATE(875),
    [sym_expression] = STATE(1019),
    [sym_primary_expression] = STATE(684),
    [sym_not_operator] = STATE(1009),
    [sym_boolean_operator] = STATE(1009),
    [sym_binary_operator] = STATE(797),
    [sym_unary_operator] = STATE(797),
    [sym_comparison_operator] = STATE(1009),
    [sym_lambda] = STATE(1009),
    [sym_assignment] = STATE(1361),
    [sym_augmented_assignment] = STATE(1361),
    [sym_pattern_list] = STATE(897),
    [sym_yield] = STATE(1361),
    [sym_attribute] = STATE(431),
    [sym_subscript] = STATE(431),
    [sym_call] = STATE(797),
    [sym_list] = STATE(797),
    [sym_set] = STATE(797),
    [sym_tuple] = STATE(797),
    [sym_dictionary] = STATE(797),
    [sym_list_comprehension] = STATE(797),
    [sym_dictionary_comprehension] = STATE(797),
    [sym_set_comprehension] = STATE(797),
    [sym_generator_expression] = STATE(797),
    [sym_parenthesized_expression] = STATE(797),
    [sym_conditional_expression] = STATE(1009),
    [sym_concatenated_string] = STATE(797),
    [sym_string] = STATE(713),
    [sym_await] = STATE(1009),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_STAR] = ACTIONS(15),
    [anon_sym_print] = ACTIONS(17),
    [anon_sym_assert] = ACTIONS(19),
    [anon_sym_return] = ACTIONS(21),
    [anon_sym_del] = ACTIONS(23),
    [anon_sym_raise] = ACTIONS(25),
    [anon_sym_pass] = ACTIONS(27),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_async] = ACTIONS(317),
    [anon_sym_match] = ACTIONS(317),
    [anon_sym_DASH] = ACTIONS(47),
    [anon_sym_PLUS] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(51),
    [anon_sym_STAR_STAR] = ACTIONS(53),
    [anon_sym_global] = ACTIONS(57),
    [anon_sym_nonlocal] = ACTIONS(59),
    [anon_sym_exec] = ACTIONS(61),
    [anon_sym_type] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(447),
    [sym__indent] = ACTIONS(449),
    [sym__string_start] = ACTIONS(81),
  },
  [104] = {
    [sym__simple_statements] = STATE(544),
    [sym_import_statement] = STATE(1319),
    [sym_future_import_statement] = STATE(1319),
    [sym_import_from_statement] = STATE(1319),
    [sym_print_statement] = STATE(1319),
    [sym_assert_statement] = STATE(1319),
    [sym_expression_statement] = STATE(1319),
    [sym_named_expression] = STATE(1009),
    [sym_return_statement] = STATE(1319),
    [sym_delete_statement] = STATE(1319),
    [sym_raise_statement] = STATE(1319),
    [sym_pass_statement] = STATE(1319),
    [sym_break_statement] = STATE(1319),
    [sym_continue_statement] = STATE(1319),
    [sym_list_splat] = STATE(1360),
    [sym_dictionary_splat] = STATE(1360),
    [sym_global_statement] = STATE(1319),
    [sym_nonlocal_statement] = STATE(1319),
    [sym_exec_statement] = STATE(1319),
    [sym_type_alias_statement] = STATE(1319),
    [sym_expression_list] = STATE(1361),
    [sym_pattern] = STATE(889),
    [sym_tuple_pattern] = STATE(875),
    [sym_list_pattern] = STATE(875),
    [sym_list_splat_pattern] = STATE(875),
    [sym_expression] = STATE(1019),
    [sym_primary_expression] = STATE(684),
    [sym_not_operator] = STATE(1009),
    [sym_boolean_operator] = STATE(1009),
    [sym_binary_operator] = STATE(797),
    [sym_unary_operator] = STATE(797),
    [sym_comparison_operator] = STATE(1009),
    [sym_lambda] = STATE(1009),
    [sym_assignment] = STATE(1361),
    [sym_augmented_assignment] = STATE(1361),
    [sym_pattern_list] = STATE(897),
    [sym_yield] = STATE(1361),
    [sym_attribute] = STATE(431),
    [sym_subscript] = STATE(431),
    [sym_call] = STATE(797),
    [sym_list] = STATE(797),
    [sym_set] = STATE(797),
    [sym_tuple] = STATE(797),
    [sym_dictionary] = STATE(797),
    [sym_list_comprehension] = STATE(797),
    [sym_dictionary_comprehension] = STATE(797),
    [sym_set_comprehension] = STATE(797),
    [sym_generator_expression] = STATE(797),
    [sym_parenthesized_expression] = STATE(797),
    [sym_conditional_expression] = STATE(1009),
    [sym_concatenated_string] = STATE(797),
    [sym_string] = STATE(713),
    [sym_await] = STATE(1009),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_STAR] = ACTIONS(15),
    [anon_sym_print] = ACTIONS(17),
    [anon_sym_assert] = ACTIONS(19),
    [anon_sym_return] = ACTIONS(21),
    [anon_sym_del] = ACTIONS(23),
    [anon_sym_raise] = ACTIONS(25),
    [anon_sym_pass] = ACTIONS(27),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_async] = ACTIONS(317),
    [anon_sym_match] = ACTIONS(317),
    [anon_sym_DASH] = ACTIONS(47),
    [anon_sym_PLUS] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(51),
    [anon_sym_STAR_STAR] = ACTIONS(53),
    [anon_sym_global] = ACTIONS(57),
    [anon_sym_nonlocal] = ACTIONS(59),
    [anon_sym_exec] = ACTIONS(61),
    [anon_sym_type] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(451),
    [sym__indent] = ACTIONS(453),
    [sym__string_start] = ACTIONS(81),
  },
  [105] = {
    [sym__simple_statements] = STATE(582),
    [sym_import_statement] = STATE(1319),
    [sym_future_import_statement] = STATE(1319),
    [sym_import_from_statement] = STATE(1319),
    [sym_print_statement] = STATE(1319),
    [sym_assert_statement] = STATE(1319),
    [sym_expression_statement] = STATE(1319),
    [sym_named_expression] = STATE(1009),
    [sym_return_statement] = STATE(1319),
    [sym_delete_statement] = STATE(1319),
    [sym_raise_statement] = STATE(1319),
    [sym_pass_statement] = STATE(1319),
    [sym_break_statement] = STATE(1319),
    [sym_continue_statement] = STATE(1319),
    [sym_list_splat] = STATE(1360),
    [sym_dictionary_splat] = STATE(1360),
    [sym_global_statement] = STATE(1319),
    [sym_nonlocal_statement] = STATE(1319),
    [sym_exec_statement] = STATE(1319),
    [sym_type_alias_statement] = STATE(1319),
    [sym_expression_list] = STATE(1361),
    [sym_pattern] = STATE(889),
    [sym_tuple_pattern] = STATE(875),
    [sym_list_pattern] = STATE(875),
    [sym_list_splat_pattern] = STATE(875),
    [sym_expression] = STATE(1019),
    [sym_primary_expression] = STATE(684),
    [sym_not_operator] = STATE(1009),
    [sym_boolean_operator] = STATE(1009),
    [sym_binary_operator] = STATE(797),
    [sym_unary_operator] = STATE(797),
    [sym_comparison_operator] = STATE(1009),
    [sym_lambda] = STATE(1009),
    [sym_assignment] = STATE(1361),
    [sym_augmented_assignment] = STATE(1361),
    [sym_pattern_list] = STATE(897),
    [sym_yield] = STATE(1361),
    [sym_attribute] = STATE(431),
    [sym_subscript] = STATE(431),
    [sym_call] = STATE(797),
    [sym_list] = STATE(797),
    [sym_set] = STATE(797),
    [sym_tuple] = STATE(797),
    [sym_dictionary] = STATE(797),
    [sym_list_comprehension] = STATE(797),
    [sym_dictionary_comprehension] = STATE(797),
    [sym_set_comprehension] = STATE(797),
    [sym_generator_expression] = STATE(797),
    [sym_parenthesized_expression] = STATE(797),
    [sym_conditional_expression] = STATE(1009),
    [sym_concatenated_string] = STATE(797),
    [sym_string] = STATE(713),
    [sym_await] = STATE(1009),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_STAR] = ACTIONS(15),
    [anon_sym_print] = ACTIONS(17),
    [anon_sym_assert] = ACTIONS(19),
    [anon_sym_return] = ACTIONS(21),
    [anon_sym_del] = ACTIONS(23),
    [anon_sym_raise] = ACTIONS(25),
    [anon_sym_pass] = ACTIONS(27),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_async] = ACTIONS(317),
    [anon_sym_match] = ACTIONS(317),
    [anon_sym_DASH] = ACTIONS(47),
    [anon_sym_PLUS] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(51),
    [anon_sym_STAR_STAR] = ACTIONS(53),
    [anon_sym_global] = ACTIONS(57),
    [anon_sym_nonlocal] = ACTIONS(59),
    [anon_sym_exec] = ACTIONS(61),
    [anon_sym_type] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(455),
    [sym__indent] = ACTIONS(457),
    [sym__string_start] = ACTIONS(81),
  },
  [106] = {
    [sym__simple_statements] = STATE(493),
    [sym_import_statement] = STATE(1209),
    [sym_future_import_statement] = STATE(1209),
    [sym_import_from_statement] = STATE(1209),
    [sym_print_statement] = STATE(1209),
    [sym_assert_statement] = STATE(1209),
    [sym_expression_statement] = STATE(1209),
    [sym_named_expression] = STATE(1009),
    [sym_return_statement] = STATE(1209),
    [sym_delete_statement] = STATE(1209),
    [sym_raise_statement] = STATE(1209),
    [sym_pass_statement] = STATE(1209),
    [sym_break_statement] = STATE(1209),
    [sym_continue_statement] = STATE(1209),
    [sym_list_splat] = STATE(1360),
    [sym_dictionary_splat] = STATE(1360),
    [sym_global_statement] = STATE(1209),
    [sym_nonlocal_statement] = STATE(1209),
    [sym_exec_statement] = STATE(1209),
    [sym_type_alias_statement] = STATE(1209),
    [sym_expression_list] = STATE(1361),
    [sym_pattern] = STATE(889),
    [sym_tuple_pattern] = STATE(875),
    [sym_list_pattern] = STATE(875),
    [sym_list_splat_pattern] = STATE(875),
    [sym_expression] = STATE(1019),
    [sym_primary_expression] = STATE(684),
    [sym_not_operator] = STATE(1009),
    [sym_boolean_operator] = STATE(1009),
    [sym_binary_operator] = STATE(797),
    [sym_unary_operator] = STATE(797),
    [sym_comparison_operator] = STATE(1009),
    [sym_lambda] = STATE(1009),
    [sym_assignment] = STATE(1361),
    [sym_augmented_assignment] = STATE(1361),
    [sym_pattern_list] = STATE(897),
    [sym_yield] = STATE(1361),
    [sym_attribute] = STATE(431),
    [sym_subscript] = STATE(431),
    [sym_call] = STATE(797),
    [sym_list] = STATE(797),
    [sym_set] = STATE(797),
    [sym_tuple] = STATE(797),
    [sym_dictionary] = STATE(797),
    [sym_list_comprehension] = STATE(797),
    [sym_dictionary_comprehension] = STATE(797),
    [sym_set_comprehension] = STATE(797),
    [sym_generator_expression] = STATE(797),
    [sym_parenthesized_expression] = STATE(797),
    [sym_conditional_expression] = STATE(1009),
    [sym_concatenated_string] = STATE(797),
    [sym_string] = STATE(713),
    [sym_await] = STATE(1009),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_STAR] = ACTIONS(15),
    [anon_sym_print] = ACTIONS(17),
    [anon_sym_assert] = ACTIONS(19),
    [anon_sym_return] = ACTIONS(21),
    [anon_sym_del] = ACTIONS(23),
    [anon_sym_raise] = ACTIONS(25),
    [anon_sym_pass] = ACTIONS(27),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_async] = ACTIONS(317),
    [anon_sym_match] = ACTIONS(317),
    [anon_sym_DASH] = ACTIONS(47),
    [anon_sym_PLUS] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(51),
    [anon_sym_STAR_STAR] = ACTIONS(53),
    [anon_sym_global] = ACTIONS(57),
    [anon_sym_nonlocal] = ACTIONS(59),
    [anon_sym_exec] = ACTIONS(61),
    [anon_sym_type] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(459),
    [sym__indent] = ACTIONS(461),
    [sym__string_start] = ACTIONS(81),
  },
  [107] = {
    [sym__simple_statements] = STATE(563),
    [sym_import_statement] = STATE(1319),
    [sym_future_import_statement] = STATE(1319),
    [sym_import_from_statement] = STATE(1319),
    [sym_print_statement] = STATE(1319),
    [sym_assert_statement] = STATE(1319),
    [sym_expression_statement] = STATE(1319),
    [sym_named_expression] = STATE(1009),
    [sym_return_statement] = STATE(1319),
    [sym_delete_statement] = STATE(1319),
    [sym_raise_statement] = STATE(1319),
    [sym_pass_statement] = STATE(1319),
    [sym_break_statement] = STATE(1319),
    [sym_continue_statement] = STATE(1319),
    [sym_list_splat] = STATE(1360),
    [sym_dictionary_splat] = STATE(1360),
    [sym_global_statement] = STATE(1319),
    [sym_nonlocal_statement] = STATE(1319),
    [sym_exec_statement] = STATE(1319),
    [sym_type_alias_statement] = STATE(1319),
    [sym_expression_list] = STATE(1361),
    [sym_pattern] = STATE(889),
    [sym_tuple_pattern] = STATE(875),
    [sym_list_pattern] = STATE(875),
    [sym_list_splat_pattern] = STATE(875),
    [sym_expression] = STATE(1019),
    [sym_primary_expression] = STATE(684),
    [sym_not_operator] = STATE(1009),
    [sym_boolean_operator] = STATE(1009),
    [sym_binary_operator] = STATE(797),
    [sym_unary_operator] = STATE(797),
    [sym_comparison_operator] = STATE(1009),
    [sym_lambda] = STATE(1009),
    [sym_assignment] = STATE(1361),
    [sym_augmented_assignment] = STATE(1361),
    [sym_pattern_list] = STATE(897),
    [sym_yield] = STATE(1361),
    [sym_attribute] = STATE(431),
    [sym_subscript] = STATE(431),
    [sym_call] = STATE(797),
    [sym_list] = STATE(797),
    [sym_set] = STATE(797),
    [sym_tuple] = STATE(797),
    [sym_dictionary] = STATE(797),
    [sym_list_comprehension] = STATE(797),
    [sym_dictionary_comprehension] = STATE(797),
    [sym_set_comprehension] = STATE(797),
    [sym_generator_expression] = STATE(797),
    [sym_parenthesized_expression] = STATE(797),
    [sym_conditional_expression] = STATE(1009),
    [sym_concatenated_string] = STATE(797),
    [sym_string] = STATE(713),
    [sym_await] = STATE(1009),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_STAR] = ACTIONS(15),
    [anon_sym_print] = ACTIONS(17),
    [anon_sym_assert] = ACTIONS(19),
    [anon_sym_return] = ACTIONS(21),
    [anon_sym_del] = ACTIONS(23),
    [anon_sym_raise] = ACTIONS(25),
    [anon_sym_pass] = ACTIONS(27),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_async] = ACTIONS(317),
    [anon_sym_match] = ACTIONS(317),
    [anon_sym_DASH] = ACTIONS(47),
    [anon_sym_PLUS] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(51),
    [anon_sym_STAR_STAR] = ACTIONS(53),
    [anon_sym_global] = ACTIONS(57),
    [anon_sym_nonlocal] = ACTIONS(59),
    [anon_sym_exec] = ACTIONS(61),
    [anon_sym_type] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(463),
    [sym__indent] = ACTIONS(465),
    [sym__string_start] = ACTIONS(81),
  },
  [108] = {
    [sym__simple_statements] = STATE(580),
    [sym_import_statement] = STATE(1319),
    [sym_future_import_statement] = STATE(1319),
    [sym_import_from_statement] = STATE(1319),
    [sym_print_statement] = STATE(1319),
    [sym_assert_statement] = STATE(1319),
    [sym_expression_statement] = STATE(1319),
    [sym_named_expression] = STATE(1009),
    [sym_return_statement] = STATE(1319),
    [sym_delete_statement] = STATE(1319),
    [sym_raise_statement] = STATE(1319),
    [sym_pass_statement] = STATE(1319),
    [sym_break_statement] = STATE(1319),
    [sym_continue_statement] = STATE(1319),
    [sym_list_splat] = STATE(1360),
    [sym_dictionary_splat] = STATE(1360),
    [sym_global_statement] = STATE(1319),
    [sym_nonlocal_statement] = STATE(1319),
    [sym_exec_statement] = STATE(1319),
    [sym_type_alias_statement] = STATE(1319),
    [sym_expression_list] = STATE(1361),
    [sym_pattern] = STATE(889),
    [sym_tuple_pattern] = STATE(875),
    [sym_list_pattern] = STATE(875),
    [sym_list_splat_pattern] = STATE(875),
    [sym_expression] = STATE(1019),
    [sym_primary_expression] = STATE(684),
    [sym_not_operator] = STATE(1009),
    [sym_boolean_operator] = STATE(1009),
    [sym_binary_operator] = STATE(797),
    [sym_unary_operator] = STATE(797),
    [sym_comparison_operator] = STATE(1009),
    [sym_lambda] = STATE(1009),
    [sym_assignment] = STATE(1361),
    [sym_augmented_assignment] = STATE(1361),
    [sym_pattern_list] = STATE(897),
    [sym_yield] = STATE(1361),
    [sym_attribute] = STATE(431),
    [sym_subscript] = STATE(431),
    [sym_call] = STATE(797),
    [sym_list] = STATE(797),
    [sym_set] = STATE(797),
    [sym_tuple] = STATE(797),
    [sym_dictionary] = STATE(797),
    [sym_list_comprehension] = STATE(797),
    [sym_dictionary_comprehension] = STATE(797),
    [sym_set_comprehension] = STATE(797),
    [sym_generator_expression] = STATE(797),
    [sym_parenthesized_expression] = STATE(797),
    [sym_conditional_expression] = STATE(1009),
    [sym_concatenated_string] = STATE(797),
    [sym_string] = STATE(713),
    [sym_await] = STATE(1009),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_STAR] = ACTIONS(15),
    [anon_sym_print] = ACTIONS(17),
    [anon_sym_assert] = ACTIONS(19),
    [anon_sym_return] = ACTIONS(21),
    [anon_sym_del] = ACTIONS(23),
    [anon_sym_raise] = ACTIONS(25),
    [anon_sym_pass] = ACTIONS(27),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_async] = ACTIONS(317),
    [anon_sym_match] = ACTIONS(317),
    [anon_sym_DASH] = ACTIONS(47),
    [anon_sym_PLUS] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(51),
    [anon_sym_STAR_STAR] = ACTIONS(53),
    [anon_sym_global] = ACTIONS(57),
    [anon_sym_nonlocal] = ACTIONS(59),
    [anon_sym_exec] = ACTIONS(61),
    [anon_sym_type] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(467),
    [sym__indent] = ACTIONS(469),
    [sym__string_start] = ACTIONS(81),
  },
  [109] = {
    [sym__simple_statements] = STATE(991),
    [sym_import_statement] = STATE(1214),
    [sym_future_import_statement] = STATE(1214),
    [sym_import_from_statement] = STATE(1214),
    [sym_print_statement] = STATE(1214),
    [sym_assert_statement] = STATE(1214),
    [sym_expression_statement] = STATE(1214),
    [sym_named_expression] = STATE(1009),
    [sym_return_statement] = STATE(1214),
    [sym_delete_statement] = STATE(1214),
    [sym_raise_statement] = STATE(1214),
    [sym_pass_statement] = STATE(1214),
    [sym_break_statement] = STATE(1214),
    [sym_continue_statement] = STATE(1214),
    [sym_list_splat] = STATE(1360),
    [sym_dictionary_splat] = STATE(1360),
    [sym_global_statement] = STATE(1214),
    [sym_nonlocal_statement] = STATE(1214),
    [sym_exec_statement] = STATE(1214),
    [sym_type_alias_statement] = STATE(1214),
    [sym_expression_list] = STATE(1361),
    [sym_pattern] = STATE(889),
    [sym_tuple_pattern] = STATE(875),
    [sym_list_pattern] = STATE(875),
    [sym_list_splat_pattern] = STATE(875),
    [sym_expression] = STATE(1019),
    [sym_primary_expression] = STATE(684),
    [sym_not_operator] = STATE(1009),
    [sym_boolean_operator] = STATE(1009),
    [sym_binary_operator] = STATE(797),
    [sym_unary_operator] = STATE(797),
    [sym_comparison_operator] = STATE(1009),
    [sym_lambda] = STATE(1009),
    [sym_assignment] = STATE(1361),
    [sym_augmented_assignment] = STATE(1361),
    [sym_pattern_list] = STATE(897),
    [sym_yield] = STATE(1361),
    [sym_attribute] = STATE(431),
    [sym_subscript] = STATE(431),
    [sym_call] = STATE(797),
    [sym_list] = STATE(797),
    [sym_set] = STATE(797),
    [sym_tuple] = STATE(797),
    [sym_dictionary] = STATE(797),
    [sym_list_comprehension] = STATE(797),
    [sym_dictionary_comprehension] = STATE(797),
    [sym_set_comprehension] = STATE(797),
    [sym_generator_expression] = STATE(797),
    [sym_parenthesized_expression] = STATE(797),
    [sym_conditional_expression] = STATE(1009),
    [sym_concatenated_string] = STATE(797),
    [sym_string] = STATE(713),
    [sym_await] = STATE(1009),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_STAR] = ACTIONS(15),
    [anon_sym_print] = ACTIONS(17),
    [anon_sym_assert] = ACTIONS(19),
    [anon_sym_return] = ACTIONS(21),
    [anon_sym_del] = ACTIONS(23),
    [anon_sym_raise] = ACTIONS(25),
    [anon_sym_pass] = ACTIONS(27),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_async] = ACTIONS(317),
    [anon_sym_match] = ACTIONS(317),
    [anon_sym_DASH] = ACTIONS(47),
    [anon_sym_PLUS] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(51),
    [anon_sym_STAR_STAR] = ACTIONS(53),
    [anon_sym_global] = ACTIONS(57),
    [anon_sym_nonlocal] = ACTIONS(59),
    [anon_sym_exec] = ACTIONS(61),
    [anon_sym_type] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(471),
    [sym__indent] = ACTIONS(473),
    [sym__string_start] = ACTIONS(81),
  },
  [110] = {
    [sym__simple_statements] = STATE(478),
    [sym_import_statement] = STATE(1319),
    [sym_future_import_statement] = STATE(1319),
    [sym_import_from_statement] = STATE(1319),
    [sym_print_statement] = STATE(1319),
    [sym_assert_statement] = STATE(1319),
    [sym_expression_statement] = STATE(1319),
    [sym_named_expression] = STATE(1009),
    [sym_return_statement] = STATE(1319),
    [sym_delete_statement] = STATE(1319),
    [sym_raise_statement] = STATE(1319),
    [sym_pass_statement] = STATE(1319),
    [sym_break_statement] = STATE(1319),
    [sym_continue_statement] = STATE(1319),
    [sym_list_splat] = STATE(1360),
    [sym_dictionary_splat] = STATE(1360),
    [sym_global_statement] = STATE(1319),
    [sym_nonlocal_statement] = STATE(1319),
    [sym_exec_statement] = STATE(1319),
    [sym_type_alias_statement] = STATE(1319),
    [sym_expression_list] = STATE(1361),
    [sym_pattern] = STATE(889),
    [sym_tuple_pattern] = STATE(875),
    [sym_list_pattern] = STATE(875),
    [sym_list_splat_pattern] = STATE(875),
    [sym_expression] = STATE(1019),
    [sym_primary_expression] = STATE(684),
    [sym_not_operator] = STATE(1009),
    [sym_boolean_operator] = STATE(1009),
    [sym_binary_operator] = STATE(797),
    [sym_unary_operator] = STATE(797),
    [sym_comparison_operator] = STATE(1009),
    [sym_lambda] = STATE(1009),
    [sym_assignment] = STATE(1361),
    [sym_augmented_assignment] = STATE(1361),
    [sym_pattern_list] = STATE(897),
    [sym_yield] = STATE(1361),
    [sym_attribute] = STATE(431),
    [sym_subscript] = STATE(431),
    [sym_call] = STATE(797),
    [sym_list] = STATE(797),
    [sym_set] = STATE(797),
    [sym_tuple] = STATE(797),
    [sym_dictionary] = STATE(797),
    [sym_list_comprehension] = STATE(797),
    [sym_dictionary_comprehension] = STATE(797),
    [sym_set_comprehension] = STATE(797),
    [sym_generator_expression] = STATE(797),
    [sym_parenthesized_expression] = STATE(797),
    [sym_conditional_expression] = STATE(1009),
    [sym_concatenated_string] = STATE(797),
    [sym_string] = STATE(713),
    [sym_await] = STATE(1009),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_STAR] = ACTIONS(15),
    [anon_sym_print] = ACTIONS(17),
    [anon_sym_assert] = ACTIONS(19),
    [anon_sym_return] = ACTIONS(21),
    [anon_sym_del] = ACTIONS(23),
    [anon_sym_raise] = ACTIONS(25),
    [anon_sym_pass] = ACTIONS(27),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_async] = ACTIONS(317),
    [anon_sym_match] = ACTIONS(317),
    [anon_sym_DASH] = ACTIONS(47),
    [anon_sym_PLUS] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(51),
    [anon_sym_STAR_STAR] = ACTIONS(53),
    [anon_sym_global] = ACTIONS(57),
    [anon_sym_nonlocal] = ACTIONS(59),
    [anon_sym_exec] = ACTIONS(61),
    [anon_sym_type] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(475),
    [sym__indent] = ACTIONS(477),
    [sym__string_start] = ACTIONS(81),
  },
  [111] = {
    [sym__simple_statements] = STATE(272),
    [sym_import_statement] = STATE(1319),
    [sym_future_import_statement] = STATE(1319),
    [sym_import_from_statement] = STATE(1319),
    [sym_print_statement] = STATE(1319),
    [sym_assert_statement] = STATE(1319),
    [sym_expression_statement] = STATE(1319),
    [sym_named_expression] = STATE(1009),
    [sym_return_statement] = STATE(1319),
    [sym_delete_statement] = STATE(1319),
    [sym_raise_statement] = STATE(1319),
    [sym_pass_statement] = STATE(1319),
    [sym_break_statement] = STATE(1319),
    [sym_continue_statement] = STATE(1319),
    [sym_list_splat] = STATE(1360),
    [sym_dictionary_splat] = STATE(1360),
    [sym_global_statement] = STATE(1319),
    [sym_nonlocal_statement] = STATE(1319),
    [sym_exec_statement] = STATE(1319),
    [sym_type_alias_statement] = STATE(1319),
    [sym_expression_list] = STATE(1361),
    [sym_pattern] = STATE(889),
    [sym_tuple_pattern] = STATE(875),
    [sym_list_pattern] = STATE(875),
    [sym_list_splat_pattern] = STATE(875),
    [sym_expression] = STATE(1019),
    [sym_primary_expression] = STATE(684),
    [sym_not_operator] = STATE(1009),
    [sym_boolean_operator] = STATE(1009),
    [sym_binary_operator] = STATE(797),
    [sym_unary_operator] = STATE(797),
    [sym_comparison_operator] = STATE(1009),
    [sym_lambda] = STATE(1009),
    [sym_assignment] = STATE(1361),
    [sym_augmented_assignment] = STATE(1361),
    [sym_pattern_list] = STATE(897),
    [sym_yield] = STATE(1361),
    [sym_attribute] = STATE(431),
    [sym_subscript] = STATE(431),
    [sym_call] = STATE(797),
    [sym_list] = STATE(797),
    [sym_set] = STATE(797),
    [sym_tuple] = STATE(797),
    [sym_dictionary] = STATE(797),
    [sym_list_comprehension] = STATE(797),
    [sym_dictionary_comprehension] = STATE(797),
    [sym_set_comprehension] = STATE(797),
    [sym_generator_expression] = STATE(797),
    [sym_parenthesized_expression] = STATE(797),
    [sym_conditional_expression] = STATE(1009),
    [sym_concatenated_string] = STATE(797),
    [sym_string] = STATE(713),
    [sym_await] = STATE(1009),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_STAR] = ACTIONS(15),
    [anon_sym_print] = ACTIONS(17),
    [anon_sym_assert] = ACTIONS(19),
    [anon_sym_return] = ACTIONS(21),
    [anon_sym_del] = ACTIONS(23),
    [anon_sym_raise] = ACTIONS(25),
    [anon_sym_pass] = ACTIONS(27),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_async] = ACTIONS(317),
    [anon_sym_match] = ACTIONS(317),
    [anon_sym_DASH] = ACTIONS(47),
    [anon_sym_PLUS] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(51),
    [anon_sym_STAR_STAR] = ACTIONS(53),
    [anon_sym_global] = ACTIONS(57),
    [anon_sym_nonlocal] = ACTIONS(59),
    [anon_sym_exec] = ACTIONS(61),
    [anon_sym_type] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(479),
    [sym__indent] = ACTIONS(481),
    [sym__string_start] = ACTIONS(81),
  },
  [112] = {
    [sym__simple_statements] = STATE(490),
    [sym_import_statement] = STATE(1209),
    [sym_future_import_statement] = STATE(1209),
    [sym_import_from_statement] = STATE(1209),
    [sym_print_statement] = STATE(1209),
    [sym_assert_statement] = STATE(1209),
    [sym_expression_statement] = STATE(1209),
    [sym_named_expression] = STATE(1009),
    [sym_return_statement] = STATE(1209),
    [sym_delete_statement] = STATE(1209),
    [sym_raise_statement] = STATE(1209),
    [sym_pass_statement] = STATE(1209),
    [sym_break_statement] = STATE(1209),
    [sym_continue_statement] = STATE(1209),
    [sym_list_splat] = STATE(1360),
    [sym_dictionary_splat] = STATE(1360),
    [sym_global_statement] = STATE(1209),
    [sym_nonlocal_statement] = STATE(1209),
    [sym_exec_statement] = STATE(1209),
    [sym_type_alias_statement] = STATE(1209),
    [sym_expression_list] = STATE(1361),
    [sym_pattern] = STATE(889),
    [sym_tuple_pattern] = STATE(875),
    [sym_list_pattern] = STATE(875),
    [sym_list_splat_pattern] = STATE(875),
    [sym_expression] = STATE(1019),
    [sym_primary_expression] = STATE(684),
    [sym_not_operator] = STATE(1009),
    [sym_boolean_operator] = STATE(1009),
    [sym_binary_operator] = STATE(797),
    [sym_unary_operator] = STATE(797),
    [sym_comparison_operator] = STATE(1009),
    [sym_lambda] = STATE(1009),
    [sym_assignment] = STATE(1361),
    [sym_augmented_assignment] = STATE(1361),
    [sym_pattern_list] = STATE(897),
    [sym_yield] = STATE(1361),
    [sym_attribute] = STATE(431),
    [sym_subscript] = STATE(431),
    [sym_call] = STATE(797),
    [sym_list] = STATE(797),
    [sym_set] = STATE(797),
    [sym_tuple] = STATE(797),
    [sym_dictionary] = STATE(797),
    [sym_list_comprehension] = STATE(797),
    [sym_dictionary_comprehension] = STATE(797),
    [sym_set_comprehension] = STATE(797),
    [sym_generator_expression] = STATE(797),
    [sym_parenthesized_expression] = STATE(797),
    [sym_conditional_expression] = STATE(1009),
    [sym_concatenated_string] = STATE(797),
    [sym_string] = STATE(713),
    [sym_await] = STATE(1009),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_STAR] = ACTIONS(15),
    [anon_sym_print] = ACTIONS(17),
    [anon_sym_assert] = ACTIONS(19),
    [anon_sym_return] = ACTIONS(21),
    [anon_sym_del] = ACTIONS(23),
    [anon_sym_raise] = ACTIONS(25),
    [anon_sym_pass] = ACTIONS(27),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_async] = ACTIONS(317),
    [anon_sym_match] = ACTIONS(317),
    [anon_sym_DASH] = ACTIONS(47),
    [anon_sym_PLUS] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(51),
    [anon_sym_STAR_STAR] = ACTIONS(53),
    [anon_sym_global] = ACTIONS(57),
    [anon_sym_nonlocal] = ACTIONS(59),
    [anon_sym_exec] = ACTIONS(61),
    [anon_sym_type] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(483),
    [sym__indent] = ACTIONS(485),
    [sym__string_start] = ACTIONS(81),
  },
  [113] = {
    [sym__simple_statements] = STATE(589),
    [sym_import_statement] = STATE(1209),
    [sym_future_import_statement] = STATE(1209),
    [sym_import_from_statement] = STATE(1209),
    [sym_print_statement] = STATE(1209),
    [sym_assert_statement] = STATE(1209),
    [sym_expression_statement] = STATE(1209),
    [sym_named_expression] = STATE(1009),
    [sym_return_statement] = STATE(1209),
    [sym_delete_statement] = STATE(1209),
    [sym_raise_statement] = STATE(1209),
    [sym_pass_statement] = STATE(1209),
    [sym_break_statement] = STATE(1209),
    [sym_continue_statement] = STATE(1209),
    [sym_list_splat] = STATE(1360),
    [sym_dictionary_splat] = STATE(1360),
    [sym_global_statement] = STATE(1209),
    [sym_nonlocal_statement] = STATE(1209),
    [sym_exec_statement] = STATE(1209),
    [sym_type_alias_statement] = STATE(1209),
    [sym_expression_list] = STATE(1361),
    [sym_pattern] = STATE(889),
    [sym_tuple_pattern] = STATE(875),
    [sym_list_pattern] = STATE(875),
    [sym_list_splat_pattern] = STATE(875),
    [sym_expression] = STATE(1019),
    [sym_primary_expression] = STATE(684),
    [sym_not_operator] = STATE(1009),
    [sym_boolean_operator] = STATE(1009),
    [sym_binary_operator] = STATE(797),
    [sym_unary_operator] = STATE(797),
    [sym_comparison_operator] = STATE(1009),
    [sym_lambda] = STATE(1009),
    [sym_assignment] = STATE(1361),
    [sym_augmented_assignment] = STATE(1361),
    [sym_pattern_list] = STATE(897),
    [sym_yield] = STATE(1361),
    [sym_attribute] = STATE(431),
    [sym_subscript] = STATE(431),
    [sym_call] = STATE(797),
    [sym_list] = STATE(797),
    [sym_set] = STATE(797),
    [sym_tuple] = STATE(797),
    [sym_dictionary] = STATE(797),
    [sym_list_comprehension] = STATE(797),
    [sym_dictionary_comprehension] = STATE(797),
    [sym_set_comprehension] = STATE(797),
    [sym_generator_expression] = STATE(797),
    [sym_parenthesized_expression] = STATE(797),
    [sym_conditional_expression] = STATE(1009),
    [sym_concatenated_string] = STATE(797),
    [sym_string] = STATE(713),
    [sym_await] = STATE(1009),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_STAR] = ACTIONS(15),
    [anon_sym_print] = ACTIONS(17),
    [anon_sym_assert] = ACTIONS(19),
    [anon_sym_return] = ACTIONS(21),
    [anon_sym_del] = ACTIONS(23),
    [anon_sym_raise] = ACTIONS(25),
    [anon_sym_pass] = ACTIONS(27),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_async] = ACTIONS(317),
    [anon_sym_match] = ACTIONS(317),
    [anon_sym_DASH] = ACTIONS(47),
    [anon_sym_PLUS] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(51),
    [anon_sym_STAR_STAR] = ACTIONS(53),
    [anon_sym_global] = ACTIONS(57),
    [anon_sym_nonlocal] = ACTIONS(59),
    [anon_sym_exec] = ACTIONS(61),
    [anon_sym_type] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(487),
    [sym__indent] = ACTIONS(489),
    [sym__string_start] = ACTIONS(81),
  },
  [114] = {
    [sym__simple_statements] = STATE(388),
    [sym_import_statement] = STATE(1209),
    [sym_future_import_statement] = STATE(1209),
    [sym_import_from_statement] = STATE(1209),
    [sym_print_statement] = STATE(1209),
    [sym_assert_statement] = STATE(1209),
    [sym_expression_statement] = STATE(1209),
    [sym_named_expression] = STATE(1009),
    [sym_return_statement] = STATE(1209),
    [sym_delete_statement] = STATE(1209),
    [sym_raise_statement] = STATE(1209),
    [sym_pass_statement] = STATE(1209),
    [sym_break_statement] = STATE(1209),
    [sym_continue_statement] = STATE(1209),
    [sym_list_splat] = STATE(1360),
    [sym_dictionary_splat] = STATE(1360),
    [sym_global_statement] = STATE(1209),
    [sym_nonlocal_statement] = STATE(1209),
    [sym_exec_statement] = STATE(1209),
    [sym_type_alias_statement] = STATE(1209),
    [sym_expression_list] = STATE(1361),
    [sym_pattern] = STATE(889),
    [sym_tuple_pattern] = STATE(875),
    [sym_list_pattern] = STATE(875),
    [sym_list_splat_pattern] = STATE(875),
    [sym_expression] = STATE(1019),
    [sym_primary_expression] = STATE(684),
    [sym_not_operator] = STATE(1009),
    [sym_boolean_operator] = STATE(1009),
    [sym_binary_operator] = STATE(797),
    [sym_unary_operator] = STATE(797),
    [sym_comparison_operator] = STATE(1009),
    [sym_lambda] = STATE(1009),
    [sym_assignment] = STATE(1361),
    [sym_augmented_assignment] = STATE(1361),
    [sym_pattern_list] = STATE(897),
    [sym_yield] = STATE(1361),
    [sym_attribute] = STATE(431),
    [sym_subscript] = STATE(431),
    [sym_call] = STATE(797),
    [sym_list] = STATE(797),
    [sym_set] = STATE(797),
    [sym_tuple] = STATE(797),
    [sym_dictionary] = STATE(797),
    [sym_list_comprehension] = STATE(797),
    [sym_dictionary_comprehension] = STATE(797),
    [sym_set_comprehension] = STATE(797),
    [sym_generator_expression] = STATE(797),
    [sym_parenthesized_expression] = STATE(797),
    [sym_conditional_expression] = STATE(1009),
    [sym_concatenated_string] = STATE(797),
    [sym_string] = STATE(713),
    [sym_await] = STATE(1009),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_STAR] = ACTIONS(15),
    [anon_sym_print] = ACTIONS(17),
    [anon_sym_assert] = ACTIONS(19),
    [anon_sym_return] = ACTIONS(21),
    [anon_sym_del] = ACTIONS(23),
    [anon_sym_raise] = ACTIONS(25),
    [anon_sym_pass] = ACTIONS(27),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_async] = ACTIONS(317),
    [anon_sym_match] = ACTIONS(317),
    [anon_sym_DASH] = ACTIONS(47),
    [anon_sym_PLUS] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(51),
    [anon_sym_STAR_STAR] = ACTIONS(53),
    [anon_sym_global] = ACTIONS(57),
    [anon_sym_nonlocal] = ACTIONS(59),
    [anon_sym_exec] = ACTIONS(61),
    [anon_sym_type] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(491),
    [sym__indent] = ACTIONS(493),
    [sym__string_start] = ACTIONS(81),
  },
  [115] = {
    [sym__simple_statements] = STATE(572),
    [sym_import_statement] = STATE(1209),
    [sym_future_import_statement] = STATE(1209),
    [sym_import_from_statement] = STATE(1209),
    [sym_print_statement] = STATE(1209),
    [sym_assert_statement] = STATE(1209),
    [sym_expression_statement] = STATE(1209),
    [sym_named_expression] = STATE(1009),
    [sym_return_statement] = STATE(1209),
    [sym_delete_statement] = STATE(1209),
    [sym_raise_statement] = STATE(1209),
    [sym_pass_statement] = STATE(1209),
    [sym_break_statement] = STATE(1209),
    [sym_continue_statement] = STATE(1209),
    [sym_list_splat] = STATE(1360),
    [sym_dictionary_splat] = STATE(1360),
    [sym_global_statement] = STATE(1209),
    [sym_nonlocal_statement] = STATE(1209),
    [sym_exec_statement] = STATE(1209),
    [sym_type_alias_statement] = STATE(1209),
    [sym_expression_list] = STATE(1361),
    [sym_pattern] = STATE(889),
    [sym_tuple_pattern] = STATE(875),
    [sym_list_pattern] = STATE(875),
    [sym_list_splat_pattern] = STATE(875),
    [sym_expression] = STATE(1019),
    [sym_primary_expression] = STATE(684),
    [sym_not_operator] = STATE(1009),
    [sym_boolean_operator] = STATE(1009),
    [sym_binary_operator] = STATE(797),
    [sym_unary_operator] = STATE(797),
    [sym_comparison_operator] = STATE(1009),
    [sym_lambda] = STATE(1009),
    [sym_assignment] = STATE(1361),
    [sym_augmented_assignment] = STATE(1361),
    [sym_pattern_list] = STATE(897),
    [sym_yield] = STATE(1361),
    [sym_attribute] = STATE(431),
    [sym_subscript] = STATE(431),
    [sym_call] = STATE(797),
    [sym_list] = STATE(797),
    [sym_set] = STATE(797),
    [sym_tuple] = STATE(797),
    [sym_dictionary] = STATE(797),
    [sym_list_comprehension] = STATE(797),
    [sym_dictionary_comprehension] = STATE(797),
    [sym_set_comprehension] = STATE(797),
    [sym_generator_expression] = STATE(797),
    [sym_parenthesized_expression] = STATE(797),
    [sym_conditional_expression] = STATE(1009),
    [sym_concatenated_string] = STATE(797),
    [sym_string] = STATE(713),
    [sym_await] = STATE(1009),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_STAR] = ACTIONS(15),
    [anon_sym_print] = ACTIONS(17),
    [anon_sym_assert] = ACTIONS(19),
    [anon_sym_return] = ACTIONS(21),
    [anon_sym_del] = ACTIONS(23),
    [anon_sym_raise] = ACTIONS(25),
    [anon_sym_pass] = ACTIONS(27),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_async] = ACTIONS(317),
    [anon_sym_match] = ACTIONS(317),
    [anon_sym_DASH] = ACTIONS(47),
    [anon_sym_PLUS] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(51),
    [anon_sym_STAR_STAR] = ACTIONS(53),
    [anon_sym_global] = ACTIONS(57),
    [anon_sym_nonlocal] = ACTIONS(59),
    [anon_sym_exec] = ACTIONS(61),
    [anon_sym_type] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(495),
    [sym__indent] = ACTIONS(497),
    [sym__string_start] = ACTIONS(81),
  },
  [116] = {
    [sym__simple_statements] = STATE(485),
    [sym_import_statement] = STATE(1319),
    [sym_future_import_statement] = STATE(1319),
    [sym_import_from_statement] = STATE(1319),
    [sym_print_statement] = STATE(1319),
    [sym_assert_statement] = STATE(1319),
    [sym_expression_statement] = STATE(1319),
    [sym_named_expression] = STATE(1009),
    [sym_return_statement] = STATE(1319),
    [sym_delete_statement] = STATE(1319),
    [sym_raise_statement] = STATE(1319),
    [sym_pass_statement] = STATE(1319),
    [sym_break_statement] = STATE(1319),
    [sym_continue_statement] = STATE(1319),
    [sym_list_splat] = STATE(1360),
    [sym_dictionary_splat] = STATE(1360),
    [sym_global_statement] = STATE(1319),
    [sym_nonlocal_statement] = STATE(1319),
    [sym_exec_statement] = STATE(1319),
    [sym_type_alias_statement] = STATE(1319),
    [sym_expression_list] = STATE(1361),
    [sym_pattern] = STATE(889),
    [sym_tuple_pattern] = STATE(875),
    [sym_list_pattern] = STATE(875),
    [sym_list_splat_pattern] = STATE(875),
    [sym_expression] = STATE(1019),
    [sym_primary_expression] = STATE(684),
    [sym_not_operator] = STATE(1009),
    [sym_boolean_operator] = STATE(1009),
    [sym_binary_operator] = STATE(797),
    [sym_unary_operator] = STATE(797),
    [sym_comparison_operator] = STATE(1009),
    [sym_lambda] = STATE(1009),
    [sym_assignment] = STATE(1361),
    [sym_augmented_assignment] = STATE(1361),
    [sym_pattern_list] = STATE(897),
    [sym_yield] = STATE(1361),
    [sym_attribute] = STATE(431),
    [sym_subscript] = STATE(431),
    [sym_call] = STATE(797),
    [sym_list] = STATE(797),
    [sym_set] = STATE(797),
    [sym_tuple] = STATE(797),
    [sym_dictionary] = STATE(797),
    [sym_list_comprehension] = STATE(797),
    [sym_dictionary_comprehension] = STATE(797),
    [sym_set_comprehension] = STATE(797),
    [sym_generator_expression] = STATE(797),
    [sym_parenthesized_expression] = STATE(797),
    [sym_conditional_expression] = STATE(1009),
    [sym_concatenated_string] = STATE(797),
    [sym_string] = STATE(713),
    [sym_await] = STATE(1009),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_STAR] = ACTIONS(15),
    [anon_sym_print] = ACTIONS(17),
    [anon_sym_assert] = ACTIONS(19),
    [anon_sym_return] = ACTIONS(21),
    [anon_sym_del] = ACTIONS(23),
    [anon_sym_raise] = ACTIONS(25),
    [anon_sym_pass] = ACTIONS(27),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_async] = ACTIONS(317),
    [anon_sym_match] = ACTIONS(317),
    [anon_sym_DASH] = ACTIONS(47),
    [anon_sym_PLUS] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(51),
    [anon_sym_STAR_STAR] = ACTIONS(53),
    [anon_sym_global] = ACTIONS(57),
    [anon_sym_nonlocal] = ACTIONS(59),
    [anon_sym_exec] = ACTIONS(61),
    [anon_sym_type] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(499),
    [sym__indent] = ACTIONS(501),
    [sym__string_start] = ACTIONS(81),
  },
  [117] = {
    [sym__simple_statements] = STATE(501),
    [sym_import_statement] = STATE(1209),
    [sym_future_import_statement] = STATE(1209),
    [sym_import_from_statement] = STATE(1209),
    [sym_print_statement] = STATE(1209),
    [sym_assert_statement] = STATE(1209),
    [sym_expression_statement] = STATE(1209),
    [sym_named_expression] = STATE(1009),
    [sym_return_statement] = STATE(1209),
    [sym_delete_statement] = STATE(1209),
    [sym_raise_statement] = STATE(1209),
    [sym_pass_statement] = STATE(1209),
    [sym_break_statement] = STATE(1209),
    [sym_continue_statement] = STATE(1209),
    [sym_list_splat] = STATE(1360),
    [sym_dictionary_splat] = STATE(1360),
    [sym_global_statement] = STATE(1209),
    [sym_nonlocal_statement] = STATE(1209),
    [sym_exec_statement] = STATE(1209),
    [sym_type_alias_statement] = STATE(1209),
    [sym_expression_list] = STATE(1361),
    [sym_pattern] = STATE(889),
    [sym_tuple_pattern] = STATE(875),
    [sym_list_pattern] = STATE(875),
    [sym_list_splat_pattern] = STATE(875),
    [sym_expression] = STATE(1019),
    [sym_primary_expression] = STATE(684),
    [sym_not_operator] = STATE(1009),
    [sym_boolean_operator] = STATE(1009),
    [sym_binary_operator] = STATE(797),
    [sym_unary_operator] = STATE(797),
    [sym_comparison_operator] = STATE(1009),
    [sym_lambda] = STATE(1009),
    [sym_assignment] = STATE(1361),
    [sym_augmented_assignment] = STATE(1361),
    [sym_pattern_list] = STATE(897),
    [sym_yield] = STATE(1361),
    [sym_attribute] = STATE(431),
    [sym_subscript] = STATE(431),
    [sym_call] = STATE(797),
    [sym_list] = STATE(797),
    [sym_set] = STATE(797),
    [sym_tuple] = STATE(797),
    [sym_dictionary] = STATE(797),
    [sym_list_comprehension] = STATE(797),
    [sym_dictionary_comprehension] = STATE(797),
    [sym_set_comprehension] = STATE(797),
    [sym_generator_expression] = STATE(797),
    [sym_parenthesized_expression] = STATE(797),
    [sym_conditional_expression] = STATE(1009),
    [sym_concatenated_string] = STATE(797),
    [sym_string] = STATE(713),
    [sym_await] = STATE(1009),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_STAR] = ACTIONS(15),
    [anon_sym_print] = ACTIONS(17),
    [anon_sym_assert] = ACTIONS(19),
    [anon_sym_return] = ACTIONS(21),
    [anon_sym_del] = ACTIONS(23),
    [anon_sym_raise] = ACTIONS(25),
    [anon_sym_pass] = ACTIONS(27),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_async] = ACTIONS(317),
    [anon_sym_match] = ACTIONS(317),
    [anon_sym_DASH] = ACTIONS(47),
    [anon_sym_PLUS] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(51),
    [anon_sym_STAR_STAR] = ACTIONS(53),
    [anon_sym_global] = ACTIONS(57),
    [anon_sym_nonlocal] = ACTIONS(59),
    [anon_sym_exec] = ACTIONS(61),
    [anon_sym_type] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(503),
    [sym__indent] = ACTIONS(505),
    [sym__string_start] = ACTIONS(81),
  },
  [118] = {
    [sym__simple_statements] = STATE(430),
    [sym_import_statement] = STATE(1209),
    [sym_future_import_statement] = STATE(1209),
    [sym_import_from_statement] = STATE(1209),
    [sym_print_statement] = STATE(1209),
    [sym_assert_statement] = STATE(1209),
    [sym_expression_statement] = STATE(1209),
    [sym_named_expression] = STATE(1009),
    [sym_return_statement] = STATE(1209),
    [sym_delete_statement] = STATE(1209),
    [sym_raise_statement] = STATE(1209),
    [sym_pass_statement] = STATE(1209),
    [sym_break_statement] = STATE(1209),
    [sym_continue_statement] = STATE(1209),
    [sym_list_splat] = STATE(1360),
    [sym_dictionary_splat] = STATE(1360),
    [sym_global_statement] = STATE(1209),
    [sym_nonlocal_statement] = STATE(1209),
    [sym_exec_statement] = STATE(1209),
    [sym_type_alias_statement] = STATE(1209),
    [sym_expression_list] = STATE(1361),
    [sym_pattern] = STATE(889),
    [sym_tuple_pattern] = STATE(875),
    [sym_list_pattern] = STATE(875),
    [sym_list_splat_pattern] = STATE(875),
    [sym_expression] = STATE(1019),
    [sym_primary_expression] = STATE(684),
    [sym_not_operator] = STATE(1009),
    [sym_boolean_operator] = STATE(1009),
    [sym_binary_operator] = STATE(797),
    [sym_unary_operator] = STATE(797),
    [sym_comparison_operator] = STATE(1009),
    [sym_lambda] = STATE(1009),
    [sym_assignment] = STATE(1361),
    [sym_augmented_assignment] = STATE(1361),
    [sym_pattern_list] = STATE(897),
    [sym_yield] = STATE(1361),
    [sym_attribute] = STATE(431),
    [sym_subscript] = STATE(431),
    [sym_call] = STATE(797),
    [sym_list] = STATE(797),
    [sym_set] = STATE(797),
    [sym_tuple] = STATE(797),
    [sym_dictionary] = STATE(797),
    [sym_list_comprehension] = STATE(797),
    [sym_dictionary_comprehension] = STATE(797),
    [sym_set_comprehension] = STATE(797),
    [sym_generator_expression] = STATE(797),
    [sym_parenthesized_expression] = STATE(797),
    [sym_conditional_expression] = STATE(1009),
    [sym_concatenated_string] = STATE(797),
    [sym_string] = STATE(713),
    [sym_await] = STATE(1009),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_STAR] = ACTIONS(15),
    [anon_sym_print] = ACTIONS(17),
    [anon_sym_assert] = ACTIONS(19),
    [anon_sym_return] = ACTIONS(21),
    [anon_sym_del] = ACTIONS(23),
    [anon_sym_raise] = ACTIONS(25),
    [anon_sym_pass] = ACTIONS(27),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_async] = ACTIONS(317),
    [anon_sym_match] = ACTIONS(317),
    [anon_sym_DASH] = ACTIONS(47),
    [anon_sym_PLUS] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(51),
    [anon_sym_STAR_STAR] = ACTIONS(53),
    [anon_sym_global] = ACTIONS(57),
    [anon_sym_nonlocal] = ACTIONS(59),
    [anon_sym_exec] = ACTIONS(61),
    [anon_sym_type] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(507),
    [sym__indent] = ACTIONS(509),
    [sym__string_start] = ACTIONS(81),
  },
  [119] = {
    [sym__simple_statements] = STATE(497),
    [sym_import_statement] = STATE(1209),
    [sym_future_import_statement] = STATE(1209),
    [sym_import_from_statement] = STATE(1209),
    [sym_print_statement] = STATE(1209),
    [sym_assert_statement] = STATE(1209),
    [sym_expression_statement] = STATE(1209),
    [sym_named_expression] = STATE(1009),
    [sym_return_statement] = STATE(1209),
    [sym_delete_statement] = STATE(1209),
    [sym_raise_statement] = STATE(1209),
    [sym_pass_statement] = STATE(1209),
    [sym_break_statement] = STATE(1209),
    [sym_continue_statement] = STATE(1209),
    [sym_list_splat] = STATE(1360),
    [sym_dictionary_splat] = STATE(1360),
    [sym_global_statement] = STATE(1209),
    [sym_nonlocal_statement] = STATE(1209),
    [sym_exec_statement] = STATE(1209),
    [sym_type_alias_statement] = STATE(1209),
    [sym_expression_list] = STATE(1361),
    [sym_pattern] = STATE(889),
    [sym_tuple_pattern] = STATE(875),
    [sym_list_pattern] = STATE(875),
    [sym_list_splat_pattern] = STATE(875),
    [sym_expression] = STATE(1019),
    [sym_primary_expression] = STATE(684),
    [sym_not_operator] = STATE(1009),
    [sym_boolean_operator] = STATE(1009),
    [sym_binary_operator] = STATE(797),
    [sym_unary_operator] = STATE(797),
    [sym_comparison_operator] = STATE(1009),
    [sym_lambda] = STATE(1009),
    [sym_assignment] = STATE(1361),
    [sym_augmented_assignment] = STATE(1361),
    [sym_pattern_list] = STATE(897),
    [sym_yield] = STATE(1361),
    [sym_attribute] = STATE(431),
    [sym_subscript] = STATE(431),
    [sym_call] = STATE(797),
    [sym_list] = STATE(797),
    [sym_set] = STATE(797),
    [sym_tuple] = STATE(797),
    [sym_dictionary] = STATE(797),
    [sym_list_comprehension] = STATE(797),
    [sym_dictionary_comprehension] = STATE(797),
    [sym_set_comprehension] = STATE(797),
    [sym_generator_expression] = STATE(797),
    [sym_parenthesized_expression] = STATE(797),
    [sym_conditional_expression] = STATE(1009),
    [sym_concatenated_string] = STATE(797),
    [sym_string] = STATE(713),
    [sym_await] = STATE(1009),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_STAR] = ACTIONS(15),
    [anon_sym_print] = ACTIONS(17),
    [anon_sym_assert] = ACTIONS(19),
    [anon_sym_return] = ACTIONS(21),
    [anon_sym_del] = ACTIONS(23),
    [anon_sym_raise] = ACTIONS(25),
    [anon_sym_pass] = ACTIONS(27),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_async] = ACTIONS(317),
    [anon_sym_match] = ACTIONS(317),
    [anon_sym_DASH] = ACTIONS(47),
    [anon_sym_PLUS] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(51),
    [anon_sym_STAR_STAR] = ACTIONS(53),
    [anon_sym_global] = ACTIONS(57),
    [anon_sym_nonlocal] = ACTIONS(59),
    [anon_sym_exec] = ACTIONS(61),
    [anon_sym_type] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(511),
    [sym__indent] = ACTIONS(513),
    [sym__string_start] = ACTIONS(81),
  },
  [120] = {
    [sym__simple_statements] = STATE(553),
    [sym_import_statement] = STATE(1209),
    [sym_future_import_statement] = STATE(1209),
    [sym_import_from_statement] = STATE(1209),
    [sym_print_statement] = STATE(1209),
    [sym_assert_statement] = STATE(1209),
    [sym_expression_statement] = STATE(1209),
    [sym_named_expression] = STATE(1009),
    [sym_return_statement] = STATE(1209),
    [sym_delete_statement] = STATE(1209),
    [sym_raise_statement] = STATE(1209),
    [sym_pass_statement] = STATE(1209),
    [sym_break_statement] = STATE(1209),
    [sym_continue_statement] = STATE(1209),
    [sym_list_splat] = STATE(1360),
    [sym_dictionary_splat] = STATE(1360),
    [sym_global_statement] = STATE(1209),
    [sym_nonlocal_statement] = STATE(1209),
    [sym_exec_statement] = STATE(1209),
    [sym_type_alias_statement] = STATE(1209),
    [sym_expression_list] = STATE(1361),
    [sym_pattern] = STATE(889),
    [sym_tuple_pattern] = STATE(875),
    [sym_list_pattern] = STATE(875),
    [sym_list_splat_pattern] = STATE(875),
    [sym_expression] = STATE(1019),
    [sym_primary_expression] = STATE(684),
    [sym_not_operator] = STATE(1009),
    [sym_boolean_operator] = STATE(1009),
    [sym_binary_operator] = STATE(797),
    [sym_unary_operator] = STATE(797),
    [sym_comparison_operator] = STATE(1009),
    [sym_lambda] = STATE(1009),
    [sym_assignment] = STATE(1361),
    [sym_augmented_assignment] = STATE(1361),
    [sym_pattern_list] = STATE(897),
    [sym_yield] = STATE(1361),
    [sym_attribute] = STATE(431),
    [sym_subscript] = STATE(431),
    [sym_call] = STATE(797),
    [sym_list] = STATE(797),
    [sym_set] = STATE(797),
    [sym_tuple] = STATE(797),
    [sym_dictionary] = STATE(797),
    [sym_list_comprehension] = STATE(797),
    [sym_dictionary_comprehension] = STATE(797),
    [sym_set_comprehension] = STATE(797),
    [sym_generator_expression] = STATE(797),
    [sym_parenthesized_expression] = STATE(797),
    [sym_conditional_expression] = STATE(1009),
    [sym_concatenated_string] = STATE(797),
    [sym_string] = STATE(713),
    [sym_await] = STATE(1009),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_STAR] = ACTIONS(15),
    [anon_sym_print] = ACTIONS(17),
    [anon_sym_assert] = ACTIONS(19),
    [anon_sym_return] = ACTIONS(21),
    [anon_sym_del] = ACTIONS(23),
    [anon_sym_raise] = ACTIONS(25),
    [anon_sym_pass] = ACTIONS(27),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_async] = ACTIONS(317),
    [anon_sym_match] = ACTIONS(317),
    [anon_sym_DASH] = ACTIONS(47),
    [anon_sym_PLUS] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(51),
    [anon_sym_STAR_STAR] = ACTIONS(53),
    [anon_sym_global] = ACTIONS(57),
    [anon_sym_nonlocal] = ACTIONS(59),
    [anon_sym_exec] = ACTIONS(61),
    [anon_sym_type] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(515),
    [sym__indent] = ACTIONS(517),
    [sym__string_start] = ACTIONS(81),
  },
  [121] = {
    [sym__simple_statements] = STATE(486),
    [sym_import_statement] = STATE(1209),
    [sym_future_import_statement] = STATE(1209),
    [sym_import_from_statement] = STATE(1209),
    [sym_print_statement] = STATE(1209),
    [sym_assert_statement] = STATE(1209),
    [sym_expression_statement] = STATE(1209),
    [sym_named_expression] = STATE(1009),
    [sym_return_statement] = STATE(1209),
    [sym_delete_statement] = STATE(1209),
    [sym_raise_statement] = STATE(1209),
    [sym_pass_statement] = STATE(1209),
    [sym_break_statement] = STATE(1209),
    [sym_continue_statement] = STATE(1209),
    [sym_list_splat] = STATE(1360),
    [sym_dictionary_splat] = STATE(1360),
    [sym_global_statement] = STATE(1209),
    [sym_nonlocal_statement] = STATE(1209),
    [sym_exec_statement] = STATE(1209),
    [sym_type_alias_statement] = STATE(1209),
    [sym_expression_list] = STATE(1361),
    [sym_pattern] = STATE(889),
    [sym_tuple_pattern] = STATE(875),
    [sym_list_pattern] = STATE(875),
    [sym_list_splat_pattern] = STATE(875),
    [sym_expression] = STATE(1019),
    [sym_primary_expression] = STATE(684),
    [sym_not_operator] = STATE(1009),
    [sym_boolean_operator] = STATE(1009),
    [sym_binary_operator] = STATE(797),
    [sym_unary_operator] = STATE(797),
    [sym_comparison_operator] = STATE(1009),
    [sym_lambda] = STATE(1009),
    [sym_assignment] = STATE(1361),
    [sym_augmented_assignment] = STATE(1361),
    [sym_pattern_list] = STATE(897),
    [sym_yield] = STATE(1361),
    [sym_attribute] = STATE(431),
    [sym_subscript] = STATE(431),
    [sym_call] = STATE(797),
    [sym_list] = STATE(797),
    [sym_set] = STATE(797),
    [sym_tuple] = STATE(797),
    [sym_dictionary] = STATE(797),
    [sym_list_comprehension] = STATE(797),
    [sym_dictionary_comprehension] = STATE(797),
    [sym_set_comprehension] = STATE(797),
    [sym_generator_expression] = STATE(797),
    [sym_parenthesized_expression] = STATE(797),
    [sym_conditional_expression] = STATE(1009),
    [sym_concatenated_string] = STATE(797),
    [sym_string] = STATE(713),
    [sym_await] = STATE(1009),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_STAR] = ACTIONS(15),
    [anon_sym_print] = ACTIONS(17),
    [anon_sym_assert] = ACTIONS(19),
    [anon_sym_return] = ACTIONS(21),
    [anon_sym_del] = ACTIONS(23),
    [anon_sym_raise] = ACTIONS(25),
    [anon_sym_pass] = ACTIONS(27),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_async] = ACTIONS(317),
    [anon_sym_match] = ACTIONS(317),
    [anon_sym_DASH] = ACTIONS(47),
    [anon_sym_PLUS] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(51),
    [anon_sym_STAR_STAR] = ACTIONS(53),
    [anon_sym_global] = ACTIONS(57),
    [anon_sym_nonlocal] = ACTIONS(59),
    [anon_sym_exec] = ACTIONS(61),
    [anon_sym_type] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(519),
    [sym__indent] = ACTIONS(521),
    [sym__string_start] = ACTIONS(81),
  },
  [122] = {
    [sym__simple_statements] = STATE(571),
    [sym_import_statement] = STATE(1319),
    [sym_future_import_statement] = STATE(1319),
    [sym_import_from_statement] = STATE(1319),
    [sym_print_statement] = STATE(1319),
    [sym_assert_statement] = STATE(1319),
    [sym_expression_statement] = STATE(1319),
    [sym_named_expression] = STATE(1009),
    [sym_return_statement] = STATE(1319),
    [sym_delete_statement] = STATE(1319),
    [sym_raise_statement] = STATE(1319),
    [sym_pass_statement] = STATE(1319),
    [sym_break_statement] = STATE(1319),
    [sym_continue_statement] = STATE(1319),
    [sym_list_splat] = STATE(1360),
    [sym_dictionary_splat] = STATE(1360),
    [sym_global_statement] = STATE(1319),
    [sym_nonlocal_statement] = STATE(1319),
    [sym_exec_statement] = STATE(1319),
    [sym_type_alias_statement] = STATE(1319),
    [sym_expression_list] = STATE(1361),
    [sym_pattern] = STATE(889),
    [sym_tuple_pattern] = STATE(875),
    [sym_list_pattern] = STATE(875),
    [sym_list_splat_pattern] = STATE(875),
    [sym_expression] = STATE(1019),
    [sym_primary_expression] = STATE(684),
    [sym_not_operator] = STATE(1009),
    [sym_boolean_operator] = STATE(1009),
    [sym_binary_operator] = STATE(797),
    [sym_unary_operator] = STATE(797),
    [sym_comparison_operator] = STATE(1009),
    [sym_lambda] = STATE(1009),
    [sym_assignment] = STATE(1361),
    [sym_augmented_assignment] = STATE(1361),
    [sym_pattern_list] = STATE(897),
    [sym_yield] = STATE(1361),
    [sym_attribute] = STATE(431),
    [sym_subscript] = STATE(431),
    [sym_call] = STATE(797),
    [sym_list] = STATE(797),
    [sym_set] = STATE(797),
    [sym_tuple] = STATE(797),
    [sym_dictionary] = STATE(797),
    [sym_list_comprehension] = STATE(797),
    [sym_dictionary_comprehension] = STATE(797),
    [sym_set_comprehension] = STATE(797),
    [sym_generator_expression] = STATE(797),
    [sym_parenthesized_expression] = STATE(797),
    [sym_conditional_expression] = STATE(1009),
    [sym_concatenated_string] = STATE(797),
    [sym_string] = STATE(713),
    [sym_await] = STATE(1009),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_STAR] = ACTIONS(15),
    [anon_sym_print] = ACTIONS(17),
    [anon_sym_assert] = ACTIONS(19),
    [anon_sym_return] = ACTIONS(21),
    [anon_sym_del] = ACTIONS(23),
    [anon_sym_raise] = ACTIONS(25),
    [anon_sym_pass] = ACTIONS(27),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_async] = ACTIONS(317),
    [anon_sym_match] = ACTIONS(317),
    [anon_sym_DASH] = ACTIONS(47),
    [anon_sym_PLUS] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(51),
    [anon_sym_STAR_STAR] = ACTIONS(53),
    [anon_sym_global] = ACTIONS(57),
    [anon_sym_nonlocal] = ACTIONS(59),
    [anon_sym_exec] = ACTIONS(61),
    [anon_sym_type] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(523),
    [sym__indent] = ACTIONS(525),
    [sym__string_start] = ACTIONS(81),
  },
  [123] = {
    [sym__simple_statements] = STATE(578),
    [sym_import_statement] = STATE(1209),
    [sym_future_import_statement] = STATE(1209),
    [sym_import_from_statement] = STATE(1209),
    [sym_print_statement] = STATE(1209),
    [sym_assert_statement] = STATE(1209),
    [sym_expression_statement] = STATE(1209),
    [sym_named_expression] = STATE(1009),
    [sym_return_statement] = STATE(1209),
    [sym_delete_statement] = STATE(1209),
    [sym_raise_statement] = STATE(1209),
    [sym_pass_statement] = STATE(1209),
    [sym_break_statement] = STATE(1209),
    [sym_continue_statement] = STATE(1209),
    [sym_list_splat] = STATE(1360),
    [sym_dictionary_splat] = STATE(1360),
    [sym_global_statement] = STATE(1209),
    [sym_nonlocal_statement] = STATE(1209),
    [sym_exec_statement] = STATE(1209),
    [sym_type_alias_statement] = STATE(1209),
    [sym_expression_list] = STATE(1361),
    [sym_pattern] = STATE(889),
    [sym_tuple_pattern] = STATE(875),
    [sym_list_pattern] = STATE(875),
    [sym_list_splat_pattern] = STATE(875),
    [sym_expression] = STATE(1019),
    [sym_primary_expression] = STATE(684),
    [sym_not_operator] = STATE(1009),
    [sym_boolean_operator] = STATE(1009),
    [sym_binary_operator] = STATE(797),
    [sym_unary_operator] = STATE(797),
    [sym_comparison_operator] = STATE(1009),
    [sym_lambda] = STATE(1009),
    [sym_assignment] = STATE(1361),
    [sym_augmented_assignment] = STATE(1361),
    [sym_pattern_list] = STATE(897),
    [sym_yield] = STATE(1361),
    [sym_attribute] = STATE(431),
    [sym_subscript] = STATE(431),
    [sym_call] = STATE(797),
    [sym_list] = STATE(797),
    [sym_set] = STATE(797),
    [sym_tuple] = STATE(797),
    [sym_dictionary] = STATE(797),
    [sym_list_comprehension] = STATE(797),
    [sym_dictionary_comprehension] = STATE(797),
    [sym_set_comprehension] = STATE(797),
    [sym_generator_expression] = STATE(797),
    [sym_parenthesized_expression] = STATE(797),
    [sym_conditional_expression] = STATE(1009),
    [sym_concatenated_string] = STATE(797),
    [sym_string] = STATE(713),
    [sym_await] = STATE(1009),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_STAR] = ACTIONS(15),
    [anon_sym_print] = ACTIONS(17),
    [anon_sym_assert] = ACTIONS(19),
    [anon_sym_return] = ACTIONS(21),
    [anon_sym_del] = ACTIONS(23),
    [anon_sym_raise] = ACTIONS(25),
    [anon_sym_pass] = ACTIONS(27),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_async] = ACTIONS(317),
    [anon_sym_match] = ACTIONS(317),
    [anon_sym_DASH] = ACTIONS(47),
    [anon_sym_PLUS] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(51),
    [anon_sym_STAR_STAR] = ACTIONS(53),
    [anon_sym_global] = ACTIONS(57),
    [anon_sym_nonlocal] = ACTIONS(59),
    [anon_sym_exec] = ACTIONS(61),
    [anon_sym_type] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(527),
    [sym__indent] = ACTIONS(529),
    [sym__string_start] = ACTIONS(81),
  },
  [124] = {
    [sym__simple_statements] = STATE(472),
    [sym_import_statement] = STATE(1209),
    [sym_future_import_statement] = STATE(1209),
    [sym_import_from_statement] = STATE(1209),
    [sym_print_statement] = STATE(1209),
    [sym_assert_statement] = STATE(1209),
    [sym_expression_statement] = STATE(1209),
    [sym_named_expression] = STATE(1009),
    [sym_return_statement] = STATE(1209),
    [sym_delete_statement] = STATE(1209),
    [sym_raise_statement] = STATE(1209),
    [sym_pass_statement] = STATE(1209),
    [sym_break_statement] = STATE(1209),
    [sym_continue_statement] = STATE(1209),
    [sym_list_splat] = STATE(1360),
    [sym_dictionary_splat] = STATE(1360),
    [sym_global_statement] = STATE(1209),
    [sym_nonlocal_statement] = STATE(1209),
    [sym_exec_statement] = STATE(1209),
    [sym_type_alias_statement] = STATE(1209),
    [sym_expression_list] = STATE(1361),
    [sym_pattern] = STATE(889),
    [sym_tuple_pattern] = STATE(875),
    [sym_list_pattern] = STATE(875),
    [sym_list_splat_pattern] = STATE(875),
    [sym_expression] = STATE(1019),
    [sym_primary_expression] = STATE(684),
    [sym_not_operator] = STATE(1009),
    [sym_boolean_operator] = STATE(1009),
    [sym_binary_operator] = STATE(797),
    [sym_unary_operator] = STATE(797),
    [sym_comparison_operator] = STATE(1009),
    [sym_lambda] = STATE(1009),
    [sym_assignment] = STATE(1361),
    [sym_augmented_assignment] = STATE(1361),
    [sym_pattern_list] = STATE(897),
    [sym_yield] = STATE(1361),
    [sym_attribute] = STATE(431),
    [sym_subscript] = STATE(431),
    [sym_call] = STATE(797),
    [sym_list] = STATE(797),
    [sym_set] = STATE(797),
    [sym_tuple] = STATE(797),
    [sym_dictionary] = STATE(797),
    [sym_list_comprehension] = STATE(797),
    [sym_dictionary_comprehension] = STATE(797),
    [sym_set_comprehension] = STATE(797),
    [sym_generator_expression] = STATE(797),
    [sym_parenthesized_expression] = STATE(797),
    [sym_conditional_expression] = STATE(1009),
    [sym_concatenated_string] = STATE(797),
    [sym_string] = STATE(713),
    [sym_await] = STATE(1009),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_STAR] = ACTIONS(15),
    [anon_sym_print] = ACTIONS(17),
    [anon_sym_assert] = ACTIONS(19),
    [anon_sym_return] = ACTIONS(21),
    [anon_sym_del] = ACTIONS(23),
    [anon_sym_raise] = ACTIONS(25),
    [anon_sym_pass] = ACTIONS(27),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_async] = ACTIONS(317),
    [anon_sym_match] = ACTIONS(317),
    [anon_sym_DASH] = ACTIONS(47),
    [anon_sym_PLUS] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(51),
    [anon_sym_STAR_STAR] = ACTIONS(53),
    [anon_sym_global] = ACTIONS(57),
    [anon_sym_nonlocal] = ACTIONS(59),
    [anon_sym_exec] = ACTIONS(61),
    [anon_sym_type] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(531),
    [sym__indent] = ACTIONS(533),
    [sym__string_start] = ACTIONS(81),
  },
  [125] = {
    [sym__simple_statements] = STATE(317),
    [sym_import_statement] = STATE(1244),
    [sym_future_import_statement] = STATE(1244),
    [sym_import_from_statement] = STATE(1244),
    [sym_print_statement] = STATE(1244),
    [sym_assert_statement] = STATE(1244),
    [sym_expression_statement] = STATE(1244),
    [sym_named_expression] = STATE(1009),
    [sym_return_statement] = STATE(1244),
    [sym_delete_statement] = STATE(1244),
    [sym_raise_statement] = STATE(1244),
    [sym_pass_statement] = STATE(1244),
    [sym_break_statement] = STATE(1244),
    [sym_continue_statement] = STATE(1244),
    [sym_list_splat] = STATE(1360),
    [sym_dictionary_splat] = STATE(1360),
    [sym_global_statement] = STATE(1244),
    [sym_nonlocal_statement] = STATE(1244),
    [sym_exec_statement] = STATE(1244),
    [sym_type_alias_statement] = STATE(1244),
    [sym_expression_list] = STATE(1361),
    [sym_pattern] = STATE(889),
    [sym_tuple_pattern] = STATE(875),
    [sym_list_pattern] = STATE(875),
    [sym_list_splat_pattern] = STATE(875),
    [sym_expression] = STATE(1019),
    [sym_primary_expression] = STATE(684),
    [sym_not_operator] = STATE(1009),
    [sym_boolean_operator] = STATE(1009),
    [sym_binary_operator] = STATE(797),
    [sym_unary_operator] = STATE(797),
    [sym_comparison_operator] = STATE(1009),
    [sym_lambda] = STATE(1009),
    [sym_assignment] = STATE(1361),
    [sym_augmented_assignment] = STATE(1361),
    [sym_pattern_list] = STATE(897),
    [sym_yield] = STATE(1361),
    [sym_attribute] = STATE(431),
    [sym_subscript] = STATE(431),
    [sym_call] = STATE(797),
    [sym_list] = STATE(797),
    [sym_set] = STATE(797),
    [sym_tuple] = STATE(797),
    [sym_dictionary] = STATE(797),
    [sym_list_comprehension] = STATE(797),
    [sym_dictionary_comprehension] = STATE(797),
    [sym_set_comprehension] = STATE(797),
    [sym_generator_expression] = STATE(797),
    [sym_parenthesized_expression] = STATE(797),
    [sym_conditional_expression] = STATE(1009),
    [sym_concatenated_string] = STATE(797),
    [sym_string] = STATE(713),
    [sym_await] = STATE(1009),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_STAR] = ACTIONS(15),
    [anon_sym_print] = ACTIONS(17),
    [anon_sym_assert] = ACTIONS(19),
    [anon_sym_return] = ACTIONS(21),
    [anon_sym_del] = ACTIONS(23),
    [anon_sym_raise] = ACTIONS(25),
    [anon_sym_pass] = ACTIONS(27),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_async] = ACTIONS(317),
    [anon_sym_match] = ACTIONS(317),
    [anon_sym_DASH] = ACTIONS(47),
    [anon_sym_PLUS] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(51),
    [anon_sym_STAR_STAR] = ACTIONS(53),
    [anon_sym_global] = ACTIONS(57),
    [anon_sym_nonlocal] = ACTIONS(59),
    [anon_sym_exec] = ACTIONS(61),
    [anon_sym_type] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(535),
    [sym__indent] = ACTIONS(537),
    [sym__string_start] = ACTIONS(81),
  },
  [126] = {
    [sym__simple_statements] = STATE(384),
    [sym_import_statement] = STATE(1238),
    [sym_future_import_statement] = STATE(1238),
    [sym_import_from_statement] = STATE(1238),
    [sym_print_statement] = STATE(1238),
    [sym_assert_statement] = STATE(1238),
    [sym_expression_statement] = STATE(1238),
    [sym_named_expression] = STATE(1009),
    [sym_return_statement] = STATE(1238),
    [sym_delete_statement] = STATE(1238),
    [sym_raise_statement] = STATE(1238),
    [sym_pass_statement] = STATE(1238),
    [sym_break_statement] = STATE(1238),
    [sym_continue_statement] = STATE(1238),
    [sym_list_splat] = STATE(1360),
    [sym_dictionary_splat] = STATE(1360),
    [sym_global_statement] = STATE(1238),
    [sym_nonlocal_statement] = STATE(1238),
    [sym_exec_statement] = STATE(1238),
    [sym_type_alias_statement] = STATE(1238),
    [sym_expression_list] = STATE(1361),
    [sym_pattern] = STATE(889),
    [sym_tuple_pattern] = STATE(875),
    [sym_list_pattern] = STATE(875),
    [sym_list_splat_pattern] = STATE(875),
    [sym_expression] = STATE(1019),
    [sym_primary_expression] = STATE(684),
    [sym_not_operator] = STATE(1009),
    [sym_boolean_operator] = STATE(1009),
    [sym_binary_operator] = STATE(797),
    [sym_unary_operator] = STATE(797),
    [sym_comparison_operator] = STATE(1009),
    [sym_lambda] = STATE(1009),
    [sym_assignment] = STATE(1361),
    [sym_augmented_assignment] = STATE(1361),
    [sym_pattern_list] = STATE(897),
    [sym_yield] = STATE(1361),
    [sym_attribute] = STATE(431),
    [sym_subscript] = STATE(431),
    [sym_call] = STATE(797),
    [sym_list] = STATE(797),
    [sym_set] = STATE(797),
    [sym_tuple] = STATE(797),
    [sym_dictionary] = STATE(797),
    [sym_list_comprehension] = STATE(797),
    [sym_dictionary_comprehension] = STATE(797),
    [sym_set_comprehension] = STATE(797),
    [sym_generator_expression] = STATE(797),
    [sym_parenthesized_expression] = STATE(797),
    [sym_conditional_expression] = STATE(1009),
    [sym_concatenated_string] = STATE(797),
    [sym_string] = STATE(713),
    [sym_await] = STATE(1009),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_STAR] = ACTIONS(15),
    [anon_sym_print] = ACTIONS(17),
    [anon_sym_assert] = ACTIONS(19),
    [anon_sym_return] = ACTIONS(21),
    [anon_sym_del] = ACTIONS(23),
    [anon_sym_raise] = ACTIONS(25),
    [anon_sym_pass] = ACTIONS(27),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_async] = ACTIONS(317),
    [anon_sym_match] = ACTIONS(317),
    [anon_sym_DASH] = ACTIONS(47),
    [anon_sym_PLUS] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(51),
    [anon_sym_STAR_STAR] = ACTIONS(53),
    [anon_sym_global] = ACTIONS(57),
    [anon_sym_nonlocal] = ACTIONS(59),
    [anon_sym_exec] = ACTIONS(61),
    [anon_sym_type] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(539),
    [sym__indent] = ACTIONS(541),
    [sym__string_start] = ACTIONS(81),
  },
  [127] = {
    [sym__simple_statements] = STATE(552),
    [sym_import_statement] = STATE(1209),
    [sym_future_import_statement] = STATE(1209),
    [sym_import_from_statement] = STATE(1209),
    [sym_print_statement] = STATE(1209),
    [sym_assert_statement] = STATE(1209),
    [sym_expression_statement] = STATE(1209),
    [sym_named_expression] = STATE(1009),
    [sym_return_statement] = STATE(1209),
    [sym_delete_statement] = STATE(1209),
    [sym_raise_statement] = STATE(1209),
    [sym_pass_statement] = STATE(1209),
    [sym_break_statement] = STATE(1209),
    [sym_continue_statement] = STATE(1209),
    [sym_list_splat] = STATE(1360),
    [sym_dictionary_splat] = STATE(1360),
    [sym_global_statement] = STATE(1209),
    [sym_nonlocal_statement] = STATE(1209),
    [sym_exec_statement] = STATE(1209),
    [sym_type_alias_statement] = STATE(1209),
    [sym_expression_list] = STATE(1361),
    [sym_pattern] = STATE(889),
    [sym_tuple_pattern] = STATE(875),
    [sym_list_pattern] = STATE(875),
    [sym_list_splat_pattern] = STATE(875),
    [sym_expression] = STATE(1019),
    [sym_primary_expression] = STATE(684),
    [sym_not_operator] = STATE(1009),
    [sym_boolean_operator] = STATE(1009),
    [sym_binary_operator] = STATE(797),
    [sym_unary_operator] = STATE(797),
    [sym_comparison_operator] = STATE(1009),
    [sym_lambda] = STATE(1009),
    [sym_assignment] = STATE(1361),
    [sym_augmented_assignment] = STATE(1361),
    [sym_pattern_list] = STATE(897),
    [sym_yield] = STATE(1361),
    [sym_attribute] = STATE(431),
    [sym_subscript] = STATE(431),
    [sym_call] = STATE(797),
    [sym_list] = STATE(797),
    [sym_set] = STATE(797),
    [sym_tuple] = STATE(797),
    [sym_dictionary] = STATE(797),
    [sym_list_comprehension] = STATE(797),
    [sym_dictionary_comprehension] = STATE(797),
    [sym_set_comprehension] = STATE(797),
    [sym_generator_expression] = STATE(797),
    [sym_parenthesized_expression] = STATE(797),
    [sym_conditional_expression] = STATE(1009),
    [sym_concatenated_string] = STATE(797),
    [sym_string] = STATE(713),
    [sym_await] = STATE(1009),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_STAR] = ACTIONS(15),
    [anon_sym_print] = ACTIONS(17),
    [anon_sym_assert] = ACTIONS(19),
    [anon_sym_return] = ACTIONS(21),
    [anon_sym_del] = ACTIONS(23),
    [anon_sym_raise] = ACTIONS(25),
    [anon_sym_pass] = ACTIONS(27),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_async] = ACTIONS(317),
    [anon_sym_match] = ACTIONS(317),
    [anon_sym_DASH] = ACTIONS(47),
    [anon_sym_PLUS] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(51),
    [anon_sym_STAR_STAR] = ACTIONS(53),
    [anon_sym_global] = ACTIONS(57),
    [anon_sym_nonlocal] = ACTIONS(59),
    [anon_sym_exec] = ACTIONS(61),
    [anon_sym_type] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(543),
    [sym__indent] = ACTIONS(545),
    [sym__string_start] = ACTIONS(81),
  },
  [128] = {
    [sym__simple_statements] = STATE(487),
    [sym_import_statement] = STATE(1319),
    [sym_future_import_statement] = STATE(1319),
    [sym_import_from_statement] = STATE(1319),
    [sym_print_statement] = STATE(1319),
    [sym_assert_statement] = STATE(1319),
    [sym_expression_statement] = STATE(1319),
    [sym_named_expression] = STATE(1009),
    [sym_return_statement] = STATE(1319),
    [sym_delete_statement] = STATE(1319),
    [sym_raise_statement] = STATE(1319),
    [sym_pass_statement] = STATE(1319),
    [sym_break_statement] = STATE(1319),
    [sym_continue_statement] = STATE(1319),
    [sym_list_splat] = STATE(1360),
    [sym_dictionary_splat] = STATE(1360),
    [sym_global_statement] = STATE(1319),
    [sym_nonlocal_statement] = STATE(1319),
    [sym_exec_statement] = STATE(1319),
    [sym_type_alias_statement] = STATE(1319),
    [sym_expression_list] = STATE(1361),
    [sym_pattern] = STATE(889),
    [sym_tuple_pattern] = STATE(875),
    [sym_list_pattern] = STATE(875),
    [sym_list_splat_pattern] = STATE(875),
    [sym_expression] = STATE(1019),
    [sym_primary_expression] = STATE(684),
    [sym_not_operator] = STATE(1009),
    [sym_boolean_operator] = STATE(1009),
    [sym_binary_operator] = STATE(797),
    [sym_unary_operator] = STATE(797),
    [sym_comparison_operator] = STATE(1009),
    [sym_lambda] = STATE(1009),
    [sym_assignment] = STATE(1361),
    [sym_augmented_assignment] = STATE(1361),
    [sym_pattern_list] = STATE(897),
    [sym_yield] = STATE(1361),
    [sym_attribute] = STATE(431),
    [sym_subscript] = STATE(431),
    [sym_call] = STATE(797),
    [sym_list] = STATE(797),
    [sym_set] = STATE(797),
    [sym_tuple] = STATE(797),
    [sym_dictionary] = STATE(797),
    [sym_list_comprehension] = STATE(797),
    [sym_dictionary_comprehension] = STATE(797),
    [sym_set_comprehension] = STATE(797),
    [sym_generator_expression] = STATE(797),
    [sym_parenthesized_expression] = STATE(797),
    [sym_conditional_expression] = STATE(1009),
    [sym_concatenated_string] = STATE(797),
    [sym_string] = STATE(713),
    [sym_await] = STATE(1009),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_STAR] = ACTIONS(15),
    [anon_sym_print] = ACTIONS(17),
    [anon_sym_assert] = ACTIONS(19),
    [anon_sym_return] = ACTIONS(21),
    [anon_sym_del] = ACTIONS(23),
    [anon_sym_raise] = ACTIONS(25),
    [anon_sym_pass] = ACTIONS(27),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_async] = ACTIONS(317),
    [anon_sym_match] = ACTIONS(317),
    [anon_sym_DASH] = ACTIONS(47),
    [anon_sym_PLUS] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(51),
    [anon_sym_STAR_STAR] = ACTIONS(53),
    [anon_sym_global] = ACTIONS(57),
    [anon_sym_nonlocal] = ACTIONS(59),
    [anon_sym_exec] = ACTIONS(61),
    [anon_sym_type] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(547),
    [sym__indent] = ACTIONS(549),
    [sym__string_start] = ACTIONS(81),
  },
  [129] = {
    [sym__simple_statements] = STATE(558),
    [sym_import_statement] = STATE(1319),
    [sym_future_import_statement] = STATE(1319),
    [sym_import_from_statement] = STATE(1319),
    [sym_print_statement] = STATE(1319),
    [sym_assert_statement] = STATE(1319),
    [sym_expression_statement] = STATE(1319),
    [sym_named_expression] = STATE(1009),
    [sym_return_statement] = STATE(1319),
    [sym_delete_statement] = STATE(1319),
    [sym_raise_statement] = STATE(1319),
    [sym_pass_statement] = STATE(1319),
    [sym_break_statement] = STATE(1319),
    [sym_continue_statement] = STATE(1319),
    [sym_list_splat] = STATE(1360),
    [sym_dictionary_splat] = STATE(1360),
    [sym_global_statement] = STATE(1319),
    [sym_nonlocal_statement] = STATE(1319),
    [sym_exec_statement] = STATE(1319),
    [sym_type_alias_statement] = STATE(1319),
    [sym_expression_list] = STATE(1361),
    [sym_pattern] = STATE(889),
    [sym_tuple_pattern] = STATE(875),
    [sym_list_pattern] = STATE(875),
    [sym_list_splat_pattern] = STATE(875),
    [sym_expression] = STATE(1019),
    [sym_primary_expression] = STATE(684),
    [sym_not_operator] = STATE(1009),
    [sym_boolean_operator] = STATE(1009),
    [sym_binary_operator] = STATE(797),
    [sym_unary_operator] = STATE(797),
    [sym_comparison_operator] = STATE(1009),
    [sym_lambda] = STATE(1009),
    [sym_assignment] = STATE(1361),
    [sym_augmented_assignment] = STATE(1361),
    [sym_pattern_list] = STATE(897),
    [sym_yield] = STATE(1361),
    [sym_attribute] = STATE(431),
    [sym_subscript] = STATE(431),
    [sym_call] = STATE(797),
    [sym_list] = STATE(797),
    [sym_set] = STATE(797),
    [sym_tuple] = STATE(797),
    [sym_dictionary] = STATE(797),
    [sym_list_comprehension] = STATE(797),
    [sym_dictionary_comprehension] = STATE(797),
    [sym_set_comprehension] = STATE(797),
    [sym_generator_expression] = STATE(797),
    [sym_parenthesized_expression] = STATE(797),
    [sym_conditional_expression] = STATE(1009),
    [sym_concatenated_string] = STATE(797),
    [sym_string] = STATE(713),
    [sym_await] = STATE(1009),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_STAR] = ACTIONS(15),
    [anon_sym_print] = ACTIONS(17),
    [anon_sym_assert] = ACTIONS(19),
    [anon_sym_return] = ACTIONS(21),
    [anon_sym_del] = ACTIONS(23),
    [anon_sym_raise] = ACTIONS(25),
    [anon_sym_pass] = ACTIONS(27),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_async] = ACTIONS(317),
    [anon_sym_match] = ACTIONS(317),
    [anon_sym_DASH] = ACTIONS(47),
    [anon_sym_PLUS] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(51),
    [anon_sym_STAR_STAR] = ACTIONS(53),
    [anon_sym_global] = ACTIONS(57),
    [anon_sym_nonlocal] = ACTIONS(59),
    [anon_sym_exec] = ACTIONS(61),
    [anon_sym_type] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(551),
    [sym__indent] = ACTIONS(553),
    [sym__string_start] = ACTIONS(81),
  },
  [130] = {
    [sym__simple_statements] = STATE(421),
    [sym_import_statement] = STATE(1319),
    [sym_future_import_statement] = STATE(1319),
    [sym_import_from_statement] = STATE(1319),
    [sym_print_statement] = STATE(1319),
    [sym_assert_statement] = STATE(1319),
    [sym_expression_statement] = STATE(1319),
    [sym_named_expression] = STATE(1009),
    [sym_return_statement] = STATE(1319),
    [sym_delete_statement] = STATE(1319),
    [sym_raise_statement] = STATE(1319),
    [sym_pass_statement] = STATE(1319),
    [sym_break_statement] = STATE(1319),
    [sym_continue_statement] = STATE(1319),
    [sym_list_splat] = STATE(1360),
    [sym_dictionary_splat] = STATE(1360),
    [sym_global_statement] = STATE(1319),
    [sym_nonlocal_statement] = STATE(1319),
    [sym_exec_statement] = STATE(1319),
    [sym_type_alias_statement] = STATE(1319),
    [sym_expression_list] = STATE(1361),
    [sym_pattern] = STATE(889),
    [sym_tuple_pattern] = STATE(875),
    [sym_list_pattern] = STATE(875),
    [sym_list_splat_pattern] = STATE(875),
    [sym_expression] = STATE(1019),
    [sym_primary_expression] = STATE(684),
    [sym_not_operator] = STATE(1009),
    [sym_boolean_operator] = STATE(1009),
    [sym_binary_operator] = STATE(797),
    [sym_unary_operator] = STATE(797),
    [sym_comparison_operator] = STATE(1009),
    [sym_lambda] = STATE(1009),
    [sym_assignment] = STATE(1361),
    [sym_augmented_assignment] = STATE(1361),
    [sym_pattern_list] = STATE(897),
    [sym_yield] = STATE(1361),
    [sym_attribute] = STATE(431),
    [sym_subscript] = STATE(431),
    [sym_call] = STATE(797),
    [sym_list] = STATE(797),
    [sym_set] = STATE(797),
    [sym_tuple] = STATE(797),
    [sym_dictionary] = STATE(797),
    [sym_list_comprehension] = STATE(797),
    [sym_dictionary_comprehension] = STATE(797),
    [sym_set_comprehension] = STATE(797),
    [sym_generator_expression] = STATE(797),
    [sym_parenthesized_expression] = STATE(797),
    [sym_conditional_expression] = STATE(1009),
    [sym_concatenated_string] = STATE(797),
    [sym_string] = STATE(713),
    [sym_await] = STATE(1009),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_STAR] = ACTIONS(15),
    [anon_sym_print] = ACTIONS(17),
    [anon_sym_assert] = ACTIONS(19),
    [anon_sym_return] = ACTIONS(21),
    [anon_sym_del] = ACTIONS(23),
    [anon_sym_raise] = ACTIONS(25),
    [anon_sym_pass] = ACTIONS(27),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_async] = ACTIONS(317),
    [anon_sym_match] = ACTIONS(317),
    [anon_sym_DASH] = ACTIONS(47),
    [anon_sym_PLUS] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(51),
    [anon_sym_STAR_STAR] = ACTIONS(53),
    [anon_sym_global] = ACTIONS(57),
    [anon_sym_nonlocal] = ACTIONS(59),
    [anon_sym_exec] = ACTIONS(61),
    [anon_sym_type] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(555),
    [sym__indent] = ACTIONS(557),
    [sym__string_start] = ACTIONS(81),
  },
  [131] = {
    [sym_named_expression] = STATE(1009),
    [sym_expression] = STATE(976),
    [sym_primary_expression] = STATE(684),
    [sym_not_operator] = STATE(1009),
    [sym_boolean_operator] = STATE(1009),
    [sym_binary_operator] = STATE(797),
    [sym_unary_operator] = STATE(797),
    [sym_comparison_operator] = STATE(1009),
    [sym_lambda] = STATE(1009),
    [sym_attribute] = STATE(797),
    [sym_subscript] = STATE(797),
    [sym_call] = STATE(797),
    [sym_list] = STATE(797),
    [sym_set] = STATE(797),
    [sym_tuple] = STATE(797),
    [sym_dictionary] = STATE(797),
    [sym_list_comprehension] = STATE(797),
    [sym_dictionary_comprehension] = STATE(797),
    [sym_set_comprehension] = STATE(797),
    [sym_generator_expression] = STATE(797),
    [sym_parenthesized_expression] = STATE(797),
    [sym_conditional_expression] = STATE(1009),
    [sym_concatenated_string] = STATE(797),
    [sym_string] = STATE(713),
    [sym_await] = STATE(1009),
    [sym_identifier] = ACTIONS(331),
    [anon_sym_DOT] = ACTIONS(276),
    [anon_sym_LPAREN] = ACTIONS(559),
    [anon_sym_COMMA] = ACTIONS(280),
    [anon_sym_STAR] = ACTIONS(276),
    [anon_sym_print] = ACTIONS(333),
    [anon_sym_GT_GT] = ACTIONS(276),
    [anon_sym_COLON_EQ] = ACTIONS(287),
    [anon_sym_if] = ACTIONS(276),
    [anon_sym_COLON] = ACTIONS(289),
    [anon_sym_async] = ACTIONS(333),
    [anon_sym_in] = ACTIONS(276),
    [anon_sym_match] = ACTIONS(333),
    [anon_sym_PIPE] = ACTIONS(276),
    [anon_sym_DASH] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_LBRACK] = ACTIONS(563),
    [anon_sym_LBRACE] = ACTIONS(51),
    [anon_sym_STAR_STAR] = ACTIONS(276),
    [anon_sym_EQ] = ACTIONS(289),
    [anon_sym_exec] = ACTIONS(333),
    [anon_sym_type] = ACTIONS(333),
    [anon_sym_AT] = ACTIONS(276),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_and] = ACTIONS(276),
    [anon_sym_or] = ACTIONS(276),
    [anon_sym_SLASH] = ACTIONS(276),
    [anon_sym_PERCENT] = ACTIONS(276),
    [anon_sym_SLASH_SLASH] = ACTIONS(276),
    [anon_sym_AMP] = ACTIONS(276),
    [anon_sym_CARET] = ACTIONS(276),
    [anon_sym_LT_LT] = ACTIONS(276),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(276),
    [anon_sym_LT_EQ] = ACTIONS(303),
    [anon_sym_EQ_EQ] = ACTIONS(303),
    [anon_sym_BANG_EQ] = ACTIONS(303),
    [anon_sym_GT_EQ] = ACTIONS(303),
    [anon_sym_GT] = ACTIONS(276),
    [anon_sym_LT_GT] = ACTIONS(303),
    [anon_sym_is] = ACTIONS(276),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_PLUS_EQ] = ACTIONS(307),
    [anon_sym_DASH_EQ] = ACTIONS(307),
    [anon_sym_STAR_EQ] = ACTIONS(307),
    [anon_sym_SLASH_EQ] = ACTIONS(307),
    [anon_sym_AT_EQ] = ACTIONS(307),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(307),
    [anon_sym_PERCENT_EQ] = ACTIONS(307),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(307),
    [anon_sym_GT_GT_EQ] = ACTIONS(307),
    [anon_sym_LT_LT_EQ] = ACTIONS(307),
    [anon_sym_AMP_EQ] = ACTIONS(307),
    [anon_sym_CARET_EQ] = ACTIONS(307),
    [anon_sym_PIPE_EQ] = ACTIONS(307),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(337),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(303),
    [sym__newline] = ACTIONS(303),
    [sym__string_start] = ACTIONS(81),
  },
  [132] = {
    [sym_named_expression] = STATE(900),
    [sym_expression] = STATE(901),
    [sym_primary_expression] = STATE(630),
    [sym_not_operator] = STATE(900),
    [sym_boolean_operator] = STATE(900),
    [sym_binary_operator] = STATE(642),
    [sym_unary_operator] = STATE(642),
    [sym_comparison_operator] = STATE(900),
    [sym_lambda] = STATE(900),
    [sym_attribute] = STATE(642),
    [sym_subscript] = STATE(642),
    [sym_call] = STATE(642),
    [sym_list] = STATE(642),
    [sym_set] = STATE(642),
    [sym_tuple] = STATE(642),
    [sym_dictionary] = STATE(642),
    [sym_list_comprehension] = STATE(642),
    [sym_dictionary_comprehension] = STATE(642),
    [sym_set_comprehension] = STATE(642),
    [sym_generator_expression] = STATE(642),
    [sym_parenthesized_expression] = STATE(642),
    [sym_conditional_expression] = STATE(900),
    [sym_concatenated_string] = STATE(642),
    [sym_string] = STATE(600),
    [sym_await] = STATE(900),
    [sym_identifier] = ACTIONS(274),
    [anon_sym_DOT] = ACTIONS(276),
    [anon_sym_LPAREN] = ACTIONS(278),
    [anon_sym_RPAREN] = ACTIONS(565),
    [anon_sym_COMMA] = ACTIONS(565),
    [anon_sym_STAR] = ACTIONS(276),
    [anon_sym_print] = ACTIONS(285),
    [anon_sym_GT_GT] = ACTIONS(276),
    [anon_sym_COLON_EQ] = ACTIONS(568),
    [anon_sym_if] = ACTIONS(276),
    [anon_sym_COLON] = ACTIONS(570),
    [anon_sym_async] = ACTIONS(285),
    [anon_sym_in] = ACTIONS(276),
    [anon_sym_match] = ACTIONS(285),
    [anon_sym_PIPE] = ACTIONS(276),
    [anon_sym_DASH] = ACTIONS(291),
    [anon_sym_PLUS] = ACTIONS(291),
    [anon_sym_LBRACK] = ACTIONS(293),
    [anon_sym_RBRACK] = ACTIONS(565),
    [anon_sym_LBRACE] = ACTIONS(295),
    [anon_sym_STAR_STAR] = ACTIONS(276),
    [anon_sym_EQ] = ACTIONS(570),
    [anon_sym_exec] = ACTIONS(285),
    [anon_sym_type] = ACTIONS(285),
    [anon_sym_AT] = ACTIONS(276),
    [anon_sym_not] = ACTIONS(299),
    [anon_sym_and] = ACTIONS(276),
    [anon_sym_or] = ACTIONS(276),
    [anon_sym_SLASH] = ACTIONS(276),
    [anon_sym_PERCENT] = ACTIONS(276),
    [anon_sym_SLASH_SLASH] = ACTIONS(276),
    [anon_sym_AMP] = ACTIONS(276),
    [anon_sym_CARET] = ACTIONS(276),
    [anon_sym_LT_LT] = ACTIONS(276),
    [anon_sym_TILDE] = ACTIONS(301),
    [anon_sym_LT] = ACTIONS(276),
    [anon_sym_LT_EQ] = ACTIONS(303),
    [anon_sym_EQ_EQ] = ACTIONS(303),
    [anon_sym_BANG_EQ] = ACTIONS(303),
    [anon_sym_GT_EQ] = ACTIONS(303),
    [anon_sym_GT] = ACTIONS(276),
    [anon_sym_LT_GT] = ACTIONS(303),
    [anon_sym_is] = ACTIONS(276),
    [anon_sym_lambda] = ACTIONS(305),
    [anon_sym_PLUS_EQ] = ACTIONS(572),
    [anon_sym_DASH_EQ] = ACTIONS(572),
    [anon_sym_STAR_EQ] = ACTIONS(572),
    [anon_sym_SLASH_EQ] = ACTIONS(572),
    [anon_sym_AT_EQ] = ACTIONS(572),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(572),
    [anon_sym_PERCENT_EQ] = ACTIONS(572),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(572),
    [anon_sym_GT_GT_EQ] = ACTIONS(572),
    [anon_sym_LT_LT_EQ] = ACTIONS(572),
    [anon_sym_AMP_EQ] = ACTIONS(572),
    [anon_sym_CARET_EQ] = ACTIONS(572),
    [anon_sym_PIPE_EQ] = ACTIONS(572),
    [sym_ellipsis] = ACTIONS(309),
    [sym_integer] = ACTIONS(311),
    [sym_float] = ACTIONS(309),
    [anon_sym_await] = ACTIONS(313),
    [sym_true] = ACTIONS(311),
    [sym_false] = ACTIONS(311),
    [sym_none] = ACTIONS(311),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(315),
  },
  [133] = {
    [sym_import_statement] = STATE(1351),
    [sym_future_import_statement] = STATE(1351),
    [sym_import_from_statement] = STATE(1351),
    [sym_print_statement] = STATE(1351),
    [sym_assert_statement] = STATE(1351),
    [sym_expression_statement] = STATE(1351),
    [sym_named_expression] = STATE(1009),
    [sym_return_statement] = STATE(1351),
    [sym_delete_statement] = STATE(1351),
    [sym_raise_statement] = STATE(1351),
    [sym_pass_statement] = STATE(1351),
    [sym_break_statement] = STATE(1351),
    [sym_continue_statement] = STATE(1351),
    [sym_list_splat] = STATE(1360),
    [sym_dictionary_splat] = STATE(1360),
    [sym_global_statement] = STATE(1351),
    [sym_nonlocal_statement] = STATE(1351),
    [sym_exec_statement] = STATE(1351),
    [sym_type_alias_statement] = STATE(1351),
    [sym_expression_list] = STATE(1361),
    [sym_pattern] = STATE(889),
    [sym_tuple_pattern] = STATE(875),
    [sym_list_pattern] = STATE(875),
    [sym_list_splat_pattern] = STATE(875),
    [sym_expression] = STATE(1019),
    [sym_primary_expression] = STATE(684),
    [sym_not_operator] = STATE(1009),
    [sym_boolean_operator] = STATE(1009),
    [sym_binary_operator] = STATE(797),
    [sym_unary_operator] = STATE(797),
    [sym_comparison_operator] = STATE(1009),
    [sym_lambda] = STATE(1009),
    [sym_assignment] = STATE(1361),
    [sym_augmented_assignment] = STATE(1361),
    [sym_pattern_list] = STATE(897),
    [sym_yield] = STATE(1361),
    [sym_attribute] = STATE(431),
    [sym_subscript] = STATE(431),
    [sym_call] = STATE(797),
    [sym_list] = STATE(797),
    [sym_set] = STATE(797),
    [sym_tuple] = STATE(797),
    [sym_dictionary] = STATE(797),
    [sym_list_comprehension] = STATE(797),
    [sym_dictionary_comprehension] = STATE(797),
    [sym_set_comprehension] = STATE(797),
    [sym_generator_expression] = STATE(797),
    [sym_parenthesized_expression] = STATE(797),
    [sym_conditional_expression] = STATE(1009),
    [sym_concatenated_string] = STATE(797),
    [sym_string] = STATE(713),
    [sym_await] = STATE(1009),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_STAR] = ACTIONS(15),
    [anon_sym_print] = ACTIONS(17),
    [anon_sym_assert] = ACTIONS(19),
    [anon_sym_return] = ACTIONS(21),
    [anon_sym_del] = ACTIONS(23),
    [anon_sym_raise] = ACTIONS(25),
    [anon_sym_pass] = ACTIONS(27),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_async] = ACTIONS(317),
    [anon_sym_match] = ACTIONS(317),
    [anon_sym_DASH] = ACTIONS(47),
    [anon_sym_PLUS] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(51),
    [anon_sym_STAR_STAR] = ACTIONS(53),
    [anon_sym_global] = ACTIONS(57),
    [anon_sym_nonlocal] = ACTIONS(59),
    [anon_sym_exec] = ACTIONS(61),
    [anon_sym_type] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(574),
    [sym__string_start] = ACTIONS(81),
  },
  [134] = {
    [sym_import_statement] = STATE(1351),
    [sym_future_import_statement] = STATE(1351),
    [sym_import_from_statement] = STATE(1351),
    [sym_print_statement] = STATE(1351),
    [sym_assert_statement] = STATE(1351),
    [sym_expression_statement] = STATE(1351),
    [sym_named_expression] = STATE(1009),
    [sym_return_statement] = STATE(1351),
    [sym_delete_statement] = STATE(1351),
    [sym_raise_statement] = STATE(1351),
    [sym_pass_statement] = STATE(1351),
    [sym_break_statement] = STATE(1351),
    [sym_continue_statement] = STATE(1351),
    [sym_list_splat] = STATE(1360),
    [sym_dictionary_splat] = STATE(1360),
    [sym_global_statement] = STATE(1351),
    [sym_nonlocal_statement] = STATE(1351),
    [sym_exec_statement] = STATE(1351),
    [sym_type_alias_statement] = STATE(1351),
    [sym_expression_list] = STATE(1361),
    [sym_pattern] = STATE(889),
    [sym_tuple_pattern] = STATE(875),
    [sym_list_pattern] = STATE(875),
    [sym_list_splat_pattern] = STATE(875),
    [sym_expression] = STATE(1019),
    [sym_primary_expression] = STATE(684),
    [sym_not_operator] = STATE(1009),
    [sym_boolean_operator] = STATE(1009),
    [sym_binary_operator] = STATE(797),
    [sym_unary_operator] = STATE(797),
    [sym_comparison_operator] = STATE(1009),
    [sym_lambda] = STATE(1009),
    [sym_assignment] = STATE(1361),
    [sym_augmented_assignment] = STATE(1361),
    [sym_pattern_list] = STATE(897),
    [sym_yield] = STATE(1361),
    [sym_attribute] = STATE(431),
    [sym_subscript] = STATE(431),
    [sym_call] = STATE(797),
    [sym_list] = STATE(797),
    [sym_set] = STATE(797),
    [sym_tuple] = STATE(797),
    [sym_dictionary] = STATE(797),
    [sym_list_comprehension] = STATE(797),
    [sym_dictionary_comprehension] = STATE(797),
    [sym_set_comprehension] = STATE(797),
    [sym_generator_expression] = STATE(797),
    [sym_parenthesized_expression] = STATE(797),
    [sym_conditional_expression] = STATE(1009),
    [sym_concatenated_string] = STATE(797),
    [sym_string] = STATE(713),
    [sym_await] = STATE(1009),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_STAR] = ACTIONS(15),
    [anon_sym_print] = ACTIONS(17),
    [anon_sym_assert] = ACTIONS(19),
    [anon_sym_return] = ACTIONS(21),
    [anon_sym_del] = ACTIONS(23),
    [anon_sym_raise] = ACTIONS(25),
    [anon_sym_pass] = ACTIONS(27),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_async] = ACTIONS(317),
    [anon_sym_match] = ACTIONS(317),
    [anon_sym_DASH] = ACTIONS(47),
    [anon_sym_PLUS] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(51),
    [anon_sym_STAR_STAR] = ACTIONS(53),
    [anon_sym_global] = ACTIONS(57),
    [anon_sym_nonlocal] = ACTIONS(59),
    [anon_sym_exec] = ACTIONS(61),
    [anon_sym_type] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(576),
    [sym__string_start] = ACTIONS(81),
  },
  [135] = {
    [sym_import_statement] = STATE(1351),
    [sym_future_import_statement] = STATE(1351),
    [sym_import_from_statement] = STATE(1351),
    [sym_print_statement] = STATE(1351),
    [sym_assert_statement] = STATE(1351),
    [sym_expression_statement] = STATE(1351),
    [sym_named_expression] = STATE(1009),
    [sym_return_statement] = STATE(1351),
    [sym_delete_statement] = STATE(1351),
    [sym_raise_statement] = STATE(1351),
    [sym_pass_statement] = STATE(1351),
    [sym_break_statement] = STATE(1351),
    [sym_continue_statement] = STATE(1351),
    [sym_list_splat] = STATE(1360),
    [sym_dictionary_splat] = STATE(1360),
    [sym_global_statement] = STATE(1351),
    [sym_nonlocal_statement] = STATE(1351),
    [sym_exec_statement] = STATE(1351),
    [sym_type_alias_statement] = STATE(1351),
    [sym_expression_list] = STATE(1361),
    [sym_pattern] = STATE(889),
    [sym_tuple_pattern] = STATE(875),
    [sym_list_pattern] = STATE(875),
    [sym_list_splat_pattern] = STATE(875),
    [sym_expression] = STATE(1019),
    [sym_primary_expression] = STATE(684),
    [sym_not_operator] = STATE(1009),
    [sym_boolean_operator] = STATE(1009),
    [sym_binary_operator] = STATE(797),
    [sym_unary_operator] = STATE(797),
    [sym_comparison_operator] = STATE(1009),
    [sym_lambda] = STATE(1009),
    [sym_assignment] = STATE(1361),
    [sym_augmented_assignment] = STATE(1361),
    [sym_pattern_list] = STATE(897),
    [sym_yield] = STATE(1361),
    [sym_attribute] = STATE(431),
    [sym_subscript] = STATE(431),
    [sym_call] = STATE(797),
    [sym_list] = STATE(797),
    [sym_set] = STATE(797),
    [sym_tuple] = STATE(797),
    [sym_dictionary] = STATE(797),
    [sym_list_comprehension] = STATE(797),
    [sym_dictionary_comprehension] = STATE(797),
    [sym_set_comprehension] = STATE(797),
    [sym_generator_expression] = STATE(797),
    [sym_parenthesized_expression] = STATE(797),
    [sym_conditional_expression] = STATE(1009),
    [sym_concatenated_string] = STATE(797),
    [sym_string] = STATE(713),
    [sym_await] = STATE(1009),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_STAR] = ACTIONS(15),
    [anon_sym_print] = ACTIONS(17),
    [anon_sym_assert] = ACTIONS(19),
    [anon_sym_return] = ACTIONS(21),
    [anon_sym_del] = ACTIONS(23),
    [anon_sym_raise] = ACTIONS(25),
    [anon_sym_pass] = ACTIONS(27),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_async] = ACTIONS(317),
    [anon_sym_match] = ACTIONS(317),
    [anon_sym_DASH] = ACTIONS(47),
    [anon_sym_PLUS] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(51),
    [anon_sym_STAR_STAR] = ACTIONS(53),
    [anon_sym_global] = ACTIONS(57),
    [anon_sym_nonlocal] = ACTIONS(59),
    [anon_sym_exec] = ACTIONS(61),
    [anon_sym_type] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(578),
    [sym__string_start] = ACTIONS(81),
  },
  [136] = {
    [sym_import_statement] = STATE(1351),
    [sym_future_import_statement] = STATE(1351),
    [sym_import_from_statement] = STATE(1351),
    [sym_print_statement] = STATE(1351),
    [sym_assert_statement] = STATE(1351),
    [sym_expression_statement] = STATE(1351),
    [sym_named_expression] = STATE(1009),
    [sym_return_statement] = STATE(1351),
    [sym_delete_statement] = STATE(1351),
    [sym_raise_statement] = STATE(1351),
    [sym_pass_statement] = STATE(1351),
    [sym_break_statement] = STATE(1351),
    [sym_continue_statement] = STATE(1351),
    [sym_list_splat] = STATE(1360),
    [sym_dictionary_splat] = STATE(1360),
    [sym_global_statement] = STATE(1351),
    [sym_nonlocal_statement] = STATE(1351),
    [sym_exec_statement] = STATE(1351),
    [sym_type_alias_statement] = STATE(1351),
    [sym_expression_list] = STATE(1361),
    [sym_pattern] = STATE(889),
    [sym_tuple_pattern] = STATE(875),
    [sym_list_pattern] = STATE(875),
    [sym_list_splat_pattern] = STATE(875),
    [sym_expression] = STATE(1019),
    [sym_primary_expression] = STATE(684),
    [sym_not_operator] = STATE(1009),
    [sym_boolean_operator] = STATE(1009),
    [sym_binary_operator] = STATE(797),
    [sym_unary_operator] = STATE(797),
    [sym_comparison_operator] = STATE(1009),
    [sym_lambda] = STATE(1009),
    [sym_assignment] = STATE(1361),
    [sym_augmented_assignment] = STATE(1361),
    [sym_pattern_list] = STATE(897),
    [sym_yield] = STATE(1361),
    [sym_attribute] = STATE(431),
    [sym_subscript] = STATE(431),
    [sym_call] = STATE(797),
    [sym_list] = STATE(797),
    [sym_set] = STATE(797),
    [sym_tuple] = STATE(797),
    [sym_dictionary] = STATE(797),
    [sym_list_comprehension] = STATE(797),
    [sym_dictionary_comprehension] = STATE(797),
    [sym_set_comprehension] = STATE(797),
    [sym_generator_expression] = STATE(797),
    [sym_parenthesized_expression] = STATE(797),
    [sym_conditional_expression] = STATE(1009),
    [sym_concatenated_string] = STATE(797),
    [sym_string] = STATE(713),
    [sym_await] = STATE(1009),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_STAR] = ACTIONS(15),
    [anon_sym_print] = ACTIONS(17),
    [anon_sym_assert] = ACTIONS(19),
    [anon_sym_return] = ACTIONS(21),
    [anon_sym_del] = ACTIONS(23),
    [anon_sym_raise] = ACTIONS(25),
    [anon_sym_pass] = ACTIONS(27),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_async] = ACTIONS(317),
    [anon_sym_match] = ACTIONS(317),
    [anon_sym_DASH] = ACTIONS(47),
    [anon_sym_PLUS] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(51),
    [anon_sym_STAR_STAR] = ACTIONS(53),
    [anon_sym_global] = ACTIONS(57),
    [anon_sym_nonlocal] = ACTIONS(59),
    [anon_sym_exec] = ACTIONS(61),
    [anon_sym_type] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(580),
    [sym__string_start] = ACTIONS(81),
  },
  [137] = {
    [sym_import_statement] = STATE(1351),
    [sym_future_import_statement] = STATE(1351),
    [sym_import_from_statement] = STATE(1351),
    [sym_print_statement] = STATE(1351),
    [sym_assert_statement] = STATE(1351),
    [sym_expression_statement] = STATE(1351),
    [sym_named_expression] = STATE(1009),
    [sym_return_statement] = STATE(1351),
    [sym_delete_statement] = STATE(1351),
    [sym_raise_statement] = STATE(1351),
    [sym_pass_statement] = STATE(1351),
    [sym_break_statement] = STATE(1351),
    [sym_continue_statement] = STATE(1351),
    [sym_list_splat] = STATE(1360),
    [sym_dictionary_splat] = STATE(1360),
    [sym_global_statement] = STATE(1351),
    [sym_nonlocal_statement] = STATE(1351),
    [sym_exec_statement] = STATE(1351),
    [sym_type_alias_statement] = STATE(1351),
    [sym_expression_list] = STATE(1361),
    [sym_pattern] = STATE(889),
    [sym_tuple_pattern] = STATE(875),
    [sym_list_pattern] = STATE(875),
    [sym_list_splat_pattern] = STATE(875),
    [sym_expression] = STATE(1019),
    [sym_primary_expression] = STATE(684),
    [sym_not_operator] = STATE(1009),
    [sym_boolean_operator] = STATE(1009),
    [sym_binary_operator] = STATE(797),
    [sym_unary_operator] = STATE(797),
    [sym_comparison_operator] = STATE(1009),
    [sym_lambda] = STATE(1009),
    [sym_assignment] = STATE(1361),
    [sym_augmented_assignment] = STATE(1361),
    [sym_pattern_list] = STATE(897),
    [sym_yield] = STATE(1361),
    [sym_attribute] = STATE(431),
    [sym_subscript] = STATE(431),
    [sym_call] = STATE(797),
    [sym_list] = STATE(797),
    [sym_set] = STATE(797),
    [sym_tuple] = STATE(797),
    [sym_dictionary] = STATE(797),
    [sym_list_comprehension] = STATE(797),
    [sym_dictionary_comprehension] = STATE(797),
    [sym_set_comprehension] = STATE(797),
    [sym_generator_expression] = STATE(797),
    [sym_parenthesized_expression] = STATE(797),
    [sym_conditional_expression] = STATE(1009),
    [sym_concatenated_string] = STATE(797),
    [sym_string] = STATE(713),
    [sym_await] = STATE(1009),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_STAR] = ACTIONS(15),
    [anon_sym_print] = ACTIONS(17),
    [anon_sym_assert] = ACTIONS(19),
    [anon_sym_return] = ACTIONS(21),
    [anon_sym_del] = ACTIONS(23),
    [anon_sym_raise] = ACTIONS(25),
    [anon_sym_pass] = ACTIONS(27),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_async] = ACTIONS(317),
    [anon_sym_match] = ACTIONS(317),
    [anon_sym_DASH] = ACTIONS(47),
    [anon_sym_PLUS] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(51),
    [anon_sym_STAR_STAR] = ACTIONS(53),
    [anon_sym_global] = ACTIONS(57),
    [anon_sym_nonlocal] = ACTIONS(59),
    [anon_sym_exec] = ACTIONS(61),
    [anon_sym_type] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(582),
    [sym__string_start] = ACTIONS(81),
  },
  [138] = {
    [sym_import_statement] = STATE(1351),
    [sym_future_import_statement] = STATE(1351),
    [sym_import_from_statement] = STATE(1351),
    [sym_print_statement] = STATE(1351),
    [sym_assert_statement] = STATE(1351),
    [sym_expression_statement] = STATE(1351),
    [sym_named_expression] = STATE(1009),
    [sym_return_statement] = STATE(1351),
    [sym_delete_statement] = STATE(1351),
    [sym_raise_statement] = STATE(1351),
    [sym_pass_statement] = STATE(1351),
    [sym_break_statement] = STATE(1351),
    [sym_continue_statement] = STATE(1351),
    [sym_list_splat] = STATE(1360),
    [sym_dictionary_splat] = STATE(1360),
    [sym_global_statement] = STATE(1351),
    [sym_nonlocal_statement] = STATE(1351),
    [sym_exec_statement] = STATE(1351),
    [sym_type_alias_statement] = STATE(1351),
    [sym_expression_list] = STATE(1361),
    [sym_pattern] = STATE(889),
    [sym_tuple_pattern] = STATE(875),
    [sym_list_pattern] = STATE(875),
    [sym_list_splat_pattern] = STATE(875),
    [sym_expression] = STATE(1019),
    [sym_primary_expression] = STATE(684),
    [sym_not_operator] = STATE(1009),
    [sym_boolean_operator] = STATE(1009),
    [sym_binary_operator] = STATE(797),
    [sym_unary_operator] = STATE(797),
    [sym_comparison_operator] = STATE(1009),
    [sym_lambda] = STATE(1009),
    [sym_assignment] = STATE(1361),
    [sym_augmented_assignment] = STATE(1361),
    [sym_pattern_list] = STATE(897),
    [sym_yield] = STATE(1361),
    [sym_attribute] = STATE(431),
    [sym_subscript] = STATE(431),
    [sym_call] = STATE(797),
    [sym_list] = STATE(797),
    [sym_set] = STATE(797),
    [sym_tuple] = STATE(797),
    [sym_dictionary] = STATE(797),
    [sym_list_comprehension] = STATE(797),
    [sym_dictionary_comprehension] = STATE(797),
    [sym_set_comprehension] = STATE(797),
    [sym_generator_expression] = STATE(797),
    [sym_parenthesized_expression] = STATE(797),
    [sym_conditional_expression] = STATE(1009),
    [sym_concatenated_string] = STATE(797),
    [sym_string] = STATE(713),
    [sym_await] = STATE(1009),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_STAR] = ACTIONS(15),
    [anon_sym_print] = ACTIONS(17),
    [anon_sym_assert] = ACTIONS(19),
    [anon_sym_return] = ACTIONS(21),
    [anon_sym_del] = ACTIONS(23),
    [anon_sym_raise] = ACTIONS(25),
    [anon_sym_pass] = ACTIONS(27),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_async] = ACTIONS(317),
    [anon_sym_match] = ACTIONS(317),
    [anon_sym_DASH] = ACTIONS(47),
    [anon_sym_PLUS] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(51),
    [anon_sym_STAR_STAR] = ACTIONS(53),
    [anon_sym_global] = ACTIONS(57),
    [anon_sym_nonlocal] = ACTIONS(59),
    [anon_sym_exec] = ACTIONS(61),
    [anon_sym_type] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(584),
    [sym__string_start] = ACTIONS(81),
  },
  [139] = {
    [sym_import_statement] = STATE(1351),
    [sym_future_import_statement] = STATE(1351),
    [sym_import_from_statement] = STATE(1351),
    [sym_print_statement] = STATE(1351),
    [sym_assert_statement] = STATE(1351),
    [sym_expression_statement] = STATE(1351),
    [sym_named_expression] = STATE(1009),
    [sym_return_statement] = STATE(1351),
    [sym_delete_statement] = STATE(1351),
    [sym_raise_statement] = STATE(1351),
    [sym_pass_statement] = STATE(1351),
    [sym_break_statement] = STATE(1351),
    [sym_continue_statement] = STATE(1351),
    [sym_list_splat] = STATE(1360),
    [sym_dictionary_splat] = STATE(1360),
    [sym_global_statement] = STATE(1351),
    [sym_nonlocal_statement] = STATE(1351),
    [sym_exec_statement] = STATE(1351),
    [sym_type_alias_statement] = STATE(1351),
    [sym_expression_list] = STATE(1361),
    [sym_pattern] = STATE(889),
    [sym_tuple_pattern] = STATE(875),
    [sym_list_pattern] = STATE(875),
    [sym_list_splat_pattern] = STATE(875),
    [sym_expression] = STATE(1019),
    [sym_primary_expression] = STATE(684),
    [sym_not_operator] = STATE(1009),
    [sym_boolean_operator] = STATE(1009),
    [sym_binary_operator] = STATE(797),
    [sym_unary_operator] = STATE(797),
    [sym_comparison_operator] = STATE(1009),
    [sym_lambda] = STATE(1009),
    [sym_assignment] = STATE(1361),
    [sym_augmented_assignment] = STATE(1361),
    [sym_pattern_list] = STATE(897),
    [sym_yield] = STATE(1361),
    [sym_attribute] = STATE(431),
    [sym_subscript] = STATE(431),
    [sym_call] = STATE(797),
    [sym_list] = STATE(797),
    [sym_set] = STATE(797),
    [sym_tuple] = STATE(797),
    [sym_dictionary] = STATE(797),
    [sym_list_comprehension] = STATE(797),
    [sym_dictionary_comprehension] = STATE(797),
    [sym_set_comprehension] = STATE(797),
    [sym_generator_expression] = STATE(797),
    [sym_parenthesized_expression] = STATE(797),
    [sym_conditional_expression] = STATE(1009),
    [sym_concatenated_string] = STATE(797),
    [sym_string] = STATE(713),
    [sym_await] = STATE(1009),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_STAR] = ACTIONS(15),
    [anon_sym_print] = ACTIONS(17),
    [anon_sym_assert] = ACTIONS(19),
    [anon_sym_return] = ACTIONS(21),
    [anon_sym_del] = ACTIONS(23),
    [anon_sym_raise] = ACTIONS(25),
    [anon_sym_pass] = ACTIONS(27),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_async] = ACTIONS(317),
    [anon_sym_match] = ACTIONS(317),
    [anon_sym_DASH] = ACTIONS(47),
    [anon_sym_PLUS] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(51),
    [anon_sym_STAR_STAR] = ACTIONS(53),
    [anon_sym_global] = ACTIONS(57),
    [anon_sym_nonlocal] = ACTIONS(59),
    [anon_sym_exec] = ACTIONS(61),
    [anon_sym_type] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(586),
    [sym__string_start] = ACTIONS(81),
  },
  [140] = {
    [sym_import_statement] = STATE(1351),
    [sym_future_import_statement] = STATE(1351),
    [sym_import_from_statement] = STATE(1351),
    [sym_print_statement] = STATE(1351),
    [sym_assert_statement] = STATE(1351),
    [sym_expression_statement] = STATE(1351),
    [sym_named_expression] = STATE(1009),
    [sym_return_statement] = STATE(1351),
    [sym_delete_statement] = STATE(1351),
    [sym_raise_statement] = STATE(1351),
    [sym_pass_statement] = STATE(1351),
    [sym_break_statement] = STATE(1351),
    [sym_continue_statement] = STATE(1351),
    [sym_list_splat] = STATE(1360),
    [sym_dictionary_splat] = STATE(1360),
    [sym_global_statement] = STATE(1351),
    [sym_nonlocal_statement] = STATE(1351),
    [sym_exec_statement] = STATE(1351),
    [sym_type_alias_statement] = STATE(1351),
    [sym_expression_list] = STATE(1361),
    [sym_pattern] = STATE(889),
    [sym_tuple_pattern] = STATE(875),
    [sym_list_pattern] = STATE(875),
    [sym_list_splat_pattern] = STATE(875),
    [sym_expression] = STATE(1019),
    [sym_primary_expression] = STATE(684),
    [sym_not_operator] = STATE(1009),
    [sym_boolean_operator] = STATE(1009),
    [sym_binary_operator] = STATE(797),
    [sym_unary_operator] = STATE(797),
    [sym_comparison_operator] = STATE(1009),
    [sym_lambda] = STATE(1009),
    [sym_assignment] = STATE(1361),
    [sym_augmented_assignment] = STATE(1361),
    [sym_pattern_list] = STATE(897),
    [sym_yield] = STATE(1361),
    [sym_attribute] = STATE(431),
    [sym_subscript] = STATE(431),
    [sym_call] = STATE(797),
    [sym_list] = STATE(797),
    [sym_set] = STATE(797),
    [sym_tuple] = STATE(797),
    [sym_dictionary] = STATE(797),
    [sym_list_comprehension] = STATE(797),
    [sym_dictionary_comprehension] = STATE(797),
    [sym_set_comprehension] = STATE(797),
    [sym_generator_expression] = STATE(797),
    [sym_parenthesized_expression] = STATE(797),
    [sym_conditional_expression] = STATE(1009),
    [sym_concatenated_string] = STATE(797),
    [sym_string] = STATE(713),
    [sym_await] = STATE(1009),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_STAR] = ACTIONS(15),
    [anon_sym_print] = ACTIONS(17),
    [anon_sym_assert] = ACTIONS(19),
    [anon_sym_return] = ACTIONS(21),
    [anon_sym_del] = ACTIONS(23),
    [anon_sym_raise] = ACTIONS(25),
    [anon_sym_pass] = ACTIONS(27),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_async] = ACTIONS(317),
    [anon_sym_match] = ACTIONS(317),
    [anon_sym_DASH] = ACTIONS(47),
    [anon_sym_PLUS] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(51),
    [anon_sym_STAR_STAR] = ACTIONS(53),
    [anon_sym_global] = ACTIONS(57),
    [anon_sym_nonlocal] = ACTIONS(59),
    [anon_sym_exec] = ACTIONS(61),
    [anon_sym_type] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(588),
    [sym__string_start] = ACTIONS(81),
  },
  [141] = {
    [sym_import_statement] = STATE(1351),
    [sym_future_import_statement] = STATE(1351),
    [sym_import_from_statement] = STATE(1351),
    [sym_print_statement] = STATE(1351),
    [sym_assert_statement] = STATE(1351),
    [sym_expression_statement] = STATE(1351),
    [sym_named_expression] = STATE(1009),
    [sym_return_statement] = STATE(1351),
    [sym_delete_statement] = STATE(1351),
    [sym_raise_statement] = STATE(1351),
    [sym_pass_statement] = STATE(1351),
    [sym_break_statement] = STATE(1351),
    [sym_continue_statement] = STATE(1351),
    [sym_list_splat] = STATE(1360),
    [sym_dictionary_splat] = STATE(1360),
    [sym_global_statement] = STATE(1351),
    [sym_nonlocal_statement] = STATE(1351),
    [sym_exec_statement] = STATE(1351),
    [sym_type_alias_statement] = STATE(1351),
    [sym_expression_list] = STATE(1361),
    [sym_pattern] = STATE(889),
    [sym_tuple_pattern] = STATE(875),
    [sym_list_pattern] = STATE(875),
    [sym_list_splat_pattern] = STATE(875),
    [sym_expression] = STATE(1019),
    [sym_primary_expression] = STATE(684),
    [sym_not_operator] = STATE(1009),
    [sym_boolean_operator] = STATE(1009),
    [sym_binary_operator] = STATE(797),
    [sym_unary_operator] = STATE(797),
    [sym_comparison_operator] = STATE(1009),
    [sym_lambda] = STATE(1009),
    [sym_assignment] = STATE(1361),
    [sym_augmented_assignment] = STATE(1361),
    [sym_pattern_list] = STATE(897),
    [sym_yield] = STATE(1361),
    [sym_attribute] = STATE(431),
    [sym_subscript] = STATE(431),
    [sym_call] = STATE(797),
    [sym_list] = STATE(797),
    [sym_set] = STATE(797),
    [sym_tuple] = STATE(797),
    [sym_dictionary] = STATE(797),
    [sym_list_comprehension] = STATE(797),
    [sym_dictionary_comprehension] = STATE(797),
    [sym_set_comprehension] = STATE(797),
    [sym_generator_expression] = STATE(797),
    [sym_parenthesized_expression] = STATE(797),
    [sym_conditional_expression] = STATE(1009),
    [sym_concatenated_string] = STATE(797),
    [sym_string] = STATE(713),
    [sym_await] = STATE(1009),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_STAR] = ACTIONS(15),
    [anon_sym_print] = ACTIONS(17),
    [anon_sym_assert] = ACTIONS(19),
    [anon_sym_return] = ACTIONS(21),
    [anon_sym_del] = ACTIONS(23),
    [anon_sym_raise] = ACTIONS(25),
    [anon_sym_pass] = ACTIONS(27),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_async] = ACTIONS(317),
    [anon_sym_match] = ACTIONS(317),
    [anon_sym_DASH] = ACTIONS(47),
    [anon_sym_PLUS] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(51),
    [anon_sym_STAR_STAR] = ACTIONS(53),
    [anon_sym_global] = ACTIONS(57),
    [anon_sym_nonlocal] = ACTIONS(59),
    [anon_sym_exec] = ACTIONS(61),
    [anon_sym_type] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(590),
    [sym__string_start] = ACTIONS(81),
  },
  [142] = {
    [sym_import_statement] = STATE(1351),
    [sym_future_import_statement] = STATE(1351),
    [sym_import_from_statement] = STATE(1351),
    [sym_print_statement] = STATE(1351),
    [sym_assert_statement] = STATE(1351),
    [sym_expression_statement] = STATE(1351),
    [sym_named_expression] = STATE(1009),
    [sym_return_statement] = STATE(1351),
    [sym_delete_statement] = STATE(1351),
    [sym_raise_statement] = STATE(1351),
    [sym_pass_statement] = STATE(1351),
    [sym_break_statement] = STATE(1351),
    [sym_continue_statement] = STATE(1351),
    [sym_list_splat] = STATE(1360),
    [sym_dictionary_splat] = STATE(1360),
    [sym_global_statement] = STATE(1351),
    [sym_nonlocal_statement] = STATE(1351),
    [sym_exec_statement] = STATE(1351),
    [sym_type_alias_statement] = STATE(1351),
    [sym_expression_list] = STATE(1361),
    [sym_pattern] = STATE(889),
    [sym_tuple_pattern] = STATE(875),
    [sym_list_pattern] = STATE(875),
    [sym_list_splat_pattern] = STATE(875),
    [sym_expression] = STATE(1019),
    [sym_primary_expression] = STATE(684),
    [sym_not_operator] = STATE(1009),
    [sym_boolean_operator] = STATE(1009),
    [sym_binary_operator] = STATE(797),
    [sym_unary_operator] = STATE(797),
    [sym_comparison_operator] = STATE(1009),
    [sym_lambda] = STATE(1009),
    [sym_assignment] = STATE(1361),
    [sym_augmented_assignment] = STATE(1361),
    [sym_pattern_list] = STATE(897),
    [sym_yield] = STATE(1361),
    [sym_attribute] = STATE(431),
    [sym_subscript] = STATE(431),
    [sym_call] = STATE(797),
    [sym_list] = STATE(797),
    [sym_set] = STATE(797),
    [sym_tuple] = STATE(797),
    [sym_dictionary] = STATE(797),
    [sym_list_comprehension] = STATE(797),
    [sym_dictionary_comprehension] = STATE(797),
    [sym_set_comprehension] = STATE(797),
    [sym_generator_expression] = STATE(797),
    [sym_parenthesized_expression] = STATE(797),
    [sym_conditional_expression] = STATE(1009),
    [sym_concatenated_string] = STATE(797),
    [sym_string] = STATE(713),
    [sym_await] = STATE(1009),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_STAR] = ACTIONS(15),
    [anon_sym_print] = ACTIONS(17),
    [anon_sym_assert] = ACTIONS(19),
    [anon_sym_return] = ACTIONS(21),
    [anon_sym_del] = ACTIONS(23),
    [anon_sym_raise] = ACTIONS(25),
    [anon_sym_pass] = ACTIONS(27),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_async] = ACTIONS(317),
    [anon_sym_match] = ACTIONS(317),
    [anon_sym_DASH] = ACTIONS(47),
    [anon_sym_PLUS] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(51),
    [anon_sym_STAR_STAR] = ACTIONS(53),
    [anon_sym_global] = ACTIONS(57),
    [anon_sym_nonlocal] = ACTIONS(59),
    [anon_sym_exec] = ACTIONS(61),
    [anon_sym_type] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(592),
    [sym__string_start] = ACTIONS(81),
  },
  [143] = {
    [sym_import_statement] = STATE(1351),
    [sym_future_import_statement] = STATE(1351),
    [sym_import_from_statement] = STATE(1351),
    [sym_print_statement] = STATE(1351),
    [sym_assert_statement] = STATE(1351),
    [sym_expression_statement] = STATE(1351),
    [sym_named_expression] = STATE(1009),
    [sym_return_statement] = STATE(1351),
    [sym_delete_statement] = STATE(1351),
    [sym_raise_statement] = STATE(1351),
    [sym_pass_statement] = STATE(1351),
    [sym_break_statement] = STATE(1351),
    [sym_continue_statement] = STATE(1351),
    [sym_list_splat] = STATE(1360),
    [sym_dictionary_splat] = STATE(1360),
    [sym_global_statement] = STATE(1351),
    [sym_nonlocal_statement] = STATE(1351),
    [sym_exec_statement] = STATE(1351),
    [sym_type_alias_statement] = STATE(1351),
    [sym_expression_list] = STATE(1361),
    [sym_pattern] = STATE(889),
    [sym_tuple_pattern] = STATE(875),
    [sym_list_pattern] = STATE(875),
    [sym_list_splat_pattern] = STATE(875),
    [sym_expression] = STATE(1019),
    [sym_primary_expression] = STATE(684),
    [sym_not_operator] = STATE(1009),
    [sym_boolean_operator] = STATE(1009),
    [sym_binary_operator] = STATE(797),
    [sym_unary_operator] = STATE(797),
    [sym_comparison_operator] = STATE(1009),
    [sym_lambda] = STATE(1009),
    [sym_assignment] = STATE(1361),
    [sym_augmented_assignment] = STATE(1361),
    [sym_pattern_list] = STATE(897),
    [sym_yield] = STATE(1361),
    [sym_attribute] = STATE(431),
    [sym_subscript] = STATE(431),
    [sym_call] = STATE(797),
    [sym_list] = STATE(797),
    [sym_set] = STATE(797),
    [sym_tuple] = STATE(797),
    [sym_dictionary] = STATE(797),
    [sym_list_comprehension] = STATE(797),
    [sym_dictionary_comprehension] = STATE(797),
    [sym_set_comprehension] = STATE(797),
    [sym_generator_expression] = STATE(797),
    [sym_parenthesized_expression] = STATE(797),
    [sym_conditional_expression] = STATE(1009),
    [sym_concatenated_string] = STATE(797),
    [sym_string] = STATE(713),
    [sym_await] = STATE(1009),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_STAR] = ACTIONS(15),
    [anon_sym_print] = ACTIONS(17),
    [anon_sym_assert] = ACTIONS(19),
    [anon_sym_return] = ACTIONS(21),
    [anon_sym_del] = ACTIONS(23),
    [anon_sym_raise] = ACTIONS(25),
    [anon_sym_pass] = ACTIONS(27),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_async] = ACTIONS(317),
    [anon_sym_match] = ACTIONS(317),
    [anon_sym_DASH] = ACTIONS(47),
    [anon_sym_PLUS] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(51),
    [anon_sym_STAR_STAR] = ACTIONS(53),
    [anon_sym_global] = ACTIONS(57),
    [anon_sym_nonlocal] = ACTIONS(59),
    [anon_sym_exec] = ACTIONS(61),
    [anon_sym_type] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(594),
    [sym__string_start] = ACTIONS(81),
  },
  [144] = {
    [sym_import_statement] = STATE(1351),
    [sym_future_import_statement] = STATE(1351),
    [sym_import_from_statement] = STATE(1351),
    [sym_print_statement] = STATE(1351),
    [sym_assert_statement] = STATE(1351),
    [sym_expression_statement] = STATE(1351),
    [sym_named_expression] = STATE(1009),
    [sym_return_statement] = STATE(1351),
    [sym_delete_statement] = STATE(1351),
    [sym_raise_statement] = STATE(1351),
    [sym_pass_statement] = STATE(1351),
    [sym_break_statement] = STATE(1351),
    [sym_continue_statement] = STATE(1351),
    [sym_list_splat] = STATE(1360),
    [sym_dictionary_splat] = STATE(1360),
    [sym_global_statement] = STATE(1351),
    [sym_nonlocal_statement] = STATE(1351),
    [sym_exec_statement] = STATE(1351),
    [sym_type_alias_statement] = STATE(1351),
    [sym_expression_list] = STATE(1361),
    [sym_pattern] = STATE(889),
    [sym_tuple_pattern] = STATE(875),
    [sym_list_pattern] = STATE(875),
    [sym_list_splat_pattern] = STATE(875),
    [sym_expression] = STATE(1019),
    [sym_primary_expression] = STATE(684),
    [sym_not_operator] = STATE(1009),
    [sym_boolean_operator] = STATE(1009),
    [sym_binary_operator] = STATE(797),
    [sym_unary_operator] = STATE(797),
    [sym_comparison_operator] = STATE(1009),
    [sym_lambda] = STATE(1009),
    [sym_assignment] = STATE(1361),
    [sym_augmented_assignment] = STATE(1361),
    [sym_pattern_list] = STATE(897),
    [sym_yield] = STATE(1361),
    [sym_attribute] = STATE(431),
    [sym_subscript] = STATE(431),
    [sym_call] = STATE(797),
    [sym_list] = STATE(797),
    [sym_set] = STATE(797),
    [sym_tuple] = STATE(797),
    [sym_dictionary] = STATE(797),
    [sym_list_comprehension] = STATE(797),
    [sym_dictionary_comprehension] = STATE(797),
    [sym_set_comprehension] = STATE(797),
    [sym_generator_expression] = STATE(797),
    [sym_parenthesized_expression] = STATE(797),
    [sym_conditional_expression] = STATE(1009),
    [sym_concatenated_string] = STATE(797),
    [sym_string] = STATE(713),
    [sym_await] = STATE(1009),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_STAR] = ACTIONS(15),
    [anon_sym_print] = ACTIONS(17),
    [anon_sym_assert] = ACTIONS(19),
    [anon_sym_return] = ACTIONS(21),
    [anon_sym_del] = ACTIONS(23),
    [anon_sym_raise] = ACTIONS(25),
    [anon_sym_pass] = ACTIONS(27),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_async] = ACTIONS(317),
    [anon_sym_match] = ACTIONS(317),
    [anon_sym_DASH] = ACTIONS(47),
    [anon_sym_PLUS] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(51),
    [anon_sym_STAR_STAR] = ACTIONS(53),
    [anon_sym_global] = ACTIONS(57),
    [anon_sym_nonlocal] = ACTIONS(59),
    [anon_sym_exec] = ACTIONS(61),
    [anon_sym_type] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(596),
    [sym__string_start] = ACTIONS(81),
  },
  [145] = {
    [sym_import_statement] = STATE(1351),
    [sym_future_import_statement] = STATE(1351),
    [sym_import_from_statement] = STATE(1351),
    [sym_print_statement] = STATE(1351),
    [sym_assert_statement] = STATE(1351),
    [sym_expression_statement] = STATE(1351),
    [sym_named_expression] = STATE(1009),
    [sym_return_statement] = STATE(1351),
    [sym_delete_statement] = STATE(1351),
    [sym_raise_statement] = STATE(1351),
    [sym_pass_statement] = STATE(1351),
    [sym_break_statement] = STATE(1351),
    [sym_continue_statement] = STATE(1351),
    [sym_list_splat] = STATE(1360),
    [sym_dictionary_splat] = STATE(1360),
    [sym_global_statement] = STATE(1351),
    [sym_nonlocal_statement] = STATE(1351),
    [sym_exec_statement] = STATE(1351),
    [sym_type_alias_statement] = STATE(1351),
    [sym_expression_list] = STATE(1361),
    [sym_pattern] = STATE(889),
    [sym_tuple_pattern] = STATE(875),
    [sym_list_pattern] = STATE(875),
    [sym_list_splat_pattern] = STATE(875),
    [sym_expression] = STATE(1019),
    [sym_primary_expression] = STATE(684),
    [sym_not_operator] = STATE(1009),
    [sym_boolean_operator] = STATE(1009),
    [sym_binary_operator] = STATE(797),
    [sym_unary_operator] = STATE(797),
    [sym_comparison_operator] = STATE(1009),
    [sym_lambda] = STATE(1009),
    [sym_assignment] = STATE(1361),
    [sym_augmented_assignment] = STATE(1361),
    [sym_pattern_list] = STATE(897),
    [sym_yield] = STATE(1361),
    [sym_attribute] = STATE(431),
    [sym_subscript] = STATE(431),
    [sym_call] = STATE(797),
    [sym_list] = STATE(797),
    [sym_set] = STATE(797),
    [sym_tuple] = STATE(797),
    [sym_dictionary] = STATE(797),
    [sym_list_comprehension] = STATE(797),
    [sym_dictionary_comprehension] = STATE(797),
    [sym_set_comprehension] = STATE(797),
    [sym_generator_expression] = STATE(797),
    [sym_parenthesized_expression] = STATE(797),
    [sym_conditional_expression] = STATE(1009),
    [sym_concatenated_string] = STATE(797),
    [sym_string] = STATE(713),
    [sym_await] = STATE(1009),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_STAR] = ACTIONS(15),
    [anon_sym_print] = ACTIONS(17),
    [anon_sym_assert] = ACTIONS(19),
    [anon_sym_return] = ACTIONS(21),
    [anon_sym_del] = ACTIONS(23),
    [anon_sym_raise] = ACTIONS(25),
    [anon_sym_pass] = ACTIONS(27),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_async] = ACTIONS(317),
    [anon_sym_match] = ACTIONS(317),
    [anon_sym_DASH] = ACTIONS(47),
    [anon_sym_PLUS] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(51),
    [anon_sym_STAR_STAR] = ACTIONS(53),
    [anon_sym_global] = ACTIONS(57),
    [anon_sym_nonlocal] = ACTIONS(59),
    [anon_sym_exec] = ACTIONS(61),
    [anon_sym_type] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(598),
    [sym__string_start] = ACTIONS(81),
  },
  [146] = {
    [sym_import_statement] = STATE(1351),
    [sym_future_import_statement] = STATE(1351),
    [sym_import_from_statement] = STATE(1351),
    [sym_print_statement] = STATE(1351),
    [sym_assert_statement] = STATE(1351),
    [sym_expression_statement] = STATE(1351),
    [sym_named_expression] = STATE(1009),
    [sym_return_statement] = STATE(1351),
    [sym_delete_statement] = STATE(1351),
    [sym_raise_statement] = STATE(1351),
    [sym_pass_statement] = STATE(1351),
    [sym_break_statement] = STATE(1351),
    [sym_continue_statement] = STATE(1351),
    [sym_list_splat] = STATE(1360),
    [sym_dictionary_splat] = STATE(1360),
    [sym_global_statement] = STATE(1351),
    [sym_nonlocal_statement] = STATE(1351),
    [sym_exec_statement] = STATE(1351),
    [sym_type_alias_statement] = STATE(1351),
    [sym_expression_list] = STATE(1361),
    [sym_pattern] = STATE(889),
    [sym_tuple_pattern] = STATE(875),
    [sym_list_pattern] = STATE(875),
    [sym_list_splat_pattern] = STATE(875),
    [sym_expression] = STATE(1019),
    [sym_primary_expression] = STATE(684),
    [sym_not_operator] = STATE(1009),
    [sym_boolean_operator] = STATE(1009),
    [sym_binary_operator] = STATE(797),
    [sym_unary_operator] = STATE(797),
    [sym_comparison_operator] = STATE(1009),
    [sym_lambda] = STATE(1009),
    [sym_assignment] = STATE(1361),
    [sym_augmented_assignment] = STATE(1361),
    [sym_pattern_list] = STATE(897),
    [sym_yield] = STATE(1361),
    [sym_attribute] = STATE(431),
    [sym_subscript] = STATE(431),
    [sym_call] = STATE(797),
    [sym_list] = STATE(797),
    [sym_set] = STATE(797),
    [sym_tuple] = STATE(797),
    [sym_dictionary] = STATE(797),
    [sym_list_comprehension] = STATE(797),
    [sym_dictionary_comprehension] = STATE(797),
    [sym_set_comprehension] = STATE(797),
    [sym_generator_expression] = STATE(797),
    [sym_parenthesized_expression] = STATE(797),
    [sym_conditional_expression] = STATE(1009),
    [sym_concatenated_string] = STATE(797),
    [sym_string] = STATE(713),
    [sym_await] = STATE(1009),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_STAR] = ACTIONS(15),
    [anon_sym_print] = ACTIONS(17),
    [anon_sym_assert] = ACTIONS(19),
    [anon_sym_return] = ACTIONS(21),
    [anon_sym_del] = ACTIONS(23),
    [anon_sym_raise] = ACTIONS(25),
    [anon_sym_pass] = ACTIONS(27),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_async] = ACTIONS(317),
    [anon_sym_match] = ACTIONS(317),
    [anon_sym_DASH] = ACTIONS(47),
    [anon_sym_PLUS] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(51),
    [anon_sym_STAR_STAR] = ACTIONS(53),
    [anon_sym_global] = ACTIONS(57),
    [anon_sym_nonlocal] = ACTIONS(59),
    [anon_sym_exec] = ACTIONS(61),
    [anon_sym_type] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(600),
    [sym__string_start] = ACTIONS(81),
  },
  [147] = {
    [sym_import_statement] = STATE(1351),
    [sym_future_import_statement] = STATE(1351),
    [sym_import_from_statement] = STATE(1351),
    [sym_print_statement] = STATE(1351),
    [sym_assert_statement] = STATE(1351),
    [sym_expression_statement] = STATE(1351),
    [sym_named_expression] = STATE(1009),
    [sym_return_statement] = STATE(1351),
    [sym_delete_statement] = STATE(1351),
    [sym_raise_statement] = STATE(1351),
    [sym_pass_statement] = STATE(1351),
    [sym_break_statement] = STATE(1351),
    [sym_continue_statement] = STATE(1351),
    [sym_list_splat] = STATE(1360),
    [sym_dictionary_splat] = STATE(1360),
    [sym_global_statement] = STATE(1351),
    [sym_nonlocal_statement] = STATE(1351),
    [sym_exec_statement] = STATE(1351),
    [sym_type_alias_statement] = STATE(1351),
    [sym_expression_list] = STATE(1361),
    [sym_pattern] = STATE(889),
    [sym_tuple_pattern] = STATE(875),
    [sym_list_pattern] = STATE(875),
    [sym_list_splat_pattern] = STATE(875),
    [sym_expression] = STATE(1019),
    [sym_primary_expression] = STATE(684),
    [sym_not_operator] = STATE(1009),
    [sym_boolean_operator] = STATE(1009),
    [sym_binary_operator] = STATE(797),
    [sym_unary_operator] = STATE(797),
    [sym_comparison_operator] = STATE(1009),
    [sym_lambda] = STATE(1009),
    [sym_assignment] = STATE(1361),
    [sym_augmented_assignment] = STATE(1361),
    [sym_pattern_list] = STATE(897),
    [sym_yield] = STATE(1361),
    [sym_attribute] = STATE(431),
    [sym_subscript] = STATE(431),
    [sym_call] = STATE(797),
    [sym_list] = STATE(797),
    [sym_set] = STATE(797),
    [sym_tuple] = STATE(797),
    [sym_dictionary] = STATE(797),
    [sym_list_comprehension] = STATE(797),
    [sym_dictionary_comprehension] = STATE(797),
    [sym_set_comprehension] = STATE(797),
    [sym_generator_expression] = STATE(797),
    [sym_parenthesized_expression] = STATE(797),
    [sym_conditional_expression] = STATE(1009),
    [sym_concatenated_string] = STATE(797),
    [sym_string] = STATE(713),
    [sym_await] = STATE(1009),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_STAR] = ACTIONS(15),
    [anon_sym_print] = ACTIONS(17),
    [anon_sym_assert] = ACTIONS(19),
    [anon_sym_return] = ACTIONS(21),
    [anon_sym_del] = ACTIONS(23),
    [anon_sym_raise] = ACTIONS(25),
    [anon_sym_pass] = ACTIONS(27),
    [anon_sym_break] = ACTIONS(29),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_async] = ACTIONS(317),
    [anon_sym_match] = ACTIONS(317),
    [anon_sym_DASH] = ACTIONS(47),
    [anon_sym_PLUS] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(49),
    [anon_sym_LBRACE] = ACTIONS(51),
    [anon_sym_STAR_STAR] = ACTIONS(53),
    [anon_sym_global] = ACTIONS(57),
    [anon_sym_nonlocal] = ACTIONS(59),
    [anon_sym_exec] = ACTIONS(61),
    [anon_sym_type] = ACTIONS(63),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_lambda] = ACTIONS(71),
    [anon_sym_yield] = ACTIONS(73),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(79),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(81),
  },
  [148] = {
    [sym_named_expression] = STATE(900),
    [sym_expression] = STATE(901),
    [sym_primary_expression] = STATE(630),
    [sym_not_operator] = STATE(900),
    [sym_boolean_operator] = STATE(900),
    [sym_binary_operator] = STATE(642),
    [sym_unary_operator] = STATE(642),
    [sym_comparison_operator] = STATE(900),
    [sym_lambda] = STATE(900),
    [sym_attribute] = STATE(642),
    [sym_subscript] = STATE(642),
    [sym_call] = STATE(642),
    [sym_list] = STATE(642),
    [sym_set] = STATE(642),
    [sym_tuple] = STATE(642),
    [sym_dictionary] = STATE(642),
    [sym_list_comprehension] = STATE(642),
    [sym_dictionary_comprehension] = STATE(642),
    [sym_set_comprehension] = STATE(642),
    [sym_generator_expression] = STATE(642),
    [sym_parenthesized_expression] = STATE(642),
    [sym_conditional_expression] = STATE(900),
    [sym_concatenated_string] = STATE(642),
    [sym_string] = STATE(600),
    [sym_await] = STATE(900),
    [sym_identifier] = ACTIONS(274),
    [anon_sym_DOT] = ACTIONS(276),
    [anon_sym_LPAREN] = ACTIONS(278),
    [anon_sym_RPAREN] = ACTIONS(303),
    [anon_sym_COMMA] = ACTIONS(303),
    [anon_sym_STAR] = ACTIONS(276),
    [anon_sym_print] = ACTIONS(285),
    [anon_sym_GT_GT] = ACTIONS(303),
    [anon_sym_COLON_EQ] = ACTIONS(568),
    [anon_sym_if] = ACTIONS(276),
    [anon_sym_COLON] = ACTIONS(276),
    [anon_sym_else] = ACTIONS(276),
    [anon_sym_async] = ACTIONS(285),
    [anon_sym_in] = ACTIONS(276),
    [anon_sym_match] = ACTIONS(285),
    [anon_sym_PIPE] = ACTIONS(303),
    [anon_sym_DASH] = ACTIONS(301),
    [anon_sym_PLUS] = ACTIONS(301),
    [anon_sym_LBRACK] = ACTIONS(293),
    [anon_sym_RBRACK] = ACTIONS(303),
    [anon_sym_LBRACE] = ACTIONS(295),
    [anon_sym_RBRACE] = ACTIONS(303),
    [anon_sym_STAR_STAR] = ACTIONS(303),
    [anon_sym_EQ] = ACTIONS(276),
    [anon_sym_exec] = ACTIONS(285),
    [anon_sym_type] = ACTIONS(285),
    [anon_sym_AT] = ACTIONS(303),
    [anon_sym_not] = ACTIONS(299),
    [anon_sym_and] = ACTIONS(276),
    [anon_sym_or] = ACTIONS(276),
    [anon_sym_SLASH] = ACTIONS(276),
    [anon_sym_PERCENT] = ACTIONS(303),
    [anon_sym_SLASH_SLASH] = ACTIONS(303),
    [anon_sym_AMP] = ACTIONS(303),
    [anon_sym_CARET] = ACTIONS(303),
    [anon_sym_LT_LT] = ACTIONS(303),
    [anon_sym_TILDE] = ACTIONS(301),
    [anon_sym_LT] = ACTIONS(276),
    [anon_sym_LT_EQ] = ACTIONS(303),
    [anon_sym_EQ_EQ] = ACTIONS(303),
    [anon_sym_BANG_EQ] = ACTIONS(303),
    [anon_sym_GT_EQ] = ACTIONS(303),
    [anon_sym_GT] = ACTIONS(276),
    [anon_sym_LT_GT] = ACTIONS(303),
    [anon_sym_is] = ACTIONS(276),
    [anon_sym_lambda] = ACTIONS(305),
    [sym_ellipsis] = ACTIONS(309),
    [sym_type_conversion] = ACTIONS(303),
    [sym_integer] = ACTIONS(311),
    [sym_float] = ACTIONS(309),
    [anon_sym_await] = ACTIONS(313),
    [sym_true] = ACTIONS(311),
    [sym_false] = ACTIONS(311),
    [sym_none] = ACTIONS(311),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(315),
  },
  [149] = {
    [sym_named_expression] = STATE(900),
    [sym_expression] = STATE(901),
    [sym_primary_expression] = STATE(643),
    [sym_not_operator] = STATE(900),
    [sym_boolean_operator] = STATE(900),
    [sym_binary_operator] = STATE(642),
    [sym_unary_operator] = STATE(642),
    [sym_comparison_operator] = STATE(900),
    [sym_lambda] = STATE(900),
    [sym_attribute] = STATE(642),
    [sym_subscript] = STATE(642),
    [sym_call] = STATE(642),
    [sym_list] = STATE(642),
    [sym_set] = STATE(642),
    [sym_tuple] = STATE(642),
    [sym_dictionary] = STATE(642),
    [sym_list_comprehension] = STATE(642),
    [sym_dictionary_comprehension] = STATE(642),
    [sym_set_comprehension] = STATE(642),
    [sym_generator_expression] = STATE(642),
    [sym_parenthesized_expression] = STATE(642),
    [sym_conditional_expression] = STATE(900),
    [sym_concatenated_string] = STATE(642),
    [sym_string] = STATE(600),
    [sym_await] = STATE(900),
    [sym_identifier] = ACTIONS(602),
    [anon_sym_DOT] = ACTIONS(276),
    [anon_sym_LPAREN] = ACTIONS(604),
    [anon_sym_RPAREN] = ACTIONS(303),
    [anon_sym_COMMA] = ACTIONS(303),
    [anon_sym_as] = ACTIONS(276),
    [anon_sym_STAR] = ACTIONS(276),
    [anon_sym_print] = ACTIONS(606),
    [anon_sym_GT_GT] = ACTIONS(303),
    [anon_sym_COLON_EQ] = ACTIONS(608),
    [anon_sym_if] = ACTIONS(276),
    [anon_sym_COLON] = ACTIONS(276),
    [anon_sym_async] = ACTIONS(606),
    [anon_sym_for] = ACTIONS(276),
    [anon_sym_in] = ACTIONS(276),
    [anon_sym_match] = ACTIONS(606),
    [anon_sym_PIPE] = ACTIONS(303),
    [anon_sym_DASH] = ACTIONS(610),
    [anon_sym_PLUS] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_RBRACK] = ACTIONS(303),
    [anon_sym_LBRACE] = ACTIONS(295),
    [anon_sym_RBRACE] = ACTIONS(303),
    [anon_sym_STAR_STAR] = ACTIONS(303),
    [anon_sym_exec] = ACTIONS(606),
    [anon_sym_type] = ACTIONS(606),
    [anon_sym_AT] = ACTIONS(303),
    [anon_sym_not] = ACTIONS(614),
    [anon_sym_and] = ACTIONS(276),
    [anon_sym_or] = ACTIONS(276),
    [anon_sym_SLASH] = ACTIONS(276),
    [anon_sym_PERCENT] = ACTIONS(303),
    [anon_sym_SLASH_SLASH] = ACTIONS(303),
    [anon_sym_AMP] = ACTIONS(303),
    [anon_sym_CARET] = ACTIONS(303),
    [anon_sym_LT_LT] = ACTIONS(303),
    [anon_sym_TILDE] = ACTIONS(610),
    [anon_sym_LT] = ACTIONS(276),
    [anon_sym_LT_EQ] = ACTIONS(303),
    [anon_sym_EQ_EQ] = ACTIONS(303),
    [anon_sym_BANG_EQ] = ACTIONS(303),
    [anon_sym_GT_EQ] = ACTIONS(303),
    [anon_sym_GT] = ACTIONS(276),
    [anon_sym_LT_GT] = ACTIONS(303),
    [anon_sym_is] = ACTIONS(276),
    [anon_sym_lambda] = ACTIONS(616),
    [sym_ellipsis] = ACTIONS(309),
    [sym_integer] = ACTIONS(311),
    [sym_float] = ACTIONS(309),
    [anon_sym_await] = ACTIONS(618),
    [sym_true] = ACTIONS(311),
    [sym_false] = ACTIONS(311),
    [sym_none] = ACTIONS(311),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(315),
  },
  [150] = {
    [sym_named_expression] = STATE(1009),
    [sym_expression] = STATE(976),
    [sym_primary_expression] = STATE(684),
    [sym_not_operator] = STATE(1009),
    [sym_boolean_operator] = STATE(1009),
    [sym_binary_operator] = STATE(797),
    [sym_unary_operator] = STATE(797),
    [sym_comparison_operator] = STATE(1009),
    [sym_lambda] = STATE(1009),
    [sym_attribute] = STATE(797),
    [sym_subscript] = STATE(797),
    [sym_call] = STATE(797),
    [sym_list] = STATE(797),
    [sym_set] = STATE(797),
    [sym_tuple] = STATE(797),
    [sym_dictionary] = STATE(797),
    [sym_list_comprehension] = STATE(797),
    [sym_dictionary_comprehension] = STATE(797),
    [sym_set_comprehension] = STATE(797),
    [sym_generator_expression] = STATE(797),
    [sym_parenthesized_expression] = STATE(797),
    [sym_conditional_expression] = STATE(1009),
    [sym_concatenated_string] = STATE(797),
    [sym_string] = STATE(713),
    [sym_await] = STATE(1009),
    [sym_identifier] = ACTIONS(331),
    [anon_sym_DOT] = ACTIONS(276),
    [anon_sym_from] = ACTIONS(276),
    [anon_sym_LPAREN] = ACTIONS(559),
    [anon_sym_COMMA] = ACTIONS(303),
    [anon_sym_STAR] = ACTIONS(276),
    [anon_sym_print] = ACTIONS(333),
    [anon_sym_GT_GT] = ACTIONS(303),
    [anon_sym_COLON_EQ] = ACTIONS(287),
    [anon_sym_if] = ACTIONS(276),
    [anon_sym_async] = ACTIONS(333),
    [anon_sym_in] = ACTIONS(276),
    [anon_sym_match] = ACTIONS(333),
    [anon_sym_PIPE] = ACTIONS(303),
    [anon_sym_DASH] = ACTIONS(47),
    [anon_sym_PLUS] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(563),
    [anon_sym_LBRACE] = ACTIONS(51),
    [anon_sym_STAR_STAR] = ACTIONS(303),
    [anon_sym_EQ] = ACTIONS(276),
    [anon_sym_exec] = ACTIONS(333),
    [anon_sym_type] = ACTIONS(333),
    [anon_sym_AT] = ACTIONS(303),
    [anon_sym_not] = ACTIONS(69),
    [anon_sym_and] = ACTIONS(276),
    [anon_sym_or] = ACTIONS(276),
    [anon_sym_SLASH] = ACTIONS(276),
    [anon_sym_PERCENT] = ACTIONS(303),
    [anon_sym_SLASH_SLASH] = ACTIONS(303),
    [anon_sym_AMP] = ACTIONS(303),
    [anon_sym_CARET] = ACTIONS(303),
    [anon_sym_LT_LT] = ACTIONS(303),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_LT] = ACTIONS(276),
    [anon_sym_LT_EQ] = ACTIONS(303),
    [anon_sym_EQ_EQ] = ACTIONS(303),
    [anon_sym_BANG_EQ] = ACTIONS(303),
    [anon_sym_GT_EQ] = ACTIONS(303),
    [anon_sym_GT] = ACTIONS(276),
    [anon_sym_LT_GT] = ACTIONS(303),
    [anon_sym_is] = ACTIONS(276),
    [anon_sym_lambda] = ACTIONS(71),
    [sym_ellipsis] = ACTIONS(75),
    [sym_integer] = ACTIONS(77),
    [sym_float] = ACTIONS(75),
    [anon_sym_await] = ACTIONS(337),
    [sym_true] = ACTIONS(77),
    [sym_false] = ACTIONS(77),
    [sym_none] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(303),
    [sym__newline] = ACTIONS(303),
    [sym__string_start] = ACTIONS(81),
  },
  [151] = {
    [sym_named_expression] = STATE(900),
    [sym_expression] = STATE(901),
    [sym_primary_expression] = STATE(643),
    [sym_not_operator] = STATE(900),
    [sym_boolean_operator] = STATE(900),
    [sym_binary_operator] = STATE(642),
    [sym_unary_operator] = STATE(642),
    [sym_comparison_operator] = STATE(900),
    [sym_lambda] = STATE(900),
    [sym_attribute] = STATE(642),
    [sym_subscript] = STATE(642),
    [sym_call] = STATE(642),
    [sym_list] = STATE(642),
    [sym_set] = STATE(642),
    [sym_tuple] = STATE(642),
    [sym_dictionary] = STATE(642),
    [sym_list_comprehension] = STATE(642),
    [sym_dictionary_comprehension] = STATE(642),
    [sym_set_comprehension] = STATE(642),
    [sym_generator_expression] = STATE(642),
    [sym_parenthesized_expression] = STATE(642),
    [sym_conditional_expression] = STATE(900),
    [sym_concatenated_string] = STATE(642),
    [sym_string] = STATE(600),
    [sym_await] = STATE(900),
    [sym_identifier] = ACTIONS(602),
    [anon_sym_DOT] = ACTIONS(276),
    [anon_sym_LPAREN] = ACTIONS(604),
    [anon_sym_RPAREN] = ACTIONS(303),
    [anon_sym_COMMA] = ACTIONS(303),
    [anon_sym_STAR] = ACTIONS(276),
    [anon_sym_print] = ACTIONS(606),
    [anon_sym_GT_GT] = ACTIONS(303),
    [anon_sym_COLON_EQ] = ACTIONS(608),
    [anon_sym_if] = ACTIONS(276),
    [anon_sym_async] = ACTIONS(606),
    [anon_sym_for] = ACTIONS(276),
    [anon_sym_in] = ACTIONS(276),
    [anon_sym_match] = ACTIONS(606),
    [anon_sym_PIPE] = ACTIONS(303),
    [anon_sym_DASH] = ACTIONS(610),
    [anon_sym_PLUS] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_LBRACE] = ACTIONS(295),
    [anon_sym_STAR_STAR] = ACTIONS(303),
    [anon_sym_EQ] = ACTIONS(620),
    [anon_sym_exec] = ACTIONS(606),
    [anon_sym_type] = ACTIONS(606),
    [anon_sym_AT] = ACTIONS(303),
    [anon_sym_not] = ACTIONS(614),
    [anon_sym_and] = ACTIONS(276),
    [anon_sym_or] = ACTIONS(276),
    [anon_sym_SLASH] = ACTIONS(276),
    [anon_sym_PERCENT] = ACTIONS(303),
    [anon_sym_SLASH_SLASH] = ACTIONS(303),
    [anon_sym_AMP] = ACTIONS(303),
    [anon_sym_CARET] = ACTIONS(303),
    [anon_sym_LT_LT] = ACTIONS(303),
    [anon_sym_TILDE] = ACTIONS(610),
    [anon_sym_LT] = ACTIONS(276),
    [anon_sym_LT_EQ] = ACTIONS(303),
    [anon_sym_EQ_EQ] = ACTIONS(303),
    [anon_sym_BANG_EQ] = ACTIONS(303),
    [anon_sym_GT_EQ] = ACTIONS(303),
    [anon_sym_GT] = ACTIONS(276),
    [anon_sym_LT_GT] = ACTIONS(303),
    [anon_sym_is] = ACTIONS(276),
    [anon_sym_lambda] = ACTIONS(616),
    [sym_ellipsis] = ACTIONS(309),
    [sym_integer] = ACTIONS(311),
    [sym_float] = ACTIONS(309),
    [anon_sym_await] = ACTIONS(618),
    [sym_true] = ACTIONS(311),
    [sym_false] = ACTIONS(311),
    [sym_none] = ACTIONS(311),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(315),
  },
  [152] = {
    [sym_named_expression] = STATE(900),
    [sym_expression] = STATE(901),
    [sym_primary_expression] = STATE(643),
    [sym_not_operator] = STATE(900),
    [sym_boolean_operator] = STATE(900),
    [sym_binary_operator] = STATE(642),
    [sym_unary_operator] = STATE(642),
    [sym_comparison_operator] = STATE(900),
    [sym_lambda] = STATE(900),
    [sym_attribute] = STATE(642),
    [sym_subscript] = STATE(642),
    [sym_call] = STATE(642),
    [sym_list] = STATE(642),
    [sym_set] = STATE(642),
    [sym_tuple] = STATE(642),
    [sym_dictionary] = STATE(642),
    [sym_list_comprehension] = STATE(642),
    [sym_dictionary_comprehension] = STATE(642),
    [sym_set_comprehension] = STATE(642),
    [sym_generator_expression] = STATE(642),
    [sym_parenthesized_expression] = STATE(642),
    [sym_conditional_expression] = STATE(900),
    [sym_concatenated_string] = STATE(642),
    [sym_string] = STATE(600),
    [sym_await] = STATE(900),
    [sym_identifier] = ACTIONS(602),
    [anon_sym_DOT] = ACTIONS(276),
    [anon_sym_LPAREN] = ACTIONS(604),
    [anon_sym_RPAREN] = ACTIONS(280),
    [anon_sym_COMMA] = ACTIONS(280),
    [anon_sym_STAR] = ACTIONS(276),
    [anon_sym_print] = ACTIONS(606),
    [anon_sym_GT_GT] = ACTIONS(303),
    [anon_sym_COLON_EQ] = ACTIONS(608),
    [anon_sym_if] = ACTIONS(276),
    [anon_sym_async] = ACTIONS(606),
    [anon_sym_for] = ACTIONS(276),
    [anon_sym_in] = ACTIONS(276),
    [anon_sym_match] = ACTIONS(606),
    [anon_sym_PIPE] = ACTIONS(303),
    [anon_sym_DASH] = ACTIONS(610),
    [anon_sym_PLUS] = ACTIONS(610),
    [anon_sym_LBRACK] = ACTIONS(612),
    [anon_sym_RBRACK] = ACTIONS(280),
    [anon_sym_LBRACE] = ACTIONS(295),
    [anon_sym_STAR_STAR] = ACTIONS(303),
    [anon_sym_exec] = ACTIONS(606),
    [anon_sym_type] = ACTIONS(606),
    [anon_sym_AT] = ACTIONS(303),
    [anon_sym_not] = ACTIONS(614),
    [anon_sym_and] = ACTIONS(276),
    [anon_sym_or] = ACTIONS(276),
    [anon_sym_SLASH] = ACTIONS(276),
    [anon_sym_PERCENT] = ACTIONS(303),
    [anon_sym_SLASH_SLASH] = ACTIONS(303),
    [anon_sym_AMP] = ACTIONS(303),
    [anon_sym_CARET] = ACTIONS(303),
    [anon_sym_LT_LT] = ACTIONS(303),
    [anon_sym_TILDE] = ACTIONS(610),
    [anon_sym_LT] = ACTIONS(276),
    [anon_sym_LT_EQ] = ACTIONS(303),
    [anon_sym_EQ_EQ] = ACTIONS(303),
    [anon_sym_BANG_EQ] = ACTIONS(303),
    [anon_sym_GT_EQ] = ACTIONS(303),
    [anon_sym_GT] = ACTIONS(276),
    [anon_sym_LT_GT] = ACTIONS(303),
    [anon_sym_is] = ACTIONS(276),
    [anon_sym_lambda] = ACTIONS(616),
    [sym_ellipsis] = ACTIONS(309),
    [sym_integer] = ACTIONS(311),
    [sym_float] = ACTIONS(309),
    [anon_sym_await] = ACTIONS(618),
    [sym_true] = ACTIONS(311),
    [sym_false] = ACTIONS(311),
    [sym_none] = ACTIONS(311),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(315),
  },
  [153] = {
    [sym_named_expression] = STATE(1015),
    [sym_expression] = STATE(1042),
    [sym_primary_expression] = STATE(740),
    [sym_not_operator] = STATE(1015),
    [sym_boolean_operator] = STATE(1015),
    [sym_binary_operator] = STATE(811),
    [sym_unary_operator] = STATE(811),
    [sym_comparison_operator] = STATE(1015),
    [sym_lambda] = STATE(1015),
    [sym_attribute] = STATE(811),
    [sym_subscript] = STATE(811),
    [sym_call] = STATE(811),
    [sym_list] = STATE(811),
    [sym_set] = STATE(811),
    [sym_tuple] = STATE(811),
    [sym_dictionary] = STATE(811),
    [sym_list_comprehension] = STATE(811),
    [sym_dictionary_comprehension] = STATE(811),
    [sym_set_comprehension] = STATE(811),
    [sym_generator_expression] = STATE(811),
    [sym_parenthesized_expression] = STATE(811),
    [sym_conditional_expression] = STATE(1015),
    [sym_concatenated_string] = STATE(811),
    [sym_string] = STATE(742),
    [sym_await] = STATE(1015),
    [sym_identifier] = ACTIONS(622),
    [anon_sym_DOT] = ACTIONS(276),
    [anon_sym_LPAREN] = ACTIONS(624),
    [anon_sym_RPAREN] = ACTIONS(303),
    [anon_sym_COMMA] = ACTIONS(303),
    [anon_sym_as] = ACTIONS(276),
    [anon_sym_STAR] = ACTIONS(276),
    [anon_sym_print] = ACTIONS(626),
    [anon_sym_GT_GT] = ACTIONS(303),
    [anon_sym_COLON_EQ] = ACTIONS(628),
    [anon_sym_if] = ACTIONS(276),
    [anon_sym_COLON] = ACTIONS(276),
    [anon_sym_async] = ACTIONS(626),
    [anon_sym_in] = ACTIONS(276),
    [anon_sym_match] = ACTIONS(626),
    [anon_sym_PIPE] = ACTIONS(303),
    [anon_sym_DASH] = ACTIONS(630),
    [anon_sym_PLUS] = ACTIONS(630),
    [anon_sym_LBRACK] = ACTIONS(632),
    [anon_sym_LBRACE] = ACTIONS(634),
    [anon_sym_STAR_STAR] = ACTIONS(303),
    [anon_sym_exec] = ACTIONS(626),
    [anon_sym_type] = ACTIONS(626),
    [anon_sym_AT] = ACTIONS(303),
    [anon_sym_not] = ACTIONS(636),
    [anon_sym_and] = ACTIONS(276),
    [anon_sym_or] = ACTIONS(276),
    [anon_sym_SLASH] = ACTIONS(276),
    [anon_sym_PERCENT] = ACTIONS(303),
    [anon_sym_SLASH_SLASH] = ACTIONS(303),
    [anon_sym_AMP] = ACTIONS(303),
    [anon_sym_CARET] = ACTIONS(303),
    [anon_sym_LT_LT] = ACTIONS(303),
    [anon_sym_TILDE] = ACTIONS(630),
    [anon_sym_LT] = ACTIONS(276),
    [anon_sym_LT_EQ] = ACTIONS(303),
    [anon_sym_EQ_EQ] = ACTIONS(303),
    [anon_sym_BANG_EQ] = ACTIONS(303),
    [anon_sym_GT_EQ] = ACTIONS(303),
    [anon_sym_GT] = ACTIONS(276),
    [anon_sym_LT_GT] = ACTIONS(303),
    [anon_sym_is] = ACTIONS(276),
    [anon_sym_lambda] = ACTIONS(638),
    [sym_ellipsis] = ACTIONS(640),
    [sym_integer] = ACTIONS(642),
    [sym_float] = ACTIONS(640),
    [anon_sym_await] = ACTIONS(644),
    [sym_true] = ACTIONS(642),
    [sym_false] = ACTIONS(642),
    [sym_none] = ACTIONS(642),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(646),
  },
  [154] = {
    [sym_named_expression] = STATE(900),
    [sym_expression] = STATE(901),
    [sym_primary_expression] = STATE(630),
    [sym_not_operator] = STATE(900),
    [sym_boolean_operator] = STATE(900),
    [sym_binary_operator] = STATE(642),
    [sym_unary_operator] = STATE(642),
    [sym_comparison_operator] = STATE(900),
    [sym_lambda] = STATE(900),
    [sym_attribute] = STATE(642),
    [sym_subscript] = STATE(642),
    [sym_call] = STATE(642),
    [sym_list] = STATE(642),
    [sym_set] = STATE(642),
    [sym_tuple] = STATE(642),
    [sym_dictionary] = STATE(642),
    [sym_list_comprehension] = STATE(642),
    [sym_dictionary_comprehension] = STATE(642),
    [sym_set_comprehension] = STATE(642),
    [sym_generator_expression] = STATE(642),
    [sym_parenthesized_expression] = STATE(642),
    [sym_conditional_expression] = STATE(900),
    [sym_concatenated_string] = STATE(642),
    [sym_string] = STATE(600),
    [sym_await] = STATE(900),
    [sym_identifier] = ACTIONS(274),
    [anon_sym_DOT] = ACTIONS(276),
    [anon_sym_LPAREN] = ACTIONS(278),
    [anon_sym_RPAREN] = ACTIONS(303),
    [anon_sym_COMMA] = ACTIONS(303),
    [anon_sym_STAR] = ACTIONS(276),
    [anon_sym_print] = ACTIONS(285),
    [anon_sym_GT_GT] = ACTIONS(303),
    [anon_sym_COLON_EQ] = ACTIONS(568),
    [anon_sym_if] = ACTIONS(276),
    [anon_sym_async] = ACTIONS(285),
    [anon_sym_in] = ACTIONS(276),
    [anon_sym_match] = ACTIONS(285),
    [anon_sym_PIPE] = ACTIONS(303),
    [anon_sym_DASH] = ACTIONS(301),
    [anon_sym_PLUS] = ACTIONS(301),
    [anon_sym_LBRACK] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(295),
    [anon_sym_STAR_STAR] = ACTIONS(303),
    [anon_sym_EQ] = ACTIONS(620),
    [anon_sym_exec] = ACTIONS(285),
    [anon_sym_type] = ACTIONS(285),
    [anon_sym_AT] = ACTIONS(303),
    [anon_sym_not] = ACTIONS(299),
    [anon_sym_and] = ACTIONS(276),
    [anon_sym_or] = ACTIONS(276),
    [anon_sym_SLASH] = ACTIONS(276),
    [anon_sym_PERCENT] = ACTIONS(303),
    [anon_sym_SLASH_SLASH] = ACTIONS(303),
    [anon_sym_AMP] = ACTIONS(303),
    [anon_sym_CARET] = ACTIONS(303),
    [anon_sym_LT_LT] = ACTIONS(303),
    [anon_sym_TILDE] = ACTIONS(301),
    [anon_sym_LT] = ACTIONS(276),
    [anon_sym_LT_EQ] = ACTIONS(303),
    [anon_sym_EQ_EQ] = ACTIONS(303),
    [anon_sym_BANG_EQ] = ACTIONS(303),
    [anon_sym_GT_EQ] = ACTIONS(303),
    [anon_sym_GT] = ACTIONS(276),
    [anon_sym_LT_GT] = ACTIONS(303),
    [anon_sym_is] = ACTIONS(276),
    [anon_sym_lambda] = ACTIONS(305),
    [sym_ellipsis] = ACTIONS(309),
    [sym_integer] = ACTIONS(311),
    [sym_float] = ACTIONS(309),
    [anon_sym_await] = ACTIONS(313),
    [sym_true] = ACTIONS(311),
    [sym_false] = ACTIONS(311),
    [sym_none] = ACTIONS(311),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(315),
  },
};

static const uint16_t ts_small_parse_table[] = {
  [0] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_identifier,
    ACTIONS(13), 1,
      anon_sym_LPAREN,
    ACTIONS(15), 1,
      anon_sym_STAR,
    ACTIONS(49), 1,
      anon_sym_LBRACK,
    ACTIONS(51), 1,
      anon_sym_LBRACE,
    ACTIONS(53), 1,
      anon_sym_STAR_STAR,
    ACTIONS(69), 1,
      anon_sym_not,
    ACTIONS(71), 1,
      anon_sym_lambda,
    ACTIONS(73), 1,
      anon_sym_yield,
    ACTIONS(79), 1,
      anon_sym_await,
    ACTIONS(81), 1,
      sym__string_start,
    STATE(684), 1,
      sym_primary_expression,
    STATE(713), 1,
      sym_string,
    STATE(889), 1,
      sym_pattern,
    STATE(897), 1,
      sym_pattern_list,
    STATE(1034), 1,
      sym_expression,
    ACTIONS(75), 2,
      sym_ellipsis,
      sym_float,
    STATE(431), 2,
      sym_attribute,
      sym_subscript,
    STATE(1360), 2,
      sym_list_splat,
      sym_dictionary_splat,
    ACTIONS(47), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(875), 3,
      sym_tuple_pattern,
      sym_list_pattern,
      sym_list_splat_pattern,
    ACTIONS(77), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(317), 5,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
    STATE(1369), 5,
      sym_expression_list,
      sym_assignment,
      sym_augmented_assignment,
      sym__right_hand_side,
      sym_yield,
    STATE(1009), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(797), 13,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [118] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_identifier,
    ACTIONS(13), 1,
      anon_sym_LPAREN,
    ACTIONS(15), 1,
      anon_sym_STAR,
    ACTIONS(49), 1,
      anon_sym_LBRACK,
    ACTIONS(51), 1,
      anon_sym_LBRACE,
    ACTIONS(53), 1,
      anon_sym_STAR_STAR,
    ACTIONS(69), 1,
      anon_sym_not,
    ACTIONS(71), 1,
      anon_sym_lambda,
    ACTIONS(73), 1,
      anon_sym_yield,
    ACTIONS(79), 1,
      anon_sym_await,
    ACTIONS(81), 1,
      sym__string_start,
    STATE(684), 1,
      sym_primary_expression,
    STATE(713), 1,
      sym_string,
    STATE(889), 1,
      sym_pattern,
    STATE(897), 1,
      sym_pattern_list,
    STATE(1034), 1,
      sym_expression,
    ACTIONS(75), 2,
      sym_ellipsis,
      sym_float,
    STATE(431), 2,
      sym_attribute,
      sym_subscript,
    STATE(1360), 2,
      sym_list_splat,
      sym_dictionary_splat,
    ACTIONS(47), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(875), 3,
      sym_tuple_pattern,
      sym_list_pattern,
      sym_list_splat_pattern,
    ACTIONS(77), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(317), 5,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
    STATE(1391), 5,
      sym_expression_list,
      sym_assignment,
      sym_augmented_assignment,
      sym__right_hand_side,
      sym_yield,
    STATE(1009), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(797), 13,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [236] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_identifier,
    ACTIONS(13), 1,
      anon_sym_LPAREN,
    ACTIONS(15), 1,
      anon_sym_STAR,
    ACTIONS(49), 1,
      anon_sym_LBRACK,
    ACTIONS(51), 1,
      anon_sym_LBRACE,
    ACTIONS(53), 1,
      anon_sym_STAR_STAR,
    ACTIONS(69), 1,
      anon_sym_not,
    ACTIONS(71), 1,
      anon_sym_lambda,
    ACTIONS(73), 1,
      anon_sym_yield,
    ACTIONS(79), 1,
      anon_sym_await,
    ACTIONS(81), 1,
      sym__string_start,
    STATE(684), 1,
      sym_primary_expression,
    STATE(713), 1,
      sym_string,
    STATE(889), 1,
      sym_pattern,
    STATE(897), 1,
      sym_pattern_list,
    STATE(1034), 1,
      sym_expression,
    ACTIONS(75), 2,
      sym_ellipsis,
      sym_float,
    STATE(431), 2,
      sym_attribute,
      sym_subscript,
    STATE(1360), 2,
      sym_list_splat,
      sym_dictionary_splat,
    ACTIONS(47), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(875), 3,
      sym_tuple_pattern,
      sym_list_pattern,
      sym_list_splat_pattern,
    ACTIONS(77), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(317), 5,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
    STATE(1386), 5,
      sym_expression_list,
      sym_assignment,
      sym_augmented_assignment,
      sym__right_hand_side,
      sym_yield,
    STATE(1009), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(797), 13,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [354] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym_STAR_STAR,
    ACTIONS(274), 1,
      sym_identifier,
    ACTIONS(278), 1,
      anon_sym_LPAREN,
    ACTIONS(283), 1,
      anon_sym_STAR,
    ACTIONS(293), 1,
      anon_sym_LBRACK,
    ACTIONS(295), 1,
      anon_sym_LBRACE,
    ACTIONS(299), 1,
      anon_sym_not,
    ACTIONS(305), 1,
      anon_sym_lambda,
    ACTIONS(313), 1,
      anon_sym_await,
    ACTIONS(315), 1,
      sym__string_start,
    ACTIONS(648), 1,
      anon_sym_from,
    STATE(600), 1,
      sym_string,
    STATE(630), 1,
      sym_primary_expression,
    STATE(929), 1,
      sym_expression,
    STATE(1041), 1,
      sym_expression_list,
    ACTIONS(309), 2,
      sym_ellipsis,
      sym_float,
    STATE(1366), 2,
      sym_list_splat,
      sym_dictionary_splat,
    ACTIONS(301), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(311), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(285), 5,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
    ACTIONS(650), 7,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_EQ,
      sym_type_conversion,
    STATE(900), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(642), 15,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [464] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(295), 1,
      anon_sym_LBRACE,
    ACTIONS(315), 1,
      sym__string_start,
    ACTIONS(614), 1,
      anon_sym_not,
    ACTIONS(616), 1,
      anon_sym_lambda,
    ACTIONS(652), 1,
      sym_identifier,
    ACTIONS(654), 1,
      anon_sym_LPAREN,
    ACTIONS(656), 1,
      anon_sym_STAR,
    ACTIONS(660), 1,
      anon_sym_LBRACK,
    ACTIONS(662), 1,
      anon_sym_RBRACK,
    ACTIONS(664), 1,
      anon_sym_yield,
    ACTIONS(666), 1,
      anon_sym_await,
    STATE(600), 1,
      sym_string,
    STATE(643), 1,
      sym_primary_expression,
    STATE(932), 1,
      sym_expression,
    STATE(1146), 1,
      sym_pattern,
    STATE(1497), 1,
      sym__patterns,
    STATE(1503), 1,
      sym__collection_elements,
    ACTIONS(309), 2,
      sym_ellipsis,
      sym_float,
    STATE(806), 2,
      sym_attribute,
      sym_subscript,
    ACTIONS(610), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(875), 3,
      sym_tuple_pattern,
      sym_list_pattern,
      sym_list_splat_pattern,
    STATE(1100), 3,
      sym_list_splat,
      sym_parenthesized_list_splat,
      sym_yield,
    ACTIONS(311), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(658), 5,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
    STATE(900), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(642), 13,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [579] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(295), 1,
      anon_sym_LBRACE,
    ACTIONS(315), 1,
      sym__string_start,
    ACTIONS(614), 1,
      anon_sym_not,
    ACTIONS(616), 1,
      anon_sym_lambda,
    ACTIONS(652), 1,
      sym_identifier,
    ACTIONS(654), 1,
      anon_sym_LPAREN,
    ACTIONS(656), 1,
      anon_sym_STAR,
    ACTIONS(660), 1,
      anon_sym_LBRACK,
    ACTIONS(664), 1,
      anon_sym_yield,
    ACTIONS(666), 1,
      anon_sym_await,
    ACTIONS(668), 1,
      anon_sym_RBRACK,
    STATE(600), 1,
      sym_string,
    STATE(643), 1,
      sym_primary_expression,
    STATE(941), 1,
      sym_expression,
    STATE(1146), 1,
      sym_pattern,
    STATE(1467), 1,
      sym__collection_elements,
    STATE(1497), 1,
      sym__patterns,
    ACTIONS(309), 2,
      sym_ellipsis,
      sym_float,
    STATE(806), 2,
      sym_attribute,
      sym_subscript,
    ACTIONS(610), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(875), 3,
      sym_tuple_pattern,
      sym_list_pattern,
      sym_list_splat_pattern,
    STATE(1100), 3,
      sym_list_splat,
      sym_parenthesized_list_splat,
      sym_yield,
    ACTIONS(311), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(658), 5,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
    STATE(900), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(642), 13,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [694] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(295), 1,
      anon_sym_LBRACE,
    ACTIONS(315), 1,
      sym__string_start,
    ACTIONS(614), 1,
      anon_sym_not,
    ACTIONS(616), 1,
      anon_sym_lambda,
    ACTIONS(652), 1,
      sym_identifier,
    ACTIONS(654), 1,
      anon_sym_LPAREN,
    ACTIONS(656), 1,
      anon_sym_STAR,
    ACTIONS(660), 1,
      anon_sym_LBRACK,
    ACTIONS(664), 1,
      anon_sym_yield,
    ACTIONS(666), 1,
      anon_sym_await,
    ACTIONS(670), 1,
      anon_sym_RBRACK,
    STATE(600), 1,
      sym_string,
    STATE(643), 1,
      sym_primary_expression,
    STATE(941), 1,
      sym_expression,
    STATE(1146), 1,
      sym_pattern,
    STATE(1467), 1,
      sym__collection_elements,
    STATE(1497), 1,
      sym__patterns,
    ACTIONS(309), 2,
      sym_ellipsis,
      sym_float,
    STATE(806), 2,
      sym_attribute,
      sym_subscript,
    ACTIONS(610), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(875), 3,
      sym_tuple_pattern,
      sym_list_pattern,
      sym_list_splat_pattern,
    STATE(1100), 3,
      sym_list_splat,
      sym_parenthesized_list_splat,
      sym_yield,
    ACTIONS(311), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(658), 5,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
    STATE(900), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(642), 13,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [809] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(295), 1,
      anon_sym_LBRACE,
    ACTIONS(315), 1,
      sym__string_start,
    ACTIONS(614), 1,
      anon_sym_not,
    ACTIONS(616), 1,
      anon_sym_lambda,
    ACTIONS(652), 1,
      sym_identifier,
    ACTIONS(654), 1,
      anon_sym_LPAREN,
    ACTIONS(656), 1,
      anon_sym_STAR,
    ACTIONS(660), 1,
      anon_sym_LBRACK,
    ACTIONS(664), 1,
      anon_sym_yield,
    ACTIONS(666), 1,
      anon_sym_await,
    ACTIONS(672), 1,
      anon_sym_RPAREN,
    STATE(600), 1,
      sym_string,
    STATE(643), 1,
      sym_primary_expression,
    STATE(930), 1,
      sym_expression,
    STATE(1146), 1,
      sym_pattern,
    STATE(1219), 1,
      sym_yield,
    STATE(1434), 1,
      sym__patterns,
    STATE(1484), 1,
      sym__collection_elements,
    ACTIONS(309), 2,
      sym_ellipsis,
      sym_float,
    STATE(806), 2,
      sym_attribute,
      sym_subscript,
    STATE(1100), 2,
      sym_list_splat,
      sym_parenthesized_list_splat,
    ACTIONS(610), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(875), 3,
      sym_tuple_pattern,
      sym_list_pattern,
      sym_list_splat_pattern,
    ACTIONS(311), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(658), 5,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
    STATE(900), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(642), 13,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [926] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(295), 1,
      anon_sym_LBRACE,
    ACTIONS(315), 1,
      sym__string_start,
    ACTIONS(614), 1,
      anon_sym_not,
    ACTIONS(616), 1,
      anon_sym_lambda,
    ACTIONS(652), 1,
      sym_identifier,
    ACTIONS(654), 1,
      anon_sym_LPAREN,
    ACTIONS(656), 1,
      anon_sym_STAR,
    ACTIONS(660), 1,
      anon_sym_LBRACK,
    ACTIONS(664), 1,
      anon_sym_yield,
    ACTIONS(666), 1,
      anon_sym_await,
    ACTIONS(674), 1,
      anon_sym_RPAREN,
    STATE(600), 1,
      sym_string,
    STATE(643), 1,
      sym_primary_expression,
    STATE(930), 1,
      sym_expression,
    STATE(1146), 1,
      sym_pattern,
    STATE(1219), 1,
      sym_yield,
    STATE(1301), 1,
      sym_parenthesized_list_splat,
    STATE(1303), 1,
      sym_list_splat,
    STATE(1434), 1,
      sym__patterns,
    STATE(1484), 1,
      sym__collection_elements,
    ACTIONS(309), 2,
      sym_ellipsis,
      sym_float,
    STATE(806), 2,
      sym_attribute,
      sym_subscript,
    ACTIONS(610), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(875), 3,
      sym_tuple_pattern,
      sym_list_pattern,
      sym_list_splat_pattern,
    ACTIONS(311), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(658), 5,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
    STATE(900), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(642), 13,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [1045] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(295), 1,
      anon_sym_LBRACE,
    ACTIONS(315), 1,
      sym__string_start,
    ACTIONS(614), 1,
      anon_sym_not,
    ACTIONS(616), 1,
      anon_sym_lambda,
    ACTIONS(652), 1,
      sym_identifier,
    ACTIONS(654), 1,
      anon_sym_LPAREN,
    ACTIONS(656), 1,
      anon_sym_STAR,
    ACTIONS(660), 1,
      anon_sym_LBRACK,
    ACTIONS(664), 1,
      anon_sym_yield,
    ACTIONS(666), 1,
      anon_sym_await,
    ACTIONS(676), 1,
      anon_sym_RPAREN,
    STATE(600), 1,
      sym_string,
    STATE(643), 1,
      sym_primary_expression,
    STATE(931), 1,
      sym_expression,
    STATE(1146), 1,
      sym_pattern,
    STATE(1251), 1,
      sym_yield,
    STATE(1431), 1,
      sym__collection_elements,
    STATE(1434), 1,
      sym__patterns,
    ACTIONS(309), 2,
      sym_ellipsis,
      sym_float,
    STATE(806), 2,
      sym_attribute,
      sym_subscript,
    STATE(1100), 2,
      sym_list_splat,
      sym_parenthesized_list_splat,
    ACTIONS(610), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(875), 3,
      sym_tuple_pattern,
      sym_list_pattern,
      sym_list_splat_pattern,
    ACTIONS(311), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(658), 5,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
    STATE(900), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(642), 13,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [1162] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(295), 1,
      anon_sym_LBRACE,
    ACTIONS(301), 1,
      anon_sym_TILDE,
    ACTIONS(315), 1,
      sym__string_start,
    ACTIONS(678), 1,
      sym_identifier,
    ACTIONS(680), 1,
      anon_sym_LPAREN,
    ACTIONS(682), 1,
      anon_sym_STAR,
    ACTIONS(688), 1,
      anon_sym_in,
    ACTIONS(690), 1,
      anon_sym_LBRACK,
    STATE(600), 1,
      sym_string,
    STATE(876), 1,
      sym_pattern,
    STATE(882), 1,
      sym_primary_expression,
    ACTIONS(291), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(309), 2,
      sym_ellipsis,
      sym_float,
    STATE(770), 2,
      sym_attribute,
      sym_subscript,
    STATE(875), 3,
      sym_tuple_pattern,
      sym_list_pattern,
      sym_list_splat_pattern,
    ACTIONS(311), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(684), 6,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_await,
    STATE(642), 13,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
    ACTIONS(686), 15,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [1262] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym_STAR_STAR,
    ACTIONS(283), 1,
      anon_sym_STAR,
    ACTIONS(295), 1,
      anon_sym_LBRACE,
    ACTIONS(315), 1,
      sym__string_start,
    ACTIONS(602), 1,
      sym_identifier,
    ACTIONS(612), 1,
      anon_sym_LBRACK,
    ACTIONS(614), 1,
      anon_sym_not,
    ACTIONS(616), 1,
      anon_sym_lambda,
    ACTIONS(618), 1,
      anon_sym_await,
    ACTIONS(664), 1,
      anon_sym_yield,
    ACTIONS(692), 1,
      anon_sym_LPAREN,
    ACTIONS(694), 1,
      anon_sym_COMMA,
    ACTIONS(696), 1,
      anon_sym_RBRACE,
    STATE(600), 1,
      sym_string,
    STATE(643), 1,
      sym_primary_expression,
    STATE(907), 1,
      sym_expression,
    STATE(1052), 1,
      sym_pair,
    STATE(1327), 1,
      sym_dictionary_splat,
    STATE(1513), 1,
      sym__collection_elements,
    ACTIONS(309), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(610), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1100), 3,
      sym_list_splat,
      sym_parenthesized_list_splat,
      sym_yield,
    ACTIONS(311), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(606), 5,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
    STATE(900), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(642), 15,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [1376] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym_STAR_STAR,
    ACTIONS(274), 1,
      sym_identifier,
    ACTIONS(278), 1,
      anon_sym_LPAREN,
    ACTIONS(283), 1,
      anon_sym_STAR,
    ACTIONS(293), 1,
      anon_sym_LBRACK,
    ACTIONS(295), 1,
      anon_sym_LBRACE,
    ACTIONS(299), 1,
      anon_sym_not,
    ACTIONS(305), 1,
      anon_sym_lambda,
    ACTIONS(313), 1,
      anon_sym_await,
    ACTIONS(315), 1,
      sym__string_start,
    STATE(600), 1,
      sym_string,
    STATE(630), 1,
      sym_primary_expression,
    STATE(933), 1,
      sym_expression,
    ACTIONS(309), 2,
      sym_ellipsis,
      sym_float,
    STATE(1023), 2,
      sym_list_splat,
      sym_dictionary_splat,
    ACTIONS(301), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(311), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(285), 5,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
    ACTIONS(698), 7,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_EQ,
      sym_type_conversion,
    STATE(900), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(642), 15,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [1480] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym_STAR_STAR,
    ACTIONS(274), 1,
      sym_identifier,
    ACTIONS(278), 1,
      anon_sym_LPAREN,
    ACTIONS(283), 1,
      anon_sym_STAR,
    ACTIONS(293), 1,
      anon_sym_LBRACK,
    ACTIONS(295), 1,
      anon_sym_LBRACE,
    ACTIONS(299), 1,
      anon_sym_not,
    ACTIONS(305), 1,
      anon_sym_lambda,
    ACTIONS(313), 1,
      anon_sym_await,
    ACTIONS(315), 1,
      sym__string_start,
    STATE(600), 1,
      sym_string,
    STATE(630), 1,
      sym_primary_expression,
    STATE(933), 1,
      sym_expression,
    ACTIONS(309), 2,
      sym_ellipsis,
      sym_float,
    STATE(1023), 2,
      sym_list_splat,
      sym_dictionary_splat,
    ACTIONS(301), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(311), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(285), 5,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
    ACTIONS(700), 7,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_EQ,
      sym_type_conversion,
    STATE(900), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(642), 15,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [1584] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym_STAR_STAR,
    ACTIONS(283), 1,
      anon_sym_STAR,
    ACTIONS(295), 1,
      anon_sym_LBRACE,
    ACTIONS(315), 1,
      sym__string_start,
    ACTIONS(602), 1,
      sym_identifier,
    ACTIONS(612), 1,
      anon_sym_LBRACK,
    ACTIONS(614), 1,
      anon_sym_not,
    ACTIONS(616), 1,
      anon_sym_lambda,
    ACTIONS(618), 1,
      anon_sym_await,
    ACTIONS(664), 1,
      anon_sym_yield,
    ACTIONS(692), 1,
      anon_sym_LPAREN,
    ACTIONS(702), 1,
      anon_sym_COMMA,
    ACTIONS(704), 1,
      anon_sym_RBRACE,
    STATE(600), 1,
      sym_string,
    STATE(643), 1,
      sym_primary_expression,
    STATE(911), 1,
      sym_expression,
    STATE(1038), 1,
      sym_pair,
    STATE(1225), 1,
      sym_dictionary_splat,
    STATE(1460), 1,
      sym__collection_elements,
    ACTIONS(309), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(610), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1100), 3,
      sym_list_splat,
      sym_parenthesized_list_splat,
      sym_yield,
    ACTIONS(311), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(606), 5,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
    STATE(900), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(642), 15,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [1698] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym_STAR_STAR,
    ACTIONS(283), 1,
      anon_sym_STAR,
    ACTIONS(295), 1,
      anon_sym_LBRACE,
    ACTIONS(315), 1,
      sym__string_start,
    ACTIONS(602), 1,
      sym_identifier,
    ACTIONS(612), 1,
      anon_sym_LBRACK,
    ACTIONS(614), 1,
      anon_sym_not,
    ACTIONS(616), 1,
      anon_sym_lambda,
    ACTIONS(618), 1,
      anon_sym_await,
    ACTIONS(664), 1,
      anon_sym_yield,
    ACTIONS(692), 1,
      anon_sym_LPAREN,
    ACTIONS(706), 1,
      anon_sym_COMMA,
    ACTIONS(708), 1,
      anon_sym_RBRACE,
    STATE(600), 1,
      sym_string,
    STATE(643), 1,
      sym_primary_expression,
    STATE(918), 1,
      sym_expression,
    STATE(1049), 1,
      sym_pair,
    STATE(1311), 1,
      sym_dictionary_splat,
    STATE(1461), 1,
      sym__collection_elements,
    ACTIONS(309), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(610), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1100), 3,
      sym_list_splat,
      sym_parenthesized_list_splat,
      sym_yield,
    ACTIONS(311), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(606), 5,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
    STATE(900), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(642), 15,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [1812] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym_STAR_STAR,
    ACTIONS(274), 1,
      sym_identifier,
    ACTIONS(278), 1,
      anon_sym_LPAREN,
    ACTIONS(283), 1,
      anon_sym_STAR,
    ACTIONS(293), 1,
      anon_sym_LBRACK,
    ACTIONS(295), 1,
      anon_sym_LBRACE,
    ACTIONS(299), 1,
      anon_sym_not,
    ACTIONS(305), 1,
      anon_sym_lambda,
    ACTIONS(313), 1,
      anon_sym_await,
    ACTIONS(315), 1,
      sym__string_start,
    STATE(600), 1,
      sym_string,
    STATE(630), 1,
      sym_primary_expression,
    STATE(933), 1,
      sym_expression,
    ACTIONS(309), 2,
      sym_ellipsis,
      sym_float,
    STATE(1023), 2,
      sym_list_splat,
      sym_dictionary_splat,
    ACTIONS(301), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(311), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(285), 5,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
    ACTIONS(700), 7,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_EQ,
      sym_type_conversion,
    STATE(900), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(642), 15,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [1916] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(295), 1,
      anon_sym_LBRACE,
    ACTIONS(301), 1,
      anon_sym_TILDE,
    ACTIONS(315), 1,
      sym__string_start,
    ACTIONS(678), 1,
      sym_identifier,
    ACTIONS(680), 1,
      anon_sym_LPAREN,
    ACTIONS(682), 1,
      anon_sym_STAR,
    ACTIONS(690), 1,
      anon_sym_LBRACK,
    ACTIONS(712), 1,
      anon_sym_in,
    STATE(600), 1,
      sym_string,
    STATE(876), 1,
      sym_pattern,
    STATE(882), 1,
      sym_primary_expression,
    ACTIONS(291), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(309), 2,
      sym_ellipsis,
      sym_float,
    STATE(770), 2,
      sym_attribute,
      sym_subscript,
    STATE(875), 3,
      sym_tuple_pattern,
      sym_list_pattern,
      sym_list_splat_pattern,
    ACTIONS(311), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(684), 6,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_await,
    STATE(642), 13,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
    ACTIONS(710), 15,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [2016] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(295), 1,
      anon_sym_LBRACE,
    ACTIONS(315), 1,
      sym__string_start,
    ACTIONS(602), 1,
      sym_identifier,
    ACTIONS(612), 1,
      anon_sym_LBRACK,
    ACTIONS(614), 1,
      anon_sym_not,
    ACTIONS(616), 1,
      anon_sym_lambda,
    ACTIONS(618), 1,
      anon_sym_await,
    ACTIONS(664), 1,
      anon_sym_yield,
    ACTIONS(692), 1,
      anon_sym_LPAREN,
    ACTIONS(714), 1,
      anon_sym_RPAREN,
    ACTIONS(716), 1,
      anon_sym_STAR,
    STATE(600), 1,
      sym_string,
    STATE(643), 1,
      sym_primary_expression,
    STATE(915), 1,
      sym_expression,
    STATE(1268), 1,
      sym_with_item,
    STATE(1313), 1,
      sym_yield,
    STATE(1475), 1,
      sym__collection_elements,
    ACTIONS(309), 2,
      sym_ellipsis,
      sym_float,
    STATE(1100), 2,
      sym_list_splat,
      sym_parenthesized_list_splat,
    ACTIONS(610), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(311), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(606), 5,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
    STATE(900), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(642), 15,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [2123] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(274), 1,
      sym_identifier,
    ACTIONS(293), 1,
      anon_sym_LBRACK,
    ACTIONS(295), 1,
      anon_sym_LBRACE,
    ACTIONS(299), 1,
      anon_sym_not,
    ACTIONS(305), 1,
      anon_sym_lambda,
    ACTIONS(313), 1,
      anon_sym_await,
    ACTIONS(315), 1,
      sym__string_start,
    ACTIONS(664), 1,
      anon_sym_yield,
    ACTIONS(716), 1,
      anon_sym_STAR,
    ACTIONS(718), 1,
      anon_sym_LPAREN,
    STATE(600), 1,
      sym_string,
    STATE(630), 1,
      sym_primary_expression,
    STATE(1053), 1,
      sym_expression,
    ACTIONS(309), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(301), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(720), 3,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
    STATE(1166), 3,
      sym_list_splat,
      sym_parenthesized_list_splat,
      sym_yield,
    ACTIONS(311), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(285), 5,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
    STATE(900), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(642), 15,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [2224] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(274), 1,
      sym_identifier,
    ACTIONS(293), 1,
      anon_sym_LBRACK,
    ACTIONS(295), 1,
      anon_sym_LBRACE,
    ACTIONS(299), 1,
      anon_sym_not,
    ACTIONS(305), 1,
      anon_sym_lambda,
    ACTIONS(313), 1,
      anon_sym_await,
    ACTIONS(315), 1,
      sym__string_start,
    ACTIONS(664), 1,
      anon_sym_yield,
    ACTIONS(716), 1,
      anon_sym_STAR,
    ACTIONS(718), 1,
      anon_sym_LPAREN,
    STATE(600), 1,
      sym_string,
    STATE(630), 1,
      sym_primary_expression,
    STATE(1053), 1,
      sym_expression,
    ACTIONS(309), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(301), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(720), 3,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
    STATE(1166), 3,
      sym_list_splat,
      sym_parenthesized_list_splat,
      sym_yield,
    ACTIONS(311), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(285), 5,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
    STATE(900), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(642), 15,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [2325] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym_STAR_STAR,
    ACTIONS(283), 1,
      anon_sym_STAR,
    ACTIONS(293), 1,
      anon_sym_LBRACK,
    ACTIONS(295), 1,
      anon_sym_LBRACE,
    ACTIONS(299), 1,
      anon_sym_not,
    ACTIONS(305), 1,
      anon_sym_lambda,
    ACTIONS(315), 1,
      sym__string_start,
    ACTIONS(718), 1,
      anon_sym_LPAREN,
    ACTIONS(722), 1,
      sym_identifier,
    ACTIONS(724), 1,
      anon_sym_RPAREN,
    ACTIONS(726), 1,
      anon_sym_COMMA,
    ACTIONS(730), 1,
      anon_sym_await,
    STATE(600), 1,
      sym_string,
    STATE(630), 1,
      sym_primary_expression,
    STATE(1071), 1,
      sym_expression,
    STATE(1256), 1,
      sym_parenthesized_list_splat,
    ACTIONS(309), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(301), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1255), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(311), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(728), 5,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
    STATE(900), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(642), 15,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [2430] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym_STAR_STAR,
    ACTIONS(283), 1,
      anon_sym_STAR,
    ACTIONS(295), 1,
      anon_sym_LBRACE,
    ACTIONS(315), 1,
      sym__string_start,
    ACTIONS(612), 1,
      anon_sym_LBRACK,
    ACTIONS(614), 1,
      anon_sym_not,
    ACTIONS(616), 1,
      anon_sym_lambda,
    ACTIONS(692), 1,
      anon_sym_LPAREN,
    ACTIONS(724), 1,
      anon_sym_RPAREN,
    ACTIONS(726), 1,
      anon_sym_COMMA,
    ACTIONS(732), 1,
      sym_identifier,
    ACTIONS(736), 1,
      anon_sym_await,
    STATE(600), 1,
      sym_string,
    STATE(643), 1,
      sym_primary_expression,
    STATE(953), 1,
      sym_expression,
    STATE(1256), 1,
      sym_parenthesized_list_splat,
    ACTIONS(309), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(610), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1255), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(311), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(734), 5,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
    STATE(900), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(642), 15,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [2535] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym_STAR_STAR,
    ACTIONS(274), 1,
      sym_identifier,
    ACTIONS(278), 1,
      anon_sym_LPAREN,
    ACTIONS(283), 1,
      anon_sym_STAR,
    ACTIONS(293), 1,
      anon_sym_LBRACK,
    ACTIONS(295), 1,
      anon_sym_LBRACE,
    ACTIONS(299), 1,
      anon_sym_not,
    ACTIONS(305), 1,
      anon_sym_lambda,
    ACTIONS(313), 1,
      anon_sym_await,
    ACTIONS(315), 1,
      sym__string_start,
    ACTIONS(664), 1,
      anon_sym_yield,
    STATE(600), 1,
      sym_string,
    STATE(630), 1,
      sym_primary_expression,
    STATE(960), 1,
      sym_expression,
    ACTIONS(309), 2,
      sym_ellipsis,
      sym_float,
    STATE(1366), 2,
      sym_list_splat,
      sym_dictionary_splat,
    ACTIONS(301), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1120), 3,
      sym_expression_list,
      sym_yield,
      sym__f_expression,
    ACTIONS(311), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(285), 5,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
    STATE(900), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(642), 15,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [2638] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym_STAR_STAR,
    ACTIONS(283), 1,
      anon_sym_STAR,
    ACTIONS(295), 1,
      anon_sym_LBRACE,
    ACTIONS(315), 1,
      sym__string_start,
    ACTIONS(612), 1,
      anon_sym_LBRACK,
    ACTIONS(614), 1,
      anon_sym_not,
    ACTIONS(616), 1,
      anon_sym_lambda,
    ACTIONS(692), 1,
      anon_sym_LPAREN,
    ACTIONS(732), 1,
      sym_identifier,
    ACTIONS(736), 1,
      anon_sym_await,
    ACTIONS(738), 1,
      anon_sym_RPAREN,
    ACTIONS(740), 1,
      anon_sym_COMMA,
    STATE(600), 1,
      sym_string,
    STATE(643), 1,
      sym_primary_expression,
    STATE(940), 1,
      sym_expression,
    STATE(1328), 1,
      sym_parenthesized_list_splat,
    ACTIONS(309), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(610), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1239), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(311), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(734), 5,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
    STATE(900), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(642), 15,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [2743] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym_LBRACE,
    ACTIONS(53), 1,
      anon_sym_STAR_STAR,
    ACTIONS(69), 1,
      anon_sym_not,
    ACTIONS(71), 1,
      anon_sym_lambda,
    ACTIONS(81), 1,
      sym__string_start,
    ACTIONS(283), 1,
      anon_sym_STAR,
    ACTIONS(331), 1,
      sym_identifier,
    ACTIONS(337), 1,
      anon_sym_await,
    ACTIONS(559), 1,
      anon_sym_LPAREN,
    ACTIONS(563), 1,
      anon_sym_LBRACK,
    ACTIONS(742), 1,
      anon_sym_from,
    STATE(684), 1,
      sym_primary_expression,
    STATE(713), 1,
      sym_string,
    STATE(1014), 1,
      sym_expression,
    STATE(1348), 1,
      sym_expression_list,
    ACTIONS(75), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(650), 2,
      sym__newline,
      sym__semicolon,
    STATE(1360), 2,
      sym_list_splat,
      sym_dictionary_splat,
    ACTIONS(47), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(77), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(333), 5,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
    STATE(1009), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(797), 15,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [2848] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym_LBRACE,
    ACTIONS(53), 1,
      anon_sym_STAR_STAR,
    ACTIONS(69), 1,
      anon_sym_not,
    ACTIONS(71), 1,
      anon_sym_lambda,
    ACTIONS(81), 1,
      sym__string_start,
    ACTIONS(283), 1,
      anon_sym_STAR,
    ACTIONS(331), 1,
      sym_identifier,
    ACTIONS(337), 1,
      anon_sym_await,
    ACTIONS(559), 1,
      anon_sym_LPAREN,
    ACTIONS(563), 1,
      anon_sym_LBRACK,
    ACTIONS(744), 1,
      anon_sym_from,
    STATE(684), 1,
      sym_primary_expression,
    STATE(713), 1,
      sym_string,
    STATE(982), 1,
      sym_expression,
    STATE(1288), 1,
      sym_expression_list,
    ACTIONS(75), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(746), 2,
      sym__newline,
      sym__semicolon,
    STATE(1360), 2,
      sym_list_splat,
      sym_dictionary_splat,
    ACTIONS(47), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(77), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(333), 5,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
    STATE(1009), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(797), 15,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [2953] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(274), 1,
      sym_identifier,
    ACTIONS(293), 1,
      anon_sym_LBRACK,
    ACTIONS(295), 1,
      anon_sym_LBRACE,
    ACTIONS(299), 1,
      anon_sym_not,
    ACTIONS(305), 1,
      anon_sym_lambda,
    ACTIONS(313), 1,
      anon_sym_await,
    ACTIONS(315), 1,
      sym__string_start,
    ACTIONS(664), 1,
      anon_sym_yield,
    ACTIONS(716), 1,
      anon_sym_STAR,
    ACTIONS(718), 1,
      anon_sym_LPAREN,
    STATE(600), 1,
      sym_string,
    STATE(630), 1,
      sym_primary_expression,
    STATE(1053), 1,
      sym_expression,
    ACTIONS(309), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(301), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(748), 3,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
    STATE(1166), 3,
      sym_list_splat,
      sym_parenthesized_list_splat,
      sym_yield,
    ACTIONS(311), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(285), 5,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
    STATE(900), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(642), 15,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [3054] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym_STAR_STAR,
    ACTIONS(274), 1,
      sym_identifier,
    ACTIONS(278), 1,
      anon_sym_LPAREN,
    ACTIONS(283), 1,
      anon_sym_STAR,
    ACTIONS(293), 1,
      anon_sym_LBRACK,
    ACTIONS(295), 1,
      anon_sym_LBRACE,
    ACTIONS(299), 1,
      anon_sym_not,
    ACTIONS(305), 1,
      anon_sym_lambda,
    ACTIONS(313), 1,
      anon_sym_await,
    ACTIONS(315), 1,
      sym__string_start,
    ACTIONS(664), 1,
      anon_sym_yield,
    STATE(600), 1,
      sym_string,
    STATE(630), 1,
      sym_primary_expression,
    STATE(960), 1,
      sym_expression,
    ACTIONS(309), 2,
      sym_ellipsis,
      sym_float,
    STATE(1366), 2,
      sym_list_splat,
      sym_dictionary_splat,
    ACTIONS(301), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1097), 3,
      sym_expression_list,
      sym_yield,
      sym__f_expression,
    ACTIONS(311), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(285), 5,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
    STATE(900), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(642), 15,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [3157] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym_STAR_STAR,
    ACTIONS(283), 1,
      anon_sym_STAR,
    ACTIONS(295), 1,
      anon_sym_LBRACE,
    ACTIONS(315), 1,
      sym__string_start,
    ACTIONS(612), 1,
      anon_sym_LBRACK,
    ACTIONS(614), 1,
      anon_sym_not,
    ACTIONS(616), 1,
      anon_sym_lambda,
    ACTIONS(692), 1,
      anon_sym_LPAREN,
    ACTIONS(732), 1,
      sym_identifier,
    ACTIONS(736), 1,
      anon_sym_await,
    ACTIONS(750), 1,
      anon_sym_RPAREN,
    ACTIONS(752), 1,
      anon_sym_COMMA,
    STATE(600), 1,
      sym_string,
    STATE(643), 1,
      sym_primary_expression,
    STATE(946), 1,
      sym_expression,
    STATE(1297), 1,
      sym_parenthesized_list_splat,
    ACTIONS(309), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(610), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1298), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(311), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(734), 5,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
    STATE(900), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(642), 15,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [3262] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(295), 1,
      anon_sym_LBRACE,
    ACTIONS(315), 1,
      sym__string_start,
    ACTIONS(602), 1,
      sym_identifier,
    ACTIONS(604), 1,
      anon_sym_LPAREN,
    ACTIONS(612), 1,
      anon_sym_LBRACK,
    ACTIONS(614), 1,
      anon_sym_not,
    ACTIONS(618), 1,
      anon_sym_await,
    ACTIONS(758), 1,
      anon_sym_lambda,
    STATE(600), 1,
      sym_string,
    STATE(643), 1,
      sym_primary_expression,
    STATE(962), 1,
      sym_expression,
    ACTIONS(309), 2,
      sym_ellipsis,
      sym_float,
    STATE(1018), 2,
      sym__expression_within_for_in_clause,
      sym_lambda_within_for_in_clause,
    ACTIONS(610), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(754), 3,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
    ACTIONS(756), 3,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
    ACTIONS(311), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(606), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
    STATE(900), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(642), 15,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [3360] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym_STAR_STAR,
    ACTIONS(283), 1,
      anon_sym_STAR,
    ACTIONS(293), 1,
      anon_sym_LBRACK,
    ACTIONS(295), 1,
      anon_sym_LBRACE,
    ACTIONS(299), 1,
      anon_sym_not,
    ACTIONS(305), 1,
      anon_sym_lambda,
    ACTIONS(315), 1,
      sym__string_start,
    ACTIONS(718), 1,
      anon_sym_LPAREN,
    ACTIONS(722), 1,
      sym_identifier,
    ACTIONS(730), 1,
      anon_sym_await,
    ACTIONS(760), 1,
      anon_sym_RPAREN,
    STATE(600), 1,
      sym_string,
    STATE(630), 1,
      sym_primary_expression,
    STATE(1124), 1,
      sym_expression,
    STATE(1379), 1,
      sym_parenthesized_list_splat,
    ACTIONS(309), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(301), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1373), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(311), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(728), 5,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
    STATE(900), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(642), 15,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [3462] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(295), 1,
      anon_sym_LBRACE,
    ACTIONS(315), 1,
      sym__string_start,
    ACTIONS(602), 1,
      sym_identifier,
    ACTIONS(612), 1,
      anon_sym_LBRACK,
    ACTIONS(614), 1,
      anon_sym_not,
    ACTIONS(616), 1,
      anon_sym_lambda,
    ACTIONS(618), 1,
      anon_sym_await,
    ACTIONS(664), 1,
      anon_sym_yield,
    ACTIONS(692), 1,
      anon_sym_LPAREN,
    ACTIONS(716), 1,
      anon_sym_STAR,
    ACTIONS(762), 1,
      anon_sym_RBRACK,
    STATE(600), 1,
      sym_string,
    STATE(643), 1,
      sym_primary_expression,
    STATE(941), 1,
      sym_expression,
    STATE(1467), 1,
      sym__collection_elements,
    ACTIONS(309), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(610), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1100), 3,
      sym_list_splat,
      sym_parenthesized_list_splat,
      sym_yield,
    ACTIONS(311), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(606), 5,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
    STATE(900), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(642), 15,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [3564] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(295), 1,
      anon_sym_LBRACE,
    ACTIONS(315), 1,
      sym__string_start,
    ACTIONS(602), 1,
      sym_identifier,
    ACTIONS(612), 1,
      anon_sym_LBRACK,
    ACTIONS(614), 1,
      anon_sym_not,
    ACTIONS(616), 1,
      anon_sym_lambda,
    ACTIONS(618), 1,
      anon_sym_await,
    ACTIONS(664), 1,
      anon_sym_yield,
    ACTIONS(692), 1,
      anon_sym_LPAREN,
    ACTIONS(714), 1,
      anon_sym_RPAREN,
    ACTIONS(716), 1,
      anon_sym_STAR,
    STATE(600), 1,
      sym_string,
    STATE(643), 1,
      sym_primary_expression,
    STATE(930), 1,
      sym_expression,
    STATE(1219), 1,
      sym_yield,
    STATE(1484), 1,
      sym__collection_elements,
    ACTIONS(309), 2,
      sym_ellipsis,
      sym_float,
    STATE(1100), 2,
      sym_list_splat,
      sym_parenthesized_list_splat,
    ACTIONS(610), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(311), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(606), 5,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
    STATE(900), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(642), 15,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [3668] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym_STAR_STAR,
    ACTIONS(283), 1,
      anon_sym_STAR,
    ACTIONS(293), 1,
      anon_sym_LBRACK,
    ACTIONS(295), 1,
      anon_sym_LBRACE,
    ACTIONS(299), 1,
      anon_sym_not,
    ACTIONS(305), 1,
      anon_sym_lambda,
    ACTIONS(315), 1,
      sym__string_start,
    ACTIONS(718), 1,
      anon_sym_LPAREN,
    ACTIONS(722), 1,
      sym_identifier,
    ACTIONS(730), 1,
      anon_sym_await,
    ACTIONS(764), 1,
      anon_sym_RPAREN,
    STATE(600), 1,
      sym_string,
    STATE(630), 1,
      sym_primary_expression,
    STATE(1124), 1,
      sym_expression,
    STATE(1379), 1,
      sym_parenthesized_list_splat,
    ACTIONS(309), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(301), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1373), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(311), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(728), 5,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
    STATE(900), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(642), 15,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [3770] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(295), 1,
      anon_sym_LBRACE,
    ACTIONS(315), 1,
      sym__string_start,
    ACTIONS(602), 1,
      sym_identifier,
    ACTIONS(612), 1,
      anon_sym_LBRACK,
    ACTIONS(614), 1,
      anon_sym_not,
    ACTIONS(616), 1,
      anon_sym_lambda,
    ACTIONS(618), 1,
      anon_sym_await,
    ACTIONS(664), 1,
      anon_sym_yield,
    ACTIONS(692), 1,
      anon_sym_LPAREN,
    ACTIONS(716), 1,
      anon_sym_STAR,
    ACTIONS(766), 1,
      anon_sym_RBRACK,
    STATE(600), 1,
      sym_string,
    STATE(643), 1,
      sym_primary_expression,
    STATE(941), 1,
      sym_expression,
    STATE(1467), 1,
      sym__collection_elements,
    ACTIONS(309), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(610), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1100), 3,
      sym_list_splat,
      sym_parenthesized_list_splat,
      sym_yield,
    ACTIONS(311), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(606), 5,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
    STATE(900), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(642), 15,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [3872] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(295), 1,
      anon_sym_LBRACE,
    ACTIONS(315), 1,
      sym__string_start,
    ACTIONS(602), 1,
      sym_identifier,
    ACTIONS(612), 1,
      anon_sym_LBRACK,
    ACTIONS(614), 1,
      anon_sym_not,
    ACTIONS(616), 1,
      anon_sym_lambda,
    ACTIONS(618), 1,
      anon_sym_await,
    ACTIONS(664), 1,
      anon_sym_yield,
    ACTIONS(692), 1,
      anon_sym_LPAREN,
    ACTIONS(716), 1,
      anon_sym_STAR,
    ACTIONS(768), 1,
      anon_sym_RBRACK,
    STATE(600), 1,
      sym_string,
    STATE(643), 1,
      sym_primary_expression,
    STATE(932), 1,
      sym_expression,
    STATE(1503), 1,
      sym__collection_elements,
    ACTIONS(309), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(610), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1100), 3,
      sym_list_splat,
      sym_parenthesized_list_splat,
      sym_yield,
    ACTIONS(311), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(606), 5,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
    STATE(900), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(642), 15,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [3974] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(295), 1,
      anon_sym_LBRACE,
    ACTIONS(315), 1,
      sym__string_start,
    ACTIONS(602), 1,
      sym_identifier,
    ACTIONS(604), 1,
      anon_sym_LPAREN,
    ACTIONS(612), 1,
      anon_sym_LBRACK,
    ACTIONS(614), 1,
      anon_sym_not,
    ACTIONS(618), 1,
      anon_sym_await,
    ACTIONS(758), 1,
      anon_sym_lambda,
    STATE(600), 1,
      sym_string,
    STATE(643), 1,
      sym_primary_expression,
    STATE(962), 1,
      sym_expression,
    ACTIONS(309), 2,
      sym_ellipsis,
      sym_float,
    STATE(1018), 2,
      sym__expression_within_for_in_clause,
      sym_lambda_within_for_in_clause,
    ACTIONS(610), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(770), 3,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
    ACTIONS(772), 3,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
    ACTIONS(311), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(606), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
    STATE(900), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(642), 15,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [4072] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(295), 1,
      anon_sym_LBRACE,
    ACTIONS(315), 1,
      sym__string_start,
    ACTIONS(602), 1,
      sym_identifier,
    ACTIONS(612), 1,
      anon_sym_LBRACK,
    ACTIONS(614), 1,
      anon_sym_not,
    ACTIONS(616), 1,
      anon_sym_lambda,
    ACTIONS(618), 1,
      anon_sym_await,
    ACTIONS(664), 1,
      anon_sym_yield,
    ACTIONS(692), 1,
      anon_sym_LPAREN,
    ACTIONS(716), 1,
      anon_sym_STAR,
    ACTIONS(774), 1,
      anon_sym_RPAREN,
    STATE(600), 1,
      sym_string,
    STATE(643), 1,
      sym_primary_expression,
    STATE(931), 1,
      sym_expression,
    STATE(1251), 1,
      sym_yield,
    STATE(1431), 1,
      sym__collection_elements,
    ACTIONS(309), 2,
      sym_ellipsis,
      sym_float,
    STATE(1100), 2,
      sym_list_splat,
      sym_parenthesized_list_splat,
    ACTIONS(610), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(311), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(606), 5,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
    STATE(900), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(642), 15,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [4176] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym_STAR_STAR,
    ACTIONS(283), 1,
      anon_sym_STAR,
    ACTIONS(293), 1,
      anon_sym_LBRACK,
    ACTIONS(295), 1,
      anon_sym_LBRACE,
    ACTIONS(299), 1,
      anon_sym_not,
    ACTIONS(305), 1,
      anon_sym_lambda,
    ACTIONS(315), 1,
      sym__string_start,
    ACTIONS(718), 1,
      anon_sym_LPAREN,
    ACTIONS(722), 1,
      sym_identifier,
    ACTIONS(730), 1,
      anon_sym_await,
    ACTIONS(776), 1,
      anon_sym_RPAREN,
    STATE(600), 1,
      sym_string,
    STATE(630), 1,
      sym_primary_expression,
    STATE(1124), 1,
      sym_expression,
    STATE(1379), 1,
      sym_parenthesized_list_splat,
    ACTIONS(309), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(301), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1373), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(311), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(728), 5,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
    STATE(900), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(642), 15,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [4278] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      anon_sym_not,
    ACTIONS(71), 1,
      anon_sym_lambda,
    ACTIONS(81), 1,
      sym__string_start,
    ACTIONS(331), 1,
      sym_identifier,
    ACTIONS(337), 1,
      anon_sym_await,
    ACTIONS(559), 1,
      anon_sym_LPAREN,
    ACTIONS(563), 1,
      anon_sym_LBRACK,
    ACTIONS(778), 1,
      anon_sym_from,
    ACTIONS(780), 1,
      anon_sym_STAR,
    ACTIONS(782), 1,
      anon_sym_STAR_STAR,
    STATE(684), 1,
      sym_primary_expression,
    STATE(713), 1,
      sym_string,
    STATE(1036), 1,
      sym_expression,
    ACTIONS(75), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(700), 2,
      sym__newline,
      sym__semicolon,
    STATE(1187), 2,
      sym_list_splat,
      sym_dictionary_splat,
    ACTIONS(47), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(77), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(333), 5,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
    STATE(1009), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(797), 15,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [4380] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym_STAR_STAR,
    ACTIONS(283), 1,
      anon_sym_STAR,
    ACTIONS(293), 1,
      anon_sym_LBRACK,
    ACTIONS(295), 1,
      anon_sym_LBRACE,
    ACTIONS(299), 1,
      anon_sym_not,
    ACTIONS(305), 1,
      anon_sym_lambda,
    ACTIONS(315), 1,
      sym__string_start,
    ACTIONS(718), 1,
      anon_sym_LPAREN,
    ACTIONS(722), 1,
      sym_identifier,
    ACTIONS(730), 1,
      anon_sym_await,
    ACTIONS(784), 1,
      anon_sym_RPAREN,
    STATE(600), 1,
      sym_string,
    STATE(630), 1,
      sym_primary_expression,
    STATE(1124), 1,
      sym_expression,
    STATE(1379), 1,
      sym_parenthesized_list_splat,
    ACTIONS(309), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(301), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1373), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(311), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(728), 5,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
    STATE(900), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(642), 15,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [4482] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym_STAR_STAR,
    ACTIONS(283), 1,
      anon_sym_STAR,
    ACTIONS(293), 1,
      anon_sym_LBRACK,
    ACTIONS(295), 1,
      anon_sym_LBRACE,
    ACTIONS(299), 1,
      anon_sym_not,
    ACTIONS(305), 1,
      anon_sym_lambda,
    ACTIONS(315), 1,
      sym__string_start,
    ACTIONS(718), 1,
      anon_sym_LPAREN,
    ACTIONS(722), 1,
      sym_identifier,
    ACTIONS(730), 1,
      anon_sym_await,
    ACTIONS(786), 1,
      anon_sym_RPAREN,
    STATE(600), 1,
      sym_string,
    STATE(630), 1,
      sym_primary_expression,
    STATE(1124), 1,
      sym_expression,
    STATE(1379), 1,
      sym_parenthesized_list_splat,
    ACTIONS(309), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(301), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1373), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(311), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(728), 5,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
    STATE(900), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(642), 15,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [4584] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym_STAR_STAR,
    ACTIONS(283), 1,
      anon_sym_STAR,
    ACTIONS(293), 1,
      anon_sym_LBRACK,
    ACTIONS(295), 1,
      anon_sym_LBRACE,
    ACTIONS(299), 1,
      anon_sym_not,
    ACTIONS(305), 1,
      anon_sym_lambda,
    ACTIONS(315), 1,
      sym__string_start,
    ACTIONS(718), 1,
      anon_sym_LPAREN,
    ACTIONS(722), 1,
      sym_identifier,
    ACTIONS(730), 1,
      anon_sym_await,
    ACTIONS(788), 1,
      anon_sym_RPAREN,
    STATE(600), 1,
      sym_string,
    STATE(630), 1,
      sym_primary_expression,
    STATE(1124), 1,
      sym_expression,
    STATE(1379), 1,
      sym_parenthesized_list_splat,
    ACTIONS(309), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(301), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1373), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(311), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(728), 5,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
    STATE(900), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(642), 15,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [4686] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym_STAR_STAR,
    ACTIONS(283), 1,
      anon_sym_STAR,
    ACTIONS(293), 1,
      anon_sym_LBRACK,
    ACTIONS(295), 1,
      anon_sym_LBRACE,
    ACTIONS(299), 1,
      anon_sym_not,
    ACTIONS(305), 1,
      anon_sym_lambda,
    ACTIONS(315), 1,
      sym__string_start,
    ACTIONS(718), 1,
      anon_sym_LPAREN,
    ACTIONS(722), 1,
      sym_identifier,
    ACTIONS(730), 1,
      anon_sym_await,
    ACTIONS(790), 1,
      anon_sym_RPAREN,
    STATE(600), 1,
      sym_string,
    STATE(630), 1,
      sym_primary_expression,
    STATE(1124), 1,
      sym_expression,
    STATE(1379), 1,
      sym_parenthesized_list_splat,
    ACTIONS(309), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(301), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1373), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(311), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(728), 5,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
    STATE(900), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(642), 15,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [4788] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(295), 1,
      anon_sym_LBRACE,
    ACTIONS(315), 1,
      sym__string_start,
    ACTIONS(602), 1,
      sym_identifier,
    ACTIONS(612), 1,
      anon_sym_LBRACK,
    ACTIONS(614), 1,
      anon_sym_not,
    ACTIONS(616), 1,
      anon_sym_lambda,
    ACTIONS(618), 1,
      anon_sym_await,
    ACTIONS(664), 1,
      anon_sym_yield,
    ACTIONS(692), 1,
      anon_sym_LPAREN,
    ACTIONS(716), 1,
      anon_sym_STAR,
    ACTIONS(792), 1,
      anon_sym_RPAREN,
    STATE(600), 1,
      sym_string,
    STATE(643), 1,
      sym_primary_expression,
    STATE(930), 1,
      sym_expression,
    STATE(1219), 1,
      sym_yield,
    STATE(1301), 1,
      sym_parenthesized_list_splat,
    STATE(1303), 1,
      sym_list_splat,
    STATE(1484), 1,
      sym__collection_elements,
    ACTIONS(309), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(610), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(311), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(606), 5,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
    STATE(900), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(642), 15,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [4894] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym_LBRACE,
    ACTIONS(53), 1,
      anon_sym_STAR_STAR,
    ACTIONS(69), 1,
      anon_sym_not,
    ACTIONS(71), 1,
      anon_sym_lambda,
    ACTIONS(81), 1,
      sym__string_start,
    ACTIONS(283), 1,
      anon_sym_STAR,
    ACTIONS(331), 1,
      sym_identifier,
    ACTIONS(337), 1,
      anon_sym_await,
    ACTIONS(559), 1,
      anon_sym_LPAREN,
    ACTIONS(563), 1,
      anon_sym_LBRACK,
    STATE(684), 1,
      sym_primary_expression,
    STATE(713), 1,
      sym_string,
    STATE(1045), 1,
      sym_expression,
    STATE(1394), 1,
      sym_expression_list,
    ACTIONS(75), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(794), 2,
      sym__newline,
      sym__semicolon,
    STATE(1360), 2,
      sym_list_splat,
      sym_dictionary_splat,
    ACTIONS(47), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(77), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(333), 5,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
    STATE(1009), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(797), 15,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [4996] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(295), 1,
      anon_sym_LBRACE,
    ACTIONS(315), 1,
      sym__string_start,
    ACTIONS(602), 1,
      sym_identifier,
    ACTIONS(604), 1,
      anon_sym_LPAREN,
    ACTIONS(612), 1,
      anon_sym_LBRACK,
    ACTIONS(614), 1,
      anon_sym_not,
    ACTIONS(618), 1,
      anon_sym_await,
    ACTIONS(758), 1,
      anon_sym_lambda,
    STATE(600), 1,
      sym_string,
    STATE(643), 1,
      sym_primary_expression,
    STATE(962), 1,
      sym_expression,
    ACTIONS(309), 2,
      sym_ellipsis,
      sym_float,
    STATE(1018), 2,
      sym__expression_within_for_in_clause,
      sym_lambda_within_for_in_clause,
    ACTIONS(610), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(796), 3,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
    ACTIONS(798), 3,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
    ACTIONS(311), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(606), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
    STATE(900), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(642), 15,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [5094] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym_STAR_STAR,
    ACTIONS(283), 1,
      anon_sym_STAR,
    ACTIONS(293), 1,
      anon_sym_LBRACK,
    ACTIONS(295), 1,
      anon_sym_LBRACE,
    ACTIONS(299), 1,
      anon_sym_not,
    ACTIONS(305), 1,
      anon_sym_lambda,
    ACTIONS(315), 1,
      sym__string_start,
    ACTIONS(718), 1,
      anon_sym_LPAREN,
    ACTIONS(722), 1,
      sym_identifier,
    ACTIONS(730), 1,
      anon_sym_await,
    ACTIONS(800), 1,
      anon_sym_RPAREN,
    STATE(600), 1,
      sym_string,
    STATE(630), 1,
      sym_primary_expression,
    STATE(1124), 1,
      sym_expression,
    STATE(1379), 1,
      sym_parenthesized_list_splat,
    ACTIONS(309), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(301), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1373), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(311), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(728), 5,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
    STATE(900), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(642), 15,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [5196] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(295), 1,
      anon_sym_LBRACE,
    ACTIONS(315), 1,
      sym__string_start,
    ACTIONS(602), 1,
      sym_identifier,
    ACTIONS(612), 1,
      anon_sym_LBRACK,
    ACTIONS(614), 1,
      anon_sym_not,
    ACTIONS(616), 1,
      anon_sym_lambda,
    ACTIONS(618), 1,
      anon_sym_await,
    ACTIONS(664), 1,
      anon_sym_yield,
    ACTIONS(692), 1,
      anon_sym_LPAREN,
    ACTIONS(716), 1,
      anon_sym_STAR,
    ACTIONS(792), 1,
      anon_sym_RPAREN,
    STATE(600), 1,
      sym_string,
    STATE(643), 1,
      sym_primary_expression,
    STATE(930), 1,
      sym_expression,
    STATE(1219), 1,
      sym_yield,
    STATE(1484), 1,
      sym__collection_elements,
    ACTIONS(309), 2,
      sym_ellipsis,
      sym_float,
    STATE(1100), 2,
      sym_list_splat,
      sym_parenthesized_list_splat,
    ACTIONS(610), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(311), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(606), 5,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
    STATE(900), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(642), 15,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [5300] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      anon_sym_not,
    ACTIONS(71), 1,
      anon_sym_lambda,
    ACTIONS(81), 1,
      sym__string_start,
    ACTIONS(331), 1,
      sym_identifier,
    ACTIONS(337), 1,
      anon_sym_await,
    ACTIONS(559), 1,
      anon_sym_LPAREN,
    ACTIONS(563), 1,
      anon_sym_LBRACK,
    ACTIONS(778), 1,
      anon_sym_from,
    ACTIONS(780), 1,
      anon_sym_STAR,
    ACTIONS(782), 1,
      anon_sym_STAR_STAR,
    STATE(684), 1,
      sym_primary_expression,
    STATE(713), 1,
      sym_string,
    STATE(1036), 1,
      sym_expression,
    ACTIONS(75), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(700), 2,
      sym__newline,
      sym__semicolon,
    STATE(1187), 2,
      sym_list_splat,
      sym_dictionary_splat,
    ACTIONS(47), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(77), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(333), 5,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
    STATE(1009), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(797), 15,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [5402] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym_STAR_STAR,
    ACTIONS(283), 1,
      anon_sym_STAR,
    ACTIONS(293), 1,
      anon_sym_LBRACK,
    ACTIONS(295), 1,
      anon_sym_LBRACE,
    ACTIONS(299), 1,
      anon_sym_not,
    ACTIONS(305), 1,
      anon_sym_lambda,
    ACTIONS(315), 1,
      sym__string_start,
    ACTIONS(718), 1,
      anon_sym_LPAREN,
    ACTIONS(722), 1,
      sym_identifier,
    ACTIONS(730), 1,
      anon_sym_await,
    ACTIONS(802), 1,
      anon_sym_RPAREN,
    STATE(600), 1,
      sym_string,
    STATE(630), 1,
      sym_primary_expression,
    STATE(1124), 1,
      sym_expression,
    STATE(1379), 1,
      sym_parenthesized_list_splat,
    ACTIONS(309), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(301), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1373), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(311), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(728), 5,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
    STATE(900), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(642), 15,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [5504] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym_STAR_STAR,
    ACTIONS(283), 1,
      anon_sym_STAR,
    ACTIONS(293), 1,
      anon_sym_LBRACK,
    ACTIONS(295), 1,
      anon_sym_LBRACE,
    ACTIONS(299), 1,
      anon_sym_not,
    ACTIONS(305), 1,
      anon_sym_lambda,
    ACTIONS(315), 1,
      sym__string_start,
    ACTIONS(718), 1,
      anon_sym_LPAREN,
    ACTIONS(722), 1,
      sym_identifier,
    ACTIONS(730), 1,
      anon_sym_await,
    ACTIONS(804), 1,
      anon_sym_RPAREN,
    STATE(600), 1,
      sym_string,
    STATE(630), 1,
      sym_primary_expression,
    STATE(1124), 1,
      sym_expression,
    STATE(1379), 1,
      sym_parenthesized_list_splat,
    ACTIONS(309), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(301), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1373), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(311), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(728), 5,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
    STATE(900), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(642), 15,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [5606] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym_STAR_STAR,
    ACTIONS(283), 1,
      anon_sym_STAR,
    ACTIONS(293), 1,
      anon_sym_LBRACK,
    ACTIONS(295), 1,
      anon_sym_LBRACE,
    ACTIONS(299), 1,
      anon_sym_not,
    ACTIONS(305), 1,
      anon_sym_lambda,
    ACTIONS(315), 1,
      sym__string_start,
    ACTIONS(718), 1,
      anon_sym_LPAREN,
    ACTIONS(722), 1,
      sym_identifier,
    ACTIONS(730), 1,
      anon_sym_await,
    ACTIONS(806), 1,
      anon_sym_RPAREN,
    STATE(600), 1,
      sym_string,
    STATE(630), 1,
      sym_primary_expression,
    STATE(1124), 1,
      sym_expression,
    STATE(1379), 1,
      sym_parenthesized_list_splat,
    ACTIONS(309), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(301), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1373), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(311), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(728), 5,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
    STATE(900), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(642), 15,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [5708] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym_STAR_STAR,
    ACTIONS(283), 1,
      anon_sym_STAR,
    ACTIONS(293), 1,
      anon_sym_LBRACK,
    ACTIONS(295), 1,
      anon_sym_LBRACE,
    ACTIONS(299), 1,
      anon_sym_not,
    ACTIONS(305), 1,
      anon_sym_lambda,
    ACTIONS(315), 1,
      sym__string_start,
    ACTIONS(718), 1,
      anon_sym_LPAREN,
    ACTIONS(722), 1,
      sym_identifier,
    ACTIONS(730), 1,
      anon_sym_await,
    ACTIONS(808), 1,
      anon_sym_RPAREN,
    STATE(600), 1,
      sym_string,
    STATE(630), 1,
      sym_primary_expression,
    STATE(1124), 1,
      sym_expression,
    STATE(1379), 1,
      sym_parenthesized_list_splat,
    ACTIONS(309), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(301), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1373), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(311), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(728), 5,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
    STATE(900), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(642), 15,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [5810] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      anon_sym_not,
    ACTIONS(71), 1,
      anon_sym_lambda,
    ACTIONS(81), 1,
      sym__string_start,
    ACTIONS(331), 1,
      sym_identifier,
    ACTIONS(337), 1,
      anon_sym_await,
    ACTIONS(559), 1,
      anon_sym_LPAREN,
    ACTIONS(563), 1,
      anon_sym_LBRACK,
    ACTIONS(780), 1,
      anon_sym_STAR,
    ACTIONS(782), 1,
      anon_sym_STAR_STAR,
    ACTIONS(810), 1,
      anon_sym_from,
    STATE(684), 1,
      sym_primary_expression,
    STATE(713), 1,
      sym_string,
    STATE(1036), 1,
      sym_expression,
    ACTIONS(75), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(698), 2,
      sym__newline,
      sym__semicolon,
    STATE(1187), 2,
      sym_list_splat,
      sym_dictionary_splat,
    ACTIONS(47), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(77), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(333), 5,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
    STATE(1009), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(797), 15,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [5912] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(295), 1,
      anon_sym_LBRACE,
    ACTIONS(315), 1,
      sym__string_start,
    ACTIONS(602), 1,
      sym_identifier,
    ACTIONS(612), 1,
      anon_sym_LBRACK,
    ACTIONS(614), 1,
      anon_sym_not,
    ACTIONS(616), 1,
      anon_sym_lambda,
    ACTIONS(618), 1,
      anon_sym_await,
    ACTIONS(664), 1,
      anon_sym_yield,
    ACTIONS(692), 1,
      anon_sym_LPAREN,
    ACTIONS(714), 1,
      anon_sym_RPAREN,
    ACTIONS(716), 1,
      anon_sym_STAR,
    STATE(600), 1,
      sym_string,
    STATE(643), 1,
      sym_primary_expression,
    STATE(930), 1,
      sym_expression,
    STATE(1219), 1,
      sym_yield,
    STATE(1301), 1,
      sym_parenthesized_list_splat,
    STATE(1303), 1,
      sym_list_splat,
    STATE(1484), 1,
      sym__collection_elements,
    ACTIONS(309), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(610), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(311), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(606), 5,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
    STATE(900), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(642), 15,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [6018] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(295), 1,
      anon_sym_LBRACE,
    ACTIONS(315), 1,
      sym__string_start,
    ACTIONS(602), 1,
      sym_identifier,
    ACTIONS(612), 1,
      anon_sym_LBRACK,
    ACTIONS(614), 1,
      anon_sym_not,
    ACTIONS(616), 1,
      anon_sym_lambda,
    ACTIONS(618), 1,
      anon_sym_await,
    ACTIONS(664), 1,
      anon_sym_yield,
    ACTIONS(692), 1,
      anon_sym_LPAREN,
    ACTIONS(714), 1,
      anon_sym_RPAREN,
    ACTIONS(716), 1,
      anon_sym_STAR,
    STATE(600), 1,
      sym_string,
    STATE(643), 1,
      sym_primary_expression,
    STATE(945), 1,
      sym_expression,
    STATE(1313), 1,
      sym_yield,
    STATE(1475), 1,
      sym__collection_elements,
    ACTIONS(309), 2,
      sym_ellipsis,
      sym_float,
    STATE(1100), 2,
      sym_list_splat,
      sym_parenthesized_list_splat,
    ACTIONS(610), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(311), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(606), 5,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
    STATE(900), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(642), 15,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [6122] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(295), 1,
      anon_sym_LBRACE,
    ACTIONS(315), 1,
      sym__string_start,
    ACTIONS(602), 1,
      sym_identifier,
    ACTIONS(604), 1,
      anon_sym_LPAREN,
    ACTIONS(612), 1,
      anon_sym_LBRACK,
    ACTIONS(614), 1,
      anon_sym_not,
    ACTIONS(618), 1,
      anon_sym_await,
    ACTIONS(758), 1,
      anon_sym_lambda,
    STATE(600), 1,
      sym_string,
    STATE(643), 1,
      sym_primary_expression,
    STATE(962), 1,
      sym_expression,
    ACTIONS(309), 2,
      sym_ellipsis,
      sym_float,
    STATE(1018), 2,
      sym__expression_within_for_in_clause,
      sym_lambda_within_for_in_clause,
    ACTIONS(610), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(812), 3,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
    ACTIONS(814), 3,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
    ACTIONS(311), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(606), 4,
      anon_sym_print,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
    STATE(900), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(642), 15,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [6220] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym_STAR_STAR,
    ACTIONS(283), 1,
      anon_sym_STAR,
    ACTIONS(293), 1,
      anon_sym_LBRACK,
    ACTIONS(295), 1,
      anon_sym_LBRACE,
    ACTIONS(299), 1,
      anon_sym_not,
    ACTIONS(305), 1,
      anon_sym_lambda,
    ACTIONS(315), 1,
      sym__string_start,
    ACTIONS(718), 1,
      anon_sym_LPAREN,
    ACTIONS(722), 1,
      sym_identifier,
    ACTIONS(730), 1,
      anon_sym_await,
    ACTIONS(816), 1,
      anon_sym_RPAREN,
    STATE(600), 1,
      sym_string,
    STATE(630), 1,
      sym_primary_expression,
    STATE(1124), 1,
      sym_expression,
    STATE(1379), 1,
      sym_parenthesized_list_splat,
    ACTIONS(309), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(301), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1373), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(311), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(728), 5,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
    STATE(900), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(642), 15,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [6322] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym_STAR_STAR,
    ACTIONS(283), 1,
      anon_sym_STAR,
    ACTIONS(293), 1,
      anon_sym_LBRACK,
    ACTIONS(295), 1,
      anon_sym_LBRACE,
    ACTIONS(299), 1,
      anon_sym_not,
    ACTIONS(305), 1,
      anon_sym_lambda,
    ACTIONS(315), 1,
      sym__string_start,
    ACTIONS(718), 1,
      anon_sym_LPAREN,
    ACTIONS(722), 1,
      sym_identifier,
    ACTIONS(730), 1,
      anon_sym_await,
    ACTIONS(818), 1,
      anon_sym_RPAREN,
    STATE(600), 1,
      sym_string,
    STATE(630), 1,
      sym_primary_expression,
    STATE(1124), 1,
      sym_expression,
    STATE(1379), 1,
      sym_parenthesized_list_splat,
    ACTIONS(309), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(301), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1373), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(311), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(728), 5,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
    STATE(900), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(642), 15,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [6424] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym_STAR_STAR,
    ACTIONS(283), 1,
      anon_sym_STAR,
    ACTIONS(293), 1,
      anon_sym_LBRACK,
    ACTIONS(295), 1,
      anon_sym_LBRACE,
    ACTIONS(299), 1,
      anon_sym_not,
    ACTIONS(305), 1,
      anon_sym_lambda,
    ACTIONS(315), 1,
      sym__string_start,
    ACTIONS(718), 1,
      anon_sym_LPAREN,
    ACTIONS(722), 1,
      sym_identifier,
    ACTIONS(730), 1,
      anon_sym_await,
    ACTIONS(820), 1,
      anon_sym_RPAREN,
    STATE(600), 1,
      sym_string,
    STATE(630), 1,
      sym_primary_expression,
    STATE(1124), 1,
      sym_expression,
    STATE(1379), 1,
      sym_parenthesized_list_splat,
    ACTIONS(309), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(301), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1373), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(311), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(728), 5,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
    STATE(900), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(642), 15,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [6526] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(295), 1,
      anon_sym_LBRACE,
    ACTIONS(315), 1,
      sym__string_start,
    ACTIONS(602), 1,
      sym_identifier,
    ACTIONS(612), 1,
      anon_sym_LBRACK,
    ACTIONS(614), 1,
      anon_sym_not,
    ACTIONS(616), 1,
      anon_sym_lambda,
    ACTIONS(618), 1,
      anon_sym_await,
    ACTIONS(664), 1,
      anon_sym_yield,
    ACTIONS(692), 1,
      anon_sym_LPAREN,
    ACTIONS(716), 1,
      anon_sym_STAR,
    ACTIONS(766), 1,
      anon_sym_RBRACK,
    STATE(600), 1,
      sym_string,
    STATE(643), 1,
      sym_primary_expression,
    STATE(935), 1,
      sym_expression,
    STATE(1473), 1,
      sym__collection_elements,
    ACTIONS(309), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(610), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1100), 3,
      sym_list_splat,
      sym_parenthesized_list_splat,
      sym_yield,
    ACTIONS(311), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(606), 5,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
    STATE(900), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(642), 15,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [6628] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(824), 17,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(822), 36,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      sym_type_conversion,
  [6689] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(828), 17,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(826), 36,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      sym_type_conversion,
  [6750] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(832), 17,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(830), 36,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      sym_type_conversion,
  [6811] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(832), 17,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(830), 36,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      sym_type_conversion,
  [6872] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym_STAR_STAR,
    ACTIONS(283), 1,
      anon_sym_STAR,
    ACTIONS(293), 1,
      anon_sym_LBRACK,
    ACTIONS(295), 1,
      anon_sym_LBRACE,
    ACTIONS(299), 1,
      anon_sym_not,
    ACTIONS(305), 1,
      anon_sym_lambda,
    ACTIONS(315), 1,
      sym__string_start,
    ACTIONS(718), 1,
      anon_sym_LPAREN,
    ACTIONS(722), 1,
      sym_identifier,
    ACTIONS(730), 1,
      anon_sym_await,
    STATE(600), 1,
      sym_string,
    STATE(630), 1,
      sym_primary_expression,
    STATE(1124), 1,
      sym_expression,
    STATE(1379), 1,
      sym_parenthesized_list_splat,
    ACTIONS(309), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(301), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1373), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(311), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(728), 5,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
    STATE(900), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(642), 15,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [6971] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(836), 17,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(834), 36,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      sym_type_conversion,
  [7032] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(274), 1,
      sym_identifier,
    ACTIONS(293), 1,
      anon_sym_LBRACK,
    ACTIONS(295), 1,
      anon_sym_LBRACE,
    ACTIONS(299), 1,
      anon_sym_not,
    ACTIONS(305), 1,
      anon_sym_lambda,
    ACTIONS(313), 1,
      anon_sym_await,
    ACTIONS(315), 1,
      sym__string_start,
    ACTIONS(664), 1,
      anon_sym_yield,
    ACTIONS(716), 1,
      anon_sym_STAR,
    ACTIONS(718), 1,
      anon_sym_LPAREN,
    ACTIONS(720), 1,
      anon_sym_RPAREN,
    STATE(600), 1,
      sym_string,
    STATE(630), 1,
      sym_primary_expression,
    STATE(1053), 1,
      sym_expression,
    ACTIONS(309), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(301), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1166), 3,
      sym_list_splat,
      sym_parenthesized_list_splat,
      sym_yield,
    ACTIONS(311), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(285), 5,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
    STATE(900), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(642), 15,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [7131] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(274), 1,
      sym_identifier,
    ACTIONS(293), 1,
      anon_sym_LBRACK,
    ACTIONS(295), 1,
      anon_sym_LBRACE,
    ACTIONS(299), 1,
      anon_sym_not,
    ACTIONS(305), 1,
      anon_sym_lambda,
    ACTIONS(313), 1,
      anon_sym_await,
    ACTIONS(315), 1,
      sym__string_start,
    ACTIONS(664), 1,
      anon_sym_yield,
    ACTIONS(716), 1,
      anon_sym_STAR,
    ACTIONS(718), 1,
      anon_sym_LPAREN,
    ACTIONS(720), 1,
      anon_sym_RPAREN,
    STATE(600), 1,
      sym_string,
    STATE(630), 1,
      sym_primary_expression,
    STATE(1053), 1,
      sym_expression,
    ACTIONS(309), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(301), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1166), 3,
      sym_list_splat,
      sym_parenthesized_list_splat,
      sym_yield,
    ACTIONS(311), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(285), 5,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
    STATE(900), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(642), 15,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [7230] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(824), 17,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(822), 36,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      sym_type_conversion,
  [7291] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(840), 17,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(838), 36,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      sym_type_conversion,
  [7352] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(846), 1,
      anon_sym_else,
    ACTIONS(848), 1,
      anon_sym_except,
    ACTIONS(850), 1,
      anon_sym_finally,
    STATE(440), 1,
      sym_else_clause,
    STATE(504), 1,
      sym_finally_clause,
    STATE(271), 2,
      sym_except_clause,
      aux_sym_try_statement_repeat1,
    ACTIONS(842), 12,
      sym__string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(844), 33,
      anon_sym_import,
      anon_sym_from,
      anon_sym_STAR,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_match,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [7424] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(852), 1,
      anon_sym_else,
    ACTIONS(854), 1,
      anon_sym_except_STAR,
    ACTIONS(856), 1,
      anon_sym_finally,
    STATE(413), 1,
      sym_else_clause,
    STATE(520), 1,
      sym_finally_clause,
    STATE(267), 2,
      sym_except_group_clause,
      aux_sym_try_statement_repeat2,
    ACTIONS(842), 12,
      sym__dedent,
      sym__string_start,
      anon_sym_LPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(844), 33,
      anon_sym_import,
      anon_sym_from,
      anon_sym_STAR,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_match,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [7496] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(274), 1,
      sym_identifier,
    ACTIONS(293), 1,
      anon_sym_LBRACK,
    ACTIONS(295), 1,
      anon_sym_LBRACE,
    ACTIONS(299), 1,
      anon_sym_not,
    ACTIONS(305), 1,
      anon_sym_lambda,
    ACTIONS(313), 1,
      anon_sym_await,
    ACTIONS(315), 1,
      sym__string_start,
    ACTIONS(664), 1,
      anon_sym_yield,
    ACTIONS(716), 1,
      anon_sym_STAR,
    ACTIONS(718), 1,
      anon_sym_LPAREN,
    STATE(600), 1,
      sym_string,
    STATE(630), 1,
      sym_primary_expression,
    STATE(1053), 1,
      sym_expression,
    ACTIONS(309), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(301), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1166), 3,
      sym_list_splat,
      sym_parenthesized_list_splat,
      sym_yield,
    ACTIONS(311), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(285), 5,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
    STATE(900), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(642), 15,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [7592] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym_LBRACE,
    ACTIONS(53), 1,
      anon_sym_STAR_STAR,
    ACTIONS(69), 1,
      anon_sym_not,
    ACTIONS(71), 1,
      anon_sym_lambda,
    ACTIONS(81), 1,
      sym__string_start,
    ACTIONS(283), 1,
      anon_sym_STAR,
    ACTIONS(331), 1,
      sym_identifier,
    ACTIONS(337), 1,
      anon_sym_await,
    ACTIONS(559), 1,
      anon_sym_LPAREN,
    ACTIONS(563), 1,
      anon_sym_LBRACK,
    STATE(684), 1,
      sym_primary_expression,
    STATE(713), 1,
      sym_string,
    STATE(1046), 1,
      sym_expression,
    STATE(1389), 1,
      sym_expression_list,
    ACTIONS(75), 2,
      sym_ellipsis,
      sym_float,
    STATE(1360), 2,
      sym_list_splat,
      sym_dictionary_splat,
    ACTIONS(47), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(77), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(333), 5,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
    STATE(1009), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(797), 15,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [7690] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(852), 1,
      anon_sym_else,
    ACTIONS(856), 1,
      anon_sym_finally,
    ACTIONS(862), 1,
      anon_sym_except,
    STATE(454), 1,
      sym_else_clause,
    STATE(588), 1,
      sym_finally_clause,
    STATE(266), 2,
      sym_except_clause,
      aux_sym_try_statement_repeat1,
    ACTIONS(860), 12,
      sym__dedent,
      sym__string_start,
      anon_sym_LPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(858), 33,
      anon_sym_import,
      anon_sym_from,
      anon_sym_STAR,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_match,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [7762] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym_STAR_STAR,
    ACTIONS(274), 1,
      sym_identifier,
    ACTIONS(278), 1,
      anon_sym_LPAREN,
    ACTIONS(283), 1,
      anon_sym_STAR,
    ACTIONS(293), 1,
      anon_sym_LBRACK,
    ACTIONS(295), 1,
      anon_sym_LBRACE,
    ACTIONS(299), 1,
      anon_sym_not,
    ACTIONS(305), 1,
      anon_sym_lambda,
    ACTIONS(313), 1,
      anon_sym_await,
    ACTIONS(315), 1,
      sym__string_start,
    STATE(600), 1,
      sym_string,
    STATE(630), 1,
      sym_primary_expression,
    STATE(1070), 1,
      sym_expression,
    STATE(1472), 1,
      sym_expression_list,
    ACTIONS(309), 2,
      sym_ellipsis,
      sym_float,
    STATE(1366), 2,
      sym_list_splat,
      sym_dictionary_splat,
    ACTIONS(301), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(311), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(285), 5,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
    STATE(900), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(642), 15,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [7860] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(852), 1,
      anon_sym_else,
    ACTIONS(854), 1,
      anon_sym_except_STAR,
    ACTIONS(856), 1,
      anon_sym_finally,
    STATE(454), 1,
      sym_else_clause,
    STATE(588), 1,
      sym_finally_clause,
    STATE(267), 2,
      sym_except_group_clause,
      aux_sym_try_statement_repeat2,
    ACTIONS(860), 12,
      sym__dedent,
      sym__string_start,
      anon_sym_LPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(858), 33,
      anon_sym_import,
      anon_sym_from,
      anon_sym_STAR,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_match,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [7932] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym_STAR_STAR,
    ACTIONS(274), 1,
      sym_identifier,
    ACTIONS(278), 1,
      anon_sym_LPAREN,
    ACTIONS(283), 1,
      anon_sym_STAR,
    ACTIONS(293), 1,
      anon_sym_LBRACK,
    ACTIONS(295), 1,
      anon_sym_LBRACE,
    ACTIONS(299), 1,
      anon_sym_not,
    ACTIONS(305), 1,
      anon_sym_lambda,
    ACTIONS(313), 1,
      anon_sym_await,
    ACTIONS(315), 1,
      sym__string_start,
    STATE(600), 1,
      sym_string,
    STATE(630), 1,
      sym_primary_expression,
    STATE(1085), 1,
      sym_expression,
    STATE(1518), 1,
      sym_expression_list,
    ACTIONS(309), 2,
      sym_ellipsis,
      sym_float,
    STATE(1366), 2,
      sym_list_splat,
      sym_dictionary_splat,
    ACTIONS(301), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(311), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(285), 5,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
    STATE(900), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(642), 15,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [8030] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym_STAR_STAR,
    ACTIONS(274), 1,
      sym_identifier,
    ACTIONS(278), 1,
      anon_sym_LPAREN,
    ACTIONS(283), 1,
      anon_sym_STAR,
    ACTIONS(293), 1,
      anon_sym_LBRACK,
    ACTIONS(295), 1,
      anon_sym_LBRACE,
    ACTIONS(299), 1,
      anon_sym_not,
    ACTIONS(305), 1,
      anon_sym_lambda,
    ACTIONS(313), 1,
      anon_sym_await,
    ACTIONS(315), 1,
      sym__string_start,
    STATE(600), 1,
      sym_string,
    STATE(630), 1,
      sym_primary_expression,
    STATE(1059), 1,
      sym_expression,
    STATE(1507), 1,
      sym_expression_list,
    ACTIONS(309), 2,
      sym_ellipsis,
      sym_float,
    STATE(1366), 2,
      sym_list_splat,
      sym_dictionary_splat,
    ACTIONS(301), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(311), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(285), 5,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
    STATE(900), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(642), 15,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [8128] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(846), 1,
      anon_sym_else,
    ACTIONS(850), 1,
      anon_sym_finally,
    ACTIONS(864), 1,
      anon_sym_except_STAR,
    STATE(467), 1,
      sym_else_clause,
    STATE(523), 1,
      sym_finally_clause,
    STATE(270), 2,
      sym_except_group_clause,
      aux_sym_try_statement_repeat2,
    ACTIONS(860), 12,
      sym__string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(858), 33,
      anon_sym_import,
      anon_sym_from,
      anon_sym_STAR,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_match,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [8200] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(846), 1,
      anon_sym_else,
    ACTIONS(848), 1,
      anon_sym_except,
    ACTIONS(850), 1,
      anon_sym_finally,
    STATE(467), 1,
      sym_else_clause,
    STATE(523), 1,
      sym_finally_clause,
    STATE(271), 2,
      sym_except_clause,
      aux_sym_try_statement_repeat1,
    ACTIONS(860), 12,
      sym__string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(858), 33,
      anon_sym_import,
      anon_sym_from,
      anon_sym_STAR,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_match,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [8272] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym_STAR_STAR,
    ACTIONS(274), 1,
      sym_identifier,
    ACTIONS(278), 1,
      anon_sym_LPAREN,
    ACTIONS(283), 1,
      anon_sym_STAR,
    ACTIONS(293), 1,
      anon_sym_LBRACK,
    ACTIONS(295), 1,
      anon_sym_LBRACE,
    ACTIONS(299), 1,
      anon_sym_not,
    ACTIONS(305), 1,
      anon_sym_lambda,
    ACTIONS(313), 1,
      anon_sym_await,
    ACTIONS(315), 1,
      sym__string_start,
    STATE(600), 1,
      sym_string,
    STATE(630), 1,
      sym_primary_expression,
    STATE(1075), 1,
      sym_expression,
    STATE(1465), 1,
      sym_expression_list,
    ACTIONS(309), 2,
      sym_ellipsis,
      sym_float,
    STATE(1366), 2,
      sym_list_splat,
      sym_dictionary_splat,
    ACTIONS(301), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(311), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(285), 5,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
    STATE(900), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(642), 15,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [8370] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(846), 1,
      anon_sym_else,
    ACTIONS(850), 1,
      anon_sym_finally,
    ACTIONS(864), 1,
      anon_sym_except_STAR,
    STATE(440), 1,
      sym_else_clause,
    STATE(504), 1,
      sym_finally_clause,
    STATE(270), 2,
      sym_except_group_clause,
      aux_sym_try_statement_repeat2,
    ACTIONS(842), 12,
      sym__string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(844), 33,
      anon_sym_import,
      anon_sym_from,
      anon_sym_STAR,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_match,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [8442] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(852), 1,
      anon_sym_else,
    ACTIONS(856), 1,
      anon_sym_finally,
    ACTIONS(862), 1,
      anon_sym_except,
    STATE(413), 1,
      sym_else_clause,
    STATE(520), 1,
      sym_finally_clause,
    STATE(266), 2,
      sym_except_clause,
      aux_sym_try_statement_repeat1,
    ACTIONS(842), 12,
      sym__dedent,
      sym__string_start,
      anon_sym_LPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(844), 33,
      anon_sym_import,
      anon_sym_from,
      anon_sym_STAR,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_match,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [8514] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym_STAR_STAR,
    ACTIONS(274), 1,
      sym_identifier,
    ACTIONS(278), 1,
      anon_sym_LPAREN,
    ACTIONS(293), 1,
      anon_sym_LBRACK,
    ACTIONS(295), 1,
      anon_sym_LBRACE,
    ACTIONS(299), 1,
      anon_sym_not,
    ACTIONS(305), 1,
      anon_sym_lambda,
    ACTIONS(313), 1,
      anon_sym_await,
    ACTIONS(315), 1,
      sym__string_start,
    ACTIONS(866), 1,
      anon_sym_RBRACE,
    STATE(600), 1,
      sym_string,
    STATE(630), 1,
      sym_primary_expression,
    STATE(1145), 1,
      sym_expression,
    ACTIONS(309), 2,
      sym_ellipsis,
      sym_float,
    STATE(1384), 2,
      sym_dictionary_splat,
      sym_pair,
    ACTIONS(301), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(311), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(285), 5,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
    STATE(900), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(642), 15,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [8609] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym_STAR_STAR,
    ACTIONS(274), 1,
      sym_identifier,
    ACTIONS(278), 1,
      anon_sym_LPAREN,
    ACTIONS(293), 1,
      anon_sym_LBRACK,
    ACTIONS(295), 1,
      anon_sym_LBRACE,
    ACTIONS(299), 1,
      anon_sym_not,
    ACTIONS(305), 1,
      anon_sym_lambda,
    ACTIONS(313), 1,
      anon_sym_await,
    ACTIONS(315), 1,
      sym__string_start,
    ACTIONS(868), 1,
      anon_sym_RBRACE,
    STATE(600), 1,
      sym_string,
    STATE(630), 1,
      sym_primary_expression,
    STATE(1145), 1,
      sym_expression,
    ACTIONS(309), 2,
      sym_ellipsis,
      sym_float,
    STATE(1384), 2,
      sym_dictionary_splat,
      sym_pair,
    ACTIONS(301), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(311), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(285), 5,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
    STATE(900), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(642), 15,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [8704] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      anon_sym_not,
    ACTIONS(71), 1,
      anon_sym_lambda,
    ACTIONS(81), 1,
      sym__string_start,
    ACTIONS(331), 1,
      sym_identifier,
    ACTIONS(337), 1,
      anon_sym_await,
    ACTIONS(559), 1,
      anon_sym_LPAREN,
    ACTIONS(563), 1,
      anon_sym_LBRACK,
    ACTIONS(780), 1,
      anon_sym_STAR,
    ACTIONS(782), 1,
      anon_sym_STAR_STAR,
    STATE(684), 1,
      sym_primary_expression,
    STATE(713), 1,
      sym_string,
    STATE(1036), 1,
      sym_expression,
    ACTIONS(75), 2,
      sym_ellipsis,
      sym_float,
    STATE(1187), 2,
      sym_list_splat,
      sym_dictionary_splat,
    ACTIONS(47), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(77), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(333), 5,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
    STATE(1009), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(797), 15,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [8799] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym_STAR_STAR,
    ACTIONS(274), 1,
      sym_identifier,
    ACTIONS(278), 1,
      anon_sym_LPAREN,
    ACTIONS(283), 1,
      anon_sym_STAR,
    ACTIONS(293), 1,
      anon_sym_LBRACK,
    ACTIONS(295), 1,
      anon_sym_LBRACE,
    ACTIONS(299), 1,
      anon_sym_not,
    ACTIONS(305), 1,
      anon_sym_lambda,
    ACTIONS(313), 1,
      anon_sym_await,
    ACTIONS(315), 1,
      sym__string_start,
    STATE(600), 1,
      sym_string,
    STATE(630), 1,
      sym_primary_expression,
    STATE(933), 1,
      sym_expression,
    ACTIONS(309), 2,
      sym_ellipsis,
      sym_float,
    STATE(1023), 2,
      sym_list_splat,
      sym_dictionary_splat,
    ACTIONS(301), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(311), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(285), 5,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
    STATE(900), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(642), 15,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [8894] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym_STAR_STAR,
    ACTIONS(274), 1,
      sym_identifier,
    ACTIONS(278), 1,
      anon_sym_LPAREN,
    ACTIONS(293), 1,
      anon_sym_LBRACK,
    ACTIONS(295), 1,
      anon_sym_LBRACE,
    ACTIONS(299), 1,
      anon_sym_not,
    ACTIONS(305), 1,
      anon_sym_lambda,
    ACTIONS(313), 1,
      anon_sym_await,
    ACTIONS(315), 1,
      sym__string_start,
    ACTIONS(870), 1,
      anon_sym_RBRACE,
    STATE(600), 1,
      sym_string,
    STATE(630), 1,
      sym_primary_expression,
    STATE(1145), 1,
      sym_expression,
    ACTIONS(309), 2,
      sym_ellipsis,
      sym_float,
    STATE(1384), 2,
      sym_dictionary_splat,
      sym_pair,
    ACTIONS(301), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(311), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(285), 5,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
    STATE(900), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(642), 15,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [8989] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(280), 1,
      anon_sym_COMMA,
    ACTIONS(287), 1,
      anon_sym_COLON_EQ,
    ACTIONS(872), 1,
      anon_sym_for,
    ACTIONS(874), 1,
      anon_sym_with,
    ACTIONS(876), 1,
      anon_sym_def,
    ACTIONS(289), 2,
      anon_sym_COLON,
      anon_sym_EQ,
    ACTIONS(307), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    ACTIONS(276), 15,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(303), 16,
      sym__newline,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym__semicolon,
  [9062] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym_STAR_STAR,
    ACTIONS(274), 1,
      sym_identifier,
    ACTIONS(278), 1,
      anon_sym_LPAREN,
    ACTIONS(293), 1,
      anon_sym_LBRACK,
    ACTIONS(295), 1,
      anon_sym_LBRACE,
    ACTIONS(299), 1,
      anon_sym_not,
    ACTIONS(305), 1,
      anon_sym_lambda,
    ACTIONS(313), 1,
      anon_sym_await,
    ACTIONS(315), 1,
      sym__string_start,
    ACTIONS(878), 1,
      anon_sym_RBRACE,
    STATE(600), 1,
      sym_string,
    STATE(630), 1,
      sym_primary_expression,
    STATE(1145), 1,
      sym_expression,
    ACTIONS(309), 2,
      sym_ellipsis,
      sym_float,
    STATE(1384), 2,
      sym_dictionary_splat,
      sym_pair,
    ACTIONS(301), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(311), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(285), 5,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
    STATE(900), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(642), 15,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [9157] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym_STAR_STAR,
    ACTIONS(274), 1,
      sym_identifier,
    ACTIONS(278), 1,
      anon_sym_LPAREN,
    ACTIONS(293), 1,
      anon_sym_LBRACK,
    ACTIONS(295), 1,
      anon_sym_LBRACE,
    ACTIONS(299), 1,
      anon_sym_not,
    ACTIONS(305), 1,
      anon_sym_lambda,
    ACTIONS(313), 1,
      anon_sym_await,
    ACTIONS(315), 1,
      sym__string_start,
    ACTIONS(880), 1,
      anon_sym_RBRACE,
    STATE(600), 1,
      sym_string,
    STATE(630), 1,
      sym_primary_expression,
    STATE(1145), 1,
      sym_expression,
    ACTIONS(309), 2,
      sym_ellipsis,
      sym_float,
    STATE(1384), 2,
      sym_dictionary_splat,
      sym_pair,
    ACTIONS(301), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(311), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(285), 5,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
    STATE(900), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(642), 15,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [9252] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym_STAR_STAR,
    ACTIONS(274), 1,
      sym_identifier,
    ACTIONS(278), 1,
      anon_sym_LPAREN,
    ACTIONS(293), 1,
      anon_sym_LBRACK,
    ACTIONS(295), 1,
      anon_sym_LBRACE,
    ACTIONS(299), 1,
      anon_sym_not,
    ACTIONS(305), 1,
      anon_sym_lambda,
    ACTIONS(313), 1,
      anon_sym_await,
    ACTIONS(315), 1,
      sym__string_start,
    ACTIONS(882), 1,
      anon_sym_RBRACE,
    STATE(600), 1,
      sym_string,
    STATE(630), 1,
      sym_primary_expression,
    STATE(1145), 1,
      sym_expression,
    ACTIONS(309), 2,
      sym_ellipsis,
      sym_float,
    STATE(1384), 2,
      sym_dictionary_splat,
      sym_pair,
    ACTIONS(301), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(311), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(285), 5,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
    STATE(900), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(642), 15,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [9347] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym_STAR_STAR,
    ACTIONS(274), 1,
      sym_identifier,
    ACTIONS(278), 1,
      anon_sym_LPAREN,
    ACTIONS(293), 1,
      anon_sym_LBRACK,
    ACTIONS(295), 1,
      anon_sym_LBRACE,
    ACTIONS(299), 1,
      anon_sym_not,
    ACTIONS(305), 1,
      anon_sym_lambda,
    ACTIONS(313), 1,
      anon_sym_await,
    ACTIONS(315), 1,
      sym__string_start,
    ACTIONS(884), 1,
      anon_sym_RBRACE,
    STATE(600), 1,
      sym_string,
    STATE(630), 1,
      sym_primary_expression,
    STATE(1145), 1,
      sym_expression,
    ACTIONS(309), 2,
      sym_ellipsis,
      sym_float,
    STATE(1384), 2,
      sym_dictionary_splat,
      sym_pair,
    ACTIONS(301), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(311), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(285), 5,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
    STATE(900), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(642), 15,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [9442] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym_STAR_STAR,
    ACTIONS(274), 1,
      sym_identifier,
    ACTIONS(278), 1,
      anon_sym_LPAREN,
    ACTIONS(293), 1,
      anon_sym_LBRACK,
    ACTIONS(295), 1,
      anon_sym_LBRACE,
    ACTIONS(299), 1,
      anon_sym_not,
    ACTIONS(305), 1,
      anon_sym_lambda,
    ACTIONS(313), 1,
      anon_sym_await,
    ACTIONS(315), 1,
      sym__string_start,
    ACTIONS(886), 1,
      anon_sym_RBRACE,
    STATE(600), 1,
      sym_string,
    STATE(630), 1,
      sym_primary_expression,
    STATE(1145), 1,
      sym_expression,
    ACTIONS(309), 2,
      sym_ellipsis,
      sym_float,
    STATE(1384), 2,
      sym_dictionary_splat,
      sym_pair,
    ACTIONS(301), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(311), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(285), 5,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
    STATE(900), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(642), 15,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [9537] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym_STAR_STAR,
    ACTIONS(274), 1,
      sym_identifier,
    ACTIONS(278), 1,
      anon_sym_LPAREN,
    ACTIONS(293), 1,
      anon_sym_LBRACK,
    ACTIONS(295), 1,
      anon_sym_LBRACE,
    ACTIONS(299), 1,
      anon_sym_not,
    ACTIONS(305), 1,
      anon_sym_lambda,
    ACTIONS(313), 1,
      anon_sym_await,
    ACTIONS(315), 1,
      sym__string_start,
    ACTIONS(888), 1,
      anon_sym_RBRACE,
    STATE(600), 1,
      sym_string,
    STATE(630), 1,
      sym_primary_expression,
    STATE(1145), 1,
      sym_expression,
    ACTIONS(309), 2,
      sym_ellipsis,
      sym_float,
    STATE(1384), 2,
      sym_dictionary_splat,
      sym_pair,
    ACTIONS(301), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(311), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(285), 5,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
    STATE(900), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(642), 15,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [9632] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(280), 1,
      anon_sym_COMMA,
    ACTIONS(287), 1,
      anon_sym_COLON_EQ,
    ACTIONS(890), 1,
      anon_sym_for,
    ACTIONS(892), 1,
      anon_sym_with,
    ACTIONS(894), 1,
      anon_sym_def,
    ACTIONS(289), 2,
      anon_sym_COLON,
      anon_sym_EQ,
    ACTIONS(307), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    ACTIONS(276), 15,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(303), 16,
      sym__newline,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym__semicolon,
  [9705] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(274), 1,
      sym_identifier,
    ACTIONS(278), 1,
      anon_sym_LPAREN,
    ACTIONS(293), 1,
      anon_sym_LBRACK,
    ACTIONS(295), 1,
      anon_sym_LBRACE,
    ACTIONS(299), 1,
      anon_sym_not,
    ACTIONS(305), 1,
      anon_sym_lambda,
    ACTIONS(313), 1,
      anon_sym_await,
    ACTIONS(315), 1,
      sym__string_start,
    ACTIONS(896), 1,
      anon_sym_COLON,
    ACTIONS(898), 1,
      anon_sym_RBRACK,
    STATE(600), 1,
      sym_string,
    STATE(630), 1,
      sym_primary_expression,
    STATE(1086), 1,
      sym_expression,
    STATE(1398), 1,
      sym_slice,
    ACTIONS(309), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(301), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(311), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(285), 5,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
    STATE(900), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(642), 15,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [9799] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(274), 1,
      sym_identifier,
    ACTIONS(278), 1,
      anon_sym_LPAREN,
    ACTIONS(293), 1,
      anon_sym_LBRACK,
    ACTIONS(295), 1,
      anon_sym_LBRACE,
    ACTIONS(299), 1,
      anon_sym_not,
    ACTIONS(305), 1,
      anon_sym_lambda,
    ACTIONS(313), 1,
      anon_sym_await,
    ACTIONS(315), 1,
      sym__string_start,
    ACTIONS(896), 1,
      anon_sym_COLON,
    ACTIONS(900), 1,
      anon_sym_RBRACK,
    STATE(600), 1,
      sym_string,
    STATE(630), 1,
      sym_primary_expression,
    STATE(1086), 1,
      sym_expression,
    STATE(1398), 1,
      sym_slice,
    ACTIONS(309), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(301), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(311), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(285), 5,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
    STATE(900), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(642), 15,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [9893] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(274), 1,
      sym_identifier,
    ACTIONS(278), 1,
      anon_sym_LPAREN,
    ACTIONS(293), 1,
      anon_sym_LBRACK,
    ACTIONS(295), 1,
      anon_sym_LBRACE,
    ACTIONS(299), 1,
      anon_sym_not,
    ACTIONS(305), 1,
      anon_sym_lambda,
    ACTIONS(313), 1,
      anon_sym_await,
    ACTIONS(315), 1,
      sym__string_start,
    ACTIONS(896), 1,
      anon_sym_COLON,
    ACTIONS(902), 1,
      anon_sym_RBRACK,
    STATE(600), 1,
      sym_string,
    STATE(630), 1,
      sym_primary_expression,
    STATE(1086), 1,
      sym_expression,
    STATE(1398), 1,
      sym_slice,
    ACTIONS(309), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(301), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(311), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(285), 5,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
    STATE(900), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(642), 15,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [9987] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(852), 1,
      anon_sym_else,
    ACTIONS(908), 1,
      anon_sym_elif,
    STATE(307), 1,
      aux_sym_if_statement_repeat1,
    STATE(420), 1,
      sym_elif_clause,
    STATE(577), 1,
      sym_else_clause,
    ACTIONS(906), 12,
      sym__dedent,
      sym__string_start,
      anon_sym_LPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(904), 33,
      anon_sym_import,
      anon_sym_from,
      anon_sym_STAR,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_match,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [10055] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(274), 1,
      sym_identifier,
    ACTIONS(278), 1,
      anon_sym_LPAREN,
    ACTIONS(293), 1,
      anon_sym_LBRACK,
    ACTIONS(295), 1,
      anon_sym_LBRACE,
    ACTIONS(299), 1,
      anon_sym_not,
    ACTIONS(305), 1,
      anon_sym_lambda,
    ACTIONS(313), 1,
      anon_sym_await,
    ACTIONS(315), 1,
      sym__string_start,
    ACTIONS(912), 1,
      anon_sym_COLON,
    STATE(600), 1,
      sym_string,
    STATE(630), 1,
      sym_primary_expression,
    STATE(1064), 1,
      sym_expression,
    ACTIONS(309), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(910), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(301), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(311), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(285), 5,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
    STATE(900), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(642), 15,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [10147] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(274), 1,
      sym_identifier,
    ACTIONS(278), 1,
      anon_sym_LPAREN,
    ACTIONS(293), 1,
      anon_sym_LBRACK,
    ACTIONS(295), 1,
      anon_sym_LBRACE,
    ACTIONS(299), 1,
      anon_sym_not,
    ACTIONS(305), 1,
      anon_sym_lambda,
    ACTIONS(313), 1,
      anon_sym_await,
    ACTIONS(315), 1,
      sym__string_start,
    ACTIONS(896), 1,
      anon_sym_COLON,
    ACTIONS(914), 1,
      anon_sym_RBRACK,
    STATE(600), 1,
      sym_string,
    STATE(630), 1,
      sym_primary_expression,
    STATE(1086), 1,
      sym_expression,
    STATE(1398), 1,
      sym_slice,
    ACTIONS(309), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(301), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(311), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(285), 5,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
    STATE(900), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(642), 15,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [10241] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(274), 1,
      sym_identifier,
    ACTIONS(278), 1,
      anon_sym_LPAREN,
    ACTIONS(293), 1,
      anon_sym_LBRACK,
    ACTIONS(295), 1,
      anon_sym_LBRACE,
    ACTIONS(299), 1,
      anon_sym_not,
    ACTIONS(305), 1,
      anon_sym_lambda,
    ACTIONS(313), 1,
      anon_sym_await,
    ACTIONS(315), 1,
      sym__string_start,
    ACTIONS(896), 1,
      anon_sym_COLON,
    ACTIONS(916), 1,
      anon_sym_RBRACK,
    STATE(600), 1,
      sym_string,
    STATE(630), 1,
      sym_primary_expression,
    STATE(1086), 1,
      sym_expression,
    STATE(1398), 1,
      sym_slice,
    ACTIONS(309), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(301), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(311), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(285), 5,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
    STATE(900), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(642), 15,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [10335] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(274), 1,
      sym_identifier,
    ACTIONS(278), 1,
      anon_sym_LPAREN,
    ACTIONS(293), 1,
      anon_sym_LBRACK,
    ACTIONS(295), 1,
      anon_sym_LBRACE,
    ACTIONS(299), 1,
      anon_sym_not,
    ACTIONS(305), 1,
      anon_sym_lambda,
    ACTIONS(313), 1,
      anon_sym_await,
    ACTIONS(315), 1,
      sym__string_start,
    ACTIONS(896), 1,
      anon_sym_COLON,
    ACTIONS(918), 1,
      anon_sym_RBRACK,
    STATE(600), 1,
      sym_string,
    STATE(630), 1,
      sym_primary_expression,
    STATE(1086), 1,
      sym_expression,
    STATE(1398), 1,
      sym_slice,
    ACTIONS(309), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(301), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(311), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(285), 5,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
    STATE(900), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(642), 15,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [10429] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(852), 1,
      anon_sym_else,
    ACTIONS(908), 1,
      anon_sym_elif,
    STATE(307), 1,
      aux_sym_if_statement_repeat1,
    STATE(420), 1,
      sym_elif_clause,
    STATE(570), 1,
      sym_else_clause,
    ACTIONS(922), 12,
      sym__dedent,
      sym__string_start,
      anon_sym_LPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(920), 33,
      anon_sym_import,
      anon_sym_from,
      anon_sym_STAR,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_match,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [10497] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(274), 1,
      sym_identifier,
    ACTIONS(278), 1,
      anon_sym_LPAREN,
    ACTIONS(293), 1,
      anon_sym_LBRACK,
    ACTIONS(295), 1,
      anon_sym_LBRACE,
    ACTIONS(299), 1,
      anon_sym_not,
    ACTIONS(305), 1,
      anon_sym_lambda,
    ACTIONS(313), 1,
      anon_sym_await,
    ACTIONS(315), 1,
      sym__string_start,
    ACTIONS(926), 1,
      anon_sym_COLON,
    STATE(600), 1,
      sym_string,
    STATE(630), 1,
      sym_primary_expression,
    STATE(1083), 1,
      sym_expression,
    ACTIONS(309), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(924), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(301), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(311), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(285), 5,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
    STATE(900), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(642), 15,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [10589] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(852), 1,
      anon_sym_else,
    ACTIONS(908), 1,
      anon_sym_elif,
    STATE(258), 1,
      aux_sym_if_statement_repeat1,
    STATE(420), 1,
      sym_elif_clause,
    STATE(522), 1,
      sym_else_clause,
    ACTIONS(930), 12,
      sym__dedent,
      sym__string_start,
      anon_sym_LPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(928), 33,
      anon_sym_import,
      anon_sym_from,
      anon_sym_STAR,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_match,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [10657] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(936), 1,
      anon_sym_except,
    STATE(266), 2,
      sym_except_clause,
      aux_sym_try_statement_repeat1,
    ACTIONS(934), 12,
      sym__dedent,
      sym__string_start,
      anon_sym_LPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(932), 35,
      anon_sym_import,
      anon_sym_from,
      anon_sym_STAR,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_match,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [10719] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(943), 1,
      anon_sym_except_STAR,
    STATE(267), 2,
      sym_except_group_clause,
      aux_sym_try_statement_repeat2,
    ACTIONS(941), 12,
      sym__dedent,
      sym__string_start,
      anon_sym_LPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(939), 35,
      anon_sym_import,
      anon_sym_from,
      anon_sym_STAR,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_match,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [10781] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(846), 1,
      anon_sym_else,
    ACTIONS(950), 1,
      anon_sym_elif,
    STATE(276), 1,
      aux_sym_if_statement_repeat1,
    STATE(433), 1,
      sym_elif_clause,
    STATE(537), 1,
      sym_else_clause,
    ACTIONS(946), 12,
      sym__string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(948), 33,
      anon_sym_import,
      anon_sym_from,
      anon_sym_STAR,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_match,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [10849] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(274), 1,
      sym_identifier,
    ACTIONS(278), 1,
      anon_sym_LPAREN,
    ACTIONS(293), 1,
      anon_sym_LBRACK,
    ACTIONS(295), 1,
      anon_sym_LBRACE,
    ACTIONS(299), 1,
      anon_sym_not,
    ACTIONS(305), 1,
      anon_sym_lambda,
    ACTIONS(313), 1,
      anon_sym_await,
    ACTIONS(315), 1,
      sym__string_start,
    ACTIONS(896), 1,
      anon_sym_COLON,
    ACTIONS(952), 1,
      anon_sym_RBRACK,
    STATE(600), 1,
      sym_string,
    STATE(630), 1,
      sym_primary_expression,
    STATE(1086), 1,
      sym_expression,
    STATE(1398), 1,
      sym_slice,
    ACTIONS(309), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(301), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(311), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(285), 5,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
    STATE(900), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(642), 15,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [10943] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(954), 1,
      anon_sym_except_STAR,
    STATE(270), 2,
      sym_except_group_clause,
      aux_sym_try_statement_repeat2,
    ACTIONS(941), 12,
      sym__string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(939), 35,
      anon_sym_import,
      anon_sym_from,
      anon_sym_STAR,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_match,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [11005] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(957), 1,
      anon_sym_except,
    STATE(271), 2,
      sym_except_clause,
      aux_sym_try_statement_repeat1,
    ACTIONS(934), 12,
      sym__string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(932), 35,
      anon_sym_import,
      anon_sym_from,
      anon_sym_STAR,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_match,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [11067] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(852), 1,
      anon_sym_else,
    ACTIONS(908), 1,
      anon_sym_elif,
    STATE(263), 1,
      aux_sym_if_statement_repeat1,
    STATE(420), 1,
      sym_elif_clause,
    STATE(529), 1,
      sym_else_clause,
    ACTIONS(946), 12,
      sym__dedent,
      sym__string_start,
      anon_sym_LPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(948), 33,
      anon_sym_import,
      anon_sym_from,
      anon_sym_STAR,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_match,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [11135] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(274), 1,
      sym_identifier,
    ACTIONS(278), 1,
      anon_sym_LPAREN,
    ACTIONS(293), 1,
      anon_sym_LBRACK,
    ACTIONS(295), 1,
      anon_sym_LBRACE,
    ACTIONS(299), 1,
      anon_sym_not,
    ACTIONS(305), 1,
      anon_sym_lambda,
    ACTIONS(313), 1,
      anon_sym_await,
    ACTIONS(315), 1,
      sym__string_start,
    ACTIONS(896), 1,
      anon_sym_COLON,
    ACTIONS(960), 1,
      anon_sym_RBRACK,
    STATE(600), 1,
      sym_string,
    STATE(630), 1,
      sym_primary_expression,
    STATE(1086), 1,
      sym_expression,
    STATE(1398), 1,
      sym_slice,
    ACTIONS(309), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(301), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(311), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(285), 5,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
    STATE(900), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(642), 15,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [11229] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(274), 1,
      sym_identifier,
    ACTIONS(278), 1,
      anon_sym_LPAREN,
    ACTIONS(293), 1,
      anon_sym_LBRACK,
    ACTIONS(295), 1,
      anon_sym_LBRACE,
    ACTIONS(299), 1,
      anon_sym_not,
    ACTIONS(305), 1,
      anon_sym_lambda,
    ACTIONS(313), 1,
      anon_sym_await,
    ACTIONS(315), 1,
      sym__string_start,
    ACTIONS(896), 1,
      anon_sym_COLON,
    ACTIONS(962), 1,
      anon_sym_RBRACK,
    STATE(600), 1,
      sym_string,
    STATE(630), 1,
      sym_primary_expression,
    STATE(1086), 1,
      sym_expression,
    STATE(1398), 1,
      sym_slice,
    ACTIONS(309), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(301), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(311), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(285), 5,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
    STATE(900), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(642), 15,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [11323] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym_STAR_STAR,
    ACTIONS(274), 1,
      sym_identifier,
    ACTIONS(278), 1,
      anon_sym_LPAREN,
    ACTIONS(293), 1,
      anon_sym_LBRACK,
    ACTIONS(295), 1,
      anon_sym_LBRACE,
    ACTIONS(299), 1,
      anon_sym_not,
    ACTIONS(305), 1,
      anon_sym_lambda,
    ACTIONS(313), 1,
      anon_sym_await,
    ACTIONS(315), 1,
      sym__string_start,
    STATE(600), 1,
      sym_string,
    STATE(630), 1,
      sym_primary_expression,
    STATE(1145), 1,
      sym_expression,
    ACTIONS(309), 2,
      sym_ellipsis,
      sym_float,
    STATE(1384), 2,
      sym_dictionary_splat,
      sym_pair,
    ACTIONS(301), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(311), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(285), 5,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
    STATE(900), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(642), 15,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [11415] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(846), 1,
      anon_sym_else,
    ACTIONS(950), 1,
      anon_sym_elif,
    STATE(285), 1,
      aux_sym_if_statement_repeat1,
    STATE(433), 1,
      sym_elif_clause,
    STATE(585), 1,
      sym_else_clause,
    ACTIONS(922), 12,
      sym__string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(920), 33,
      anon_sym_import,
      anon_sym_from,
      anon_sym_STAR,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_match,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [11483] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(846), 1,
      anon_sym_else,
    ACTIONS(950), 1,
      anon_sym_elif,
    STATE(285), 1,
      aux_sym_if_statement_repeat1,
    STATE(433), 1,
      sym_elif_clause,
    STATE(575), 1,
      sym_else_clause,
    ACTIONS(906), 12,
      sym__string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(904), 33,
      anon_sym_import,
      anon_sym_from,
      anon_sym_STAR,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_match,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [11551] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(280), 1,
      anon_sym_COMMA,
    ACTIONS(287), 1,
      anon_sym_COLON_EQ,
    ACTIONS(964), 1,
      sym__string_start,
    STATE(1335), 1,
      sym_string,
    ACTIONS(289), 2,
      anon_sym_COLON,
      anon_sym_EQ,
    ACTIONS(307), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    ACTIONS(276), 15,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(303), 16,
      sym__newline,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym__semicolon,
  [11621] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(846), 1,
      anon_sym_else,
    ACTIONS(950), 1,
      anon_sym_elif,
    STATE(277), 1,
      aux_sym_if_statement_repeat1,
    STATE(433), 1,
      sym_elif_clause,
    STATE(576), 1,
      sym_else_clause,
    ACTIONS(930), 12,
      sym__string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(928), 33,
      anon_sym_import,
      anon_sym_from,
      anon_sym_STAR,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_match,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [11689] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(295), 1,
      anon_sym_LBRACE,
    ACTIONS(315), 1,
      sym__string_start,
    ACTIONS(602), 1,
      sym_identifier,
    ACTIONS(604), 1,
      anon_sym_LPAREN,
    ACTIONS(612), 1,
      anon_sym_LBRACK,
    ACTIONS(614), 1,
      anon_sym_not,
    ACTIONS(618), 1,
      anon_sym_await,
    ACTIONS(758), 1,
      anon_sym_lambda,
    STATE(600), 1,
      sym_string,
    STATE(643), 1,
      sym_primary_expression,
    STATE(962), 1,
      sym_expression,
    ACTIONS(309), 2,
      sym_ellipsis,
      sym_float,
    STATE(1018), 2,
      sym__expression_within_for_in_clause,
      sym_lambda_within_for_in_clause,
    ACTIONS(610), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(311), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(606), 5,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
    STATE(900), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(642), 15,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [11778] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(966), 12,
      sym__string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(968), 37,
      anon_sym_import,
      anon_sym_from,
      anon_sym_STAR,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_elif,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_match,
      anon_sym_case,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [11835] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(970), 12,
      sym__string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(972), 37,
      anon_sym_import,
      anon_sym_from,
      anon_sym_STAR,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_elif,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_match,
      anon_sym_case,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [11892] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(622), 1,
      sym_identifier,
    ACTIONS(632), 1,
      anon_sym_LBRACK,
    ACTIONS(634), 1,
      anon_sym_LBRACE,
    ACTIONS(636), 1,
      anon_sym_not,
    ACTIONS(638), 1,
      anon_sym_lambda,
    ACTIONS(644), 1,
      anon_sym_await,
    ACTIONS(646), 1,
      sym__string_start,
    ACTIONS(974), 1,
      anon_sym_LPAREN,
    STATE(740), 1,
      sym_primary_expression,
    STATE(742), 1,
      sym_string,
    STATE(1050), 1,
      sym_expression,
    STATE(1320), 1,
      sym_with_item,
    STATE(1422), 1,
      sym_with_clause,
    ACTIONS(640), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(630), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(642), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(626), 5,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
    STATE(1015), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(811), 15,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [11983] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(280), 1,
      anon_sym_COMMA,
    ACTIONS(287), 1,
      anon_sym_COLON_EQ,
    ACTIONS(976), 1,
      sym_identifier,
    ACTIONS(289), 2,
      anon_sym_COLON,
      anon_sym_EQ,
    ACTIONS(303), 10,
      sym__newline,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      sym__semicolon,
    ACTIONS(307), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    ACTIONS(276), 21,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_is,
  [12050] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(982), 1,
      anon_sym_elif,
    STATE(285), 1,
      aux_sym_if_statement_repeat1,
    STATE(433), 1,
      sym_elif_clause,
    ACTIONS(978), 12,
      sym__string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(980), 34,
      anon_sym_import,
      anon_sym_from,
      anon_sym_STAR,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_match,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [12113] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(295), 1,
      anon_sym_LBRACE,
    ACTIONS(315), 1,
      sym__string_start,
    ACTIONS(602), 1,
      sym_identifier,
    ACTIONS(604), 1,
      anon_sym_LPAREN,
    ACTIONS(612), 1,
      anon_sym_LBRACK,
    ACTIONS(614), 1,
      anon_sym_not,
    ACTIONS(618), 1,
      anon_sym_await,
    ACTIONS(758), 1,
      anon_sym_lambda,
    STATE(600), 1,
      sym_string,
    STATE(643), 1,
      sym_primary_expression,
    STATE(962), 1,
      sym_expression,
    ACTIONS(309), 2,
      sym_ellipsis,
      sym_float,
    STATE(979), 2,
      sym__expression_within_for_in_clause,
      sym_lambda_within_for_in_clause,
    ACTIONS(610), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(311), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(606), 5,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
    STATE(900), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(642), 15,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [12202] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(985), 12,
      sym__string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(987), 37,
      anon_sym_import,
      anon_sym_from,
      anon_sym_STAR,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_elif,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_match,
      anon_sym_case,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [12259] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(991), 12,
      sym__dedent,
      sym__string_start,
      anon_sym_LPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(989), 37,
      anon_sym_import,
      anon_sym_from,
      anon_sym_STAR,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_elif,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_match,
      anon_sym_case,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [12316] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(274), 1,
      sym_identifier,
    ACTIONS(278), 1,
      anon_sym_LPAREN,
    ACTIONS(293), 1,
      anon_sym_LBRACK,
    ACTIONS(295), 1,
      anon_sym_LBRACE,
    ACTIONS(299), 1,
      anon_sym_not,
    ACTIONS(305), 1,
      anon_sym_lambda,
    ACTIONS(313), 1,
      anon_sym_await,
    ACTIONS(315), 1,
      sym__string_start,
    STATE(600), 1,
      sym_string,
    STATE(630), 1,
      sym_primary_expression,
    STATE(1103), 1,
      sym_expression,
    ACTIONS(309), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(993), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(301), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(311), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(285), 5,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
    STATE(900), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(642), 15,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [12405] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(622), 1,
      sym_identifier,
    ACTIONS(624), 1,
      anon_sym_LPAREN,
    ACTIONS(632), 1,
      anon_sym_LBRACK,
    ACTIONS(634), 1,
      anon_sym_LBRACE,
    ACTIONS(636), 1,
      anon_sym_not,
    ACTIONS(638), 1,
      anon_sym_lambda,
    ACTIONS(644), 1,
      anon_sym_await,
    ACTIONS(646), 1,
      sym__string_start,
    ACTIONS(995), 1,
      anon_sym_RPAREN,
    STATE(740), 1,
      sym_primary_expression,
    STATE(742), 1,
      sym_string,
    STATE(1050), 1,
      sym_expression,
    STATE(1308), 1,
      sym_with_item,
    ACTIONS(640), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(630), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(642), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(626), 5,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
    STATE(1015), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(811), 15,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [12496] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(966), 12,
      sym__dedent,
      sym__string_start,
      anon_sym_LPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(968), 37,
      anon_sym_import,
      anon_sym_from,
      anon_sym_STAR,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_elif,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_match,
      anon_sym_case,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [12553] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(622), 1,
      sym_identifier,
    ACTIONS(632), 1,
      anon_sym_LBRACK,
    ACTIONS(634), 1,
      anon_sym_LBRACE,
    ACTIONS(636), 1,
      anon_sym_not,
    ACTIONS(638), 1,
      anon_sym_lambda,
    ACTIONS(644), 1,
      anon_sym_await,
    ACTIONS(646), 1,
      sym__string_start,
    ACTIONS(974), 1,
      anon_sym_LPAREN,
    STATE(740), 1,
      sym_primary_expression,
    STATE(742), 1,
      sym_string,
    STATE(1050), 1,
      sym_expression,
    STATE(1320), 1,
      sym_with_item,
    STATE(1459), 1,
      sym_with_clause,
    ACTIONS(640), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(630), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(642), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(626), 5,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
    STATE(1015), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(811), 15,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [12644] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(274), 1,
      sym_identifier,
    ACTIONS(278), 1,
      anon_sym_LPAREN,
    ACTIONS(293), 1,
      anon_sym_LBRACK,
    ACTIONS(295), 1,
      anon_sym_LBRACE,
    ACTIONS(299), 1,
      anon_sym_not,
    ACTIONS(305), 1,
      anon_sym_lambda,
    ACTIONS(313), 1,
      anon_sym_await,
    ACTIONS(315), 1,
      sym__string_start,
    STATE(600), 1,
      sym_string,
    STATE(630), 1,
      sym_primary_expression,
    STATE(1090), 1,
      sym_expression,
    ACTIONS(309), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(997), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(301), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(311), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(285), 5,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
    STATE(900), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(642), 15,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [12733] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(274), 1,
      sym_identifier,
    ACTIONS(278), 1,
      anon_sym_LPAREN,
    ACTIONS(293), 1,
      anon_sym_LBRACK,
    ACTIONS(295), 1,
      anon_sym_LBRACE,
    ACTIONS(299), 1,
      anon_sym_not,
    ACTIONS(305), 1,
      anon_sym_lambda,
    ACTIONS(313), 1,
      anon_sym_await,
    ACTIONS(315), 1,
      sym__string_start,
    STATE(600), 1,
      sym_string,
    STATE(630), 1,
      sym_primary_expression,
    STATE(1091), 1,
      sym_expression,
    ACTIONS(309), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(999), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(301), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(311), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(285), 5,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
    STATE(900), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(642), 15,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [12822] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      anon_sym_not,
    ACTIONS(71), 1,
      anon_sym_lambda,
    ACTIONS(81), 1,
      sym__string_start,
    ACTIONS(331), 1,
      sym_identifier,
    ACTIONS(337), 1,
      anon_sym_await,
    ACTIONS(559), 1,
      anon_sym_LPAREN,
    ACTIONS(563), 1,
      anon_sym_LBRACK,
    STATE(684), 1,
      sym_primary_expression,
    STATE(713), 1,
      sym_string,
    STATE(1066), 1,
      sym_expression,
    ACTIONS(75), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(1001), 2,
      sym__newline,
      sym__semicolon,
    ACTIONS(47), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(77), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(333), 5,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
    STATE(1009), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(797), 15,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [12911] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(622), 1,
      sym_identifier,
    ACTIONS(632), 1,
      anon_sym_LBRACK,
    ACTIONS(634), 1,
      anon_sym_LBRACE,
    ACTIONS(636), 1,
      anon_sym_not,
    ACTIONS(638), 1,
      anon_sym_lambda,
    ACTIONS(644), 1,
      anon_sym_await,
    ACTIONS(646), 1,
      sym__string_start,
    ACTIONS(974), 1,
      anon_sym_LPAREN,
    STATE(740), 1,
      sym_primary_expression,
    STATE(742), 1,
      sym_string,
    STATE(1050), 1,
      sym_expression,
    STATE(1320), 1,
      sym_with_item,
    STATE(1474), 1,
      sym_with_clause,
    ACTIONS(640), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(630), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(642), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(626), 5,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
    STATE(1015), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(811), 15,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [13002] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(295), 1,
      anon_sym_LBRACE,
    ACTIONS(315), 1,
      sym__string_start,
    ACTIONS(602), 1,
      sym_identifier,
    ACTIONS(604), 1,
      anon_sym_LPAREN,
    ACTIONS(612), 1,
      anon_sym_LBRACK,
    ACTIONS(614), 1,
      anon_sym_not,
    ACTIONS(618), 1,
      anon_sym_await,
    ACTIONS(758), 1,
      anon_sym_lambda,
    STATE(600), 1,
      sym_string,
    STATE(643), 1,
      sym_primary_expression,
    STATE(962), 1,
      sym_expression,
    ACTIONS(309), 2,
      sym_ellipsis,
      sym_float,
    STATE(1013), 2,
      sym__expression_within_for_in_clause,
      sym_lambda_within_for_in_clause,
    ACTIONS(610), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(311), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(606), 5,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
    STATE(900), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(642), 15,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [13091] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(622), 1,
      sym_identifier,
    ACTIONS(632), 1,
      anon_sym_LBRACK,
    ACTIONS(634), 1,
      anon_sym_LBRACE,
    ACTIONS(636), 1,
      anon_sym_not,
    ACTIONS(638), 1,
      anon_sym_lambda,
    ACTIONS(644), 1,
      anon_sym_await,
    ACTIONS(646), 1,
      sym__string_start,
    ACTIONS(974), 1,
      anon_sym_LPAREN,
    STATE(740), 1,
      sym_primary_expression,
    STATE(742), 1,
      sym_string,
    STATE(1050), 1,
      sym_expression,
    STATE(1320), 1,
      sym_with_item,
    STATE(1451), 1,
      sym_with_clause,
    ACTIONS(640), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(630), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(642), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(626), 5,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
    STATE(1015), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(811), 15,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [13182] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(274), 1,
      sym_identifier,
    ACTIONS(278), 1,
      anon_sym_LPAREN,
    ACTIONS(293), 1,
      anon_sym_LBRACK,
    ACTIONS(295), 1,
      anon_sym_LBRACE,
    ACTIONS(299), 1,
      anon_sym_not,
    ACTIONS(305), 1,
      anon_sym_lambda,
    ACTIONS(313), 1,
      anon_sym_await,
    ACTIONS(315), 1,
      sym__string_start,
    ACTIONS(896), 1,
      anon_sym_COLON,
    STATE(600), 1,
      sym_string,
    STATE(630), 1,
      sym_primary_expression,
    STATE(1047), 1,
      sym_expression,
    STATE(1294), 1,
      sym_slice,
    ACTIONS(309), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(301), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(311), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(285), 5,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
    STATE(900), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(642), 15,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [13273] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      anon_sym_not,
    ACTIONS(71), 1,
      anon_sym_lambda,
    ACTIONS(81), 1,
      sym__string_start,
    ACTIONS(331), 1,
      sym_identifier,
    ACTIONS(337), 1,
      anon_sym_await,
    ACTIONS(559), 1,
      anon_sym_LPAREN,
    ACTIONS(563), 1,
      anon_sym_LBRACK,
    STATE(684), 1,
      sym_primary_expression,
    STATE(713), 1,
      sym_string,
    STATE(1066), 1,
      sym_expression,
    ACTIONS(75), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(1003), 2,
      sym__newline,
      sym__semicolon,
    ACTIONS(47), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(77), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(333), 5,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
    STATE(1009), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(797), 15,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [13362] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(274), 1,
      sym_identifier,
    ACTIONS(278), 1,
      anon_sym_LPAREN,
    ACTIONS(293), 1,
      anon_sym_LBRACK,
    ACTIONS(295), 1,
      anon_sym_LBRACE,
    ACTIONS(299), 1,
      anon_sym_not,
    ACTIONS(305), 1,
      anon_sym_lambda,
    ACTIONS(313), 1,
      anon_sym_await,
    ACTIONS(315), 1,
      sym__string_start,
    ACTIONS(896), 1,
      anon_sym_COLON,
    STATE(600), 1,
      sym_string,
    STATE(630), 1,
      sym_primary_expression,
    STATE(1021), 1,
      sym_expression,
    STATE(1220), 1,
      sym_slice,
    ACTIONS(309), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(301), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(311), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(285), 5,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
    STATE(900), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(642), 15,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [13453] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(622), 1,
      sym_identifier,
    ACTIONS(624), 1,
      anon_sym_LPAREN,
    ACTIONS(632), 1,
      anon_sym_LBRACK,
    ACTIONS(634), 1,
      anon_sym_LBRACE,
    ACTIONS(636), 1,
      anon_sym_not,
    ACTIONS(638), 1,
      anon_sym_lambda,
    ACTIONS(644), 1,
      anon_sym_await,
    ACTIONS(646), 1,
      sym__string_start,
    ACTIONS(1005), 1,
      anon_sym_RPAREN,
    STATE(740), 1,
      sym_primary_expression,
    STATE(742), 1,
      sym_string,
    STATE(1050), 1,
      sym_expression,
    STATE(1308), 1,
      sym_with_item,
    ACTIONS(640), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(630), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(642), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(626), 5,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
    STATE(1015), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(811), 15,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [13544] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      anon_sym_not,
    ACTIONS(71), 1,
      anon_sym_lambda,
    ACTIONS(81), 1,
      sym__string_start,
    ACTIONS(331), 1,
      sym_identifier,
    ACTIONS(337), 1,
      anon_sym_await,
    ACTIONS(559), 1,
      anon_sym_LPAREN,
    ACTIONS(563), 1,
      anon_sym_LBRACK,
    STATE(684), 1,
      sym_primary_expression,
    STATE(713), 1,
      sym_string,
    STATE(1066), 1,
      sym_expression,
    ACTIONS(75), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(1007), 2,
      sym__newline,
      sym__semicolon,
    ACTIONS(47), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(77), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(333), 5,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
    STATE(1009), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(797), 15,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [13633] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      anon_sym_not,
    ACTIONS(71), 1,
      anon_sym_lambda,
    ACTIONS(81), 1,
      sym__string_start,
    ACTIONS(331), 1,
      sym_identifier,
    ACTIONS(337), 1,
      anon_sym_await,
    ACTIONS(559), 1,
      anon_sym_LPAREN,
    ACTIONS(563), 1,
      anon_sym_LBRACK,
    STATE(684), 1,
      sym_primary_expression,
    STATE(713), 1,
      sym_string,
    STATE(1066), 1,
      sym_expression,
    ACTIONS(75), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(1009), 2,
      sym__newline,
      sym__semicolon,
    ACTIONS(47), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(77), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(333), 5,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
    STATE(1009), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(797), 15,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [13722] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(991), 12,
      sym__string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(989), 37,
      anon_sym_import,
      anon_sym_from,
      anon_sym_STAR,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_elif,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_match,
      anon_sym_case,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [13779] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(274), 1,
      sym_identifier,
    ACTIONS(278), 1,
      anon_sym_LPAREN,
    ACTIONS(293), 1,
      anon_sym_LBRACK,
    ACTIONS(295), 1,
      anon_sym_LBRACE,
    ACTIONS(299), 1,
      anon_sym_not,
    ACTIONS(305), 1,
      anon_sym_lambda,
    ACTIONS(313), 1,
      anon_sym_await,
    ACTIONS(315), 1,
      sym__string_start,
    STATE(600), 1,
      sym_string,
    STATE(630), 1,
      sym_primary_expression,
    STATE(1119), 1,
      sym_expression,
    ACTIONS(309), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(1011), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(301), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(311), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(285), 5,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
    STATE(900), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(642), 15,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [13868] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1013), 1,
      anon_sym_elif,
    STATE(307), 1,
      aux_sym_if_statement_repeat1,
    STATE(420), 1,
      sym_elif_clause,
    ACTIONS(978), 12,
      sym__dedent,
      sym__string_start,
      anon_sym_LPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(980), 34,
      anon_sym_import,
      anon_sym_from,
      anon_sym_STAR,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_match,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [13931] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1018), 12,
      sym__dedent,
      sym__string_start,
      anon_sym_LPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1016), 37,
      anon_sym_import,
      anon_sym_from,
      anon_sym_STAR,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_elif,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_match,
      anon_sym_case,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [13988] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(295), 1,
      anon_sym_LBRACE,
    ACTIONS(315), 1,
      sym__string_start,
    ACTIONS(602), 1,
      sym_identifier,
    ACTIONS(604), 1,
      anon_sym_LPAREN,
    ACTIONS(612), 1,
      anon_sym_LBRACK,
    ACTIONS(614), 1,
      anon_sym_not,
    ACTIONS(618), 1,
      anon_sym_await,
    ACTIONS(758), 1,
      anon_sym_lambda,
    STATE(600), 1,
      sym_string,
    STATE(643), 1,
      sym_primary_expression,
    STATE(963), 1,
      sym_expression,
    ACTIONS(309), 2,
      sym_ellipsis,
      sym_float,
    STATE(1017), 2,
      sym__expression_within_for_in_clause,
      sym_lambda_within_for_in_clause,
    ACTIONS(610), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(311), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(606), 5,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
    STATE(900), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(642), 15,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [14077] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(274), 1,
      sym_identifier,
    ACTIONS(278), 1,
      anon_sym_LPAREN,
    ACTIONS(293), 1,
      anon_sym_LBRACK,
    ACTIONS(295), 1,
      anon_sym_LBRACE,
    ACTIONS(299), 1,
      anon_sym_not,
    ACTIONS(305), 1,
      anon_sym_lambda,
    ACTIONS(313), 1,
      anon_sym_await,
    ACTIONS(315), 1,
      sym__string_start,
    ACTIONS(896), 1,
      anon_sym_COLON,
    STATE(600), 1,
      sym_string,
    STATE(630), 1,
      sym_primary_expression,
    STATE(1040), 1,
      sym_expression,
    STATE(1258), 1,
      sym_slice,
    ACTIONS(309), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(301), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(311), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(285), 5,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
    STATE(900), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(642), 15,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [14168] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(985), 12,
      sym__dedent,
      sym__string_start,
      anon_sym_LPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(987), 37,
      anon_sym_import,
      anon_sym_from,
      anon_sym_STAR,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_elif,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_match,
      anon_sym_case,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [14225] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(295), 1,
      anon_sym_LBRACE,
    ACTIONS(315), 1,
      sym__string_start,
    ACTIONS(602), 1,
      sym_identifier,
    ACTIONS(604), 1,
      anon_sym_LPAREN,
    ACTIONS(612), 1,
      anon_sym_LBRACK,
    ACTIONS(614), 1,
      anon_sym_not,
    ACTIONS(618), 1,
      anon_sym_await,
    ACTIONS(758), 1,
      anon_sym_lambda,
    STATE(600), 1,
      sym_string,
    STATE(643), 1,
      sym_primary_expression,
    STATE(958), 1,
      sym_expression,
    ACTIONS(309), 2,
      sym_ellipsis,
      sym_float,
    STATE(1033), 2,
      sym__expression_within_for_in_clause,
      sym_lambda_within_for_in_clause,
    ACTIONS(610), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(311), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(606), 5,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
    STATE(900), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(642), 15,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [14314] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1018), 12,
      sym__string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1016), 37,
      anon_sym_import,
      anon_sym_from,
      anon_sym_STAR,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_elif,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_match,
      anon_sym_case,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [14371] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(274), 1,
      sym_identifier,
    ACTIONS(278), 1,
      anon_sym_LPAREN,
    ACTIONS(293), 1,
      anon_sym_LBRACK,
    ACTIONS(295), 1,
      anon_sym_LBRACE,
    ACTIONS(299), 1,
      anon_sym_not,
    ACTIONS(305), 1,
      anon_sym_lambda,
    ACTIONS(313), 1,
      anon_sym_await,
    ACTIONS(315), 1,
      sym__string_start,
    ACTIONS(896), 1,
      anon_sym_COLON,
    STATE(600), 1,
      sym_string,
    STATE(630), 1,
      sym_primary_expression,
    STATE(1086), 1,
      sym_expression,
    STATE(1398), 1,
      sym_slice,
    ACTIONS(309), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(301), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(311), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(285), 5,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
    STATE(900), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(642), 15,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [14462] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(970), 12,
      sym__dedent,
      sym__string_start,
      anon_sym_LPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(972), 37,
      anon_sym_import,
      anon_sym_from,
      anon_sym_STAR,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_elif,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_match,
      anon_sym_case,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [14519] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1022), 13,
      sym__dedent,
      sym__string_start,
      anon_sym_LPAREN,
      anon_sym_except_STAR,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1020), 35,
      anon_sym_import,
      anon_sym_from,
      anon_sym_STAR,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_match,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [14575] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1026), 12,
      sym__dedent,
      sym__string_start,
      anon_sym_LPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1024), 36,
      anon_sym_import,
      anon_sym_from,
      anon_sym_STAR,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_except,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_match,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [14631] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1028), 13,
      sym__string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_except_STAR,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1030), 35,
      anon_sym_import,
      anon_sym_from,
      anon_sym_STAR,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_match,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [14687] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(991), 12,
      sym__string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(989), 36,
      anon_sym_import,
      anon_sym_from,
      anon_sym_STAR,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_except,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_match,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [14743] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1032), 12,
      sym__string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1034), 36,
      anon_sym_import,
      anon_sym_from,
      anon_sym_STAR,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_except,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_match,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [14799] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(274), 1,
      sym_identifier,
    ACTIONS(278), 1,
      anon_sym_LPAREN,
    ACTIONS(293), 1,
      anon_sym_LBRACK,
    ACTIONS(295), 1,
      anon_sym_LBRACE,
    ACTIONS(299), 1,
      anon_sym_not,
    ACTIONS(305), 1,
      anon_sym_lambda,
    ACTIONS(313), 1,
      anon_sym_await,
    ACTIONS(315), 1,
      sym__string_start,
    STATE(600), 1,
      sym_string,
    STATE(630), 1,
      sym_primary_expression,
    STATE(1022), 1,
      sym_expression,
    STATE(1483), 1,
      sym_type,
    ACTIONS(309), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(301), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(311), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(285), 5,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
    STATE(900), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(642), 15,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [14887] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(274), 1,
      sym_identifier,
    ACTIONS(278), 1,
      anon_sym_LPAREN,
    ACTIONS(293), 1,
      anon_sym_LBRACK,
    ACTIONS(295), 1,
      anon_sym_LBRACE,
    ACTIONS(299), 1,
      anon_sym_not,
    ACTIONS(305), 1,
      anon_sym_lambda,
    ACTIONS(313), 1,
      anon_sym_await,
    ACTIONS(315), 1,
      sym__string_start,
    STATE(600), 1,
      sym_string,
    STATE(630), 1,
      sym_primary_expression,
    STATE(1022), 1,
      sym_expression,
    STATE(1482), 1,
      sym_type,
    ACTIONS(309), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(301), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(311), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(285), 5,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
    STATE(900), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(642), 15,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [14975] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(274), 1,
      sym_identifier,
    ACTIONS(278), 1,
      anon_sym_LPAREN,
    ACTIONS(293), 1,
      anon_sym_LBRACK,
    ACTIONS(295), 1,
      anon_sym_LBRACE,
    ACTIONS(299), 1,
      anon_sym_not,
    ACTIONS(305), 1,
      anon_sym_lambda,
    ACTIONS(313), 1,
      anon_sym_await,
    ACTIONS(315), 1,
      sym__string_start,
    STATE(600), 1,
      sym_string,
    STATE(630), 1,
      sym_primary_expression,
    STATE(1022), 1,
      sym_expression,
    STATE(1480), 1,
      sym_type,
    ACTIONS(309), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(301), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(311), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(285), 5,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
    STATE(900), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(642), 15,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [15063] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(274), 1,
      sym_identifier,
    ACTIONS(278), 1,
      anon_sym_LPAREN,
    ACTIONS(293), 1,
      anon_sym_LBRACK,
    ACTIONS(295), 1,
      anon_sym_LBRACE,
    ACTIONS(299), 1,
      anon_sym_not,
    ACTIONS(305), 1,
      anon_sym_lambda,
    ACTIONS(313), 1,
      anon_sym_await,
    ACTIONS(315), 1,
      sym__string_start,
    STATE(600), 1,
      sym_string,
    STATE(630), 1,
      sym_primary_expression,
    STATE(1022), 1,
      sym_expression,
    STATE(1478), 1,
      sym_type,
    ACTIONS(309), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(301), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(311), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(285), 5,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
    STATE(900), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(642), 15,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [15151] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1036), 12,
      sym__string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1038), 36,
      anon_sym_import,
      anon_sym_from,
      anon_sym_STAR,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_except,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_match,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [15207] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(966), 12,
      sym__string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(968), 36,
      anon_sym_import,
      anon_sym_from,
      anon_sym_STAR,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_except,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_match,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [15263] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1022), 13,
      sym__string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_except_STAR,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1020), 35,
      anon_sym_import,
      anon_sym_from,
      anon_sym_STAR,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_match,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [15319] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1040), 12,
      sym__string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1042), 36,
      anon_sym_import,
      anon_sym_from,
      anon_sym_STAR,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_except,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_match,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [15375] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1044), 13,
      sym__string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_except_STAR,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1046), 35,
      anon_sym_import,
      anon_sym_from,
      anon_sym_STAR,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_match,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [15431] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1050), 1,
      anon_sym_COMMA,
    ACTIONS(1055), 1,
      anon_sym_COLON_EQ,
    ACTIONS(1057), 2,
      anon_sym_COLON,
      anon_sym_EQ,
    ACTIONS(1059), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    ACTIONS(1053), 15,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1048), 16,
      sym__newline,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym__semicolon,
  [15495] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1061), 13,
      sym__string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_except_STAR,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1063), 35,
      anon_sym_import,
      anon_sym_from,
      anon_sym_STAR,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_match,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [15551] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1026), 12,
      sym__string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1024), 36,
      anon_sym_import,
      anon_sym_from,
      anon_sym_STAR,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_except,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_match,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [15607] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1065), 12,
      sym__string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1067), 36,
      anon_sym_import,
      anon_sym_from,
      anon_sym_STAR,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_except,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_match,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [15663] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(280), 1,
      anon_sym_COMMA,
    ACTIONS(287), 1,
      anon_sym_COLON_EQ,
    ACTIONS(289), 2,
      anon_sym_COLON,
      anon_sym_EQ,
    ACTIONS(307), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    ACTIONS(276), 15,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(303), 16,
      sym__newline,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym__semicolon,
  [15727] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(622), 1,
      sym_identifier,
    ACTIONS(624), 1,
      anon_sym_LPAREN,
    ACTIONS(632), 1,
      anon_sym_LBRACK,
    ACTIONS(634), 1,
      anon_sym_LBRACE,
    ACTIONS(636), 1,
      anon_sym_not,
    ACTIONS(638), 1,
      anon_sym_lambda,
    ACTIONS(644), 1,
      anon_sym_await,
    ACTIONS(646), 1,
      sym__string_start,
    ACTIONS(1069), 1,
      anon_sym_COLON,
    STATE(740), 1,
      sym_primary_expression,
    STATE(742), 1,
      sym_string,
    STATE(1063), 1,
      sym_expression,
    ACTIONS(640), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(630), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(642), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(626), 5,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
    STATE(1015), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(811), 15,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [15815] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(824), 16,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(822), 32,
      sym__newline,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      sym__semicolon,
  [15871] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(824), 16,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(822), 32,
      sym__newline,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      sym__semicolon,
  [15927] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(568), 1,
      anon_sym_COLON_EQ,
    ACTIONS(570), 2,
      anon_sym_COLON,
      anon_sym_EQ,
    ACTIONS(565), 3,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(572), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    ACTIONS(303), 14,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
    ACTIONS(276), 15,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT,
      anon_sym_GT,
  [15991] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1074), 1,
      anon_sym_COLON_EQ,
    ACTIONS(1076), 2,
      anon_sym_COLON,
      anon_sym_EQ,
    ACTIONS(1071), 3,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(1078), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    ACTIONS(1048), 14,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
    ACTIONS(1053), 15,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT,
      anon_sym_GT,
  [16055] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1080), 12,
      sym__string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1082), 36,
      anon_sym_import,
      anon_sym_from,
      anon_sym_STAR,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_except,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_match,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [16111] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(274), 1,
      sym_identifier,
    ACTIONS(278), 1,
      anon_sym_LPAREN,
    ACTIONS(293), 1,
      anon_sym_LBRACK,
    ACTIONS(295), 1,
      anon_sym_LBRACE,
    ACTIONS(299), 1,
      anon_sym_not,
    ACTIONS(305), 1,
      anon_sym_lambda,
    ACTIONS(313), 1,
      anon_sym_await,
    ACTIONS(315), 1,
      sym__string_start,
    STATE(600), 1,
      sym_string,
    STATE(630), 1,
      sym_primary_expression,
    STATE(1022), 1,
      sym_expression,
    STATE(1485), 1,
      sym_type,
    ACTIONS(309), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(301), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(311), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(285), 5,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
    STATE(900), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(642), 15,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [16199] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(832), 16,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(830), 32,
      sym__newline,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      sym__semicolon,
  [16255] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(832), 16,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(830), 32,
      sym__newline,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      sym__semicolon,
  [16311] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(836), 16,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(834), 32,
      sym__newline,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      sym__semicolon,
  [16367] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1088), 1,
      anon_sym_case,
    STATE(349), 2,
      sym_case_block,
      aux_sym_cases_repeat1,
    ACTIONS(1086), 12,
      sym__dedent,
      sym__string_start,
      anon_sym_LPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1084), 33,
      anon_sym_import,
      anon_sym_from,
      anon_sym_STAR,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_match,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [16427] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(274), 1,
      sym_identifier,
    ACTIONS(278), 1,
      anon_sym_LPAREN,
    ACTIONS(293), 1,
      anon_sym_LBRACK,
    ACTIONS(295), 1,
      anon_sym_LBRACE,
    ACTIONS(299), 1,
      anon_sym_not,
    ACTIONS(305), 1,
      anon_sym_lambda,
    ACTIONS(313), 1,
      anon_sym_await,
    ACTIONS(315), 1,
      sym__string_start,
    STATE(600), 1,
      sym_string,
    STATE(630), 1,
      sym_primary_expression,
    STATE(1022), 1,
      sym_expression,
    STATE(1428), 1,
      sym_type,
    ACTIONS(309), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(301), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(311), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(285), 5,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
    STATE(900), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(642), 15,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [16515] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1094), 1,
      anon_sym_case,
    STATE(347), 2,
      sym_case_block,
      aux_sym_cases_repeat1,
    ACTIONS(1090), 12,
      sym__string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1092), 33,
      anon_sym_import,
      anon_sym_from,
      anon_sym_STAR,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_match,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [16575] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      anon_sym_not,
    ACTIONS(71), 1,
      anon_sym_lambda,
    ACTIONS(81), 1,
      sym__string_start,
    ACTIONS(331), 1,
      sym_identifier,
    ACTIONS(337), 1,
      anon_sym_await,
    ACTIONS(559), 1,
      anon_sym_LPAREN,
    ACTIONS(563), 1,
      anon_sym_LBRACK,
    STATE(684), 1,
      sym_primary_expression,
    STATE(713), 1,
      sym_string,
    STATE(1082), 1,
      sym_expression,
    STATE(1263), 1,
      sym_type,
    ACTIONS(75), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(47), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(77), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(333), 5,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
    STATE(1009), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(797), 15,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [16663] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1097), 1,
      anon_sym_case,
    STATE(349), 2,
      sym_case_block,
      aux_sym_cases_repeat1,
    ACTIONS(1090), 12,
      sym__dedent,
      sym__string_start,
      anon_sym_LPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1092), 33,
      anon_sym_import,
      anon_sym_from,
      anon_sym_STAR,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_match,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [16723] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(274), 1,
      sym_identifier,
    ACTIONS(278), 1,
      anon_sym_LPAREN,
    ACTIONS(293), 1,
      anon_sym_LBRACK,
    ACTIONS(295), 1,
      anon_sym_LBRACE,
    ACTIONS(299), 1,
      anon_sym_not,
    ACTIONS(305), 1,
      anon_sym_lambda,
    ACTIONS(313), 1,
      anon_sym_await,
    ACTIONS(315), 1,
      sym__string_start,
    STATE(600), 1,
      sym_string,
    STATE(630), 1,
      sym_primary_expression,
    STATE(1022), 1,
      sym_expression,
    STATE(1505), 1,
      sym_type,
    ACTIONS(309), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(301), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(311), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(285), 5,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
    STATE(900), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(642), 15,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [16811] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(622), 1,
      sym_identifier,
    ACTIONS(624), 1,
      anon_sym_LPAREN,
    ACTIONS(632), 1,
      anon_sym_LBRACK,
    ACTIONS(634), 1,
      anon_sym_LBRACE,
    ACTIONS(636), 1,
      anon_sym_not,
    ACTIONS(638), 1,
      anon_sym_lambda,
    ACTIONS(644), 1,
      anon_sym_await,
    ACTIONS(646), 1,
      sym__string_start,
    STATE(740), 1,
      sym_primary_expression,
    STATE(742), 1,
      sym_string,
    STATE(1050), 1,
      sym_expression,
    STATE(1308), 1,
      sym_with_item,
    ACTIONS(640), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(630), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(642), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(626), 5,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
    STATE(1015), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(811), 15,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [16899] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(828), 16,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(826), 32,
      sym__newline,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      sym__semicolon,
  [16955] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1080), 12,
      sym__dedent,
      sym__string_start,
      anon_sym_LPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1082), 36,
      anon_sym_import,
      anon_sym_from,
      anon_sym_STAR,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_except,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_match,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [17011] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(991), 13,
      sym__dedent,
      sym__string_start,
      anon_sym_LPAREN,
      anon_sym_except_STAR,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(989), 35,
      anon_sym_import,
      anon_sym_from,
      anon_sym_STAR,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_match,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [17067] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(970), 13,
      sym__dedent,
      sym__string_start,
      anon_sym_LPAREN,
      anon_sym_except_STAR,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(972), 35,
      anon_sym_import,
      anon_sym_from,
      anon_sym_STAR,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_match,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [17123] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(966), 13,
      sym__dedent,
      sym__string_start,
      anon_sym_LPAREN,
      anon_sym_except_STAR,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(968), 35,
      anon_sym_import,
      anon_sym_from,
      anon_sym_STAR,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_match,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [17179] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1065), 12,
      sym__dedent,
      sym__string_start,
      anon_sym_LPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1067), 36,
      anon_sym_import,
      anon_sym_from,
      anon_sym_STAR,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_except,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_match,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [17235] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1018), 13,
      sym__dedent,
      sym__string_start,
      anon_sym_LPAREN,
      anon_sym_except_STAR,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1016), 35,
      anon_sym_import,
      anon_sym_from,
      anon_sym_STAR,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_match,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [17291] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(991), 13,
      sym__string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_except_STAR,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(989), 35,
      anon_sym_import,
      anon_sym_from,
      anon_sym_STAR,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_match,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [17347] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1018), 12,
      sym__dedent,
      sym__string_start,
      anon_sym_LPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1016), 36,
      anon_sym_import,
      anon_sym_from,
      anon_sym_STAR,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_except,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_match,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [17403] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(274), 1,
      sym_identifier,
    ACTIONS(278), 1,
      anon_sym_LPAREN,
    ACTIONS(293), 1,
      anon_sym_LBRACK,
    ACTIONS(295), 1,
      anon_sym_LBRACE,
    ACTIONS(299), 1,
      anon_sym_not,
    ACTIONS(305), 1,
      anon_sym_lambda,
    ACTIONS(313), 1,
      anon_sym_await,
    ACTIONS(315), 1,
      sym__string_start,
    STATE(600), 1,
      sym_string,
    STATE(630), 1,
      sym_primary_expression,
    STATE(1022), 1,
      sym_expression,
    STATE(1133), 1,
      sym_type,
    ACTIONS(309), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(301), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(311), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(285), 5,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
    STATE(900), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(642), 15,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [17491] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1018), 13,
      sym__string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_except_STAR,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1016), 35,
      anon_sym_import,
      anon_sym_from,
      anon_sym_STAR,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_match,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [17547] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1044), 13,
      sym__dedent,
      sym__string_start,
      anon_sym_LPAREN,
      anon_sym_except_STAR,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1046), 35,
      anon_sym_import,
      anon_sym_from,
      anon_sym_STAR,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_match,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [17603] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(274), 1,
      sym_identifier,
    ACTIONS(278), 1,
      anon_sym_LPAREN,
    ACTIONS(293), 1,
      anon_sym_LBRACK,
    ACTIONS(295), 1,
      anon_sym_LBRACE,
    ACTIONS(299), 1,
      anon_sym_not,
    ACTIONS(305), 1,
      anon_sym_lambda,
    ACTIONS(313), 1,
      anon_sym_await,
    ACTIONS(315), 1,
      sym__string_start,
    STATE(600), 1,
      sym_string,
    STATE(630), 1,
      sym_primary_expression,
    STATE(1022), 1,
      sym_expression,
    STATE(1270), 1,
      sym_type,
    ACTIONS(309), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(301), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(311), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(285), 5,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
    STATE(900), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(642), 15,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [17691] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(840), 16,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(838), 32,
      sym__newline,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      sym__semicolon,
  [17747] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1040), 12,
      sym__dedent,
      sym__string_start,
      anon_sym_LPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1042), 36,
      anon_sym_import,
      anon_sym_from,
      anon_sym_STAR,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_except,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_match,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [17803] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(985), 13,
      sym__string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_except_STAR,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(987), 35,
      anon_sym_import,
      anon_sym_from,
      anon_sym_STAR,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_match,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [17859] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(274), 1,
      sym_identifier,
    ACTIONS(278), 1,
      anon_sym_LPAREN,
    ACTIONS(293), 1,
      anon_sym_LBRACK,
    ACTIONS(295), 1,
      anon_sym_LBRACE,
    ACTIONS(299), 1,
      anon_sym_not,
    ACTIONS(305), 1,
      anon_sym_lambda,
    ACTIONS(313), 1,
      anon_sym_await,
    ACTIONS(315), 1,
      sym__string_start,
    STATE(600), 1,
      sym_string,
    STATE(630), 1,
      sym_primary_expression,
    STATE(1022), 1,
      sym_expression,
    STATE(1491), 1,
      sym_type,
    ACTIONS(309), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(301), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(311), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(285), 5,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
    STATE(900), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(642), 15,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [17947] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1018), 12,
      sym__string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1016), 36,
      anon_sym_import,
      anon_sym_from,
      anon_sym_STAR,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_except,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_match,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [18003] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(966), 12,
      sym__dedent,
      sym__string_start,
      anon_sym_LPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(968), 36,
      anon_sym_import,
      anon_sym_from,
      anon_sym_STAR,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_except,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_match,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [18059] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(970), 13,
      sym__string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_except_STAR,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(972), 35,
      anon_sym_import,
      anon_sym_from,
      anon_sym_STAR,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_match,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [18115] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1028), 13,
      sym__dedent,
      sym__string_start,
      anon_sym_LPAREN,
      anon_sym_except_STAR,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1030), 35,
      anon_sym_import,
      anon_sym_from,
      anon_sym_STAR,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_match,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [18171] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1032), 12,
      sym__dedent,
      sym__string_start,
      anon_sym_LPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1034), 36,
      anon_sym_import,
      anon_sym_from,
      anon_sym_STAR,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_except,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_match,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [18227] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(985), 13,
      sym__dedent,
      sym__string_start,
      anon_sym_LPAREN,
      anon_sym_except_STAR,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(987), 35,
      anon_sym_import,
      anon_sym_from,
      anon_sym_STAR,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_match,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [18283] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(985), 12,
      sym__string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(987), 36,
      anon_sym_import,
      anon_sym_from,
      anon_sym_STAR,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_except,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_match,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [18339] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(966), 13,
      sym__string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_except_STAR,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(968), 35,
      anon_sym_import,
      anon_sym_from,
      anon_sym_STAR,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_match,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [18395] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1036), 12,
      sym__dedent,
      sym__string_start,
      anon_sym_LPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1038), 36,
      anon_sym_import,
      anon_sym_from,
      anon_sym_STAR,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_except,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_match,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [18451] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(985), 12,
      sym__dedent,
      sym__string_start,
      anon_sym_LPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(987), 36,
      anon_sym_import,
      anon_sym_from,
      anon_sym_STAR,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_except,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_match,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [18507] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(970), 12,
      sym__dedent,
      sym__string_start,
      anon_sym_LPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(972), 36,
      anon_sym_import,
      anon_sym_from,
      anon_sym_STAR,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_except,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_match,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [18563] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1100), 1,
      anon_sym_case,
    STATE(347), 2,
      sym_case_block,
      aux_sym_cases_repeat1,
    ACTIONS(1086), 12,
      sym__string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1084), 33,
      anon_sym_import,
      anon_sym_from,
      anon_sym_STAR,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_match,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [18623] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(991), 12,
      sym__dedent,
      sym__string_start,
      anon_sym_LPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(989), 36,
      anon_sym_import,
      anon_sym_from,
      anon_sym_STAR,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_except,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_match,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [18679] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(970), 12,
      sym__string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(972), 36,
      anon_sym_import,
      anon_sym_from,
      anon_sym_STAR,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_except,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_match,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [18735] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(622), 1,
      sym_identifier,
    ACTIONS(624), 1,
      anon_sym_LPAREN,
    ACTIONS(632), 1,
      anon_sym_LBRACK,
    ACTIONS(634), 1,
      anon_sym_LBRACE,
    ACTIONS(636), 1,
      anon_sym_not,
    ACTIONS(638), 1,
      anon_sym_lambda,
    ACTIONS(644), 1,
      anon_sym_await,
    ACTIONS(646), 1,
      sym__string_start,
    ACTIONS(1102), 1,
      anon_sym_COLON,
    STATE(740), 1,
      sym_primary_expression,
    STATE(742), 1,
      sym_string,
    STATE(1081), 1,
      sym_expression,
    ACTIONS(640), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(630), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(642), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(626), 5,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
    STATE(1015), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(811), 15,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [18823] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1061), 13,
      sym__dedent,
      sym__string_start,
      anon_sym_LPAREN,
      anon_sym_except_STAR,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1063), 35,
      anon_sym_import,
      anon_sym_from,
      anon_sym_STAR,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_match,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [18879] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      anon_sym_not,
    ACTIONS(71), 1,
      anon_sym_lambda,
    ACTIONS(81), 1,
      sym__string_start,
    ACTIONS(331), 1,
      sym_identifier,
    ACTIONS(337), 1,
      anon_sym_await,
    ACTIONS(559), 1,
      anon_sym_LPAREN,
    ACTIONS(563), 1,
      anon_sym_LBRACK,
    STATE(684), 1,
      sym_primary_expression,
    STATE(713), 1,
      sym_string,
    STATE(980), 1,
      sym_expression,
    ACTIONS(75), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(47), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(77), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(333), 5,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
    STATE(1009), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(797), 15,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [18964] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(274), 1,
      sym_identifier,
    ACTIONS(278), 1,
      anon_sym_LPAREN,
    ACTIONS(293), 1,
      anon_sym_LBRACK,
    ACTIONS(295), 1,
      anon_sym_LBRACE,
    ACTIONS(299), 1,
      anon_sym_not,
    ACTIONS(305), 1,
      anon_sym_lambda,
    ACTIONS(313), 1,
      anon_sym_await,
    ACTIONS(315), 1,
      sym__string_start,
    STATE(600), 1,
      sym_string,
    STATE(630), 1,
      sym_primary_expression,
    STATE(1186), 1,
      sym_expression,
    ACTIONS(309), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(301), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(311), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(285), 5,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
    STATE(900), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(642), 15,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [19049] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(846), 1,
      anon_sym_else,
    STATE(545), 1,
      sym_else_clause,
    ACTIONS(1104), 12,
      sym__string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1106), 33,
      anon_sym_import,
      anon_sym_from,
      anon_sym_STAR,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_match,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [19108] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1108), 12,
      sym__string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1110), 35,
      anon_sym_import,
      anon_sym_from,
      anon_sym_STAR,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_elif,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_match,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [19163] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(274), 1,
      sym_identifier,
    ACTIONS(278), 1,
      anon_sym_LPAREN,
    ACTIONS(293), 1,
      anon_sym_LBRACK,
    ACTIONS(295), 1,
      anon_sym_LBRACE,
    ACTIONS(299), 1,
      anon_sym_not,
    ACTIONS(305), 1,
      anon_sym_lambda,
    ACTIONS(313), 1,
      anon_sym_await,
    ACTIONS(315), 1,
      sym__string_start,
    STATE(600), 1,
      sym_string,
    STATE(630), 1,
      sym_primary_expression,
    STATE(919), 1,
      sym_expression,
    ACTIONS(309), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(301), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(311), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(285), 5,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
    STATE(900), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(642), 15,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [19248] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(295), 1,
      anon_sym_LBRACE,
    ACTIONS(315), 1,
      sym__string_start,
    ACTIONS(602), 1,
      sym_identifier,
    ACTIONS(604), 1,
      anon_sym_LPAREN,
    ACTIONS(612), 1,
      anon_sym_LBRACK,
    ACTIONS(614), 1,
      anon_sym_not,
    ACTIONS(616), 1,
      anon_sym_lambda,
    ACTIONS(618), 1,
      anon_sym_await,
    STATE(600), 1,
      sym_string,
    STATE(643), 1,
      sym_primary_expression,
    STATE(994), 1,
      sym_expression,
    ACTIONS(309), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(610), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(311), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(606), 5,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
    STATE(900), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(642), 15,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [19333] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(295), 1,
      anon_sym_LBRACE,
    ACTIONS(315), 1,
      sym__string_start,
    ACTIONS(602), 1,
      sym_identifier,
    ACTIONS(604), 1,
      anon_sym_LPAREN,
    ACTIONS(612), 1,
      anon_sym_LBRACK,
    ACTIONS(614), 1,
      anon_sym_not,
    ACTIONS(616), 1,
      anon_sym_lambda,
    ACTIONS(618), 1,
      anon_sym_await,
    STATE(600), 1,
      sym_string,
    STATE(643), 1,
      sym_primary_expression,
    STATE(904), 1,
      sym_expression,
    ACTIONS(309), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(610), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(311), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(606), 5,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
    STATE(900), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(642), 15,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [19418] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(622), 1,
      sym_identifier,
    ACTIONS(624), 1,
      anon_sym_LPAREN,
    ACTIONS(632), 1,
      anon_sym_LBRACK,
    ACTIONS(634), 1,
      anon_sym_LBRACE,
    ACTIONS(636), 1,
      anon_sym_not,
    ACTIONS(638), 1,
      anon_sym_lambda,
    ACTIONS(644), 1,
      anon_sym_await,
    ACTIONS(646), 1,
      sym__string_start,
    STATE(740), 1,
      sym_primary_expression,
    STATE(742), 1,
      sym_string,
    STATE(1028), 1,
      sym_expression,
    ACTIONS(640), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(630), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(642), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(626), 5,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
    STATE(1015), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(811), 15,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [19503] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(278), 1,
      anon_sym_LPAREN,
    ACTIONS(293), 1,
      anon_sym_LBRACK,
    ACTIONS(295), 1,
      anon_sym_LBRACE,
    ACTIONS(299), 1,
      anon_sym_not,
    ACTIONS(305), 1,
      anon_sym_lambda,
    ACTIONS(315), 1,
      sym__string_start,
    ACTIONS(1112), 1,
      sym_identifier,
    ACTIONS(1116), 1,
      anon_sym_await,
    STATE(600), 1,
      sym_string,
    STATE(630), 1,
      sym_primary_expression,
    STATE(948), 1,
      sym_expression,
    ACTIONS(309), 2,
      sym_ellipsis,
      sym_float,
    STATE(449), 2,
      sym_attribute,
      sym_subscript,
    ACTIONS(301), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(311), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1114), 5,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
    STATE(900), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(642), 13,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [19590] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      anon_sym_not,
    ACTIONS(71), 1,
      anon_sym_lambda,
    ACTIONS(81), 1,
      sym__string_start,
    ACTIONS(331), 1,
      sym_identifier,
    ACTIONS(337), 1,
      anon_sym_await,
    ACTIONS(559), 1,
      anon_sym_LPAREN,
    ACTIONS(563), 1,
      anon_sym_LBRACK,
    STATE(684), 1,
      sym_primary_expression,
    STATE(713), 1,
      sym_string,
    STATE(1044), 1,
      sym_expression,
    ACTIONS(75), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(47), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(77), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(333), 5,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
    STATE(1009), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(797), 15,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [19675] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(622), 1,
      sym_identifier,
    ACTIONS(624), 1,
      anon_sym_LPAREN,
    ACTIONS(632), 1,
      anon_sym_LBRACK,
    ACTIONS(634), 1,
      anon_sym_LBRACE,
    ACTIONS(636), 1,
      anon_sym_not,
    ACTIONS(638), 1,
      anon_sym_lambda,
    ACTIONS(644), 1,
      anon_sym_await,
    ACTIONS(646), 1,
      sym__string_start,
    STATE(740), 1,
      sym_primary_expression,
    STATE(742), 1,
      sym_string,
    STATE(1029), 1,
      sym_expression,
    ACTIONS(640), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(630), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(642), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(626), 5,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
    STATE(1015), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(811), 15,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [19760] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(622), 1,
      sym_identifier,
    ACTIONS(624), 1,
      anon_sym_LPAREN,
    ACTIONS(632), 1,
      anon_sym_LBRACK,
    ACTIONS(634), 1,
      anon_sym_LBRACE,
    ACTIONS(636), 1,
      anon_sym_not,
    ACTIONS(638), 1,
      anon_sym_lambda,
    ACTIONS(644), 1,
      anon_sym_await,
    ACTIONS(646), 1,
      sym__string_start,
    STATE(740), 1,
      sym_primary_expression,
    STATE(742), 1,
      sym_string,
    STATE(1030), 1,
      sym_expression,
    ACTIONS(640), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(630), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(642), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(626), 5,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
    STATE(1015), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(811), 15,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [19845] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(622), 1,
      sym_identifier,
    ACTIONS(624), 1,
      anon_sym_LPAREN,
    ACTIONS(632), 1,
      anon_sym_LBRACK,
    ACTIONS(634), 1,
      anon_sym_LBRACE,
    ACTIONS(636), 1,
      anon_sym_not,
    ACTIONS(638), 1,
      anon_sym_lambda,
    ACTIONS(644), 1,
      anon_sym_await,
    ACTIONS(646), 1,
      sym__string_start,
    STATE(740), 1,
      sym_primary_expression,
    STATE(742), 1,
      sym_string,
    STATE(1032), 1,
      sym_expression,
    ACTIONS(640), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(630), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(642), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(626), 5,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
    STATE(1015), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(811), 15,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [19930] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(274), 1,
      sym_identifier,
    ACTIONS(278), 1,
      anon_sym_LPAREN,
    ACTIONS(293), 1,
      anon_sym_LBRACK,
    ACTIONS(295), 1,
      anon_sym_LBRACE,
    ACTIONS(299), 1,
      anon_sym_not,
    ACTIONS(305), 1,
      anon_sym_lambda,
    ACTIONS(313), 1,
      anon_sym_await,
    ACTIONS(315), 1,
      sym__string_start,
    STATE(600), 1,
      sym_string,
    STATE(630), 1,
      sym_primary_expression,
    STATE(1134), 1,
      sym_expression,
    ACTIONS(309), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(301), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(311), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(285), 5,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
    STATE(900), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(642), 15,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [20015] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(274), 1,
      sym_identifier,
    ACTIONS(278), 1,
      anon_sym_LPAREN,
    ACTIONS(293), 1,
      anon_sym_LBRACK,
    ACTIONS(295), 1,
      anon_sym_LBRACE,
    ACTIONS(299), 1,
      anon_sym_not,
    ACTIONS(305), 1,
      anon_sym_lambda,
    ACTIONS(313), 1,
      anon_sym_await,
    ACTIONS(315), 1,
      sym__string_start,
    STATE(600), 1,
      sym_string,
    STATE(630), 1,
      sym_primary_expression,
    STATE(1135), 1,
      sym_expression,
    ACTIONS(309), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(301), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(311), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(285), 5,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
    STATE(900), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(642), 15,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [20100] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(274), 1,
      sym_identifier,
    ACTIONS(278), 1,
      anon_sym_LPAREN,
    ACTIONS(293), 1,
      anon_sym_LBRACK,
    ACTIONS(295), 1,
      anon_sym_LBRACE,
    ACTIONS(299), 1,
      anon_sym_not,
    ACTIONS(305), 1,
      anon_sym_lambda,
    ACTIONS(313), 1,
      anon_sym_await,
    ACTIONS(315), 1,
      sym__string_start,
    STATE(600), 1,
      sym_string,
    STATE(630), 1,
      sym_primary_expression,
    STATE(1151), 1,
      sym_expression,
    ACTIONS(309), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(301), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(311), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(285), 5,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
    STATE(900), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(642), 15,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [20185] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(846), 1,
      anon_sym_else,
    STATE(500), 1,
      sym_else_clause,
    ACTIONS(1118), 12,
      sym__string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1120), 33,
      anon_sym_import,
      anon_sym_from,
      anon_sym_STAR,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_match,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [20244] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(622), 1,
      sym_identifier,
    ACTIONS(624), 1,
      anon_sym_LPAREN,
    ACTIONS(632), 1,
      anon_sym_LBRACK,
    ACTIONS(634), 1,
      anon_sym_LBRACE,
    ACTIONS(636), 1,
      anon_sym_not,
    ACTIONS(638), 1,
      anon_sym_lambda,
    ACTIONS(644), 1,
      anon_sym_await,
    ACTIONS(646), 1,
      sym__string_start,
    STATE(740), 1,
      sym_primary_expression,
    STATE(742), 1,
      sym_string,
    STATE(1104), 1,
      sym_expression,
    ACTIONS(640), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(630), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(642), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(626), 5,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
    STATE(1015), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(811), 15,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [20329] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1124), 12,
      sym__dedent,
      sym__string_start,
      anon_sym_LPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1122), 35,
      anon_sym_import,
      anon_sym_from,
      anon_sym_STAR,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_elif,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_match,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [20384] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(274), 1,
      sym_identifier,
    ACTIONS(278), 1,
      anon_sym_LPAREN,
    ACTIONS(293), 1,
      anon_sym_LBRACK,
    ACTIONS(295), 1,
      anon_sym_LBRACE,
    ACTIONS(299), 1,
      anon_sym_not,
    ACTIONS(305), 1,
      anon_sym_lambda,
    ACTIONS(313), 1,
      anon_sym_await,
    ACTIONS(315), 1,
      sym__string_start,
    STATE(600), 1,
      sym_string,
    STATE(630), 1,
      sym_primary_expression,
    STATE(1153), 1,
      sym_expression,
    ACTIONS(309), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(301), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(311), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(285), 5,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
    STATE(900), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(642), 15,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [20469] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(622), 1,
      sym_identifier,
    ACTIONS(624), 1,
      anon_sym_LPAREN,
    ACTIONS(632), 1,
      anon_sym_LBRACK,
    ACTIONS(634), 1,
      anon_sym_LBRACE,
    ACTIONS(636), 1,
      anon_sym_not,
    ACTIONS(638), 1,
      anon_sym_lambda,
    ACTIONS(644), 1,
      anon_sym_await,
    ACTIONS(646), 1,
      sym__string_start,
    STATE(740), 1,
      sym_primary_expression,
    STATE(742), 1,
      sym_string,
    STATE(1035), 1,
      sym_expression,
    ACTIONS(640), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(630), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(642), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(626), 5,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
    STATE(1015), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(811), 15,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [20554] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(274), 1,
      sym_identifier,
    ACTIONS(278), 1,
      anon_sym_LPAREN,
    ACTIONS(293), 1,
      anon_sym_LBRACK,
    ACTIONS(295), 1,
      anon_sym_LBRACE,
    ACTIONS(299), 1,
      anon_sym_not,
    ACTIONS(305), 1,
      anon_sym_lambda,
    ACTIONS(313), 1,
      anon_sym_await,
    ACTIONS(315), 1,
      sym__string_start,
    STATE(600), 1,
      sym_string,
    STATE(630), 1,
      sym_primary_expression,
    STATE(947), 1,
      sym_expression,
    ACTIONS(309), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(301), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(311), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(285), 5,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
    STATE(900), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(642), 15,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [20639] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1124), 12,
      sym__string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1122), 35,
      anon_sym_import,
      anon_sym_from,
      anon_sym_STAR,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_elif,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_match,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [20694] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(846), 1,
      anon_sym_else,
    STATE(519), 1,
      sym_else_clause,
    ACTIONS(1126), 12,
      sym__string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1128), 33,
      anon_sym_import,
      anon_sym_from,
      anon_sym_STAR,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_match,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [20753] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(274), 1,
      sym_identifier,
    ACTIONS(278), 1,
      anon_sym_LPAREN,
    ACTIONS(293), 1,
      anon_sym_LBRACK,
    ACTIONS(295), 1,
      anon_sym_LBRACE,
    ACTIONS(299), 1,
      anon_sym_not,
    ACTIONS(305), 1,
      anon_sym_lambda,
    ACTIONS(313), 1,
      anon_sym_await,
    ACTIONS(315), 1,
      sym__string_start,
    STATE(600), 1,
      sym_string,
    STATE(630), 1,
      sym_primary_expression,
    STATE(916), 1,
      sym_expression,
    ACTIONS(309), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(301), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(311), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(285), 5,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
    STATE(900), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(642), 15,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [20838] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      anon_sym_not,
    ACTIONS(71), 1,
      anon_sym_lambda,
    ACTIONS(81), 1,
      sym__string_start,
    ACTIONS(331), 1,
      sym_identifier,
    ACTIONS(337), 1,
      anon_sym_await,
    ACTIONS(559), 1,
      anon_sym_LPAREN,
    ACTIONS(563), 1,
      anon_sym_LBRACK,
    STATE(684), 1,
      sym_primary_expression,
    STATE(713), 1,
      sym_string,
    STATE(1000), 1,
      sym_expression,
    ACTIONS(75), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(47), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(77), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(333), 5,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
    STATE(1009), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(797), 15,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [20923] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      anon_sym_not,
    ACTIONS(71), 1,
      anon_sym_lambda,
    ACTIONS(81), 1,
      sym__string_start,
    ACTIONS(331), 1,
      sym_identifier,
    ACTIONS(337), 1,
      anon_sym_await,
    ACTIONS(559), 1,
      anon_sym_LPAREN,
    ACTIONS(563), 1,
      anon_sym_LBRACK,
    STATE(684), 1,
      sym_primary_expression,
    STATE(713), 1,
      sym_string,
    STATE(1001), 1,
      sym_expression,
    ACTIONS(75), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(47), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(77), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(333), 5,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
    STATE(1009), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(797), 15,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [21008] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(274), 1,
      sym_identifier,
    ACTIONS(278), 1,
      anon_sym_LPAREN,
    ACTIONS(293), 1,
      anon_sym_LBRACK,
    ACTIONS(295), 1,
      anon_sym_LBRACE,
    ACTIONS(299), 1,
      anon_sym_not,
    ACTIONS(305), 1,
      anon_sym_lambda,
    ACTIONS(313), 1,
      anon_sym_await,
    ACTIONS(315), 1,
      sym__string_start,
    STATE(600), 1,
      sym_string,
    STATE(630), 1,
      sym_primary_expression,
    STATE(1136), 1,
      sym_expression,
    ACTIONS(309), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(301), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(311), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(285), 5,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
    STATE(900), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(642), 15,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [21093] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(856), 1,
      anon_sym_finally,
    STATE(591), 1,
      sym_finally_clause,
    ACTIONS(1132), 12,
      sym__dedent,
      sym__string_start,
      anon_sym_LPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1130), 33,
      anon_sym_import,
      anon_sym_from,
      anon_sym_STAR,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_match,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [21152] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(852), 1,
      anon_sym_else,
    STATE(593), 1,
      sym_else_clause,
    ACTIONS(1126), 12,
      sym__dedent,
      sym__string_start,
      anon_sym_LPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1128), 33,
      anon_sym_import,
      anon_sym_from,
      anon_sym_STAR,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_match,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [21211] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(274), 1,
      sym_identifier,
    ACTIONS(278), 1,
      anon_sym_LPAREN,
    ACTIONS(293), 1,
      anon_sym_LBRACK,
    ACTIONS(295), 1,
      anon_sym_LBRACE,
    ACTIONS(299), 1,
      anon_sym_not,
    ACTIONS(305), 1,
      anon_sym_lambda,
    ACTIONS(313), 1,
      anon_sym_await,
    ACTIONS(315), 1,
      sym__string_start,
    STATE(600), 1,
      sym_string,
    STATE(630), 1,
      sym_primary_expression,
    STATE(1169), 1,
      sym_expression,
    ACTIONS(309), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(301), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(311), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(285), 5,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
    STATE(900), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(642), 15,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [21296] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(622), 1,
      sym_identifier,
    ACTIONS(624), 1,
      anon_sym_LPAREN,
    ACTIONS(632), 1,
      anon_sym_LBRACK,
    ACTIONS(634), 1,
      anon_sym_LBRACE,
    ACTIONS(636), 1,
      anon_sym_not,
    ACTIONS(638), 1,
      anon_sym_lambda,
    ACTIONS(644), 1,
      anon_sym_await,
    ACTIONS(646), 1,
      sym__string_start,
    STATE(740), 1,
      sym_primary_expression,
    STATE(742), 1,
      sym_string,
    STATE(1123), 1,
      sym_expression,
    ACTIONS(640), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(630), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(642), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(626), 5,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
    STATE(1015), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(811), 15,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [21381] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      anon_sym_not,
    ACTIONS(71), 1,
      anon_sym_lambda,
    ACTIONS(81), 1,
      sym__string_start,
    ACTIONS(331), 1,
      sym_identifier,
    ACTIONS(337), 1,
      anon_sym_await,
    ACTIONS(559), 1,
      anon_sym_LPAREN,
    ACTIONS(563), 1,
      anon_sym_LBRACK,
    STATE(684), 1,
      sym_primary_expression,
    STATE(713), 1,
      sym_string,
    STATE(1156), 1,
      sym_expression,
    ACTIONS(75), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(47), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(77), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(333), 5,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
    STATE(1009), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(797), 15,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [21466] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(852), 1,
      anon_sym_else,
    STATE(510), 1,
      sym_else_clause,
    ACTIONS(1104), 12,
      sym__dedent,
      sym__string_start,
      anon_sym_LPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1106), 33,
      anon_sym_import,
      anon_sym_from,
      anon_sym_STAR,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_match,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [21525] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      anon_sym_not,
    ACTIONS(71), 1,
      anon_sym_lambda,
    ACTIONS(81), 1,
      sym__string_start,
    ACTIONS(331), 1,
      sym_identifier,
    ACTIONS(337), 1,
      anon_sym_await,
    ACTIONS(559), 1,
      anon_sym_LPAREN,
    ACTIONS(563), 1,
      anon_sym_LBRACK,
    STATE(684), 1,
      sym_primary_expression,
    STATE(713), 1,
      sym_string,
    STATE(967), 1,
      sym_expression,
    ACTIONS(75), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(47), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(77), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(333), 5,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
    STATE(1009), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(797), 15,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [21610] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1136), 12,
      sym__dedent,
      sym__string_start,
      anon_sym_LPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1134), 35,
      anon_sym_import,
      anon_sym_from,
      anon_sym_STAR,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_elif,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_match,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [21665] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1108), 12,
      sym__dedent,
      sym__string_start,
      anon_sym_LPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1110), 35,
      anon_sym_import,
      anon_sym_from,
      anon_sym_STAR,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_elif,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_match,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [21720] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      anon_sym_not,
    ACTIONS(71), 1,
      anon_sym_lambda,
    ACTIONS(81), 1,
      sym__string_start,
    ACTIONS(331), 1,
      sym_identifier,
    ACTIONS(337), 1,
      anon_sym_await,
    ACTIONS(559), 1,
      anon_sym_LPAREN,
    ACTIONS(563), 1,
      anon_sym_LBRACK,
    STATE(684), 1,
      sym_primary_expression,
    STATE(713), 1,
      sym_string,
    STATE(974), 1,
      sym_expression,
    ACTIONS(75), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(47), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(77), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(333), 5,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
    STATE(1009), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(797), 15,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [21805] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(274), 1,
      sym_identifier,
    ACTIONS(278), 1,
      anon_sym_LPAREN,
    ACTIONS(293), 1,
      anon_sym_LBRACK,
    ACTIONS(295), 1,
      anon_sym_LBRACE,
    ACTIONS(299), 1,
      anon_sym_not,
    ACTIONS(305), 1,
      anon_sym_lambda,
    ACTIONS(313), 1,
      anon_sym_await,
    ACTIONS(315), 1,
      sym__string_start,
    STATE(600), 1,
      sym_string,
    STATE(630), 1,
      sym_primary_expression,
    STATE(1140), 1,
      sym_expression,
    ACTIONS(309), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(301), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(311), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(285), 5,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
    STATE(900), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(642), 15,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [21890] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(274), 1,
      sym_identifier,
    ACTIONS(278), 1,
      anon_sym_LPAREN,
    ACTIONS(293), 1,
      anon_sym_LBRACK,
    ACTIONS(295), 1,
      anon_sym_LBRACE,
    ACTIONS(299), 1,
      anon_sym_not,
    ACTIONS(305), 1,
      anon_sym_lambda,
    ACTIONS(313), 1,
      anon_sym_await,
    ACTIONS(315), 1,
      sym__string_start,
    STATE(600), 1,
      sym_string,
    STATE(630), 1,
      sym_primary_expression,
    STATE(1141), 1,
      sym_expression,
    ACTIONS(309), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(301), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(311), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(285), 5,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
    STATE(900), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(642), 15,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [21975] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      anon_sym_not,
    ACTIONS(71), 1,
      anon_sym_lambda,
    ACTIONS(81), 1,
      sym__string_start,
    ACTIONS(331), 1,
      sym_identifier,
    ACTIONS(337), 1,
      anon_sym_await,
    ACTIONS(559), 1,
      anon_sym_LPAREN,
    ACTIONS(563), 1,
      anon_sym_LBRACK,
    STATE(684), 1,
      sym_primary_expression,
    STATE(713), 1,
      sym_string,
    STATE(1094), 1,
      sym_expression,
    ACTIONS(75), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(47), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(77), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(333), 5,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
    STATE(1009), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(797), 15,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [22060] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(274), 1,
      sym_identifier,
    ACTIONS(278), 1,
      anon_sym_LPAREN,
    ACTIONS(293), 1,
      anon_sym_LBRACK,
    ACTIONS(295), 1,
      anon_sym_LBRACE,
    ACTIONS(299), 1,
      anon_sym_not,
    ACTIONS(305), 1,
      anon_sym_lambda,
    ACTIONS(313), 1,
      anon_sym_await,
    ACTIONS(315), 1,
      sym__string_start,
    STATE(600), 1,
      sym_string,
    STATE(630), 1,
      sym_primary_expression,
    STATE(1149), 1,
      sym_expression,
    ACTIONS(309), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(301), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(311), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(285), 5,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
    STATE(900), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(642), 15,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [22145] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(846), 1,
      anon_sym_else,
    STATE(511), 1,
      sym_else_clause,
    ACTIONS(1138), 12,
      sym__string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1140), 33,
      anon_sym_import,
      anon_sym_from,
      anon_sym_STAR,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_match,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [22204] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(852), 1,
      anon_sym_else,
    STATE(539), 1,
      sym_else_clause,
    ACTIONS(1138), 12,
      sym__dedent,
      sym__string_start,
      anon_sym_LPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1140), 33,
      anon_sym_import,
      anon_sym_from,
      anon_sym_STAR,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_match,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [22263] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(274), 1,
      sym_identifier,
    ACTIONS(278), 1,
      anon_sym_LPAREN,
    ACTIONS(293), 1,
      anon_sym_LBRACK,
    ACTIONS(295), 1,
      anon_sym_LBRACE,
    ACTIONS(299), 1,
      anon_sym_not,
    ACTIONS(305), 1,
      anon_sym_lambda,
    ACTIONS(313), 1,
      anon_sym_await,
    ACTIONS(315), 1,
      sym__string_start,
    STATE(600), 1,
      sym_string,
    STATE(630), 1,
      sym_primary_expression,
    STATE(1152), 1,
      sym_expression,
    ACTIONS(309), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(301), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(311), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(285), 5,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
    STATE(900), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(642), 15,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [22348] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(846), 1,
      anon_sym_else,
    STATE(503), 1,
      sym_else_clause,
    ACTIONS(1142), 12,
      sym__string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1144), 33,
      anon_sym_import,
      anon_sym_from,
      anon_sym_STAR,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_match,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [22407] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1050), 1,
      anon_sym_COMMA,
    ACTIONS(1057), 1,
      anon_sym_EQ,
    ACTIONS(1059), 14,
      anon_sym_COLON,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    ACTIONS(1053), 15,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1048), 16,
      sym__newline,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym__semicolon,
  [22468] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(852), 1,
      anon_sym_else,
    STATE(551), 1,
      sym_else_clause,
    ACTIONS(1142), 12,
      sym__dedent,
      sym__string_start,
      anon_sym_LPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1144), 33,
      anon_sym_import,
      anon_sym_from,
      anon_sym_STAR,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_match,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [22527] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1136), 12,
      sym__string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1134), 35,
      anon_sym_import,
      anon_sym_from,
      anon_sym_STAR,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_elif,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_match,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [22582] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(274), 1,
      sym_identifier,
    ACTIONS(278), 1,
      anon_sym_LPAREN,
    ACTIONS(293), 1,
      anon_sym_LBRACK,
    ACTIONS(295), 1,
      anon_sym_LBRACE,
    ACTIONS(299), 1,
      anon_sym_not,
    ACTIONS(305), 1,
      anon_sym_lambda,
    ACTIONS(313), 1,
      anon_sym_await,
    ACTIONS(315), 1,
      sym__string_start,
    STATE(600), 1,
      sym_string,
    STATE(630), 1,
      sym_primary_expression,
    STATE(1098), 1,
      sym_expression,
    ACTIONS(309), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(301), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(311), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(285), 5,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
    STATE(900), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(642), 15,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [22667] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      anon_sym_not,
    ACTIONS(71), 1,
      anon_sym_lambda,
    ACTIONS(81), 1,
      sym__string_start,
    ACTIONS(331), 1,
      sym_identifier,
    ACTIONS(337), 1,
      anon_sym_await,
    ACTIONS(559), 1,
      anon_sym_LPAREN,
    ACTIONS(563), 1,
      anon_sym_LBRACK,
    STATE(684), 1,
      sym_primary_expression,
    STATE(713), 1,
      sym_string,
    STATE(1121), 1,
      sym_expression,
    ACTIONS(75), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(47), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(77), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(333), 5,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
    STATE(1009), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(797), 15,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [22752] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(274), 1,
      sym_identifier,
    ACTIONS(278), 1,
      anon_sym_LPAREN,
    ACTIONS(293), 1,
      anon_sym_LBRACK,
    ACTIONS(295), 1,
      anon_sym_LBRACE,
    ACTIONS(299), 1,
      anon_sym_not,
    ACTIONS(305), 1,
      anon_sym_lambda,
    ACTIONS(313), 1,
      anon_sym_await,
    ACTIONS(315), 1,
      sym__string_start,
    STATE(600), 1,
      sym_string,
    STATE(630), 1,
      sym_primary_expression,
    STATE(908), 1,
      sym_expression,
    ACTIONS(309), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(301), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(311), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(285), 5,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
    STATE(900), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(642), 15,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [22837] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      anon_sym_not,
    ACTIONS(71), 1,
      anon_sym_lambda,
    ACTIONS(81), 1,
      sym__string_start,
    ACTIONS(331), 1,
      sym_identifier,
    ACTIONS(337), 1,
      anon_sym_await,
    ACTIONS(559), 1,
      anon_sym_LPAREN,
    ACTIONS(563), 1,
      anon_sym_LBRACK,
    STATE(684), 1,
      sym_primary_expression,
    STATE(713), 1,
      sym_string,
    STATE(1007), 1,
      sym_expression,
    ACTIONS(75), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(47), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(77), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(333), 5,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
    STATE(1009), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(797), 15,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [22922] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(274), 1,
      sym_identifier,
    ACTIONS(278), 1,
      anon_sym_LPAREN,
    ACTIONS(293), 1,
      anon_sym_LBRACK,
    ACTIONS(295), 1,
      anon_sym_LBRACE,
    ACTIONS(299), 1,
      anon_sym_not,
    ACTIONS(305), 1,
      anon_sym_lambda,
    ACTIONS(313), 1,
      anon_sym_await,
    ACTIONS(315), 1,
      sym__string_start,
    STATE(600), 1,
      sym_string,
    STATE(630), 1,
      sym_primary_expression,
    STATE(1073), 1,
      sym_expression,
    ACTIONS(309), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(301), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(311), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(285), 5,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
    STATE(900), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(642), 15,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [23007] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(295), 1,
      anon_sym_LBRACE,
    ACTIONS(315), 1,
      sym__string_start,
    ACTIONS(602), 1,
      sym_identifier,
    ACTIONS(604), 1,
      anon_sym_LPAREN,
    ACTIONS(612), 1,
      anon_sym_LBRACK,
    ACTIONS(614), 1,
      anon_sym_not,
    ACTIONS(616), 1,
      anon_sym_lambda,
    ACTIONS(618), 1,
      anon_sym_await,
    STATE(600), 1,
      sym_string,
    STATE(643), 1,
      sym_primary_expression,
    STATE(928), 1,
      sym_expression,
    ACTIONS(309), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(610), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(311), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(606), 5,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
    STATE(900), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(642), 15,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [23092] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(850), 1,
      anon_sym_finally,
    STATE(518), 1,
      sym_finally_clause,
    ACTIONS(1132), 12,
      sym__string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1130), 33,
      anon_sym_import,
      anon_sym_from,
      anon_sym_STAR,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_match,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [23151] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1148), 1,
      anon_sym_COMMA,
    ACTIONS(1155), 1,
      anon_sym_EQ,
    ACTIONS(1153), 14,
      anon_sym_COLON,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    ACTIONS(1151), 15,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1146), 16,
      sym__newline,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym__semicolon,
  [23212] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      anon_sym_not,
    ACTIONS(71), 1,
      anon_sym_lambda,
    ACTIONS(81), 1,
      sym__string_start,
    ACTIONS(331), 1,
      sym_identifier,
    ACTIONS(337), 1,
      anon_sym_await,
    ACTIONS(559), 1,
      anon_sym_LPAREN,
    ACTIONS(563), 1,
      anon_sym_LBRACK,
    STATE(684), 1,
      sym_primary_expression,
    STATE(713), 1,
      sym_string,
    STATE(1054), 1,
      sym_expression,
    ACTIONS(75), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(47), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(77), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(333), 5,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
    STATE(1009), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(797), 15,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [23297] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(622), 1,
      sym_identifier,
    ACTIONS(624), 1,
      anon_sym_LPAREN,
    ACTIONS(632), 1,
      anon_sym_LBRACK,
    ACTIONS(634), 1,
      anon_sym_LBRACE,
    ACTIONS(636), 1,
      anon_sym_not,
    ACTIONS(638), 1,
      anon_sym_lambda,
    ACTIONS(644), 1,
      anon_sym_await,
    ACTIONS(646), 1,
      sym__string_start,
    STATE(740), 1,
      sym_primary_expression,
    STATE(742), 1,
      sym_string,
    STATE(1025), 1,
      sym_expression,
    ACTIONS(640), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(630), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(642), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(626), 5,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
    STATE(1015), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(811), 15,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [23382] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(295), 1,
      anon_sym_LBRACE,
    ACTIONS(315), 1,
      sym__string_start,
    ACTIONS(602), 1,
      sym_identifier,
    ACTIONS(604), 1,
      anon_sym_LPAREN,
    ACTIONS(612), 1,
      anon_sym_LBRACK,
    ACTIONS(614), 1,
      anon_sym_not,
    ACTIONS(616), 1,
      anon_sym_lambda,
    ACTIONS(618), 1,
      anon_sym_await,
    STATE(600), 1,
      sym_string,
    STATE(643), 1,
      sym_primary_expression,
    STATE(912), 1,
      sym_expression,
    ACTIONS(309), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(610), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(311), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(606), 5,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
    STATE(900), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(642), 15,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [23467] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(622), 1,
      sym_identifier,
    ACTIONS(624), 1,
      anon_sym_LPAREN,
    ACTIONS(632), 1,
      anon_sym_LBRACK,
    ACTIONS(634), 1,
      anon_sym_LBRACE,
    ACTIONS(636), 1,
      anon_sym_not,
    ACTIONS(638), 1,
      anon_sym_lambda,
    ACTIONS(644), 1,
      anon_sym_await,
    ACTIONS(646), 1,
      sym__string_start,
    STATE(740), 1,
      sym_primary_expression,
    STATE(742), 1,
      sym_string,
    STATE(1051), 1,
      sym_expression,
    ACTIONS(640), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(630), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(642), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(626), 5,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
    STATE(1015), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(811), 15,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [23552] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(274), 1,
      sym_identifier,
    ACTIONS(278), 1,
      anon_sym_LPAREN,
    ACTIONS(293), 1,
      anon_sym_LBRACK,
    ACTIONS(295), 1,
      anon_sym_LBRACE,
    ACTIONS(299), 1,
      anon_sym_not,
    ACTIONS(305), 1,
      anon_sym_lambda,
    ACTIONS(313), 1,
      anon_sym_await,
    ACTIONS(315), 1,
      sym__string_start,
    STATE(600), 1,
      sym_string,
    STATE(630), 1,
      sym_primary_expression,
    STATE(920), 1,
      sym_expression,
    ACTIONS(309), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(301), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(311), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(285), 5,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
    STATE(900), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(642), 15,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [23637] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(274), 1,
      sym_identifier,
    ACTIONS(278), 1,
      anon_sym_LPAREN,
    ACTIONS(293), 1,
      anon_sym_LBRACK,
    ACTIONS(295), 1,
      anon_sym_LBRACE,
    ACTIONS(299), 1,
      anon_sym_not,
    ACTIONS(305), 1,
      anon_sym_lambda,
    ACTIONS(313), 1,
      anon_sym_await,
    ACTIONS(315), 1,
      sym__string_start,
    STATE(600), 1,
      sym_string,
    STATE(630), 1,
      sym_primary_expression,
    STATE(939), 1,
      sym_expression,
    ACTIONS(309), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(301), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(311), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(285), 5,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
    STATE(900), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(642), 15,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [23722] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      anon_sym_not,
    ACTIONS(71), 1,
      anon_sym_lambda,
    ACTIONS(81), 1,
      sym__string_start,
    ACTIONS(331), 1,
      sym_identifier,
    ACTIONS(337), 1,
      anon_sym_await,
    ACTIONS(559), 1,
      anon_sym_LPAREN,
    ACTIONS(563), 1,
      anon_sym_LBRACK,
    STATE(684), 1,
      sym_primary_expression,
    STATE(713), 1,
      sym_string,
    STATE(992), 1,
      sym_expression,
    ACTIONS(75), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(47), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(77), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(333), 5,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
    STATE(1009), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(797), 15,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [23807] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1076), 1,
      anon_sym_EQ,
    ACTIONS(1071), 3,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(1048), 14,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
    ACTIONS(1078), 14,
      anon_sym_COLON,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    ACTIONS(1053), 15,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT,
      anon_sym_GT,
  [23868] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(274), 1,
      sym_identifier,
    ACTIONS(278), 1,
      anon_sym_LPAREN,
    ACTIONS(293), 1,
      anon_sym_LBRACK,
    ACTIONS(295), 1,
      anon_sym_LBRACE,
    ACTIONS(299), 1,
      anon_sym_not,
    ACTIONS(305), 1,
      anon_sym_lambda,
    ACTIONS(313), 1,
      anon_sym_await,
    ACTIONS(315), 1,
      sym__string_start,
    STATE(600), 1,
      sym_string,
    STATE(630), 1,
      sym_primary_expression,
    STATE(1126), 1,
      sym_expression,
    ACTIONS(309), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(301), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(311), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(285), 5,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
    STATE(900), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(642), 15,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [23953] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(274), 1,
      sym_identifier,
    ACTIONS(278), 1,
      anon_sym_LPAREN,
    ACTIONS(293), 1,
      anon_sym_LBRACK,
    ACTIONS(295), 1,
      anon_sym_LBRACE,
    ACTIONS(299), 1,
      anon_sym_not,
    ACTIONS(305), 1,
      anon_sym_lambda,
    ACTIONS(313), 1,
      anon_sym_await,
    ACTIONS(315), 1,
      sym__string_start,
    STATE(600), 1,
      sym_string,
    STATE(630), 1,
      sym_primary_expression,
    STATE(1127), 1,
      sym_expression,
    ACTIONS(309), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(301), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(311), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(285), 5,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
    STATE(900), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(642), 15,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [24038] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(295), 1,
      anon_sym_LBRACE,
    ACTIONS(315), 1,
      sym__string_start,
    ACTIONS(602), 1,
      sym_identifier,
    ACTIONS(604), 1,
      anon_sym_LPAREN,
    ACTIONS(612), 1,
      anon_sym_LBRACK,
    ACTIONS(614), 1,
      anon_sym_not,
    ACTIONS(616), 1,
      anon_sym_lambda,
    ACTIONS(618), 1,
      anon_sym_await,
    STATE(600), 1,
      sym_string,
    STATE(643), 1,
      sym_primary_expression,
    STATE(914), 1,
      sym_expression,
    ACTIONS(309), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(610), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(311), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(606), 5,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
    STATE(900), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(642), 15,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [24123] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      anon_sym_not,
    ACTIONS(71), 1,
      anon_sym_lambda,
    ACTIONS(81), 1,
      sym__string_start,
    ACTIONS(331), 1,
      sym_identifier,
    ACTIONS(337), 1,
      anon_sym_await,
    ACTIONS(559), 1,
      anon_sym_LPAREN,
    ACTIONS(563), 1,
      anon_sym_LBRACK,
    STATE(684), 1,
      sym_primary_expression,
    STATE(713), 1,
      sym_string,
    STATE(1078), 1,
      sym_expression,
    ACTIONS(75), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(47), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(77), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(333), 5,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
    STATE(1009), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(797), 15,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [24208] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(856), 1,
      anon_sym_finally,
    STATE(564), 1,
      sym_finally_clause,
    ACTIONS(1159), 12,
      sym__dedent,
      sym__string_start,
      anon_sym_LPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1157), 33,
      anon_sym_import,
      anon_sym_from,
      anon_sym_STAR,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_match,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [24267] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(295), 1,
      anon_sym_LBRACE,
    ACTIONS(315), 1,
      sym__string_start,
    ACTIONS(602), 1,
      sym_identifier,
    ACTIONS(604), 1,
      anon_sym_LPAREN,
    ACTIONS(612), 1,
      anon_sym_LBRACK,
    ACTIONS(614), 1,
      anon_sym_not,
    ACTIONS(616), 1,
      anon_sym_lambda,
    ACTIONS(618), 1,
      anon_sym_await,
    STATE(600), 1,
      sym_string,
    STATE(643), 1,
      sym_primary_expression,
    STATE(927), 1,
      sym_expression,
    ACTIONS(309), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(610), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(311), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(606), 5,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
    STATE(900), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(642), 15,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [24352] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(274), 1,
      sym_identifier,
    ACTIONS(278), 1,
      anon_sym_LPAREN,
    ACTIONS(293), 1,
      anon_sym_LBRACK,
    ACTIONS(295), 1,
      anon_sym_LBRACE,
    ACTIONS(299), 1,
      anon_sym_not,
    ACTIONS(305), 1,
      anon_sym_lambda,
    ACTIONS(313), 1,
      anon_sym_await,
    ACTIONS(315), 1,
      sym__string_start,
    STATE(600), 1,
      sym_string,
    STATE(630), 1,
      sym_primary_expression,
    STATE(926), 1,
      sym_expression,
    ACTIONS(309), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(301), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(311), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(285), 5,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
    STATE(900), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(642), 15,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [24437] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(295), 1,
      anon_sym_LBRACE,
    ACTIONS(315), 1,
      sym__string_start,
    ACTIONS(602), 1,
      sym_identifier,
    ACTIONS(604), 1,
      anon_sym_LPAREN,
    ACTIONS(612), 1,
      anon_sym_LBRACK,
    ACTIONS(614), 1,
      anon_sym_not,
    ACTIONS(616), 1,
      anon_sym_lambda,
    ACTIONS(618), 1,
      anon_sym_await,
    STATE(600), 1,
      sym_string,
    STATE(643), 1,
      sym_primary_expression,
    STATE(922), 1,
      sym_expression,
    ACTIONS(309), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(610), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(311), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(606), 5,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
    STATE(900), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(642), 15,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [24522] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(622), 1,
      sym_identifier,
    ACTIONS(624), 1,
      anon_sym_LPAREN,
    ACTIONS(632), 1,
      anon_sym_LBRACK,
    ACTIONS(634), 1,
      anon_sym_LBRACE,
    ACTIONS(636), 1,
      anon_sym_not,
    ACTIONS(638), 1,
      anon_sym_lambda,
    ACTIONS(644), 1,
      anon_sym_await,
    ACTIONS(646), 1,
      sym__string_start,
    STATE(740), 1,
      sym_primary_expression,
    STATE(742), 1,
      sym_string,
    STATE(1027), 1,
      sym_expression,
    ACTIONS(640), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(630), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(642), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(626), 5,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
    STATE(1015), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(811), 15,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [24607] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(274), 1,
      sym_identifier,
    ACTIONS(278), 1,
      anon_sym_LPAREN,
    ACTIONS(293), 1,
      anon_sym_LBRACK,
    ACTIONS(295), 1,
      anon_sym_LBRACE,
    ACTIONS(299), 1,
      anon_sym_not,
    ACTIONS(305), 1,
      anon_sym_lambda,
    ACTIONS(313), 1,
      anon_sym_await,
    ACTIONS(315), 1,
      sym__string_start,
    STATE(600), 1,
      sym_string,
    STATE(630), 1,
      sym_primary_expression,
    STATE(1148), 1,
      sym_expression,
    ACTIONS(309), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(301), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(311), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(285), 5,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
    STATE(900), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(642), 15,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [24692] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(274), 1,
      sym_identifier,
    ACTIONS(278), 1,
      anon_sym_LPAREN,
    ACTIONS(293), 1,
      anon_sym_LBRACK,
    ACTIONS(295), 1,
      anon_sym_LBRACE,
    ACTIONS(299), 1,
      anon_sym_not,
    ACTIONS(305), 1,
      anon_sym_lambda,
    ACTIONS(313), 1,
      anon_sym_await,
    ACTIONS(315), 1,
      sym__string_start,
    STATE(600), 1,
      sym_string,
    STATE(630), 1,
      sym_primary_expression,
    STATE(948), 1,
      sym_expression,
    ACTIONS(309), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(301), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(311), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(285), 5,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
    STATE(900), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(642), 15,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [24777] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      anon_sym_not,
    ACTIONS(71), 1,
      anon_sym_lambda,
    ACTIONS(81), 1,
      sym__string_start,
    ACTIONS(331), 1,
      sym_identifier,
    ACTIONS(337), 1,
      anon_sym_await,
    ACTIONS(559), 1,
      anon_sym_LPAREN,
    ACTIONS(563), 1,
      anon_sym_LBRACK,
    STATE(684), 1,
      sym_primary_expression,
    STATE(713), 1,
      sym_string,
    STATE(1113), 1,
      sym_expression,
    ACTIONS(75), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(47), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(77), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(333), 5,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
    STATE(1009), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(797), 15,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [24862] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      anon_sym_not,
    ACTIONS(71), 1,
      anon_sym_lambda,
    ACTIONS(81), 1,
      sym__string_start,
    ACTIONS(331), 1,
      sym_identifier,
    ACTIONS(337), 1,
      anon_sym_await,
    ACTIONS(559), 1,
      anon_sym_LPAREN,
    ACTIONS(563), 1,
      anon_sym_LBRACK,
    STATE(684), 1,
      sym_primary_expression,
    STATE(713), 1,
      sym_string,
    STATE(1026), 1,
      sym_expression,
    ACTIONS(75), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(47), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(77), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(333), 5,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
    STATE(1009), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(797), 15,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [24947] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(274), 1,
      sym_identifier,
    ACTIONS(278), 1,
      anon_sym_LPAREN,
    ACTIONS(293), 1,
      anon_sym_LBRACK,
    ACTIONS(295), 1,
      anon_sym_LBRACE,
    ACTIONS(299), 1,
      anon_sym_not,
    ACTIONS(305), 1,
      anon_sym_lambda,
    ACTIONS(313), 1,
      anon_sym_await,
    ACTIONS(315), 1,
      sym__string_start,
    STATE(600), 1,
      sym_string,
    STATE(630), 1,
      sym_primary_expression,
    STATE(924), 1,
      sym_expression,
    ACTIONS(309), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(301), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(311), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(285), 5,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
    STATE(900), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(642), 15,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [25032] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(852), 1,
      anon_sym_else,
    STATE(567), 1,
      sym_else_clause,
    ACTIONS(1163), 12,
      sym__dedent,
      sym__string_start,
      anon_sym_LPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1161), 33,
      anon_sym_import,
      anon_sym_from,
      anon_sym_STAR,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_match,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [25091] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(295), 1,
      anon_sym_LBRACE,
    ACTIONS(315), 1,
      sym__string_start,
    ACTIONS(602), 1,
      sym_identifier,
    ACTIONS(604), 1,
      anon_sym_LPAREN,
    ACTIONS(612), 1,
      anon_sym_LBRACK,
    ACTIONS(614), 1,
      anon_sym_not,
    ACTIONS(616), 1,
      anon_sym_lambda,
    ACTIONS(618), 1,
      anon_sym_await,
    STATE(600), 1,
      sym_string,
    STATE(643), 1,
      sym_primary_expression,
    STATE(923), 1,
      sym_expression,
    ACTIONS(309), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(610), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(311), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(606), 5,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
    STATE(900), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(642), 15,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [25176] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      anon_sym_not,
    ACTIONS(71), 1,
      anon_sym_lambda,
    ACTIONS(81), 1,
      sym__string_start,
    ACTIONS(331), 1,
      sym_identifier,
    ACTIONS(337), 1,
      anon_sym_await,
    ACTIONS(559), 1,
      anon_sym_LPAREN,
    ACTIONS(563), 1,
      anon_sym_LBRACK,
    STATE(684), 1,
      sym_primary_expression,
    STATE(713), 1,
      sym_string,
    STATE(1105), 1,
      sym_expression,
    ACTIONS(75), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(47), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(77), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(333), 5,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
    STATE(1009), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(797), 15,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [25261] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(850), 1,
      anon_sym_finally,
    STATE(559), 1,
      sym_finally_clause,
    ACTIONS(1159), 12,
      sym__string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1157), 33,
      anon_sym_import,
      anon_sym_from,
      anon_sym_STAR,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_match,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [25320] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(274), 1,
      sym_identifier,
    ACTIONS(278), 1,
      anon_sym_LPAREN,
    ACTIONS(293), 1,
      anon_sym_LBRACK,
    ACTIONS(295), 1,
      anon_sym_LBRACE,
    ACTIONS(299), 1,
      anon_sym_not,
    ACTIONS(305), 1,
      anon_sym_lambda,
    ACTIONS(313), 1,
      anon_sym_await,
    ACTIONS(315), 1,
      sym__string_start,
    STATE(600), 1,
      sym_string,
    STATE(630), 1,
      sym_primary_expression,
    STATE(1157), 1,
      sym_expression,
    ACTIONS(309), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(301), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(311), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(285), 5,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
    STATE(900), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(642), 15,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [25405] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      anon_sym_not,
    ACTIONS(71), 1,
      anon_sym_lambda,
    ACTIONS(81), 1,
      sym__string_start,
    ACTIONS(331), 1,
      sym_identifier,
    ACTIONS(337), 1,
      anon_sym_await,
    ACTIONS(559), 1,
      anon_sym_LPAREN,
    ACTIONS(563), 1,
      anon_sym_LBRACK,
    STATE(684), 1,
      sym_primary_expression,
    STATE(713), 1,
      sym_string,
    STATE(1048), 1,
      sym_expression,
    ACTIONS(75), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(47), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(77), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(333), 5,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
    STATE(1009), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(797), 15,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [25490] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(274), 1,
      sym_identifier,
    ACTIONS(278), 1,
      anon_sym_LPAREN,
    ACTIONS(293), 1,
      anon_sym_LBRACK,
    ACTIONS(295), 1,
      anon_sym_LBRACE,
    ACTIONS(299), 1,
      anon_sym_not,
    ACTIONS(305), 1,
      anon_sym_lambda,
    ACTIONS(313), 1,
      anon_sym_await,
    ACTIONS(315), 1,
      sym__string_start,
    STATE(600), 1,
      sym_string,
    STATE(630), 1,
      sym_primary_expression,
    STATE(904), 1,
      sym_expression,
    ACTIONS(309), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(301), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(311), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(285), 5,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
    STATE(900), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(642), 15,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [25575] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(274), 1,
      sym_identifier,
    ACTIONS(278), 1,
      anon_sym_LPAREN,
    ACTIONS(293), 1,
      anon_sym_LBRACK,
    ACTIONS(295), 1,
      anon_sym_LBRACE,
    ACTIONS(299), 1,
      anon_sym_not,
    ACTIONS(305), 1,
      anon_sym_lambda,
    ACTIONS(313), 1,
      anon_sym_await,
    ACTIONS(315), 1,
      sym__string_start,
    STATE(600), 1,
      sym_string,
    STATE(630), 1,
      sym_primary_expression,
    STATE(1158), 1,
      sym_expression,
    ACTIONS(309), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(301), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(311), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(285), 5,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
    STATE(900), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(642), 15,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [25660] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(846), 1,
      anon_sym_else,
    STATE(569), 1,
      sym_else_clause,
    ACTIONS(1163), 12,
      sym__string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1161), 33,
      anon_sym_import,
      anon_sym_from,
      anon_sym_STAR,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_match,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [25719] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(295), 1,
      anon_sym_LBRACE,
    ACTIONS(315), 1,
      sym__string_start,
    ACTIONS(602), 1,
      sym_identifier,
    ACTIONS(604), 1,
      anon_sym_LPAREN,
    ACTIONS(612), 1,
      anon_sym_LBRACK,
    ACTIONS(614), 1,
      anon_sym_not,
    ACTIONS(616), 1,
      anon_sym_lambda,
    ACTIONS(618), 1,
      anon_sym_await,
    STATE(600), 1,
      sym_string,
    STATE(643), 1,
      sym_primary_expression,
    STATE(1039), 1,
      sym_expression,
    ACTIONS(309), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(610), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(311), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(606), 5,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
    STATE(900), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(642), 15,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [25804] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(274), 1,
      sym_identifier,
    ACTIONS(278), 1,
      anon_sym_LPAREN,
    ACTIONS(293), 1,
      anon_sym_LBRACK,
    ACTIONS(295), 1,
      anon_sym_LBRACE,
    ACTIONS(299), 1,
      anon_sym_not,
    ACTIONS(305), 1,
      anon_sym_lambda,
    ACTIONS(313), 1,
      anon_sym_await,
    ACTIONS(315), 1,
      sym__string_start,
    STATE(600), 1,
      sym_string,
    STATE(630), 1,
      sym_primary_expression,
    STATE(1102), 1,
      sym_expression,
    ACTIONS(309), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(301), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(311), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(285), 5,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
    STATE(900), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(642), 15,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [25889] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1167), 1,
      anon_sym_COMMA,
    ACTIONS(1174), 1,
      anon_sym_EQ,
    ACTIONS(1172), 14,
      anon_sym_COLON,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    ACTIONS(1170), 15,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1165), 16,
      sym__newline,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym__semicolon,
  [25950] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(274), 1,
      sym_identifier,
    ACTIONS(278), 1,
      anon_sym_LPAREN,
    ACTIONS(293), 1,
      anon_sym_LBRACK,
    ACTIONS(295), 1,
      anon_sym_LBRACE,
    ACTIONS(299), 1,
      anon_sym_not,
    ACTIONS(305), 1,
      anon_sym_lambda,
    ACTIONS(313), 1,
      anon_sym_await,
    ACTIONS(315), 1,
      sym__string_start,
    STATE(600), 1,
      sym_string,
    STATE(630), 1,
      sym_primary_expression,
    STATE(921), 1,
      sym_expression,
    ACTIONS(309), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(301), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(311), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(285), 5,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
    STATE(900), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(642), 15,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [26035] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      anon_sym_not,
    ACTIONS(71), 1,
      anon_sym_lambda,
    ACTIONS(81), 1,
      sym__string_start,
    ACTIONS(331), 1,
      sym_identifier,
    ACTIONS(337), 1,
      anon_sym_await,
    ACTIONS(559), 1,
      anon_sym_LPAREN,
    ACTIONS(563), 1,
      anon_sym_LBRACK,
    STATE(684), 1,
      sym_primary_expression,
    STATE(713), 1,
      sym_string,
    STATE(1122), 1,
      sym_expression,
    ACTIONS(75), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(47), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(77), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(333), 5,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
    STATE(1009), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(797), 15,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [26120] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(852), 1,
      anon_sym_else,
    STATE(525), 1,
      sym_else_clause,
    ACTIONS(1118), 12,
      sym__dedent,
      sym__string_start,
      anon_sym_LPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1120), 33,
      anon_sym_import,
      anon_sym_from,
      anon_sym_STAR,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_match,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [26179] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(274), 1,
      sym_identifier,
    ACTIONS(278), 1,
      anon_sym_LPAREN,
    ACTIONS(293), 1,
      anon_sym_LBRACK,
    ACTIONS(295), 1,
      anon_sym_LBRACE,
    ACTIONS(299), 1,
      anon_sym_not,
    ACTIONS(305), 1,
      anon_sym_lambda,
    ACTIONS(313), 1,
      anon_sym_await,
    ACTIONS(315), 1,
      sym__string_start,
    STATE(600), 1,
      sym_string,
    STATE(630), 1,
      sym_primary_expression,
    STATE(1084), 1,
      sym_expression,
    ACTIONS(309), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(301), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(311), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(285), 5,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
    STATE(900), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(642), 15,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [26264] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      anon_sym_not,
    ACTIONS(71), 1,
      anon_sym_lambda,
    ACTIONS(81), 1,
      sym__string_start,
    ACTIONS(331), 1,
      sym_identifier,
    ACTIONS(337), 1,
      anon_sym_await,
    ACTIONS(559), 1,
      anon_sym_LPAREN,
    ACTIONS(563), 1,
      anon_sym_LBRACK,
    STATE(684), 1,
      sym_primary_expression,
    STATE(713), 1,
      sym_string,
    STATE(1065), 1,
      sym_expression,
    ACTIONS(75), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(47), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(77), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(333), 5,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
    STATE(1009), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(797), 15,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [26349] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      anon_sym_not,
    ACTIONS(71), 1,
      anon_sym_lambda,
    ACTIONS(81), 1,
      sym__string_start,
    ACTIONS(331), 1,
      sym_identifier,
    ACTIONS(337), 1,
      anon_sym_await,
    ACTIONS(559), 1,
      anon_sym_LPAREN,
    ACTIONS(563), 1,
      anon_sym_LBRACK,
    STATE(684), 1,
      sym_primary_expression,
    STATE(713), 1,
      sym_string,
    STATE(997), 1,
      sym_expression,
    ACTIONS(75), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(47), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(77), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(333), 5,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
    STATE(1009), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(797), 15,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [26434] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(295), 1,
      anon_sym_LBRACE,
    ACTIONS(315), 1,
      sym__string_start,
    ACTIONS(602), 1,
      sym_identifier,
    ACTIONS(604), 1,
      anon_sym_LPAREN,
    ACTIONS(612), 1,
      anon_sym_LBRACK,
    ACTIONS(614), 1,
      anon_sym_not,
    ACTIONS(616), 1,
      anon_sym_lambda,
    ACTIONS(618), 1,
      anon_sym_await,
    STATE(600), 1,
      sym_string,
    STATE(643), 1,
      sym_primary_expression,
    STATE(909), 1,
      sym_expression,
    ACTIONS(309), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(610), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(311), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(606), 5,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
    STATE(900), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(642), 15,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [26519] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      anon_sym_not,
    ACTIONS(71), 1,
      anon_sym_lambda,
    ACTIONS(81), 1,
      sym__string_start,
    ACTIONS(331), 1,
      sym_identifier,
    ACTIONS(337), 1,
      anon_sym_await,
    ACTIONS(559), 1,
      anon_sym_LPAREN,
    ACTIONS(563), 1,
      anon_sym_LBRACK,
    STATE(684), 1,
      sym_primary_expression,
    STATE(713), 1,
      sym_string,
    STATE(1066), 1,
      sym_expression,
    ACTIONS(75), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(47), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(77), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(333), 5,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
    STATE(1009), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(797), 15,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [26604] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(274), 1,
      sym_identifier,
    ACTIONS(278), 1,
      anon_sym_LPAREN,
    ACTIONS(293), 1,
      anon_sym_LBRACK,
    ACTIONS(295), 1,
      anon_sym_LBRACE,
    ACTIONS(299), 1,
      anon_sym_not,
    ACTIONS(305), 1,
      anon_sym_lambda,
    ACTIONS(313), 1,
      anon_sym_await,
    ACTIONS(315), 1,
      sym__string_start,
    STATE(600), 1,
      sym_string,
    STATE(630), 1,
      sym_primary_expression,
    STATE(1159), 1,
      sym_expression,
    ACTIONS(309), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(301), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(311), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(285), 5,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
    STATE(900), 7,
      sym_named_expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(642), 15,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [26689] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1178), 12,
      sym__dedent,
      sym__string_start,
      anon_sym_LPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1176), 34,
      anon_sym_import,
      anon_sym_from,
      anon_sym_STAR,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_match,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [26743] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1178), 12,
      sym__string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1176), 34,
      anon_sym_import,
      anon_sym_from,
      anon_sym_STAR,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_match,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [26797] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1182), 12,
      sym__dedent,
      sym__string_start,
      anon_sym_LPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1180), 34,
      anon_sym_import,
      anon_sym_from,
      anon_sym_STAR,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_match,
      anon_sym_case,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [26851] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1184), 12,
      sym__string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1186), 34,
      anon_sym_import,
      anon_sym_from,
      anon_sym_STAR,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_match,
      anon_sym_case,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [26905] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1190), 12,
      sym__dedent,
      sym__string_start,
      anon_sym_LPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1188), 34,
      anon_sym_import,
      anon_sym_from,
      anon_sym_STAR,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_match,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [26959] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1182), 12,
      sym__string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1180), 34,
      anon_sym_import,
      anon_sym_from,
      anon_sym_STAR,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_match,
      anon_sym_case,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [27013] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1194), 12,
      sym__dedent,
      sym__string_start,
      anon_sym_LPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1192), 34,
      anon_sym_import,
      anon_sym_from,
      anon_sym_STAR,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_match,
      anon_sym_case,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [27067] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1198), 12,
      sym__dedent,
      sym__string_start,
      anon_sym_LPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1196), 34,
      anon_sym_import,
      anon_sym_from,
      anon_sym_STAR,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_match,
      anon_sym_case,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [27121] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1198), 12,
      sym__string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1196), 34,
      anon_sym_import,
      anon_sym_from,
      anon_sym_STAR,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_match,
      anon_sym_case,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [27175] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1194), 12,
      sym__string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1192), 34,
      anon_sym_import,
      anon_sym_from,
      anon_sym_STAR,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_match,
      anon_sym_case,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [27229] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1184), 12,
      sym__dedent,
      sym__string_start,
      anon_sym_LPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1186), 34,
      anon_sym_import,
      anon_sym_from,
      anon_sym_STAR,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_match,
      anon_sym_case,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [27283] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1190), 12,
      sym__string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1188), 34,
      anon_sym_import,
      anon_sym_from,
      anon_sym_STAR,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_match,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [27337] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1200), 12,
      sym__string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1202), 33,
      anon_sym_import,
      anon_sym_from,
      anon_sym_STAR,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_match,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [27390] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1206), 12,
      sym__dedent,
      sym__string_start,
      anon_sym_LPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1204), 33,
      anon_sym_import,
      anon_sym_from,
      anon_sym_STAR,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_match,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [27443] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1208), 12,
      sym__string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1210), 33,
      anon_sym_import,
      anon_sym_from,
      anon_sym_STAR,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_match,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [27496] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1212), 12,
      sym__string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1214), 33,
      anon_sym_import,
      anon_sym_from,
      anon_sym_STAR,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_match,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [27549] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1216), 12,
      sym__string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1218), 33,
      anon_sym_import,
      anon_sym_from,
      anon_sym_STAR,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_match,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [27602] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1222), 12,
      sym__dedent,
      sym__string_start,
      anon_sym_LPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1220), 33,
      anon_sym_import,
      anon_sym_from,
      anon_sym_STAR,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_match,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [27655] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1224), 12,
      sym__string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1226), 33,
      anon_sym_import,
      anon_sym_from,
      anon_sym_STAR,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_match,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [27708] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1132), 12,
      sym__string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1130), 33,
      anon_sym_import,
      anon_sym_from,
      anon_sym_STAR,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_match,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [27761] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1230), 12,
      sym__dedent,
      sym__string_start,
      anon_sym_LPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1228), 33,
      anon_sym_import,
      anon_sym_from,
      anon_sym_STAR,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_match,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [27814] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1234), 12,
      sym__dedent,
      sym__string_start,
      anon_sym_LPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1232), 33,
      anon_sym_import,
      anon_sym_from,
      anon_sym_STAR,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_match,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [27867] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(860), 12,
      sym__string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(858), 33,
      anon_sym_import,
      anon_sym_from,
      anon_sym_STAR,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_match,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [27920] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1238), 12,
      sym__dedent,
      sym__string_start,
      anon_sym_LPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1236), 33,
      anon_sym_import,
      anon_sym_from,
      anon_sym_STAR,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_match,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [27973] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1242), 12,
      sym__dedent,
      sym__string_start,
      anon_sym_LPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1240), 33,
      anon_sym_import,
      anon_sym_from,
      anon_sym_STAR,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_match,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [28026] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1246), 12,
      sym__dedent,
      sym__string_start,
      anon_sym_LPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1244), 33,
      anon_sym_import,
      anon_sym_from,
      anon_sym_STAR,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_match,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [28079] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1248), 12,
      sym__string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1250), 33,
      anon_sym_import,
      anon_sym_from,
      anon_sym_STAR,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_match,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [28132] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1252), 12,
      sym__string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1254), 33,
      anon_sym_import,
      anon_sym_from,
      anon_sym_STAR,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_match,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [28185] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1252), 12,
      sym__dedent,
      sym__string_start,
      anon_sym_LPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1254), 33,
      anon_sym_import,
      anon_sym_from,
      anon_sym_STAR,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_match,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [28238] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(842), 12,
      sym__string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(844), 33,
      anon_sym_import,
      anon_sym_from,
      anon_sym_STAR,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_match,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [28291] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1206), 12,
      sym__string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1204), 33,
      anon_sym_import,
      anon_sym_from,
      anon_sym_STAR,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_match,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [28344] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(860), 12,
      sym__dedent,
      sym__string_start,
      anon_sym_LPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(858), 33,
      anon_sym_import,
      anon_sym_from,
      anon_sym_STAR,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_match,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [28397] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1258), 12,
      sym__dedent,
      sym__string_start,
      anon_sym_LPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1256), 33,
      anon_sym_import,
      anon_sym_from,
      anon_sym_STAR,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_match,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [28450] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1260), 12,
      sym__string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1262), 33,
      anon_sym_import,
      anon_sym_from,
      anon_sym_STAR,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_match,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [28503] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1264), 12,
      sym__string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1266), 33,
      anon_sym_import,
      anon_sym_from,
      anon_sym_STAR,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_match,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [28556] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1132), 12,
      sym__dedent,
      sym__string_start,
      anon_sym_LPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1130), 33,
      anon_sym_import,
      anon_sym_from,
      anon_sym_STAR,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_match,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [28609] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1268), 12,
      sym__string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1270), 33,
      anon_sym_import,
      anon_sym_from,
      anon_sym_STAR,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_match,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [28662] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1274), 12,
      sym__dedent,
      sym__string_start,
      anon_sym_LPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1272), 33,
      anon_sym_import,
      anon_sym_from,
      anon_sym_STAR,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_match,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [28715] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1159), 12,
      sym__string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1157), 33,
      anon_sym_import,
      anon_sym_from,
      anon_sym_STAR,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_match,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [28768] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1276), 12,
      sym__string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1278), 33,
      anon_sym_import,
      anon_sym_from,
      anon_sym_STAR,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_match,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [28821] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1212), 12,
      sym__dedent,
      sym__string_start,
      anon_sym_LPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1214), 33,
      anon_sym_import,
      anon_sym_from,
      anon_sym_STAR,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_match,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [28874] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1276), 12,
      sym__dedent,
      sym__string_start,
      anon_sym_LPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1278), 33,
      anon_sym_import,
      anon_sym_from,
      anon_sym_STAR,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_match,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [28927] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1282), 12,
      sym__dedent,
      sym__string_start,
      anon_sym_LPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1280), 33,
      anon_sym_import,
      anon_sym_from,
      anon_sym_STAR,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_match,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [28980] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1284), 12,
      sym__string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1286), 33,
      anon_sym_import,
      anon_sym_from,
      anon_sym_STAR,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_match,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [29033] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1290), 12,
      sym__dedent,
      sym__string_start,
      anon_sym_LPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1288), 33,
      anon_sym_import,
      anon_sym_from,
      anon_sym_STAR,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_match,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [29086] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1294), 12,
      sym__dedent,
      sym__string_start,
      anon_sym_LPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1292), 33,
      anon_sym_import,
      anon_sym_from,
      anon_sym_STAR,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_match,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [29139] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1298), 12,
      sym__dedent,
      sym__string_start,
      anon_sym_LPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1296), 33,
      anon_sym_import,
      anon_sym_from,
      anon_sym_STAR,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_match,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [29192] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1300), 12,
      sym__string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1302), 33,
      anon_sym_import,
      anon_sym_from,
      anon_sym_STAR,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_match,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [29245] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1304), 12,
      sym__string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1306), 33,
      anon_sym_import,
      anon_sym_from,
      anon_sym_STAR,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_match,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [29298] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 12,
      sym__dedent,
      sym__string_start,
      anon_sym_LPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1308), 33,
      anon_sym_import,
      anon_sym_from,
      anon_sym_STAR,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_match,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [29351] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1312), 12,
      sym__string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1314), 33,
      anon_sym_import,
      anon_sym_from,
      anon_sym_STAR,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_match,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [29404] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 12,
      sym__string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1308), 33,
      anon_sym_import,
      anon_sym_from,
      anon_sym_STAR,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_match,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [29457] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1290), 12,
      sym__string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1288), 33,
      anon_sym_import,
      anon_sym_from,
      anon_sym_STAR,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_match,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [29510] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1294), 12,
      sym__string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1292), 33,
      anon_sym_import,
      anon_sym_from,
      anon_sym_STAR,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_match,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [29563] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1248), 12,
      sym__dedent,
      sym__string_start,
      anon_sym_LPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1250), 33,
      anon_sym_import,
      anon_sym_from,
      anon_sym_STAR,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_match,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [29616] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1304), 12,
      sym__dedent,
      sym__string_start,
      anon_sym_LPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1306), 33,
      anon_sym_import,
      anon_sym_from,
      anon_sym_STAR,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_match,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [29669] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1316), 12,
      sym__string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1318), 33,
      anon_sym_import,
      anon_sym_from,
      anon_sym_STAR,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_match,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [29722] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1222), 12,
      sym__string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1220), 33,
      anon_sym_import,
      anon_sym_from,
      anon_sym_STAR,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_match,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [29775] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1320), 12,
      sym__string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1322), 33,
      anon_sym_import,
      anon_sym_from,
      anon_sym_STAR,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_match,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [29828] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1326), 12,
      sym__dedent,
      sym__string_start,
      anon_sym_LPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1324), 33,
      anon_sym_import,
      anon_sym_from,
      anon_sym_STAR,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_match,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [29881] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1246), 12,
      sym__string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1244), 33,
      anon_sym_import,
      anon_sym_from,
      anon_sym_STAR,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_match,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [29934] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1242), 12,
      sym__string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1240), 33,
      anon_sym_import,
      anon_sym_from,
      anon_sym_STAR,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_match,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [29987] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1238), 12,
      sym__string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1236), 33,
      anon_sym_import,
      anon_sym_from,
      anon_sym_STAR,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_match,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [30040] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1216), 12,
      sym__dedent,
      sym__string_start,
      anon_sym_LPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1218), 33,
      anon_sym_import,
      anon_sym_from,
      anon_sym_STAR,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_match,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [30093] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1328), 12,
      sym__string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1330), 33,
      anon_sym_import,
      anon_sym_from,
      anon_sym_STAR,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_match,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [30146] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1282), 12,
      sym__string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1280), 33,
      anon_sym_import,
      anon_sym_from,
      anon_sym_STAR,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_match,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [30199] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1224), 12,
      sym__dedent,
      sym__string_start,
      anon_sym_LPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1226), 33,
      anon_sym_import,
      anon_sym_from,
      anon_sym_STAR,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_match,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [30252] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1332), 12,
      sym__string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1334), 33,
      anon_sym_import,
      anon_sym_from,
      anon_sym_STAR,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_match,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [30305] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1298), 12,
      sym__string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1296), 33,
      anon_sym_import,
      anon_sym_from,
      anon_sym_STAR,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_match,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [30358] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1328), 12,
      sym__dedent,
      sym__string_start,
      anon_sym_LPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1330), 33,
      anon_sym_import,
      anon_sym_from,
      anon_sym_STAR,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_match,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [30411] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1284), 12,
      sym__dedent,
      sym__string_start,
      anon_sym_LPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1286), 33,
      anon_sym_import,
      anon_sym_from,
      anon_sym_STAR,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_match,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [30464] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1234), 12,
      sym__string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1232), 33,
      anon_sym_import,
      anon_sym_from,
      anon_sym_STAR,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_match,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [30517] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1230), 12,
      sym__string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1228), 33,
      anon_sym_import,
      anon_sym_from,
      anon_sym_STAR,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_match,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [30570] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1300), 12,
      sym__dedent,
      sym__string_start,
      anon_sym_LPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1302), 33,
      anon_sym_import,
      anon_sym_from,
      anon_sym_STAR,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_match,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [30623] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1336), 12,
      sym__string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1338), 33,
      anon_sym_import,
      anon_sym_from,
      anon_sym_STAR,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_match,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [30676] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1320), 12,
      sym__dedent,
      sym__string_start,
      anon_sym_LPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1322), 33,
      anon_sym_import,
      anon_sym_from,
      anon_sym_STAR,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_match,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [30729] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1340), 12,
      sym__string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1342), 33,
      anon_sym_import,
      anon_sym_from,
      anon_sym_STAR,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_match,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [30782] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1316), 12,
      sym__dedent,
      sym__string_start,
      anon_sym_LPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1318), 33,
      anon_sym_import,
      anon_sym_from,
      anon_sym_STAR,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_match,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [30835] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1312), 12,
      sym__dedent,
      sym__string_start,
      anon_sym_LPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1314), 33,
      anon_sym_import,
      anon_sym_from,
      anon_sym_STAR,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_match,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [30888] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1336), 12,
      sym__dedent,
      sym__string_start,
      anon_sym_LPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1338), 33,
      anon_sym_import,
      anon_sym_from,
      anon_sym_STAR,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_match,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [30941] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1340), 12,
      sym__dedent,
      sym__string_start,
      anon_sym_LPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1342), 33,
      anon_sym_import,
      anon_sym_from,
      anon_sym_STAR,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_match,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [30994] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1258), 12,
      sym__string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1256), 33,
      anon_sym_import,
      anon_sym_from,
      anon_sym_STAR,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_match,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [31047] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1346), 12,
      sym__dedent,
      sym__string_start,
      anon_sym_LPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1344), 33,
      anon_sym_import,
      anon_sym_from,
      anon_sym_STAR,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_match,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [31100] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(842), 12,
      sym__dedent,
      sym__string_start,
      anon_sym_LPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(844), 33,
      anon_sym_import,
      anon_sym_from,
      anon_sym_STAR,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_match,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [31153] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1346), 12,
      sym__string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1344), 33,
      anon_sym_import,
      anon_sym_from,
      anon_sym_STAR,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_match,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [31206] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1350), 12,
      sym__dedent,
      sym__string_start,
      anon_sym_LPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1348), 33,
      anon_sym_import,
      anon_sym_from,
      anon_sym_STAR,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_match,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [31259] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1354), 12,
      sym__dedent,
      sym__string_start,
      anon_sym_LPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1352), 33,
      anon_sym_import,
      anon_sym_from,
      anon_sym_STAR,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_match,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [31312] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1354), 12,
      sym__string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1352), 33,
      anon_sym_import,
      anon_sym_from,
      anon_sym_STAR,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_match,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [31365] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1356), 12,
      sym__string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1358), 33,
      anon_sym_import,
      anon_sym_from,
      anon_sym_STAR,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_match,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [31418] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1356), 12,
      sym__dedent,
      sym__string_start,
      anon_sym_LPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1358), 33,
      anon_sym_import,
      anon_sym_from,
      anon_sym_STAR,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_match,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [31471] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1360), 12,
      sym__string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1362), 33,
      anon_sym_import,
      anon_sym_from,
      anon_sym_STAR,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_match,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [31524] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1274), 12,
      sym__string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1272), 33,
      anon_sym_import,
      anon_sym_from,
      anon_sym_STAR,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_match,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [31577] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1360), 12,
      sym__dedent,
      sym__string_start,
      anon_sym_LPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1362), 33,
      anon_sym_import,
      anon_sym_from,
      anon_sym_STAR,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_match,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [31630] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1326), 12,
      sym__string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1324), 33,
      anon_sym_import,
      anon_sym_from,
      anon_sym_STAR,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_match,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [31683] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1366), 12,
      sym__dedent,
      sym__string_start,
      anon_sym_LPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1364), 33,
      anon_sym_import,
      anon_sym_from,
      anon_sym_STAR,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_match,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [31736] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1200), 12,
      sym__dedent,
      sym__string_start,
      anon_sym_LPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1202), 33,
      anon_sym_import,
      anon_sym_from,
      anon_sym_STAR,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_match,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [31789] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1370), 12,
      sym__dedent,
      sym__string_start,
      anon_sym_LPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1368), 33,
      anon_sym_import,
      anon_sym_from,
      anon_sym_STAR,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_match,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [31842] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1374), 12,
      sym__dedent,
      sym__string_start,
      anon_sym_LPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1372), 33,
      anon_sym_import,
      anon_sym_from,
      anon_sym_STAR,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_match,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [31895] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1366), 12,
      sym__string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1364), 33,
      anon_sym_import,
      anon_sym_from,
      anon_sym_STAR,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_match,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [31948] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1208), 12,
      sym__dedent,
      sym__string_start,
      anon_sym_LPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1210), 33,
      anon_sym_import,
      anon_sym_from,
      anon_sym_STAR,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_match,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [32001] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1350), 12,
      sym__string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1348), 33,
      anon_sym_import,
      anon_sym_from,
      anon_sym_STAR,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_match,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [32054] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1370), 12,
      sym__string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1368), 33,
      anon_sym_import,
      anon_sym_from,
      anon_sym_STAR,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_match,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [32107] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1378), 12,
      sym__dedent,
      sym__string_start,
      anon_sym_LPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1376), 33,
      anon_sym_import,
      anon_sym_from,
      anon_sym_STAR,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_match,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [32160] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1159), 12,
      sym__dedent,
      sym__string_start,
      anon_sym_LPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1157), 33,
      anon_sym_import,
      anon_sym_from,
      anon_sym_STAR,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_match,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [32213] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1374), 12,
      sym__string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1372), 33,
      anon_sym_import,
      anon_sym_from,
      anon_sym_STAR,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_match,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [32266] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1378), 12,
      sym__string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1376), 33,
      anon_sym_import,
      anon_sym_from,
      anon_sym_STAR,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_match,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [32319] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1260), 12,
      sym__dedent,
      sym__string_start,
      anon_sym_LPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1262), 33,
      anon_sym_import,
      anon_sym_from,
      anon_sym_STAR,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_match,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [32372] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1268), 12,
      sym__dedent,
      sym__string_start,
      anon_sym_LPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1270), 33,
      anon_sym_import,
      anon_sym_from,
      anon_sym_STAR,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_match,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [32425] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1264), 12,
      sym__dedent,
      sym__string_start,
      anon_sym_LPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1266), 33,
      anon_sym_import,
      anon_sym_from,
      anon_sym_STAR,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_match,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [32478] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1332), 12,
      sym__dedent,
      sym__string_start,
      anon_sym_LPAREN,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1334), 33,
      anon_sym_import,
      anon_sym_from,
      anon_sym_STAR,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_match,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      sym_true,
      sym_false,
      sym_none,
  [32531] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(295), 1,
      anon_sym_LBRACE,
    ACTIONS(315), 1,
      sym__string_start,
    ACTIONS(678), 1,
      sym_identifier,
    ACTIONS(680), 1,
      anon_sym_LPAREN,
    ACTIONS(690), 1,
      anon_sym_LBRACK,
    ACTIONS(1382), 1,
      anon_sym_STAR,
    STATE(600), 1,
      sym_string,
    STATE(876), 1,
      sym_pattern,
    STATE(882), 1,
      sym_primary_expression,
    ACTIONS(309), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(1380), 2,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
    STATE(770), 2,
      sym_attribute,
      sym_subscript,
    ACTIONS(301), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(875), 3,
      sym_tuple_pattern,
      sym_list_pattern,
      sym_list_splat_pattern,
    ACTIONS(311), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(684), 6,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_await,
    STATE(642), 13,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [32613] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(295), 1,
      anon_sym_LBRACE,
    ACTIONS(315), 1,
      sym__string_start,
    ACTIONS(678), 1,
      sym_identifier,
    ACTIONS(680), 1,
      anon_sym_LPAREN,
    ACTIONS(690), 1,
      anon_sym_LBRACK,
    ACTIONS(1382), 1,
      anon_sym_STAR,
    ACTIONS(1384), 1,
      anon_sym_RPAREN,
    STATE(600), 1,
      sym_string,
    STATE(882), 1,
      sym_primary_expression,
    STATE(1146), 1,
      sym_pattern,
    STATE(1434), 1,
      sym__patterns,
    ACTIONS(309), 2,
      sym_ellipsis,
      sym_float,
    STATE(770), 2,
      sym_attribute,
      sym_subscript,
    ACTIONS(301), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(875), 3,
      sym_tuple_pattern,
      sym_list_pattern,
      sym_list_splat_pattern,
    ACTIONS(311), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(684), 6,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_await,
    STATE(642), 13,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [32697] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(295), 1,
      anon_sym_LBRACE,
    ACTIONS(315), 1,
      sym__string_start,
    ACTIONS(678), 1,
      sym_identifier,
    ACTIONS(680), 1,
      anon_sym_LPAREN,
    ACTIONS(690), 1,
      anon_sym_LBRACK,
    ACTIONS(1382), 1,
      anon_sym_STAR,
    STATE(600), 1,
      sym_string,
    STATE(876), 1,
      sym_pattern,
    STATE(882), 1,
      sym_primary_expression,
    ACTIONS(309), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(1386), 2,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
    STATE(770), 2,
      sym_attribute,
      sym_subscript,
    ACTIONS(301), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(875), 3,
      sym_tuple_pattern,
      sym_list_pattern,
      sym_list_splat_pattern,
    ACTIONS(311), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(684), 6,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_await,
    STATE(642), 13,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [32779] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(315), 1,
      sym__string_start,
    STATE(599), 2,
      sym_string,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(1390), 6,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1388), 34,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [32834] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1396), 1,
      sym__string_start,
    STATE(599), 2,
      sym_string,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(1394), 6,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1392), 34,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [32889] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(315), 1,
      sym__string_start,
    STATE(598), 2,
      sym_string,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(1053), 6,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1048), 34,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [32944] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(295), 1,
      anon_sym_LBRACE,
    ACTIONS(315), 1,
      sym__string_start,
    ACTIONS(678), 1,
      sym_identifier,
    ACTIONS(680), 1,
      anon_sym_LPAREN,
    ACTIONS(690), 1,
      anon_sym_LBRACK,
    ACTIONS(1382), 1,
      anon_sym_STAR,
    STATE(600), 1,
      sym_string,
    STATE(882), 1,
      sym_primary_expression,
    STATE(1305), 1,
      sym_pattern,
    STATE(1466), 1,
      sym_pattern_list,
    ACTIONS(309), 2,
      sym_ellipsis,
      sym_float,
    STATE(770), 2,
      sym_attribute,
      sym_subscript,
    ACTIONS(301), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(875), 3,
      sym_tuple_pattern,
      sym_list_pattern,
      sym_list_splat_pattern,
    ACTIONS(311), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(684), 6,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_await,
    STATE(642), 13,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [33025] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(295), 1,
      anon_sym_LBRACE,
    ACTIONS(315), 1,
      sym__string_start,
    ACTIONS(678), 1,
      sym_identifier,
    ACTIONS(680), 1,
      anon_sym_LPAREN,
    ACTIONS(690), 1,
      anon_sym_LBRACK,
    ACTIONS(1382), 1,
      anon_sym_STAR,
    STATE(600), 1,
      sym_string,
    STATE(882), 1,
      sym_primary_expression,
    STATE(1306), 1,
      sym_pattern,
    STATE(1454), 1,
      sym_pattern_list,
    ACTIONS(309), 2,
      sym_ellipsis,
      sym_float,
    STATE(770), 2,
      sym_attribute,
      sym_subscript,
    ACTIONS(301), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(875), 3,
      sym_tuple_pattern,
      sym_list_pattern,
      sym_list_splat_pattern,
    ACTIONS(311), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(684), 6,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_await,
    STATE(642), 13,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [33106] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(295), 1,
      anon_sym_LBRACE,
    ACTIONS(315), 1,
      sym__string_start,
    ACTIONS(678), 1,
      sym_identifier,
    ACTIONS(680), 1,
      anon_sym_LPAREN,
    ACTIONS(690), 1,
      anon_sym_LBRACK,
    ACTIONS(1382), 1,
      anon_sym_STAR,
    STATE(600), 1,
      sym_string,
    STATE(882), 1,
      sym_primary_expression,
    STATE(1197), 1,
      sym_pattern,
    STATE(1522), 1,
      sym_pattern_list,
    ACTIONS(309), 2,
      sym_ellipsis,
      sym_float,
    STATE(770), 2,
      sym_attribute,
      sym_subscript,
    ACTIONS(301), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(875), 3,
      sym_tuple_pattern,
      sym_list_pattern,
      sym_list_splat_pattern,
    ACTIONS(311), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(684), 6,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_await,
    STATE(642), 13,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [33187] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(295), 1,
      anon_sym_LBRACE,
    ACTIONS(315), 1,
      sym__string_start,
    ACTIONS(678), 1,
      sym_identifier,
    ACTIONS(680), 1,
      anon_sym_LPAREN,
    ACTIONS(690), 1,
      anon_sym_LBRACK,
    ACTIONS(1382), 1,
      anon_sym_STAR,
    STATE(600), 1,
      sym_string,
    STATE(882), 1,
      sym_primary_expression,
    STATE(1199), 1,
      sym_pattern,
    STATE(1519), 1,
      sym_pattern_list,
    ACTIONS(309), 2,
      sym_ellipsis,
      sym_float,
    STATE(770), 2,
      sym_attribute,
      sym_subscript,
    ACTIONS(301), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(875), 3,
      sym_tuple_pattern,
      sym_list_pattern,
      sym_list_splat_pattern,
    ACTIONS(311), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(684), 6,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_await,
    STATE(642), 13,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [33268] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(295), 1,
      anon_sym_LBRACE,
    ACTIONS(315), 1,
      sym__string_start,
    ACTIONS(678), 1,
      sym_identifier,
    ACTIONS(680), 1,
      anon_sym_LPAREN,
    ACTIONS(690), 1,
      anon_sym_LBRACK,
    ACTIONS(1382), 1,
      anon_sym_STAR,
    STATE(600), 1,
      sym_string,
    STATE(882), 1,
      sym_primary_expression,
    STATE(1276), 1,
      sym_pattern,
    STATE(1421), 1,
      sym_pattern_list,
    ACTIONS(309), 2,
      sym_ellipsis,
      sym_float,
    STATE(770), 2,
      sym_attribute,
      sym_subscript,
    ACTIONS(301), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(875), 3,
      sym_tuple_pattern,
      sym_list_pattern,
      sym_list_splat_pattern,
    ACTIONS(311), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(684), 6,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_await,
    STATE(642), 13,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [33349] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(295), 1,
      anon_sym_LBRACE,
    ACTIONS(315), 1,
      sym__string_start,
    ACTIONS(678), 1,
      sym_identifier,
    ACTIONS(680), 1,
      anon_sym_LPAREN,
    ACTIONS(690), 1,
      anon_sym_LBRACK,
    ACTIONS(1382), 1,
      anon_sym_STAR,
    STATE(600), 1,
      sym_string,
    STATE(882), 1,
      sym_primary_expression,
    STATE(1293), 1,
      sym_pattern,
    STATE(1419), 1,
      sym_pattern_list,
    ACTIONS(309), 2,
      sym_ellipsis,
      sym_float,
    STATE(770), 2,
      sym_attribute,
      sym_subscript,
    ACTIONS(301), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(875), 3,
      sym_tuple_pattern,
      sym_list_pattern,
      sym_list_splat_pattern,
    ACTIONS(311), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(684), 6,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_await,
    STATE(642), 13,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [33430] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(295), 1,
      anon_sym_LBRACE,
    ACTIONS(315), 1,
      sym__string_start,
    ACTIONS(678), 1,
      sym_identifier,
    ACTIONS(680), 1,
      anon_sym_LPAREN,
    ACTIONS(690), 1,
      anon_sym_LBRACK,
    ACTIONS(1382), 1,
      anon_sym_STAR,
    STATE(600), 1,
      sym_string,
    STATE(876), 1,
      sym_pattern,
    STATE(882), 1,
      sym_primary_expression,
    ACTIONS(309), 2,
      sym_ellipsis,
      sym_float,
    STATE(770), 2,
      sym_attribute,
      sym_subscript,
    ACTIONS(301), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(875), 3,
      sym_tuple_pattern,
      sym_list_pattern,
      sym_list_splat_pattern,
    ACTIONS(311), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(684), 6,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_await,
    STATE(642), 13,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [33508] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(295), 1,
      anon_sym_LBRACE,
    ACTIONS(315), 1,
      sym__string_start,
    ACTIONS(678), 1,
      sym_identifier,
    ACTIONS(680), 1,
      anon_sym_LPAREN,
    ACTIONS(690), 1,
      anon_sym_LBRACK,
    ACTIONS(1382), 1,
      anon_sym_STAR,
    STATE(600), 1,
      sym_string,
    STATE(882), 1,
      sym_primary_expression,
    STATE(1281), 1,
      sym_pattern,
    ACTIONS(309), 2,
      sym_ellipsis,
      sym_float,
    STATE(770), 2,
      sym_attribute,
      sym_subscript,
    ACTIONS(301), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(875), 3,
      sym_tuple_pattern,
      sym_list_pattern,
      sym_list_splat_pattern,
    ACTIONS(311), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(684), 6,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_await,
    STATE(642), 13,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [33586] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1401), 6,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1399), 35,
      sym__string_start,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [33635] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1405), 6,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1403), 35,
      sym__string_start,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [33684] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1409), 6,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1407), 34,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [33732] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1413), 6,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1411), 34,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [33780] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1417), 6,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1415), 34,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [33828] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1421), 6,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1419), 34,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [33876] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1425), 6,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1423), 34,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [33924] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1421), 6,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1419), 34,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [33972] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1429), 6,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1427), 34,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [34020] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(276), 6,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(303), 34,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [34068] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1433), 6,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1431), 34,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [34116] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1437), 6,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1435), 34,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [34164] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1441), 6,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1439), 34,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [34212] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1445), 6,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1443), 34,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [34260] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1449), 6,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1447), 34,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [34308] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1453), 6,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1451), 34,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [34356] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1457), 6,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1455), 34,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [34404] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1461), 6,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1459), 34,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [34452] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1465), 6,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1463), 34,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [34500] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1469), 6,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1467), 34,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [34548] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1473), 6,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1471), 34,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [34596] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1475), 1,
      anon_sym_DOT,
    ACTIONS(1477), 1,
      anon_sym_LPAREN,
    ACTIONS(1487), 1,
      anon_sym_PIPE,
    ACTIONS(1491), 1,
      anon_sym_LBRACK,
    ACTIONS(1493), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1495), 1,
      anon_sym_EQ,
    ACTIONS(1499), 1,
      anon_sym_not,
    ACTIONS(1501), 1,
      anon_sym_AMP,
    ACTIONS(1503), 1,
      anon_sym_CARET,
    ACTIONS(1507), 1,
      anon_sym_is,
    STATE(870), 1,
      aux_sym_comparison_operator_repeat1,
    ACTIONS(1481), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1483), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(1489), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1505), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(633), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(1497), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(1485), 6,
      anon_sym_in,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
    ACTIONS(1479), 10,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
      sym_type_conversion,
  [34678] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1511), 6,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1509), 34,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [34726] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1417), 6,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1415), 34,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [34774] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1515), 6,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1513), 34,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [34822] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1519), 6,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1517), 34,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [34870] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1523), 6,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1521), 34,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [34918] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(278), 1,
      anon_sym_LPAREN,
    ACTIONS(293), 1,
      anon_sym_LBRACK,
    ACTIONS(295), 1,
      anon_sym_LBRACE,
    ACTIONS(315), 1,
      sym__string_start,
    ACTIONS(1525), 1,
      sym_identifier,
    STATE(600), 1,
      sym_string,
    STATE(882), 1,
      sym_primary_expression,
    ACTIONS(309), 2,
      sym_ellipsis,
      sym_float,
    STATE(762), 2,
      sym_attribute,
      sym_subscript,
    ACTIONS(301), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(1527), 3,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(311), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1529), 6,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_await,
    STATE(642), 13,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [34990] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1533), 6,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1531), 34,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [35038] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1537), 6,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1535), 34,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [35086] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1425), 6,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1423), 34,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [35134] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1519), 6,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1517), 34,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [35182] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1541), 6,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1539), 34,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [35230] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1053), 6,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1048), 34,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [35278] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1475), 1,
      anon_sym_DOT,
    ACTIONS(1477), 1,
      anon_sym_LPAREN,
    ACTIONS(1491), 1,
      anon_sym_LBRACK,
    ACTIONS(1495), 1,
      anon_sym_as,
    ACTIONS(1549), 1,
      anon_sym_PIPE,
    ACTIONS(1553), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1557), 1,
      anon_sym_not,
    ACTIONS(1559), 1,
      anon_sym_AMP,
    ACTIONS(1561), 1,
      anon_sym_CARET,
    ACTIONS(1565), 1,
      anon_sym_is,
    STATE(871), 1,
      aux_sym_comparison_operator_repeat1,
    ACTIONS(1543), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1545), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(1551), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1563), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(633), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(1555), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(1547), 6,
      anon_sym_in,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
    ACTIONS(1479), 10,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
  [35360] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1569), 6,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1567), 34,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [35408] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1475), 1,
      anon_sym_DOT,
    ACTIONS(1477), 1,
      anon_sym_LPAREN,
    ACTIONS(1491), 1,
      anon_sym_LBRACK,
    ACTIONS(1493), 1,
      anon_sym_STAR_STAR,
    STATE(633), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(1573), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1571), 28,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [35465] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1475), 1,
      anon_sym_DOT,
    ACTIONS(1477), 1,
      anon_sym_LPAREN,
    ACTIONS(1491), 1,
      anon_sym_LBRACK,
    ACTIONS(1493), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1503), 1,
      anon_sym_CARET,
    ACTIONS(1481), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1483), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(1489), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(633), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(1497), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(1573), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1571), 20,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [35532] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1475), 1,
      anon_sym_DOT,
    ACTIONS(1477), 1,
      anon_sym_LPAREN,
    ACTIONS(1491), 1,
      anon_sym_LBRACK,
    ACTIONS(1553), 1,
      anon_sym_STAR_STAR,
    STATE(633), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(1573), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1571), 28,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [35589] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1475), 1,
      anon_sym_DOT,
    ACTIONS(1477), 1,
      anon_sym_LPAREN,
    ACTIONS(1491), 1,
      anon_sym_LBRACK,
    ACTIONS(1493), 1,
      anon_sym_STAR_STAR,
    STATE(633), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(1573), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1571), 28,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [35646] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1475), 1,
      anon_sym_DOT,
    ACTIONS(1477), 1,
      anon_sym_LPAREN,
    ACTIONS(1491), 1,
      anon_sym_LBRACK,
    ACTIONS(1553), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1543), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1551), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(633), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(1555), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(1573), 3,
      anon_sym_as,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1571), 23,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [35709] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1475), 1,
      anon_sym_DOT,
    ACTIONS(1477), 1,
      anon_sym_LPAREN,
    ACTIONS(1491), 1,
      anon_sym_LBRACK,
    ACTIONS(1493), 1,
      anon_sym_STAR_STAR,
    STATE(633), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(1577), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1575), 28,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [35766] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1475), 1,
      anon_sym_DOT,
    ACTIONS(1477), 1,
      anon_sym_LPAREN,
    ACTIONS(1491), 1,
      anon_sym_LBRACK,
    ACTIONS(1493), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1481), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    STATE(633), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(1497), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(1573), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1571), 25,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [35827] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1475), 1,
      anon_sym_DOT,
    ACTIONS(1477), 1,
      anon_sym_LPAREN,
    ACTIONS(1491), 1,
      anon_sym_LBRACK,
    ACTIONS(1549), 1,
      anon_sym_PIPE,
    ACTIONS(1553), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1559), 1,
      anon_sym_AMP,
    ACTIONS(1561), 1,
      anon_sym_CARET,
    ACTIONS(1543), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1545), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(1551), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(633), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(1555), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(1581), 3,
      anon_sym_as,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1579), 18,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [35898] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1475), 1,
      anon_sym_DOT,
    ACTIONS(1477), 1,
      anon_sym_LPAREN,
    ACTIONS(1491), 1,
      anon_sym_LBRACK,
    ACTIONS(1553), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1559), 1,
      anon_sym_AMP,
    ACTIONS(1561), 1,
      anon_sym_CARET,
    ACTIONS(1543), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1545), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(1551), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(633), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(1555), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(1573), 3,
      anon_sym_as,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1571), 19,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [35967] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1475), 1,
      anon_sym_DOT,
    ACTIONS(1477), 1,
      anon_sym_LPAREN,
    ACTIONS(1491), 1,
      anon_sym_LBRACK,
    ACTIONS(1553), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1543), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    STATE(633), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(1555), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(1573), 3,
      anon_sym_as,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1571), 25,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [36028] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1475), 1,
      anon_sym_DOT,
    ACTIONS(1477), 1,
      anon_sym_LPAREN,
    ACTIONS(1491), 1,
      anon_sym_LBRACK,
    ACTIONS(1553), 1,
      anon_sym_STAR_STAR,
    STATE(633), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(1573), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1571), 28,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [36085] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1475), 1,
      anon_sym_DOT,
    ACTIONS(1477), 1,
      anon_sym_LPAREN,
    ACTIONS(1491), 1,
      anon_sym_LBRACK,
    ACTIONS(1493), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1481), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1483), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(1489), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(633), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(1497), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(1573), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1571), 21,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [36150] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1475), 1,
      anon_sym_DOT,
    ACTIONS(1477), 1,
      anon_sym_LPAREN,
    ACTIONS(1491), 1,
      anon_sym_LBRACK,
    ACTIONS(1553), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1543), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1545), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(1551), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(633), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(1555), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(1573), 3,
      anon_sym_as,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1571), 21,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [36215] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1475), 1,
      anon_sym_DOT,
    ACTIONS(1477), 1,
      anon_sym_LPAREN,
    ACTIONS(1491), 1,
      anon_sym_LBRACK,
    ACTIONS(1493), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1501), 1,
      anon_sym_AMP,
    ACTIONS(1503), 1,
      anon_sym_CARET,
    ACTIONS(1481), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1483), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(1489), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(633), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(1497), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(1573), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1571), 19,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [36284] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1475), 1,
      anon_sym_DOT,
    ACTIONS(1477), 1,
      anon_sym_LPAREN,
    ACTIONS(1491), 1,
      anon_sym_LBRACK,
    ACTIONS(1549), 1,
      anon_sym_PIPE,
    ACTIONS(1553), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1559), 1,
      anon_sym_AMP,
    ACTIONS(1561), 1,
      anon_sym_CARET,
    ACTIONS(1543), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1545), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(1551), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(633), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(1555), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(1585), 3,
      anon_sym_as,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1583), 18,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [36355] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1475), 1,
      anon_sym_DOT,
    ACTIONS(1477), 1,
      anon_sym_LPAREN,
    ACTIONS(1491), 1,
      anon_sym_LBRACK,
    ACTIONS(1553), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1561), 1,
      anon_sym_CARET,
    ACTIONS(1543), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1545), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(1551), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(633), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(1555), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(1573), 3,
      anon_sym_as,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1571), 20,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [36422] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1475), 1,
      anon_sym_DOT,
    ACTIONS(1477), 1,
      anon_sym_LPAREN,
    ACTIONS(1491), 1,
      anon_sym_LBRACK,
    ACTIONS(1553), 1,
      anon_sym_STAR_STAR,
    STATE(633), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(1577), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1575), 28,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [36479] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1475), 1,
      anon_sym_DOT,
    ACTIONS(1477), 1,
      anon_sym_LPAREN,
    ACTIONS(1491), 1,
      anon_sym_LBRACK,
    ACTIONS(1549), 1,
      anon_sym_PIPE,
    ACTIONS(1553), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1559), 1,
      anon_sym_AMP,
    ACTIONS(1561), 1,
      anon_sym_CARET,
    ACTIONS(1543), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1545), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(1551), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(633), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(1555), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(1589), 3,
      anon_sym_as,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1587), 18,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [36550] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1475), 1,
      anon_sym_DOT,
    ACTIONS(1477), 1,
      anon_sym_LPAREN,
    ACTIONS(1487), 1,
      anon_sym_PIPE,
    ACTIONS(1491), 1,
      anon_sym_LBRACK,
    ACTIONS(1493), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1501), 1,
      anon_sym_AMP,
    ACTIONS(1503), 1,
      anon_sym_CARET,
    ACTIONS(1481), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1483), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(1489), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(633), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(1497), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(1589), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1587), 18,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_in,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [36621] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1475), 1,
      anon_sym_DOT,
    ACTIONS(1477), 1,
      anon_sym_LPAREN,
    ACTIONS(1487), 1,
      anon_sym_PIPE,
    ACTIONS(1491), 1,
      anon_sym_LBRACK,
    ACTIONS(1493), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1501), 1,
      anon_sym_AMP,
    ACTIONS(1503), 1,
      anon_sym_CARET,
    ACTIONS(1481), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1483), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(1489), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(633), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(1497), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(1585), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1583), 18,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_in,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [36692] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1475), 1,
      anon_sym_DOT,
    ACTIONS(1477), 1,
      anon_sym_LPAREN,
    ACTIONS(1487), 1,
      anon_sym_PIPE,
    ACTIONS(1491), 1,
      anon_sym_LBRACK,
    ACTIONS(1493), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1501), 1,
      anon_sym_AMP,
    ACTIONS(1503), 1,
      anon_sym_CARET,
    ACTIONS(1481), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1483), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(1489), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(633), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(1497), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(1581), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1579), 18,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_in,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [36763] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1475), 1,
      anon_sym_DOT,
    ACTIONS(1477), 1,
      anon_sym_LPAREN,
    ACTIONS(1491), 1,
      anon_sym_LBRACK,
    ACTIONS(1493), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1481), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1489), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(633), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(1497), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(1573), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1571), 23,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [36826] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1591), 1,
      anon_sym_COLON_EQ,
    ACTIONS(1053), 6,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_COLON,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1048), 31,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [36874] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(608), 1,
      anon_sym_COLON_EQ,
    ACTIONS(276), 6,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_COLON,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(303), 31,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [36922] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym_LBRACE,
    ACTIONS(81), 1,
      sym__string_start,
    ACTIONS(559), 1,
      anon_sym_LPAREN,
    ACTIONS(563), 1,
      anon_sym_LBRACK,
    ACTIONS(1595), 1,
      anon_sym_not,
    STATE(713), 1,
      sym_string,
    STATE(733), 1,
      sym_primary_expression,
    ACTIONS(75), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(47), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(77), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1593), 6,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_await,
    STATE(797), 15,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [36988] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(624), 1,
      anon_sym_LPAREN,
    ACTIONS(632), 1,
      anon_sym_LBRACK,
    ACTIONS(634), 1,
      anon_sym_LBRACE,
    ACTIONS(646), 1,
      sym__string_start,
    ACTIONS(1599), 1,
      anon_sym_not,
    STATE(742), 1,
      sym_string,
    STATE(751), 1,
      sym_primary_expression,
    ACTIONS(640), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(630), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(642), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1597), 6,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_await,
    STATE(811), 15,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [37054] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1151), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1146), 33,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [37100] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1170), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1165), 33,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [37146] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(278), 1,
      anon_sym_LPAREN,
    ACTIONS(293), 1,
      anon_sym_LBRACK,
    ACTIONS(295), 1,
      anon_sym_LBRACE,
    ACTIONS(315), 1,
      sym__string_start,
    ACTIONS(1603), 1,
      anon_sym_not,
    STATE(600), 1,
      sym_string,
    STATE(665), 1,
      sym_primary_expression,
    ACTIONS(309), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(301), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(311), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1601), 6,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_await,
    STATE(642), 15,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [37212] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1074), 1,
      anon_sym_COLON_EQ,
    ACTIONS(1053), 6,
      anon_sym_STAR,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1048), 31,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_else,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [37260] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(568), 1,
      anon_sym_COLON_EQ,
    ACTIONS(276), 6,
      anon_sym_STAR,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(303), 31,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_else,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym_type_conversion,
  [37308] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(295), 1,
      anon_sym_LBRACE,
    ACTIONS(315), 1,
      sym__string_start,
    ACTIONS(604), 1,
      anon_sym_LPAREN,
    ACTIONS(612), 1,
      anon_sym_LBRACK,
    ACTIONS(1605), 1,
      anon_sym_not,
    STATE(600), 1,
      sym_string,
    STATE(652), 1,
      sym_primary_expression,
    ACTIONS(309), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(610), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(311), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1601), 6,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_await,
    STATE(642), 15,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [37374] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1607), 1,
      sym__string_start,
    STATE(677), 2,
      sym_string,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(1394), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1392), 31,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [37424] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(646), 1,
      sym__string_start,
    STATE(677), 2,
      sym_string,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(1390), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1388), 31,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [37474] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(278), 1,
      anon_sym_LPAREN,
    ACTIONS(293), 1,
      anon_sym_LBRACK,
    ACTIONS(295), 1,
      anon_sym_LBRACE,
    ACTIONS(315), 1,
      sym__string_start,
    STATE(600), 1,
      sym_string,
    STATE(663), 1,
      sym_primary_expression,
    ACTIONS(309), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(301), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(311), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1601), 6,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_await,
    STATE(642), 15,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [37537] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(624), 1,
      anon_sym_LPAREN,
    ACTIONS(632), 1,
      anon_sym_LBRACK,
    ACTIONS(634), 1,
      anon_sym_LBRACE,
    ACTIONS(646), 1,
      sym__string_start,
    STATE(742), 1,
      sym_string,
    STATE(751), 1,
      sym_primary_expression,
    ACTIONS(640), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(630), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(642), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1597), 6,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_await,
    STATE(811), 15,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [37600] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(624), 1,
      anon_sym_LPAREN,
    ACTIONS(632), 1,
      anon_sym_LBRACK,
    ACTIONS(634), 1,
      anon_sym_LBRACE,
    ACTIONS(646), 1,
      sym__string_start,
    STATE(742), 1,
      sym_string,
    STATE(747), 1,
      sym_primary_expression,
    ACTIONS(640), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(630), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(642), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1597), 6,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_await,
    STATE(811), 15,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [37663] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(624), 1,
      anon_sym_LPAREN,
    ACTIONS(632), 1,
      anon_sym_LBRACK,
    ACTIONS(634), 1,
      anon_sym_LBRACE,
    ACTIONS(646), 1,
      sym__string_start,
    STATE(742), 1,
      sym_string,
    STATE(763), 1,
      sym_primary_expression,
    ACTIONS(640), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(630), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(642), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1597), 6,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_await,
    STATE(811), 15,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [37726] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(624), 1,
      anon_sym_LPAREN,
    ACTIONS(632), 1,
      anon_sym_LBRACK,
    ACTIONS(634), 1,
      anon_sym_LBRACE,
    ACTIONS(646), 1,
      sym__string_start,
    STATE(742), 1,
      sym_string,
    STATE(766), 1,
      sym_primary_expression,
    ACTIONS(640), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(630), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(642), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1597), 6,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_await,
    STATE(811), 15,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [37789] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1495), 1,
      anon_sym_EQ,
    ACTIONS(1610), 1,
      anon_sym_DOT,
    ACTIONS(1612), 1,
      anon_sym_LPAREN,
    ACTIONS(1620), 1,
      anon_sym_PIPE,
    ACTIONS(1624), 1,
      anon_sym_LBRACK,
    ACTIONS(1626), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1630), 1,
      anon_sym_not,
    ACTIONS(1632), 1,
      anon_sym_AMP,
    ACTIONS(1634), 1,
      anon_sym_CARET,
    ACTIONS(1638), 1,
      anon_sym_is,
    STATE(878), 1,
      aux_sym_comparison_operator_repeat1,
    ACTIONS(1614), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1616), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(1622), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1636), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(792), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(1628), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(1618), 6,
      anon_sym_in,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
    ACTIONS(1479), 7,
      sym__newline,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_and,
      anon_sym_or,
      sym__semicolon,
  [37868] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(278), 1,
      anon_sym_LPAREN,
    ACTIONS(293), 1,
      anon_sym_LBRACK,
    ACTIONS(295), 1,
      anon_sym_LBRACE,
    ACTIONS(315), 1,
      sym__string_start,
    ACTIONS(1525), 1,
      sym_identifier,
    STATE(600), 1,
      sym_string,
    STATE(882), 1,
      sym_primary_expression,
    ACTIONS(309), 2,
      sym_ellipsis,
      sym_float,
    STATE(762), 2,
      sym_attribute,
      sym_subscript,
    ACTIONS(301), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(311), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1529), 6,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_await,
    STATE(642), 13,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [37935] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(278), 1,
      anon_sym_LPAREN,
    ACTIONS(293), 1,
      anon_sym_LBRACK,
    ACTIONS(295), 1,
      anon_sym_LBRACE,
    ACTIONS(315), 1,
      sym__string_start,
    STATE(600), 1,
      sym_string,
    STATE(656), 1,
      sym_primary_expression,
    ACTIONS(309), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(301), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(311), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1601), 6,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_await,
    STATE(642), 15,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [37998] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(278), 1,
      anon_sym_LPAREN,
    ACTIONS(293), 1,
      anon_sym_LBRACK,
    ACTIONS(295), 1,
      anon_sym_LBRACE,
    ACTIONS(315), 1,
      sym__string_start,
    STATE(600), 1,
      sym_string,
    STATE(646), 1,
      sym_primary_expression,
    ACTIONS(309), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(301), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(311), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1601), 6,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_await,
    STATE(642), 15,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [38061] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(295), 1,
      anon_sym_LBRACE,
    ACTIONS(315), 1,
      sym__string_start,
    ACTIONS(604), 1,
      anon_sym_LPAREN,
    ACTIONS(612), 1,
      anon_sym_LBRACK,
    STATE(600), 1,
      sym_string,
    STATE(659), 1,
      sym_primary_expression,
    ACTIONS(309), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(610), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(311), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1601), 6,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_await,
    STATE(642), 15,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [38124] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1640), 1,
      sym__string_start,
    STATE(689), 2,
      sym_string,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(1394), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1392), 29,
      sym__newline,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym__semicolon,
  [38173] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(278), 1,
      anon_sym_LPAREN,
    ACTIONS(293), 1,
      anon_sym_LBRACK,
    ACTIONS(295), 1,
      anon_sym_LBRACE,
    ACTIONS(315), 1,
      sym__string_start,
    STATE(600), 1,
      sym_string,
    STATE(645), 1,
      sym_primary_expression,
    ACTIONS(309), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(301), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(311), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1601), 6,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_await,
    STATE(642), 15,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [38236] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(624), 1,
      anon_sym_LPAREN,
    ACTIONS(632), 1,
      anon_sym_LBRACK,
    ACTIONS(634), 1,
      anon_sym_LBRACE,
    ACTIONS(646), 1,
      sym__string_start,
    STATE(742), 1,
      sym_string,
    STATE(746), 1,
      sym_primary_expression,
    ACTIONS(640), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(630), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(642), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1597), 6,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_await,
    STATE(811), 15,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [38299] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(278), 1,
      anon_sym_LPAREN,
    ACTIONS(293), 1,
      anon_sym_LBRACK,
    ACTIONS(295), 1,
      anon_sym_LBRACE,
    ACTIONS(315), 1,
      sym__string_start,
    STATE(600), 1,
      sym_string,
    STATE(651), 1,
      sym_primary_expression,
    ACTIONS(309), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(301), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(311), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1601), 6,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_await,
    STATE(642), 15,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [38362] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(295), 1,
      anon_sym_LBRACE,
    ACTIONS(315), 1,
      sym__string_start,
    ACTIONS(604), 1,
      anon_sym_LPAREN,
    ACTIONS(612), 1,
      anon_sym_LBRACK,
    STATE(600), 1,
      sym_string,
    STATE(647), 1,
      sym_primary_expression,
    ACTIONS(309), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(610), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(311), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1601), 6,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_await,
    STATE(642), 15,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [38425] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym_LBRACE,
    ACTIONS(81), 1,
      sym__string_start,
    ACTIONS(559), 1,
      anon_sym_LPAREN,
    ACTIONS(563), 1,
      anon_sym_LBRACK,
    STATE(713), 1,
      sym_string,
    STATE(731), 1,
      sym_primary_expression,
    ACTIONS(75), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(47), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(77), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1593), 6,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_await,
    STATE(797), 15,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [38488] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(278), 1,
      anon_sym_LPAREN,
    ACTIONS(293), 1,
      anon_sym_LBRACK,
    ACTIONS(295), 1,
      anon_sym_LBRACE,
    ACTIONS(315), 1,
      sym__string_start,
    STATE(600), 1,
      sym_string,
    STATE(658), 1,
      sym_primary_expression,
    ACTIONS(309), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(301), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(311), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1601), 6,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_await,
    STATE(642), 15,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [38551] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(278), 1,
      anon_sym_LPAREN,
    ACTIONS(293), 1,
      anon_sym_LBRACK,
    ACTIONS(295), 1,
      anon_sym_LBRACE,
    ACTIONS(315), 1,
      sym__string_start,
    STATE(600), 1,
      sym_string,
    STATE(665), 1,
      sym_primary_expression,
    ACTIONS(309), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(301), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(311), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1601), 6,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_await,
    STATE(642), 15,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [38614] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(624), 1,
      anon_sym_LPAREN,
    ACTIONS(632), 1,
      anon_sym_LBRACK,
    ACTIONS(634), 1,
      anon_sym_LBRACE,
    ACTIONS(646), 1,
      sym__string_start,
    STATE(742), 1,
      sym_string,
    STATE(750), 1,
      sym_primary_expression,
    ACTIONS(640), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(630), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(642), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1597), 6,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_await,
    STATE(811), 15,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [38677] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(295), 1,
      anon_sym_LBRACE,
    ACTIONS(315), 1,
      sym__string_start,
    ACTIONS(604), 1,
      anon_sym_LPAREN,
    ACTIONS(612), 1,
      anon_sym_LBRACK,
    STATE(600), 1,
      sym_string,
    STATE(649), 1,
      sym_primary_expression,
    ACTIONS(309), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(610), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(311), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1601), 6,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_await,
    STATE(642), 15,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [38740] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(624), 1,
      anon_sym_LPAREN,
    ACTIONS(632), 1,
      anon_sym_LBRACK,
    ACTIONS(634), 1,
      anon_sym_LBRACE,
    ACTIONS(646), 1,
      sym__string_start,
    STATE(742), 1,
      sym_string,
    STATE(756), 1,
      sym_primary_expression,
    ACTIONS(640), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(630), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(642), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1597), 6,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_await,
    STATE(811), 15,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [38803] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym_LBRACE,
    ACTIONS(81), 1,
      sym__string_start,
    ACTIONS(559), 1,
      anon_sym_LPAREN,
    ACTIONS(563), 1,
      anon_sym_LBRACK,
    STATE(713), 1,
      sym_string,
    STATE(743), 1,
      sym_primary_expression,
    ACTIONS(75), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(47), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(77), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1593), 6,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_await,
    STATE(797), 15,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [38866] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym_LBRACE,
    ACTIONS(81), 1,
      sym__string_start,
    ACTIONS(559), 1,
      anon_sym_LPAREN,
    ACTIONS(563), 1,
      anon_sym_LBRACK,
    STATE(713), 1,
      sym_string,
    STATE(734), 1,
      sym_primary_expression,
    ACTIONS(75), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(47), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(77), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1593), 6,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_await,
    STATE(797), 15,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [38929] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(295), 1,
      anon_sym_LBRACE,
    ACTIONS(315), 1,
      sym__string_start,
    ACTIONS(604), 1,
      anon_sym_LPAREN,
    ACTIONS(612), 1,
      anon_sym_LBRACK,
    STATE(600), 1,
      sym_string,
    STATE(652), 1,
      sym_primary_expression,
    ACTIONS(309), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(610), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(311), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1601), 6,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_await,
    STATE(642), 15,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [38992] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(295), 1,
      anon_sym_LBRACE,
    ACTIONS(315), 1,
      sym__string_start,
    ACTIONS(604), 1,
      anon_sym_LPAREN,
    ACTIONS(612), 1,
      anon_sym_LBRACK,
    STATE(600), 1,
      sym_string,
    STATE(653), 1,
      sym_primary_expression,
    ACTIONS(309), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(610), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(311), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1601), 6,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_await,
    STATE(642), 15,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [39055] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(295), 1,
      anon_sym_LBRACE,
    ACTIONS(315), 1,
      sym__string_start,
    ACTIONS(604), 1,
      anon_sym_LPAREN,
    ACTIONS(612), 1,
      anon_sym_LBRACK,
    STATE(600), 1,
      sym_string,
    STATE(654), 1,
      sym_primary_expression,
    ACTIONS(309), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(610), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(311), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1601), 6,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_await,
    STATE(642), 15,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [39118] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(295), 1,
      anon_sym_LBRACE,
    ACTIONS(315), 1,
      sym__string_start,
    ACTIONS(604), 1,
      anon_sym_LPAREN,
    ACTIONS(612), 1,
      anon_sym_LBRACK,
    STATE(600), 1,
      sym_string,
    STATE(655), 1,
      sym_primary_expression,
    ACTIONS(309), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(610), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(311), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1601), 6,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_await,
    STATE(642), 15,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [39181] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym_LBRACE,
    ACTIONS(81), 1,
      sym__string_start,
    ACTIONS(559), 1,
      anon_sym_LPAREN,
    ACTIONS(563), 1,
      anon_sym_LBRACK,
    STATE(713), 1,
      sym_string,
    STATE(741), 1,
      sym_primary_expression,
    ACTIONS(75), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(47), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(77), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1593), 6,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_await,
    STATE(797), 15,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [39244] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(278), 1,
      anon_sym_LPAREN,
    ACTIONS(293), 1,
      anon_sym_LBRACK,
    ACTIONS(295), 1,
      anon_sym_LBRACE,
    ACTIONS(315), 1,
      sym__string_start,
    STATE(600), 1,
      sym_string,
    STATE(666), 1,
      sym_primary_expression,
    ACTIONS(309), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(301), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(311), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1601), 6,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_await,
    STATE(642), 15,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [39307] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(624), 1,
      anon_sym_LPAREN,
    ACTIONS(632), 1,
      anon_sym_LBRACK,
    ACTIONS(634), 1,
      anon_sym_LBRACE,
    ACTIONS(646), 1,
      sym__string_start,
    STATE(742), 1,
      sym_string,
    STATE(761), 1,
      sym_primary_expression,
    ACTIONS(640), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(630), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(642), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1597), 6,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_await,
    STATE(811), 15,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [39370] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(295), 1,
      anon_sym_LBRACE,
    ACTIONS(315), 1,
      sym__string_start,
    ACTIONS(604), 1,
      anon_sym_LPAREN,
    ACTIONS(612), 1,
      anon_sym_LBRACK,
    STATE(600), 1,
      sym_string,
    STATE(661), 1,
      sym_primary_expression,
    ACTIONS(309), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(610), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(311), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1601), 6,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_await,
    STATE(642), 15,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [39433] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(295), 1,
      anon_sym_LBRACE,
    ACTIONS(315), 1,
      sym__string_start,
    ACTIONS(604), 1,
      anon_sym_LPAREN,
    ACTIONS(612), 1,
      anon_sym_LBRACK,
    STATE(600), 1,
      sym_string,
    STATE(660), 1,
      sym_primary_expression,
    ACTIONS(309), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(610), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(311), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1601), 6,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_await,
    STATE(642), 15,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [39496] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(295), 1,
      anon_sym_LBRACE,
    ACTIONS(315), 1,
      sym__string_start,
    ACTIONS(604), 1,
      anon_sym_LPAREN,
    ACTIONS(612), 1,
      anon_sym_LBRACK,
    STATE(600), 1,
      sym_string,
    STATE(657), 1,
      sym_primary_expression,
    ACTIONS(309), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(610), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(311), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1601), 6,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_await,
    STATE(642), 15,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [39559] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(295), 1,
      anon_sym_LBRACE,
    ACTIONS(315), 1,
      sym__string_start,
    ACTIONS(604), 1,
      anon_sym_LPAREN,
    ACTIONS(612), 1,
      anon_sym_LBRACK,
    STATE(600), 1,
      sym_string,
    STATE(662), 1,
      sym_primary_expression,
    ACTIONS(309), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(610), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(311), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1601), 6,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_await,
    STATE(642), 15,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [39622] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(81), 1,
      sym__string_start,
    STATE(720), 2,
      sym_string,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(1053), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1048), 29,
      sym__newline,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym__semicolon,
  [39671] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym_LBRACE,
    ACTIONS(81), 1,
      sym__string_start,
    ACTIONS(559), 1,
      anon_sym_LPAREN,
    ACTIONS(563), 1,
      anon_sym_LBRACK,
    STATE(713), 1,
      sym_string,
    STATE(739), 1,
      sym_primary_expression,
    ACTIONS(75), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(47), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(77), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1593), 6,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_await,
    STATE(797), 15,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [39734] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(278), 1,
      anon_sym_LPAREN,
    ACTIONS(293), 1,
      anon_sym_LBRACK,
    ACTIONS(295), 1,
      anon_sym_LBRACE,
    ACTIONS(315), 1,
      sym__string_start,
    ACTIONS(1643), 1,
      sym_identifier,
    STATE(600), 1,
      sym_string,
    STATE(882), 1,
      sym_primary_expression,
    ACTIONS(309), 2,
      sym_ellipsis,
      sym_float,
    STATE(879), 2,
      sym_attribute,
      sym_subscript,
    ACTIONS(301), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(311), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1645), 6,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_await,
    STATE(642), 13,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [39801] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(278), 1,
      anon_sym_LPAREN,
    ACTIONS(293), 1,
      anon_sym_LBRACK,
    ACTIONS(295), 1,
      anon_sym_LBRACE,
    ACTIONS(315), 1,
      sym__string_start,
    STATE(600), 1,
      sym_string,
    STATE(648), 1,
      sym_primary_expression,
    ACTIONS(309), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(301), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(311), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1601), 6,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_await,
    STATE(642), 15,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [39864] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym_LBRACE,
    ACTIONS(81), 1,
      sym__string_start,
    ACTIONS(559), 1,
      anon_sym_LPAREN,
    ACTIONS(563), 1,
      anon_sym_LBRACK,
    STATE(713), 1,
      sym_string,
    STATE(738), 1,
      sym_primary_expression,
    ACTIONS(75), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(47), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(77), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1593), 6,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_await,
    STATE(797), 15,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [39927] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(278), 1,
      anon_sym_LPAREN,
    ACTIONS(293), 1,
      anon_sym_LBRACK,
    ACTIONS(295), 1,
      anon_sym_LBRACE,
    ACTIONS(315), 1,
      sym__string_start,
    STATE(600), 1,
      sym_string,
    STATE(664), 1,
      sym_primary_expression,
    ACTIONS(309), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(301), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(311), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1601), 6,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_await,
    STATE(642), 15,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [39990] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym_LBRACE,
    ACTIONS(81), 1,
      sym__string_start,
    ACTIONS(559), 1,
      anon_sym_LPAREN,
    ACTIONS(563), 1,
      anon_sym_LBRACK,
    STATE(713), 1,
      sym_string,
    STATE(745), 1,
      sym_primary_expression,
    ACTIONS(75), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(47), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(77), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1593), 6,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_await,
    STATE(797), 15,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [40053] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(81), 1,
      sym__string_start,
    STATE(689), 2,
      sym_string,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(1390), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1388), 29,
      sym__newline,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym__semicolon,
  [40102] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym_LBRACE,
    ACTIONS(81), 1,
      sym__string_start,
    ACTIONS(559), 1,
      anon_sym_LPAREN,
    ACTIONS(563), 1,
      anon_sym_LBRACK,
    STATE(713), 1,
      sym_string,
    STATE(737), 1,
      sym_primary_expression,
    ACTIONS(75), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(47), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(77), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1593), 6,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_await,
    STATE(797), 15,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [40165] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym_LBRACE,
    ACTIONS(81), 1,
      sym__string_start,
    ACTIONS(559), 1,
      anon_sym_LPAREN,
    ACTIONS(563), 1,
      anon_sym_LBRACK,
    STATE(713), 1,
      sym_string,
    STATE(733), 1,
      sym_primary_expression,
    ACTIONS(75), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(47), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(77), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1593), 6,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_await,
    STATE(797), 15,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [40228] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym_LBRACE,
    ACTIONS(81), 1,
      sym__string_start,
    ACTIONS(559), 1,
      anon_sym_LPAREN,
    ACTIONS(563), 1,
      anon_sym_LBRACK,
    STATE(713), 1,
      sym_string,
    STATE(732), 1,
      sym_primary_expression,
    ACTIONS(75), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(47), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(77), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1593), 6,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_await,
    STATE(797), 15,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [40291] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(624), 1,
      anon_sym_LPAREN,
    ACTIONS(632), 1,
      anon_sym_LBRACK,
    ACTIONS(634), 1,
      anon_sym_LBRACE,
    ACTIONS(646), 1,
      sym__string_start,
    STATE(742), 1,
      sym_string,
    STATE(757), 1,
      sym_primary_expression,
    ACTIONS(640), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(630), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(642), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1597), 6,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_await,
    STATE(811), 15,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [40354] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1170), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1165), 32,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [40399] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(278), 1,
      anon_sym_LPAREN,
    ACTIONS(293), 1,
      anon_sym_LBRACK,
    ACTIONS(295), 1,
      anon_sym_LBRACE,
    ACTIONS(315), 1,
      sym__string_start,
    STATE(600), 1,
      sym_string,
    STATE(650), 1,
      sym_primary_expression,
    ACTIONS(309), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(301), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(311), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1601), 6,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_await,
    STATE(642), 15,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [40462] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1151), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1146), 32,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [40507] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(624), 1,
      anon_sym_LPAREN,
    ACTIONS(632), 1,
      anon_sym_LBRACK,
    ACTIONS(634), 1,
      anon_sym_LBRACE,
    ACTIONS(646), 1,
      sym__string_start,
    STATE(742), 1,
      sym_string,
    STATE(752), 1,
      sym_primary_expression,
    ACTIONS(640), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(630), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(642), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1597), 6,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_await,
    STATE(811), 15,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [40570] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(624), 1,
      anon_sym_LPAREN,
    ACTIONS(632), 1,
      anon_sym_LBRACK,
    ACTIONS(634), 1,
      anon_sym_LBRACE,
    ACTIONS(646), 1,
      sym__string_start,
    STATE(742), 1,
      sym_string,
    STATE(753), 1,
      sym_primary_expression,
    ACTIONS(640), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(630), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(642), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1597), 6,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_await,
    STATE(811), 15,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [40633] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(51), 1,
      anon_sym_LBRACE,
    ACTIONS(81), 1,
      sym__string_start,
    ACTIONS(559), 1,
      anon_sym_LPAREN,
    ACTIONS(563), 1,
      anon_sym_LBRACK,
    STATE(713), 1,
      sym_string,
    STATE(735), 1,
      sym_primary_expression,
    ACTIONS(75), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(47), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(77), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1593), 6,
      anon_sym_print,
      anon_sym_async,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_await,
    STATE(797), 15,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_generator_expression,
      sym_parenthesized_expression,
      sym_concatenated_string,
  [40696] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1610), 1,
      anon_sym_DOT,
    ACTIONS(1612), 1,
      anon_sym_LPAREN,
    ACTIONS(1620), 1,
      anon_sym_PIPE,
    ACTIONS(1624), 1,
      anon_sym_LBRACK,
    ACTIONS(1626), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1632), 1,
      anon_sym_AMP,
    ACTIONS(1634), 1,
      anon_sym_CARET,
    ACTIONS(1614), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1616), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(1622), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(792), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(1589), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1628), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(1587), 15,
      sym__newline,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_in,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym__semicolon,
  [40764] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1610), 1,
      anon_sym_DOT,
    ACTIONS(1612), 1,
      anon_sym_LPAREN,
    ACTIONS(1624), 1,
      anon_sym_LBRACK,
    ACTIONS(1626), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1614), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1622), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(792), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(1573), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1628), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(1571), 20,
      sym__newline,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym__semicolon,
  [40824] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1610), 1,
      anon_sym_DOT,
    ACTIONS(1612), 1,
      anon_sym_LPAREN,
    ACTIONS(1620), 1,
      anon_sym_PIPE,
    ACTIONS(1624), 1,
      anon_sym_LBRACK,
    ACTIONS(1626), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1632), 1,
      anon_sym_AMP,
    ACTIONS(1634), 1,
      anon_sym_CARET,
    ACTIONS(1614), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1616), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(1622), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(792), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(1581), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1628), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(1579), 15,
      sym__newline,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_in,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym__semicolon,
  [40892] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1610), 1,
      anon_sym_DOT,
    ACTIONS(1612), 1,
      anon_sym_LPAREN,
    ACTIONS(1620), 1,
      anon_sym_PIPE,
    ACTIONS(1624), 1,
      anon_sym_LBRACK,
    ACTIONS(1626), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1632), 1,
      anon_sym_AMP,
    ACTIONS(1634), 1,
      anon_sym_CARET,
    ACTIONS(1614), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1616), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(1622), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(792), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(1585), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1628), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(1583), 15,
      sym__newline,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_in,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym__semicolon,
  [40960] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1610), 1,
      anon_sym_DOT,
    ACTIONS(1612), 1,
      anon_sym_LPAREN,
    ACTIONS(1624), 1,
      anon_sym_LBRACK,
    ACTIONS(1626), 1,
      anon_sym_STAR_STAR,
    STATE(792), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(1573), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1571), 25,
      sym__newline,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_AT,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym__semicolon,
  [41014] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1401), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1399), 32,
      sym__string_start,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [41058] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1610), 1,
      anon_sym_DOT,
    ACTIONS(1612), 1,
      anon_sym_LPAREN,
    ACTIONS(1624), 1,
      anon_sym_LBRACK,
    ACTIONS(1626), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1632), 1,
      anon_sym_AMP,
    ACTIONS(1634), 1,
      anon_sym_CARET,
    ACTIONS(1614), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1616), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(1622), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(792), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(1573), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1628), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(1571), 16,
      sym__newline,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym__semicolon,
  [41124] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1610), 1,
      anon_sym_DOT,
    ACTIONS(1612), 1,
      anon_sym_LPAREN,
    ACTIONS(1624), 1,
      anon_sym_LBRACK,
    ACTIONS(1626), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1614), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    STATE(792), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(1573), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1628), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(1571), 22,
      sym__newline,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym__semicolon,
  [41182] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1610), 1,
      anon_sym_DOT,
    ACTIONS(1612), 1,
      anon_sym_LPAREN,
    ACTIONS(1624), 1,
      anon_sym_LBRACK,
    ACTIONS(1626), 1,
      anon_sym_STAR_STAR,
    STATE(792), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(1573), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1571), 25,
      sym__newline,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_AT,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym__semicolon,
  [41236] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1647), 1,
      anon_sym_DOT,
    ACTIONS(1649), 1,
      anon_sym_LPAREN,
    ACTIONS(1657), 1,
      anon_sym_PIPE,
    ACTIONS(1661), 1,
      anon_sym_LBRACK,
    ACTIONS(1663), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1667), 1,
      anon_sym_not,
    ACTIONS(1669), 1,
      anon_sym_AMP,
    ACTIONS(1671), 1,
      anon_sym_CARET,
    ACTIONS(1675), 1,
      anon_sym_is,
    STATE(881), 1,
      aux_sym_comparison_operator_repeat1,
    ACTIONS(1651), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1653), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(1659), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1673), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(847), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(1665), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(1655), 6,
      anon_sym_in,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
    ACTIONS(1479), 7,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_or,
  [41312] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1610), 1,
      anon_sym_DOT,
    ACTIONS(1612), 1,
      anon_sym_LPAREN,
    ACTIONS(1624), 1,
      anon_sym_LBRACK,
    ACTIONS(1626), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1634), 1,
      anon_sym_CARET,
    ACTIONS(1614), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1616), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(1622), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(792), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(1573), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1628), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(1571), 17,
      sym__newline,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym__semicolon,
  [41376] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(646), 1,
      sym__string_start,
    STATE(678), 2,
      sym_string,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(1053), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1048), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [41424] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1610), 1,
      anon_sym_DOT,
    ACTIONS(1612), 1,
      anon_sym_LPAREN,
    ACTIONS(1624), 1,
      anon_sym_LBRACK,
    ACTIONS(1626), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1614), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1616), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(1622), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(792), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(1573), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1628), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(1571), 18,
      sym__newline,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym__semicolon,
  [41486] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1405), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1403), 32,
      sym__string_start,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [41530] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1610), 1,
      anon_sym_DOT,
    ACTIONS(1612), 1,
      anon_sym_LPAREN,
    ACTIONS(1624), 1,
      anon_sym_LBRACK,
    ACTIONS(1626), 1,
      anon_sym_STAR_STAR,
    STATE(792), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(1577), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1575), 25,
      sym__newline,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_AT,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym__semicolon,
  [41584] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1647), 1,
      anon_sym_DOT,
    ACTIONS(1649), 1,
      anon_sym_LPAREN,
    ACTIONS(1657), 1,
      anon_sym_PIPE,
    ACTIONS(1661), 1,
      anon_sym_LBRACK,
    ACTIONS(1663), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1669), 1,
      anon_sym_AMP,
    ACTIONS(1671), 1,
      anon_sym_CARET,
    ACTIONS(1589), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1651), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1653), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(1659), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(847), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(1665), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(1587), 15,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [41651] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1647), 1,
      anon_sym_DOT,
    ACTIONS(1649), 1,
      anon_sym_LPAREN,
    ACTIONS(1661), 1,
      anon_sym_LBRACK,
    ACTIONS(1663), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1573), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1651), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    STATE(847), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(1665), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(1571), 22,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [41708] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(303), 3,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
    ACTIONS(276), 13,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(307), 19,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [41753] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1591), 1,
      anon_sym_COLON_EQ,
    ACTIONS(1050), 3,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(1053), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1048), 27,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [41800] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1647), 1,
      anon_sym_DOT,
    ACTIONS(1649), 1,
      anon_sym_LPAREN,
    ACTIONS(1661), 1,
      anon_sym_LBRACK,
    ACTIONS(1663), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1669), 1,
      anon_sym_AMP,
    ACTIONS(1671), 1,
      anon_sym_CARET,
    ACTIONS(1573), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1651), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1653), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(1659), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(847), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(1665), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(1571), 16,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [41865] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1647), 1,
      anon_sym_DOT,
    ACTIONS(1649), 1,
      anon_sym_LPAREN,
    ACTIONS(1657), 1,
      anon_sym_PIPE,
    ACTIONS(1661), 1,
      anon_sym_LBRACK,
    ACTIONS(1663), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1669), 1,
      anon_sym_AMP,
    ACTIONS(1671), 1,
      anon_sym_CARET,
    ACTIONS(1581), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1651), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1653), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(1659), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(847), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(1665), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(1579), 15,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [41932] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1647), 1,
      anon_sym_DOT,
    ACTIONS(1649), 1,
      anon_sym_LPAREN,
    ACTIONS(1661), 1,
      anon_sym_LBRACK,
    ACTIONS(1663), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1573), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1651), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1659), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(847), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(1665), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(1571), 20,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [41991] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1647), 1,
      anon_sym_DOT,
    ACTIONS(1649), 1,
      anon_sym_LPAREN,
    ACTIONS(1661), 1,
      anon_sym_LBRACK,
    ACTIONS(1663), 1,
      anon_sym_STAR_STAR,
    STATE(847), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(1573), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1571), 25,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_AT,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [42044] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1055), 1,
      anon_sym_COLON_EQ,
    ACTIONS(1053), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1048), 29,
      sym__newline,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym__semicolon,
  [42089] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(287), 1,
      anon_sym_COLON_EQ,
    ACTIONS(276), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(303), 29,
      sym__newline,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym__semicolon,
  [42134] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1647), 1,
      anon_sym_DOT,
    ACTIONS(1649), 1,
      anon_sym_LPAREN,
    ACTIONS(1661), 1,
      anon_sym_LBRACK,
    ACTIONS(1663), 1,
      anon_sym_STAR_STAR,
    STATE(847), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(1573), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1571), 25,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_AT,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [42187] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1647), 1,
      anon_sym_DOT,
    ACTIONS(1649), 1,
      anon_sym_LPAREN,
    ACTIONS(1657), 1,
      anon_sym_PIPE,
    ACTIONS(1661), 1,
      anon_sym_LBRACK,
    ACTIONS(1663), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1669), 1,
      anon_sym_AMP,
    ACTIONS(1671), 1,
      anon_sym_CARET,
    ACTIONS(1585), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1651), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1653), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(1659), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(847), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(1665), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(1583), 15,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [42254] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1401), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1399), 30,
      sym__newline,
      sym__string_start,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym__semicolon,
  [42297] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1591), 1,
      anon_sym_COLON_EQ,
    ACTIONS(1677), 1,
      anon_sym_EQ,
    ACTIONS(1053), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1048), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [42344] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(608), 1,
      anon_sym_COLON_EQ,
    ACTIONS(620), 1,
      anon_sym_EQ,
    ACTIONS(276), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(303), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [42391] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1647), 1,
      anon_sym_DOT,
    ACTIONS(1649), 1,
      anon_sym_LPAREN,
    ACTIONS(1661), 1,
      anon_sym_LBRACK,
    ACTIONS(1663), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1671), 1,
      anon_sym_CARET,
    ACTIONS(1573), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1651), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1653), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(1659), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(847), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(1665), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(1571), 17,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [42454] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1048), 3,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
    ACTIONS(1053), 13,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(1078), 19,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [42499] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1647), 1,
      anon_sym_DOT,
    ACTIONS(1649), 1,
      anon_sym_LPAREN,
    ACTIONS(1661), 1,
      anon_sym_LBRACK,
    ACTIONS(1663), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1573), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1651), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1653), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(1659), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(847), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(1665), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(1571), 18,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [42560] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(608), 1,
      anon_sym_COLON_EQ,
    ACTIONS(280), 3,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(276), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(303), 27,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [42607] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1165), 3,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
    ACTIONS(1170), 13,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(1172), 19,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [42652] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1647), 1,
      anon_sym_DOT,
    ACTIONS(1649), 1,
      anon_sym_LPAREN,
    ACTIONS(1661), 1,
      anon_sym_LBRACK,
    ACTIONS(1663), 1,
      anon_sym_STAR_STAR,
    STATE(847), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(1577), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1575), 25,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_AT,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [42705] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(303), 3,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
    ACTIONS(276), 13,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(572), 19,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [42750] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1146), 3,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
    ACTIONS(1151), 13,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(1153), 19,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [42795] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1405), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1403), 30,
      sym__newline,
      sym__string_start,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym__semicolon,
  [42838] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1048), 3,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
    ACTIONS(1053), 13,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(1059), 19,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [42883] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1461), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1459), 29,
      sym__newline,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym__semicolon,
  [42925] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1425), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1423), 29,
      sym__newline,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym__semicolon,
  [42967] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1457), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1455), 29,
      sym__newline,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym__semicolon,
  [43009] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1453), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1451), 29,
      sym__newline,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym__semicolon,
  [43051] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1533), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1531), 29,
      sym__newline,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym__semicolon,
  [43093] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1437), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1435), 29,
      sym__newline,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym__semicolon,
  [43135] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1449), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1447), 29,
      sym__newline,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym__semicolon,
  [43177] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1429), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1427), 29,
      sym__newline,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym__semicolon,
  [43219] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1167), 3,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(1170), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1165), 27,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [43263] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1445), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1443), 29,
      sym__newline,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym__semicolon,
  [43305] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1473), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1471), 29,
      sym__newline,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym__semicolon,
  [43347] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1417), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1415), 29,
      sym__newline,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym__semicolon,
  [43389] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1425), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1423), 29,
      sym__newline,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym__semicolon,
  [43431] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1465), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1463), 29,
      sym__newline,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym__semicolon,
  [43473] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1469), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1467), 29,
      sym__newline,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym__semicolon,
  [43515] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1151), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1146), 29,
      sym__newline,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym__semicolon,
  [43557] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1170), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1165), 29,
      sym__newline,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym__semicolon,
  [43599] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1511), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1509), 29,
      sym__newline,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym__semicolon,
  [43641] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1148), 3,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(1151), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1146), 27,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [43685] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1519), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1517), 29,
      sym__newline,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym__semicolon,
  [43727] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1523), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1521), 29,
      sym__newline,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym__semicolon,
  [43769] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1515), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1513), 29,
      sym__newline,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym__semicolon,
  [43811] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1417), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1415), 29,
      sym__newline,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym__semicolon,
  [43853] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(276), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(303), 29,
      sym__newline,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym__semicolon,
  [43895] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1413), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1411), 29,
      sym__newline,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym__semicolon,
  [43937] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1519), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1517), 29,
      sym__newline,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym__semicolon,
  [43979] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1053), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1048), 29,
      sym__newline,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym__semicolon,
  [44021] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1679), 1,
      anon_sym_COLON_EQ,
    ACTIONS(1053), 5,
      anon_sym_STAR,
      anon_sym_COLON,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1048), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [44065] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1441), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1439), 29,
      sym__newline,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym__semicolon,
  [44107] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1541), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1539), 29,
      sym__newline,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym__semicolon,
  [44149] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(628), 1,
      anon_sym_COLON_EQ,
    ACTIONS(276), 5,
      anon_sym_STAR,
      anon_sym_COLON,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(303), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [44193] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1569), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1567), 29,
      sym__newline,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym__semicolon,
  [44235] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1433), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1431), 29,
      sym__newline,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym__semicolon,
  [44277] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1409), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1407), 29,
      sym__newline,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym__semicolon,
  [44319] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1537), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1535), 29,
      sym__newline,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym__semicolon,
  [44361] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1050), 3,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(1053), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1048), 27,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [44405] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1421), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1419), 29,
      sym__newline,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym__semicolon,
  [44447] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1421), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1419), 29,
      sym__newline,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      sym__semicolon,
  [44489] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1519), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1517), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [44530] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(832), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(830), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [44571] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1053), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1048), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [44612] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1074), 1,
      anon_sym_COLON_EQ,
    ACTIONS(1677), 1,
      anon_sym_EQ,
    ACTIONS(1053), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1048), 27,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [44657] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1461), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1459), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [44698] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1457), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1455), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [44739] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1453), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1451), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [44780] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1449), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1447), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [44821] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1409), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1407), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [44862] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1445), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1443), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [44903] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1533), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1531), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [44944] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1441), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1439), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [44985] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1437), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1435), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [45026] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(828), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(826), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [45067] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1421), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1419), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [45108] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1421), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1419), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [45149] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1473), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1471), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [45190] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1541), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1539), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [45231] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1417), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1415), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [45272] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1537), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1535), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [45313] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(840), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(838), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [45354] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1569), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1567), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [45395] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1417), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1415), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [45436] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(276), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(303), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [45477] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1511), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1509), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [45518] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(836), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(834), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [45559] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1519), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1517), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [45600] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(832), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(830), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [45641] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(568), 1,
      anon_sym_COLON_EQ,
    ACTIONS(620), 1,
      anon_sym_EQ,
    ACTIONS(276), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(303), 27,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [45686] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1425), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1423), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [45727] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1413), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1411), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [45768] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1465), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1463), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [45809] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1429), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1427), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [45850] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1469), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1467), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [45891] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1425), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1423), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [45932] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(824), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(822), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [45973] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(824), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(822), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [46014] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1433), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1431), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [46055] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1515), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1513), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [46096] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1523), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1521), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [46137] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(646), 1,
      sym__string_start,
    ACTIONS(1681), 1,
      sym_identifier,
    ACTIONS(1683), 1,
      anon_sym_LPAREN,
    ACTIONS(1685), 1,
      anon_sym_STAR,
    ACTIONS(1687), 1,
      anon_sym_DASH,
    ACTIONS(1689), 1,
      sym_match_wildcard_pattern,
    ACTIONS(1691), 1,
      anon_sym_LBRACK,
    ACTIONS(1693), 1,
      anon_sym_LBRACE,
    ACTIONS(1695), 1,
      sym_integer,
    ACTIONS(1697), 1,
      sym_float,
    STATE(913), 1,
      sym_string,
    STATE(975), 1,
      sym_concatenated_string,
    STATE(1406), 1,
      sym_pattern_class_name,
    STATE(1024), 2,
      sym__match_or_pattern,
      sym_match_or_pattern,
    STATE(1286), 2,
      sym__match_patterns,
      sym_open_sequence_match_pattern,
    STATE(1287), 2,
      sym__match_pattern,
      sym_match_as_pattern,
    STATE(1404), 2,
      sym__match_maybe_star_pattern,
      sym_match_star_pattern,
    ACTIONS(1699), 3,
      sym_true,
      sym_false,
      sym_none,
    STATE(971), 8,
      sym__closed_pattern,
      sym_match_literal_pattern,
      sym_match_capture_pattern,
      sym_match_value_pattern,
      sym_match_group_pattern,
      sym_match_sequence_pattern,
      sym_match_mapping_pattern,
      sym_match_class_pattern,
  [46211] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(646), 1,
      sym__string_start,
    ACTIONS(1681), 1,
      sym_identifier,
    ACTIONS(1683), 1,
      anon_sym_LPAREN,
    ACTIONS(1685), 1,
      anon_sym_STAR,
    ACTIONS(1687), 1,
      anon_sym_DASH,
    ACTIONS(1689), 1,
      sym_match_wildcard_pattern,
    ACTIONS(1691), 1,
      anon_sym_LBRACK,
    ACTIONS(1693), 1,
      anon_sym_LBRACE,
    ACTIONS(1695), 1,
      sym_integer,
    ACTIONS(1697), 1,
      sym_float,
    ACTIONS(1701), 1,
      anon_sym_if,
    ACTIONS(1703), 1,
      anon_sym_COLON,
    STATE(913), 1,
      sym_string,
    STATE(975), 1,
      sym_concatenated_string,
    STATE(1406), 1,
      sym_pattern_class_name,
    STATE(1024), 2,
      sym__match_or_pattern,
      sym_match_or_pattern,
    ACTIONS(1699), 3,
      sym_true,
      sym_false,
      sym_none,
    STATE(1106), 4,
      sym__match_pattern,
      sym_match_as_pattern,
      sym__match_maybe_star_pattern,
      sym_match_star_pattern,
    STATE(971), 8,
      sym__closed_pattern,
      sym_match_literal_pattern,
      sym_match_capture_pattern,
      sym_match_value_pattern,
      sym_match_group_pattern,
      sym_match_sequence_pattern,
      sym_match_mapping_pattern,
      sym_match_class_pattern,
  [46285] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(646), 1,
      sym__string_start,
    ACTIONS(1681), 1,
      sym_identifier,
    ACTIONS(1683), 1,
      anon_sym_LPAREN,
    ACTIONS(1685), 1,
      anon_sym_STAR,
    ACTIONS(1687), 1,
      anon_sym_DASH,
    ACTIONS(1689), 1,
      sym_match_wildcard_pattern,
    ACTIONS(1691), 1,
      anon_sym_LBRACK,
    ACTIONS(1693), 1,
      anon_sym_LBRACE,
    ACTIONS(1695), 1,
      sym_integer,
    ACTIONS(1697), 1,
      sym_float,
    ACTIONS(1705), 1,
      anon_sym_if,
    ACTIONS(1707), 1,
      anon_sym_COLON,
    STATE(913), 1,
      sym_string,
    STATE(975), 1,
      sym_concatenated_string,
    STATE(1406), 1,
      sym_pattern_class_name,
    STATE(1024), 2,
      sym__match_or_pattern,
      sym_match_or_pattern,
    ACTIONS(1699), 3,
      sym_true,
      sym_false,
      sym_none,
    STATE(1106), 4,
      sym__match_pattern,
      sym_match_as_pattern,
      sym__match_maybe_star_pattern,
      sym_match_star_pattern,
    STATE(971), 8,
      sym__closed_pattern,
      sym_match_literal_pattern,
      sym_match_capture_pattern,
      sym_match_value_pattern,
      sym_match_group_pattern,
      sym_match_sequence_pattern,
      sym_match_mapping_pattern,
      sym_match_class_pattern,
  [46359] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(646), 1,
      sym__string_start,
    ACTIONS(1681), 1,
      sym_identifier,
    ACTIONS(1683), 1,
      anon_sym_LPAREN,
    ACTIONS(1685), 1,
      anon_sym_STAR,
    ACTIONS(1687), 1,
      anon_sym_DASH,
    ACTIONS(1689), 1,
      sym_match_wildcard_pattern,
    ACTIONS(1691), 1,
      anon_sym_LBRACK,
    ACTIONS(1693), 1,
      anon_sym_LBRACE,
    ACTIONS(1695), 1,
      sym_integer,
    ACTIONS(1697), 1,
      sym_float,
    STATE(913), 1,
      sym_string,
    STATE(975), 1,
      sym_concatenated_string,
    STATE(1406), 1,
      sym_pattern_class_name,
    STATE(1024), 2,
      sym__match_or_pattern,
      sym_match_or_pattern,
    STATE(1221), 2,
      sym__match_patterns,
      sym_open_sequence_match_pattern,
    STATE(1287), 2,
      sym__match_pattern,
      sym_match_as_pattern,
    STATE(1404), 2,
      sym__match_maybe_star_pattern,
      sym_match_star_pattern,
    ACTIONS(1699), 3,
      sym_true,
      sym_false,
      sym_none,
    STATE(971), 8,
      sym__closed_pattern,
      sym_match_literal_pattern,
      sym_match_capture_pattern,
      sym_match_value_pattern,
      sym_match_group_pattern,
      sym_match_sequence_pattern,
      sym_match_mapping_pattern,
      sym_match_class_pattern,
  [46433] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(646), 1,
      sym__string_start,
    ACTIONS(1681), 1,
      sym_identifier,
    ACTIONS(1683), 1,
      anon_sym_LPAREN,
    ACTIONS(1685), 1,
      anon_sym_STAR,
    ACTIONS(1687), 1,
      anon_sym_DASH,
    ACTIONS(1689), 1,
      sym_match_wildcard_pattern,
    ACTIONS(1691), 1,
      anon_sym_LBRACK,
    ACTIONS(1693), 1,
      anon_sym_LBRACE,
    ACTIONS(1695), 1,
      sym_integer,
    ACTIONS(1697), 1,
      sym_float,
    ACTIONS(1709), 1,
      anon_sym_RPAREN,
    STATE(913), 1,
      sym_string,
    STATE(975), 1,
      sym_concatenated_string,
    STATE(1406), 1,
      sym_pattern_class_name,
    STATE(1024), 2,
      sym__match_or_pattern,
      sym_match_or_pattern,
    STATE(1392), 2,
      sym__match_pattern,
      sym_match_as_pattern,
    STATE(1396), 2,
      sym__match_maybe_star_pattern,
      sym_match_star_pattern,
    ACTIONS(1699), 3,
      sym_true,
      sym_false,
      sym_none,
    STATE(971), 8,
      sym__closed_pattern,
      sym_match_literal_pattern,
      sym_match_capture_pattern,
      sym_match_value_pattern,
      sym_match_group_pattern,
      sym_match_sequence_pattern,
      sym_match_mapping_pattern,
      sym_match_class_pattern,
  [46506] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(646), 1,
      sym__string_start,
    ACTIONS(1681), 1,
      sym_identifier,
    ACTIONS(1683), 1,
      anon_sym_LPAREN,
    ACTIONS(1685), 1,
      anon_sym_STAR,
    ACTIONS(1687), 1,
      anon_sym_DASH,
    ACTIONS(1689), 1,
      sym_match_wildcard_pattern,
    ACTIONS(1691), 1,
      anon_sym_LBRACK,
    ACTIONS(1693), 1,
      anon_sym_LBRACE,
    ACTIONS(1695), 1,
      sym_integer,
    ACTIONS(1697), 1,
      sym_float,
    ACTIONS(1711), 1,
      anon_sym_RPAREN,
    STATE(913), 1,
      sym_string,
    STATE(975), 1,
      sym_concatenated_string,
    STATE(1406), 1,
      sym_pattern_class_name,
    STATE(1024), 2,
      sym__match_or_pattern,
      sym_match_or_pattern,
    ACTIONS(1699), 3,
      sym_true,
      sym_false,
      sym_none,
    STATE(1106), 4,
      sym__match_pattern,
      sym_match_as_pattern,
      sym__match_maybe_star_pattern,
      sym_match_star_pattern,
    STATE(971), 8,
      sym__closed_pattern,
      sym_match_literal_pattern,
      sym_match_capture_pattern,
      sym_match_value_pattern,
      sym_match_group_pattern,
      sym_match_sequence_pattern,
      sym_match_mapping_pattern,
      sym_match_class_pattern,
  [46577] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(646), 1,
      sym__string_start,
    ACTIONS(1681), 1,
      sym_identifier,
    ACTIONS(1683), 1,
      anon_sym_LPAREN,
    ACTIONS(1685), 1,
      anon_sym_STAR,
    ACTIONS(1687), 1,
      anon_sym_DASH,
    ACTIONS(1689), 1,
      sym_match_wildcard_pattern,
    ACTIONS(1691), 1,
      anon_sym_LBRACK,
    ACTIONS(1693), 1,
      anon_sym_LBRACE,
    ACTIONS(1695), 1,
      sym_integer,
    ACTIONS(1697), 1,
      sym_float,
    ACTIONS(1711), 1,
      anon_sym_RBRACK,
    STATE(913), 1,
      sym_string,
    STATE(975), 1,
      sym_concatenated_string,
    STATE(1406), 1,
      sym_pattern_class_name,
    STATE(1024), 2,
      sym__match_or_pattern,
      sym_match_or_pattern,
    ACTIONS(1699), 3,
      sym_true,
      sym_false,
      sym_none,
    STATE(1106), 4,
      sym__match_pattern,
      sym_match_as_pattern,
      sym__match_maybe_star_pattern,
      sym_match_star_pattern,
    STATE(971), 8,
      sym__closed_pattern,
      sym_match_literal_pattern,
      sym_match_capture_pattern,
      sym_match_value_pattern,
      sym_match_group_pattern,
      sym_match_sequence_pattern,
      sym_match_mapping_pattern,
      sym_match_class_pattern,
  [46648] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(646), 1,
      sym__string_start,
    ACTIONS(1681), 1,
      sym_identifier,
    ACTIONS(1683), 1,
      anon_sym_LPAREN,
    ACTIONS(1685), 1,
      anon_sym_STAR,
    ACTIONS(1687), 1,
      anon_sym_DASH,
    ACTIONS(1689), 1,
      sym_match_wildcard_pattern,
    ACTIONS(1691), 1,
      anon_sym_LBRACK,
    ACTIONS(1693), 1,
      anon_sym_LBRACE,
    ACTIONS(1695), 1,
      sym_integer,
    ACTIONS(1697), 1,
      sym_float,
    ACTIONS(1709), 1,
      anon_sym_RBRACK,
    STATE(913), 1,
      sym_string,
    STATE(975), 1,
      sym_concatenated_string,
    STATE(1406), 1,
      sym_pattern_class_name,
    STATE(1024), 2,
      sym__match_or_pattern,
      sym_match_or_pattern,
    ACTIONS(1699), 3,
      sym_true,
      sym_false,
      sym_none,
    STATE(1202), 4,
      sym__match_pattern,
      sym_match_as_pattern,
      sym__match_maybe_star_pattern,
      sym_match_star_pattern,
    STATE(971), 8,
      sym__closed_pattern,
      sym_match_literal_pattern,
      sym_match_capture_pattern,
      sym_match_value_pattern,
      sym_match_group_pattern,
      sym_match_sequence_pattern,
      sym_match_mapping_pattern,
      sym_match_class_pattern,
  [46719] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(646), 1,
      sym__string_start,
    ACTIONS(1681), 1,
      sym_identifier,
    ACTIONS(1683), 1,
      anon_sym_LPAREN,
    ACTIONS(1685), 1,
      anon_sym_STAR,
    ACTIONS(1687), 1,
      anon_sym_DASH,
    ACTIONS(1689), 1,
      sym_match_wildcard_pattern,
    ACTIONS(1691), 1,
      anon_sym_LBRACK,
    ACTIONS(1693), 1,
      anon_sym_LBRACE,
    ACTIONS(1695), 1,
      sym_integer,
    ACTIONS(1697), 1,
      sym_float,
    ACTIONS(1713), 1,
      anon_sym_RBRACK,
    STATE(913), 1,
      sym_string,
    STATE(975), 1,
      sym_concatenated_string,
    STATE(1406), 1,
      sym_pattern_class_name,
    STATE(1024), 2,
      sym__match_or_pattern,
      sym_match_or_pattern,
    ACTIONS(1699), 3,
      sym_true,
      sym_false,
      sym_none,
    STATE(1106), 4,
      sym__match_pattern,
      sym_match_as_pattern,
      sym__match_maybe_star_pattern,
      sym_match_star_pattern,
    STATE(971), 8,
      sym__closed_pattern,
      sym_match_literal_pattern,
      sym_match_capture_pattern,
      sym_match_value_pattern,
      sym_match_group_pattern,
      sym_match_sequence_pattern,
      sym_match_mapping_pattern,
      sym_match_class_pattern,
  [46790] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(646), 1,
      sym__string_start,
    ACTIONS(1681), 1,
      sym_identifier,
    ACTIONS(1683), 1,
      anon_sym_LPAREN,
    ACTIONS(1685), 1,
      anon_sym_STAR,
    ACTIONS(1687), 1,
      anon_sym_DASH,
    ACTIONS(1689), 1,
      sym_match_wildcard_pattern,
    ACTIONS(1691), 1,
      anon_sym_LBRACK,
    ACTIONS(1693), 1,
      anon_sym_LBRACE,
    ACTIONS(1695), 1,
      sym_integer,
    ACTIONS(1697), 1,
      sym_float,
    ACTIONS(1713), 1,
      anon_sym_RPAREN,
    STATE(913), 1,
      sym_string,
    STATE(975), 1,
      sym_concatenated_string,
    STATE(1406), 1,
      sym_pattern_class_name,
    STATE(1024), 2,
      sym__match_or_pattern,
      sym_match_or_pattern,
    ACTIONS(1699), 3,
      sym_true,
      sym_false,
      sym_none,
    STATE(1106), 4,
      sym__match_pattern,
      sym_match_as_pattern,
      sym__match_maybe_star_pattern,
      sym_match_star_pattern,
    STATE(971), 8,
      sym__closed_pattern,
      sym_match_literal_pattern,
      sym_match_capture_pattern,
      sym_match_value_pattern,
      sym_match_group_pattern,
      sym_match_sequence_pattern,
      sym_match_mapping_pattern,
      sym_match_class_pattern,
  [46861] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(646), 1,
      sym__string_start,
    ACTIONS(1681), 1,
      sym_identifier,
    ACTIONS(1683), 1,
      anon_sym_LPAREN,
    ACTIONS(1685), 1,
      anon_sym_STAR,
    ACTIONS(1687), 1,
      anon_sym_DASH,
    ACTIONS(1689), 1,
      sym_match_wildcard_pattern,
    ACTIONS(1691), 1,
      anon_sym_LBRACK,
    ACTIONS(1693), 1,
      anon_sym_LBRACE,
    ACTIONS(1695), 1,
      sym_integer,
    ACTIONS(1697), 1,
      sym_float,
    STATE(913), 1,
      sym_string,
    STATE(975), 1,
      sym_concatenated_string,
    STATE(1406), 1,
      sym_pattern_class_name,
    STATE(1024), 2,
      sym__match_or_pattern,
      sym_match_or_pattern,
    ACTIONS(1699), 3,
      sym_true,
      sym_false,
      sym_none,
    STATE(1106), 4,
      sym__match_pattern,
      sym_match_as_pattern,
      sym__match_maybe_star_pattern,
      sym_match_star_pattern,
    STATE(971), 8,
      sym__closed_pattern,
      sym_match_literal_pattern,
      sym_match_capture_pattern,
      sym_match_value_pattern,
      sym_match_group_pattern,
      sym_match_sequence_pattern,
      sym_match_mapping_pattern,
      sym_match_class_pattern,
  [46929] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(646), 1,
      sym__string_start,
    ACTIONS(1683), 1,
      anon_sym_LPAREN,
    ACTIONS(1687), 1,
      anon_sym_DASH,
    ACTIONS(1689), 1,
      sym_match_wildcard_pattern,
    ACTIONS(1691), 1,
      anon_sym_LBRACK,
    ACTIONS(1693), 1,
      anon_sym_LBRACE,
    ACTIONS(1695), 1,
      sym_integer,
    ACTIONS(1697), 1,
      sym_float,
    ACTIONS(1715), 1,
      sym_identifier,
    ACTIONS(1717), 1,
      anon_sym_RPAREN,
    STATE(913), 1,
      sym_string,
    STATE(975), 1,
      sym_concatenated_string,
    STATE(1212), 1,
      sym_match_positional_pattern,
    STATE(1330), 1,
      sym_match_keyword_pattern,
    STATE(1406), 1,
      sym_pattern_class_name,
    STATE(1024), 2,
      sym__match_or_pattern,
      sym_match_or_pattern,
    STATE(1364), 2,
      sym__match_pattern,
      sym_match_as_pattern,
    ACTIONS(1699), 3,
      sym_true,
      sym_false,
      sym_none,
    STATE(971), 8,
      sym__closed_pattern,
      sym_match_literal_pattern,
      sym_match_capture_pattern,
      sym_match_value_pattern,
      sym_match_group_pattern,
      sym_match_sequence_pattern,
      sym_match_mapping_pattern,
      sym_match_class_pattern,
  [47001] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(646), 1,
      sym__string_start,
    ACTIONS(1683), 1,
      anon_sym_LPAREN,
    ACTIONS(1687), 1,
      anon_sym_DASH,
    ACTIONS(1689), 1,
      sym_match_wildcard_pattern,
    ACTIONS(1691), 1,
      anon_sym_LBRACK,
    ACTIONS(1693), 1,
      anon_sym_LBRACE,
    ACTIONS(1695), 1,
      sym_integer,
    ACTIONS(1697), 1,
      sym_float,
    ACTIONS(1715), 1,
      sym_identifier,
    ACTIONS(1719), 1,
      anon_sym_RPAREN,
    STATE(913), 1,
      sym_string,
    STATE(975), 1,
      sym_concatenated_string,
    STATE(1290), 1,
      sym_match_keyword_pattern,
    STATE(1403), 1,
      sym_match_positional_pattern,
    STATE(1406), 1,
      sym_pattern_class_name,
    STATE(1024), 2,
      sym__match_or_pattern,
      sym_match_or_pattern,
    STATE(1364), 2,
      sym__match_pattern,
      sym_match_as_pattern,
    ACTIONS(1699), 3,
      sym_true,
      sym_false,
      sym_none,
    STATE(971), 8,
      sym__closed_pattern,
      sym_match_literal_pattern,
      sym_match_capture_pattern,
      sym_match_value_pattern,
      sym_match_group_pattern,
      sym_match_sequence_pattern,
      sym_match_mapping_pattern,
      sym_match_class_pattern,
  [47073] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(646), 1,
      sym__string_start,
    ACTIONS(1683), 1,
      anon_sym_LPAREN,
    ACTIONS(1687), 1,
      anon_sym_DASH,
    ACTIONS(1689), 1,
      sym_match_wildcard_pattern,
    ACTIONS(1691), 1,
      anon_sym_LBRACK,
    ACTIONS(1693), 1,
      anon_sym_LBRACE,
    ACTIONS(1695), 1,
      sym_integer,
    ACTIONS(1697), 1,
      sym_float,
    ACTIONS(1715), 1,
      sym_identifier,
    ACTIONS(1721), 1,
      anon_sym_RPAREN,
    STATE(913), 1,
      sym_string,
    STATE(975), 1,
      sym_concatenated_string,
    STATE(1326), 1,
      sym_match_keyword_pattern,
    STATE(1403), 1,
      sym_match_positional_pattern,
    STATE(1406), 1,
      sym_pattern_class_name,
    STATE(1024), 2,
      sym__match_or_pattern,
      sym_match_or_pattern,
    STATE(1364), 2,
      sym__match_pattern,
      sym_match_as_pattern,
    ACTIONS(1699), 3,
      sym_true,
      sym_false,
      sym_none,
    STATE(971), 8,
      sym__closed_pattern,
      sym_match_literal_pattern,
      sym_match_capture_pattern,
      sym_match_value_pattern,
      sym_match_group_pattern,
      sym_match_sequence_pattern,
      sym_match_mapping_pattern,
      sym_match_class_pattern,
  [47145] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(646), 1,
      sym__string_start,
    ACTIONS(1681), 1,
      sym_identifier,
    ACTIONS(1683), 1,
      anon_sym_LPAREN,
    ACTIONS(1687), 1,
      anon_sym_DASH,
    ACTIONS(1689), 1,
      sym_match_wildcard_pattern,
    ACTIONS(1691), 1,
      anon_sym_LBRACK,
    ACTIONS(1693), 1,
      anon_sym_LBRACE,
    ACTIONS(1695), 1,
      sym_integer,
    ACTIONS(1697), 1,
      sym_float,
    STATE(913), 1,
      sym_string,
    STATE(975), 1,
      sym_concatenated_string,
    STATE(1403), 1,
      sym_match_positional_pattern,
    STATE(1406), 1,
      sym_pattern_class_name,
    STATE(1024), 2,
      sym__match_or_pattern,
      sym_match_or_pattern,
    STATE(1364), 2,
      sym__match_pattern,
      sym_match_as_pattern,
    ACTIONS(1699), 3,
      sym_true,
      sym_false,
      sym_none,
    STATE(971), 8,
      sym__closed_pattern,
      sym_match_literal_pattern,
      sym_match_capture_pattern,
      sym_match_value_pattern,
      sym_match_group_pattern,
      sym_match_sequence_pattern,
      sym_match_mapping_pattern,
      sym_match_class_pattern,
  [47211] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(646), 1,
      sym__string_start,
    ACTIONS(1681), 1,
      sym_identifier,
    ACTIONS(1683), 1,
      anon_sym_LPAREN,
    ACTIONS(1687), 1,
      anon_sym_DASH,
    ACTIONS(1689), 1,
      sym_match_wildcard_pattern,
    ACTIONS(1691), 1,
      anon_sym_LBRACK,
    ACTIONS(1693), 1,
      anon_sym_LBRACE,
    ACTIONS(1695), 1,
      sym_integer,
    ACTIONS(1697), 1,
      sym_float,
    STATE(913), 1,
      sym_string,
    STATE(975), 1,
      sym_concatenated_string,
    STATE(1406), 1,
      sym_pattern_class_name,
    STATE(1024), 2,
      sym__match_or_pattern,
      sym_match_or_pattern,
    STATE(1355), 2,
      sym__match_pattern,
      sym_match_as_pattern,
    ACTIONS(1699), 3,
      sym_true,
      sym_false,
      sym_none,
    STATE(971), 8,
      sym__closed_pattern,
      sym_match_literal_pattern,
      sym_match_capture_pattern,
      sym_match_value_pattern,
      sym_match_group_pattern,
      sym_match_sequence_pattern,
      sym_match_mapping_pattern,
      sym_match_class_pattern,
  [47274] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(646), 1,
      sym__string_start,
    ACTIONS(1681), 1,
      sym_identifier,
    ACTIONS(1683), 1,
      anon_sym_LPAREN,
    ACTIONS(1687), 1,
      anon_sym_DASH,
    ACTIONS(1689), 1,
      sym_match_wildcard_pattern,
    ACTIONS(1691), 1,
      anon_sym_LBRACK,
    ACTIONS(1693), 1,
      anon_sym_LBRACE,
    ACTIONS(1695), 1,
      sym_integer,
    ACTIONS(1697), 1,
      sym_float,
    STATE(913), 1,
      sym_string,
    STATE(975), 1,
      sym_concatenated_string,
    STATE(1406), 1,
      sym_pattern_class_name,
    STATE(1024), 2,
      sym__match_or_pattern,
      sym_match_or_pattern,
    STATE(1399), 2,
      sym__match_pattern,
      sym_match_as_pattern,
    ACTIONS(1699), 3,
      sym_true,
      sym_false,
      sym_none,
    STATE(971), 8,
      sym__closed_pattern,
      sym_match_literal_pattern,
      sym_match_capture_pattern,
      sym_match_value_pattern,
      sym_match_group_pattern,
      sym_match_sequence_pattern,
      sym_match_mapping_pattern,
      sym_match_class_pattern,
  [47337] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(646), 1,
      sym__string_start,
    ACTIONS(1681), 1,
      sym_identifier,
    ACTIONS(1683), 1,
      anon_sym_LPAREN,
    ACTIONS(1687), 1,
      anon_sym_DASH,
    ACTIONS(1691), 1,
      anon_sym_LBRACK,
    ACTIONS(1693), 1,
      anon_sym_LBRACE,
    ACTIONS(1695), 1,
      sym_integer,
    ACTIONS(1697), 1,
      sym_float,
    ACTIONS(1723), 1,
      sym_match_wildcard_pattern,
    STATE(913), 1,
      sym_string,
    STATE(975), 1,
      sym_concatenated_string,
    STATE(1406), 1,
      sym_pattern_class_name,
    ACTIONS(1699), 3,
      sym_true,
      sym_false,
      sym_none,
    STATE(984), 8,
      sym__closed_pattern,
      sym_match_literal_pattern,
      sym_match_capture_pattern,
      sym_match_value_pattern,
      sym_match_group_pattern,
      sym_match_sequence_pattern,
      sym_match_mapping_pattern,
      sym_match_class_pattern,
  [47392] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(646), 1,
      sym__string_start,
    ACTIONS(1681), 1,
      sym_identifier,
    ACTIONS(1683), 1,
      anon_sym_LPAREN,
    ACTIONS(1687), 1,
      anon_sym_DASH,
    ACTIONS(1691), 1,
      anon_sym_LBRACK,
    ACTIONS(1693), 1,
      anon_sym_LBRACE,
    ACTIONS(1695), 1,
      sym_integer,
    ACTIONS(1697), 1,
      sym_float,
    ACTIONS(1725), 1,
      sym_match_wildcard_pattern,
    STATE(913), 1,
      sym_string,
    STATE(975), 1,
      sym_concatenated_string,
    STATE(1406), 1,
      sym_pattern_class_name,
    ACTIONS(1699), 3,
      sym_true,
      sym_false,
      sym_none,
    STATE(957), 8,
      sym__closed_pattern,
      sym_match_literal_pattern,
      sym_match_capture_pattern,
      sym_match_value_pattern,
      sym_match_group_pattern,
      sym_match_sequence_pattern,
      sym_match_mapping_pattern,
      sym_match_class_pattern,
  [47447] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1729), 1,
      anon_sym_as,
    ACTIONS(1734), 1,
      anon_sym_not,
    ACTIONS(1740), 1,
      anon_sym_is,
    STATE(868), 1,
      aux_sym_comparison_operator_repeat1,
    ACTIONS(1737), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1731), 6,
      anon_sym_in,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
    ACTIONS(1727), 10,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
  [47487] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1729), 1,
      anon_sym_EQ,
    ACTIONS(1746), 1,
      anon_sym_not,
    ACTIONS(1752), 1,
      anon_sym_is,
    STATE(869), 1,
      aux_sym_comparison_operator_repeat1,
    ACTIONS(1749), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1743), 6,
      anon_sym_in,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
    ACTIONS(1727), 10,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
      sym_type_conversion,
  [47527] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1499), 1,
      anon_sym_not,
    ACTIONS(1507), 1,
      anon_sym_is,
    ACTIONS(1757), 1,
      anon_sym_EQ,
    STATE(869), 1,
      aux_sym_comparison_operator_repeat1,
    ACTIONS(1505), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1485), 6,
      anon_sym_in,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
    ACTIONS(1755), 10,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
      sym_type_conversion,
  [47567] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1557), 1,
      anon_sym_not,
    ACTIONS(1565), 1,
      anon_sym_is,
    ACTIONS(1757), 1,
      anon_sym_as,
    STATE(868), 1,
      aux_sym_comparison_operator_repeat1,
    ACTIONS(1563), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1547), 6,
      anon_sym_in,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
    ACTIONS(1755), 10,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
  [47607] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1761), 1,
      anon_sym_COMMA,
    STATE(872), 1,
      aux_sym__patterns_repeat1,
    ACTIONS(1759), 18,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [47637] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1764), 19,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [47662] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1766), 19,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [47687] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1059), 19,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [47712] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1768), 19,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [47737] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1729), 1,
      anon_sym_EQ,
    ACTIONS(1773), 1,
      anon_sym_not,
    ACTIONS(1779), 1,
      anon_sym_is,
    STATE(877), 1,
      aux_sym_comparison_operator_repeat1,
    ACTIONS(1776), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1770), 6,
      anon_sym_in,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
    ACTIONS(1727), 7,
      sym__newline,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_and,
      anon_sym_or,
      sym__semicolon,
  [47774] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1630), 1,
      anon_sym_not,
    ACTIONS(1638), 1,
      anon_sym_is,
    ACTIONS(1757), 1,
      anon_sym_EQ,
    STATE(877), 1,
      aux_sym_comparison_operator_repeat1,
    ACTIONS(1636), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1618), 6,
      anon_sym_in,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
    ACTIONS(1755), 7,
      sym__newline,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_and,
      anon_sym_or,
      sym__semicolon,
  [47811] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1053), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1782), 3,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(1048), 14,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [47840] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(276), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1784), 3,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(303), 14,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LBRACK,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [47869] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1667), 1,
      anon_sym_not,
    ACTIONS(1675), 1,
      anon_sym_is,
    STATE(883), 1,
      aux_sym_comparison_operator_repeat1,
    ACTIONS(1673), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1655), 6,
      anon_sym_in,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
    ACTIONS(1755), 7,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_or,
  [47903] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1475), 1,
      anon_sym_DOT,
    ACTIONS(1477), 1,
      anon_sym_LPAREN,
    ACTIONS(1487), 1,
      anon_sym_PIPE,
    ACTIONS(1491), 1,
      anon_sym_LBRACK,
    ACTIONS(1493), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1501), 1,
      anon_sym_AMP,
    ACTIONS(1503), 1,
      anon_sym_CARET,
    ACTIONS(1481), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1483), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(1489), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    STATE(633), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(1497), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
  [47949] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1789), 1,
      anon_sym_not,
    ACTIONS(1795), 1,
      anon_sym_is,
    STATE(883), 1,
      aux_sym_comparison_operator_repeat1,
    ACTIONS(1792), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1786), 6,
      anon_sym_in,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
    ACTIONS(1727), 7,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_or,
  [47983] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1798), 1,
      anon_sym_COMMA,
    STATE(872), 1,
      aux_sym__patterns_repeat1,
    ACTIONS(1800), 16,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [48011] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1802), 1,
      sym_identifier,
    ACTIONS(1804), 1,
      anon_sym_LPAREN,
    ACTIONS(1806), 1,
      anon_sym_STAR,
    ACTIONS(1808), 1,
      anon_sym_COLON,
    ACTIONS(1810), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1812), 1,
      anon_sym_SLASH,
    STATE(1334), 1,
      sym_parameter,
    STATE(1453), 1,
      sym_lambda_parameters,
    STATE(1521), 1,
      sym__parameters,
    STATE(1347), 2,
      sym_list_splat_pattern,
      sym_dictionary_splat_pattern,
    STATE(1333), 6,
      sym_tuple_pattern,
      sym_default_parameter,
      sym_typed_default_parameter,
      sym_typed_parameter,
      sym_positional_separator,
      sym_keyword_separator,
  [48054] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1802), 1,
      sym_identifier,
    ACTIONS(1804), 1,
      anon_sym_LPAREN,
    ACTIONS(1806), 1,
      anon_sym_STAR,
    ACTIONS(1810), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1812), 1,
      anon_sym_SLASH,
    ACTIONS(1814), 1,
      anon_sym_COLON,
    STATE(1334), 1,
      sym_parameter,
    STATE(1458), 1,
      sym_lambda_parameters,
    STATE(1521), 1,
      sym__parameters,
    STATE(1347), 2,
      sym_list_splat_pattern,
      sym_dictionary_splat_pattern,
    STATE(1333), 6,
      sym_tuple_pattern,
      sym_default_parameter,
      sym_typed_default_parameter,
      sym_typed_parameter,
      sym_positional_separator,
      sym_keyword_separator,
  [48097] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1802), 1,
      sym_identifier,
    ACTIONS(1804), 1,
      anon_sym_LPAREN,
    ACTIONS(1806), 1,
      anon_sym_STAR,
    ACTIONS(1810), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1812), 1,
      anon_sym_SLASH,
    ACTIONS(1816), 1,
      anon_sym_COLON,
    STATE(1334), 1,
      sym_parameter,
    STATE(1413), 1,
      sym_lambda_parameters,
    STATE(1521), 1,
      sym__parameters,
    STATE(1347), 2,
      sym_list_splat_pattern,
      sym_dictionary_splat_pattern,
    STATE(1333), 6,
      sym_tuple_pattern,
      sym_default_parameter,
      sym_typed_default_parameter,
      sym_typed_parameter,
      sym_positional_separator,
      sym_keyword_separator,
  [48140] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1802), 1,
      sym_identifier,
    ACTIONS(1804), 1,
      anon_sym_LPAREN,
    ACTIONS(1806), 1,
      anon_sym_STAR,
    ACTIONS(1810), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1812), 1,
      anon_sym_SLASH,
    ACTIONS(1818), 1,
      anon_sym_COLON,
    STATE(1334), 1,
      sym_parameter,
    STATE(1427), 1,
      sym_lambda_parameters,
    STATE(1521), 1,
      sym__parameters,
    STATE(1347), 2,
      sym_list_splat_pattern,
      sym_dictionary_splat_pattern,
    STATE(1333), 6,
      sym_tuple_pattern,
      sym_default_parameter,
      sym_typed_default_parameter,
      sym_typed_parameter,
      sym_positional_separator,
      sym_keyword_separator,
  [48183] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1820), 1,
      anon_sym_COMMA,
    ACTIONS(1822), 1,
      anon_sym_COLON,
    ACTIONS(1824), 1,
      anon_sym_EQ,
    STATE(884), 1,
      aux_sym__patterns_repeat1,
    ACTIONS(1826), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [48214] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1802), 1,
      sym_identifier,
    ACTIONS(1804), 1,
      anon_sym_LPAREN,
    ACTIONS(1806), 1,
      anon_sym_STAR,
    ACTIONS(1810), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1812), 1,
      anon_sym_SLASH,
    ACTIONS(1828), 1,
      anon_sym_COLON,
    STATE(1334), 1,
      sym_parameter,
    STATE(1521), 1,
      sym__parameters,
    STATE(1524), 1,
      sym_lambda_parameters,
    STATE(1347), 2,
      sym_list_splat_pattern,
      sym_dictionary_splat_pattern,
    STATE(1333), 6,
      sym_tuple_pattern,
      sym_default_parameter,
      sym_typed_default_parameter,
      sym_typed_parameter,
      sym_positional_separator,
      sym_keyword_separator,
  [48257] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(315), 1,
      sym__string_start,
    ACTIONS(1687), 1,
      anon_sym_DASH,
    ACTIONS(1695), 1,
      sym_integer,
    ACTIONS(1697), 1,
      sym_float,
    ACTIONS(1830), 1,
      sym_identifier,
    ACTIONS(1832), 1,
      anon_sym_RBRACE,
    ACTIONS(1834), 1,
      anon_sym_STAR_STAR,
    STATE(975), 1,
      sym_concatenated_string,
    STATE(1168), 1,
      sym_string,
    STATE(1359), 1,
      sym_match_double_star_pattern,
    STATE(1362), 1,
      sym_match_key_value_pattern,
    STATE(1486), 2,
      sym_match_literal_pattern,
      sym_match_value_pattern,
    ACTIONS(1699), 3,
      sym_true,
      sym_false,
      sym_none,
  [48303] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(315), 1,
      sym__string_start,
    ACTIONS(1687), 1,
      anon_sym_DASH,
    ACTIONS(1695), 1,
      sym_integer,
    ACTIONS(1697), 1,
      sym_float,
    ACTIONS(1830), 1,
      sym_identifier,
    ACTIONS(1834), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1836), 1,
      anon_sym_RBRACE,
    STATE(975), 1,
      sym_concatenated_string,
    STATE(1168), 1,
      sym_string,
    STATE(1218), 1,
      sym_match_key_value_pattern,
    STATE(1368), 1,
      sym_match_double_star_pattern,
    STATE(1486), 2,
      sym_match_literal_pattern,
      sym_match_value_pattern,
    ACTIONS(1699), 3,
      sym_true,
      sym_false,
      sym_none,
  [48349] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1804), 1,
      anon_sym_LPAREN,
    ACTIONS(1806), 1,
      anon_sym_STAR,
    ACTIONS(1810), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1812), 1,
      anon_sym_SLASH,
    ACTIONS(1838), 1,
      sym_identifier,
    ACTIONS(1840), 1,
      anon_sym_RPAREN,
    STATE(1229), 1,
      sym_parameter,
    STATE(1455), 1,
      sym__parameters,
    STATE(1267), 2,
      sym_list_splat_pattern,
      sym_dictionary_splat_pattern,
    STATE(1333), 6,
      sym_tuple_pattern,
      sym_default_parameter,
      sym_typed_default_parameter,
      sym_typed_parameter,
      sym_positional_separator,
      sym_keyword_separator,
  [48389] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(315), 1,
      sym__string_start,
    ACTIONS(1687), 1,
      anon_sym_DASH,
    ACTIONS(1695), 1,
      sym_integer,
    ACTIONS(1697), 1,
      sym_float,
    ACTIONS(1830), 1,
      sym_identifier,
    ACTIONS(1834), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1842), 1,
      anon_sym_RBRACE,
    STATE(975), 1,
      sym_concatenated_string,
    STATE(1168), 1,
      sym_string,
    STATE(1362), 1,
      sym_match_key_value_pattern,
    STATE(1401), 1,
      sym_match_double_star_pattern,
    STATE(1486), 2,
      sym_match_literal_pattern,
      sym_match_value_pattern,
    ACTIONS(1699), 3,
      sym_true,
      sym_false,
      sym_none,
  [48435] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1804), 1,
      anon_sym_LPAREN,
    ACTIONS(1806), 1,
      anon_sym_STAR,
    ACTIONS(1810), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1812), 1,
      anon_sym_SLASH,
    ACTIONS(1838), 1,
      sym_identifier,
    ACTIONS(1844), 1,
      anon_sym_RPAREN,
    STATE(1201), 1,
      sym_parameter,
    STATE(1267), 2,
      sym_list_splat_pattern,
      sym_dictionary_splat_pattern,
    STATE(1333), 6,
      sym_tuple_pattern,
      sym_default_parameter,
      sym_typed_default_parameter,
      sym_typed_parameter,
      sym_positional_separator,
      sym_keyword_separator,
  [48472] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1802), 1,
      sym_identifier,
    ACTIONS(1804), 1,
      anon_sym_LPAREN,
    ACTIONS(1806), 1,
      anon_sym_STAR,
    ACTIONS(1810), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1812), 1,
      anon_sym_SLASH,
    ACTIONS(1846), 1,
      anon_sym_COLON,
    STATE(1201), 1,
      sym_parameter,
    STATE(1347), 2,
      sym_list_splat_pattern,
      sym_dictionary_splat_pattern,
    STATE(1333), 6,
      sym_tuple_pattern,
      sym_default_parameter,
      sym_typed_default_parameter,
      sym_typed_parameter,
      sym_positional_separator,
      sym_keyword_separator,
  [48509] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1822), 1,
      anon_sym_COLON,
    ACTIONS(1824), 1,
      anon_sym_EQ,
    ACTIONS(1826), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [48534] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1802), 1,
      sym_identifier,
    ACTIONS(1804), 1,
      anon_sym_LPAREN,
    ACTIONS(1806), 1,
      anon_sym_STAR,
    ACTIONS(1810), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1812), 1,
      anon_sym_SLASH,
    ACTIONS(1844), 1,
      anon_sym_COLON,
    STATE(1201), 1,
      sym_parameter,
    STATE(1347), 2,
      sym_list_splat_pattern,
      sym_dictionary_splat_pattern,
    STATE(1333), 6,
      sym_tuple_pattern,
      sym_default_parameter,
      sym_typed_default_parameter,
      sym_typed_parameter,
      sym_positional_separator,
      sym_keyword_separator,
  [48571] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1804), 1,
      anon_sym_LPAREN,
    ACTIONS(1806), 1,
      anon_sym_STAR,
    ACTIONS(1810), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1812), 1,
      anon_sym_SLASH,
    ACTIONS(1838), 1,
      sym_identifier,
    ACTIONS(1846), 1,
      anon_sym_RPAREN,
    STATE(1201), 1,
      sym_parameter,
    STATE(1267), 2,
      sym_list_splat_pattern,
      sym_dictionary_splat_pattern,
    STATE(1333), 6,
      sym_tuple_pattern,
      sym_default_parameter,
      sym_typed_default_parameter,
      sym_typed_parameter,
      sym_positional_separator,
      sym_keyword_separator,
  [48608] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1495), 1,
      anon_sym_as,
    ACTIONS(1479), 13,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_and,
      anon_sym_or,
      sym_type_conversion,
  [48630] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1850), 1,
      anon_sym_as,
    ACTIONS(1848), 13,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_and,
      anon_sym_or,
      sym_type_conversion,
  [48652] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1802), 1,
      sym_identifier,
    ACTIONS(1804), 1,
      anon_sym_LPAREN,
    ACTIONS(1806), 1,
      anon_sym_STAR,
    ACTIONS(1810), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1812), 1,
      anon_sym_SLASH,
    STATE(1201), 1,
      sym_parameter,
    STATE(1347), 2,
      sym_list_splat_pattern,
      sym_dictionary_splat_pattern,
    STATE(1333), 6,
      sym_tuple_pattern,
      sym_default_parameter,
      sym_typed_default_parameter,
      sym_typed_parameter,
      sym_positional_separator,
      sym_keyword_separator,
  [48686] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1804), 1,
      anon_sym_LPAREN,
    ACTIONS(1806), 1,
      anon_sym_STAR,
    ACTIONS(1810), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1812), 1,
      anon_sym_SLASH,
    ACTIONS(1838), 1,
      sym_identifier,
    STATE(1201), 1,
      sym_parameter,
    STATE(1267), 2,
      sym_list_splat_pattern,
      sym_dictionary_splat_pattern,
    STATE(1333), 6,
      sym_tuple_pattern,
      sym_default_parameter,
      sym_typed_default_parameter,
      sym_typed_parameter,
      sym_positional_separator,
      sym_keyword_separator,
  [48720] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1854), 1,
      anon_sym_as,
    ACTIONS(1852), 13,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_and,
      anon_sym_or,
      sym_type_conversion,
  [48742] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(315), 1,
      sym__string_start,
    ACTIONS(1687), 1,
      anon_sym_DASH,
    ACTIONS(1695), 1,
      sym_integer,
    ACTIONS(1697), 1,
      sym_float,
    ACTIONS(1830), 1,
      sym_identifier,
    STATE(975), 1,
      sym_concatenated_string,
    STATE(1168), 1,
      sym_string,
    STATE(1362), 1,
      sym_match_key_value_pattern,
    STATE(1486), 2,
      sym_match_literal_pattern,
      sym_match_value_pattern,
    ACTIONS(1699), 3,
      sym_true,
      sym_false,
      sym_none,
  [48779] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1858), 1,
      anon_sym_DOT,
    STATE(906), 1,
      aux_sym_match_value_pattern_repeat1,
    ACTIONS(1856), 10,
      anon_sym_import,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
  [48801] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1861), 1,
      anon_sym_COMMA,
    ACTIONS(1863), 1,
      anon_sym_if,
    ACTIONS(1865), 1,
      anon_sym_COLON,
    ACTIONS(1867), 1,
      anon_sym_async,
    ACTIONS(1869), 1,
      anon_sym_for,
    ACTIONS(1871), 1,
      anon_sym_RBRACE,
    ACTIONS(1873), 1,
      anon_sym_and,
    ACTIONS(1875), 1,
      anon_sym_or,
    STATE(956), 1,
      sym_for_in_clause,
    STATE(1111), 1,
      aux_sym__collection_elements_repeat1,
    STATE(1438), 1,
      sym__comprehension_clauses,
  [48838] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1879), 1,
      anon_sym_if,
    ACTIONS(1881), 1,
      anon_sym_and,
    ACTIONS(1883), 1,
      anon_sym_or,
    ACTIONS(1877), 8,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_EQ,
      sym_type_conversion,
  [48861] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1863), 1,
      anon_sym_if,
    ACTIONS(1873), 1,
      anon_sym_and,
    ACTIONS(1875), 1,
      anon_sym_or,
    ACTIONS(1887), 1,
      anon_sym_as,
    ACTIONS(1885), 7,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
  [48886] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1889), 1,
      anon_sym_DOT,
    ACTIONS(1891), 1,
      anon_sym_LPAREN,
    STATE(906), 1,
      aux_sym_match_value_pattern_repeat1,
    ACTIONS(1893), 8,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
  [48909] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1861), 1,
      anon_sym_COMMA,
    ACTIONS(1863), 1,
      anon_sym_if,
    ACTIONS(1865), 1,
      anon_sym_COLON,
    ACTIONS(1867), 1,
      anon_sym_async,
    ACTIONS(1869), 1,
      anon_sym_for,
    ACTIONS(1871), 1,
      anon_sym_RBRACE,
    ACTIONS(1873), 1,
      anon_sym_and,
    ACTIONS(1875), 1,
      anon_sym_or,
    STATE(956), 1,
      sym_for_in_clause,
    STATE(1111), 1,
      aux_sym__collection_elements_repeat1,
    STATE(1405), 1,
      sym__comprehension_clauses,
  [48946] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1863), 1,
      anon_sym_if,
    ACTIONS(1873), 1,
      anon_sym_and,
    ACTIONS(1875), 1,
      anon_sym_or,
    ACTIONS(1897), 1,
      anon_sym_as,
    ACTIONS(1895), 7,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
  [48971] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(646), 1,
      sym__string_start,
    STATE(678), 2,
      sym_string,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(1899), 8,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
  [48992] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1873), 1,
      anon_sym_and,
    ACTIONS(1875), 1,
      anon_sym_or,
    ACTIONS(1903), 1,
      anon_sym_as,
    ACTIONS(1901), 8,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
  [49015] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1863), 1,
      anon_sym_if,
    ACTIONS(1867), 1,
      anon_sym_async,
    ACTIONS(1869), 1,
      anon_sym_for,
    ACTIONS(1873), 1,
      anon_sym_and,
    ACTIONS(1875), 1,
      anon_sym_or,
    ACTIONS(1905), 1,
      anon_sym_RPAREN,
    ACTIONS(1907), 1,
      anon_sym_COMMA,
    ACTIONS(1910), 1,
      anon_sym_as,
    STATE(956), 1,
      sym_for_in_clause,
    STATE(1111), 1,
      aux_sym__collection_elements_repeat1,
    STATE(1464), 1,
      sym__comprehension_clauses,
  [49052] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1881), 1,
      anon_sym_and,
    ACTIONS(1883), 1,
      anon_sym_or,
    ACTIONS(1912), 9,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_EQ,
      sym_type_conversion,
  [49073] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1856), 11,
      anon_sym_import,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
  [49090] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1861), 1,
      anon_sym_COMMA,
    ACTIONS(1863), 1,
      anon_sym_if,
    ACTIONS(1865), 1,
      anon_sym_COLON,
    ACTIONS(1867), 1,
      anon_sym_async,
    ACTIONS(1869), 1,
      anon_sym_for,
    ACTIONS(1871), 1,
      anon_sym_RBRACE,
    ACTIONS(1873), 1,
      anon_sym_and,
    ACTIONS(1875), 1,
      anon_sym_or,
    STATE(956), 1,
      sym_for_in_clause,
    STATE(1111), 1,
      aux_sym__collection_elements_repeat1,
    STATE(1410), 1,
      sym__comprehension_clauses,
  [49127] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1879), 1,
      anon_sym_if,
    ACTIONS(1881), 1,
      anon_sym_and,
    ACTIONS(1883), 1,
      anon_sym_or,
    ACTIONS(1885), 8,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_EQ,
      sym_type_conversion,
  [49150] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1881), 1,
      anon_sym_and,
    ACTIONS(1912), 10,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_or,
      sym_type_conversion,
  [49169] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1881), 1,
      anon_sym_and,
    ACTIONS(1883), 1,
      anon_sym_or,
    ACTIONS(1901), 9,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_EQ,
      sym_type_conversion,
  [49190] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1873), 1,
      anon_sym_and,
    ACTIONS(1875), 1,
      anon_sym_or,
    ACTIONS(1914), 1,
      anon_sym_as,
    ACTIONS(1912), 8,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
  [49213] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1863), 1,
      anon_sym_if,
    ACTIONS(1873), 1,
      anon_sym_and,
    ACTIONS(1875), 1,
      anon_sym_or,
    ACTIONS(1916), 1,
      anon_sym_as,
    ACTIONS(1877), 7,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
  [49238] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1879), 1,
      anon_sym_if,
    ACTIONS(1881), 1,
      anon_sym_and,
    ACTIONS(1883), 1,
      anon_sym_or,
    ACTIONS(1895), 8,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_EQ,
      sym_type_conversion,
  [49261] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1889), 1,
      anon_sym_DOT,
    ACTIONS(1918), 1,
      anon_sym_LPAREN,
    STATE(910), 1,
      aux_sym_match_value_pattern_repeat1,
    ACTIONS(1920), 8,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
  [49284] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1881), 1,
      anon_sym_and,
    ACTIONS(1883), 1,
      anon_sym_or,
    ACTIONS(1922), 9,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_EQ,
      sym_type_conversion,
  [49305] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1873), 1,
      anon_sym_and,
    ACTIONS(1914), 1,
      anon_sym_as,
    ACTIONS(1912), 9,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_or,
  [49326] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1873), 1,
      anon_sym_and,
    ACTIONS(1875), 1,
      anon_sym_or,
    ACTIONS(1924), 1,
      anon_sym_as,
    ACTIONS(1922), 8,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
  [49349] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1879), 1,
      anon_sym_if,
    ACTIONS(1881), 1,
      anon_sym_and,
    ACTIONS(1883), 1,
      anon_sym_or,
    ACTIONS(1928), 1,
      anon_sym_COMMA,
    STATE(964), 1,
      aux_sym_expression_list_repeat1,
    ACTIONS(1926), 6,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_EQ,
      sym_type_conversion,
  [49376] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1861), 1,
      anon_sym_COMMA,
    ACTIONS(1863), 1,
      anon_sym_if,
    ACTIONS(1867), 1,
      anon_sym_async,
    ACTIONS(1869), 1,
      anon_sym_for,
    ACTIONS(1873), 1,
      anon_sym_and,
    ACTIONS(1875), 1,
      anon_sym_or,
    ACTIONS(1930), 1,
      anon_sym_RPAREN,
    STATE(956), 1,
      sym_for_in_clause,
    STATE(1111), 1,
      aux_sym__collection_elements_repeat1,
    STATE(1442), 1,
      sym__comprehension_clauses,
  [49410] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1861), 1,
      anon_sym_COMMA,
    ACTIONS(1863), 1,
      anon_sym_if,
    ACTIONS(1867), 1,
      anon_sym_async,
    ACTIONS(1869), 1,
      anon_sym_for,
    ACTIONS(1873), 1,
      anon_sym_and,
    ACTIONS(1875), 1,
      anon_sym_or,
    ACTIONS(1932), 1,
      anon_sym_RPAREN,
    STATE(956), 1,
      sym_for_in_clause,
    STATE(1111), 1,
      aux_sym__collection_elements_repeat1,
    STATE(1417), 1,
      sym__comprehension_clauses,
  [49444] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1861), 1,
      anon_sym_COMMA,
    ACTIONS(1863), 1,
      anon_sym_if,
    ACTIONS(1867), 1,
      anon_sym_async,
    ACTIONS(1869), 1,
      anon_sym_for,
    ACTIONS(1871), 1,
      anon_sym_RBRACK,
    ACTIONS(1873), 1,
      anon_sym_and,
    ACTIONS(1875), 1,
      anon_sym_or,
    STATE(956), 1,
      sym_for_in_clause,
    STATE(1111), 1,
      aux_sym__collection_elements_repeat1,
    STATE(1429), 1,
      sym__comprehension_clauses,
  [49478] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1879), 1,
      anon_sym_if,
    ACTIONS(1881), 1,
      anon_sym_and,
    ACTIONS(1883), 1,
      anon_sym_or,
    ACTIONS(1934), 7,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_EQ,
      sym_type_conversion,
  [49500] = 9,
    ACTIONS(1936), 1,
      anon_sym_LBRACE2,
    ACTIONS(1940), 1,
      sym__not_escape_sequence,
    ACTIONS(1942), 1,
      sym_comment,
    ACTIONS(1944), 1,
      sym__string_end,
    STATE(936), 1,
      aux_sym_string_repeat1,
    STATE(1031), 1,
      aux_sym_string_content_repeat1,
    STATE(1072), 1,
      sym_string_content,
    STATE(1076), 1,
      sym_interpolation,
    ACTIONS(1938), 3,
      sym__string_content,
      sym__escape_interpolation,
      sym_escape_sequence,
  [49530] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1861), 1,
      anon_sym_COMMA,
    ACTIONS(1863), 1,
      anon_sym_if,
    ACTIONS(1867), 1,
      anon_sym_async,
    ACTIONS(1869), 1,
      anon_sym_for,
    ACTIONS(1871), 1,
      anon_sym_RBRACK,
    ACTIONS(1873), 1,
      anon_sym_and,
    ACTIONS(1875), 1,
      anon_sym_or,
    STATE(956), 1,
      sym_for_in_clause,
    STATE(1111), 1,
      aux_sym__collection_elements_repeat1,
    STATE(1407), 1,
      sym__comprehension_clauses,
  [49564] = 9,
    ACTIONS(1936), 1,
      anon_sym_LBRACE2,
    ACTIONS(1940), 1,
      sym__not_escape_sequence,
    ACTIONS(1942), 1,
      sym_comment,
    ACTIONS(1946), 1,
      sym__string_end,
    STATE(937), 1,
      aux_sym_string_repeat1,
    STATE(1031), 1,
      aux_sym_string_content_repeat1,
    STATE(1072), 1,
      sym_string_content,
    STATE(1076), 1,
      sym_interpolation,
    ACTIONS(1938), 3,
      sym__string_content,
      sym__escape_interpolation,
      sym_escape_sequence,
  [49594] = 9,
    ACTIONS(1942), 1,
      sym_comment,
    ACTIONS(1948), 1,
      anon_sym_LBRACE2,
    ACTIONS(1954), 1,
      sym__not_escape_sequence,
    ACTIONS(1957), 1,
      sym__string_end,
    STATE(937), 1,
      aux_sym_string_repeat1,
    STATE(1031), 1,
      aux_sym_string_content_repeat1,
    STATE(1072), 1,
      sym_string_content,
    STATE(1076), 1,
      sym_interpolation,
    ACTIONS(1951), 3,
      sym__string_content,
      sym__escape_interpolation,
      sym_escape_sequence,
  [49624] = 9,
    ACTIONS(1936), 1,
      anon_sym_LBRACE2,
    ACTIONS(1940), 1,
      sym__not_escape_sequence,
    ACTIONS(1942), 1,
      sym_comment,
    ACTIONS(1959), 1,
      sym__string_end,
    STATE(937), 1,
      aux_sym_string_repeat1,
    STATE(1031), 1,
      aux_sym_string_content_repeat1,
    STATE(1072), 1,
      sym_string_content,
    STATE(1076), 1,
      sym_interpolation,
    ACTIONS(1938), 3,
      sym__string_content,
      sym__escape_interpolation,
      sym_escape_sequence,
  [49654] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1879), 1,
      anon_sym_if,
    ACTIONS(1881), 1,
      anon_sym_and,
    ACTIONS(1883), 1,
      anon_sym_or,
    ACTIONS(1961), 7,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_EQ,
      sym_type_conversion,
  [49676] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1863), 1,
      anon_sym_if,
    ACTIONS(1867), 1,
      anon_sym_async,
    ACTIONS(1869), 1,
      anon_sym_for,
    ACTIONS(1873), 1,
      anon_sym_and,
    ACTIONS(1875), 1,
      anon_sym_or,
    ACTIONS(1963), 1,
      anon_sym_RPAREN,
    ACTIONS(1965), 1,
      anon_sym_COMMA,
    STATE(956), 1,
      sym_for_in_clause,
    STATE(1228), 1,
      aux_sym_argument_list_repeat1,
    STATE(1417), 1,
      sym__comprehension_clauses,
  [49710] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1861), 1,
      anon_sym_COMMA,
    ACTIONS(1863), 1,
      anon_sym_if,
    ACTIONS(1867), 1,
      anon_sym_async,
    ACTIONS(1869), 1,
      anon_sym_for,
    ACTIONS(1871), 1,
      anon_sym_RBRACK,
    ACTIONS(1873), 1,
      anon_sym_and,
    ACTIONS(1875), 1,
      anon_sym_or,
    STATE(956), 1,
      sym_for_in_clause,
    STATE(1111), 1,
      aux_sym__collection_elements_repeat1,
    STATE(1437), 1,
      sym__comprehension_clauses,
  [49744] = 9,
    ACTIONS(1936), 1,
      anon_sym_LBRACE2,
    ACTIONS(1940), 1,
      sym__not_escape_sequence,
    ACTIONS(1942), 1,
      sym_comment,
    ACTIONS(1967), 1,
      sym__string_end,
    STATE(937), 1,
      aux_sym_string_repeat1,
    STATE(1031), 1,
      aux_sym_string_content_repeat1,
    STATE(1072), 1,
      sym_string_content,
    STATE(1076), 1,
      sym_interpolation,
    ACTIONS(1938), 3,
      sym__string_content,
      sym__escape_interpolation,
      sym_escape_sequence,
  [49774] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1971), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1969), 8,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
  [49792] = 9,
    ACTIONS(1936), 1,
      anon_sym_LBRACE2,
    ACTIONS(1940), 1,
      sym__not_escape_sequence,
    ACTIONS(1942), 1,
      sym_comment,
    ACTIONS(1973), 1,
      sym__string_end,
    STATE(942), 1,
      aux_sym_string_repeat1,
    STATE(1031), 1,
      aux_sym_string_content_repeat1,
    STATE(1072), 1,
      sym_string_content,
    STATE(1076), 1,
      sym_interpolation,
    ACTIONS(1938), 3,
      sym__string_content,
      sym__escape_interpolation,
      sym_escape_sequence,
  [49822] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1861), 1,
      anon_sym_COMMA,
    ACTIONS(1863), 1,
      anon_sym_if,
    ACTIONS(1867), 1,
      anon_sym_async,
    ACTIONS(1869), 1,
      anon_sym_for,
    ACTIONS(1873), 1,
      anon_sym_and,
    ACTIONS(1875), 1,
      anon_sym_or,
    ACTIONS(1905), 1,
      anon_sym_RPAREN,
    STATE(956), 1,
      sym_for_in_clause,
    STATE(1111), 1,
      aux_sym__collection_elements_repeat1,
    STATE(1464), 1,
      sym__comprehension_clauses,
  [49856] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1863), 1,
      anon_sym_if,
    ACTIONS(1867), 1,
      anon_sym_async,
    ACTIONS(1869), 1,
      anon_sym_for,
    ACTIONS(1873), 1,
      anon_sym_and,
    ACTIONS(1875), 1,
      anon_sym_or,
    ACTIONS(1975), 1,
      anon_sym_RPAREN,
    ACTIONS(1977), 1,
      anon_sym_COMMA,
    STATE(956), 1,
      sym_for_in_clause,
    STATE(1273), 1,
      aux_sym_argument_list_repeat1,
    STATE(1464), 1,
      sym__comprehension_clauses,
  [49890] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1879), 1,
      anon_sym_if,
    ACTIONS(1881), 1,
      anon_sym_and,
    ACTIONS(1883), 1,
      anon_sym_or,
    ACTIONS(1979), 7,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_EQ,
      sym_type_conversion,
  [49912] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1879), 1,
      anon_sym_if,
    ACTIONS(1881), 1,
      anon_sym_and,
    ACTIONS(1883), 1,
      anon_sym_or,
    ACTIONS(1981), 7,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_EQ,
      sym_type_conversion,
  [49934] = 9,
    ACTIONS(1936), 1,
      anon_sym_LBRACE2,
    ACTIONS(1940), 1,
      sym__not_escape_sequence,
    ACTIONS(1942), 1,
      sym_comment,
    ACTIONS(1983), 1,
      sym__string_end,
    STATE(937), 1,
      aux_sym_string_repeat1,
    STATE(1031), 1,
      aux_sym_string_content_repeat1,
    STATE(1072), 1,
      sym_string_content,
    STATE(1076), 1,
      sym_interpolation,
    ACTIONS(1938), 3,
      sym__string_content,
      sym__escape_interpolation,
      sym_escape_sequence,
  [49964] = 9,
    ACTIONS(1936), 1,
      anon_sym_LBRACE2,
    ACTIONS(1940), 1,
      sym__not_escape_sequence,
    ACTIONS(1942), 1,
      sym_comment,
    ACTIONS(1985), 1,
      sym__string_end,
    STATE(949), 1,
      aux_sym_string_repeat1,
    STATE(1031), 1,
      aux_sym_string_content_repeat1,
    STATE(1072), 1,
      sym_string_content,
    STATE(1076), 1,
      sym_interpolation,
    ACTIONS(1938), 3,
      sym__string_content,
      sym__escape_interpolation,
      sym_escape_sequence,
  [49994] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1989), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1987), 8,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
  [50012] = 9,
    ACTIONS(1936), 1,
      anon_sym_LBRACE2,
    ACTIONS(1940), 1,
      sym__not_escape_sequence,
    ACTIONS(1942), 1,
      sym_comment,
    ACTIONS(1991), 1,
      sym__string_end,
    STATE(938), 1,
      aux_sym_string_repeat1,
    STATE(1031), 1,
      aux_sym_string_content_repeat1,
    STATE(1072), 1,
      sym_string_content,
    STATE(1076), 1,
      sym_interpolation,
    ACTIONS(1938), 3,
      sym__string_content,
      sym__escape_interpolation,
      sym_escape_sequence,
  [50042] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1863), 1,
      anon_sym_if,
    ACTIONS(1867), 1,
      anon_sym_async,
    ACTIONS(1869), 1,
      anon_sym_for,
    ACTIONS(1873), 1,
      anon_sym_and,
    ACTIONS(1875), 1,
      anon_sym_or,
    ACTIONS(1993), 1,
      anon_sym_RPAREN,
    ACTIONS(1995), 1,
      anon_sym_COMMA,
    STATE(956), 1,
      sym_for_in_clause,
    STATE(1280), 1,
      aux_sym_argument_list_repeat1,
    STATE(1442), 1,
      sym__comprehension_clauses,
  [50076] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1999), 1,
      anon_sym_PIPE,
    STATE(954), 1,
      aux_sym_match_or_pattern_repeat1,
    ACTIONS(1997), 7,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
  [50095] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2004), 1,
      anon_sym_if,
    ACTIONS(2007), 1,
      anon_sym_async,
    ACTIONS(2010), 1,
      anon_sym_for,
    ACTIONS(2002), 3,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
    STATE(955), 3,
      sym_for_in_clause,
      sym_if_clause,
      aux_sym__comprehension_clauses_repeat1,
  [50118] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1867), 1,
      anon_sym_async,
    ACTIONS(1869), 1,
      anon_sym_for,
    ACTIONS(2015), 1,
      anon_sym_if,
    ACTIONS(2013), 3,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
    STATE(959), 3,
      sym_for_in_clause,
      sym_if_clause,
      aux_sym__comprehension_clauses_repeat1,
  [50141] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2019), 1,
      anon_sym_PIPE,
    STATE(961), 1,
      aux_sym_match_or_pattern_repeat1,
    ACTIONS(2017), 7,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
  [50160] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1873), 1,
      anon_sym_and,
    ACTIONS(1875), 1,
      anon_sym_or,
    ACTIONS(2021), 7,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
  [50179] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1867), 1,
      anon_sym_async,
    ACTIONS(1869), 1,
      anon_sym_for,
    ACTIONS(2015), 1,
      anon_sym_if,
    ACTIONS(2023), 3,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
    STATE(955), 3,
      sym_for_in_clause,
      sym_if_clause,
      aux_sym__comprehension_clauses_repeat1,
  [50202] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1879), 1,
      anon_sym_if,
    ACTIONS(1881), 1,
      anon_sym_and,
    ACTIONS(1883), 1,
      anon_sym_or,
    ACTIONS(1928), 1,
      anon_sym_COMMA,
    STATE(964), 1,
      aux_sym_expression_list_repeat1,
    ACTIONS(2025), 4,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_EQ,
      sym_type_conversion,
  [50227] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2019), 1,
      anon_sym_PIPE,
    STATE(954), 1,
      aux_sym_match_or_pattern_repeat1,
    ACTIONS(2027), 7,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
  [50246] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1873), 1,
      anon_sym_and,
    ACTIONS(1875), 1,
      anon_sym_or,
    ACTIONS(2021), 7,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
  [50265] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1873), 1,
      anon_sym_and,
    ACTIONS(1875), 1,
      anon_sym_or,
    ACTIONS(2021), 7,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
  [50284] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2031), 1,
      anon_sym_COMMA,
    STATE(1005), 1,
      aux_sym_expression_list_repeat1,
    ACTIONS(2029), 6,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_EQ,
      sym_type_conversion,
  [50302] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(854), 1,
      anon_sym_except_STAR,
    ACTIONS(862), 1,
      anon_sym_except,
    ACTIONS(2033), 1,
      anon_sym_finally,
    STATE(568), 1,
      sym_finally_clause,
    STATE(229), 2,
      sym_except_group_clause,
      aux_sym_try_statement_repeat2,
    STATE(241), 2,
      sym_except_clause,
      aux_sym_try_statement_repeat1,
  [50326] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2035), 8,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
  [50340] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1852), 8,
      sym__newline,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_EQ,
      anon_sym_and,
      anon_sym_or,
      sym__semicolon,
  [50354] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2037), 8,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
  [50368] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2039), 8,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
  [50382] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2041), 8,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
  [50396] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2045), 1,
      anon_sym_PIPE,
    ACTIONS(2043), 7,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
  [50412] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2047), 8,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
  [50426] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2049), 8,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
  [50440] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2051), 1,
      anon_sym_and,
    ACTIONS(2053), 1,
      anon_sym_or,
    ACTIONS(1901), 6,
      sym__newline,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_EQ,
      sym__semicolon,
  [50458] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1899), 8,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
  [50472] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1848), 8,
      sym__newline,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_EQ,
      anon_sym_and,
      anon_sym_or,
      sym__semicolon,
  [50486] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2055), 8,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
  [50500] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2059), 1,
      anon_sym_COMMA,
    STATE(1012), 1,
      aux_sym_for_in_clause_repeat1,
    ACTIONS(2057), 6,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
  [50518] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2063), 1,
      anon_sym_COMMA,
    STATE(995), 1,
      aux_sym_for_in_clause_repeat1,
    ACTIONS(2061), 6,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
  [50536] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2051), 1,
      anon_sym_and,
    ACTIONS(2053), 1,
      anon_sym_or,
    ACTIONS(1922), 6,
      sym__newline,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_EQ,
      sym__semicolon,
  [50554] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2065), 8,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
  [50568] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2051), 1,
      anon_sym_and,
    ACTIONS(2053), 1,
      anon_sym_or,
    ACTIONS(2067), 1,
      anon_sym_from,
    ACTIONS(2069), 1,
      anon_sym_COMMA,
    ACTIONS(2071), 1,
      anon_sym_if,
    STATE(1092), 1,
      aux_sym_expression_list_repeat1,
    ACTIONS(2073), 2,
      sym__newline,
      sym__semicolon,
  [50594] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(854), 1,
      anon_sym_except_STAR,
    ACTIONS(862), 1,
      anon_sym_except,
    ACTIONS(2033), 1,
      anon_sym_finally,
    STATE(516), 1,
      sym_finally_clause,
    STATE(232), 2,
      sym_except_clause,
      aux_sym_try_statement_repeat1,
    STATE(234), 2,
      sym_except_group_clause,
      aux_sym_try_statement_repeat2,
  [50618] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1997), 8,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
  [50632] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2075), 1,
      anon_sym_COMMA,
    STATE(1005), 1,
      aux_sym_expression_list_repeat1,
    ACTIONS(2029), 6,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_EQ,
      sym_type_conversion,
  [50650] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2077), 8,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
  [50664] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2079), 8,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
  [50678] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2081), 8,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
  [50692] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2083), 8,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
  [50706] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2085), 8,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
  [50720] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(848), 1,
      anon_sym_except,
    ACTIONS(864), 1,
      anon_sym_except_STAR,
    ACTIONS(2087), 1,
      anon_sym_finally,
    STATE(514), 1,
      sym_finally_clause,
    STATE(228), 2,
      sym_except_clause,
      aux_sym_try_statement_repeat1,
    STATE(240), 2,
      sym_except_group_clause,
      aux_sym_try_statement_repeat2,
  [50744] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2051), 1,
      anon_sym_and,
    ACTIONS(2053), 1,
      anon_sym_or,
    ACTIONS(2071), 1,
      anon_sym_if,
    ACTIONS(1885), 5,
      sym__newline,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_EQ,
      sym__semicolon,
  [50764] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2089), 8,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
  [50778] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1873), 1,
      anon_sym_and,
    ACTIONS(1875), 1,
      anon_sym_or,
    ACTIONS(2091), 6,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
  [50796] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2095), 1,
      anon_sym_COMMA,
    STATE(1012), 1,
      aux_sym_for_in_clause_repeat1,
    ACTIONS(2093), 6,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
  [50814] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(67), 1,
      anon_sym_AT,
    ACTIONS(2097), 1,
      anon_sym_async,
    ACTIONS(2099), 1,
      anon_sym_def,
    ACTIONS(2101), 1,
      anon_sym_class,
    STATE(584), 2,
      sym_function_definition,
      sym_class_definition,
    STATE(1062), 2,
      sym_decorator,
      aux_sym_decorated_definition_repeat1,
  [50838] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2051), 1,
      anon_sym_and,
    ACTIONS(2053), 1,
      anon_sym_or,
    ACTIONS(2071), 1,
      anon_sym_if,
    ACTIONS(1895), 5,
      sym__newline,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_EQ,
      sym__semicolon,
  [50858] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2103), 8,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
  [50872] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1889), 1,
      anon_sym_DOT,
    ACTIONS(1918), 1,
      anon_sym_LPAREN,
    ACTIONS(2105), 1,
      anon_sym_EQ,
    STATE(910), 1,
      aux_sym_match_value_pattern_repeat1,
    ACTIONS(1920), 4,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
  [50894] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2051), 1,
      anon_sym_and,
    ACTIONS(2053), 1,
      anon_sym_or,
    ACTIONS(1912), 6,
      sym__newline,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_EQ,
      sym__semicolon,
  [50912] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2051), 1,
      anon_sym_and,
    ACTIONS(1912), 7,
      sym__newline,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_EQ,
      anon_sym_or,
      sym__semicolon,
  [50928] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(67), 1,
      anon_sym_AT,
    ACTIONS(2107), 1,
      anon_sym_async,
    ACTIONS(2109), 1,
      anon_sym_def,
    ACTIONS(2111), 1,
      anon_sym_class,
    STATE(499), 2,
      sym_function_definition,
      sym_class_definition,
    STATE(1062), 2,
      sym_decorator,
      aux_sym_decorated_definition_repeat1,
  [50952] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(848), 1,
      anon_sym_except,
    ACTIONS(864), 1,
      anon_sym_except_STAR,
    ACTIONS(2087), 1,
      anon_sym_finally,
    STATE(507), 1,
      sym_finally_clause,
    STATE(237), 2,
      sym_except_group_clause,
      aux_sym_try_statement_repeat2,
    STATE(238), 2,
      sym_except_clause,
      aux_sym_try_statement_repeat1,
  [50976] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2113), 8,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
  [50990] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2117), 1,
      anon_sym_COMMA,
    STATE(1005), 1,
      aux_sym_expression_list_repeat1,
    ACTIONS(2115), 6,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_EQ,
      sym_type_conversion,
  [51008] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2120), 8,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
  [51022] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2051), 1,
      anon_sym_and,
    ACTIONS(2053), 1,
      anon_sym_or,
    ACTIONS(2071), 1,
      anon_sym_if,
    ACTIONS(1877), 5,
      sym__newline,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_EQ,
      sym__semicolon,
  [51042] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2122), 8,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
  [51056] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1479), 8,
      sym__newline,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_EQ,
      anon_sym_and,
      anon_sym_or,
      sym__semicolon,
  [51070] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2124), 8,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
  [51084] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2126), 8,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
  [51098] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2130), 1,
      anon_sym_COMMA,
    STATE(1012), 1,
      aux_sym_for_in_clause_repeat1,
    ACTIONS(2128), 6,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
  [51116] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2135), 1,
      anon_sym_COMMA,
    STATE(978), 1,
      aux_sym_for_in_clause_repeat1,
    ACTIONS(2133), 6,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
  [51134] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2051), 1,
      anon_sym_and,
    ACTIONS(2053), 1,
      anon_sym_or,
    ACTIONS(2069), 1,
      anon_sym_COMMA,
    ACTIONS(2071), 1,
      anon_sym_if,
    STATE(1092), 1,
      aux_sym_expression_list_repeat1,
    ACTIONS(1926), 2,
      sym__newline,
      sym__semicolon,
  [51157] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1479), 7,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_or,
  [51170] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2137), 1,
      sym_identifier,
    ACTIONS(2139), 1,
      anon_sym_DOT,
    ACTIONS(2141), 1,
      anon_sym___future__,
    STATE(1144), 1,
      aux_sym_import_prefix_repeat1,
    STATE(1236), 1,
      sym_import_prefix,
    STATE(1441), 2,
      sym_relative_import,
      sym_dotted_name,
  [51193] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2143), 7,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
  [51206] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2128), 7,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
  [51219] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2051), 1,
      anon_sym_and,
    ACTIONS(2053), 1,
      anon_sym_or,
    ACTIONS(2069), 1,
      anon_sym_COMMA,
    ACTIONS(2071), 1,
      anon_sym_if,
    STATE(1092), 1,
      aux_sym_expression_list_repeat1,
    ACTIONS(2145), 2,
      sym__newline,
      sym__semicolon,
  [51242] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2147), 1,
      sym_identifier,
    ACTIONS(2149), 1,
      anon_sym_STAR,
    ACTIONS(2151), 1,
      anon_sym_STAR_STAR,
    STATE(1388), 4,
      sym_typevar_parameter,
      sym_typevartuple_parameter,
      sym_paramspec_parameter,
      sym__type_parameter,
  [51261] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1879), 1,
      anon_sym_if,
    ACTIONS(1881), 1,
      anon_sym_and,
    ACTIONS(1883), 1,
      anon_sym_or,
    ACTIONS(2153), 1,
      anon_sym_COMMA,
    ACTIONS(2155), 1,
      anon_sym_COLON,
    ACTIONS(2157), 1,
      anon_sym_RBRACK,
    STATE(1203), 1,
      aux_sym_subscript_repeat1,
  [51286] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1879), 1,
      anon_sym_if,
    ACTIONS(1881), 1,
      anon_sym_and,
    ACTIONS(1883), 1,
      anon_sym_or,
    ACTIONS(2159), 4,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
  [51305] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1934), 7,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_EQ,
      sym_type_conversion,
  [51318] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2163), 1,
      anon_sym_as,
    ACTIONS(2161), 6,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
  [51333] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2165), 1,
      anon_sym_and,
    ACTIONS(2167), 1,
      anon_sym_or,
    ACTIONS(1922), 5,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
  [51350] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2051), 1,
      anon_sym_and,
    ACTIONS(2053), 1,
      anon_sym_or,
    ACTIONS(2071), 1,
      anon_sym_if,
    ACTIONS(2169), 1,
      anon_sym_COMMA,
    STATE(1137), 1,
      aux_sym_assert_statement_repeat1,
    ACTIONS(2171), 2,
      sym__newline,
      sym__semicolon,
  [51373] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2165), 1,
      anon_sym_and,
    ACTIONS(2167), 1,
      anon_sym_or,
    ACTIONS(2173), 1,
      anon_sym_if,
    ACTIONS(1895), 4,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_COLON,
  [51392] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2165), 1,
      anon_sym_and,
    ACTIONS(2167), 1,
      anon_sym_or,
    ACTIONS(1901), 5,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
  [51409] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2165), 1,
      anon_sym_and,
    ACTIONS(1912), 6,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_or,
  [51424] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2165), 1,
      anon_sym_and,
    ACTIONS(2167), 1,
      anon_sym_or,
    ACTIONS(1912), 5,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
  [51441] = 6,
    ACTIONS(1942), 1,
      sym_comment,
    ACTIONS(2175), 1,
      anon_sym_LBRACE2,
    ACTIONS(2179), 1,
      sym__not_escape_sequence,
    ACTIONS(2181), 1,
      sym__string_end,
    STATE(1055), 1,
      aux_sym_string_content_repeat1,
    ACTIONS(2177), 3,
      sym__string_content,
      sym__escape_interpolation,
      sym_escape_sequence,
  [51462] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2165), 1,
      anon_sym_and,
    ACTIONS(2167), 1,
      anon_sym_or,
    ACTIONS(2173), 1,
      anon_sym_if,
    ACTIONS(1877), 4,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_COLON,
  [51481] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2183), 7,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
  [51494] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2051), 1,
      anon_sym_and,
    ACTIONS(2053), 1,
      anon_sym_or,
    ACTIONS(2069), 1,
      anon_sym_COMMA,
    ACTIONS(2071), 1,
      anon_sym_if,
    STATE(1092), 1,
      aux_sym_expression_list_repeat1,
    ACTIONS(2185), 2,
      sym__newline,
      sym__semicolon,
  [51517] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2165), 1,
      anon_sym_and,
    ACTIONS(2167), 1,
      anon_sym_or,
    ACTIONS(2173), 1,
      anon_sym_if,
    ACTIONS(1885), 4,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_COLON,
  [51536] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2051), 1,
      anon_sym_and,
    ACTIONS(2053), 1,
      anon_sym_or,
    ACTIONS(2071), 1,
      anon_sym_if,
    ACTIONS(1934), 4,
      sym__newline,
      anon_sym_from,
      anon_sym_COMMA,
      sym__semicolon,
  [51555] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2147), 1,
      sym_identifier,
    ACTIONS(2149), 1,
      anon_sym_STAR,
    ACTIONS(2151), 1,
      anon_sym_STAR_STAR,
    STATE(1227), 4,
      sym_typevar_parameter,
      sym_typevartuple_parameter,
      sym_paramspec_parameter,
      sym__type_parameter,
  [51574] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1867), 1,
      anon_sym_async,
    ACTIONS(1869), 1,
      anon_sym_for,
    ACTIONS(2187), 1,
      anon_sym_COMMA,
    ACTIONS(2189), 1,
      anon_sym_RBRACE,
    STATE(956), 1,
      sym_for_in_clause,
    STATE(1247), 1,
      aux_sym_dictionary_repeat1,
    STATE(1433), 1,
      sym__comprehension_clauses,
  [51599] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1863), 1,
      anon_sym_if,
    ACTIONS(1873), 1,
      anon_sym_and,
    ACTIONS(1875), 1,
      anon_sym_or,
    ACTIONS(2191), 4,
      anon_sym_COMMA,
      anon_sym_async,
      anon_sym_for,
      anon_sym_RBRACE,
  [51618] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1879), 1,
      anon_sym_if,
    ACTIONS(1881), 1,
      anon_sym_and,
    ACTIONS(1883), 1,
      anon_sym_or,
    ACTIONS(2155), 1,
      anon_sym_COLON,
    ACTIONS(2193), 1,
      anon_sym_COMMA,
    ACTIONS(2195), 1,
      anon_sym_RBRACK,
    STATE(1282), 1,
      aux_sym_subscript_repeat1,
  [51643] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1926), 7,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_EQ,
      sym_type_conversion,
  [51656] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1848), 7,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_or,
  [51669] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2051), 1,
      anon_sym_and,
    ACTIONS(2053), 1,
      anon_sym_or,
    ACTIONS(2071), 1,
      anon_sym_if,
    ACTIONS(2197), 1,
      anon_sym_COMMA,
    STATE(1172), 1,
      aux_sym_print_statement_repeat1,
    ACTIONS(2199), 2,
      sym__newline,
      sym__semicolon,
  [51692] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2051), 1,
      anon_sym_and,
    ACTIONS(2053), 1,
      anon_sym_or,
    ACTIONS(2071), 1,
      anon_sym_if,
    ACTIONS(2169), 1,
      anon_sym_COMMA,
    STATE(1174), 1,
      aux_sym_assert_statement_repeat1,
    ACTIONS(2201), 2,
      sym__newline,
      sym__semicolon,
  [51715] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2051), 1,
      anon_sym_and,
    ACTIONS(2053), 1,
      anon_sym_or,
    ACTIONS(2069), 1,
      anon_sym_COMMA,
    ACTIONS(2071), 1,
      anon_sym_if,
    STATE(1092), 1,
      aux_sym_expression_list_repeat1,
    ACTIONS(2203), 2,
      sym__newline,
      sym__semicolon,
  [51738] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2051), 1,
      anon_sym_and,
    ACTIONS(2053), 1,
      anon_sym_or,
    ACTIONS(2069), 1,
      anon_sym_COMMA,
    ACTIONS(2071), 1,
      anon_sym_if,
    STATE(1092), 1,
      aux_sym_expression_list_repeat1,
    ACTIONS(2205), 2,
      sym__newline,
      sym__semicolon,
  [51761] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1879), 1,
      anon_sym_if,
    ACTIONS(1881), 1,
      anon_sym_and,
    ACTIONS(1883), 1,
      anon_sym_or,
    ACTIONS(2155), 1,
      anon_sym_COLON,
    ACTIONS(2207), 1,
      anon_sym_COMMA,
    ACTIONS(2209), 1,
      anon_sym_RBRACK,
    STATE(1272), 1,
      aux_sym_subscript_repeat1,
  [51786] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2051), 1,
      anon_sym_and,
    ACTIONS(2053), 1,
      anon_sym_or,
    ACTIONS(2071), 1,
      anon_sym_if,
    ACTIONS(1979), 4,
      sym__newline,
      anon_sym_from,
      anon_sym_COMMA,
      sym__semicolon,
  [51805] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1867), 1,
      anon_sym_async,
    ACTIONS(1869), 1,
      anon_sym_for,
    ACTIONS(2211), 1,
      anon_sym_COMMA,
    ACTIONS(2213), 1,
      anon_sym_RBRACE,
    STATE(956), 1,
      sym_for_in_clause,
    STATE(1300), 1,
      aux_sym_dictionary_repeat1,
    STATE(1411), 1,
      sym__comprehension_clauses,
  [51830] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2165), 1,
      anon_sym_and,
    ACTIONS(2167), 1,
      anon_sym_or,
    ACTIONS(2173), 1,
      anon_sym_if,
    ACTIONS(2217), 1,
      anon_sym_as,
    ACTIONS(2215), 3,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON,
  [51851] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1852), 7,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_or,
  [51864] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1867), 1,
      anon_sym_async,
    ACTIONS(1869), 1,
      anon_sym_for,
    ACTIONS(2219), 1,
      anon_sym_COMMA,
    ACTIONS(2221), 1,
      anon_sym_RBRACE,
    STATE(956), 1,
      sym_for_in_clause,
    STATE(1234), 1,
      aux_sym_dictionary_repeat1,
    STATE(1439), 1,
      sym__comprehension_clauses,
  [51889] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1879), 1,
      anon_sym_if,
    ACTIONS(1881), 1,
      anon_sym_and,
    ACTIONS(1883), 1,
      anon_sym_or,
    ACTIONS(2223), 4,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
  [51908] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2051), 1,
      anon_sym_and,
    ACTIONS(2053), 1,
      anon_sym_or,
    ACTIONS(2071), 1,
      anon_sym_if,
    ACTIONS(1981), 4,
      sym__newline,
      anon_sym_from,
      anon_sym_COMMA,
      sym__semicolon,
  [51927] = 6,
    ACTIONS(1942), 1,
      sym_comment,
    ACTIONS(2225), 1,
      anon_sym_LBRACE2,
    ACTIONS(2230), 1,
      sym__not_escape_sequence,
    ACTIONS(2233), 1,
      sym__string_end,
    STATE(1055), 1,
      aux_sym_string_content_repeat1,
    ACTIONS(2227), 3,
      sym__string_content,
      sym__escape_interpolation,
      sym_escape_sequence,
  [51948] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2235), 1,
      sym_identifier,
    ACTIONS(2237), 1,
      anon_sym_LPAREN,
    ACTIONS(2239), 1,
      anon_sym_STAR,
    STATE(1109), 1,
      sym_dotted_name,
    STATE(1143), 1,
      sym_aliased_import,
    STATE(1393), 1,
      sym_wildcard_import,
    STATE(1395), 1,
      sym__import_list,
  [51973] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2241), 1,
      anon_sym_DOT,
    STATE(1057), 1,
      aux_sym_match_value_pattern_repeat1,
    ACTIONS(1856), 4,
      sym__newline,
      anon_sym_COMMA,
      anon_sym_as,
      sym__semicolon,
  [51989] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1889), 1,
      anon_sym_DOT,
    STATE(906), 1,
      aux_sym_match_value_pattern_repeat1,
    ACTIONS(2244), 4,
      anon_sym_import,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
  [52005] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1879), 1,
      anon_sym_if,
    ACTIONS(1881), 1,
      anon_sym_and,
    ACTIONS(1883), 1,
      anon_sym_or,
    ACTIONS(1928), 1,
      anon_sym_COMMA,
    ACTIONS(2246), 1,
      anon_sym_COLON,
    STATE(964), 1,
      aux_sym_expression_list_repeat1,
  [52027] = 3,
    ACTIONS(1942), 1,
      sym_comment,
    ACTIONS(2248), 2,
      anon_sym_LBRACE2,
      sym__not_escape_sequence,
    ACTIONS(2250), 4,
      sym__string_content,
      sym__string_end,
      sym__escape_interpolation,
      sym_escape_sequence,
  [52041] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1889), 1,
      anon_sym_DOT,
    STATE(1058), 1,
      aux_sym_match_value_pattern_repeat1,
    ACTIONS(2252), 4,
      anon_sym_import,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
  [52057] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2256), 1,
      anon_sym_AT,
    STATE(1062), 2,
      sym_decorator,
      aux_sym_decorated_definition_repeat1,
    ACTIONS(2254), 3,
      anon_sym_async,
      anon_sym_def,
      anon_sym_class,
  [52073] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2165), 1,
      anon_sym_and,
    ACTIONS(2167), 1,
      anon_sym_or,
    ACTIONS(2173), 1,
      anon_sym_if,
    ACTIONS(2261), 1,
      anon_sym_COLON,
    ACTIONS(2259), 2,
      anon_sym_COMMA,
      anon_sym_as,
  [52093] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1879), 1,
      anon_sym_if,
    ACTIONS(1881), 1,
      anon_sym_and,
    ACTIONS(1883), 1,
      anon_sym_or,
    ACTIONS(2265), 1,
      anon_sym_COLON,
    ACTIONS(2263), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [52113] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2051), 1,
      anon_sym_and,
    ACTIONS(2053), 1,
      anon_sym_or,
    ACTIONS(2071), 1,
      anon_sym_if,
    ACTIONS(2267), 3,
      sym__newline,
      anon_sym_COMMA,
      sym__semicolon,
  [52131] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2051), 1,
      anon_sym_and,
    ACTIONS(2053), 1,
      anon_sym_or,
    ACTIONS(2071), 1,
      anon_sym_if,
    ACTIONS(2269), 3,
      sym__newline,
      anon_sym_COMMA,
      sym__semicolon,
  [52149] = 3,
    ACTIONS(1942), 1,
      sym_comment,
    ACTIONS(2271), 2,
      anon_sym_LBRACE2,
      sym__not_escape_sequence,
    ACTIONS(2273), 4,
      sym__string_content,
      sym__string_end,
      sym__escape_interpolation,
      sym_escape_sequence,
  [52163] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2275), 1,
      anon_sym_DOT,
    STATE(1057), 1,
      aux_sym_match_value_pattern_repeat1,
    ACTIONS(2244), 4,
      sym__newline,
      anon_sym_COMMA,
      anon_sym_as,
      sym__semicolon,
  [52179] = 3,
    ACTIONS(1942), 1,
      sym_comment,
    ACTIONS(2277), 2,
      anon_sym_LBRACE2,
      sym__not_escape_sequence,
    ACTIONS(2279), 4,
      sym__string_content,
      sym__string_end,
      sym__escape_interpolation,
      sym_escape_sequence,
  [52193] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1879), 1,
      anon_sym_if,
    ACTIONS(1881), 1,
      anon_sym_and,
    ACTIONS(1883), 1,
      anon_sym_or,
    ACTIONS(1928), 1,
      anon_sym_COMMA,
    ACTIONS(2281), 1,
      anon_sym_COLON,
    STATE(964), 1,
      aux_sym_expression_list_repeat1,
  [52215] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1879), 1,
      anon_sym_if,
    ACTIONS(1881), 1,
      anon_sym_and,
    ACTIONS(1883), 1,
      anon_sym_or,
    ACTIONS(1993), 1,
      anon_sym_RPAREN,
    ACTIONS(1995), 1,
      anon_sym_COMMA,
    STATE(1280), 1,
      aux_sym_argument_list_repeat1,
  [52237] = 3,
    ACTIONS(1942), 1,
      sym_comment,
    ACTIONS(2283), 2,
      anon_sym_LBRACE2,
      sym__not_escape_sequence,
    ACTIONS(2285), 4,
      sym__string_content,
      sym__string_end,
      sym__escape_interpolation,
      sym_escape_sequence,
  [52251] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1879), 1,
      anon_sym_if,
    ACTIONS(1881), 1,
      anon_sym_and,
    ACTIONS(1883), 1,
      anon_sym_or,
    ACTIONS(2287), 3,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON,
  [52269] = 3,
    ACTIONS(1942), 1,
      sym_comment,
    ACTIONS(2289), 2,
      anon_sym_LBRACE2,
      sym__not_escape_sequence,
    ACTIONS(2291), 4,
      sym__string_content,
      sym__string_end,
      sym__escape_interpolation,
      sym_escape_sequence,
  [52283] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1879), 1,
      anon_sym_if,
    ACTIONS(1881), 1,
      anon_sym_and,
    ACTIONS(1883), 1,
      anon_sym_or,
    ACTIONS(1928), 1,
      anon_sym_COMMA,
    ACTIONS(2293), 1,
      anon_sym_COLON,
    STATE(964), 1,
      aux_sym_expression_list_repeat1,
  [52305] = 3,
    ACTIONS(1942), 1,
      sym_comment,
    ACTIONS(2295), 2,
      anon_sym_LBRACE2,
      sym__not_escape_sequence,
    ACTIONS(2297), 4,
      sym__string_content,
      sym__string_end,
      sym__escape_interpolation,
      sym_escape_sequence,
  [52319] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2301), 1,
      anon_sym_COMMA,
    STATE(1077), 1,
      aux_sym_open_sequence_match_pattern_repeat1,
    ACTIONS(2299), 4,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [52335] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2051), 1,
      anon_sym_and,
    ACTIONS(2053), 1,
      anon_sym_or,
    ACTIONS(2071), 1,
      anon_sym_if,
    ACTIONS(2304), 3,
      sym__newline,
      anon_sym_COMMA,
      sym__semicolon,
  [52353] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1879), 1,
      anon_sym_if,
    ACTIONS(1881), 1,
      anon_sym_and,
    ACTIONS(1883), 1,
      anon_sym_or,
    ACTIONS(1928), 1,
      anon_sym_COMMA,
    ACTIONS(2306), 1,
      anon_sym_COLON,
    STATE(964), 1,
      aux_sym_expression_list_repeat1,
  [52375] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1879), 1,
      anon_sym_if,
    ACTIONS(1881), 1,
      anon_sym_and,
    ACTIONS(1883), 1,
      anon_sym_or,
    ACTIONS(1928), 1,
      anon_sym_COMMA,
    ACTIONS(2308), 1,
      anon_sym_COLON,
    STATE(964), 1,
      aux_sym_expression_list_repeat1,
  [52397] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2165), 1,
      anon_sym_and,
    ACTIONS(2167), 1,
      anon_sym_or,
    ACTIONS(2173), 1,
      anon_sym_if,
    ACTIONS(2312), 1,
      anon_sym_COLON,
    ACTIONS(2310), 2,
      anon_sym_COMMA,
      anon_sym_as,
  [52417] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2051), 1,
      anon_sym_and,
    ACTIONS(2053), 1,
      anon_sym_or,
    ACTIONS(2071), 1,
      anon_sym_if,
    ACTIONS(2159), 3,
      sym__newline,
      anon_sym_EQ,
      sym__semicolon,
  [52435] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1879), 1,
      anon_sym_if,
    ACTIONS(1881), 1,
      anon_sym_and,
    ACTIONS(1883), 1,
      anon_sym_or,
    ACTIONS(2316), 1,
      anon_sym_COLON,
    ACTIONS(2314), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [52455] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1879), 1,
      anon_sym_if,
    ACTIONS(1881), 1,
      anon_sym_and,
    ACTIONS(1883), 1,
      anon_sym_or,
    ACTIONS(2318), 3,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON,
  [52473] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1879), 1,
      anon_sym_if,
    ACTIONS(1881), 1,
      anon_sym_and,
    ACTIONS(1883), 1,
      anon_sym_or,
    ACTIONS(1928), 1,
      anon_sym_COMMA,
    ACTIONS(2320), 1,
      anon_sym_COLON,
    STATE(964), 1,
      aux_sym_expression_list_repeat1,
  [52495] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1879), 1,
      anon_sym_if,
    ACTIONS(1881), 1,
      anon_sym_and,
    ACTIONS(1883), 1,
      anon_sym_or,
    ACTIONS(2155), 1,
      anon_sym_COLON,
    ACTIONS(2322), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [52515] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1920), 6,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
  [52527] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2275), 1,
      anon_sym_DOT,
    STATE(1068), 1,
      aux_sym_match_value_pattern_repeat1,
    ACTIONS(2252), 4,
      sym__newline,
      anon_sym_COMMA,
      anon_sym_as,
      sym__semicolon,
  [52543] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2324), 6,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
  [52555] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1879), 1,
      anon_sym_if,
    ACTIONS(1881), 1,
      anon_sym_and,
    ACTIONS(1883), 1,
      anon_sym_or,
    ACTIONS(2326), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [52572] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1879), 1,
      anon_sym_if,
    ACTIONS(1881), 1,
      anon_sym_and,
    ACTIONS(1883), 1,
      anon_sym_or,
    ACTIONS(2328), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [52589] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2330), 1,
      anon_sym_COMMA,
    STATE(1096), 1,
      aux_sym_expression_list_repeat1,
    ACTIONS(2029), 3,
      sym__newline,
      anon_sym_from,
      sym__semicolon,
  [52604] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2235), 1,
      sym_identifier,
    STATE(1183), 1,
      sym_dotted_name,
    STATE(1198), 1,
      sym_aliased_import,
    ACTIONS(2332), 2,
      sym__newline,
      sym__semicolon,
  [52621] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2051), 1,
      anon_sym_and,
    ACTIONS(2053), 1,
      anon_sym_or,
    ACTIONS(2071), 1,
      anon_sym_if,
    ACTIONS(1961), 2,
      sym__newline,
      sym__semicolon,
  [52638] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2235), 1,
      sym_identifier,
    STATE(1183), 1,
      sym_dotted_name,
    STATE(1198), 1,
      sym_aliased_import,
    ACTIONS(2332), 2,
      sym__newline,
      sym__semicolon,
  [52655] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2334), 1,
      anon_sym_COMMA,
    STATE(1096), 1,
      aux_sym_expression_list_repeat1,
    ACTIONS(2115), 3,
      sym__newline,
      anon_sym_from,
      sym__semicolon,
  [52670] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2337), 1,
      anon_sym_COLON,
    ACTIONS(2339), 1,
      anon_sym_RBRACE,
    ACTIONS(2341), 1,
      anon_sym_EQ,
    ACTIONS(2343), 1,
      sym_type_conversion,
    STATE(1425), 1,
      sym_format_specifier,
  [52689] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1879), 1,
      anon_sym_if,
    ACTIONS(1881), 1,
      anon_sym_and,
    ACTIONS(1883), 1,
      anon_sym_or,
    ACTIONS(2345), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [52706] = 6,
    ACTIONS(1942), 1,
      sym_comment,
    ACTIONS(2347), 1,
      anon_sym_RBRACE,
    ACTIONS(2349), 1,
      anon_sym_LBRACE2,
    ACTIONS(2351), 1,
      aux_sym_format_specifier_token1,
    STATE(1117), 1,
      aux_sym_format_specifier_repeat1,
    STATE(1269), 1,
      sym_interpolation,
  [52725] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1861), 1,
      anon_sym_COMMA,
    STATE(1115), 1,
      aux_sym__collection_elements_repeat1,
    ACTIONS(1871), 3,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
  [52740] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1856), 5,
      sym__newline,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      sym__semicolon,
  [52751] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1879), 1,
      anon_sym_if,
    ACTIONS(1881), 1,
      anon_sym_and,
    ACTIONS(1883), 1,
      anon_sym_or,
    ACTIONS(2191), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [52768] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1879), 1,
      anon_sym_if,
    ACTIONS(1881), 1,
      anon_sym_and,
    ACTIONS(1883), 1,
      anon_sym_or,
    ACTIONS(2353), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [52785] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2165), 1,
      anon_sym_and,
    ACTIONS(2167), 1,
      anon_sym_or,
    ACTIONS(2173), 1,
      anon_sym_if,
    ACTIONS(2355), 1,
      anon_sym_as,
    ACTIONS(2357), 1,
      anon_sym_COLON,
  [52804] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2051), 1,
      anon_sym_and,
    ACTIONS(2053), 1,
      anon_sym_or,
    ACTIONS(2071), 1,
      anon_sym_if,
    ACTIONS(2359), 2,
      sym__newline,
      sym__semicolon,
  [52821] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2299), 5,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [52832] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2361), 1,
      anon_sym_LPAREN,
    ACTIONS(2363), 1,
      anon_sym_COLON,
    ACTIONS(2365), 1,
      anon_sym_LBRACK,
    STATE(1224), 1,
      sym_type_parameters,
    STATE(1463), 1,
      sym_argument_list,
  [52851] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2361), 1,
      anon_sym_LPAREN,
    ACTIONS(2365), 1,
      anon_sym_LBRACK,
    ACTIONS(2367), 1,
      anon_sym_COLON,
    STATE(1210), 1,
      sym_type_parameters,
    STATE(1499), 1,
      sym_argument_list,
  [52870] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2369), 1,
      anon_sym_COMMA,
    ACTIONS(2371), 1,
      anon_sym_as,
    STATE(1164), 1,
      aux_sym__import_list_repeat1,
    ACTIONS(2373), 2,
      sym__newline,
      sym__semicolon,
  [52887] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2375), 5,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [52898] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2379), 1,
      anon_sym_COMMA,
    STATE(1114), 1,
      aux_sym__collection_elements_repeat1,
    ACTIONS(2377), 3,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
  [52913] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2381), 1,
      anon_sym_COMMA,
    STATE(1096), 1,
      aux_sym_expression_list_repeat1,
    ACTIONS(2029), 3,
      sym__newline,
      anon_sym_from,
      sym__semicolon,
  [52928] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2051), 1,
      anon_sym_and,
    ACTIONS(2053), 1,
      anon_sym_or,
    ACTIONS(2071), 1,
      anon_sym_if,
    ACTIONS(2383), 2,
      sym__newline,
      sym__semicolon,
  [52945] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2387), 1,
      anon_sym_COMMA,
    STATE(1114), 1,
      aux_sym__collection_elements_repeat1,
    ACTIONS(2385), 3,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
  [52960] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2390), 1,
      anon_sym_COMMA,
    STATE(1114), 1,
      aux_sym__collection_elements_repeat1,
    ACTIONS(2377), 3,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
  [52975] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2235), 1,
      sym_identifier,
    ACTIONS(2392), 1,
      anon_sym_LPAREN,
    STATE(1109), 1,
      sym_dotted_name,
    STATE(1143), 1,
      sym_aliased_import,
    STATE(1385), 1,
      sym__import_list,
  [52994] = 6,
    ACTIONS(1942), 1,
      sym_comment,
    ACTIONS(2394), 1,
      anon_sym_RBRACE,
    ACTIONS(2396), 1,
      anon_sym_LBRACE2,
    ACTIONS(2399), 1,
      aux_sym_format_specifier_token1,
    STATE(1117), 1,
      aux_sym_format_specifier_repeat1,
    STATE(1269), 1,
      sym_interpolation,
  [53013] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2235), 1,
      sym_identifier,
    STATE(1183), 1,
      sym_dotted_name,
    STATE(1198), 1,
      sym_aliased_import,
    ACTIONS(2402), 2,
      sym__newline,
      sym__semicolon,
  [53030] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1879), 1,
      anon_sym_if,
    ACTIONS(1881), 1,
      anon_sym_and,
    ACTIONS(1883), 1,
      anon_sym_or,
    ACTIONS(2404), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [53047] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2337), 1,
      anon_sym_COLON,
    ACTIONS(2406), 1,
      anon_sym_RBRACE,
    ACTIONS(2408), 1,
      anon_sym_EQ,
    ACTIONS(2410), 1,
      sym_type_conversion,
    STATE(1523), 1,
      sym_format_specifier,
  [53066] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2051), 1,
      anon_sym_and,
    ACTIONS(2053), 1,
      anon_sym_or,
    ACTIONS(2071), 1,
      anon_sym_if,
    ACTIONS(2412), 2,
      sym__newline,
      sym__semicolon,
  [53083] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2051), 1,
      anon_sym_and,
    ACTIONS(2053), 1,
      anon_sym_or,
    ACTIONS(2071), 1,
      anon_sym_if,
    ACTIONS(2414), 2,
      sym__newline,
      sym__semicolon,
  [53100] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2165), 1,
      anon_sym_and,
    ACTIONS(2167), 1,
      anon_sym_or,
    ACTIONS(2173), 1,
      anon_sym_if,
    ACTIONS(2416), 1,
      anon_sym_as,
    ACTIONS(2418), 1,
      anon_sym_COLON,
  [53119] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1879), 1,
      anon_sym_if,
    ACTIONS(1881), 1,
      anon_sym_and,
    ACTIONS(1883), 1,
      anon_sym_or,
    ACTIONS(2420), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [53136] = 6,
    ACTIONS(1942), 1,
      sym_comment,
    ACTIONS(2349), 1,
      anon_sym_LBRACE2,
    ACTIONS(2422), 1,
      anon_sym_RBRACE,
    ACTIONS(2424), 1,
      aux_sym_format_specifier_token1,
    STATE(1099), 1,
      aux_sym_format_specifier_repeat1,
    STATE(1269), 1,
      sym_interpolation,
  [53155] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1879), 1,
      anon_sym_if,
    ACTIONS(1881), 1,
      anon_sym_and,
    ACTIONS(1883), 1,
      anon_sym_or,
    ACTIONS(2426), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [53172] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1879), 1,
      anon_sym_if,
    ACTIONS(1881), 1,
      anon_sym_and,
    ACTIONS(1883), 1,
      anon_sym_or,
    ACTIONS(2428), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [53189] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2365), 1,
      anon_sym_LBRACK,
    ACTIONS(2430), 1,
      anon_sym_LPAREN,
    STATE(1370), 1,
      sym_type_parameters,
    STATE(1371), 1,
      sym_parameters,
  [53205] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2432), 1,
      anon_sym_case,
    STATE(562), 1,
      sym_cases,
    STATE(345), 2,
      sym_case_block,
      aux_sym_cases_repeat1,
  [53219] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2235), 1,
      sym_identifier,
    STATE(1109), 1,
      sym_dotted_name,
    STATE(1143), 1,
      sym_aliased_import,
    STATE(1383), 1,
      sym__import_list,
  [53235] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2365), 1,
      anon_sym_LBRACK,
    ACTIONS(2430), 1,
      anon_sym_LPAREN,
    STATE(1354), 1,
      sym_type_parameters,
    STATE(1377), 1,
      sym_parameters,
  [53251] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2365), 1,
      anon_sym_LBRACK,
    ACTIONS(2430), 1,
      anon_sym_LPAREN,
    STATE(1356), 1,
      sym_type_parameters,
    STATE(1378), 1,
      sym_parameters,
  [53267] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2436), 1,
      anon_sym_EQ,
    ACTIONS(2434), 3,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON,
  [53279] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1879), 1,
      anon_sym_if,
    ACTIONS(1881), 1,
      anon_sym_and,
    ACTIONS(1883), 1,
      anon_sym_or,
    ACTIONS(2438), 1,
      anon_sym_COLON,
  [53295] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1879), 1,
      anon_sym_if,
    ACTIONS(1881), 1,
      anon_sym_and,
    ACTIONS(1883), 1,
      anon_sym_or,
    ACTIONS(2440), 1,
      anon_sym_COLON,
  [53311] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1879), 1,
      anon_sym_if,
    ACTIONS(1881), 1,
      anon_sym_and,
    ACTIONS(1883), 1,
      anon_sym_or,
    ACTIONS(2442), 1,
      anon_sym_COLON,
  [53327] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2169), 1,
      anon_sym_COMMA,
    STATE(1160), 1,
      aux_sym_assert_statement_repeat1,
    ACTIONS(2444), 2,
      sym__newline,
      sym__semicolon,
  [53341] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2446), 1,
      anon_sym_COMMA,
    STATE(1138), 1,
      aux_sym_global_statement_repeat1,
    ACTIONS(2449), 2,
      sym__newline,
      sym__semicolon,
  [53355] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2453), 1,
      anon_sym_COLON,
    STATE(1343), 1,
      sym__type_bound,
    ACTIONS(2451), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [53369] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1879), 1,
      anon_sym_if,
    ACTIONS(1881), 1,
      anon_sym_and,
    ACTIONS(1883), 1,
      anon_sym_or,
    ACTIONS(2455), 1,
      anon_sym_COLON,
  [53385] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1879), 1,
      anon_sym_if,
    ACTIONS(1881), 1,
      anon_sym_and,
    ACTIONS(1883), 1,
      anon_sym_or,
    ACTIONS(2457), 1,
      anon_sym_COLON,
  [53401] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2332), 1,
      anon_sym_RPAREN,
    ACTIONS(2459), 1,
      sym_identifier,
    STATE(1245), 1,
      sym_dotted_name,
    STATE(1397), 1,
      sym_aliased_import,
  [53417] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2369), 1,
      anon_sym_COMMA,
    STATE(1163), 1,
      aux_sym__import_list_repeat1,
    ACTIONS(2373), 2,
      sym__newline,
      sym__semicolon,
  [53431] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2463), 1,
      anon_sym_DOT,
    STATE(1165), 1,
      aux_sym_import_prefix_repeat1,
    ACTIONS(2461), 2,
      anon_sym_import,
      sym_identifier,
  [53445] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1879), 1,
      anon_sym_if,
    ACTIONS(1881), 1,
      anon_sym_and,
    ACTIONS(1883), 1,
      anon_sym_or,
    ACTIONS(2465), 1,
      anon_sym_COLON,
  [53461] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2469), 1,
      anon_sym_COMMA,
    STATE(1167), 1,
      aux_sym__patterns_repeat1,
    ACTIONS(2467), 2,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
  [53475] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2332), 1,
      anon_sym_RPAREN,
    ACTIONS(2459), 1,
      sym_identifier,
    STATE(1245), 1,
      sym_dotted_name,
    STATE(1397), 1,
      sym_aliased_import,
  [53491] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1879), 1,
      anon_sym_if,
    ACTIONS(1881), 1,
      anon_sym_and,
    ACTIONS(1883), 1,
      anon_sym_or,
    ACTIONS(2471), 1,
      anon_sym_COLON,
  [53507] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1879), 1,
      anon_sym_if,
    ACTIONS(1881), 1,
      anon_sym_and,
    ACTIONS(1883), 1,
      anon_sym_or,
    ACTIONS(2473), 1,
      anon_sym_else,
  [53523] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2475), 1,
      anon_sym_COMMA,
    STATE(1171), 1,
      aux_sym_print_statement_repeat1,
    ACTIONS(2477), 2,
      sym__newline,
      sym__semicolon,
  [53537] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1879), 1,
      anon_sym_if,
    ACTIONS(1881), 1,
      anon_sym_and,
    ACTIONS(1883), 1,
      anon_sym_or,
    ACTIONS(2479), 1,
      anon_sym_COLON,
  [53553] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1879), 1,
      anon_sym_if,
    ACTIONS(1881), 1,
      anon_sym_and,
    ACTIONS(1883), 1,
      anon_sym_or,
    ACTIONS(2481), 1,
      anon_sym_else,
  [53569] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1879), 1,
      anon_sym_if,
    ACTIONS(1881), 1,
      anon_sym_and,
    ACTIONS(1883), 1,
      anon_sym_or,
    ACTIONS(2483), 1,
      anon_sym_COLON,
  [53585] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2485), 1,
      anon_sym_COMMA,
    STATE(1192), 1,
      aux_sym_global_statement_repeat1,
    ACTIONS(2487), 2,
      sym__newline,
      sym__semicolon,
  [53599] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2485), 1,
      anon_sym_COMMA,
    STATE(1191), 1,
      aux_sym_global_statement_repeat1,
    ACTIONS(2489), 2,
      sym__newline,
      sym__semicolon,
  [53613] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2051), 1,
      anon_sym_and,
    ACTIONS(2053), 1,
      anon_sym_or,
    ACTIONS(2071), 1,
      anon_sym_if,
    ACTIONS(2491), 1,
      sym__newline,
  [53629] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1879), 1,
      anon_sym_if,
    ACTIONS(1881), 1,
      anon_sym_and,
    ACTIONS(1883), 1,
      anon_sym_or,
    ACTIONS(2493), 1,
      anon_sym_COLON,
  [53645] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1879), 1,
      anon_sym_if,
    ACTIONS(1881), 1,
      anon_sym_and,
    ACTIONS(1883), 1,
      anon_sym_or,
    ACTIONS(2495), 1,
      anon_sym_COLON,
  [53661] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1879), 1,
      anon_sym_if,
    ACTIONS(1881), 1,
      anon_sym_and,
    ACTIONS(1883), 1,
      anon_sym_or,
    ACTIONS(2497), 1,
      anon_sym_COLON,
  [53677] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2499), 1,
      anon_sym_COMMA,
    STATE(1160), 1,
      aux_sym_assert_statement_repeat1,
    ACTIONS(2267), 2,
      sym__newline,
      sym__semicolon,
  [53691] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2373), 1,
      anon_sym_RPAREN,
    ACTIONS(2502), 1,
      anon_sym_COMMA,
    ACTIONS(2504), 1,
      anon_sym_as,
    STATE(1205), 1,
      aux_sym__import_list_repeat1,
  [53707] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2506), 1,
      anon_sym_COMMA,
    STATE(1162), 1,
      aux_sym_print_statement_repeat1,
    ACTIONS(2509), 2,
      sym__newline,
      sym__semicolon,
  [53721] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2511), 1,
      anon_sym_COMMA,
    STATE(1189), 1,
      aux_sym__import_list_repeat1,
    ACTIONS(2513), 2,
      sym__newline,
      sym__semicolon,
  [53735] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2515), 1,
      anon_sym_COMMA,
    STATE(1189), 1,
      aux_sym__import_list_repeat1,
    ACTIONS(2513), 2,
      sym__newline,
      sym__semicolon,
  [53749] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2519), 1,
      anon_sym_DOT,
    STATE(1165), 1,
      aux_sym_import_prefix_repeat1,
    ACTIONS(2517), 2,
      anon_sym_import,
      sym_identifier,
  [53763] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2223), 4,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
  [53773] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2524), 1,
      anon_sym_COMMA,
    STATE(872), 1,
      aux_sym__patterns_repeat1,
    ACTIONS(2522), 2,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
  [53787] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(315), 1,
      sym__string_start,
    ACTIONS(1899), 1,
      anon_sym_COLON,
    STATE(598), 2,
      sym_string,
      aux_sym_concatenated_string_repeat1,
  [53801] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1879), 1,
      anon_sym_if,
    ACTIONS(1881), 1,
      anon_sym_and,
    ACTIONS(1883), 1,
      anon_sym_or,
    ACTIONS(2526), 1,
      anon_sym_else,
  [53817] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2528), 4,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
  [53827] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2530), 1,
      anon_sym_COMMA,
    STATE(1162), 1,
      aux_sym_print_statement_repeat1,
    ACTIONS(2532), 2,
      sym__newline,
      sym__semicolon,
  [53841] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2534), 1,
      anon_sym_COMMA,
    STATE(1162), 1,
      aux_sym_print_statement_repeat1,
    ACTIONS(2536), 2,
      sym__newline,
      sym__semicolon,
  [53855] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2337), 1,
      anon_sym_COLON,
    ACTIONS(2538), 1,
      anon_sym_RBRACE,
    ACTIONS(2540), 1,
      sym_type_conversion,
    STATE(1479), 1,
      sym_format_specifier,
  [53871] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2169), 1,
      anon_sym_COMMA,
    STATE(1160), 1,
      aux_sym_assert_statement_repeat1,
    ACTIONS(2542), 2,
      sym__newline,
      sym__semicolon,
  [53885] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2544), 4,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
  [53895] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2365), 1,
      anon_sym_LBRACK,
    ACTIONS(2430), 1,
      anon_sym_LPAREN,
    STATE(1358), 1,
      sym_type_parameters,
    STATE(1363), 1,
      sym_parameters,
  [53911] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2548), 1,
      anon_sym_COLON,
    ACTIONS(2550), 1,
      anon_sym_EQ,
    ACTIONS(2546), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [53925] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2554), 1,
      anon_sym_COMMA,
    STATE(1178), 1,
      aux_sym_with_clause_repeat1,
    ACTIONS(2552), 2,
      anon_sym_RPAREN,
      anon_sym_COLON,
  [53939] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2557), 1,
      anon_sym_case,
    STATE(541), 1,
      sym_cases,
    STATE(380), 2,
      sym_case_block,
      aux_sym_cases_repeat1,
  [53953] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2557), 1,
      anon_sym_case,
    STATE(543), 1,
      sym_cases,
    STATE(380), 2,
      sym_case_block,
      aux_sym_cases_repeat1,
  [53967] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2337), 1,
      anon_sym_COLON,
    ACTIONS(2559), 1,
      anon_sym_RBRACE,
    ACTIONS(2561), 1,
      sym_type_conversion,
    STATE(1420), 1,
      sym_format_specifier,
  [53983] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2402), 1,
      anon_sym_RPAREN,
    ACTIONS(2459), 1,
      sym_identifier,
    STATE(1245), 1,
      sym_dotted_name,
    STATE(1397), 1,
      sym_aliased_import,
  [53999] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2371), 1,
      anon_sym_as,
    ACTIONS(2563), 3,
      sym__newline,
      anon_sym_COMMA,
      sym__semicolon,
  [54011] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2432), 1,
      anon_sym_case,
    STATE(560), 1,
      sym_cases,
    STATE(345), 2,
      sym_case_block,
      aux_sym_cases_repeat1,
  [54025] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2565), 4,
      anon_sym_async,
      anon_sym_def,
      anon_sym_class,
      anon_sym_AT,
  [54035] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1879), 1,
      anon_sym_if,
    ACTIONS(1881), 1,
      anon_sym_and,
    ACTIONS(1883), 1,
      anon_sym_or,
    ACTIONS(2567), 1,
      anon_sym_else,
  [54051] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1934), 4,
      sym__newline,
      anon_sym_from,
      anon_sym_COMMA,
      sym__semicolon,
  [54061] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2459), 1,
      sym_identifier,
    STATE(1161), 1,
      sym_dotted_name,
    STATE(1321), 1,
      sym_aliased_import,
    STATE(1415), 1,
      sym__import_list,
  [54077] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2569), 1,
      anon_sym_COMMA,
    STATE(1189), 1,
      aux_sym__import_list_repeat1,
    ACTIONS(2572), 2,
      sym__newline,
      sym__semicolon,
  [54091] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2574), 1,
      anon_sym_COMMA,
    STATE(1077), 1,
      aux_sym_open_sequence_match_pattern_repeat1,
    ACTIONS(1703), 2,
      anon_sym_if,
      anon_sym_COLON,
  [54105] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2485), 1,
      anon_sym_COMMA,
    STATE(1138), 1,
      aux_sym_global_statement_repeat1,
    ACTIONS(2576), 2,
      sym__newline,
      sym__semicolon,
  [54119] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2485), 1,
      anon_sym_COMMA,
    STATE(1138), 1,
      aux_sym_global_statement_repeat1,
    ACTIONS(2578), 2,
      sym__newline,
      sym__semicolon,
  [54133] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2459), 1,
      sym_identifier,
    STATE(1161), 1,
      sym_dotted_name,
    STATE(1321), 1,
      sym_aliased_import,
    STATE(1418), 1,
      sym__import_list,
  [54149] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(584), 1,
      sym__newline,
    ACTIONS(2580), 1,
      sym__semicolon,
    STATE(1200), 1,
      aux_sym__simple_statements_repeat1,
  [54162] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2582), 1,
      sym_identifier,
    ACTIONS(2584), 1,
      anon_sym_RPAREN,
    STATE(1341), 1,
      sym_match_keyword_pattern,
  [54175] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2586), 1,
      anon_sym_COMMA,
    ACTIONS(2588), 1,
      anon_sym_RBRACK,
    STATE(1299), 1,
      aux_sym_subscript_repeat1,
  [54188] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1820), 1,
      anon_sym_COMMA,
    ACTIONS(2590), 1,
      anon_sym_in,
    STATE(884), 1,
      aux_sym__patterns_repeat1,
  [54201] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2563), 3,
      sym__newline,
      anon_sym_COMMA,
      sym__semicolon,
  [54210] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1820), 1,
      anon_sym_COMMA,
    ACTIONS(2592), 1,
      anon_sym_in,
    STATE(884), 1,
      aux_sym__patterns_repeat1,
  [54223] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2594), 1,
      sym__semicolon,
    ACTIONS(2597), 1,
      sym__newline,
    STATE(1200), 1,
      aux_sym__simple_statements_repeat1,
  [54236] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2599), 3,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON,
  [54245] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2601), 1,
      anon_sym_COMMA,
    ACTIONS(2603), 1,
      anon_sym_RBRACK,
    STATE(1323), 1,
      aux_sym_open_sequence_match_pattern_repeat1,
  [54258] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2605), 1,
      anon_sym_COMMA,
    ACTIONS(2607), 1,
      anon_sym_RBRACK,
    STATE(1299), 1,
      aux_sym_subscript_repeat1,
  [54271] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1844), 1,
      anon_sym_COLON,
    ACTIONS(2609), 1,
      anon_sym_COMMA,
    STATE(1295), 1,
      aux_sym__parameters_repeat1,
  [54284] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2513), 1,
      anon_sym_RPAREN,
    ACTIONS(2611), 1,
      anon_sym_COMMA,
    STATE(1240), 1,
      aux_sym__import_list_repeat1,
  [54297] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2513), 1,
      anon_sym_RPAREN,
    ACTIONS(2613), 1,
      anon_sym_COMMA,
    STATE(1240), 1,
      aux_sym__import_list_repeat1,
  [54310] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1153), 3,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON,
  [54319] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2615), 1,
      anon_sym_COMMA,
    ACTIONS(2617), 1,
      anon_sym_RBRACK,
    STATE(1252), 1,
      aux_sym_type_parameters_repeat1,
  [54332] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2619), 1,
      sym__semicolon,
    ACTIONS(2621), 1,
      sym__newline,
    STATE(1194), 1,
      aux_sym__simple_statements_repeat1,
  [54345] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2361), 1,
      anon_sym_LPAREN,
    ACTIONS(2623), 1,
      anon_sym_COLON,
    STATE(1476), 1,
      sym_argument_list,
  [54358] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2625), 1,
      anon_sym_COMMA,
    ACTIONS(2628), 1,
      anon_sym_RBRACE,
    STATE(1211), 1,
      aux_sym_match_mapping_pattern_repeat1,
  [54371] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2630), 1,
      anon_sym_RPAREN,
    ACTIONS(2632), 1,
      anon_sym_COMMA,
    STATE(1213), 1,
      aux_sym_match_class_pattern_repeat1,
  [54384] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1719), 1,
      anon_sym_RPAREN,
    ACTIONS(2634), 1,
      anon_sym_COMMA,
    STATE(1296), 1,
      aux_sym_match_class_pattern_repeat1,
  [54397] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2636), 1,
      sym__semicolon,
    ACTIONS(2638), 1,
      sym__newline,
    STATE(1231), 1,
      aux_sym__simple_statements_repeat1,
  [54410] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1719), 1,
      anon_sym_RPAREN,
    ACTIONS(2582), 1,
      sym_identifier,
    STATE(1341), 1,
      sym_match_keyword_pattern,
  [54423] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1719), 1,
      anon_sym_RPAREN,
    ACTIONS(2640), 1,
      anon_sym_COMMA,
    STATE(1316), 1,
      aux_sym_match_class_pattern_repeat2,
  [54436] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(972), 1,
      anon_sym_except,
    ACTIONS(970), 2,
      anon_sym_except_STAR,
      anon_sym_finally,
  [54447] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2642), 1,
      anon_sym_COMMA,
    ACTIONS(2644), 1,
      anon_sym_RBRACE,
    STATE(1257), 1,
      aux_sym_match_mapping_pattern_repeat1,
  [54460] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1861), 1,
      anon_sym_COMMA,
    ACTIONS(1930), 1,
      anon_sym_RPAREN,
    STATE(1292), 1,
      aux_sym__collection_elements_repeat1,
  [54473] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2153), 1,
      anon_sym_COMMA,
    ACTIONS(2157), 1,
      anon_sym_RBRACK,
    STATE(1196), 1,
      aux_sym_subscript_repeat1,
  [54486] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2646), 1,
      anon_sym_if,
    ACTIONS(2648), 1,
      anon_sym_COLON,
    STATE(1481), 1,
      sym_guard,
  [54499] = 3,
    ACTIONS(1942), 1,
      sym_comment,
    ACTIONS(2289), 1,
      anon_sym_RBRACE,
    ACTIONS(2291), 2,
      anon_sym_LBRACE2,
      aux_sym_format_specifier_token1,
  [54510] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2449), 3,
      sym__newline,
      anon_sym_COMMA,
      sym__semicolon,
  [54519] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2361), 1,
      anon_sym_LPAREN,
    ACTIONS(2650), 1,
      anon_sym_COLON,
    STATE(1470), 1,
      sym_argument_list,
  [54532] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2187), 1,
      anon_sym_COMMA,
    ACTIONS(2189), 1,
      anon_sym_RBRACE,
    STATE(1243), 1,
      aux_sym_dictionary_repeat1,
  [54545] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2652), 3,
      sym__newline,
      anon_sym_COMMA,
      sym__semicolon,
  [54554] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2615), 1,
      anon_sym_COMMA,
    ACTIONS(2654), 1,
      anon_sym_RBRACK,
    STATE(1208), 1,
      aux_sym_type_parameters_repeat1,
  [54567] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2656), 1,
      anon_sym_RPAREN,
    ACTIONS(2658), 1,
      anon_sym_COMMA,
    STATE(1232), 1,
      aux_sym_argument_list_repeat1,
  [54580] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2660), 1,
      anon_sym_RPAREN,
    ACTIONS(2662), 1,
      anon_sym_COMMA,
    STATE(1249), 1,
      aux_sym__parameters_repeat1,
  [54593] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2664), 1,
      anon_sym_RPAREN,
    ACTIONS(2666), 1,
      anon_sym_COMMA,
    STATE(1232), 1,
      aux_sym_argument_list_repeat1,
  [54606] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(586), 1,
      sym__newline,
    ACTIONS(2668), 1,
      sym__semicolon,
    STATE(1200), 1,
      aux_sym__simple_statements_repeat1,
  [54619] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2670), 1,
      anon_sym_RPAREN,
    ACTIONS(2672), 1,
      anon_sym_COMMA,
    STATE(1232), 1,
      aux_sym_argument_list_repeat1,
  [54632] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1016), 1,
      anon_sym_except,
    ACTIONS(1018), 2,
      anon_sym_except_STAR,
      anon_sym_finally,
  [54643] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2675), 1,
      anon_sym_COMMA,
    ACTIONS(2677), 1,
      anon_sym_RBRACE,
    STATE(1235), 1,
      aux_sym_dictionary_repeat1,
  [54656] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2679), 1,
      anon_sym_COMMA,
    ACTIONS(2682), 1,
      anon_sym_RBRACE,
    STATE(1235), 1,
      aux_sym_dictionary_repeat1,
  [54669] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2137), 1,
      sym_identifier,
    ACTIONS(2684), 1,
      anon_sym_import,
    STATE(1408), 1,
      sym_dotted_name,
  [54682] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(598), 1,
      sym__newline,
    ACTIONS(2686), 1,
      sym__semicolon,
    STATE(1200), 1,
      aux_sym__simple_statements_repeat1,
  [54695] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2688), 1,
      sym__semicolon,
    ACTIONS(2690), 1,
      sym__newline,
    STATE(1237), 1,
      aux_sym__simple_statements_repeat1,
  [54708] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1963), 1,
      anon_sym_RPAREN,
    ACTIONS(1965), 1,
      anon_sym_COMMA,
    STATE(1264), 1,
      aux_sym_argument_list_repeat1,
  [54721] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2572), 1,
      anon_sym_RPAREN,
    ACTIONS(2692), 1,
      anon_sym_COMMA,
    STATE(1240), 1,
      aux_sym__import_list_repeat1,
  [54734] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(576), 1,
      sym__newline,
    ACTIONS(2695), 1,
      sym__semicolon,
    STATE(1200), 1,
      aux_sym__simple_statements_repeat1,
  [54747] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2697), 1,
      anon_sym_COMMA,
    ACTIONS(2699), 1,
      anon_sym_RBRACE,
    STATE(1235), 1,
      aux_sym_dictionary_repeat1,
  [54760] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2701), 1,
      anon_sym_COMMA,
    ACTIONS(2703), 1,
      anon_sym_RBRACE,
    STATE(1235), 1,
      aux_sym_dictionary_repeat1,
  [54773] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2705), 1,
      sym__semicolon,
    ACTIONS(2707), 1,
      sym__newline,
    STATE(1241), 1,
      aux_sym__simple_statements_repeat1,
  [54786] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2504), 1,
      anon_sym_as,
    ACTIONS(2563), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [54797] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(582), 1,
      sym__newline,
    ACTIONS(2709), 1,
      sym__semicolon,
    STATE(1200), 1,
      aux_sym__simple_statements_repeat1,
  [54810] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2711), 1,
      anon_sym_COMMA,
    ACTIONS(2713), 1,
      anon_sym_RBRACE,
    STATE(1235), 1,
      aux_sym_dictionary_repeat1,
  [54823] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2715), 1,
      sym__semicolon,
    ACTIONS(2717), 1,
      sym__newline,
    STATE(1246), 1,
      aux_sym__simple_statements_repeat1,
  [54836] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1844), 1,
      anon_sym_RPAREN,
    ACTIONS(2719), 1,
      anon_sym_COMMA,
    STATE(1275), 1,
      aux_sym__parameters_repeat1,
  [54849] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2721), 3,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_EQ,
  [54858] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1861), 1,
      anon_sym_COMMA,
    ACTIONS(1932), 1,
      anon_sym_RPAREN,
    STATE(1292), 1,
      aux_sym__collection_elements_repeat1,
  [54871] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2723), 1,
      anon_sym_COMMA,
    ACTIONS(2726), 1,
      anon_sym_RBRACK,
    STATE(1252), 1,
      aux_sym_type_parameters_repeat1,
  [54884] = 3,
    ACTIONS(1942), 1,
      sym_comment,
    ACTIONS(2248), 1,
      anon_sym_RBRACE,
    ACTIONS(2250), 2,
      anon_sym_LBRACE2,
      aux_sym_format_specifier_token1,
  [54895] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(574), 1,
      sym__newline,
    ACTIONS(2728), 1,
      sym__semicolon,
    STATE(1200), 1,
      aux_sym__simple_statements_repeat1,
  [54908] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1993), 1,
      anon_sym_RPAREN,
    ACTIONS(1995), 1,
      anon_sym_COMMA,
    STATE(1277), 1,
      aux_sym_argument_list_repeat1,
  [54921] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2730), 1,
      anon_sym_RPAREN,
    ACTIONS(2732), 1,
      anon_sym_COMMA,
    STATE(1279), 1,
      aux_sym_argument_list_repeat1,
  [54934] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1832), 1,
      anon_sym_RBRACE,
    ACTIONS(2734), 1,
      anon_sym_COMMA,
    STATE(1211), 1,
      aux_sym_match_mapping_pattern_repeat1,
  [54947] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2193), 1,
      anon_sym_COMMA,
    ACTIONS(2195), 1,
      anon_sym_RBRACK,
    STATE(1283), 1,
      aux_sym_subscript_repeat1,
  [54960] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2736), 1,
      sym_identifier,
    ACTIONS(2738), 1,
      sym_match_wildcard_pattern,
    STATE(1110), 1,
      sym_match_capture_pattern,
  [54973] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2337), 1,
      anon_sym_COLON,
    ACTIONS(2559), 1,
      anon_sym_RBRACE,
    STATE(1420), 1,
      sym_format_specifier,
  [54986] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2740), 1,
      sym__semicolon,
    ACTIONS(2742), 1,
      sym__newline,
    STATE(1254), 1,
      aux_sym__simple_statements_repeat1,
  [54999] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1889), 1,
      anon_sym_DOT,
    ACTIONS(1893), 1,
      anon_sym_COLON,
    STATE(906), 1,
      aux_sym_match_value_pattern_repeat1,
  [55012] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2744), 1,
      anon_sym_EQ,
    ACTIONS(2746), 2,
      sym__newline,
      sym__semicolon,
  [55023] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2748), 1,
      anon_sym_RPAREN,
    ACTIONS(2750), 1,
      anon_sym_COMMA,
    STATE(1232), 1,
      aux_sym_argument_list_repeat1,
  [55036] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(968), 1,
      anon_sym_except,
    ACTIONS(966), 2,
      anon_sym_except_STAR,
      anon_sym_finally,
  [55047] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2752), 1,
      anon_sym_COMMA,
    ACTIONS(2754), 1,
      anon_sym_COLON,
    STATE(1178), 1,
      aux_sym_with_clause_repeat1,
  [55060] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2756), 1,
      anon_sym_COLON,
    ACTIONS(2546), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [55071] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2758), 1,
      anon_sym_RPAREN,
    ACTIONS(2760), 1,
      anon_sym_COMMA,
    STATE(1310), 1,
      aux_sym_with_clause_repeat1,
  [55084] = 3,
    ACTIONS(1942), 1,
      sym_comment,
    ACTIONS(2762), 1,
      anon_sym_RBRACE,
    ACTIONS(2764), 2,
      anon_sym_LBRACE2,
      aux_sym_format_specifier_token1,
  [55095] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2434), 3,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON,
  [55104] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2766), 1,
      anon_sym_COMMA,
    ACTIONS(2768), 1,
      anon_sym_RBRACK,
    STATE(1299), 1,
      aux_sym_subscript_repeat1,
  [55117] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2770), 1,
      anon_sym_COMMA,
    ACTIONS(2772), 1,
      anon_sym_RBRACK,
    STATE(1299), 1,
      aux_sym_subscript_repeat1,
  [55130] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2774), 1,
      anon_sym_RPAREN,
    ACTIONS(2776), 1,
      anon_sym_COMMA,
    STATE(1232), 1,
      aux_sym_argument_list_repeat1,
  [55143] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2778), 1,
      anon_sym_RPAREN,
    ACTIONS(2780), 1,
      anon_sym_COMMA,
    STATE(1232), 1,
      aux_sym_argument_list_repeat1,
  [55156] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2599), 1,
      anon_sym_RPAREN,
    ACTIONS(2782), 1,
      anon_sym_COMMA,
    STATE(1275), 1,
      aux_sym__parameters_repeat1,
  [55169] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1820), 1,
      anon_sym_COMMA,
    ACTIONS(2785), 1,
      anon_sym_in,
    STATE(884), 1,
      aux_sym__patterns_repeat1,
  [55182] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2787), 1,
      anon_sym_RPAREN,
    ACTIONS(2789), 1,
      anon_sym_COMMA,
    STATE(1232), 1,
      aux_sym_argument_list_repeat1,
  [55195] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2337), 1,
      anon_sym_COLON,
    ACTIONS(2538), 1,
      anon_sym_RBRACE,
    STATE(1479), 1,
      sym_format_specifier,
  [55208] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2791), 1,
      anon_sym_RPAREN,
    ACTIONS(2793), 1,
      anon_sym_COMMA,
    STATE(1232), 1,
      aux_sym_argument_list_repeat1,
  [55221] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2795), 1,
      anon_sym_RPAREN,
    ACTIONS(2797), 1,
      anon_sym_COMMA,
    STATE(1232), 1,
      aux_sym_argument_list_repeat1,
  [55234] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2799), 3,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON,
  [55243] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2801), 1,
      anon_sym_COMMA,
    ACTIONS(2803), 1,
      anon_sym_RBRACK,
    STATE(1299), 1,
      aux_sym_subscript_repeat1,
  [55256] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2805), 1,
      anon_sym_COMMA,
    ACTIONS(2807), 1,
      anon_sym_RBRACK,
    STATE(1299), 1,
      aux_sym_subscript_repeat1,
  [55269] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2337), 1,
      anon_sym_COLON,
    ACTIONS(2809), 1,
      anon_sym_RBRACE,
    STATE(1409), 1,
      sym_format_specifier,
  [55282] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2811), 1,
      anon_sym_RPAREN,
    ACTIONS(2813), 1,
      anon_sym_COMMA,
    STATE(1232), 1,
      aux_sym_argument_list_repeat1,
  [55295] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2646), 1,
      anon_sym_if,
    ACTIONS(2815), 1,
      anon_sym_COLON,
    STATE(1501), 1,
      sym_guard,
  [55308] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2817), 1,
      anon_sym_COMMA,
    ACTIONS(2819), 2,
      anon_sym_if,
      anon_sym_COLON,
  [55319] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2067), 1,
      anon_sym_from,
    ACTIONS(2073), 2,
      sym__newline,
      sym__semicolon,
  [55330] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2377), 1,
      anon_sym_RPAREN,
    ACTIONS(2821), 1,
      anon_sym_COMMA,
    STATE(1114), 1,
      aux_sym__collection_elements_repeat1,
  [55343] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1721), 1,
      anon_sym_RPAREN,
    ACTIONS(2823), 1,
      anon_sym_COMMA,
    STATE(1325), 1,
      aux_sym_match_class_pattern_repeat2,
  [55356] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1399), 3,
      sym__newline,
      anon_sym_in,
      sym__semicolon,
  [55365] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2377), 1,
      anon_sym_RPAREN,
    ACTIONS(2825), 1,
      anon_sym_COMMA,
    STATE(1114), 1,
      aux_sym__collection_elements_repeat1,
  [55378] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1820), 1,
      anon_sym_COMMA,
    ACTIONS(2827), 1,
      anon_sym_in,
    STATE(884), 1,
      aux_sym__patterns_repeat1,
  [55391] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2207), 1,
      anon_sym_COMMA,
    ACTIONS(2209), 1,
      anon_sym_RBRACK,
    STATE(1271), 1,
      aux_sym_subscript_repeat1,
  [55404] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2599), 1,
      anon_sym_COLON,
    ACTIONS(2829), 1,
      anon_sym_COMMA,
    STATE(1295), 1,
      aux_sym__parameters_repeat1,
  [55417] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2832), 1,
      anon_sym_RPAREN,
    ACTIONS(2834), 1,
      anon_sym_COMMA,
    STATE(1296), 1,
      aux_sym_match_class_pattern_repeat1,
  [55430] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2837), 1,
      anon_sym_RPAREN,
    ACTIONS(2839), 1,
      anon_sym_COMMA,
    STATE(1274), 1,
      aux_sym_argument_list_repeat1,
  [55443] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1975), 1,
      anon_sym_RPAREN,
    ACTIONS(1977), 1,
      anon_sym_COMMA,
    STATE(1285), 1,
      aux_sym_argument_list_repeat1,
  [55456] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2841), 1,
      anon_sym_COMMA,
    ACTIONS(2844), 1,
      anon_sym_RBRACK,
    STATE(1299), 1,
      aux_sym_subscript_repeat1,
  [55469] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2846), 1,
      anon_sym_COMMA,
    ACTIONS(2848), 1,
      anon_sym_RBRACE,
    STATE(1235), 1,
      aux_sym_dictionary_repeat1,
  [55482] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1861), 1,
      anon_sym_COMMA,
    ACTIONS(2850), 1,
      anon_sym_RPAREN,
    STATE(1289), 1,
      aux_sym__collection_elements_repeat1,
  [55495] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2852), 1,
      anon_sym_COMMA,
    ACTIONS(2854), 1,
      anon_sym_RBRACE,
    STATE(1235), 1,
      aux_sym_dictionary_repeat1,
  [55508] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1861), 1,
      anon_sym_COMMA,
    ACTIONS(2856), 1,
      anon_sym_RPAREN,
    STATE(1115), 1,
      aux_sym__collection_elements_repeat1,
  [55521] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(987), 1,
      anon_sym_except,
    ACTIONS(985), 2,
      anon_sym_except_STAR,
      anon_sym_finally,
  [55532] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1820), 1,
      anon_sym_COMMA,
    ACTIONS(2858), 1,
      anon_sym_in,
    STATE(884), 1,
      aux_sym__patterns_repeat1,
  [55545] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1820), 1,
      anon_sym_COMMA,
    ACTIONS(2860), 1,
      anon_sym_in,
    STATE(884), 1,
      aux_sym__patterns_repeat1,
  [55558] = 3,
    ACTIONS(1942), 1,
      sym_comment,
    ACTIONS(2277), 1,
      anon_sym_RBRACE,
    ACTIONS(2279), 2,
      anon_sym_LBRACE2,
      aux_sym_format_specifier_token1,
  [55569] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2552), 3,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON,
  [55578] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(588), 1,
      sym__newline,
    ACTIONS(2862), 1,
      sym__semicolon,
    STATE(1200), 1,
      aux_sym__simple_statements_repeat1,
  [55591] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(995), 1,
      anon_sym_RPAREN,
    ACTIONS(2864), 1,
      anon_sym_COMMA,
    STATE(1178), 1,
      aux_sym_with_clause_repeat1,
  [55604] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2211), 1,
      anon_sym_COMMA,
    ACTIONS(2213), 1,
      anon_sym_RBRACE,
    STATE(1302), 1,
      aux_sym_dictionary_repeat1,
  [55617] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2235), 1,
      sym_identifier,
    STATE(1183), 1,
      sym_dotted_name,
    STATE(1198), 1,
      sym_aliased_import,
  [55630] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1861), 1,
      anon_sym_COMMA,
    ACTIONS(1905), 1,
      anon_sym_RPAREN,
    STATE(1292), 1,
      aux_sym__collection_elements_repeat1,
  [55643] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1721), 1,
      anon_sym_RPAREN,
    ACTIONS(2582), 1,
      sym_identifier,
    STATE(1341), 1,
      sym_match_keyword_pattern,
  [55656] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2337), 1,
      anon_sym_COLON,
    ACTIONS(2866), 1,
      anon_sym_RBRACE,
    STATE(1515), 1,
      sym_format_specifier,
  [55669] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2868), 1,
      anon_sym_RPAREN,
    ACTIONS(2870), 1,
      anon_sym_COMMA,
    STATE(1316), 1,
      aux_sym_match_class_pattern_repeat2,
  [55682] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2459), 1,
      sym_identifier,
    STATE(1245), 1,
      sym_dotted_name,
    STATE(1397), 1,
      sym_aliased_import,
  [55695] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1403), 3,
      sym__newline,
      anon_sym_in,
      sym__semicolon,
  [55704] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2873), 1,
      sym__semicolon,
    ACTIONS(2875), 1,
      sym__newline,
    STATE(1309), 1,
      aux_sym__simple_statements_repeat1,
  [55717] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2752), 1,
      anon_sym_COMMA,
    ACTIONS(2877), 1,
      anon_sym_COLON,
    STATE(1266), 1,
      aux_sym_with_clause_repeat1,
  [55730] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2373), 1,
      anon_sym_RPAREN,
    ACTIONS(2502), 1,
      anon_sym_COMMA,
    STATE(1206), 1,
      aux_sym__import_list_repeat1,
  [55743] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2879), 3,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_EQ,
  [55752] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1711), 1,
      anon_sym_RBRACK,
    ACTIONS(2881), 1,
      anon_sym_COMMA,
    STATE(1077), 1,
      aux_sym_open_sequence_match_pattern_repeat1,
  [55765] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(989), 1,
      anon_sym_except,
    ACTIONS(991), 2,
      anon_sym_except_STAR,
      anon_sym_finally,
  [55776] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2584), 1,
      anon_sym_RPAREN,
    ACTIONS(2883), 1,
      anon_sym_COMMA,
    STATE(1316), 1,
      aux_sym_match_class_pattern_repeat2,
  [55789] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2584), 1,
      anon_sym_RPAREN,
    ACTIONS(2883), 1,
      anon_sym_COMMA,
    STATE(1331), 1,
      aux_sym_match_class_pattern_repeat2,
  [55802] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2219), 1,
      anon_sym_COMMA,
    ACTIONS(2221), 1,
      anon_sym_RBRACE,
    STATE(1242), 1,
      aux_sym_dictionary_repeat1,
  [55815] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2885), 1,
      anon_sym_RPAREN,
    ACTIONS(2887), 1,
      anon_sym_COMMA,
    STATE(1230), 1,
      aux_sym_argument_list_repeat1,
  [55828] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2582), 1,
      sym_identifier,
    ACTIONS(2889), 1,
      anon_sym_RPAREN,
    STATE(1341), 1,
      sym_match_keyword_pattern,
  [55841] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2630), 1,
      anon_sym_RPAREN,
    ACTIONS(2891), 1,
      anon_sym_COMMA,
    STATE(1216), 1,
      aux_sym_match_class_pattern_repeat2,
  [55854] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2889), 1,
      anon_sym_RPAREN,
    ACTIONS(2893), 1,
      anon_sym_COMMA,
    STATE(1316), 1,
      aux_sym_match_class_pattern_repeat2,
  [55867] = 3,
    ACTIONS(1942), 1,
      sym_comment,
    ACTIONS(2271), 1,
      anon_sym_RBRACE,
    ACTIONS(2273), 2,
      anon_sym_LBRACE2,
      aux_sym_format_specifier_token1,
  [55878] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2546), 3,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON,
  [55887] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2660), 1,
      anon_sym_COLON,
    ACTIONS(2895), 1,
      anon_sym_COMMA,
    STATE(1204), 1,
      aux_sym__parameters_repeat1,
  [55900] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2897), 1,
      anon_sym_in,
    ACTIONS(2899), 2,
      sym__newline,
      sym__semicolon,
  [55911] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2365), 1,
      anon_sym_LBRACK,
    ACTIONS(2901), 1,
      anon_sym_EQ,
    STATE(1492), 1,
      sym_type_parameters,
  [55924] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1711), 1,
      anon_sym_RPAREN,
    ACTIONS(2903), 1,
      anon_sym_COMMA,
    STATE(1077), 1,
      aux_sym_open_sequence_match_pattern_repeat1,
  [55937] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2582), 1,
      sym_identifier,
    ACTIONS(2905), 1,
      anon_sym_RPAREN,
    STATE(1341), 1,
      sym_match_keyword_pattern,
  [55950] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2550), 1,
      anon_sym_EQ,
    ACTIONS(2546), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
  [55961] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2907), 3,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON,
  [55970] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2868), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [55978] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2909), 2,
      sym__newline,
      sym__semicolon,
  [55986] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2911), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [55994] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2913), 1,
      anon_sym_COLON,
    ACTIONS(2915), 1,
      anon_sym_DASH_GT,
  [56004] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2917), 2,
      sym__newline,
      sym__semicolon,
  [56012] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2919), 2,
      sym__newline,
      sym__semicolon,
  [56020] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2546), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
  [56028] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1926), 2,
      sym__newline,
      sym__semicolon,
  [56036] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2921), 2,
      sym__newline,
      sym__semicolon,
  [56044] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2923), 2,
      sym__newline,
      sym__semicolon,
  [56052] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2597), 2,
      sym__newline,
      sym__semicolon,
  [56060] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2925), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [56068] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2582), 1,
      sym_identifier,
    STATE(1341), 1,
      sym_match_keyword_pattern,
  [56078] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2430), 1,
      anon_sym_LPAREN,
    STATE(1372), 1,
      sym_parameters,
  [56088] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2927), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [56096] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2430), 1,
      anon_sym_LPAREN,
    STATE(1375), 1,
      sym_parameters,
  [56106] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2929), 1,
      sym_identifier,
    STATE(1367), 1,
      sym_match_capture_pattern,
  [56116] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2430), 1,
      anon_sym_LPAREN,
    STATE(1344), 1,
      sym_parameters,
  [56126] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1842), 1,
      anon_sym_RBRACE,
    ACTIONS(2931), 1,
      anon_sym_COMMA,
  [56136] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2069), 1,
      anon_sym_COMMA,
    STATE(1112), 1,
      aux_sym_expression_list_repeat1,
  [56146] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2145), 2,
      sym__newline,
      sym__semicolon,
  [56154] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2628), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [56162] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2933), 1,
      anon_sym_COLON,
    ACTIONS(2935), 1,
      anon_sym_DASH_GT,
  [56172] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2937), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [56180] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1889), 1,
      anon_sym_DOT,
    STATE(1262), 1,
      aux_sym_match_value_pattern_repeat1,
  [56190] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1928), 1,
      anon_sym_COMMA,
    STATE(985), 1,
      aux_sym_expression_list_repeat1,
  [56200] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2939), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [56208] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2644), 1,
      anon_sym_RBRACE,
    ACTIONS(2941), 1,
      anon_sym_COMMA,
  [56218] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2943), 2,
      sym__newline,
      sym__semicolon,
  [56226] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2430), 1,
      anon_sym_LPAREN,
    STATE(1376), 1,
      sym_parameters,
  [56236] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2945), 1,
      anon_sym_COLON,
    ACTIONS(2947), 1,
      anon_sym_DASH_GT,
  [56246] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2949), 1,
      anon_sym_COLON,
    ACTIONS(2951), 1,
      anon_sym_DASH_GT,
  [56256] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2420), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [56264] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2953), 2,
      anon_sym_COLON,
      anon_sym_DASH_GT,
  [56272] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2955), 1,
      anon_sym_COLON,
    ACTIONS(2957), 1,
      anon_sym_DASH_GT,
  [56282] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2959), 1,
      anon_sym_COLON,
    ACTIONS(2961), 1,
      anon_sym_DASH_GT,
  [56292] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2963), 1,
      anon_sym_COLON,
    ACTIONS(2965), 1,
      anon_sym_DASH_GT,
  [56302] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2967), 1,
      anon_sym_COLON,
    ACTIONS(2969), 1,
      anon_sym_DASH_GT,
  [56312] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2971), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [56320] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2973), 2,
      anon_sym_COLON,
      anon_sym_DASH_GT,
  [56328] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2975), 1,
      sym_integer,
    ACTIONS(2977), 1,
      sym_float,
  [56338] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2652), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [56346] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2979), 2,
      sym__newline,
      sym__semicolon,
  [56354] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2981), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [56362] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2983), 2,
      sym__newline,
      sym__semicolon,
  [56370] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2985), 2,
      sym__newline,
      sym__semicolon,
  [56378] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2987), 1,
      sym_integer,
    ACTIONS(2989), 1,
      sym_float,
  [56388] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2991), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [56396] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2205), 2,
      sym__newline,
      sym__semicolon,
  [56404] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2993), 1,
      sym_integer,
    ACTIONS(2995), 1,
      sym_float,
  [56414] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2997), 2,
      sym__newline,
      sym__semicolon,
  [56422] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2817), 1,
      anon_sym_COMMA,
    ACTIONS(2999), 1,
      anon_sym_RPAREN,
  [56432] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3001), 2,
      sym__newline,
      sym__semicolon,
  [56440] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2203), 2,
      sym__newline,
      sym__semicolon,
  [56448] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3003), 2,
      sym__newline,
      sym__semicolon,
  [56456] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3005), 1,
      anon_sym_COMMA,
    STATE(1337), 1,
      aux_sym_open_sequence_match_pattern_repeat1,
  [56466] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2563), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [56474] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2322), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [56482] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3007), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [56490] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3009), 2,
      sym__newline,
      sym__semicolon,
  [56498] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3011), 1,
      anon_sym_COMMA,
    ACTIONS(3013), 1,
      anon_sym_RBRACE,
  [56508] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3015), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [56516] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2832), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [56524] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3017), 1,
      anon_sym_COMMA,
    STATE(1190), 1,
      aux_sym_open_sequence_match_pattern_repeat1,
  [56534] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3019), 1,
      anon_sym_RBRACE,
  [56541] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3021), 1,
      anon_sym_LPAREN,
  [56548] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3023), 1,
      anon_sym_RBRACK,
  [56555] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3025), 1,
      anon_sym_import,
  [56562] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3027), 1,
      anon_sym_RBRACE,
  [56569] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3029), 1,
      anon_sym_RBRACE,
  [56576] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3031), 1,
      anon_sym_RBRACE,
  [56583] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2105), 1,
      anon_sym_EQ,
  [56590] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3033), 1,
      anon_sym_COLON,
  [56597] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3035), 1,
      anon_sym_RPAREN,
  [56604] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3037), 1,
      anon_sym_RPAREN,
  [56611] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3039), 1,
      anon_sym_for,
  [56618] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3041), 1,
      anon_sym_RPAREN,
  [56625] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3043), 1,
      anon_sym_RPAREN,
  [56632] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2827), 1,
      anon_sym_in,
  [56639] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2809), 1,
      anon_sym_RBRACE,
  [56646] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2785), 1,
      anon_sym_in,
  [56653] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3045), 1,
      anon_sym_COLON,
  [56660] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3047), 1,
      anon_sym_COLON,
  [56667] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3013), 1,
      anon_sym_RBRACE,
  [56674] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2559), 1,
      anon_sym_RBRACE,
  [56681] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1832), 1,
      anon_sym_RBRACE,
  [56688] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3049), 1,
      anon_sym_COLON,
  [56695] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3051), 1,
      anon_sym_COLON,
  [56702] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3053), 1,
      anon_sym_RBRACK,
  [56709] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3055), 1,
      anon_sym_in,
  [56716] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3057), 1,
      anon_sym_RPAREN,
  [56723] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3059), 1,
      anon_sym_RPAREN,
  [56730] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3061), 1,
      anon_sym_RBRACE,
  [56737] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3063), 1,
      anon_sym_RPAREN,
  [56744] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3065), 1,
      anon_sym_COLON,
  [56751] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3067), 1,
      anon_sym_in,
  [56758] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3069), 1,
      anon_sym_RBRACK,
  [56765] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3071), 1,
      anon_sym_RBRACE,
  [56772] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3073), 1,
      anon_sym_RBRACE,
  [56779] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3075), 1,
      sym_identifier,
  [56786] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3077), 1,
      anon_sym_import,
  [56793] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3079), 1,
      anon_sym_RPAREN,
  [56800] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3081), 1,
      sym_identifier,
  [56807] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3083), 1,
      anon_sym_import,
  [56814] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3085), 1,
      sym_identifier,
  [56821] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3087), 1,
      anon_sym_in,
  [56828] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3089), 1,
      anon_sym_RPAREN,
  [56835] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3091), 1,
      sym_identifier,
  [56842] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3093), 1,
      sym_identifier,
  [56849] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3095), 1,
      sym_identifier,
  [56856] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3097), 1,
      anon_sym_COLON,
  [56863] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3099), 1,
      anon_sym_COLON,
  [56870] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3101), 1,
      anon_sym_COLON,
  [56877] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2860), 1,
      anon_sym_in,
  [56884] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3103), 1,
      anon_sym_RPAREN,
  [56891] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3105), 1,
      sym_identifier,
  [56898] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3107), 1,
      sym_identifier,
  [56905] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3109), 1,
      anon_sym_COLON,
  [56912] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3111), 1,
      anon_sym_COLON,
  [56919] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3113), 1,
      anon_sym_RBRACE,
  [56926] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3115), 1,
      anon_sym_RBRACE,
  [56933] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3117), 1,
      anon_sym_RBRACE,
  [56940] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3119), 1,
      anon_sym_COLON,
  [56947] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3121), 1,
      anon_sym_RPAREN,
  [56954] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2293), 1,
      anon_sym_COLON,
  [56961] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2858), 1,
      anon_sym_in,
  [56968] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3123), 1,
      anon_sym_RBRACK,
  [56975] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3125), 1,
      anon_sym_COLON,
  [56982] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3127), 1,
      anon_sym_RBRACE,
  [56989] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3129), 1,
      anon_sym_COLON,
  [56996] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3131), 1,
      anon_sym_COLON,
  [57003] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2281), 1,
      anon_sym_COLON,
  [57010] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3133), 1,
      anon_sym_RBRACK,
  [57017] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3135), 1,
      anon_sym_COLON,
  [57024] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3137), 1,
      anon_sym_RPAREN,
  [57031] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3139), 1,
      anon_sym_COLON,
  [57038] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3141), 1,
      sym_identifier,
  [57045] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3143), 1,
      anon_sym_COLON,
  [57052] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2866), 1,
      anon_sym_RBRACE,
  [57059] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3145), 1,
      anon_sym_COLON,
  [57066] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3147), 1,
      anon_sym_COLON,
  [57073] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3149), 1,
      anon_sym_COLON,
  [57080] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3151), 1,
      anon_sym_COLON,
  [57087] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3153), 1,
      anon_sym_RPAREN,
  [57094] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3155), 1,
      anon_sym_COLON,
  [57101] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3157), 1,
      anon_sym_COLON,
  [57108] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3159), 1,
      anon_sym_COLON,
  [57115] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(876), 1,
      anon_sym_def,
  [57122] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3161), 1,
      anon_sym_COLON,
  [57129] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3163), 1,
      sym_identifier,
  [57136] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3165), 1,
      anon_sym_COLON,
  [57143] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3167), 1,
      anon_sym_EQ,
  [57150] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3169), 1,
      anon_sym_COLON,
  [57157] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3171), 1,
      anon_sym_in,
  [57164] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3173), 1,
      anon_sym_COLON,
  [57171] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3175), 1,
      anon_sym_RBRACE,
  [57178] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3177), 1,
      anon_sym_RBRACK,
  [57185] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3179), 1,
      sym_identifier,
  [57192] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3181), 1,
      anon_sym_COLON,
  [57199] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3183), 1,
      sym_identifier,
  [57206] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3185), 1,
      anon_sym_COLON,
  [57213] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3187), 1,
      ts_builtin_sym_end,
  [57220] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3189), 1,
      anon_sym_RBRACK,
  [57227] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3191), 1,
      anon_sym_RBRACE,
  [57234] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3193), 1,
      anon_sym_COLON,
  [57241] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3195), 1,
      anon_sym_COLON,
  [57248] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2246), 1,
      anon_sym_COLON,
  [57255] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3197), 1,
      sym_identifier,
  [57262] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3199), 1,
      sym_identifier,
  [57269] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3201), 1,
      sym_identifier,
  [57276] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3203), 1,
      sym_identifier,
  [57283] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3205), 1,
      anon_sym_COLON,
  [57290] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3207), 1,
      anon_sym_RBRACE,
  [57297] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3209), 1,
      sym_identifier,
  [57304] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3211), 1,
      anon_sym_RBRACE,
  [57311] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3213), 1,
      sym_identifier,
  [57318] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3215), 1,
      sym_identifier,
  [57325] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2320), 1,
      anon_sym_COLON,
  [57332] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2592), 1,
      anon_sym_in,
  [57339] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(894), 1,
      anon_sym_def,
  [57346] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3217), 1,
      anon_sym_COLON,
  [57353] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2590), 1,
      anon_sym_in,
  [57360] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2538), 1,
      anon_sym_RBRACE,
  [57367] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3219), 1,
      anon_sym_COLON,
};

static const uint32_t ts_small_parse_table_map[] = {
  [SMALL_STATE(155)] = 0,
  [SMALL_STATE(156)] = 118,
  [SMALL_STATE(157)] = 236,
  [SMALL_STATE(158)] = 354,
  [SMALL_STATE(159)] = 464,
  [SMALL_STATE(160)] = 579,
  [SMALL_STATE(161)] = 694,
  [SMALL_STATE(162)] = 809,
  [SMALL_STATE(163)] = 926,
  [SMALL_STATE(164)] = 1045,
  [SMALL_STATE(165)] = 1162,
  [SMALL_STATE(166)] = 1262,
  [SMALL_STATE(167)] = 1376,
  [SMALL_STATE(168)] = 1480,
  [SMALL_STATE(169)] = 1584,
  [SMALL_STATE(170)] = 1698,
  [SMALL_STATE(171)] = 1812,
  [SMALL_STATE(172)] = 1916,
  [SMALL_STATE(173)] = 2016,
  [SMALL_STATE(174)] = 2123,
  [SMALL_STATE(175)] = 2224,
  [SMALL_STATE(176)] = 2325,
  [SMALL_STATE(177)] = 2430,
  [SMALL_STATE(178)] = 2535,
  [SMALL_STATE(179)] = 2638,
  [SMALL_STATE(180)] = 2743,
  [SMALL_STATE(181)] = 2848,
  [SMALL_STATE(182)] = 2953,
  [SMALL_STATE(183)] = 3054,
  [SMALL_STATE(184)] = 3157,
  [SMALL_STATE(185)] = 3262,
  [SMALL_STATE(186)] = 3360,
  [SMALL_STATE(187)] = 3462,
  [SMALL_STATE(188)] = 3564,
  [SMALL_STATE(189)] = 3668,
  [SMALL_STATE(190)] = 3770,
  [SMALL_STATE(191)] = 3872,
  [SMALL_STATE(192)] = 3974,
  [SMALL_STATE(193)] = 4072,
  [SMALL_STATE(194)] = 4176,
  [SMALL_STATE(195)] = 4278,
  [SMALL_STATE(196)] = 4380,
  [SMALL_STATE(197)] = 4482,
  [SMALL_STATE(198)] = 4584,
  [SMALL_STATE(199)] = 4686,
  [SMALL_STATE(200)] = 4788,
  [SMALL_STATE(201)] = 4894,
  [SMALL_STATE(202)] = 4996,
  [SMALL_STATE(203)] = 5094,
  [SMALL_STATE(204)] = 5196,
  [SMALL_STATE(205)] = 5300,
  [SMALL_STATE(206)] = 5402,
  [SMALL_STATE(207)] = 5504,
  [SMALL_STATE(208)] = 5606,
  [SMALL_STATE(209)] = 5708,
  [SMALL_STATE(210)] = 5810,
  [SMALL_STATE(211)] = 5912,
  [SMALL_STATE(212)] = 6018,
  [SMALL_STATE(213)] = 6122,
  [SMALL_STATE(214)] = 6220,
  [SMALL_STATE(215)] = 6322,
  [SMALL_STATE(216)] = 6424,
  [SMALL_STATE(217)] = 6526,
  [SMALL_STATE(218)] = 6628,
  [SMALL_STATE(219)] = 6689,
  [SMALL_STATE(220)] = 6750,
  [SMALL_STATE(221)] = 6811,
  [SMALL_STATE(222)] = 6872,
  [SMALL_STATE(223)] = 6971,
  [SMALL_STATE(224)] = 7032,
  [SMALL_STATE(225)] = 7131,
  [SMALL_STATE(226)] = 7230,
  [SMALL_STATE(227)] = 7291,
  [SMALL_STATE(228)] = 7352,
  [SMALL_STATE(229)] = 7424,
  [SMALL_STATE(230)] = 7496,
  [SMALL_STATE(231)] = 7592,
  [SMALL_STATE(232)] = 7690,
  [SMALL_STATE(233)] = 7762,
  [SMALL_STATE(234)] = 7860,
  [SMALL_STATE(235)] = 7932,
  [SMALL_STATE(236)] = 8030,
  [SMALL_STATE(237)] = 8128,
  [SMALL_STATE(238)] = 8200,
  [SMALL_STATE(239)] = 8272,
  [SMALL_STATE(240)] = 8370,
  [SMALL_STATE(241)] = 8442,
  [SMALL_STATE(242)] = 8514,
  [SMALL_STATE(243)] = 8609,
  [SMALL_STATE(244)] = 8704,
  [SMALL_STATE(245)] = 8799,
  [SMALL_STATE(246)] = 8894,
  [SMALL_STATE(247)] = 8989,
  [SMALL_STATE(248)] = 9062,
  [SMALL_STATE(249)] = 9157,
  [SMALL_STATE(250)] = 9252,
  [SMALL_STATE(251)] = 9347,
  [SMALL_STATE(252)] = 9442,
  [SMALL_STATE(253)] = 9537,
  [SMALL_STATE(254)] = 9632,
  [SMALL_STATE(255)] = 9705,
  [SMALL_STATE(256)] = 9799,
  [SMALL_STATE(257)] = 9893,
  [SMALL_STATE(258)] = 9987,
  [SMALL_STATE(259)] = 10055,
  [SMALL_STATE(260)] = 10147,
  [SMALL_STATE(261)] = 10241,
  [SMALL_STATE(262)] = 10335,
  [SMALL_STATE(263)] = 10429,
  [SMALL_STATE(264)] = 10497,
  [SMALL_STATE(265)] = 10589,
  [SMALL_STATE(266)] = 10657,
  [SMALL_STATE(267)] = 10719,
  [SMALL_STATE(268)] = 10781,
  [SMALL_STATE(269)] = 10849,
  [SMALL_STATE(270)] = 10943,
  [SMALL_STATE(271)] = 11005,
  [SMALL_STATE(272)] = 11067,
  [SMALL_STATE(273)] = 11135,
  [SMALL_STATE(274)] = 11229,
  [SMALL_STATE(275)] = 11323,
  [SMALL_STATE(276)] = 11415,
  [SMALL_STATE(277)] = 11483,
  [SMALL_STATE(278)] = 11551,
  [SMALL_STATE(279)] = 11621,
  [SMALL_STATE(280)] = 11689,
  [SMALL_STATE(281)] = 11778,
  [SMALL_STATE(282)] = 11835,
  [SMALL_STATE(283)] = 11892,
  [SMALL_STATE(284)] = 11983,
  [SMALL_STATE(285)] = 12050,
  [SMALL_STATE(286)] = 12113,
  [SMALL_STATE(287)] = 12202,
  [SMALL_STATE(288)] = 12259,
  [SMALL_STATE(289)] = 12316,
  [SMALL_STATE(290)] = 12405,
  [SMALL_STATE(291)] = 12496,
  [SMALL_STATE(292)] = 12553,
  [SMALL_STATE(293)] = 12644,
  [SMALL_STATE(294)] = 12733,
  [SMALL_STATE(295)] = 12822,
  [SMALL_STATE(296)] = 12911,
  [SMALL_STATE(297)] = 13002,
  [SMALL_STATE(298)] = 13091,
  [SMALL_STATE(299)] = 13182,
  [SMALL_STATE(300)] = 13273,
  [SMALL_STATE(301)] = 13362,
  [SMALL_STATE(302)] = 13453,
  [SMALL_STATE(303)] = 13544,
  [SMALL_STATE(304)] = 13633,
  [SMALL_STATE(305)] = 13722,
  [SMALL_STATE(306)] = 13779,
  [SMALL_STATE(307)] = 13868,
  [SMALL_STATE(308)] = 13931,
  [SMALL_STATE(309)] = 13988,
  [SMALL_STATE(310)] = 14077,
  [SMALL_STATE(311)] = 14168,
  [SMALL_STATE(312)] = 14225,
  [SMALL_STATE(313)] = 14314,
  [SMALL_STATE(314)] = 14371,
  [SMALL_STATE(315)] = 14462,
  [SMALL_STATE(316)] = 14519,
  [SMALL_STATE(317)] = 14575,
  [SMALL_STATE(318)] = 14631,
  [SMALL_STATE(319)] = 14687,
  [SMALL_STATE(320)] = 14743,
  [SMALL_STATE(321)] = 14799,
  [SMALL_STATE(322)] = 14887,
  [SMALL_STATE(323)] = 14975,
  [SMALL_STATE(324)] = 15063,
  [SMALL_STATE(325)] = 15151,
  [SMALL_STATE(326)] = 15207,
  [SMALL_STATE(327)] = 15263,
  [SMALL_STATE(328)] = 15319,
  [SMALL_STATE(329)] = 15375,
  [SMALL_STATE(330)] = 15431,
  [SMALL_STATE(331)] = 15495,
  [SMALL_STATE(332)] = 15551,
  [SMALL_STATE(333)] = 15607,
  [SMALL_STATE(334)] = 15663,
  [SMALL_STATE(335)] = 15727,
  [SMALL_STATE(336)] = 15815,
  [SMALL_STATE(337)] = 15871,
  [SMALL_STATE(338)] = 15927,
  [SMALL_STATE(339)] = 15991,
  [SMALL_STATE(340)] = 16055,
  [SMALL_STATE(341)] = 16111,
  [SMALL_STATE(342)] = 16199,
  [SMALL_STATE(343)] = 16255,
  [SMALL_STATE(344)] = 16311,
  [SMALL_STATE(345)] = 16367,
  [SMALL_STATE(346)] = 16427,
  [SMALL_STATE(347)] = 16515,
  [SMALL_STATE(348)] = 16575,
  [SMALL_STATE(349)] = 16663,
  [SMALL_STATE(350)] = 16723,
  [SMALL_STATE(351)] = 16811,
  [SMALL_STATE(352)] = 16899,
  [SMALL_STATE(353)] = 16955,
  [SMALL_STATE(354)] = 17011,
  [SMALL_STATE(355)] = 17067,
  [SMALL_STATE(356)] = 17123,
  [SMALL_STATE(357)] = 17179,
  [SMALL_STATE(358)] = 17235,
  [SMALL_STATE(359)] = 17291,
  [SMALL_STATE(360)] = 17347,
  [SMALL_STATE(361)] = 17403,
  [SMALL_STATE(362)] = 17491,
  [SMALL_STATE(363)] = 17547,
  [SMALL_STATE(364)] = 17603,
  [SMALL_STATE(365)] = 17691,
  [SMALL_STATE(366)] = 17747,
  [SMALL_STATE(367)] = 17803,
  [SMALL_STATE(368)] = 17859,
  [SMALL_STATE(369)] = 17947,
  [SMALL_STATE(370)] = 18003,
  [SMALL_STATE(371)] = 18059,
  [SMALL_STATE(372)] = 18115,
  [SMALL_STATE(373)] = 18171,
  [SMALL_STATE(374)] = 18227,
  [SMALL_STATE(375)] = 18283,
  [SMALL_STATE(376)] = 18339,
  [SMALL_STATE(377)] = 18395,
  [SMALL_STATE(378)] = 18451,
  [SMALL_STATE(379)] = 18507,
  [SMALL_STATE(380)] = 18563,
  [SMALL_STATE(381)] = 18623,
  [SMALL_STATE(382)] = 18679,
  [SMALL_STATE(383)] = 18735,
  [SMALL_STATE(384)] = 18823,
  [SMALL_STATE(385)] = 18879,
  [SMALL_STATE(386)] = 18964,
  [SMALL_STATE(387)] = 19049,
  [SMALL_STATE(388)] = 19108,
  [SMALL_STATE(389)] = 19163,
  [SMALL_STATE(390)] = 19248,
  [SMALL_STATE(391)] = 19333,
  [SMALL_STATE(392)] = 19418,
  [SMALL_STATE(393)] = 19503,
  [SMALL_STATE(394)] = 19590,
  [SMALL_STATE(395)] = 19675,
  [SMALL_STATE(396)] = 19760,
  [SMALL_STATE(397)] = 19845,
  [SMALL_STATE(398)] = 19930,
  [SMALL_STATE(399)] = 20015,
  [SMALL_STATE(400)] = 20100,
  [SMALL_STATE(401)] = 20185,
  [SMALL_STATE(402)] = 20244,
  [SMALL_STATE(403)] = 20329,
  [SMALL_STATE(404)] = 20384,
  [SMALL_STATE(405)] = 20469,
  [SMALL_STATE(406)] = 20554,
  [SMALL_STATE(407)] = 20639,
  [SMALL_STATE(408)] = 20694,
  [SMALL_STATE(409)] = 20753,
  [SMALL_STATE(410)] = 20838,
  [SMALL_STATE(411)] = 20923,
  [SMALL_STATE(412)] = 21008,
  [SMALL_STATE(413)] = 21093,
  [SMALL_STATE(414)] = 21152,
  [SMALL_STATE(415)] = 21211,
  [SMALL_STATE(416)] = 21296,
  [SMALL_STATE(417)] = 21381,
  [SMALL_STATE(418)] = 21466,
  [SMALL_STATE(419)] = 21525,
  [SMALL_STATE(420)] = 21610,
  [SMALL_STATE(421)] = 21665,
  [SMALL_STATE(422)] = 21720,
  [SMALL_STATE(423)] = 21805,
  [SMALL_STATE(424)] = 21890,
  [SMALL_STATE(425)] = 21975,
  [SMALL_STATE(426)] = 22060,
  [SMALL_STATE(427)] = 22145,
  [SMALL_STATE(428)] = 22204,
  [SMALL_STATE(429)] = 22263,
  [SMALL_STATE(430)] = 22348,
  [SMALL_STATE(431)] = 22407,
  [SMALL_STATE(432)] = 22468,
  [SMALL_STATE(433)] = 22527,
  [SMALL_STATE(434)] = 22582,
  [SMALL_STATE(435)] = 22667,
  [SMALL_STATE(436)] = 22752,
  [SMALL_STATE(437)] = 22837,
  [SMALL_STATE(438)] = 22922,
  [SMALL_STATE(439)] = 23007,
  [SMALL_STATE(440)] = 23092,
  [SMALL_STATE(441)] = 23151,
  [SMALL_STATE(442)] = 23212,
  [SMALL_STATE(443)] = 23297,
  [SMALL_STATE(444)] = 23382,
  [SMALL_STATE(445)] = 23467,
  [SMALL_STATE(446)] = 23552,
  [SMALL_STATE(447)] = 23637,
  [SMALL_STATE(448)] = 23722,
  [SMALL_STATE(449)] = 23807,
  [SMALL_STATE(450)] = 23868,
  [SMALL_STATE(451)] = 23953,
  [SMALL_STATE(452)] = 24038,
  [SMALL_STATE(453)] = 24123,
  [SMALL_STATE(454)] = 24208,
  [SMALL_STATE(455)] = 24267,
  [SMALL_STATE(456)] = 24352,
  [SMALL_STATE(457)] = 24437,
  [SMALL_STATE(458)] = 24522,
  [SMALL_STATE(459)] = 24607,
  [SMALL_STATE(460)] = 24692,
  [SMALL_STATE(461)] = 24777,
  [SMALL_STATE(462)] = 24862,
  [SMALL_STATE(463)] = 24947,
  [SMALL_STATE(464)] = 25032,
  [SMALL_STATE(465)] = 25091,
  [SMALL_STATE(466)] = 25176,
  [SMALL_STATE(467)] = 25261,
  [SMALL_STATE(468)] = 25320,
  [SMALL_STATE(469)] = 25405,
  [SMALL_STATE(470)] = 25490,
  [SMALL_STATE(471)] = 25575,
  [SMALL_STATE(472)] = 25660,
  [SMALL_STATE(473)] = 25719,
  [SMALL_STATE(474)] = 25804,
  [SMALL_STATE(475)] = 25889,
  [SMALL_STATE(476)] = 25950,
  [SMALL_STATE(477)] = 26035,
  [SMALL_STATE(478)] = 26120,
  [SMALL_STATE(479)] = 26179,
  [SMALL_STATE(480)] = 26264,
  [SMALL_STATE(481)] = 26349,
  [SMALL_STATE(482)] = 26434,
  [SMALL_STATE(483)] = 26519,
  [SMALL_STATE(484)] = 26604,
  [SMALL_STATE(485)] = 26689,
  [SMALL_STATE(486)] = 26743,
  [SMALL_STATE(487)] = 26797,
  [SMALL_STATE(488)] = 26851,
  [SMALL_STATE(489)] = 26905,
  [SMALL_STATE(490)] = 26959,
  [SMALL_STATE(491)] = 27013,
  [SMALL_STATE(492)] = 27067,
  [SMALL_STATE(493)] = 27121,
  [SMALL_STATE(494)] = 27175,
  [SMALL_STATE(495)] = 27229,
  [SMALL_STATE(496)] = 27283,
  [SMALL_STATE(497)] = 27337,
  [SMALL_STATE(498)] = 27390,
  [SMALL_STATE(499)] = 27443,
  [SMALL_STATE(500)] = 27496,
  [SMALL_STATE(501)] = 27549,
  [SMALL_STATE(502)] = 27602,
  [SMALL_STATE(503)] = 27655,
  [SMALL_STATE(504)] = 27708,
  [SMALL_STATE(505)] = 27761,
  [SMALL_STATE(506)] = 27814,
  [SMALL_STATE(507)] = 27867,
  [SMALL_STATE(508)] = 27920,
  [SMALL_STATE(509)] = 27973,
  [SMALL_STATE(510)] = 28026,
  [SMALL_STATE(511)] = 28079,
  [SMALL_STATE(512)] = 28132,
  [SMALL_STATE(513)] = 28185,
  [SMALL_STATE(514)] = 28238,
  [SMALL_STATE(515)] = 28291,
  [SMALL_STATE(516)] = 28344,
  [SMALL_STATE(517)] = 28397,
  [SMALL_STATE(518)] = 28450,
  [SMALL_STATE(519)] = 28503,
  [SMALL_STATE(520)] = 28556,
  [SMALL_STATE(521)] = 28609,
  [SMALL_STATE(522)] = 28662,
  [SMALL_STATE(523)] = 28715,
  [SMALL_STATE(524)] = 28768,
  [SMALL_STATE(525)] = 28821,
  [SMALL_STATE(526)] = 28874,
  [SMALL_STATE(527)] = 28927,
  [SMALL_STATE(528)] = 28980,
  [SMALL_STATE(529)] = 29033,
  [SMALL_STATE(530)] = 29086,
  [SMALL_STATE(531)] = 29139,
  [SMALL_STATE(532)] = 29192,
  [SMALL_STATE(533)] = 29245,
  [SMALL_STATE(534)] = 29298,
  [SMALL_STATE(535)] = 29351,
  [SMALL_STATE(536)] = 29404,
  [SMALL_STATE(537)] = 29457,
  [SMALL_STATE(538)] = 29510,
  [SMALL_STATE(539)] = 29563,
  [SMALL_STATE(540)] = 29616,
  [SMALL_STATE(541)] = 29669,
  [SMALL_STATE(542)] = 29722,
  [SMALL_STATE(543)] = 29775,
  [SMALL_STATE(544)] = 29828,
  [SMALL_STATE(545)] = 29881,
  [SMALL_STATE(546)] = 29934,
  [SMALL_STATE(547)] = 29987,
  [SMALL_STATE(548)] = 30040,
  [SMALL_STATE(549)] = 30093,
  [SMALL_STATE(550)] = 30146,
  [SMALL_STATE(551)] = 30199,
  [SMALL_STATE(552)] = 30252,
  [SMALL_STATE(553)] = 30305,
  [SMALL_STATE(554)] = 30358,
  [SMALL_STATE(555)] = 30411,
  [SMALL_STATE(556)] = 30464,
  [SMALL_STATE(557)] = 30517,
  [SMALL_STATE(558)] = 30570,
  [SMALL_STATE(559)] = 30623,
  [SMALL_STATE(560)] = 30676,
  [SMALL_STATE(561)] = 30729,
  [SMALL_STATE(562)] = 30782,
  [SMALL_STATE(563)] = 30835,
  [SMALL_STATE(564)] = 30888,
  [SMALL_STATE(565)] = 30941,
  [SMALL_STATE(566)] = 30994,
  [SMALL_STATE(567)] = 31047,
  [SMALL_STATE(568)] = 31100,
  [SMALL_STATE(569)] = 31153,
  [SMALL_STATE(570)] = 31206,
  [SMALL_STATE(571)] = 31259,
  [SMALL_STATE(572)] = 31312,
  [SMALL_STATE(573)] = 31365,
  [SMALL_STATE(574)] = 31418,
  [SMALL_STATE(575)] = 31471,
  [SMALL_STATE(576)] = 31524,
  [SMALL_STATE(577)] = 31577,
  [SMALL_STATE(578)] = 31630,
  [SMALL_STATE(579)] = 31683,
  [SMALL_STATE(580)] = 31736,
  [SMALL_STATE(581)] = 31789,
  [SMALL_STATE(582)] = 31842,
  [SMALL_STATE(583)] = 31895,
  [SMALL_STATE(584)] = 31948,
  [SMALL_STATE(585)] = 32001,
  [SMALL_STATE(586)] = 32054,
  [SMALL_STATE(587)] = 32107,
  [SMALL_STATE(588)] = 32160,
  [SMALL_STATE(589)] = 32213,
  [SMALL_STATE(590)] = 32266,
  [SMALL_STATE(591)] = 32319,
  [SMALL_STATE(592)] = 32372,
  [SMALL_STATE(593)] = 32425,
  [SMALL_STATE(594)] = 32478,
  [SMALL_STATE(595)] = 32531,
  [SMALL_STATE(596)] = 32613,
  [SMALL_STATE(597)] = 32697,
  [SMALL_STATE(598)] = 32779,
  [SMALL_STATE(599)] = 32834,
  [SMALL_STATE(600)] = 32889,
  [SMALL_STATE(601)] = 32944,
  [SMALL_STATE(602)] = 33025,
  [SMALL_STATE(603)] = 33106,
  [SMALL_STATE(604)] = 33187,
  [SMALL_STATE(605)] = 33268,
  [SMALL_STATE(606)] = 33349,
  [SMALL_STATE(607)] = 33430,
  [SMALL_STATE(608)] = 33508,
  [SMALL_STATE(609)] = 33586,
  [SMALL_STATE(610)] = 33635,
  [SMALL_STATE(611)] = 33684,
  [SMALL_STATE(612)] = 33732,
  [SMALL_STATE(613)] = 33780,
  [SMALL_STATE(614)] = 33828,
  [SMALL_STATE(615)] = 33876,
  [SMALL_STATE(616)] = 33924,
  [SMALL_STATE(617)] = 33972,
  [SMALL_STATE(618)] = 34020,
  [SMALL_STATE(619)] = 34068,
  [SMALL_STATE(620)] = 34116,
  [SMALL_STATE(621)] = 34164,
  [SMALL_STATE(622)] = 34212,
  [SMALL_STATE(623)] = 34260,
  [SMALL_STATE(624)] = 34308,
  [SMALL_STATE(625)] = 34356,
  [SMALL_STATE(626)] = 34404,
  [SMALL_STATE(627)] = 34452,
  [SMALL_STATE(628)] = 34500,
  [SMALL_STATE(629)] = 34548,
  [SMALL_STATE(630)] = 34596,
  [SMALL_STATE(631)] = 34678,
  [SMALL_STATE(632)] = 34726,
  [SMALL_STATE(633)] = 34774,
  [SMALL_STATE(634)] = 34822,
  [SMALL_STATE(635)] = 34870,
  [SMALL_STATE(636)] = 34918,
  [SMALL_STATE(637)] = 34990,
  [SMALL_STATE(638)] = 35038,
  [SMALL_STATE(639)] = 35086,
  [SMALL_STATE(640)] = 35134,
  [SMALL_STATE(641)] = 35182,
  [SMALL_STATE(642)] = 35230,
  [SMALL_STATE(643)] = 35278,
  [SMALL_STATE(644)] = 35360,
  [SMALL_STATE(645)] = 35408,
  [SMALL_STATE(646)] = 35465,
  [SMALL_STATE(647)] = 35532,
  [SMALL_STATE(648)] = 35589,
  [SMALL_STATE(649)] = 35646,
  [SMALL_STATE(650)] = 35709,
  [SMALL_STATE(651)] = 35766,
  [SMALL_STATE(652)] = 35827,
  [SMALL_STATE(653)] = 35898,
  [SMALL_STATE(654)] = 35967,
  [SMALL_STATE(655)] = 36028,
  [SMALL_STATE(656)] = 36085,
  [SMALL_STATE(657)] = 36150,
  [SMALL_STATE(658)] = 36215,
  [SMALL_STATE(659)] = 36284,
  [SMALL_STATE(660)] = 36355,
  [SMALL_STATE(661)] = 36422,
  [SMALL_STATE(662)] = 36479,
  [SMALL_STATE(663)] = 36550,
  [SMALL_STATE(664)] = 36621,
  [SMALL_STATE(665)] = 36692,
  [SMALL_STATE(666)] = 36763,
  [SMALL_STATE(667)] = 36826,
  [SMALL_STATE(668)] = 36874,
  [SMALL_STATE(669)] = 36922,
  [SMALL_STATE(670)] = 36988,
  [SMALL_STATE(671)] = 37054,
  [SMALL_STATE(672)] = 37100,
  [SMALL_STATE(673)] = 37146,
  [SMALL_STATE(674)] = 37212,
  [SMALL_STATE(675)] = 37260,
  [SMALL_STATE(676)] = 37308,
  [SMALL_STATE(677)] = 37374,
  [SMALL_STATE(678)] = 37424,
  [SMALL_STATE(679)] = 37474,
  [SMALL_STATE(680)] = 37537,
  [SMALL_STATE(681)] = 37600,
  [SMALL_STATE(682)] = 37663,
  [SMALL_STATE(683)] = 37726,
  [SMALL_STATE(684)] = 37789,
  [SMALL_STATE(685)] = 37868,
  [SMALL_STATE(686)] = 37935,
  [SMALL_STATE(687)] = 37998,
  [SMALL_STATE(688)] = 38061,
  [SMALL_STATE(689)] = 38124,
  [SMALL_STATE(690)] = 38173,
  [SMALL_STATE(691)] = 38236,
  [SMALL_STATE(692)] = 38299,
  [SMALL_STATE(693)] = 38362,
  [SMALL_STATE(694)] = 38425,
  [SMALL_STATE(695)] = 38488,
  [SMALL_STATE(696)] = 38551,
  [SMALL_STATE(697)] = 38614,
  [SMALL_STATE(698)] = 38677,
  [SMALL_STATE(699)] = 38740,
  [SMALL_STATE(700)] = 38803,
  [SMALL_STATE(701)] = 38866,
  [SMALL_STATE(702)] = 38929,
  [SMALL_STATE(703)] = 38992,
  [SMALL_STATE(704)] = 39055,
  [SMALL_STATE(705)] = 39118,
  [SMALL_STATE(706)] = 39181,
  [SMALL_STATE(707)] = 39244,
  [SMALL_STATE(708)] = 39307,
  [SMALL_STATE(709)] = 39370,
  [SMALL_STATE(710)] = 39433,
  [SMALL_STATE(711)] = 39496,
  [SMALL_STATE(712)] = 39559,
  [SMALL_STATE(713)] = 39622,
  [SMALL_STATE(714)] = 39671,
  [SMALL_STATE(715)] = 39734,
  [SMALL_STATE(716)] = 39801,
  [SMALL_STATE(717)] = 39864,
  [SMALL_STATE(718)] = 39927,
  [SMALL_STATE(719)] = 39990,
  [SMALL_STATE(720)] = 40053,
  [SMALL_STATE(721)] = 40102,
  [SMALL_STATE(722)] = 40165,
  [SMALL_STATE(723)] = 40228,
  [SMALL_STATE(724)] = 40291,
  [SMALL_STATE(725)] = 40354,
  [SMALL_STATE(726)] = 40399,
  [SMALL_STATE(727)] = 40462,
  [SMALL_STATE(728)] = 40507,
  [SMALL_STATE(729)] = 40570,
  [SMALL_STATE(730)] = 40633,
  [SMALL_STATE(731)] = 40696,
  [SMALL_STATE(732)] = 40764,
  [SMALL_STATE(733)] = 40824,
  [SMALL_STATE(734)] = 40892,
  [SMALL_STATE(735)] = 40960,
  [SMALL_STATE(736)] = 41014,
  [SMALL_STATE(737)] = 41058,
  [SMALL_STATE(738)] = 41124,
  [SMALL_STATE(739)] = 41182,
  [SMALL_STATE(740)] = 41236,
  [SMALL_STATE(741)] = 41312,
  [SMALL_STATE(742)] = 41376,
  [SMALL_STATE(743)] = 41424,
  [SMALL_STATE(744)] = 41486,
  [SMALL_STATE(745)] = 41530,
  [SMALL_STATE(746)] = 41584,
  [SMALL_STATE(747)] = 41651,
  [SMALL_STATE(748)] = 41708,
  [SMALL_STATE(749)] = 41753,
  [SMALL_STATE(750)] = 41800,
  [SMALL_STATE(751)] = 41865,
  [SMALL_STATE(752)] = 41932,
  [SMALL_STATE(753)] = 41991,
  [SMALL_STATE(754)] = 42044,
  [SMALL_STATE(755)] = 42089,
  [SMALL_STATE(756)] = 42134,
  [SMALL_STATE(757)] = 42187,
  [SMALL_STATE(758)] = 42254,
  [SMALL_STATE(759)] = 42297,
  [SMALL_STATE(760)] = 42344,
  [SMALL_STATE(761)] = 42391,
  [SMALL_STATE(762)] = 42454,
  [SMALL_STATE(763)] = 42499,
  [SMALL_STATE(764)] = 42560,
  [SMALL_STATE(765)] = 42607,
  [SMALL_STATE(766)] = 42652,
  [SMALL_STATE(767)] = 42705,
  [SMALL_STATE(768)] = 42750,
  [SMALL_STATE(769)] = 42795,
  [SMALL_STATE(770)] = 42838,
  [SMALL_STATE(771)] = 42883,
  [SMALL_STATE(772)] = 42925,
  [SMALL_STATE(773)] = 42967,
  [SMALL_STATE(774)] = 43009,
  [SMALL_STATE(775)] = 43051,
  [SMALL_STATE(776)] = 43093,
  [SMALL_STATE(777)] = 43135,
  [SMALL_STATE(778)] = 43177,
  [SMALL_STATE(779)] = 43219,
  [SMALL_STATE(780)] = 43263,
  [SMALL_STATE(781)] = 43305,
  [SMALL_STATE(782)] = 43347,
  [SMALL_STATE(783)] = 43389,
  [SMALL_STATE(784)] = 43431,
  [SMALL_STATE(785)] = 43473,
  [SMALL_STATE(786)] = 43515,
  [SMALL_STATE(787)] = 43557,
  [SMALL_STATE(788)] = 43599,
  [SMALL_STATE(789)] = 43641,
  [SMALL_STATE(790)] = 43685,
  [SMALL_STATE(791)] = 43727,
  [SMALL_STATE(792)] = 43769,
  [SMALL_STATE(793)] = 43811,
  [SMALL_STATE(794)] = 43853,
  [SMALL_STATE(795)] = 43895,
  [SMALL_STATE(796)] = 43937,
  [SMALL_STATE(797)] = 43979,
  [SMALL_STATE(798)] = 44021,
  [SMALL_STATE(799)] = 44065,
  [SMALL_STATE(800)] = 44107,
  [SMALL_STATE(801)] = 44149,
  [SMALL_STATE(802)] = 44193,
  [SMALL_STATE(803)] = 44235,
  [SMALL_STATE(804)] = 44277,
  [SMALL_STATE(805)] = 44319,
  [SMALL_STATE(806)] = 44361,
  [SMALL_STATE(807)] = 44405,
  [SMALL_STATE(808)] = 44447,
  [SMALL_STATE(809)] = 44489,
  [SMALL_STATE(810)] = 44530,
  [SMALL_STATE(811)] = 44571,
  [SMALL_STATE(812)] = 44612,
  [SMALL_STATE(813)] = 44657,
  [SMALL_STATE(814)] = 44698,
  [SMALL_STATE(815)] = 44739,
  [SMALL_STATE(816)] = 44780,
  [SMALL_STATE(817)] = 44821,
  [SMALL_STATE(818)] = 44862,
  [SMALL_STATE(819)] = 44903,
  [SMALL_STATE(820)] = 44944,
  [SMALL_STATE(821)] = 44985,
  [SMALL_STATE(822)] = 45026,
  [SMALL_STATE(823)] = 45067,
  [SMALL_STATE(824)] = 45108,
  [SMALL_STATE(825)] = 45149,
  [SMALL_STATE(826)] = 45190,
  [SMALL_STATE(827)] = 45231,
  [SMALL_STATE(828)] = 45272,
  [SMALL_STATE(829)] = 45313,
  [SMALL_STATE(830)] = 45354,
  [SMALL_STATE(831)] = 45395,
  [SMALL_STATE(832)] = 45436,
  [SMALL_STATE(833)] = 45477,
  [SMALL_STATE(834)] = 45518,
  [SMALL_STATE(835)] = 45559,
  [SMALL_STATE(836)] = 45600,
  [SMALL_STATE(837)] = 45641,
  [SMALL_STATE(838)] = 45686,
  [SMALL_STATE(839)] = 45727,
  [SMALL_STATE(840)] = 45768,
  [SMALL_STATE(841)] = 45809,
  [SMALL_STATE(842)] = 45850,
  [SMALL_STATE(843)] = 45891,
  [SMALL_STATE(844)] = 45932,
  [SMALL_STATE(845)] = 45973,
  [SMALL_STATE(846)] = 46014,
  [SMALL_STATE(847)] = 46055,
  [SMALL_STATE(848)] = 46096,
  [SMALL_STATE(849)] = 46137,
  [SMALL_STATE(850)] = 46211,
  [SMALL_STATE(851)] = 46285,
  [SMALL_STATE(852)] = 46359,
  [SMALL_STATE(853)] = 46433,
  [SMALL_STATE(854)] = 46506,
  [SMALL_STATE(855)] = 46577,
  [SMALL_STATE(856)] = 46648,
  [SMALL_STATE(857)] = 46719,
  [SMALL_STATE(858)] = 46790,
  [SMALL_STATE(859)] = 46861,
  [SMALL_STATE(860)] = 46929,
  [SMALL_STATE(861)] = 47001,
  [SMALL_STATE(862)] = 47073,
  [SMALL_STATE(863)] = 47145,
  [SMALL_STATE(864)] = 47211,
  [SMALL_STATE(865)] = 47274,
  [SMALL_STATE(866)] = 47337,
  [SMALL_STATE(867)] = 47392,
  [SMALL_STATE(868)] = 47447,
  [SMALL_STATE(869)] = 47487,
  [SMALL_STATE(870)] = 47527,
  [SMALL_STATE(871)] = 47567,
  [SMALL_STATE(872)] = 47607,
  [SMALL_STATE(873)] = 47637,
  [SMALL_STATE(874)] = 47662,
  [SMALL_STATE(875)] = 47687,
  [SMALL_STATE(876)] = 47712,
  [SMALL_STATE(877)] = 47737,
  [SMALL_STATE(878)] = 47774,
  [SMALL_STATE(879)] = 47811,
  [SMALL_STATE(880)] = 47840,
  [SMALL_STATE(881)] = 47869,
  [SMALL_STATE(882)] = 47903,
  [SMALL_STATE(883)] = 47949,
  [SMALL_STATE(884)] = 47983,
  [SMALL_STATE(885)] = 48011,
  [SMALL_STATE(886)] = 48054,
  [SMALL_STATE(887)] = 48097,
  [SMALL_STATE(888)] = 48140,
  [SMALL_STATE(889)] = 48183,
  [SMALL_STATE(890)] = 48214,
  [SMALL_STATE(891)] = 48257,
  [SMALL_STATE(892)] = 48303,
  [SMALL_STATE(893)] = 48349,
  [SMALL_STATE(894)] = 48389,
  [SMALL_STATE(895)] = 48435,
  [SMALL_STATE(896)] = 48472,
  [SMALL_STATE(897)] = 48509,
  [SMALL_STATE(898)] = 48534,
  [SMALL_STATE(899)] = 48571,
  [SMALL_STATE(900)] = 48608,
  [SMALL_STATE(901)] = 48630,
  [SMALL_STATE(902)] = 48652,
  [SMALL_STATE(903)] = 48686,
  [SMALL_STATE(904)] = 48720,
  [SMALL_STATE(905)] = 48742,
  [SMALL_STATE(906)] = 48779,
  [SMALL_STATE(907)] = 48801,
  [SMALL_STATE(908)] = 48838,
  [SMALL_STATE(909)] = 48861,
  [SMALL_STATE(910)] = 48886,
  [SMALL_STATE(911)] = 48909,
  [SMALL_STATE(912)] = 48946,
  [SMALL_STATE(913)] = 48971,
  [SMALL_STATE(914)] = 48992,
  [SMALL_STATE(915)] = 49015,
  [SMALL_STATE(916)] = 49052,
  [SMALL_STATE(917)] = 49073,
  [SMALL_STATE(918)] = 49090,
  [SMALL_STATE(919)] = 49127,
  [SMALL_STATE(920)] = 49150,
  [SMALL_STATE(921)] = 49169,
  [SMALL_STATE(922)] = 49190,
  [SMALL_STATE(923)] = 49213,
  [SMALL_STATE(924)] = 49238,
  [SMALL_STATE(925)] = 49261,
  [SMALL_STATE(926)] = 49284,
  [SMALL_STATE(927)] = 49305,
  [SMALL_STATE(928)] = 49326,
  [SMALL_STATE(929)] = 49349,
  [SMALL_STATE(930)] = 49376,
  [SMALL_STATE(931)] = 49410,
  [SMALL_STATE(932)] = 49444,
  [SMALL_STATE(933)] = 49478,
  [SMALL_STATE(934)] = 49500,
  [SMALL_STATE(935)] = 49530,
  [SMALL_STATE(936)] = 49564,
  [SMALL_STATE(937)] = 49594,
  [SMALL_STATE(938)] = 49624,
  [SMALL_STATE(939)] = 49654,
  [SMALL_STATE(940)] = 49676,
  [SMALL_STATE(941)] = 49710,
  [SMALL_STATE(942)] = 49744,
  [SMALL_STATE(943)] = 49774,
  [SMALL_STATE(944)] = 49792,
  [SMALL_STATE(945)] = 49822,
  [SMALL_STATE(946)] = 49856,
  [SMALL_STATE(947)] = 49890,
  [SMALL_STATE(948)] = 49912,
  [SMALL_STATE(949)] = 49934,
  [SMALL_STATE(950)] = 49964,
  [SMALL_STATE(951)] = 49994,
  [SMALL_STATE(952)] = 50012,
  [SMALL_STATE(953)] = 50042,
  [SMALL_STATE(954)] = 50076,
  [SMALL_STATE(955)] = 50095,
  [SMALL_STATE(956)] = 50118,
  [SMALL_STATE(957)] = 50141,
  [SMALL_STATE(958)] = 50160,
  [SMALL_STATE(959)] = 50179,
  [SMALL_STATE(960)] = 50202,
  [SMALL_STATE(961)] = 50227,
  [SMALL_STATE(962)] = 50246,
  [SMALL_STATE(963)] = 50265,
  [SMALL_STATE(964)] = 50284,
  [SMALL_STATE(965)] = 50302,
  [SMALL_STATE(966)] = 50326,
  [SMALL_STATE(967)] = 50340,
  [SMALL_STATE(968)] = 50354,
  [SMALL_STATE(969)] = 50368,
  [SMALL_STATE(970)] = 50382,
  [SMALL_STATE(971)] = 50396,
  [SMALL_STATE(972)] = 50412,
  [SMALL_STATE(973)] = 50426,
  [SMALL_STATE(974)] = 50440,
  [SMALL_STATE(975)] = 50458,
  [SMALL_STATE(976)] = 50472,
  [SMALL_STATE(977)] = 50486,
  [SMALL_STATE(978)] = 50500,
  [SMALL_STATE(979)] = 50518,
  [SMALL_STATE(980)] = 50536,
  [SMALL_STATE(981)] = 50554,
  [SMALL_STATE(982)] = 50568,
  [SMALL_STATE(983)] = 50594,
  [SMALL_STATE(984)] = 50618,
  [SMALL_STATE(985)] = 50632,
  [SMALL_STATE(986)] = 50650,
  [SMALL_STATE(987)] = 50664,
  [SMALL_STATE(988)] = 50678,
  [SMALL_STATE(989)] = 50692,
  [SMALL_STATE(990)] = 50706,
  [SMALL_STATE(991)] = 50720,
  [SMALL_STATE(992)] = 50744,
  [SMALL_STATE(993)] = 50764,
  [SMALL_STATE(994)] = 50778,
  [SMALL_STATE(995)] = 50796,
  [SMALL_STATE(996)] = 50814,
  [SMALL_STATE(997)] = 50838,
  [SMALL_STATE(998)] = 50858,
  [SMALL_STATE(999)] = 50872,
  [SMALL_STATE(1000)] = 50894,
  [SMALL_STATE(1001)] = 50912,
  [SMALL_STATE(1002)] = 50928,
  [SMALL_STATE(1003)] = 50952,
  [SMALL_STATE(1004)] = 50976,
  [SMALL_STATE(1005)] = 50990,
  [SMALL_STATE(1006)] = 51008,
  [SMALL_STATE(1007)] = 51022,
  [SMALL_STATE(1008)] = 51042,
  [SMALL_STATE(1009)] = 51056,
  [SMALL_STATE(1010)] = 51070,
  [SMALL_STATE(1011)] = 51084,
  [SMALL_STATE(1012)] = 51098,
  [SMALL_STATE(1013)] = 51116,
  [SMALL_STATE(1014)] = 51134,
  [SMALL_STATE(1015)] = 51157,
  [SMALL_STATE(1016)] = 51170,
  [SMALL_STATE(1017)] = 51193,
  [SMALL_STATE(1018)] = 51206,
  [SMALL_STATE(1019)] = 51219,
  [SMALL_STATE(1020)] = 51242,
  [SMALL_STATE(1021)] = 51261,
  [SMALL_STATE(1022)] = 51286,
  [SMALL_STATE(1023)] = 51305,
  [SMALL_STATE(1024)] = 51318,
  [SMALL_STATE(1025)] = 51333,
  [SMALL_STATE(1026)] = 51350,
  [SMALL_STATE(1027)] = 51373,
  [SMALL_STATE(1028)] = 51392,
  [SMALL_STATE(1029)] = 51409,
  [SMALL_STATE(1030)] = 51424,
  [SMALL_STATE(1031)] = 51441,
  [SMALL_STATE(1032)] = 51462,
  [SMALL_STATE(1033)] = 51481,
  [SMALL_STATE(1034)] = 51494,
  [SMALL_STATE(1035)] = 51517,
  [SMALL_STATE(1036)] = 51536,
  [SMALL_STATE(1037)] = 51555,
  [SMALL_STATE(1038)] = 51574,
  [SMALL_STATE(1039)] = 51599,
  [SMALL_STATE(1040)] = 51618,
  [SMALL_STATE(1041)] = 51643,
  [SMALL_STATE(1042)] = 51656,
  [SMALL_STATE(1043)] = 51669,
  [SMALL_STATE(1044)] = 51692,
  [SMALL_STATE(1045)] = 51715,
  [SMALL_STATE(1046)] = 51738,
  [SMALL_STATE(1047)] = 51761,
  [SMALL_STATE(1048)] = 51786,
  [SMALL_STATE(1049)] = 51805,
  [SMALL_STATE(1050)] = 51830,
  [SMALL_STATE(1051)] = 51851,
  [SMALL_STATE(1052)] = 51864,
  [SMALL_STATE(1053)] = 51889,
  [SMALL_STATE(1054)] = 51908,
  [SMALL_STATE(1055)] = 51927,
  [SMALL_STATE(1056)] = 51948,
  [SMALL_STATE(1057)] = 51973,
  [SMALL_STATE(1058)] = 51989,
  [SMALL_STATE(1059)] = 52005,
  [SMALL_STATE(1060)] = 52027,
  [SMALL_STATE(1061)] = 52041,
  [SMALL_STATE(1062)] = 52057,
  [SMALL_STATE(1063)] = 52073,
  [SMALL_STATE(1064)] = 52093,
  [SMALL_STATE(1065)] = 52113,
  [SMALL_STATE(1066)] = 52131,
  [SMALL_STATE(1067)] = 52149,
  [SMALL_STATE(1068)] = 52163,
  [SMALL_STATE(1069)] = 52179,
  [SMALL_STATE(1070)] = 52193,
  [SMALL_STATE(1071)] = 52215,
  [SMALL_STATE(1072)] = 52237,
  [SMALL_STATE(1073)] = 52251,
  [SMALL_STATE(1074)] = 52269,
  [SMALL_STATE(1075)] = 52283,
  [SMALL_STATE(1076)] = 52305,
  [SMALL_STATE(1077)] = 52319,
  [SMALL_STATE(1078)] = 52335,
  [SMALL_STATE(1079)] = 52353,
  [SMALL_STATE(1080)] = 52375,
  [SMALL_STATE(1081)] = 52397,
  [SMALL_STATE(1082)] = 52417,
  [SMALL_STATE(1083)] = 52435,
  [SMALL_STATE(1084)] = 52455,
  [SMALL_STATE(1085)] = 52473,
  [SMALL_STATE(1086)] = 52495,
  [SMALL_STATE(1087)] = 52515,
  [SMALL_STATE(1088)] = 52527,
  [SMALL_STATE(1089)] = 52543,
  [SMALL_STATE(1090)] = 52555,
  [SMALL_STATE(1091)] = 52572,
  [SMALL_STATE(1092)] = 52589,
  [SMALL_STATE(1093)] = 52604,
  [SMALL_STATE(1094)] = 52621,
  [SMALL_STATE(1095)] = 52638,
  [SMALL_STATE(1096)] = 52655,
  [SMALL_STATE(1097)] = 52670,
  [SMALL_STATE(1098)] = 52689,
  [SMALL_STATE(1099)] = 52706,
  [SMALL_STATE(1100)] = 52725,
  [SMALL_STATE(1101)] = 52740,
  [SMALL_STATE(1102)] = 52751,
  [SMALL_STATE(1103)] = 52768,
  [SMALL_STATE(1104)] = 52785,
  [SMALL_STATE(1105)] = 52804,
  [SMALL_STATE(1106)] = 52821,
  [SMALL_STATE(1107)] = 52832,
  [SMALL_STATE(1108)] = 52851,
  [SMALL_STATE(1109)] = 52870,
  [SMALL_STATE(1110)] = 52887,
  [SMALL_STATE(1111)] = 52898,
  [SMALL_STATE(1112)] = 52913,
  [SMALL_STATE(1113)] = 52928,
  [SMALL_STATE(1114)] = 52945,
  [SMALL_STATE(1115)] = 52960,
  [SMALL_STATE(1116)] = 52975,
  [SMALL_STATE(1117)] = 52994,
  [SMALL_STATE(1118)] = 53013,
  [SMALL_STATE(1119)] = 53030,
  [SMALL_STATE(1120)] = 53047,
  [SMALL_STATE(1121)] = 53066,
  [SMALL_STATE(1122)] = 53083,
  [SMALL_STATE(1123)] = 53100,
  [SMALL_STATE(1124)] = 53119,
  [SMALL_STATE(1125)] = 53136,
  [SMALL_STATE(1126)] = 53155,
  [SMALL_STATE(1127)] = 53172,
  [SMALL_STATE(1128)] = 53189,
  [SMALL_STATE(1129)] = 53205,
  [SMALL_STATE(1130)] = 53219,
  [SMALL_STATE(1131)] = 53235,
  [SMALL_STATE(1132)] = 53251,
  [SMALL_STATE(1133)] = 53267,
  [SMALL_STATE(1134)] = 53279,
  [SMALL_STATE(1135)] = 53295,
  [SMALL_STATE(1136)] = 53311,
  [SMALL_STATE(1137)] = 53327,
  [SMALL_STATE(1138)] = 53341,
  [SMALL_STATE(1139)] = 53355,
  [SMALL_STATE(1140)] = 53369,
  [SMALL_STATE(1141)] = 53385,
  [SMALL_STATE(1142)] = 53401,
  [SMALL_STATE(1143)] = 53417,
  [SMALL_STATE(1144)] = 53431,
  [SMALL_STATE(1145)] = 53445,
  [SMALL_STATE(1146)] = 53461,
  [SMALL_STATE(1147)] = 53475,
  [SMALL_STATE(1148)] = 53491,
  [SMALL_STATE(1149)] = 53507,
  [SMALL_STATE(1150)] = 53523,
  [SMALL_STATE(1151)] = 53537,
  [SMALL_STATE(1152)] = 53553,
  [SMALL_STATE(1153)] = 53569,
  [SMALL_STATE(1154)] = 53585,
  [SMALL_STATE(1155)] = 53599,
  [SMALL_STATE(1156)] = 53613,
  [SMALL_STATE(1157)] = 53629,
  [SMALL_STATE(1158)] = 53645,
  [SMALL_STATE(1159)] = 53661,
  [SMALL_STATE(1160)] = 53677,
  [SMALL_STATE(1161)] = 53691,
  [SMALL_STATE(1162)] = 53707,
  [SMALL_STATE(1163)] = 53721,
  [SMALL_STATE(1164)] = 53735,
  [SMALL_STATE(1165)] = 53749,
  [SMALL_STATE(1166)] = 53763,
  [SMALL_STATE(1167)] = 53773,
  [SMALL_STATE(1168)] = 53787,
  [SMALL_STATE(1169)] = 53801,
  [SMALL_STATE(1170)] = 53817,
  [SMALL_STATE(1171)] = 53827,
  [SMALL_STATE(1172)] = 53841,
  [SMALL_STATE(1173)] = 53855,
  [SMALL_STATE(1174)] = 53871,
  [SMALL_STATE(1175)] = 53885,
  [SMALL_STATE(1176)] = 53895,
  [SMALL_STATE(1177)] = 53911,
  [SMALL_STATE(1178)] = 53925,
  [SMALL_STATE(1179)] = 53939,
  [SMALL_STATE(1180)] = 53953,
  [SMALL_STATE(1181)] = 53967,
  [SMALL_STATE(1182)] = 53983,
  [SMALL_STATE(1183)] = 53999,
  [SMALL_STATE(1184)] = 54011,
  [SMALL_STATE(1185)] = 54025,
  [SMALL_STATE(1186)] = 54035,
  [SMALL_STATE(1187)] = 54051,
  [SMALL_STATE(1188)] = 54061,
  [SMALL_STATE(1189)] = 54077,
  [SMALL_STATE(1190)] = 54091,
  [SMALL_STATE(1191)] = 54105,
  [SMALL_STATE(1192)] = 54119,
  [SMALL_STATE(1193)] = 54133,
  [SMALL_STATE(1194)] = 54149,
  [SMALL_STATE(1195)] = 54162,
  [SMALL_STATE(1196)] = 54175,
  [SMALL_STATE(1197)] = 54188,
  [SMALL_STATE(1198)] = 54201,
  [SMALL_STATE(1199)] = 54210,
  [SMALL_STATE(1200)] = 54223,
  [SMALL_STATE(1201)] = 54236,
  [SMALL_STATE(1202)] = 54245,
  [SMALL_STATE(1203)] = 54258,
  [SMALL_STATE(1204)] = 54271,
  [SMALL_STATE(1205)] = 54284,
  [SMALL_STATE(1206)] = 54297,
  [SMALL_STATE(1207)] = 54310,
  [SMALL_STATE(1208)] = 54319,
  [SMALL_STATE(1209)] = 54332,
  [SMALL_STATE(1210)] = 54345,
  [SMALL_STATE(1211)] = 54358,
  [SMALL_STATE(1212)] = 54371,
  [SMALL_STATE(1213)] = 54384,
  [SMALL_STATE(1214)] = 54397,
  [SMALL_STATE(1215)] = 54410,
  [SMALL_STATE(1216)] = 54423,
  [SMALL_STATE(1217)] = 54436,
  [SMALL_STATE(1218)] = 54447,
  [SMALL_STATE(1219)] = 54460,
  [SMALL_STATE(1220)] = 54473,
  [SMALL_STATE(1221)] = 54486,
  [SMALL_STATE(1222)] = 54499,
  [SMALL_STATE(1223)] = 54510,
  [SMALL_STATE(1224)] = 54519,
  [SMALL_STATE(1225)] = 54532,
  [SMALL_STATE(1226)] = 54545,
  [SMALL_STATE(1227)] = 54554,
  [SMALL_STATE(1228)] = 54567,
  [SMALL_STATE(1229)] = 54580,
  [SMALL_STATE(1230)] = 54593,
  [SMALL_STATE(1231)] = 54606,
  [SMALL_STATE(1232)] = 54619,
  [SMALL_STATE(1233)] = 54632,
  [SMALL_STATE(1234)] = 54643,
  [SMALL_STATE(1235)] = 54656,
  [SMALL_STATE(1236)] = 54669,
  [SMALL_STATE(1237)] = 54682,
  [SMALL_STATE(1238)] = 54695,
  [SMALL_STATE(1239)] = 54708,
  [SMALL_STATE(1240)] = 54721,
  [SMALL_STATE(1241)] = 54734,
  [SMALL_STATE(1242)] = 54747,
  [SMALL_STATE(1243)] = 54760,
  [SMALL_STATE(1244)] = 54773,
  [SMALL_STATE(1245)] = 54786,
  [SMALL_STATE(1246)] = 54797,
  [SMALL_STATE(1247)] = 54810,
  [SMALL_STATE(1248)] = 54823,
  [SMALL_STATE(1249)] = 54836,
  [SMALL_STATE(1250)] = 54849,
  [SMALL_STATE(1251)] = 54858,
  [SMALL_STATE(1252)] = 54871,
  [SMALL_STATE(1253)] = 54884,
  [SMALL_STATE(1254)] = 54895,
  [SMALL_STATE(1255)] = 54908,
  [SMALL_STATE(1256)] = 54921,
  [SMALL_STATE(1257)] = 54934,
  [SMALL_STATE(1258)] = 54947,
  [SMALL_STATE(1259)] = 54960,
  [SMALL_STATE(1260)] = 54973,
  [SMALL_STATE(1261)] = 54986,
  [SMALL_STATE(1262)] = 54999,
  [SMALL_STATE(1263)] = 55012,
  [SMALL_STATE(1264)] = 55023,
  [SMALL_STATE(1265)] = 55036,
  [SMALL_STATE(1266)] = 55047,
  [SMALL_STATE(1267)] = 55060,
  [SMALL_STATE(1268)] = 55071,
  [SMALL_STATE(1269)] = 55084,
  [SMALL_STATE(1270)] = 55095,
  [SMALL_STATE(1271)] = 55104,
  [SMALL_STATE(1272)] = 55117,
  [SMALL_STATE(1273)] = 55130,
  [SMALL_STATE(1274)] = 55143,
  [SMALL_STATE(1275)] = 55156,
  [SMALL_STATE(1276)] = 55169,
  [SMALL_STATE(1277)] = 55182,
  [SMALL_STATE(1278)] = 55195,
  [SMALL_STATE(1279)] = 55208,
  [SMALL_STATE(1280)] = 55221,
  [SMALL_STATE(1281)] = 55234,
  [SMALL_STATE(1282)] = 55243,
  [SMALL_STATE(1283)] = 55256,
  [SMALL_STATE(1284)] = 55269,
  [SMALL_STATE(1285)] = 55282,
  [SMALL_STATE(1286)] = 55295,
  [SMALL_STATE(1287)] = 55308,
  [SMALL_STATE(1288)] = 55319,
  [SMALL_STATE(1289)] = 55330,
  [SMALL_STATE(1290)] = 55343,
  [SMALL_STATE(1291)] = 55356,
  [SMALL_STATE(1292)] = 55365,
  [SMALL_STATE(1293)] = 55378,
  [SMALL_STATE(1294)] = 55391,
  [SMALL_STATE(1295)] = 55404,
  [SMALL_STATE(1296)] = 55417,
  [SMALL_STATE(1297)] = 55430,
  [SMALL_STATE(1298)] = 55443,
  [SMALL_STATE(1299)] = 55456,
  [SMALL_STATE(1300)] = 55469,
  [SMALL_STATE(1301)] = 55482,
  [SMALL_STATE(1302)] = 55495,
  [SMALL_STATE(1303)] = 55508,
  [SMALL_STATE(1304)] = 55521,
  [SMALL_STATE(1305)] = 55532,
  [SMALL_STATE(1306)] = 55545,
  [SMALL_STATE(1307)] = 55558,
  [SMALL_STATE(1308)] = 55569,
  [SMALL_STATE(1309)] = 55578,
  [SMALL_STATE(1310)] = 55591,
  [SMALL_STATE(1311)] = 55604,
  [SMALL_STATE(1312)] = 55617,
  [SMALL_STATE(1313)] = 55630,
  [SMALL_STATE(1314)] = 55643,
  [SMALL_STATE(1315)] = 55656,
  [SMALL_STATE(1316)] = 55669,
  [SMALL_STATE(1317)] = 55682,
  [SMALL_STATE(1318)] = 55695,
  [SMALL_STATE(1319)] = 55704,
  [SMALL_STATE(1320)] = 55717,
  [SMALL_STATE(1321)] = 55730,
  [SMALL_STATE(1322)] = 55743,
  [SMALL_STATE(1323)] = 55752,
  [SMALL_STATE(1324)] = 55765,
  [SMALL_STATE(1325)] = 55776,
  [SMALL_STATE(1326)] = 55789,
  [SMALL_STATE(1327)] = 55802,
  [SMALL_STATE(1328)] = 55815,
  [SMALL_STATE(1329)] = 55828,
  [SMALL_STATE(1330)] = 55841,
  [SMALL_STATE(1331)] = 55854,
  [SMALL_STATE(1332)] = 55867,
  [SMALL_STATE(1333)] = 55878,
  [SMALL_STATE(1334)] = 55887,
  [SMALL_STATE(1335)] = 55900,
  [SMALL_STATE(1336)] = 55911,
  [SMALL_STATE(1337)] = 55924,
  [SMALL_STATE(1338)] = 55937,
  [SMALL_STATE(1339)] = 55950,
  [SMALL_STATE(1340)] = 55961,
  [SMALL_STATE(1341)] = 55970,
  [SMALL_STATE(1342)] = 55978,
  [SMALL_STATE(1343)] = 55986,
  [SMALL_STATE(1344)] = 55994,
  [SMALL_STATE(1345)] = 56004,
  [SMALL_STATE(1346)] = 56012,
  [SMALL_STATE(1347)] = 56020,
  [SMALL_STATE(1348)] = 56028,
  [SMALL_STATE(1349)] = 56036,
  [SMALL_STATE(1350)] = 56044,
  [SMALL_STATE(1351)] = 56052,
  [SMALL_STATE(1352)] = 56060,
  [SMALL_STATE(1353)] = 56068,
  [SMALL_STATE(1354)] = 56078,
  [SMALL_STATE(1355)] = 56088,
  [SMALL_STATE(1356)] = 56096,
  [SMALL_STATE(1357)] = 56106,
  [SMALL_STATE(1358)] = 56116,
  [SMALL_STATE(1359)] = 56126,
  [SMALL_STATE(1360)] = 56136,
  [SMALL_STATE(1361)] = 56146,
  [SMALL_STATE(1362)] = 56154,
  [SMALL_STATE(1363)] = 56162,
  [SMALL_STATE(1364)] = 56172,
  [SMALL_STATE(1365)] = 56180,
  [SMALL_STATE(1366)] = 56190,
  [SMALL_STATE(1367)] = 56200,
  [SMALL_STATE(1368)] = 56208,
  [SMALL_STATE(1369)] = 56218,
  [SMALL_STATE(1370)] = 56226,
  [SMALL_STATE(1371)] = 56236,
  [SMALL_STATE(1372)] = 56246,
  [SMALL_STATE(1373)] = 56256,
  [SMALL_STATE(1374)] = 56264,
  [SMALL_STATE(1375)] = 56272,
  [SMALL_STATE(1376)] = 56282,
  [SMALL_STATE(1377)] = 56292,
  [SMALL_STATE(1378)] = 56302,
  [SMALL_STATE(1379)] = 56312,
  [SMALL_STATE(1380)] = 56320,
  [SMALL_STATE(1381)] = 56328,
  [SMALL_STATE(1382)] = 56338,
  [SMALL_STATE(1383)] = 56346,
  [SMALL_STATE(1384)] = 56354,
  [SMALL_STATE(1385)] = 56362,
  [SMALL_STATE(1386)] = 56370,
  [SMALL_STATE(1387)] = 56378,
  [SMALL_STATE(1388)] = 56388,
  [SMALL_STATE(1389)] = 56396,
  [SMALL_STATE(1390)] = 56404,
  [SMALL_STATE(1391)] = 56414,
  [SMALL_STATE(1392)] = 56422,
  [SMALL_STATE(1393)] = 56432,
  [SMALL_STATE(1394)] = 56440,
  [SMALL_STATE(1395)] = 56448,
  [SMALL_STATE(1396)] = 56456,
  [SMALL_STATE(1397)] = 56466,
  [SMALL_STATE(1398)] = 56474,
  [SMALL_STATE(1399)] = 56482,
  [SMALL_STATE(1400)] = 56490,
  [SMALL_STATE(1401)] = 56498,
  [SMALL_STATE(1402)] = 56508,
  [SMALL_STATE(1403)] = 56516,
  [SMALL_STATE(1404)] = 56524,
  [SMALL_STATE(1405)] = 56534,
  [SMALL_STATE(1406)] = 56541,
  [SMALL_STATE(1407)] = 56548,
  [SMALL_STATE(1408)] = 56555,
  [SMALL_STATE(1409)] = 56562,
  [SMALL_STATE(1410)] = 56569,
  [SMALL_STATE(1411)] = 56576,
  [SMALL_STATE(1412)] = 56583,
  [SMALL_STATE(1413)] = 56590,
  [SMALL_STATE(1414)] = 56597,
  [SMALL_STATE(1415)] = 56604,
  [SMALL_STATE(1416)] = 56611,
  [SMALL_STATE(1417)] = 56618,
  [SMALL_STATE(1418)] = 56625,
  [SMALL_STATE(1419)] = 56632,
  [SMALL_STATE(1420)] = 56639,
  [SMALL_STATE(1421)] = 56646,
  [SMALL_STATE(1422)] = 56653,
  [SMALL_STATE(1423)] = 56660,
  [SMALL_STATE(1424)] = 56667,
  [SMALL_STATE(1425)] = 56674,
  [SMALL_STATE(1426)] = 56681,
  [SMALL_STATE(1427)] = 56688,
  [SMALL_STATE(1428)] = 56695,
  [SMALL_STATE(1429)] = 56702,
  [SMALL_STATE(1430)] = 56709,
  [SMALL_STATE(1431)] = 56716,
  [SMALL_STATE(1432)] = 56723,
  [SMALL_STATE(1433)] = 56730,
  [SMALL_STATE(1434)] = 56737,
  [SMALL_STATE(1435)] = 56744,
  [SMALL_STATE(1436)] = 56751,
  [SMALL_STATE(1437)] = 56758,
  [SMALL_STATE(1438)] = 56765,
  [SMALL_STATE(1439)] = 56772,
  [SMALL_STATE(1440)] = 56779,
  [SMALL_STATE(1441)] = 56786,
  [SMALL_STATE(1442)] = 56793,
  [SMALL_STATE(1443)] = 56800,
  [SMALL_STATE(1444)] = 56807,
  [SMALL_STATE(1445)] = 56814,
  [SMALL_STATE(1446)] = 56821,
  [SMALL_STATE(1447)] = 56828,
  [SMALL_STATE(1448)] = 56835,
  [SMALL_STATE(1449)] = 56842,
  [SMALL_STATE(1450)] = 56849,
  [SMALL_STATE(1451)] = 56856,
  [SMALL_STATE(1452)] = 56863,
  [SMALL_STATE(1453)] = 56870,
  [SMALL_STATE(1454)] = 56877,
  [SMALL_STATE(1455)] = 56884,
  [SMALL_STATE(1456)] = 56891,
  [SMALL_STATE(1457)] = 56898,
  [SMALL_STATE(1458)] = 56905,
  [SMALL_STATE(1459)] = 56912,
  [SMALL_STATE(1460)] = 56919,
  [SMALL_STATE(1461)] = 56926,
  [SMALL_STATE(1462)] = 56933,
  [SMALL_STATE(1463)] = 56940,
  [SMALL_STATE(1464)] = 56947,
  [SMALL_STATE(1465)] = 56954,
  [SMALL_STATE(1466)] = 56961,
  [SMALL_STATE(1467)] = 56968,
  [SMALL_STATE(1468)] = 56975,
  [SMALL_STATE(1469)] = 56982,
  [SMALL_STATE(1470)] = 56989,
  [SMALL_STATE(1471)] = 56996,
  [SMALL_STATE(1472)] = 57003,
  [SMALL_STATE(1473)] = 57010,
  [SMALL_STATE(1474)] = 57017,
  [SMALL_STATE(1475)] = 57024,
  [SMALL_STATE(1476)] = 57031,
  [SMALL_STATE(1477)] = 57038,
  [SMALL_STATE(1478)] = 57045,
  [SMALL_STATE(1479)] = 57052,
  [SMALL_STATE(1480)] = 57059,
  [SMALL_STATE(1481)] = 57066,
  [SMALL_STATE(1482)] = 57073,
  [SMALL_STATE(1483)] = 57080,
  [SMALL_STATE(1484)] = 57087,
  [SMALL_STATE(1485)] = 57094,
  [SMALL_STATE(1486)] = 57101,
  [SMALL_STATE(1487)] = 57108,
  [SMALL_STATE(1488)] = 57115,
  [SMALL_STATE(1489)] = 57122,
  [SMALL_STATE(1490)] = 57129,
  [SMALL_STATE(1491)] = 57136,
  [SMALL_STATE(1492)] = 57143,
  [SMALL_STATE(1493)] = 57150,
  [SMALL_STATE(1494)] = 57157,
  [SMALL_STATE(1495)] = 57164,
  [SMALL_STATE(1496)] = 57171,
  [SMALL_STATE(1497)] = 57178,
  [SMALL_STATE(1498)] = 57185,
  [SMALL_STATE(1499)] = 57192,
  [SMALL_STATE(1500)] = 57199,
  [SMALL_STATE(1501)] = 57206,
  [SMALL_STATE(1502)] = 57213,
  [SMALL_STATE(1503)] = 57220,
  [SMALL_STATE(1504)] = 57227,
  [SMALL_STATE(1505)] = 57234,
  [SMALL_STATE(1506)] = 57241,
  [SMALL_STATE(1507)] = 57248,
  [SMALL_STATE(1508)] = 57255,
  [SMALL_STATE(1509)] = 57262,
  [SMALL_STATE(1510)] = 57269,
  [SMALL_STATE(1511)] = 57276,
  [SMALL_STATE(1512)] = 57283,
  [SMALL_STATE(1513)] = 57290,
  [SMALL_STATE(1514)] = 57297,
  [SMALL_STATE(1515)] = 57304,
  [SMALL_STATE(1516)] = 57311,
  [SMALL_STATE(1517)] = 57318,
  [SMALL_STATE(1518)] = 57325,
  [SMALL_STATE(1519)] = 57332,
  [SMALL_STATE(1520)] = 57339,
  [SMALL_STATE(1521)] = 57346,
  [SMALL_STATE(1522)] = 57353,
  [SMALL_STATE(1523)] = 57360,
  [SMALL_STATE(1524)] = 57367,
};

static const TSParseActionEntry ts_parse_actions[] = {
  [0] = {.entry = {.count = 0, .reusable = false}},
  [1] = {.entry = {.count = 1, .reusable = false}}, RECOVER(),
  [3] = {.entry = {.count = 1, .reusable = true}}, SHIFT_EXTRA(),
  [5] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module, 0),
  [7] = {.entry = {.count = 1, .reusable = false}}, SHIFT(330),
  [9] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1130),
  [11] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1016),
  [13] = {.entry = {.count = 1, .reusable = true}}, SHIFT(164),
  [15] = {.entry = {.count = 1, .reusable = false}}, SHIFT(393),
  [17] = {.entry = {.count = 1, .reusable = false}}, SHIFT(75),
  [19] = {.entry = {.count = 1, .reusable = false}}, SHIFT(394),
  [21] = {.entry = {.count = 1, .reusable = false}}, SHIFT(201),
  [23] = {.entry = {.count = 1, .reusable = false}}, SHIFT(231),
  [25] = {.entry = {.count = 1, .reusable = false}}, SHIFT(181),
  [27] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1345),
  [29] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1346),
  [31] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1349),
  [33] = {.entry = {.count = 1, .reusable = false}}, SHIFT(400),
  [35] = {.entry = {.count = 1, .reusable = false}}, SHIFT(247),
  [37] = {.entry = {.count = 1, .reusable = false}}, SHIFT(602),
  [39] = {.entry = {.count = 1, .reusable = false}}, SHIFT(404),
  [41] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1512),
  [43] = {.entry = {.count = 1, .reusable = false}}, SHIFT(296),
  [45] = {.entry = {.count = 1, .reusable = false}}, SHIFT(71),
  [47] = {.entry = {.count = 1, .reusable = true}}, SHIFT(719),
  [49] = {.entry = {.count = 1, .reusable = true}}, SHIFT(159),
  [51] = {.entry = {.count = 1, .reusable = true}}, SHIFT(166),
  [53] = {.entry = {.count = 1, .reusable = true}}, SHIFT(406),
  [55] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1511),
  [57] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1510),
  [59] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1509),
  [61] = {.entry = {.count = 1, .reusable = false}}, SHIFT(278),
  [63] = {.entry = {.count = 1, .reusable = false}}, SHIFT(284),
  [65] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1508),
  [67] = {.entry = {.count = 1, .reusable = true}}, SHIFT(417),
  [69] = {.entry = {.count = 1, .reusable = false}}, SHIFT(419),
  [71] = {.entry = {.count = 1, .reusable = false}}, SHIFT(890),
  [73] = {.entry = {.count = 1, .reusable = false}}, SHIFT(180),
  [75] = {.entry = {.count = 1, .reusable = true}}, SHIFT(797),
  [77] = {.entry = {.count = 1, .reusable = false}}, SHIFT(797),
  [79] = {.entry = {.count = 1, .reusable = false}}, SHIFT(131),
  [81] = {.entry = {.count = 1, .reusable = true}}, SHIFT(952),
  [83] = {.entry = {.count = 1, .reusable = false}}, SHIFT(424),
  [85] = {.entry = {.count = 1, .reusable = false}}, SHIFT(254),
  [87] = {.entry = {.count = 1, .reusable = false}}, SHIFT(604),
  [89] = {.entry = {.count = 1, .reusable = false}}, SHIFT(423),
  [91] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1495),
  [93] = {.entry = {.count = 1, .reusable = false}}, SHIFT(298),
  [95] = {.entry = {.count = 1, .reusable = false}}, SHIFT(70),
  [97] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1516),
  [99] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1498),
  [101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(370),
  [103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(291),
  [105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(356),
  [107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(281),
  [109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(326),
  [111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(376),
  [113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1265),
  [115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(319),
  [117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(305),
  [119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(354),
  [121] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(330),
  [124] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(1130),
  [127] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(1016),
  [130] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(164),
  [133] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(393),
  [136] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(75),
  [139] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(394),
  [142] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(201),
  [145] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(231),
  [148] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(181),
  [151] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(1345),
  [154] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(1346),
  [157] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(1349),
  [160] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(424),
  [163] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(254),
  [166] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(604),
  [169] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(423),
  [172] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(1495),
  [175] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(298),
  [178] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(70),
  [181] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(719),
  [184] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(159),
  [187] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(166),
  [190] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(406),
  [193] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(1516),
  [196] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(1510),
  [199] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(1509),
  [202] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(278),
  [205] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(284),
  [208] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(1498),
  [211] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(417),
  [214] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(419),
  [217] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(890),
  [220] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(180),
  [223] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(797),
  [226] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(797),
  [229] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(131),
  [232] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_module_repeat1, 2),
  [234] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(952),
  [237] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module, 1),
  [239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(381),
  [241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(359),
  [243] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(400),
  [246] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(247),
  [249] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(602),
  [252] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(404),
  [255] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(1512),
  [258] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(296),
  [261] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(71),
  [264] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(1511),
  [267] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(1508),
  [270] = {.entry = {.count = 1, .reusable = true}}, SHIFT(288),
  [272] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1324),
  [274] = {.entry = {.count = 1, .reusable = false}}, SHIFT(674),
  [276] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_primary_expression, 1, .production_id = 1),
  [278] = {.entry = {.count = 1, .reusable = true}}, SHIFT(188),
  [280] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_pattern, 1, .production_id = 1), REDUCE(sym_primary_expression, 1, .production_id = 1),
  [283] = {.entry = {.count = 1, .reusable = false}}, SHIFT(460),
  [285] = {.entry = {.count = 1, .reusable = false}}, SHIFT(675),
  [287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(385),
  [289] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pattern, 1, .production_id = 1),
  [291] = {.entry = {.count = 1, .reusable = false}}, SHIFT(726),
  [293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(190),
  [295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(169),
  [297] = {.entry = {.count = 1, .reusable = false}}, SHIFT(406),
  [299] = {.entry = {.count = 1, .reusable = false}}, SHIFT(470),
  [301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(726),
  [303] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_primary_expression, 1, .production_id = 1),
  [305] = {.entry = {.count = 1, .reusable = false}}, SHIFT(886),
  [307] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pattern, 1, .production_id = 1),
  [309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(642),
  [311] = {.entry = {.count = 1, .reusable = false}}, SHIFT(642),
  [313] = {.entry = {.count = 1, .reusable = false}}, SHIFT(148),
  [315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(944),
  [317] = {.entry = {.count = 1, .reusable = false}}, SHIFT(334),
  [319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(550),
  [321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(30),
  [323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(432),
  [325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(34),
  [327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(327),
  [329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(32),
  [331] = {.entry = {.count = 1, .reusable = false}}, SHIFT(754),
  [333] = {.entry = {.count = 1, .reusable = false}}, SHIFT(755),
  [335] = {.entry = {.count = 1, .reusable = false}}, SHIFT(453),
  [337] = {.entry = {.count = 1, .reusable = false}}, SHIFT(150),
  [339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(340),
  [341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(50),
  [343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(530),
  [345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14),
  [347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(521),
  [349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(57),
  [351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(548),
  [353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8),
  [355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(325),
  [357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(31),
  [359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(535),
  [361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(24),
  [363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(508),
  [365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15),
  [367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(377),
  [369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22),
  [371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(524),
  [373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(49),
  [375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(316),
  [377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(23),
  [379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(532),
  [381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17),
  [383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(547),
  [385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(28),
  [387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(401),
  [389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16),
  [391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(502),
  [393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3),
  [395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(526),
  [397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(58),
  [399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(527),
  [401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(53),
  [403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(531),
  [405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(52),
  [407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(268),
  [409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11),
  [411] = {.entry = {.count = 1, .reusable = true}}, SHIFT(538),
  [413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19),
  [415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(594),
  [417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(41),
  [419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(965),
  [421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(55),
  [423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(464),
  [425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(39),
  [427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(353),
  [429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2),
  [431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(542),
  [433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(26),
  [435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(331),
  [437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(42),
  [439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(592),
  [441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(38),
  [443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(492),
  [445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13),
  [447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(332),
  [449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(25),
  [451] = {.entry = {.count = 1, .reusable = true}}, SHIFT(544),
  [453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(59),
  [455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(582),
  [457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(37),
  [459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(493),
  [461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18),
  [463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(563),
  [465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(43),
  [467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(580),
  [469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(36),
  [471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(991),
  [473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(54),
  [475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(478),
  [477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21),
  [479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(272),
  [481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(56),
  [483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(490),
  [485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(27),
  [487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(589),
  [489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20),
  [491] = {.entry = {.count = 1, .reusable = true}}, SHIFT(388),
  [493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(51),
  [495] = {.entry = {.count = 1, .reusable = true}}, SHIFT(572),
  [497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(44),
  [499] = {.entry = {.count = 1, .reusable = true}}, SHIFT(485),
  [501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(35),
  [503] = {.entry = {.count = 1, .reusable = true}}, SHIFT(501),
  [505] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10),
  [507] = {.entry = {.count = 1, .reusable = true}}, SHIFT(430),
  [509] = {.entry = {.count = 1, .reusable = true}}, SHIFT(47),
  [511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(497),
  [513] = {.entry = {.count = 1, .reusable = true}}, SHIFT(40),
  [515] = {.entry = {.count = 1, .reusable = true}}, SHIFT(553),
  [517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(33),
  [519] = {.entry = {.count = 1, .reusable = true}}, SHIFT(486),
  [521] = {.entry = {.count = 1, .reusable = true}}, SHIFT(48),
  [523] = {.entry = {.count = 1, .reusable = true}}, SHIFT(571),
  [525] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4),
  [527] = {.entry = {.count = 1, .reusable = true}}, SHIFT(578),
  [529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(29),
  [531] = {.entry = {.count = 1, .reusable = true}}, SHIFT(472),
  [533] = {.entry = {.count = 1, .reusable = true}}, SHIFT(46),
  [535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(317),
  [537] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6),
  [539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(384),
  [541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9),
  [543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(552),
  [545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(45),
  [547] = {.entry = {.count = 1, .reusable = true}}, SHIFT(487),
  [549] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12),
  [551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(558),
  [553] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5),
  [555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(421),
  [557] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7),
  [559] = {.entry = {.count = 1, .reusable = true}}, SHIFT(193),
  [561] = {.entry = {.count = 1, .reusable = false}}, SHIFT(719),
  [563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(191),
  [565] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1, .production_id = 1), REDUCE(sym_list_splat_pattern, 2, .production_id = 8),
  [568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(456),
  [570] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_list_splat_pattern, 2, .production_id = 8),
  [572] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_list_splat_pattern, 2, .production_id = 8),
  [574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(375),
  [576] = {.entry = {.count = 1, .reusable = true}}, SHIFT(378),
  [578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(371),
  [580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(379),
  [582] = {.entry = {.count = 1, .reusable = true}}, SHIFT(367),
  [584] = {.entry = {.count = 1, .reusable = true}}, SHIFT(287),
  [586] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1304),
  [588] = {.entry = {.count = 1, .reusable = true}}, SHIFT(311),
  [590] = {.entry = {.count = 1, .reusable = true}}, SHIFT(315),
  [592] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1217),
  [594] = {.entry = {.count = 1, .reusable = true}}, SHIFT(382),
  [596] = {.entry = {.count = 1, .reusable = true}}, SHIFT(282),
  [598] = {.entry = {.count = 1, .reusable = true}}, SHIFT(374),
  [600] = {.entry = {.count = 1, .reusable = true}}, SHIFT(355),
  [602] = {.entry = {.count = 1, .reusable = false}}, SHIFT(667),
  [604] = {.entry = {.count = 1, .reusable = true}}, SHIFT(204),
  [606] = {.entry = {.count = 1, .reusable = false}}, SHIFT(668),
  [608] = {.entry = {.count = 1, .reusable = true}}, SHIFT(439),
  [610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(709),
  [612] = {.entry = {.count = 1, .reusable = true}}, SHIFT(187),
  [614] = {.entry = {.count = 1, .reusable = false}}, SHIFT(391),
  [616] = {.entry = {.count = 1, .reusable = false}}, SHIFT(885),
  [618] = {.entry = {.count = 1, .reusable = false}}, SHIFT(149),
  [620] = {.entry = {.count = 1, .reusable = false}}, SHIFT(450),
  [622] = {.entry = {.count = 1, .reusable = false}}, SHIFT(798),
  [624] = {.entry = {.count = 1, .reusable = true}}, SHIFT(212),
  [626] = {.entry = {.count = 1, .reusable = false}}, SHIFT(801),
  [628] = {.entry = {.count = 1, .reusable = true}}, SHIFT(443),
  [630] = {.entry = {.count = 1, .reusable = true}}, SHIFT(683),
  [632] = {.entry = {.count = 1, .reusable = true}}, SHIFT(217),
  [634] = {.entry = {.count = 1, .reusable = true}}, SHIFT(170),
  [636] = {.entry = {.count = 1, .reusable = false}}, SHIFT(445),
  [638] = {.entry = {.count = 1, .reusable = false}}, SHIFT(888),
  [640] = {.entry = {.count = 1, .reusable = true}}, SHIFT(811),
  [642] = {.entry = {.count = 1, .reusable = false}}, SHIFT(811),
  [644] = {.entry = {.count = 1, .reusable = false}}, SHIFT(153),
  [646] = {.entry = {.count = 1, .reusable = true}}, SHIFT(934),
  [648] = {.entry = {.count = 1, .reusable = false}}, SHIFT(447),
  [650] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yield, 1),
  [652] = {.entry = {.count = 1, .reusable = false}}, SHIFT(749),
  [654] = {.entry = {.count = 1, .reusable = true}}, SHIFT(163),
  [656] = {.entry = {.count = 1, .reusable = true}}, SHIFT(393),
  [658] = {.entry = {.count = 1, .reusable = false}}, SHIFT(764),
  [660] = {.entry = {.count = 1, .reusable = true}}, SHIFT(161),
  [662] = {.entry = {.count = 1, .reusable = true}}, SHIFT(475),
  [664] = {.entry = {.count = 1, .reusable = false}}, SHIFT(158),
  [666] = {.entry = {.count = 1, .reusable = false}}, SHIFT(152),
  [668] = {.entry = {.count = 1, .reusable = true}}, SHIFT(765),
  [670] = {.entry = {.count = 1, .reusable = true}}, SHIFT(779),
  [672] = {.entry = {.count = 1, .reusable = true}}, SHIFT(768),
  [674] = {.entry = {.count = 1, .reusable = true}}, SHIFT(789),
  [676] = {.entry = {.count = 1, .reusable = true}}, SHIFT(441),
  [678] = {.entry = {.count = 1, .reusable = false}}, SHIFT(770),
  [680] = {.entry = {.count = 1, .reusable = true}}, SHIFT(162),
  [682] = {.entry = {.count = 1, .reusable = false}}, SHIFT(685),
  [684] = {.entry = {.count = 1, .reusable = false}}, SHIFT(748),
  [686] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pattern_list, 2, .production_id = 7),
  [688] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pattern_list, 2, .production_id = 7),
  [690] = {.entry = {.count = 1, .reusable = true}}, SHIFT(160),
  [692] = {.entry = {.count = 1, .reusable = true}}, SHIFT(200),
  [694] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1504),
  [696] = {.entry = {.count = 1, .reusable = true}}, SHIFT(803),
  [698] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression_list, 2, .production_id = 7),
  [700] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression_list, 3, .production_id = 16),
  [702] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1462),
  [704] = {.entry = {.count = 1, .reusable = true}}, SHIFT(619),
  [706] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1469),
  [708] = {.entry = {.count = 1, .reusable = true}}, SHIFT(846),
  [710] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pattern_list, 3, .production_id = 16),
  [712] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pattern_list, 3, .production_id = 16),
  [714] = {.entry = {.count = 1, .reusable = true}}, SHIFT(671),
  [716] = {.entry = {.count = 1, .reusable = true}}, SHIFT(460),
  [718] = {.entry = {.count = 1, .reusable = true}}, SHIFT(211),
  [720] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__collection_elements, 3, .production_id = 50),
  [722] = {.entry = {.count = 1, .reusable = false}}, SHIFT(812),
  [724] = {.entry = {.count = 1, .reusable = true}}, SHIFT(631),
  [726] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1432),
  [728] = {.entry = {.count = 1, .reusable = false}}, SHIFT(837),
  [730] = {.entry = {.count = 1, .reusable = false}}, SHIFT(154),
  [732] = {.entry = {.count = 1, .reusable = false}}, SHIFT(759),
  [734] = {.entry = {.count = 1, .reusable = false}}, SHIFT(760),
  [736] = {.entry = {.count = 1, .reusable = false}}, SHIFT(151),
  [738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(788),
  [740] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1447),
  [742] = {.entry = {.count = 1, .reusable = false}}, SHIFT(425),
  [744] = {.entry = {.count = 1, .reusable = false}}, SHIFT(466),
  [746] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_raise_statement, 1),
  [748] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__collection_elements, 2, .production_id = 24),
  [750] = {.entry = {.count = 1, .reusable = true}}, SHIFT(833),
  [752] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1414),
  [754] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_in_clause, 7, .production_id = 140),
  [756] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_in_clause, 7, .production_id = 140),
  [758] = {.entry = {.count = 1, .reusable = false}}, SHIFT(887),
  [760] = {.entry = {.count = 1, .reusable = true}}, SHIFT(828),
  [762] = {.entry = {.count = 1, .reusable = true}}, SHIFT(725),
  [764] = {.entry = {.count = 1, .reusable = true}}, SHIFT(778),
  [766] = {.entry = {.count = 1, .reusable = true}}, SHIFT(672),
  [768] = {.entry = {.count = 1, .reusable = true}}, SHIFT(787),
  [770] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_in_clause, 6, .production_id = 122),
  [772] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_in_clause, 6, .production_id = 122),
  [774] = {.entry = {.count = 1, .reusable = true}}, SHIFT(786),
  [776] = {.entry = {.count = 1, .reusable = true}}, SHIFT(783),
  [778] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression_list, 3, .production_id = 16),
  [780] = {.entry = {.count = 1, .reusable = false}}, SHIFT(442),
  [782] = {.entry = {.count = 1, .reusable = true}}, SHIFT(469),
  [784] = {.entry = {.count = 1, .reusable = true}}, SHIFT(825),
  [786] = {.entry = {.count = 1, .reusable = true}}, SHIFT(843),
  [788] = {.entry = {.count = 1, .reusable = true}}, SHIFT(841),
  [790] = {.entry = {.count = 1, .reusable = true}}, SHIFT(838),
  [792] = {.entry = {.count = 1, .reusable = true}}, SHIFT(727),
  [794] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_return_statement, 1),
  [796] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_in_clause, 6, .production_id = 121),
  [798] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_in_clause, 6, .production_id = 121),
  [800] = {.entry = {.count = 1, .reusable = true}}, SHIFT(629),
  [802] = {.entry = {.count = 1, .reusable = true}}, SHIFT(615),
  [804] = {.entry = {.count = 1, .reusable = true}}, SHIFT(617),
  [806] = {.entry = {.count = 1, .reusable = true}}, SHIFT(638),
  [808] = {.entry = {.count = 1, .reusable = true}}, SHIFT(639),
  [810] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression_list, 2, .production_id = 7),
  [812] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_in_clause, 5, .production_id = 100),
  [814] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_in_clause, 5, .production_id = 100),
  [816] = {.entry = {.count = 1, .reusable = true}}, SHIFT(805),
  [818] = {.entry = {.count = 1, .reusable = true}}, SHIFT(772),
  [820] = {.entry = {.count = 1, .reusable = true}}, SHIFT(781),
  [822] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subscript, 6, .production_id = 96),
  [824] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_subscript, 6, .production_id = 96),
  [826] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subscript, 4, .production_id = 70),
  [828] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_subscript, 4, .production_id = 70),
  [830] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subscript, 5, .production_id = 96),
  [832] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_subscript, 5, .production_id = 96),
  [834] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subscript, 5, .production_id = 70),
  [836] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_subscript, 5, .production_id = 70),
  [838] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute, 3, .production_id = 40),
  [840] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_attribute, 3, .production_id = 40),
  [842] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_try_statement, 4, .production_id = 56),
  [844] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_try_statement, 4, .production_id = 56),
  [846] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1506),
  [848] = {.entry = {.count = 1, .reusable = false}}, SHIFT(383),
  [850] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1435),
  [852] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1471),
  [854] = {.entry = {.count = 1, .reusable = true}}, SHIFT(416),
  [856] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1468),
  [858] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_try_statement, 5, .production_id = 81),
  [860] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_try_statement, 5, .production_id = 81),
  [862] = {.entry = {.count = 1, .reusable = false}}, SHIFT(335),
  [864] = {.entry = {.count = 1, .reusable = true}}, SHIFT(402),
  [866] = {.entry = {.count = 1, .reusable = true}}, SHIFT(614),
  [868] = {.entry = {.count = 1, .reusable = true}}, SHIFT(823),
  [870] = {.entry = {.count = 1, .reusable = true}}, SHIFT(826),
  [872] = {.entry = {.count = 1, .reusable = true}}, SHIFT(605),
  [874] = {.entry = {.count = 1, .reusable = true}}, SHIFT(283),
  [876] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1514),
  [878] = {.entry = {.count = 1, .reusable = true}}, SHIFT(807),
  [880] = {.entry = {.count = 1, .reusable = true}}, SHIFT(616),
  [882] = {.entry = {.count = 1, .reusable = true}}, SHIFT(824),
  [884] = {.entry = {.count = 1, .reusable = true}}, SHIFT(800),
  [886] = {.entry = {.count = 1, .reusable = true}}, SHIFT(641),
  [888] = {.entry = {.count = 1, .reusable = true}}, SHIFT(808),
  [890] = {.entry = {.count = 1, .reusable = true}}, SHIFT(603),
  [892] = {.entry = {.count = 1, .reusable = true}}, SHIFT(292),
  [894] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1517),
  [896] = {.entry = {.count = 1, .reusable = true}}, SHIFT(264),
  [898] = {.entry = {.count = 1, .reusable = true}}, SHIFT(226),
  [900] = {.entry = {.count = 1, .reusable = true}}, SHIFT(218),
  [902] = {.entry = {.count = 1, .reusable = true}}, SHIFT(845),
  [904] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 6, .production_id = 104),
  [906] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 6, .production_id = 104),
  [908] = {.entry = {.count = 1, .reusable = false}}, SHIFT(412),
  [910] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_slice, 2, .production_id = 69),
  [912] = {.entry = {.count = 1, .reusable = true}}, SHIFT(293),
  [914] = {.entry = {.count = 1, .reusable = true}}, SHIFT(844),
  [916] = {.entry = {.count = 1, .reusable = true}}, SHIFT(834),
  [918] = {.entry = {.count = 1, .reusable = true}}, SHIFT(344),
  [920] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 5, .production_id = 76),
  [922] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 5, .production_id = 76),
  [924] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_slice, 1),
  [926] = {.entry = {.count = 1, .reusable = true}}, SHIFT(306),
  [928] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 5, .production_id = 77),
  [930] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 5, .production_id = 77),
  [932] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_try_statement_repeat1, 2),
  [934] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_try_statement_repeat1, 2),
  [936] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_try_statement_repeat1, 2), SHIFT_REPEAT(335),
  [939] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_try_statement_repeat2, 2),
  [941] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_try_statement_repeat2, 2),
  [943] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_try_statement_repeat2, 2), SHIFT_REPEAT(416),
  [946] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 4, .production_id = 54),
  [948] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 4, .production_id = 54),
  [950] = {.entry = {.count = 1, .reusable = false}}, SHIFT(484),
  [952] = {.entry = {.count = 1, .reusable = true}}, SHIFT(223),
  [954] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_try_statement_repeat2, 2), SHIFT_REPEAT(402),
  [957] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_try_statement_repeat1, 2), SHIFT_REPEAT(383),
  [960] = {.entry = {.count = 1, .reusable = true}}, SHIFT(337),
  [962] = {.entry = {.count = 1, .reusable = true}}, SHIFT(336),
  [964] = {.entry = {.count = 1, .reusable = true}}, SHIFT(950),
  [966] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block, 1),
  [968] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_block, 1),
  [970] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__simple_statements, 4),
  [972] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__simple_statements, 4),
  [974] = {.entry = {.count = 1, .reusable = true}}, SHIFT(173),
  [976] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1336),
  [978] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_if_statement_repeat1, 2, .production_id = 102),
  [980] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_if_statement_repeat1, 2, .production_id = 102),
  [982] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_if_statement_repeat1, 2, .production_id = 102), SHIFT_REPEAT(484),
  [985] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__simple_statements, 3),
  [987] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__simple_statements, 3),
  [989] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_block, 2),
  [991] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block, 2),
  [993] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_slice, 4, .production_id = 95),
  [995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1423),
  [997] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_slice, 3, .production_id = 69),
  [999] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_slice, 3, .production_id = 68),
  [1001] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_print_statement, 3),
  [1003] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_print_statement, 3, .production_id = 10),
  [1005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1487),
  [1007] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_print_statement, 4, .production_id = 29),
  [1009] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_print_statement, 4, .production_id = 28),
  [1011] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_slice, 2),
  [1013] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_if_statement_repeat1, 2, .production_id = 102), SHIFT_REPEAT(412),
  [1016] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__simple_statements, 2),
  [1018] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__simple_statements, 2),
  [1020] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_except_group_clause, 6, .production_id = 155),
  [1022] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_except_group_clause, 6, .production_id = 155),
  [1024] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_except_clause, 4, .production_id = 129),
  [1026] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_except_clause, 4, .production_id = 129),
  [1028] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_except_group_clause, 5, .production_id = 146),
  [1030] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_except_group_clause, 5, .production_id = 146),
  [1032] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_except_clause, 5, .production_id = 146),
  [1034] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_except_clause, 5, .production_id = 146),
  [1036] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_except_clause, 6, .production_id = 155),
  [1038] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_except_clause, 6, .production_id = 155),
  [1040] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_except_clause, 7, .production_id = 160),
  [1042] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_except_clause, 7, .production_id = 160),
  [1044] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_except_group_clause, 7, .production_id = 160),
  [1046] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_except_group_clause, 7, .production_id = 160),
  [1048] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_primary_expression, 1),
  [1050] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_pattern, 1), REDUCE(sym_primary_expression, 1),
  [1053] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_primary_expression, 1),
  [1055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(422),
  [1057] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pattern, 1),
  [1059] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pattern, 1),
  [1061] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_except_group_clause, 4, .production_id = 129),
  [1063] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_except_group_clause, 4, .production_id = 129),
  [1065] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_except_clause, 4, .production_id = 81),
  [1067] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_except_clause, 4, .production_id = 81),
  [1069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(98),
  [1071] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1), REDUCE(sym_list_splat_pattern, 2, .production_id = 9),
  [1074] = {.entry = {.count = 1, .reusable = true}}, SHIFT(476),
  [1076] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_list_splat_pattern, 2, .production_id = 9),
  [1078] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_list_splat_pattern, 2, .production_id = 9),
  [1080] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_except_clause, 3, .production_id = 56),
  [1082] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_except_clause, 3, .production_id = 56),
  [1084] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_cases, 1),
  [1086] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_cases, 1),
  [1088] = {.entry = {.count = 1, .reusable = false}}, SHIFT(852),
  [1090] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_cases_repeat1, 2),
  [1092] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_cases_repeat1, 2),
  [1094] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_cases_repeat1, 2), SHIFT_REPEAT(849),
  [1097] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_cases_repeat1, 2), SHIFT_REPEAT(852),
  [1100] = {.entry = {.count = 1, .reusable = false}}, SHIFT(849),
  [1102] = {.entry = {.count = 1, .reusable = true}}, SHIFT(76),
  [1104] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 8, .production_id = 142),
  [1106] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 8, .production_id = 142),
  [1108] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_elif_clause, 4, .production_id = 54),
  [1110] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_elif_clause, 4, .production_id = 54),
  [1112] = {.entry = {.count = 1, .reusable = false}}, SHIFT(339),
  [1114] = {.entry = {.count = 1, .reusable = false}}, SHIFT(338),
  [1116] = {.entry = {.count = 1, .reusable = false}}, SHIFT(132),
  [1118] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_while_statement, 4, .production_id = 55),
  [1120] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_while_statement, 4, .production_id = 55),
  [1122] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_elif_clause, 5, .production_id = 77),
  [1124] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_elif_clause, 5, .production_id = 77),
  [1126] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_while_statement, 5, .production_id = 80),
  [1128] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_while_statement, 5, .production_id = 80),
  [1130] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_try_statement, 5, .production_id = 56),
  [1132] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_try_statement, 5, .production_id = 56),
  [1134] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_if_statement_repeat1, 1, .production_id = 74),
  [1136] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_if_statement_repeat1, 1, .production_id = 74),
  [1138] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 7, .production_id = 128),
  [1140] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 7, .production_id = 128),
  [1142] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 7, .production_id = 124),
  [1144] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 7, .production_id = 124),
  [1146] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple, 2),
  [1148] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_tuple_pattern, 2), REDUCE(sym_tuple, 2),
  [1151] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple, 2),
  [1153] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_pattern, 2),
  [1155] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple_pattern, 2),
  [1157] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_try_statement, 6, .production_id = 81),
  [1159] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_try_statement, 6, .production_id = 81),
  [1161] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 6, .production_id = 107),
  [1163] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 6, .production_id = 107),
  [1165] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_list, 2),
  [1167] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_list_pattern, 2), REDUCE(sym_list, 2),
  [1170] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_list, 2),
  [1172] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_list_pattern, 2),
  [1174] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_list_pattern, 2),
  [1176] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_else_clause, 3, .production_id = 56),
  [1178] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_else_clause, 3, .production_id = 56),
  [1180] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_case_block, 4, .production_id = 133),
  [1182] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case_block, 4, .production_id = 133),
  [1184] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case_block, 6, .production_id = 156),
  [1186] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_case_block, 6, .production_id = 156),
  [1188] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_else_clause, 4, .production_id = 81),
  [1190] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_else_clause, 4, .production_id = 81),
  [1192] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_case_block, 5, .production_id = 148),
  [1194] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case_block, 5, .production_id = 148),
  [1196] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_case_block, 5, .production_id = 149),
  [1198] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case_block, 5, .production_id = 149),
  [1200] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_definition, 6, .production_id = 116),
  [1202] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_definition, 6, .production_id = 116),
  [1204] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_definition, 7, .production_id = 138),
  [1206] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_definition, 7, .production_id = 138),
  [1208] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decorated_definition, 2, .production_id = 19),
  [1210] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_decorated_definition, 2, .production_id = 19),
  [1212] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_while_statement, 5, .production_id = 79),
  [1214] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_while_statement, 5, .production_id = 79),
  [1216] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_definition, 8, .production_id = 143),
  [1218] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_definition, 8, .production_id = 143),
  [1220] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_definition, 5, .production_id = 86),
  [1222] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_definition, 5, .production_id = 86),
  [1224] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 8, .production_id = 141),
  [1226] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 8, .production_id = 141),
  [1228] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_definition, 10, .production_id = 159),
  [1230] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_definition, 10, .production_id = 159),
  [1232] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_definition, 9, .production_id = 158),
  [1234] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_definition, 9, .production_id = 158),
  [1236] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_definition, 9, .production_id = 154),
  [1238] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_definition, 9, .production_id = 154),
  [1240] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_definition, 9, .production_id = 153),
  [1242] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_definition, 9, .production_id = 153),
  [1244] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 9, .production_id = 152),
  [1246] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 9, .production_id = 152),
  [1248] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 8, .production_id = 145),
  [1250] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 8, .production_id = 145),
  [1252] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_statement, 5, .production_id = 82),
  [1254] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_with_statement, 5, .production_id = 82),
  [1256] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_with_statement, 6, .production_id = 105),
  [1258] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_statement, 6, .production_id = 105),
  [1260] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_try_statement, 6, .production_id = 56),
  [1262] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_try_statement, 6, .production_id = 56),
  [1264] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_while_statement, 6, .production_id = 108),
  [1266] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_while_statement, 6, .production_id = 108),
  [1268] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_finally_clause, 3, .production_id = 56),
  [1270] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_finally_clause, 3, .production_id = 56),
  [1272] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 6, .production_id = 103),
  [1274] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 6, .production_id = 103),
  [1276] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_statement, 5, .production_id = 78),
  [1278] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_with_statement, 5, .production_id = 78),
  [1280] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_definition, 5, .production_id = 89),
  [1282] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_definition, 5, .production_id = 89),
  [1284] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_definition, 7, .production_id = 137),
  [1286] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_definition, 7, .production_id = 137),
  [1288] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 5, .production_id = 75),
  [1290] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 5, .production_id = 75),
  [1292] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_definition, 8, .production_id = 151),
  [1294] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_definition, 8, .production_id = 151),
  [1296] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_definition, 5, .production_id = 90),
  [1298] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_definition, 5, .production_id = 90),
  [1300] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_definition, 7, .production_id = 136),
  [1302] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_definition, 7, .production_id = 136),
  [1304] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_definition, 8, .production_id = 144),
  [1306] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_definition, 8, .production_id = 144),
  [1308] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_definition, 8, .production_id = 150),
  [1310] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_definition, 8, .production_id = 150),
  [1312] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_statement, 4, .production_id = 57),
  [1314] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_with_statement, 4, .production_id = 57),
  [1316] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_match_statement, 4, .production_id = 59),
  [1318] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_match_statement, 4, .production_id = 59),
  [1320] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_match_statement, 4, .production_id = 60),
  [1322] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_match_statement, 4, .production_id = 60),
  [1324] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_definition, 4, .production_id = 64),
  [1326] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_definition, 4, .production_id = 64),
  [1328] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_definition, 5, .production_id = 88),
  [1330] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_definition, 5, .production_id = 88),
  [1332] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_definition, 6, .production_id = 106),
  [1334] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_definition, 6, .production_id = 106),
  [1336] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_try_statement, 7, .production_id = 81),
  [1338] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_try_statement, 7, .production_id = 81),
  [1340] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_finally_clause, 4, .production_id = 81),
  [1342] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_finally_clause, 4, .production_id = 81),
  [1344] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 7, .production_id = 127),
  [1346] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 7, .production_id = 127),
  [1348] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 6, .production_id = 101),
  [1350] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 6, .production_id = 101),
  [1352] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_definition, 7, .production_id = 126),
  [1354] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_definition, 7, .production_id = 126),
  [1356] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_definition, 7, .production_id = 125),
  [1358] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_definition, 7, .production_id = 125),
  [1360] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 7, .production_id = 123),
  [1362] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 7, .production_id = 123),
  [1364] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_definition, 6, .production_id = 117),
  [1366] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_definition, 6, .production_id = 117),
  [1368] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_definition, 6, .production_id = 115),
  [1370] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_definition, 6, .production_id = 115),
  [1372] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_definition, 6, .production_id = 114),
  [1374] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_definition, 6, .production_id = 114),
  [1376] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_definition, 6, .production_id = 113),
  [1378] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_definition, 6, .production_id = 113),
  [1380] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__patterns, 3, .production_id = 50),
  [1382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(685),
  [1384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1207),
  [1386] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__patterns, 2, .production_id = 24),
  [1388] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_concatenated_string, 2),
  [1390] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_concatenated_string, 2),
  [1392] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_concatenated_string_repeat1, 2),
  [1394] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_concatenated_string_repeat1, 2),
  [1396] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_concatenated_string_repeat1, 2), SHIFT_REPEAT(944),
  [1399] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string, 3, .production_id = 20),
  [1401] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string, 3, .production_id = 20),
  [1403] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string, 2, .production_id = 2),
  [1405] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string, 2, .production_id = 2),
  [1407] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_list_comprehension, 4, .production_id = 51),
  [1409] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_list_comprehension, 4, .production_id = 51),
  [1411] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_set_comprehension, 4, .production_id = 51),
  [1413] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_set_comprehension, 4, .production_id = 51),
  [1415] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_list, 4, .production_id = 61),
  [1417] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_argument_list, 4, .production_id = 61),
  [1419] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dictionary, 5, .production_id = 61),
  [1421] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_dictionary, 5, .production_id = 61),
  [1423] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_list, 5, .production_id = 61),
  [1425] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_argument_list, 5, .production_id = 61),
  [1427] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_list, 5, .production_id = 92),
  [1429] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_argument_list, 5, .production_id = 92),
  [1431] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dictionary, 2),
  [1433] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_dictionary, 2),
  [1435] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_list, 3, .production_id = 67),
  [1437] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_argument_list, 3, .production_id = 67),
  [1439] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_list, 3, .production_id = 31),
  [1441] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_argument_list, 3, .production_id = 31),
  [1443] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_list, 3),
  [1445] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_argument_list, 3),
  [1447] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_set, 3, .production_id = 25),
  [1449] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_set, 3, .production_id = 25),
  [1451] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dictionary, 3, .production_id = 31),
  [1453] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_dictionary, 3, .production_id = 31),
  [1455] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dictionary, 3),
  [1457] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_dictionary, 3),
  [1459] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_list, 3, .production_id = 25),
  [1461] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_list, 3, .production_id = 25),
  [1463] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple, 3, .production_id = 25),
  [1465] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple, 3, .production_id = 25),
  [1467] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_expression, 3, .production_id = 26),
  [1469] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_expression, 3, .production_id = 26),
  [1471] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_list, 4, .production_id = 31),
  [1473] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_argument_list, 4, .production_id = 31),
  [1475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1449),
  [1477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(177),
  [1479] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression, 1),
  [1481] = {.entry = {.count = 1, .reusable = false}}, SHIFT(716),
  [1483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(707),
  [1485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(696),
  [1487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(695),
  [1489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(692),
  [1491] = {.entry = {.count = 1, .reusable = true}}, SHIFT(310),
  [1493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(690),
  [1495] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression, 1),
  [1497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(716),
  [1499] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1436),
  [1501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(687),
  [1503] = {.entry = {.count = 1, .reusable = true}}, SHIFT(686),
  [1505] = {.entry = {.count = 1, .reusable = false}}, SHIFT(696),
  [1507] = {.entry = {.count = 1, .reusable = true}}, SHIFT(673),
  [1509] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_list, 2),
  [1511] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_argument_list, 2),
  [1513] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_call, 2, .production_id = 17),
  [1515] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_call, 2, .production_id = 17),
  [1517] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dictionary, 4, .production_id = 61),
  [1519] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_dictionary, 4, .production_id = 61),
  [1521] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dictionary_comprehension, 4, .production_id = 51),
  [1523] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_dictionary_comprehension, 4, .production_id = 51),
  [1525] = {.entry = {.count = 1, .reusable = false}}, SHIFT(762),
  [1527] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_keyword_separator, 1),
  [1529] = {.entry = {.count = 1, .reusable = false}}, SHIFT(767),
  [1531] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generator_expression, 4, .production_id = 51),
  [1533] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generator_expression, 4, .production_id = 51),
  [1535] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_list, 4, .production_id = 67),
  [1537] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_argument_list, 4, .production_id = 67),
  [1539] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dictionary, 4, .production_id = 31),
  [1541] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_dictionary, 4, .production_id = 31),
  [1543] = {.entry = {.count = 1, .reusable = false}}, SHIFT(693),
  [1545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(698),
  [1547] = {.entry = {.count = 1, .reusable = true}}, SHIFT(702),
  [1549] = {.entry = {.count = 1, .reusable = true}}, SHIFT(703),
  [1551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(704),
  [1553] = {.entry = {.count = 1, .reusable = true}}, SHIFT(705),
  [1555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(693),
  [1557] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1446),
  [1559] = {.entry = {.count = 1, .reusable = true}}, SHIFT(710),
  [1561] = {.entry = {.count = 1, .reusable = true}}, SHIFT(711),
  [1563] = {.entry = {.count = 1, .reusable = false}}, SHIFT(702),
  [1565] = {.entry = {.count = 1, .reusable = true}}, SHIFT(676),
  [1567] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_list, 4, .production_id = 92),
  [1569] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_argument_list, 4, .production_id = 92),
  [1571] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_binary_operator, 3, .production_id = 39),
  [1573] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_binary_operator, 3, .production_id = 39),
  [1575] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unary_operator, 2, .production_id = 13),
  [1577] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_unary_operator, 2, .production_id = 13),
  [1579] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_comparison_operator_repeat1, 2, .production_id = 41),
  [1581] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_comparison_operator_repeat1, 2, .production_id = 41),
  [1583] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_comparison_operator_repeat1, 3, .production_id = 71),
  [1585] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_comparison_operator_repeat1, 3, .production_id = 71),
  [1587] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_comparison_operator_repeat1, 3, .production_id = 72),
  [1589] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_comparison_operator_repeat1, 3, .production_id = 72),
  [1591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(452),
  [1593] = {.entry = {.count = 1, .reusable = false}}, SHIFT(794),
  [1595] = {.entry = {.count = 1, .reusable = false}}, SHIFT(694),
  [1597] = {.entry = {.count = 1, .reusable = false}}, SHIFT(832),
  [1599] = {.entry = {.count = 1, .reusable = false}}, SHIFT(691),
  [1601] = {.entry = {.count = 1, .reusable = false}}, SHIFT(618),
  [1603] = {.entry = {.count = 1, .reusable = false}}, SHIFT(679),
  [1605] = {.entry = {.count = 1, .reusable = false}}, SHIFT(712),
  [1607] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_concatenated_string_repeat1, 2), SHIFT_REPEAT(934),
  [1610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1500),
  [1612] = {.entry = {.count = 1, .reusable = true}}, SHIFT(179),
  [1614] = {.entry = {.count = 1, .reusable = false}}, SHIFT(730),
  [1616] = {.entry = {.count = 1, .reusable = true}}, SHIFT(723),
  [1618] = {.entry = {.count = 1, .reusable = true}}, SHIFT(722),
  [1620] = {.entry = {.count = 1, .reusable = true}}, SHIFT(721),
  [1622] = {.entry = {.count = 1, .reusable = true}}, SHIFT(717),
  [1624] = {.entry = {.count = 1, .reusable = true}}, SHIFT(301),
  [1626] = {.entry = {.count = 1, .reusable = true}}, SHIFT(714),
  [1628] = {.entry = {.count = 1, .reusable = true}}, SHIFT(730),
  [1630] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1494),
  [1632] = {.entry = {.count = 1, .reusable = true}}, SHIFT(706),
  [1634] = {.entry = {.count = 1, .reusable = true}}, SHIFT(700),
  [1636] = {.entry = {.count = 1, .reusable = false}}, SHIFT(722),
  [1638] = {.entry = {.count = 1, .reusable = true}}, SHIFT(669),
  [1640] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_concatenated_string_repeat1, 2), SHIFT_REPEAT(952),
  [1643] = {.entry = {.count = 1, .reusable = false}}, SHIFT(879),
  [1645] = {.entry = {.count = 1, .reusable = false}}, SHIFT(880),
  [1647] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1448),
  [1649] = {.entry = {.count = 1, .reusable = true}}, SHIFT(184),
  [1651] = {.entry = {.count = 1, .reusable = false}}, SHIFT(729),
  [1653] = {.entry = {.count = 1, .reusable = true}}, SHIFT(728),
  [1655] = {.entry = {.count = 1, .reusable = true}}, SHIFT(680),
  [1657] = {.entry = {.count = 1, .reusable = true}}, SHIFT(697),
  [1659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(681),
  [1661] = {.entry = {.count = 1, .reusable = true}}, SHIFT(299),
  [1663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(699),
  [1665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(729),
  [1667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1430),
  [1669] = {.entry = {.count = 1, .reusable = true}}, SHIFT(708),
  [1671] = {.entry = {.count = 1, .reusable = true}}, SHIFT(682),
  [1673] = {.entry = {.count = 1, .reusable = false}}, SHIFT(680),
  [1675] = {.entry = {.count = 1, .reusable = true}}, SHIFT(670),
  [1677] = {.entry = {.count = 1, .reusable = false}}, SHIFT(451),
  [1679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(392),
  [1681] = {.entry = {.count = 1, .reusable = false}}, SHIFT(925),
  [1683] = {.entry = {.count = 1, .reusable = true}}, SHIFT(853),
  [1685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1259),
  [1687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1390),
  [1689] = {.entry = {.count = 1, .reusable = false}}, SHIFT(971),
  [1691] = {.entry = {.count = 1, .reusable = true}}, SHIFT(856),
  [1693] = {.entry = {.count = 1, .reusable = true}}, SHIFT(892),
  [1695] = {.entry = {.count = 1, .reusable = false}}, SHIFT(943),
  [1697] = {.entry = {.count = 1, .reusable = true}}, SHIFT(943),
  [1699] = {.entry = {.count = 1, .reusable = false}}, SHIFT(975),
  [1701] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_open_sequence_match_pattern, 2),
  [1703] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_open_sequence_match_pattern, 2),
  [1705] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_open_sequence_match_pattern, 3),
  [1707] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_open_sequence_match_pattern, 3),
  [1709] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1006),
  [1711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1011),
  [1713] = {.entry = {.count = 1, .reusable = true}}, SHIFT(987),
  [1715] = {.entry = {.count = 1, .reusable = false}}, SHIFT(999),
  [1717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(998),
  [1719] = {.entry = {.count = 1, .reusable = true}}, SHIFT(981),
  [1721] = {.entry = {.count = 1, .reusable = true}}, SHIFT(970),
  [1723] = {.entry = {.count = 1, .reusable = false}}, SHIFT(984),
  [1725] = {.entry = {.count = 1, .reusable = false}}, SHIFT(957),
  [1727] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_comparison_operator_repeat1, 2, .production_id = 42),
  [1729] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_comparison_operator_repeat1, 2, .production_id = 42),
  [1731] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_comparison_operator_repeat1, 2, .production_id = 42), SHIFT_REPEAT(702),
  [1734] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_comparison_operator_repeat1, 2, .production_id = 42), SHIFT_REPEAT(1446),
  [1737] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_comparison_operator_repeat1, 2, .production_id = 42), SHIFT_REPEAT(702),
  [1740] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_comparison_operator_repeat1, 2, .production_id = 42), SHIFT_REPEAT(676),
  [1743] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_comparison_operator_repeat1, 2, .production_id = 42), SHIFT_REPEAT(696),
  [1746] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_comparison_operator_repeat1, 2, .production_id = 42), SHIFT_REPEAT(1436),
  [1749] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_comparison_operator_repeat1, 2, .production_id = 42), SHIFT_REPEAT(696),
  [1752] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_comparison_operator_repeat1, 2, .production_id = 42), SHIFT_REPEAT(673),
  [1755] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_comparison_operator, 2, .production_id = 18),
  [1757] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_comparison_operator, 2, .production_id = 18),
  [1759] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__patterns_repeat1, 2, .production_id = 36),
  [1761] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__patterns_repeat1, 2, .production_id = 36), SHIFT_REPEAT(607),
  [1764] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_pattern, 3, .production_id = 25),
  [1766] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_list_pattern, 3, .production_id = 25),
  [1768] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__patterns_repeat1, 2, .production_id = 31),
  [1770] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_comparison_operator_repeat1, 2, .production_id = 42), SHIFT_REPEAT(722),
  [1773] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_comparison_operator_repeat1, 2, .production_id = 42), SHIFT_REPEAT(1494),
  [1776] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_comparison_operator_repeat1, 2, .production_id = 42), SHIFT_REPEAT(722),
  [1779] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_comparison_operator_repeat1, 2, .production_id = 42), SHIFT_REPEAT(669),
  [1782] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dictionary_splat_pattern, 2, .production_id = 34),
  [1784] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dictionary_splat_pattern, 2, .production_id = 33),
  [1786] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_comparison_operator_repeat1, 2, .production_id = 42), SHIFT_REPEAT(680),
  [1789] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_comparison_operator_repeat1, 2, .production_id = 42), SHIFT_REPEAT(1430),
  [1792] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_comparison_operator_repeat1, 2, .production_id = 42), SHIFT_REPEAT(680),
  [1795] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_comparison_operator_repeat1, 2, .production_id = 42), SHIFT_REPEAT(670),
  [1798] = {.entry = {.count = 1, .reusable = true}}, SHIFT(172),
  [1800] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pattern_list, 2, .production_id = 16),
  [1802] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1339),
  [1804] = {.entry = {.count = 1, .reusable = true}}, SHIFT(596),
  [1806] = {.entry = {.count = 1, .reusable = false}}, SHIFT(636),
  [1808] = {.entry = {.count = 1, .reusable = true}}, SHIFT(444),
  [1810] = {.entry = {.count = 1, .reusable = true}}, SHIFT(715),
  [1812] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1340),
  [1814] = {.entry = {.count = 1, .reusable = true}}, SHIFT(463),
  [1816] = {.entry = {.count = 1, .reusable = true}}, SHIFT(309),
  [1818] = {.entry = {.count = 1, .reusable = true}}, SHIFT(458),
  [1820] = {.entry = {.count = 1, .reusable = true}}, SHIFT(165),
  [1822] = {.entry = {.count = 1, .reusable = true}}, SHIFT(348),
  [1824] = {.entry = {.count = 1, .reusable = true}}, SHIFT(156),
  [1826] = {.entry = {.count = 1, .reusable = true}}, SHIFT(157),
  [1828] = {.entry = {.count = 1, .reusable = true}}, SHIFT(481),
  [1830] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1365),
  [1832] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1008),
  [1834] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1357),
  [1836] = {.entry = {.count = 1, .reusable = true}}, SHIFT(993),
  [1838] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1177),
  [1840] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1380),
  [1842] = {.entry = {.count = 1, .reusable = true}}, SHIFT(986),
  [1844] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameters, 2),
  [1846] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameters, 3),
  [1848] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_await, 2),
  [1850] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_await, 2),
  [1852] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_not_operator, 2, .production_id = 10),
  [1854] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_not_operator, 2, .production_id = 10),
  [1856] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_match_value_pattern_repeat1, 2),
  [1858] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_match_value_pattern_repeat1, 2), SHIFT_REPEAT(1445),
  [1861] = {.entry = {.count = 1, .reusable = true}}, SHIFT(182),
  [1863] = {.entry = {.count = 1, .reusable = true}}, SHIFT(386),
  [1865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(473),
  [1867] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1416),
  [1869] = {.entry = {.count = 1, .reusable = true}}, SHIFT(601),
  [1871] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__collection_elements, 1, .production_id = 7),
  [1873] = {.entry = {.count = 1, .reusable = true}}, SHIFT(455),
  [1875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(457),
  [1877] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda, 4, .production_id = 66),
  [1879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(429),
  [1881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(446),
  [1883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(409),
  [1885] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_conditional_expression, 5),
  [1887] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_conditional_expression, 5),
  [1889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1445),
  [1891] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pattern_class_name, 2),
  [1893] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_match_value_pattern, 2),
  [1895] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda, 3, .production_id = 32),
  [1897] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lambda, 3, .production_id = 32),
  [1899] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_match_literal_pattern, 1),
  [1901] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_named_expression, 3, .production_id = 35),
  [1903] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_named_expression, 3, .production_id = 35),
  [1905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(842),
  [1907] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_item, 1, .dynamic_precedence = -1, .production_id = 12), SHIFT(182),
  [1910] = {.entry = {.count = 1, .reusable = false}}, SHIFT(608),
  [1912] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_boolean_operator, 3, .production_id = 39),
  [1914] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_boolean_operator, 3, .production_id = 39),
  [1916] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lambda, 4, .production_id = 66),
  [1918] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pattern_class_name, 1),
  [1920] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_match_capture_pattern, 1),
  [1922] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_named_expression, 3, .production_id = 27),
  [1924] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_named_expression, 3, .production_id = 27),
  [1926] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yield, 2),
  [1928] = {.entry = {.count = 1, .reusable = true}}, SHIFT(167),
  [1930] = {.entry = {.count = 1, .reusable = true}}, SHIFT(628),
  [1932] = {.entry = {.count = 1, .reusable = true}}, SHIFT(785),
  [1934] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_expression_list_repeat1, 2, .production_id = 31),
  [1936] = {.entry = {.count = 1, .reusable = false}}, SHIFT(178),
  [1938] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1031),
  [1940] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1031),
  [1942] = {.entry = {.count = 1, .reusable = false}}, SHIFT_EXTRA(),
  [1944] = {.entry = {.count = 1, .reusable = true}}, SHIFT(744),
  [1946] = {.entry = {.count = 1, .reusable = true}}, SHIFT(736),
  [1948] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_string_repeat1, 2, .production_id = 21), SHIFT_REPEAT(178),
  [1951] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_string_repeat1, 2, .production_id = 21), SHIFT_REPEAT(1031),
  [1954] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_string_repeat1, 2, .production_id = 21), SHIFT_REPEAT(1031),
  [1957] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_string_repeat1, 2, .production_id = 21),
  [1959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(758),
  [1961] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yield, 3),
  [1963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(799),
  [1965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(216),
  [1967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(609),
  [1969] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_match_literal_pattern, 1, .production_id = 83),
  [1971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1381),
  [1973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(610),
  [1975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(820),
  [1977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(196),
  [1979] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dictionary_splat, 2, .production_id = 14),
  [1981] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_list_splat, 2),
  [1983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1291),
  [1985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1318),
  [1987] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_match_literal_pattern, 2, .production_id = 109),
  [1989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1387),
  [1991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(769),
  [1993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(621),
  [1995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(203),
  [1997] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_match_or_pattern_repeat1, 2),
  [1999] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_match_or_pattern_repeat1, 2), SHIFT_REPEAT(866),
  [2002] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__comprehension_clauses_repeat1, 2),
  [2004] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__comprehension_clauses_repeat1, 2), SHIFT_REPEAT(390),
  [2007] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__comprehension_clauses_repeat1, 2), SHIFT_REPEAT(1416),
  [2010] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__comprehension_clauses_repeat1, 2), SHIFT_REPEAT(601),
  [2013] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__comprehension_clauses, 1),
  [2015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(390),
  [2017] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_match_or_pattern, 3),
  [2019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(866),
  [2021] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__expression_within_for_in_clause, 1),
  [2023] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__comprehension_clauses, 2),
  [2025] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__f_expression, 1),
  [2027] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_match_or_pattern, 4),
  [2029] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression_list, 2, .production_id = 16),
  [2031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(171),
  [2033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1468),
  [2035] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_match_class_pattern, 8, .production_id = 135),
  [2037] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_match_class_pattern, 7, .production_id = 135),
  [2039] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_match_mapping_pattern, 7),
  [2041] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_match_class_pattern, 6, .production_id = 135),
  [2043] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__match_or_pattern, 1),
  [2045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(867),
  [2047] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_match_mapping_pattern, 6),
  [2049] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_match_sequence_pattern, 3),
  [2051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(411),
  [2053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(410),
  [2055] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_match_group_pattern, 3, .production_id = 130),
  [2057] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_in_clause, 5, .production_id = 122),
  [2059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(192),
  [2061] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_in_clause, 5, .production_id = 121),
  [2063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(202),
  [2065] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_match_class_pattern, 5, .production_id = 135),
  [2067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(477),
  [2069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(210),
  [2071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(415),
  [2073] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_raise_statement, 2),
  [2075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(168),
  [2077] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_match_mapping_pattern, 5),
  [2079] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_match_sequence_pattern, 5),
  [2081] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_match_mapping_pattern, 3),
  [2083] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_match_class_pattern, 9, .production_id = 135),
  [2085] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_match_literal_pattern, 3, .production_id = 131),
  [2087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1435),
  [2089] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_match_mapping_pattern, 2),
  [2091] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_clause, 2),
  [2093] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_in_clause, 6, .production_id = 140),
  [2095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(185),
  [2097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1520),
  [2099] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1516),
  [2101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1498),
  [2103] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_match_class_pattern, 3, .production_id = 135),
  [2105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(865),
  [2107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1488),
  [2109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1511),
  [2111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1508),
  [2113] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_match_class_pattern, 4, .production_id = 135),
  [2115] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_expression_list_repeat1, 2, .production_id = 36),
  [2117] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_expression_list_repeat1, 2, .production_id = 36), SHIFT_REPEAT(245),
  [2120] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_match_sequence_pattern, 2),
  [2122] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_match_mapping_pattern, 4),
  [2124] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_match_literal_pattern, 4, .production_id = 147),
  [2126] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_match_sequence_pattern, 4),
  [2128] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_for_in_clause_repeat1, 2),
  [2130] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_for_in_clause_repeat1, 2), SHIFT_REPEAT(280),
  [2133] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_in_clause, 4, .production_id = 100),
  [2135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(213),
  [2137] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1061),
  [2139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1144),
  [2141] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1444),
  [2143] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_within_for_in_clause, 3, .production_id = 32),
  [2145] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression_statement, 1),
  [2147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1139),
  [2149] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1456),
  [2151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1457),
  [2153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(262),
  [2155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(259),
  [2157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(352),
  [2159] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type, 1),
  [2161] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__match_pattern, 1),
  [2163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1440),
  [2165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(395),
  [2167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(396),
  [2169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(480),
  [2171] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exec_statement, 4, .production_id = 15),
  [2173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(426),
  [2175] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string_content, 1),
  [2177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1055),
  [2179] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1055),
  [2181] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string_content, 1),
  [2183] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_within_for_in_clause, 4, .production_id = 66),
  [2185] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__right_hand_side, 1),
  [2187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(252),
  [2189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(624),
  [2191] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pair, 3, .production_id = 62),
  [2193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(269),
  [2195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(219),
  [2197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(300),
  [2199] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_print_statement, 2, .production_id = 10),
  [2201] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assert_statement, 2),
  [2203] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_return_statement, 2),
  [2205] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_delete_statement, 2, .production_id = 11),
  [2207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(261),
  [2209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(822),
  [2211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(246),
  [2213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(815),
  [2215] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_item, 1, .dynamic_precedence = -1, .production_id = 12),
  [2217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(608),
  [2219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(251),
  [2221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(774),
  [2223] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__collection_elements_repeat1, 2, .production_id = 31),
  [2225] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_string_content_repeat1, 2),
  [2227] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_string_content_repeat1, 2), SHIFT_REPEAT(1055),
  [2230] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_string_content_repeat1, 2), SHIFT_REPEAT(1055),
  [2233] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_string_content_repeat1, 2),
  [2235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1088),
  [2237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1193),
  [2239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1400),
  [2241] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_match_value_pattern_repeat1, 2), SHIFT_REPEAT(1477),
  [2244] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dotted_name, 2),
  [2246] = {.entry = {.count = 1, .reusable = true}}, SHIFT(124),
  [2248] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interpolation, 3, .production_id = 43),
  [2250] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interpolation, 3, .production_id = 43),
  [2252] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dotted_name, 1),
  [2254] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_decorated_definition_repeat1, 2),
  [2256] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_decorated_definition_repeat1, 2), SHIFT_REPEAT(417),
  [2259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(399),
  [2261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(125),
  [2263] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_slice, 3, .production_id = 95),
  [2265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(289),
  [2267] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_assert_statement_repeat1, 2),
  [2269] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_print_statement_repeat1, 2, .production_id = 10),
  [2271] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interpolation, 4, .production_id = 43),
  [2273] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interpolation, 4, .production_id = 43),
  [2275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1477),
  [2277] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interpolation, 5, .production_id = 43),
  [2279] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interpolation, 5, .production_id = 43),
  [2281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(73),
  [2283] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_string_repeat1, 1, .production_id = 3),
  [2285] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_string_repeat1, 1, .production_id = 3),
  [2287] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_default_parameter, 3, .production_id = 35),
  [2289] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interpolation, 6, .production_id = 43),
  [2291] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interpolation, 6, .production_id = 43),
  [2293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(97),
  [2295] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_string_repeat1, 1, .production_id = 4),
  [2297] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_string_repeat1, 1, .production_id = 4),
  [2299] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_open_sequence_match_pattern_repeat1, 2),
  [2301] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_open_sequence_match_pattern_repeat1, 2), SHIFT_REPEAT(859),
  [2304] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_chevron, 2),
  [2306] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1184),
  [2308] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1180),
  [2310] = {.entry = {.count = 1, .reusable = true}}, SHIFT(471),
  [2312] = {.entry = {.count = 1, .reusable = true}}, SHIFT(103),
  [2314] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_slice, 2, .production_id = 68),
  [2316] = {.entry = {.count = 1, .reusable = true}}, SHIFT(294),
  [2318] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_typed_default_parameter, 5, .production_id = 118),
  [2320] = {.entry = {.count = 1, .reusable = true}}, SHIFT(118),
  [2322] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_subscript_repeat1, 2, .production_id = 94),
  [2324] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_match_as_pattern, 3, .production_id = 134),
  [2326] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_slice, 4, .production_id = 120),
  [2328] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_slice, 4, .production_id = 119),
  [2330] = {.entry = {.count = 1, .reusable = true}}, SHIFT(205),
  [2332] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__import_list, 3, .production_id = 22),
  [2334] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_expression_list_repeat1, 2, .production_id = 36), SHIFT_REPEAT(244),
  [2337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1125),
  [2339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1253),
  [2341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1181),
  [2343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1260),
  [2345] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_bound, 2, .production_id = 110),
  [2347] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_format_specifier, 2),
  [2349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(183),
  [2351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1117),
  [2353] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_slice, 5, .production_id = 139),
  [2355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(468),
  [2357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(100),
  [2359] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_raise_statement, 3, .production_id = 30),
  [2361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(176),
  [2363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(104),
  [2365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1037),
  [2367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(123),
  [2369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1118),
  [2371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1450),
  [2373] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__import_list, 1, .production_id = 6),
  [2375] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_match_star_pattern, 2, .production_id = 11),
  [2377] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__collection_elements, 2, .production_id = 16),
  [2379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(175),
  [2381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(195),
  [2383] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_alias_statement, 4, .production_id = 63),
  [2385] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__collection_elements_repeat1, 2, .production_id = 36),
  [2387] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__collection_elements_repeat1, 2, .production_id = 36), SHIFT_REPEAT(230),
  [2390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(174),
  [2392] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1188),
  [2394] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_format_specifier_repeat1, 2),
  [2396] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_format_specifier_repeat1, 2), SHIFT_REPEAT(183),
  [2399] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_format_specifier_repeat1, 2), SHIFT_REPEAT(1117),
  [2402] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__import_list, 2, .production_id = 6),
  [2404] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_slice, 3, .production_id = 93),
  [2406] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1060),
  [2408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1173),
  [2410] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1278),
  [2412] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_alias_statement, 5, .production_id = 87),
  [2414] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_raise_statement, 4, .production_id = 53),
  [2416] = {.entry = {.count = 1, .reusable = true}}, SHIFT(398),
  [2418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(126),
  [2420] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_argument_list_repeat1, 2, .production_id = 31),
  [2422] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_format_specifier, 1),
  [2424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1099),
  [2426] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_keyword_argument, 3, .production_id = 27),
  [2428] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_keyword_argument, 3, .production_id = 35),
  [2430] = {.entry = {.count = 1, .reusable = true}}, SHIFT(893),
  [2432] = {.entry = {.count = 1, .reusable = true}}, SHIFT(852),
  [2434] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_typed_parameter, 3, .production_id = 65),
  [2436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(479),
  [2438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(85),
  [2440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(83),
  [2442] = {.entry = {.count = 1, .reusable = true}}, SHIFT(130),
  [2444] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exec_statement, 5, .production_id = 15),
  [2446] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_global_statement_repeat1, 2), SHIFT_REPEAT(1490),
  [2449] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_global_statement_repeat1, 2),
  [2451] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_typevar_parameter, 1, .production_id = 6),
  [2453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(434),
  [2455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(110),
  [2457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(111),
  [2459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1061),
  [2461] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_prefix, 1),
  [2463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1165),
  [2465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(474),
  [2467] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__patterns, 1, .production_id = 7),
  [2469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(597),
  [2471] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_guard, 2, .production_id = 132),
  [2473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(405),
  [2475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(295),
  [2477] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_print_statement, 2),
  [2479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(93),
  [2481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(389),
  [2483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(88),
  [2485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1490),
  [2487] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_global_statement, 2),
  [2489] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_nonlocal_statement, 2),
  [2491] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1185),
  [2493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(74),
  [2495] = {.entry = {.count = 1, .reusable = true}}, SHIFT(80),
  [2497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(114),
  [2499] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_assert_statement_repeat1, 2), SHIFT_REPEAT(480),
  [2502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1182),
  [2504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1443),
  [2506] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_print_statement_repeat1, 2, .production_id = 52), SHIFT_REPEAT(483),
  [2509] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_print_statement_repeat1, 2, .production_id = 52),
  [2511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1093),
  [2513] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__import_list, 2, .production_id = 22),
  [2515] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1095),
  [2517] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_import_prefix_repeat1, 2),
  [2519] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_import_prefix_repeat1, 2), SHIFT_REPEAT(1165),
  [2522] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__patterns, 2, .production_id = 16),
  [2524] = {.entry = {.count = 1, .reusable = true}}, SHIFT(595),
  [2526] = {.entry = {.count = 1, .reusable = true}}, SHIFT(448),
  [2528] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_list_splat, 3, .production_id = 49),
  [2530] = {.entry = {.count = 1, .reusable = true}}, SHIFT(304),
  [2532] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_print_statement, 3, .production_id = 28),
  [2534] = {.entry = {.count = 1, .reusable = true}}, SHIFT(303),
  [2536] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_print_statement, 3, .production_id = 29),
  [2538] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1067),
  [2540] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1315),
  [2542] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assert_statement, 3),
  [2544] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_list_splat, 3),
  [2546] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter, 1),
  [2548] = {.entry = {.count = 1, .reusable = true}}, SHIFT(361),
  [2550] = {.entry = {.count = 1, .reusable = true}}, SHIFT(438),
  [2552] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_with_clause_repeat1, 2),
  [2554] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_with_clause_repeat1, 2), SHIFT_REPEAT(351),
  [2557] = {.entry = {.count = 1, .reusable = true}}, SHIFT(849),
  [2559] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1332),
  [2561] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1284),
  [2563] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__import_list_repeat1, 2, .production_id = 23),
  [2565] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decorator, 3),
  [2567] = {.entry = {.count = 1, .reusable = true}}, SHIFT(482),
  [2569] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__import_list_repeat1, 2, .production_id = 44), SHIFT_REPEAT(1312),
  [2572] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__import_list_repeat1, 2, .production_id = 44),
  [2574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(851),
  [2576] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_nonlocal_statement, 3),
  [2578] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_global_statement, 3),
  [2580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(144),
  [2582] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1412),
  [2584] = {.entry = {.count = 1, .reusable = true}}, SHIFT(968),
  [2586] = {.entry = {.count = 1, .reusable = true}}, SHIFT(274),
  [2588] = {.entry = {.count = 1, .reusable = true}}, SHIFT(342),
  [2590] = {.entry = {.count = 1, .reusable = true}}, SHIFT(233),
  [2592] = {.entry = {.count = 1, .reusable = true}}, SHIFT(239),
  [2594] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__simple_statements_repeat1, 2), SHIFT_REPEAT(147),
  [2597] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__simple_statements_repeat1, 2),
  [2599] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__parameters_repeat1, 2),
  [2601] = {.entry = {.count = 1, .reusable = true}}, SHIFT(855),
  [2603] = {.entry = {.count = 1, .reusable = true}}, SHIFT(973),
  [2605] = {.entry = {.count = 1, .reusable = true}}, SHIFT(273),
  [2607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(343),
  [2609] = {.entry = {.count = 1, .reusable = true}}, SHIFT(896),
  [2611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1142),
  [2613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1147),
  [2615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1020),
  [2617] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1250),
  [2619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(138),
  [2621] = {.entry = {.count = 1, .reusable = true}}, SHIFT(313),
  [2623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(72),
  [2625] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_match_mapping_pattern_repeat1, 2), SHIFT_REPEAT(905),
  [2628] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_match_mapping_pattern_repeat1, 2),
  [2630] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1004),
  [2632] = {.entry = {.count = 1, .reusable = true}}, SHIFT(861),
  [2634] = {.entry = {.count = 1, .reusable = true}}, SHIFT(862),
  [2636] = {.entry = {.count = 1, .reusable = true}}, SHIFT(139),
  [2638] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1233),
  [2640] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1314),
  [2642] = {.entry = {.count = 1, .reusable = true}}, SHIFT(891),
  [2644] = {.entry = {.count = 1, .reusable = true}}, SHIFT(988),
  [2646] = {.entry = {.count = 1, .reusable = true}}, SHIFT(459),
  [2648] = {.entry = {.count = 1, .reusable = true}}, SHIFT(128),
  [2650] = {.entry = {.count = 1, .reusable = true}}, SHIFT(91),
  [2652] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_aliased_import, 3, .production_id = 45),
  [2654] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1322),
  [2656] = {.entry = {.count = 1, .reusable = true}}, SHIFT(793),
  [2658] = {.entry = {.count = 1, .reusable = true}}, SHIFT(194),
  [2660] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameters, 1),
  [2662] = {.entry = {.count = 1, .reusable = true}}, SHIFT(895),
  [2664] = {.entry = {.count = 1, .reusable = true}}, SHIFT(802),
  [2666] = {.entry = {.count = 1, .reusable = true}}, SHIFT(189),
  [2668] = {.entry = {.count = 1, .reusable = true}}, SHIFT(142),
  [2670] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_argument_list_repeat1, 2, .production_id = 36),
  [2672] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_argument_list_repeat1, 2, .production_id = 36), SHIFT_REPEAT(222),
  [2675] = {.entry = {.count = 1, .reusable = true}}, SHIFT(253),
  [2677] = {.entry = {.count = 1, .reusable = true}}, SHIFT(790),
  [2679] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_dictionary_repeat1, 2, .production_id = 36), SHIFT_REPEAT(275),
  [2682] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_dictionary_repeat1, 2, .production_id = 36),
  [2684] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_relative_import, 1),
  [2686] = {.entry = {.count = 1, .reusable = true}}, SHIFT(146),
  [2688] = {.entry = {.count = 1, .reusable = true}}, SHIFT(145),
  [2690] = {.entry = {.count = 1, .reusable = true}}, SHIFT(358),
  [2692] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__import_list_repeat1, 2, .production_id = 44), SHIFT_REPEAT(1317),
  [2695] = {.entry = {.count = 1, .reusable = true}}, SHIFT(136),
  [2697] = {.entry = {.count = 1, .reusable = true}}, SHIFT(248),
  [2699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(796),
  [2701] = {.entry = {.count = 1, .reusable = true}}, SHIFT(249),
  [2703] = {.entry = {.count = 1, .reusable = true}}, SHIFT(640),
  [2705] = {.entry = {.count = 1, .reusable = true}}, SHIFT(134),
  [2707] = {.entry = {.count = 1, .reusable = true}}, SHIFT(360),
  [2709] = {.entry = {.count = 1, .reusable = true}}, SHIFT(135),
  [2711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(242),
  [2713] = {.entry = {.count = 1, .reusable = true}}, SHIFT(634),
  [2715] = {.entry = {.count = 1, .reusable = true}}, SHIFT(137),
  [2717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(362),
  [2719] = {.entry = {.count = 1, .reusable = true}}, SHIFT(899),
  [2721] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameters, 4, .production_id = 111),
  [2723] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_parameters_repeat1, 2, .production_id = 112), SHIFT_REPEAT(1020),
  [2726] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_type_parameters_repeat1, 2, .production_id = 112),
  [2728] = {.entry = {.count = 1, .reusable = true}}, SHIFT(143),
  [2730] = {.entry = {.count = 1, .reusable = true}}, SHIFT(620),
  [2732] = {.entry = {.count = 1, .reusable = true}}, SHIFT(208),
  [2734] = {.entry = {.count = 1, .reusable = true}}, SHIFT(894),
  [2736] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1087),
  [2738] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1110),
  [2740] = {.entry = {.count = 1, .reusable = true}}, SHIFT(133),
  [2742] = {.entry = {.count = 1, .reusable = true}}, SHIFT(369),
  [2744] = {.entry = {.count = 1, .reusable = true}}, SHIFT(155),
  [2746] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assignment, 3, .production_id = 37),
  [2748] = {.entry = {.count = 1, .reusable = true}}, SHIFT(782),
  [2750] = {.entry = {.count = 1, .reusable = true}}, SHIFT(215),
  [2752] = {.entry = {.count = 1, .reusable = true}}, SHIFT(351),
  [2754] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_clause, 2),
  [2756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(364),
  [2758] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1489),
  [2760] = {.entry = {.count = 1, .reusable = true}}, SHIFT(290),
  [2762] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_format_specifier_repeat1, 1, .production_id = 73),
  [2764] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_format_specifier_repeat1, 1, .production_id = 73),
  [2766] = {.entry = {.count = 1, .reusable = true}}, SHIFT(257),
  [2768] = {.entry = {.count = 1, .reusable = true}}, SHIFT(810),
  [2770] = {.entry = {.count = 1, .reusable = true}}, SHIFT(260),
  [2772] = {.entry = {.count = 1, .reusable = true}}, SHIFT(836),
  [2774] = {.entry = {.count = 1, .reusable = true}}, SHIFT(831),
  [2776] = {.entry = {.count = 1, .reusable = true}}, SHIFT(197),
  [2778] = {.entry = {.count = 1, .reusable = true}}, SHIFT(830),
  [2780] = {.entry = {.count = 1, .reusable = true}}, SHIFT(198),
  [2782] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__parameters_repeat1, 2), SHIFT_REPEAT(903),
  [2785] = {.entry = {.count = 1, .reusable = true}}, SHIFT(235),
  [2787] = {.entry = {.count = 1, .reusable = true}}, SHIFT(632),
  [2789] = {.entry = {.count = 1, .reusable = true}}, SHIFT(209),
  [2791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(644),
  [2793] = {.entry = {.count = 1, .reusable = true}}, SHIFT(207),
  [2795] = {.entry = {.count = 1, .reusable = true}}, SHIFT(613),
  [2797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(206),
  [2799] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_item, 3, .dynamic_precedence = -1, .production_id = 58),
  [2801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(256),
  [2803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(221),
  [2805] = {.entry = {.count = 1, .reusable = true}}, SHIFT(255),
  [2807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(220),
  [2809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1307),
  [2811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(827),
  [2813] = {.entry = {.count = 1, .reusable = true}}, SHIFT(199),
  [2815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(112),
  [2817] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__match_maybe_star_pattern, 1),
  [2819] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__match_patterns, 1),
  [2821] = {.entry = {.count = 1, .reusable = true}}, SHIFT(225),
  [2823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1195),
  [2825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(224),
  [2827] = {.entry = {.count = 1, .reusable = true}}, SHIFT(286),
  [2829] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__parameters_repeat1, 2), SHIFT_REPEAT(902),
  [2832] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_match_class_pattern_repeat1, 2),
  [2834] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_match_class_pattern_repeat1, 2), SHIFT_REPEAT(863),
  [2837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(821),
  [2839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(186),
  [2841] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_subscript_repeat1, 2, .production_id = 97), SHIFT_REPEAT(314),
  [2844] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_subscript_repeat1, 2, .production_id = 97),
  [2846] = {.entry = {.count = 1, .reusable = true}}, SHIFT(250),
  [2848] = {.entry = {.count = 1, .reusable = true}}, SHIFT(809),
  [2850] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1170),
  [2852] = {.entry = {.count = 1, .reusable = true}}, SHIFT(243),
  [2854] = {.entry = {.count = 1, .reusable = true}}, SHIFT(835),
  [2856] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1175),
  [2858] = {.entry = {.count = 1, .reusable = true}}, SHIFT(297),
  [2860] = {.entry = {.count = 1, .reusable = true}}, SHIFT(236),
  [2862] = {.entry = {.count = 1, .reusable = true}}, SHIFT(141),
  [2864] = {.entry = {.count = 1, .reusable = true}}, SHIFT(302),
  [2866] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1069),
  [2868] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_match_class_pattern_repeat2, 2),
  [2870] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_match_class_pattern_repeat2, 2), SHIFT_REPEAT(1353),
  [2873] = {.entry = {.count = 1, .reusable = true}}, SHIFT(140),
  [2875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(308),
  [2877] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_clause, 1),
  [2879] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameters, 3, .production_id = 85),
  [2881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(857),
  [2883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1329),
  [2885] = {.entry = {.count = 1, .reusable = true}}, SHIFT(776),
  [2887] = {.entry = {.count = 1, .reusable = true}}, SHIFT(214),
  [2889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(966),
  [2891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1215),
  [2893] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1338),
  [2895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(898),
  [2897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(462),
  [2899] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exec_statement, 2, .production_id = 15),
  [2901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(461),
  [2903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(858),
  [2905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(989),
  [2907] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_positional_separator, 1),
  [2909] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_future_import_statement, 6, .production_id = 98),
  [2911] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_typevar_parameter, 2, .production_id = 84),
  [2913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(115),
  [2915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(341),
  [2917] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pass_statement, 1),
  [2919] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_break_statement, 1),
  [2921] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_continue_statement, 1),
  [2923] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_from_statement, 6, .production_id = 99),
  [2925] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_typevartuple_parameter, 2, .production_id = 23),
  [2927] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_match_key_value_pattern, 3, .production_id = 62),
  [2929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1087),
  [2931] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1424),
  [2933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(127),
  [2935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(350),
  [2937] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_match_positional_pattern, 1),
  [2939] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_match_double_star_pattern, 2, .production_id = 11),
  [2941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1426),
  [2943] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assignment, 5, .production_id = 91),
  [2945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(99),
  [2947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(368),
  [2949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(122),
  [2951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(321),
  [2953] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameters, 3),
  [2955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(105),
  [2957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(322),
  [2959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(113),
  [2961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(346),
  [2963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(95),
  [2965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(323),
  [2967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(89),
  [2969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(324),
  [2971] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_argument_list_repeat1, 2, .production_id = 67),
  [2973] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameters, 2),
  [2975] = {.entry = {.count = 1, .reusable = false}}, SHIFT(990),
  [2977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(990),
  [2979] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_statement, 2, .production_id = 5),
  [2981] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_dictionary_repeat1, 2, .production_id = 31),
  [2983] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_future_import_statement, 4, .production_id = 46),
  [2985] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_augmented_assignment, 3, .production_id = 39),
  [2987] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1010),
  [2989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1010),
  [2991] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_type_parameters_repeat1, 2, .production_id = 85),
  [2993] = {.entry = {.count = 1, .reusable = false}}, SHIFT(951),
  [2995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(951),
  [2997] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assignment, 3, .production_id = 38),
  [2999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(977),
  [3001] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_from_statement, 4, .production_id = 48),
  [3003] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_from_statement, 4, .production_id = 47),
  [3005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(854),
  [3007] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_match_keyword_pattern, 3, .production_id = 157),
  [3009] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_wildcard_import, 1),
  [3011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1496),
  [3013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(972),
  [3015] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_paramspec_parameter, 2, .production_id = 23),
  [3017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(850),
  [3019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(612),
  [3021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(860),
  [3023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(817),
  [3025] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_relative_import, 2, .production_id = 23),
  [3027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1222),
  [3029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(839),
  [3031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(848),
  [3033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(312),
  [3035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(818),
  [3037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1342),
  [3039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(606),
  [3041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(775),
  [3043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1350),
  [3045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(84),
  [3047] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_clause, 4),
  [3049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(397),
  [3051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(94),
  [3053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(804),
  [3055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(724),
  [3057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(784),
  [3059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(622),
  [3061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(635),
  [3063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(873),
  [3065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(78),
  [3067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(718),
  [3069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(611),
  [3071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(795),
  [3073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(791),
  [3075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1089),
  [3077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1056),
  [3079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(637),
  [3081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1382),
  [3083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1116),
  [3085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(917),
  [3087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(688),
  [3089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(780),
  [3091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(829),
  [3093] = {.entry = {.count = 1, .reusable = true}}, SHIFT(227),
  [3095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1226),
  [3097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(107),
  [3099] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1129),
  [3101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(465),
  [3103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1374),
  [3105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1352),
  [3107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1402),
  [3109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(436),
  [3111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(90),
  [3113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(623),
  [3115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(816),
  [3117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(625),
  [3119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(92),
  [3121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(819),
  [3123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(626),
  [3125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(101),
  [3127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(814),
  [3129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(108),
  [3131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(116),
  [3133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(813),
  [3135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(81),
  [3137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(840),
  [3139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(119),
  [3141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1101),
  [3143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(129),
  [3145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(79),
  [3147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(102),
  [3149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(77),
  [3151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(82),
  [3153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(627),
  [3155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(87),
  [3157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(864),
  [3159] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_clause, 5),
  [3161] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_clause, 3),
  [3163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1223),
  [3165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(86),
  [3167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(435),
  [3169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1179),
  [3171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(701),
  [3173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(96),
  [3175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(969),
  [3177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(874),
  [3179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1107),
  [3181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(120),
  [3183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(365),
  [3185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(106),
  [3187] = {.entry = {.count = 1, .reusable = true}},  ACCEPT_INPUT(),
  [3189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(771),
  [3191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(773),
  [3193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(117),
  [3195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(121),
  [3197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1108),
  [3199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1155),
  [3201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1154),
  [3203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1128),
  [3205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(109),
  [3207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(777),
  [3209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1176),
  [3211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1074),
  [3213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1132),
  [3215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1131),
  [3217] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_parameters, 1),
  [3219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(437),
};

#ifdef __cplusplus
extern "C" {
#endif
void *tree_sitter_python_external_scanner_create(void);
void tree_sitter_python_external_scanner_destroy(void *);
bool tree_sitter_python_external_scanner_scan(void *, TSLexer *, const bool *);
unsigned tree_sitter_python_external_scanner_serialize(void *, char *);
void tree_sitter_python_external_scanner_deserialize(void *, const char *, unsigned);

#ifdef _WIN32
#define extern __declspec(dllexport)
#endif

extern const TSLanguage *tree_sitter_python(void) {
  static const TSLanguage language = {
    .version = LANGUAGE_VERSION,
    .symbol_count = SYMBOL_COUNT,
    .alias_count = ALIAS_COUNT,
    .token_count = TOKEN_COUNT,
    .external_token_count = EXTERNAL_TOKEN_COUNT,
    .state_count = STATE_COUNT,
    .large_state_count = LARGE_STATE_COUNT,
    .production_id_count = PRODUCTION_ID_COUNT,
    .field_count = FIELD_COUNT,
    .max_alias_sequence_length = MAX_ALIAS_SEQUENCE_LENGTH,
    .parse_table = &ts_parse_table[0][0],
    .small_parse_table = ts_small_parse_table,
    .small_parse_table_map = ts_small_parse_table_map,
    .parse_actions = ts_parse_actions,
    .symbol_names = ts_symbol_names,
    .field_names = ts_field_names,
    .field_map_slices = ts_field_map_slices,
    .field_map_entries = ts_field_map_entries,
    .symbol_metadata = ts_symbol_metadata,
    .public_symbol_map = ts_symbol_map,
    .alias_map = ts_non_terminal_alias_map,
    .alias_sequences = &ts_alias_sequences[0][0],
    .lex_modes = ts_lex_modes,
    .lex_fn = ts_lex,
    .keyword_lex_fn = ts_lex_keywords,
    .keyword_capture_token = sym_identifier,
    .external_scanner = {
      &ts_external_scanner_states[0][0],
      ts_external_scanner_symbol_map,
      tree_sitter_python_external_scanner_create,
      tree_sitter_python_external_scanner_destroy,
      tree_sitter_python_external_scanner_scan,
      tree_sitter_python_external_scanner_serialize,
      tree_sitter_python_external_scanner_deserialize,
    },
    .primary_state_ids = ts_primary_state_ids,
  };
  return &language;
}
#ifdef __cplusplus
}
#endif
