var express = require("express");
var app = express();

// set up rate limiter: maximum of five requests per minute
var RateLimit = require("express-rate-limit");
var limiter = RateLimit({
  windowMs: 1 * 60 * 1000, // 1 minute
  max: 5,
});

// apply rate limiter to all requests
app.use(limiter);

app.get("/:path", function (req, res) {
  let path = req.params.path;
  if (isValidPath(path)) res.sendFile(path);
});
